#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 5586
#define LARGE_STATE_COUNT 1181
#define SYMBOL_COUNT 333
#define ALIAS_COUNT 6
#define TOKEN_COUNT 150
#define EXTERNAL_TOKEN_COUNT 4
#define FIELD_COUNT 36
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 175

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_BANG = 19,
  anon_sym_else = 20,
  anon_sym_if = 21,
  anon_sym_switch = 22,
  anon_sym_for = 23,
  anon_sym_LPAREN = 24,
  anon_sym_RPAREN = 25,
  anon_sym_await = 26,
  anon_sym_in = 27,
  anon_sym_of = 28,
  anon_sym_while = 29,
  anon_sym_do = 30,
  anon_sym_try = 31,
  anon_sym_with = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  anon_sym_LT = 46,
  anon_sym_GT = 47,
  anon_sym_SLASH = 48,
  anon_sym_DOT = 49,
  anon_sym_class = 50,
  anon_sym_async = 51,
  anon_sym_function = 52,
  anon_sym_EQ_GT = 53,
  anon_sym_QMARK_DOT = 54,
  anon_sym_new = 55,
  anon_sym_PLUS_EQ = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_CARET_EQ = 61,
  anon_sym_AMP_EQ = 62,
  anon_sym_PIPE_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_GT_GT_GT_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_STAR_STAR_EQ = 67,
  anon_sym_AMP_AMP_EQ = 68,
  anon_sym_PIPE_PIPE_EQ = 69,
  anon_sym_QMARK_QMARK_EQ = 70,
  anon_sym_DOT_DOT_DOT = 71,
  anon_sym_QMARK = 72,
  anon_sym_AMP_AMP = 73,
  anon_sym_PIPE_PIPE = 74,
  anon_sym_GT_GT = 75,
  anon_sym_GT_GT_GT = 76,
  anon_sym_LT_LT = 77,
  anon_sym_AMP = 78,
  anon_sym_CARET = 79,
  anon_sym_PIPE = 80,
  anon_sym_PLUS = 81,
  anon_sym_DASH = 82,
  anon_sym_PERCENT = 83,
  anon_sym_STAR_STAR = 84,
  anon_sym_LT_EQ = 85,
  anon_sym_EQ_EQ = 86,
  anon_sym_EQ_EQ_EQ = 87,
  anon_sym_BANG_EQ = 88,
  anon_sym_BANG_EQ_EQ = 89,
  anon_sym_GT_EQ = 90,
  anon_sym_QMARK_QMARK = 91,
  anon_sym_instanceof = 92,
  anon_sym_TILDE = 93,
  anon_sym_void = 94,
  anon_sym_delete = 95,
  anon_sym_PLUS_PLUS = 96,
  anon_sym_DASH_DASH = 97,
  anon_sym_DQUOTE = 98,
  aux_sym_string_token1 = 99,
  anon_sym_SQUOTE = 100,
  aux_sym_string_token2 = 101,
  sym_escape_sequence = 102,
  sym_comment = 103,
  anon_sym_BQUOTE = 104,
  anon_sym_DOLLAR_LBRACE = 105,
  anon_sym_SLASH2 = 106,
  sym_regex_pattern = 107,
  sym_regex_flags = 108,
  sym_number = 109,
  anon_sym_target = 110,
  sym_this = 111,
  sym_super = 112,
  sym_true = 113,
  sym_false = 114,
  sym_null = 115,
  sym_undefined = 116,
  anon_sym_AT = 117,
  anon_sym_declare = 118,
  anon_sym_static = 119,
  anon_sym_readonly = 120,
  anon_sym_abstract = 121,
  anon_sym_get = 122,
  anon_sym_set = 123,
  anon_sym_public = 124,
  anon_sym_private = 125,
  anon_sym_protected = 126,
  anon_sym_module = 127,
  anon_sym_any = 128,
  anon_sym_number = 129,
  anon_sym_boolean = 130,
  anon_sym_string = 131,
  anon_sym_symbol = 132,
  anon_sym_require = 133,
  anon_sym_implements = 134,
  anon_sym_global = 135,
  anon_sym_interface = 136,
  anon_sym_extends = 137,
  anon_sym_enum = 138,
  anon_sym_DASH_QMARK_COLON = 139,
  anon_sym_QMARK_COLON = 140,
  anon_sym_asserts = 141,
  anon_sym_infer = 142,
  anon_sym_is = 143,
  anon_sym_keyof = 144,
  anon_sym_LBRACE_PIPE = 145,
  anon_sym_PIPE_RBRACE = 146,
  sym__automatic_semicolon = 147,
  sym__template_chars = 148,
  sym__function_signature_automatic_semicolon = 149,
  sym_program = 150,
  sym_export_statement = 151,
  sym_export_clause = 152,
  sym__import_export_specifier = 153,
  sym_declaration = 154,
  sym_import = 155,
  sym_import_statement = 156,
  sym_import_clause = 157,
  sym__from_clause = 158,
  sym_namespace_import = 159,
  sym_named_imports = 160,
  sym_expression_statement = 161,
  sym_variable_declaration = 162,
  sym_lexical_declaration = 163,
  sym_variable_declarator = 164,
  sym_statement_block = 165,
  sym_else_clause = 166,
  sym_if_statement = 167,
  sym_switch_statement = 168,
  sym_for_statement = 169,
  sym_for_in_statement = 170,
  sym__for_header = 171,
  sym_while_statement = 172,
  sym_do_statement = 173,
  sym_try_statement = 174,
  sym_with_statement = 175,
  sym_break_statement = 176,
  sym_continue_statement = 177,
  sym_debugger_statement = 178,
  sym_return_statement = 179,
  sym_throw_statement = 180,
  sym_empty_statement = 181,
  sym_labeled_statement = 182,
  sym_switch_body = 183,
  sym_switch_case = 184,
  sym_switch_default = 185,
  sym_catch_clause = 186,
  sym_finally_clause = 187,
  sym_parenthesized_expression = 188,
  sym_expression = 189,
  sym_primary_expression = 190,
  sym_yield_expression = 191,
  sym_object = 192,
  sym_object_pattern = 193,
  sym_assignment_pattern = 194,
  sym_object_assignment_pattern = 195,
  sym_array = 196,
  sym_array_pattern = 197,
  sym_nested_identifier = 198,
  sym_class = 199,
  sym_class_declaration = 200,
  sym_class_heritage = 201,
  sym_function = 202,
  sym_function_declaration = 203,
  sym_generator_function = 204,
  sym_generator_function_declaration = 205,
  sym_arrow_function = 206,
  sym__call_signature = 207,
  sym__formal_parameter = 208,
  sym_call_expression = 209,
  sym_new_expression = 210,
  sym_await_expression = 211,
  sym_member_expression = 212,
  sym_subscript_expression = 213,
  sym_assignment_expression = 214,
  sym__augmented_assignment_lhs = 215,
  sym_augmented_assignment_expression = 216,
  sym__initializer = 217,
  sym__destructuring_pattern = 218,
  sym_spread_element = 219,
  sym_ternary_expression = 220,
  sym_binary_expression = 221,
  sym_unary_expression = 222,
  sym_update_expression = 223,
  sym_sequence_expression = 224,
  sym_string = 225,
  sym_template_string = 226,
  sym_template_substitution = 227,
  sym_regex = 228,
  sym_meta_property = 229,
  sym_arguments = 230,
  sym_decorator = 231,
  sym_decorator_member_expression = 232,
  sym_decorator_call_expression = 233,
  sym_class_body = 234,
  sym_public_field_definition = 235,
  sym_formal_parameters = 236,
  sym_pattern = 237,
  sym_rest_pattern = 238,
  sym_method_definition = 239,
  sym_pair = 240,
  sym_pair_pattern = 241,
  sym__property_name = 242,
  sym_computed_property_name = 243,
  sym_non_null_expression = 244,
  sym_method_signature = 245,
  sym_abstract_method_signature = 246,
  sym_function_signature = 247,
  sym_type_assertion = 248,
  sym_as_expression = 249,
  sym_import_require_clause = 250,
  sym_implements_clause = 251,
  sym_ambient_declaration = 252,
  sym_abstract_class_declaration = 253,
  sym_module = 254,
  sym_internal_module = 255,
  sym__module = 256,
  sym_import_alias = 257,
  sym_nested_type_identifier = 258,
  sym_interface_declaration = 259,
  sym_extends_clause = 260,
  sym_enum_declaration = 261,
  sym_enum_body = 262,
  sym_enum_assignment = 263,
  sym_type_alias_declaration = 264,
  sym_accessibility_modifier = 265,
  sym_required_parameter = 266,
  sym_optional_parameter = 267,
  sym__parameter_name = 268,
  sym_omitting_type_annotation = 269,
  sym_opting_type_annotation = 270,
  sym_type_annotation = 271,
  sym_asserts = 272,
  sym__type = 273,
  sym_tuple_parameter = 274,
  sym_optional_tuple_parameter = 275,
  sym_optional_type = 276,
  sym_rest_type = 277,
  sym__tuple_type_member = 278,
  sym_constructor_type = 279,
  sym__primary_type = 280,
  sym_infer_type = 281,
  sym_conditional_type = 282,
  sym_generic_type = 283,
  sym_type_predicate = 284,
  sym_type_predicate_annotation = 285,
  sym_type_query = 286,
  sym_index_type_query = 287,
  sym_lookup_type = 288,
  sym_mapped_type_clause = 289,
  sym_literal_type = 290,
  sym__number = 291,
  sym_existential_type = 292,
  sym_flow_maybe_type = 293,
  sym_parenthesized_type = 294,
  sym_predefined_type = 295,
  sym_type_arguments = 296,
  sym_object_type = 297,
  sym_call_signature = 298,
  sym_property_signature = 299,
  sym_type_parameters = 300,
  sym_type_parameter = 301,
  sym_default_type = 302,
  sym_constraint = 303,
  sym_construct_signature = 304,
  sym_index_signature = 305,
  sym_array_type = 306,
  sym_tuple_type = 307,
  sym_readonly_type = 308,
  sym_union_type = 309,
  sym_intersection_type = 310,
  sym_function_type = 311,
  aux_sym_program_repeat1 = 312,
  aux_sym_export_statement_repeat1 = 313,
  aux_sym_export_clause_repeat1 = 314,
  aux_sym_named_imports_repeat1 = 315,
  aux_sym_variable_declaration_repeat1 = 316,
  aux_sym_switch_body_repeat1 = 317,
  aux_sym_object_repeat1 = 318,
  aux_sym_object_pattern_repeat1 = 319,
  aux_sym_array_repeat1 = 320,
  aux_sym_array_pattern_repeat1 = 321,
  aux_sym_string_repeat1 = 322,
  aux_sym_string_repeat2 = 323,
  aux_sym_template_string_repeat1 = 324,
  aux_sym_class_body_repeat1 = 325,
  aux_sym_formal_parameters_repeat1 = 326,
  aux_sym_implements_clause_repeat1 = 327,
  aux_sym_extends_clause_repeat1 = 328,
  aux_sym_enum_body_repeat1 = 329,
  aux_sym_object_type_repeat1 = 330,
  aux_sym_type_parameters_repeat1 = 331,
  aux_sym_tuple_type_repeat1 = 332,
  alias_sym_import_specifier = 333,
  alias_sym_property_identifier = 334,
  alias_sym_shorthand_property_identifier = 335,
  alias_sym_shorthand_property_identifier_pattern = 336,
  alias_sym_statement_identifier = 337,
  alias_sym_type_identifier = 338,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_declare] = "declare",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "export_specifier",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_clause] = sym_extends_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constructor = 8,
  field_declaration = 9,
  field_decorator = 10,
  field_finalizer = 11,
  field_flags = 12,
  field_function = 13,
  field_handler = 14,
  field_increment = 15,
  field_index = 16,
  field_initializer = 17,
  field_key = 18,
  field_label = 19,
  field_left = 20,
  field_module = 21,
  field_name = 22,
  field_object = 23,
  field_operator = 24,
  field_parameter = 25,
  field_parameters = 26,
  field_pattern = 27,
  field_property = 28,
  field_return_type = 29,
  field_right = 30,
  field_sign = 31,
  field_source = 32,
  field_type = 33,
  field_type_arguments = 34,
  field_type_parameters = 35,
  field_value = 36,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 9, .length = 1},
  [12] = {.index = 10, .length = 1},
  [13] = {.index = 11, .length = 2},
  [14] = {.index = 13, .length = 2},
  [15] = {.index = 15, .length = 2},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 21, .length = 2},
  [19] = {.index = 23, .length = 1},
  [20] = {.index = 24, .length = 2},
  [21] = {.index = 26, .length = 2},
  [24] = {.index = 28, .length = 2},
  [25] = {.index = 30, .length = 2},
  [26] = {.index = 32, .length = 2},
  [27] = {.index = 34, .length = 2},
  [28] = {.index = 36, .length = 3},
  [29] = {.index = 39, .length = 2},
  [30] = {.index = 41, .length = 2},
  [31] = {.index = 43, .length = 2},
  [32] = {.index = 45, .length = 2},
  [33] = {.index = 47, .length = 2},
  [34] = {.index = 49, .length = 1},
  [35] = {.index = 50, .length = 3},
  [37] = {.index = 53, .length = 1},
  [38] = {.index = 54, .length = 2},
  [39] = {.index = 56, .length = 1},
  [40] = {.index = 57, .length = 2},
  [41] = {.index = 59, .length = 4},
  [42] = {.index = 63, .length = 2},
  [43] = {.index = 65, .length = 2},
  [44] = {.index = 21, .length = 2},
  [45] = {.index = 24, .length = 2},
  [46] = {.index = 54, .length = 2},
  [47] = {.index = 67, .length = 3},
  [48] = {.index = 70, .length = 2},
  [49] = {.index = 72, .length = 3},
  [50] = {.index = 75, .length = 2},
  [51] = {.index = 77, .length = 4},
  [52] = {.index = 81, .length = 3},
  [53] = {.index = 84, .length = 2},
  [54] = {.index = 86, .length = 1},
  [55] = {.index = 87, .length = 1},
  [56] = {.index = 88, .length = 1},
  [57] = {.index = 89, .length = 1},
  [58] = {.index = 21, .length = 2},
  [59] = {.index = 90, .length = 2},
  [60] = {.index = 92, .length = 5},
  [61] = {.index = 97, .length = 2},
  [62] = {.index = 99, .length = 1},
  [63] = {.index = 100, .length = 2},
  [64] = {.index = 102, .length = 3},
  [65] = {.index = 105, .length = 2},
  [66] = {.index = 107, .length = 3},
  [67] = {.index = 110, .length = 3},
  [68] = {.index = 113, .length = 2},
  [69] = {.index = 115, .length = 3},
  [70] = {.index = 118, .length = 4},
  [71] = {.index = 122, .length = 2},
  [72] = {.index = 124, .length = 2},
  [73] = {.index = 126, .length = 2},
  [74] = {.index = 128, .length = 3},
  [75] = {.index = 131, .length = 2},
  [76] = {.index = 133, .length = 2},
  [77] = {.index = 135, .length = 4},
  [78] = {.index = 133, .length = 2},
  [79] = {.index = 139, .length = 4},
  [80] = {.index = 143, .length = 4},
  [81] = {.index = 147, .length = 5},
  [82] = {.index = 152, .length = 3},
  [83] = {.index = 105, .length = 2},
  [84] = {.index = 155, .length = 2},
  [85] = {.index = 157, .length = 3},
  [86] = {.index = 160, .length = 3},
  [87] = {.index = 163, .length = 2},
  [88] = {.index = 165, .length = 3},
  [89] = {.index = 168, .length = 2},
  [90] = {.index = 97, .length = 2},
  [91] = {.index = 170, .length = 5},
  [92] = {.index = 175, .length = 2},
  [93] = {.index = 177, .length = 1},
  [94] = {.index = 178, .length = 2},
  [95] = {.index = 180, .length = 2},
  [96] = {.index = 182, .length = 1},
  [97] = {.index = 183, .length = 2},
  [98] = {.index = 185, .length = 4},
  [99] = {.index = 189, .length = 2},
  [100] = {.index = 191, .length = 2},
  [101] = {.index = 193, .length = 3},
  [102] = {.index = 196, .length = 4},
  [103] = {.index = 200, .length = 4},
  [104] = {.index = 204, .length = 5},
  [105] = {.index = 209, .length = 2},
  [106] = {.index = 211, .length = 3},
  [107] = {.index = 214, .length = 1},
  [108] = {.index = 215, .length = 2},
  [109] = {.index = 217, .length = 3},
  [110] = {.index = 220, .length = 2},
  [111] = {.index = 222, .length = 3},
  [112] = {.index = 225, .length = 4},
  [113] = {.index = 229, .length = 3},
  [114] = {.index = 232, .length = 3},
  [115] = {.index = 235, .length = 2},
  [116] = {.index = 237, .length = 5},
  [117] = {.index = 242, .length = 3},
  [118] = {.index = 245, .length = 2},
  [119] = {.index = 245, .length = 2},
  [120] = {.index = 247, .length = 3},
  [121] = {.index = 250, .length = 4},
  [122] = {.index = 254, .length = 2},
  [123] = {.index = 256, .length = 2},
  [124] = {.index = 258, .length = 1},
  [125] = {.index = 259, .length = 2},
  [126] = {.index = 261, .length = 2},
  [127] = {.index = 263, .length = 3},
  [128] = {.index = 266, .length = 3},
  [129] = {.index = 269, .length = 5},
  [130] = {.index = 274, .length = 3},
  [131] = {.index = 277, .length = 4},
  [132] = {.index = 281, .length = 3},
  [133] = {.index = 284, .length = 4},
  [134] = {.index = 288, .length = 5},
  [135] = {.index = 293, .length = 2},
  [136] = {.index = 295, .length = 4},
  [137] = {.index = 299, .length = 2},
  [138] = {.index = 301, .length = 4},
  [139] = {.index = 305, .length = 4},
  [140] = {.index = 309, .length = 2},
  [141] = {.index = 311, .length = 2},
  [142] = {.index = 313, .length = 2},
  [143] = {.index = 315, .length = 2},
  [144] = {.index = 317, .length = 3},
  [145] = {.index = 320, .length = 3},
  [146] = {.index = 323, .length = 1},
  [148] = {.index = 324, .length = 4},
  [149] = {.index = 328, .length = 5},
  [150] = {.index = 333, .length = 5},
  [152] = {.index = 338, .length = 1},
  [153] = {.index = 339, .length = 4},
  [154] = {.index = 343, .length = 4},
  [155] = {.index = 347, .length = 2},
  [156] = {.index = 349, .length = 4},
  [157] = {.index = 353, .length = 2},
  [158] = {.index = 355, .length = 3},
  [159] = {.index = 358, .length = 3},
  [160] = {.index = 361, .length = 2},
  [161] = {.index = 363, .length = 2},
  [162] = {.index = 365, .length = 5},
  [163] = {.index = 370, .length = 5},
  [164] = {.index = 375, .length = 4},
  [166] = {.index = 379, .length = 4},
  [167] = {.index = 383, .length = 3},
  [168] = {.index = 386, .length = 2},
  [169] = {.index = 388, .length = 2},
  [170] = {.index = 390, .length = 3},
  [171] = {.index = 393, .length = 5},
  [172] = {.index = 338, .length = 1},
  [173] = {.index = 398, .length = 4},
  [174] = {.index = 402, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_decorator, 0, .inherited = true},
  [9] =
    {field_body, 1},
  [10] =
    {field_constructor, 1},
  [11] =
    {field_argument, 0},
    {field_operator, 1},
  [13] =
    {field_arguments, 1},
    {field_function, 0},
  [15] =
    {field_parameters, 0},
    {field_return_type, 1},
  [17] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [19] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [21] =
    {field_left, 0},
    {field_right, 2},
  [23] =
    {field_label, 0},
  [24] =
    {field_body, 2},
    {field_parameter, 0},
  [26] =
    {field_body, 1},
    {field_name, 0},
  [28] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [30] =
    {field_name, 0},
    {field_type, 1},
  [32] =
    {field_condition, 1},
    {field_consequence, 2},
  [34] =
    {field_body, 2},
    {field_value, 1},
  [36] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [39] =
    {field_decorator, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [41] =
    {field_body, 2},
    {field_condition, 1},
  [43] =
    {field_body, 1},
    {field_handler, 2},
  [45] =
    {field_body, 1},
    {field_finalizer, 2},
  [47] =
    {field_body, 2},
    {field_object, 1},
  [49] =
    {field_label, 1},
  [50] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [53] =
    {field_pattern, 1},
  [54] =
    {field_body, 2},
    {field_name, 1},
  [56] =
    {field_body, 2},
  [57] =
    {field_body, 2},
    {field_type_parameters, 1},
  [59] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [63] =
    {field_arguments, 2},
    {field_constructor, 1},
  [65] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [67] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [70] =
    {field_object, 0},
    {field_property, 2},
  [72] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [75] =
    {field_arguments, 2},
    {field_function, 0},
  [77] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [81] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [84] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [86] =
    {field_source, 1},
  [87] =
    {field_source, 2, .inherited = true},
  [88] =
    {field_value, 2},
  [89] =
    {field_name, 1},
  [90] =
    {field_key, 0},
    {field_value, 2},
  [92] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [97] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [99] =
    {field_value, 1},
  [100] =
    {field_name, 0},
    {field_type, 2},
  [102] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [105] =
    {field_body, 3},
    {field_name, 2},
  [107] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [110] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [113] =
    {field_decorator, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [115] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [118] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [122] =
    {field_module, 0},
    {field_name, 2},
  [124] =
    {field_flags, 3},
    {field_pattern, 1},
  [126] =
    {field_body, 3},
    {field_name, 1},
  [128] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [131] =
    {field_body, 3},
    {field_type_parameters, 1},
  [133] =
    {field_body, 3},
    {field_parameter, 1},
  [135] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [139] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [143] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [147] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [152] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [155] =
    {field_index, 2},
    {field_object, 0},
  [157] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [160] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [163] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [165] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [168] =
    {field_alias, 2},
    {field_name, 0},
  [170] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [175] =
    {field_name, 1},
    {field_value, 3},
  [177] =
    {field_source, 3, .inherited = true},
  [178] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3, .inherited = true},
  [180] =
    {field_body, 1},
    {field_condition, 3},
  [182] =
    {field_name, 2},
  [183] =
    {field_name, 1},
    {field_type, 2},
  [185] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [189] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [191] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [193] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [196] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [200] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [204] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [209] =
    {field_body, 4},
    {field_name, 2},
  [211] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [214] =
    {field_value, 1, .inherited = true},
  [215] =
    {field_index, 3},
    {field_object, 0},
  [217] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [220] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [222] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [225] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [229] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [232] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [235] =
    {field_alias, 3},
    {field_name, 1},
  [237] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [242] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [245] =
    {field_left, 1},
    {field_right, 3},
  [247] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [250] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [254] =
    {field_name, 2},
    {field_type, 3},
  [256] =
    {field_name, 1},
    {field_type, 3},
  [258] =
    {field_name, 3},
  [259] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [261] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [263] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [266] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [269] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [274] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [277] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [281] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [284] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [288] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [293] =
    {field_left, 2},
    {field_right, 4},
  [295] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [299] =
    {field_body, 4},
    {field_parameter, 2},
  [301] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [305] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [309] =
    {field_name, 2},
    {field_type, 4},
  [311] =
    {field_name, 3},
    {field_type, 4},
  [313] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [315] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [317] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [320] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [323] =
    {field_name, 4},
  [324] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [328] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [333] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [338] =
    {field_sign, 0},
  [339] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [343] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [347] =
    {field_name, 3},
    {field_type, 5},
  [349] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [353] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [355] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [358] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [361] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [363] =
    {field_name, 4},
    {field_type, 5},
  [365] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [370] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [375] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [379] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [383] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [386] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [388] =
    {field_name, 4},
    {field_type, 6},
  [390] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [393] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [398] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [402] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [11] = {
    [0] = alias_sym_type_identifier,
  },
  [18] = {
    [0] = sym_identifier,
  },
  [19] = {
    [0] = alias_sym_statement_identifier,
  },
  [20] = {
    [0] = sym_identifier,
  },
  [22] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [23] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [34] = {
    [1] = alias_sym_statement_identifier,
  },
  [36] = {
    [1] = alias_sym_type_identifier,
  },
  [38] = {
    [1] = alias_sym_type_identifier,
  },
  [48] = {
    [2] = alias_sym_property_identifier,
  },
  [58] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [61] = {
    [1] = alias_sym_import_specifier,
  },
  [71] = {
    [2] = alias_sym_type_identifier,
  },
  [73] = {
    [1] = alias_sym_type_identifier,
  },
  [74] = {
    [1] = alias_sym_type_identifier,
  },
  [76] = {
    [1] = sym_identifier,
  },
  [83] = {
    [2] = alias_sym_type_identifier,
  },
  [86] = {
    [2] = alias_sym_type_identifier,
  },
  [92] = {
    [1] = alias_sym_type_identifier,
  },
  [101] = {
    [1] = alias_sym_type_identifier,
  },
  [105] = {
    [2] = alias_sym_type_identifier,
  },
  [106] = {
    [2] = alias_sym_type_identifier,
  },
  [111] = {
    [2] = alias_sym_type_identifier,
  },
  [112] = {
    [2] = alias_sym_type_identifier,
  },
  [114] = {
    [3] = alias_sym_type_identifier,
  },
  [117] = {
    [1] = alias_sym_type_identifier,
  },
  [118] = {
    [1] = sym_identifier,
  },
  [130] = {
    [2] = alias_sym_type_identifier,
  },
  [131] = {
    [2] = alias_sym_type_identifier,
  },
  [132] = {
    [3] = alias_sym_type_identifier,
  },
  [133] = {
    [3] = alias_sym_type_identifier,
  },
  [147] = {
    [3] = alias_sym_property_identifier,
  },
  [148] = {
    [3] = alias_sym_type_identifier,
  },
  [151] = {
    [1] = sym_identifier,
  },
  [165] = {
    [2] = sym_identifier,
  },
  [172] = {
    [3] = sym_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  sym__import_export_specifier, 2,
    sym__import_export_specifier,
    alias_sym_import_specifier,
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < '`'
    ? (c < '%'
      ? (c < 0
        ? c == 0
        : c <= '#')
      : (c <= '/' || (c < '['
        ? (c >= ':' && c <= '@')
        : c <= '^')))
    : (c <= '`' || (c < 8203
      ? (c < 160
        ? (c >= '{' && c <= '~')
        : c <= 160)
      : (c <= 8203 || (c < 65279
        ? c == 8288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(65);
      if (lookahead == '!') ADVANCE(79);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '#') ADVANCE(9);
      if (lookahead == '$') ADVANCE(197);
      if (lookahead == '%') ADVANCE(147);
      if (lookahead == '&') ADVANCE(130);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(141);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '/') ADVANCE(183);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(87);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(117);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(29);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '^') ADVANCE(133);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(62)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(198);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(23)
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(184);
      if (lookahead != 0) ADVANCE(185);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(79);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '%') ADVANCE(147);
      if (lookahead == '&') ADVANCE(130);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(141);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(144);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(87);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(117);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '^') ADVANCE(133);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != '~') ADVANCE(198);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(79);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '%') ADVANCE(147);
      if (lookahead == '&') ADVANCE(130);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(141);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(144);
      if (lookahead == '.') ADVANCE(95);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(87);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(117);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '^') ADVANCE(133);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(3)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != '~') ADVANCE(198);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(79);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '%') ADVANCE(146);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == '<') ADVANCE(88);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(91);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(198);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(79);
      if (lookahead == '%') ADVANCE(146);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(88);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(91);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(198);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(79);
      if (lookahead == '%') ADVANCE(146);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(88);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(91);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(198);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(79);
      if (lookahead == '%') ADVANCE(146);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '<') ADVANCE(88);
      if (lookahead == '=') ADVANCE(26);
      if (lookahead == '>') ADVANCE(91);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(198);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(79);
      if (lookahead == '%') ADVANCE(146);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '<') ADVANCE(88);
      if (lookahead == '=') ADVANCE(26);
      if (lookahead == '>') ADVANCE(91);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(198);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(66);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(78);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(134);
      if (lookahead == '~') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(198);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(21);
      if (lookahead == '/') ADVANCE(183);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != '%' &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(198);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(21);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != '%' &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(198);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(38);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(198);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(166);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 15:
      if (lookahead == '$') ADVANCE(32);
      if (lookahead == '-') ADVANCE(27);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == '?') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      END_STATE();
    case 16:
      if (lookahead == '$') ADVANCE(32);
      if (lookahead == '-') ADVANCE(27);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == '?') ADVANCE(25);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      END_STATE();
    case 17:
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(173);
      if (lookahead != 0) ADVANCE(174);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(180);
      END_STATE();
    case 19:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(179);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 22:
      if (lookahead == '.') ADVANCE(115);
      END_STATE();
    case 23:
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(23)
      END_STATE();
    case 24:
      if (lookahead == ':') ADVANCE(200);
      END_STATE();
    case 25:
      if (lookahead == ':') ADVANCE(201);
      END_STATE();
    case 26:
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 27:
      if (lookahead == '?') ADVANCE(24);
      END_STATE();
    case 28:
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == ']') ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      if (lookahead != 0) ADVANCE(175);
      END_STATE();
    case 30:
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 31:
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      if (lookahead != 0) ADVANCE(175);
      END_STATE();
    case 32:
      if (lookahead == '{') ADVANCE(182);
      END_STATE();
    case 33:
      if (lookahead == '{') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 34:
      if (lookahead == '{') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 37:
      if (lookahead == '}') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 38:
      if (lookahead == '}') ADVANCE(203);
      END_STATE();
    case 39:
      if (lookahead == '}') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 41:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(190);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(191);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(198);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(175);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(192);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(176);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 60:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(28);
      END_STATE();
    case 61:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(185);
      END_STATE();
    case 62:
      if (eof) ADVANCE(65);
      if (lookahead == '!') ADVANCE(79);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '#') ADVANCE(9);
      if (lookahead == '$') ADVANCE(197);
      if (lookahead == '%') ADVANCE(147);
      if (lookahead == '&') ADVANCE(130);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(141);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(87);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(117);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '^') ADVANCE(133);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(62)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(198);
      END_STATE();
    case 63:
      if (eof) ADVANCE(65);
      if (lookahead == '!') ADVANCE(79);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '%') ADVANCE(146);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(88);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(91);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(63)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(198);
      END_STATE();
    case 64:
      if (eof) ADVANCE(65);
      if (lookahead == '!') ADVANCE(78);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '#') ADVANCE(9);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '\'') ADVANCE(168);
      if (lookahead == '(') ADVANCE(80);
      if (lookahead == ')') ADVANCE(81);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(188);
      if (lookahead == ':') ADVANCE(83);
      if (lookahead == ';') ADVANCE(82);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(199);
      if (lookahead == '[') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(85);
      if (lookahead == '`') ADVANCE(181);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(64)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(198);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(66);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(148);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '>') ADVANCE(98);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(98);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(202);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(123);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(124);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(180);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(180);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(22);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '?') ADVANCE(157);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '?') ADVANCE(156);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '>') ADVANCE(126);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(120);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(119);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(107);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(203);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(121);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(121);
      if (lookahead == '}') ADVANCE(203);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(203);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(159);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(159);
      if (lookahead == '=') ADVANCE(100);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(160);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(160);
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(160);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '?') ADVANCE(24);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(154);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\n') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(165);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(164);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(165);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(165);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '\n') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(172);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(174);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead == '/') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(172);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(174);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(30);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(198);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(175);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(177);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(180);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(23)
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(184);
      if (lookahead != 0) ADVANCE(185);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(185);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(30);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(198);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(196);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(41);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(40);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(42);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(49);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(187);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(189);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(196);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(40);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(187);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(49);
      if (lookahead == 'n') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(40);
      if (lookahead == '_') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '{') ADVANCE(182);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(198);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(30);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(198);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(74);
      if (lookahead == 'y') ADVANCE(75);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(76);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(79);
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(81);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(82);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(83);
      if (lookahead == 'c') ADVANCE(84);
      if (lookahead == 'f') ADVANCE(85);
      if (lookahead == 'l') ADVANCE(86);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(87);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(89);
      if (lookahead == 't') ADVANCE(90);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(91);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(92);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(94);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(98);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(99);
      if (lookahead == 's') ADVANCE(100);
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(102);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(104);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(105);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(106);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(107);
      if (lookahead == 'm') ADVANCE(108);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(109);
      if (lookahead == 'o') ADVANCE(110);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(111);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'q') ADVANCE(113);
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(116);
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(118);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(119);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(120);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(122);
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(124);
      if (lookahead == 'y') ADVANCE(125);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(126);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(127);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(129);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(136);
      END_STATE();
    case 77:
      if (lookahead == 'l') ADVANCE(137);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 80:
      if (lookahead == 'c') ADVANCE(140);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(142);
      if (lookahead == 't') ADVANCE(143);
      END_STATE();
    case 83:
      if (lookahead == 'u') ADVANCE(144);
      END_STATE();
    case 84:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(146);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 88:
      if (lookahead == 'm') ADVANCE(149);
      END_STATE();
    case 89:
      if (lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 91:
      if (lookahead == 's') ADVANCE(152);
      END_STATE();
    case 92:
      if (lookahead == 'a') ADVANCE(153);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 94:
      if (lookahead == 'm') ADVANCE(154);
      END_STATE();
    case 95:
      if (lookahead == 'c') ADVANCE(155);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 97:
      if (lookahead == 'b') ADVANCE(156);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(157);
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 100:
      if (lookahead == 't') ADVANCE(160);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(161);
      END_STATE();
    case 102:
      if (lookahead == 'o') ADVANCE(162);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 104:
      if (lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 107:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 108:
      if (lookahead == 'b') ADVANCE(166);
      END_STATE();
    case 109:
      if (lookahead == 'v') ADVANCE(167);
      END_STATE();
    case 110:
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(169);
      END_STATE();
    case 112:
      if (lookahead == 'd') ADVANCE(170);
      END_STATE();
    case 113:
      if (lookahead == 'u') ADVANCE(171);
      END_STATE();
    case 114:
      if (lookahead == 'u') ADVANCE(172);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 117:
      if (lookahead == 'i') ADVANCE(174);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 119:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 120:
      if (lookahead == 'b') ADVANCE(177);
      END_STATE();
    case 121:
      if (lookahead == 'g') ADVANCE(178);
      END_STATE();
    case 122:
      if (lookahead == 's') ADVANCE(179);
      END_STATE();
    case 123:
      if (lookahead == 'o') ADVANCE(180);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 129:
      if (lookahead == 'd') ADVANCE(184);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(185);
      END_STATE();
    case 131:
      if (lookahead == 'h') ADVANCE(186);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(188);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(189);
      END_STATE();
    case 135:
      if (lookahead == 'c') ADVANCE(190);
      END_STATE();
    case 136:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(192);
      END_STATE();
    case 138:
      if (lookahead == 'k') ADVANCE(193);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 140:
      if (lookahead == 'h') ADVANCE(194);
      END_STATE();
    case 141:
      if (lookahead == 's') ADVANCE(195);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 143:
      if (lookahead == 'i') ADVANCE(197);
      END_STATE();
    case 144:
      if (lookahead == 'g') ADVANCE(198);
      END_STATE();
    case 145:
      if (lookahead == 'a') ADVANCE(199);
      END_STATE();
    case 146:
      if (lookahead == 'u') ADVANCE(200);
      END_STATE();
    case 147:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 150:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 151:
      if (lookahead == 'n') ADVANCE(203);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 153:
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 155:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(207);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 158:
      if (lookahead == 'r') ADVANCE(209);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(210);
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 161:
      if (lookahead == 'r') ADVANCE(212);
      END_STATE();
    case 162:
      if (lookahead == 'f') ADVANCE(213);
      END_STATE();
    case 163:
      if (lookahead == 'l') ADVANCE(214);
      END_STATE();
    case 164:
      if (lookahead == 's') ADVANCE(215);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(216);
      END_STATE();
    case 167:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(219);
      END_STATE();
    case 170:
      if (lookahead == 'o') ADVANCE(220);
      END_STATE();
    case 171:
      if (lookahead == 'i') ADVANCE(221);
      END_STATE();
    case 172:
      if (lookahead == 'r') ADVANCE(222);
      END_STATE();
    case 173:
      if (lookahead == 'i') ADVANCE(223);
      END_STATE();
    case 174:
      if (lookahead == 'n') ADVANCE(224);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 176:
      if (lookahead == 'c') ADVANCE(226);
      END_STATE();
    case 177:
      if (lookahead == 'o') ADVANCE(227);
      END_STATE();
    case 178:
      if (lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 180:
      if (lookahead == 'w') ADVANCE(229);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(230);
      END_STATE();
    case 183:
      if (lookahead == 'f') ADVANCE(231);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 185:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 187:
      if (lookahead == 'd') ADVANCE(233);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(234);
      END_STATE();
    case 189:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 192:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 197:
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 198:
      if (lookahead == 'g') ADVANCE(238);
      END_STATE();
    case 199:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(240);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(242);
      END_STATE();
    case 203:
      if (lookahead == 'd') ADVANCE(243);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 206:
      if (lookahead == 'i') ADVANCE(245);
      END_STATE();
    case 207:
      if (lookahead == 'l') ADVANCE(246);
      END_STATE();
    case 208:
      if (lookahead == 'm') ADVANCE(247);
      END_STATE();
    case 209:
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 211:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 212:
      if (lookahead == 'f') ADVANCE(250);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 215:
      if (lookahead == 'p') ADVANCE(252);
      END_STATE();
    case 216:
      if (lookahead == 'r') ADVANCE(253);
      END_STATE();
    case 217:
      if (lookahead == 't') ADVANCE(254);
      END_STATE();
    case 218:
      if (lookahead == 'c') ADVANCE(255);
      END_STATE();
    case 219:
      if (lookahead == 'c') ADVANCE(256);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(257);
      END_STATE();
    case 221:
      if (lookahead == 'r') ADVANCE(258);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(259);
      END_STATE();
    case 223:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 224:
      if (lookahead == 'g') ADVANCE(261);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 226:
      if (lookahead == 'h') ADVANCE(262);
      END_STATE();
    case 227:
      if (lookahead == 'l') ADVANCE(263);
      END_STATE();
    case 228:
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 230:
      if (lookahead == 'f') ADVANCE(265);
      END_STATE();
    case 231:
      if (lookahead == 'i') ADVANCE(266);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(267);
      END_STATE();
    case 235:
      if (lookahead == 's') ADVANCE(268);
      END_STATE();
    case 236:
      if (lookahead == 'n') ADVANCE(269);
      END_STATE();
    case 237:
      if (lookahead == 'u') ADVANCE(270);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(271);
      END_STATE();
    case 239:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 240:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 243:
      if (lookahead == 's') ADVANCE(274);
      END_STATE();
    case 244:
      if (lookahead == 'y') ADVANCE(275);
      END_STATE();
    case 245:
      if (lookahead == 'o') ADVANCE(276);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(277);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 249:
      if (lookahead == 'c') ADVANCE(278);
      END_STATE();
    case 250:
      if (lookahead == 'a') ADVANCE(279);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 252:
      if (lookahead == 'a') ADVANCE(280);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 254:
      if (lookahead == 'e') ADVANCE(281);
      END_STATE();
    case 255:
      if (lookahead == 't') ADVANCE(282);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 257:
      if (lookahead == 'l') ADVANCE(283);
      END_STATE();
    case 258:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 266:
      if (lookahead == 'n') ADVANCE(285);
      END_STATE();
    case 267:
      if (lookahead == 't') ADVANCE(286);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(287);
      END_STATE();
    case 271:
      if (lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 276:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 277:
      if (lookahead == 'n') ADVANCE(290);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 279:
      if (lookahead == 'c') ADVANCE(292);
      END_STATE();
    case 280:
      if (lookahead == 'c') ADVANCE(293);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 282:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 283:
      if (lookahead == 'y') ADVANCE(295);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(296);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 290:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 291:
      if (lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 293:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(301);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 296:
      if (lookahead == 'd') ADVANCE(302);
      END_STATE();
    case 297:
      if (lookahead == 's') ADVANCE(303);
      END_STATE();
    case 298:
      if (lookahead == 'f') ADVANCE(304);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 64},
  [2] = {.lex_state = 64},
  [3] = {.lex_state = 64},
  [4] = {.lex_state = 64},
  [5] = {.lex_state = 64},
  [6] = {.lex_state = 64},
  [7] = {.lex_state = 64},
  [8] = {.lex_state = 64},
  [9] = {.lex_state = 64},
  [10] = {.lex_state = 64},
  [11] = {.lex_state = 64},
  [12] = {.lex_state = 64},
  [13] = {.lex_state = 64},
  [14] = {.lex_state = 64},
  [15] = {.lex_state = 64},
  [16] = {.lex_state = 64},
  [17] = {.lex_state = 64},
  [18] = {.lex_state = 64},
  [19] = {.lex_state = 64},
  [20] = {.lex_state = 64},
  [21] = {.lex_state = 64},
  [22] = {.lex_state = 64},
  [23] = {.lex_state = 64},
  [24] = {.lex_state = 64},
  [25] = {.lex_state = 64},
  [26] = {.lex_state = 64},
  [27] = {.lex_state = 64},
  [28] = {.lex_state = 64},
  [29] = {.lex_state = 64},
  [30] = {.lex_state = 64},
  [31] = {.lex_state = 64},
  [32] = {.lex_state = 64},
  [33] = {.lex_state = 64},
  [34] = {.lex_state = 64},
  [35] = {.lex_state = 64},
  [36] = {.lex_state = 64},
  [37] = {.lex_state = 64},
  [38] = {.lex_state = 64},
  [39] = {.lex_state = 64},
  [40] = {.lex_state = 64},
  [41] = {.lex_state = 64},
  [42] = {.lex_state = 64},
  [43] = {.lex_state = 64},
  [44] = {.lex_state = 64},
  [45] = {.lex_state = 64},
  [46] = {.lex_state = 64},
  [47] = {.lex_state = 64},
  [48] = {.lex_state = 64},
  [49] = {.lex_state = 64},
  [50] = {.lex_state = 64},
  [51] = {.lex_state = 64},
  [52] = {.lex_state = 64},
  [53] = {.lex_state = 64},
  [54] = {.lex_state = 10},
  [55] = {.lex_state = 10},
  [56] = {.lex_state = 10},
  [57] = {.lex_state = 10},
  [58] = {.lex_state = 10},
  [59] = {.lex_state = 10},
  [60] = {.lex_state = 10},
  [61] = {.lex_state = 10},
  [62] = {.lex_state = 10},
  [63] = {.lex_state = 10},
  [64] = {.lex_state = 10},
  [65] = {.lex_state = 10},
  [66] = {.lex_state = 10},
  [67] = {.lex_state = 10},
  [68] = {.lex_state = 10},
  [69] = {.lex_state = 10},
  [70] = {.lex_state = 10},
  [71] = {.lex_state = 10},
  [72] = {.lex_state = 10},
  [73] = {.lex_state = 10},
  [74] = {.lex_state = 10},
  [75] = {.lex_state = 10},
  [76] = {.lex_state = 10},
  [77] = {.lex_state = 10},
  [78] = {.lex_state = 10},
  [79] = {.lex_state = 10},
  [80] = {.lex_state = 10},
  [81] = {.lex_state = 10},
  [82] = {.lex_state = 10},
  [83] = {.lex_state = 10},
  [84] = {.lex_state = 10},
  [85] = {.lex_state = 10},
  [86] = {.lex_state = 10},
  [87] = {.lex_state = 10},
  [88] = {.lex_state = 10},
  [89] = {.lex_state = 10},
  [90] = {.lex_state = 10},
  [91] = {.lex_state = 63, .external_lex_state = 2},
  [92] = {.lex_state = 10},
  [93] = {.lex_state = 10},
  [94] = {.lex_state = 10},
  [95] = {.lex_state = 10},
  [96] = {.lex_state = 10},
  [97] = {.lex_state = 10},
  [98] = {.lex_state = 63, .external_lex_state = 3},
  [99] = {.lex_state = 10},
  [100] = {.lex_state = 10},
  [101] = {.lex_state = 63, .external_lex_state = 3},
  [102] = {.lex_state = 2, .external_lex_state = 3},
  [103] = {.lex_state = 63, .external_lex_state = 2},
  [104] = {.lex_state = 63, .external_lex_state = 4},
  [105] = {.lex_state = 63, .external_lex_state = 2},
  [106] = {.lex_state = 63, .external_lex_state = 4},
  [107] = {.lex_state = 63, .external_lex_state = 3},
  [108] = {.lex_state = 63, .external_lex_state = 3},
  [109] = {.lex_state = 63, .external_lex_state = 3},
  [110] = {.lex_state = 63, .external_lex_state = 2},
  [111] = {.lex_state = 4, .external_lex_state = 3},
  [112] = {.lex_state = 63, .external_lex_state = 3},
  [113] = {.lex_state = 63, .external_lex_state = 3},
  [114] = {.lex_state = 63, .external_lex_state = 3},
  [115] = {.lex_state = 63, .external_lex_state = 3},
  [116] = {.lex_state = 63, .external_lex_state = 2},
  [117] = {.lex_state = 4, .external_lex_state = 3},
  [118] = {.lex_state = 63, .external_lex_state = 3},
  [119] = {.lex_state = 63, .external_lex_state = 3},
  [120] = {.lex_state = 2, .external_lex_state = 2},
  [121] = {.lex_state = 2, .external_lex_state = 3},
  [122] = {.lex_state = 2, .external_lex_state = 4},
  [123] = {.lex_state = 2, .external_lex_state = 3},
  [124] = {.lex_state = 2, .external_lex_state = 2},
  [125] = {.lex_state = 2, .external_lex_state = 2},
  [126] = {.lex_state = 2, .external_lex_state = 4},
  [127] = {.lex_state = 2, .external_lex_state = 3},
  [128] = {.lex_state = 2, .external_lex_state = 3},
  [129] = {.lex_state = 63, .external_lex_state = 2},
  [130] = {.lex_state = 2, .external_lex_state = 2},
  [131] = {.lex_state = 63, .external_lex_state = 2},
  [132] = {.lex_state = 2, .external_lex_state = 3},
  [133] = {.lex_state = 63, .external_lex_state = 2},
  [134] = {.lex_state = 63, .external_lex_state = 2},
  [135] = {.lex_state = 63, .external_lex_state = 2},
  [136] = {.lex_state = 2, .external_lex_state = 3},
  [137] = {.lex_state = 63, .external_lex_state = 2},
  [138] = {.lex_state = 63, .external_lex_state = 2},
  [139] = {.lex_state = 2, .external_lex_state = 2},
  [140] = {.lex_state = 63, .external_lex_state = 2},
  [141] = {.lex_state = 63, .external_lex_state = 2},
  [142] = {.lex_state = 63, .external_lex_state = 2},
  [143] = {.lex_state = 63, .external_lex_state = 2},
  [144] = {.lex_state = 63, .external_lex_state = 2},
  [145] = {.lex_state = 2, .external_lex_state = 3},
  [146] = {.lex_state = 2, .external_lex_state = 3},
  [147] = {.lex_state = 63, .external_lex_state = 2},
  [148] = {.lex_state = 63, .external_lex_state = 2},
  [149] = {.lex_state = 63, .external_lex_state = 2},
  [150] = {.lex_state = 63, .external_lex_state = 2},
  [151] = {.lex_state = 63, .external_lex_state = 2},
  [152] = {.lex_state = 63, .external_lex_state = 2},
  [153] = {.lex_state = 2, .external_lex_state = 3},
  [154] = {.lex_state = 63, .external_lex_state = 2},
  [155] = {.lex_state = 63, .external_lex_state = 2},
  [156] = {.lex_state = 2, .external_lex_state = 3},
  [157] = {.lex_state = 63, .external_lex_state = 2},
  [158] = {.lex_state = 63, .external_lex_state = 2},
  [159] = {.lex_state = 63, .external_lex_state = 2},
  [160] = {.lex_state = 63, .external_lex_state = 2},
  [161] = {.lex_state = 63, .external_lex_state = 2},
  [162] = {.lex_state = 63, .external_lex_state = 2},
  [163] = {.lex_state = 63, .external_lex_state = 2},
  [164] = {.lex_state = 2, .external_lex_state = 3},
  [165] = {.lex_state = 2, .external_lex_state = 3},
  [166] = {.lex_state = 64},
  [167] = {.lex_state = 64},
  [168] = {.lex_state = 2, .external_lex_state = 3},
  [169] = {.lex_state = 64},
  [170] = {.lex_state = 2, .external_lex_state = 3},
  [171] = {.lex_state = 64},
  [172] = {.lex_state = 2, .external_lex_state = 3},
  [173] = {.lex_state = 2, .external_lex_state = 3},
  [174] = {.lex_state = 64},
  [175] = {.lex_state = 64},
  [176] = {.lex_state = 64},
  [177] = {.lex_state = 64},
  [178] = {.lex_state = 64},
  [179] = {.lex_state = 64},
  [180] = {.lex_state = 64},
  [181] = {.lex_state = 64},
  [182] = {.lex_state = 64},
  [183] = {.lex_state = 64},
  [184] = {.lex_state = 64},
  [185] = {.lex_state = 64},
  [186] = {.lex_state = 64},
  [187] = {.lex_state = 64},
  [188] = {.lex_state = 64},
  [189] = {.lex_state = 64},
  [190] = {.lex_state = 64, .external_lex_state = 5},
  [191] = {.lex_state = 64},
  [192] = {.lex_state = 64},
  [193] = {.lex_state = 64},
  [194] = {.lex_state = 64},
  [195] = {.lex_state = 64},
  [196] = {.lex_state = 64},
  [197] = {.lex_state = 64},
  [198] = {.lex_state = 64},
  [199] = {.lex_state = 64},
  [200] = {.lex_state = 64},
  [201] = {.lex_state = 64},
  [202] = {.lex_state = 64},
  [203] = {.lex_state = 64},
  [204] = {.lex_state = 64},
  [205] = {.lex_state = 64},
  [206] = {.lex_state = 64},
  [207] = {.lex_state = 64},
  [208] = {.lex_state = 64},
  [209] = {.lex_state = 64},
  [210] = {.lex_state = 64},
  [211] = {.lex_state = 64},
  [212] = {.lex_state = 64},
  [213] = {.lex_state = 64},
  [214] = {.lex_state = 64},
  [215] = {.lex_state = 64},
  [216] = {.lex_state = 64},
  [217] = {.lex_state = 64},
  [218] = {.lex_state = 64},
  [219] = {.lex_state = 3, .external_lex_state = 2},
  [220] = {.lex_state = 3, .external_lex_state = 2},
  [221] = {.lex_state = 3, .external_lex_state = 2},
  [222] = {.lex_state = 3, .external_lex_state = 2},
  [223] = {.lex_state = 64},
  [224] = {.lex_state = 3, .external_lex_state = 2},
  [225] = {.lex_state = 3, .external_lex_state = 2},
  [226] = {.lex_state = 3, .external_lex_state = 2},
  [227] = {.lex_state = 64},
  [228] = {.lex_state = 64},
  [229] = {.lex_state = 64},
  [230] = {.lex_state = 64},
  [231] = {.lex_state = 64},
  [232] = {.lex_state = 64},
  [233] = {.lex_state = 64},
  [234] = {.lex_state = 64},
  [235] = {.lex_state = 64},
  [236] = {.lex_state = 64},
  [237] = {.lex_state = 64},
  [238] = {.lex_state = 64},
  [239] = {.lex_state = 64},
  [240] = {.lex_state = 64},
  [241] = {.lex_state = 64},
  [242] = {.lex_state = 64},
  [243] = {.lex_state = 64},
  [244] = {.lex_state = 64},
  [245] = {.lex_state = 64},
  [246] = {.lex_state = 64},
  [247] = {.lex_state = 64},
  [248] = {.lex_state = 64, .external_lex_state = 5},
  [249] = {.lex_state = 64},
  [250] = {.lex_state = 64},
  [251] = {.lex_state = 64},
  [252] = {.lex_state = 64},
  [253] = {.lex_state = 64},
  [254] = {.lex_state = 64},
  [255] = {.lex_state = 64},
  [256] = {.lex_state = 64},
  [257] = {.lex_state = 64},
  [258] = {.lex_state = 64},
  [259] = {.lex_state = 64},
  [260] = {.lex_state = 64},
  [261] = {.lex_state = 64},
  [262] = {.lex_state = 64},
  [263] = {.lex_state = 64},
  [264] = {.lex_state = 64},
  [265] = {.lex_state = 64},
  [266] = {.lex_state = 64},
  [267] = {.lex_state = 64},
  [268] = {.lex_state = 64},
  [269] = {.lex_state = 64},
  [270] = {.lex_state = 64},
  [271] = {.lex_state = 64},
  [272] = {.lex_state = 64},
  [273] = {.lex_state = 64},
  [274] = {.lex_state = 64},
  [275] = {.lex_state = 64},
  [276] = {.lex_state = 64},
  [277] = {.lex_state = 64},
  [278] = {.lex_state = 64},
  [279] = {.lex_state = 64},
  [280] = {.lex_state = 64},
  [281] = {.lex_state = 64},
  [282] = {.lex_state = 64},
  [283] = {.lex_state = 64},
  [284] = {.lex_state = 2, .external_lex_state = 2},
  [285] = {.lex_state = 2, .external_lex_state = 2},
  [286] = {.lex_state = 2, .external_lex_state = 2},
  [287] = {.lex_state = 64},
  [288] = {.lex_state = 2, .external_lex_state = 2},
  [289] = {.lex_state = 2, .external_lex_state = 2},
  [290] = {.lex_state = 64},
  [291] = {.lex_state = 2, .external_lex_state = 2},
  [292] = {.lex_state = 2, .external_lex_state = 2},
  [293] = {.lex_state = 64},
  [294] = {.lex_state = 64},
  [295] = {.lex_state = 64},
  [296] = {.lex_state = 64},
  [297] = {.lex_state = 64},
  [298] = {.lex_state = 64},
  [299] = {.lex_state = 64},
  [300] = {.lex_state = 64},
  [301] = {.lex_state = 64},
  [302] = {.lex_state = 64},
  [303] = {.lex_state = 64},
  [304] = {.lex_state = 64},
  [305] = {.lex_state = 64},
  [306] = {.lex_state = 64},
  [307] = {.lex_state = 64},
  [308] = {.lex_state = 64},
  [309] = {.lex_state = 64},
  [310] = {.lex_state = 64},
  [311] = {.lex_state = 64},
  [312] = {.lex_state = 64},
  [313] = {.lex_state = 3, .external_lex_state = 2},
  [314] = {.lex_state = 64},
  [315] = {.lex_state = 64},
  [316] = {.lex_state = 64},
  [317] = {.lex_state = 64},
  [318] = {.lex_state = 64},
  [319] = {.lex_state = 64},
  [320] = {.lex_state = 64},
  [321] = {.lex_state = 64},
  [322] = {.lex_state = 64},
  [323] = {.lex_state = 64},
  [324] = {.lex_state = 64},
  [325] = {.lex_state = 64},
  [326] = {.lex_state = 64},
  [327] = {.lex_state = 64},
  [328] = {.lex_state = 64},
  [329] = {.lex_state = 64},
  [330] = {.lex_state = 64},
  [331] = {.lex_state = 64},
  [332] = {.lex_state = 64},
  [333] = {.lex_state = 64},
  [334] = {.lex_state = 64},
  [335] = {.lex_state = 64},
  [336] = {.lex_state = 64},
  [337] = {.lex_state = 64},
  [338] = {.lex_state = 64},
  [339] = {.lex_state = 64},
  [340] = {.lex_state = 64},
  [341] = {.lex_state = 64},
  [342] = {.lex_state = 64},
  [343] = {.lex_state = 64},
  [344] = {.lex_state = 64},
  [345] = {.lex_state = 64},
  [346] = {.lex_state = 64},
  [347] = {.lex_state = 64},
  [348] = {.lex_state = 64},
  [349] = {.lex_state = 64},
  [350] = {.lex_state = 64},
  [351] = {.lex_state = 64},
  [352] = {.lex_state = 64},
  [353] = {.lex_state = 64},
  [354] = {.lex_state = 64},
  [355] = {.lex_state = 64},
  [356] = {.lex_state = 64},
  [357] = {.lex_state = 64},
  [358] = {.lex_state = 64},
  [359] = {.lex_state = 64},
  [360] = {.lex_state = 64},
  [361] = {.lex_state = 64},
  [362] = {.lex_state = 64},
  [363] = {.lex_state = 64},
  [364] = {.lex_state = 64},
  [365] = {.lex_state = 64},
  [366] = {.lex_state = 64},
  [367] = {.lex_state = 64},
  [368] = {.lex_state = 64},
  [369] = {.lex_state = 64},
  [370] = {.lex_state = 64},
  [371] = {.lex_state = 3, .external_lex_state = 2},
  [372] = {.lex_state = 64},
  [373] = {.lex_state = 64},
  [374] = {.lex_state = 64},
  [375] = {.lex_state = 64},
  [376] = {.lex_state = 64},
  [377] = {.lex_state = 64},
  [378] = {.lex_state = 64},
  [379] = {.lex_state = 64},
  [380] = {.lex_state = 64},
  [381] = {.lex_state = 64},
  [382] = {.lex_state = 64},
  [383] = {.lex_state = 64},
  [384] = {.lex_state = 64},
  [385] = {.lex_state = 64},
  [386] = {.lex_state = 64},
  [387] = {.lex_state = 64},
  [388] = {.lex_state = 64},
  [389] = {.lex_state = 64},
  [390] = {.lex_state = 64},
  [391] = {.lex_state = 64},
  [392] = {.lex_state = 64},
  [393] = {.lex_state = 64},
  [394] = {.lex_state = 64},
  [395] = {.lex_state = 64},
  [396] = {.lex_state = 64},
  [397] = {.lex_state = 64},
  [398] = {.lex_state = 64},
  [399] = {.lex_state = 64},
  [400] = {.lex_state = 64},
  [401] = {.lex_state = 64},
  [402] = {.lex_state = 64},
  [403] = {.lex_state = 64},
  [404] = {.lex_state = 64},
  [405] = {.lex_state = 64},
  [406] = {.lex_state = 64},
  [407] = {.lex_state = 64},
  [408] = {.lex_state = 64},
  [409] = {.lex_state = 64},
  [410] = {.lex_state = 64},
  [411] = {.lex_state = 64},
  [412] = {.lex_state = 64},
  [413] = {.lex_state = 64},
  [414] = {.lex_state = 64},
  [415] = {.lex_state = 64},
  [416] = {.lex_state = 64},
  [417] = {.lex_state = 64},
  [418] = {.lex_state = 64},
  [419] = {.lex_state = 64},
  [420] = {.lex_state = 64},
  [421] = {.lex_state = 64},
  [422] = {.lex_state = 64},
  [423] = {.lex_state = 64},
  [424] = {.lex_state = 64},
  [425] = {.lex_state = 64},
  [426] = {.lex_state = 64},
  [427] = {.lex_state = 64},
  [428] = {.lex_state = 64},
  [429] = {.lex_state = 64},
  [430] = {.lex_state = 64},
  [431] = {.lex_state = 64},
  [432] = {.lex_state = 64},
  [433] = {.lex_state = 64},
  [434] = {.lex_state = 64},
  [435] = {.lex_state = 64},
  [436] = {.lex_state = 64},
  [437] = {.lex_state = 64},
  [438] = {.lex_state = 64},
  [439] = {.lex_state = 64},
  [440] = {.lex_state = 64},
  [441] = {.lex_state = 64},
  [442] = {.lex_state = 64},
  [443] = {.lex_state = 64},
  [444] = {.lex_state = 64},
  [445] = {.lex_state = 64},
  [446] = {.lex_state = 64},
  [447] = {.lex_state = 64},
  [448] = {.lex_state = 64},
  [449] = {.lex_state = 64},
  [450] = {.lex_state = 64},
  [451] = {.lex_state = 64},
  [452] = {.lex_state = 64},
  [453] = {.lex_state = 64},
  [454] = {.lex_state = 64},
  [455] = {.lex_state = 64},
  [456] = {.lex_state = 64},
  [457] = {.lex_state = 64},
  [458] = {.lex_state = 64},
  [459] = {.lex_state = 64},
  [460] = {.lex_state = 64},
  [461] = {.lex_state = 64},
  [462] = {.lex_state = 64},
  [463] = {.lex_state = 64},
  [464] = {.lex_state = 64},
  [465] = {.lex_state = 64},
  [466] = {.lex_state = 64},
  [467] = {.lex_state = 64},
  [468] = {.lex_state = 64},
  [469] = {.lex_state = 64},
  [470] = {.lex_state = 64},
  [471] = {.lex_state = 64},
  [472] = {.lex_state = 64},
  [473] = {.lex_state = 64},
  [474] = {.lex_state = 64},
  [475] = {.lex_state = 64},
  [476] = {.lex_state = 64},
  [477] = {.lex_state = 64},
  [478] = {.lex_state = 64},
  [479] = {.lex_state = 64},
  [480] = {.lex_state = 64},
  [481] = {.lex_state = 64},
  [482] = {.lex_state = 64},
  [483] = {.lex_state = 64},
  [484] = {.lex_state = 64},
  [485] = {.lex_state = 64},
  [486] = {.lex_state = 64},
  [487] = {.lex_state = 64},
  [488] = {.lex_state = 64},
  [489] = {.lex_state = 64},
  [490] = {.lex_state = 64},
  [491] = {.lex_state = 64},
  [492] = {.lex_state = 64},
  [493] = {.lex_state = 64},
  [494] = {.lex_state = 64},
  [495] = {.lex_state = 64},
  [496] = {.lex_state = 64},
  [497] = {.lex_state = 64},
  [498] = {.lex_state = 64},
  [499] = {.lex_state = 64},
  [500] = {.lex_state = 64},
  [501] = {.lex_state = 64},
  [502] = {.lex_state = 64},
  [503] = {.lex_state = 64},
  [504] = {.lex_state = 64},
  [505] = {.lex_state = 64},
  [506] = {.lex_state = 64},
  [507] = {.lex_state = 64},
  [508] = {.lex_state = 64},
  [509] = {.lex_state = 64},
  [510] = {.lex_state = 64},
  [511] = {.lex_state = 64},
  [512] = {.lex_state = 64},
  [513] = {.lex_state = 64},
  [514] = {.lex_state = 64},
  [515] = {.lex_state = 64},
  [516] = {.lex_state = 64},
  [517] = {.lex_state = 64},
  [518] = {.lex_state = 64},
  [519] = {.lex_state = 64},
  [520] = {.lex_state = 64},
  [521] = {.lex_state = 64},
  [522] = {.lex_state = 64},
  [523] = {.lex_state = 64},
  [524] = {.lex_state = 64},
  [525] = {.lex_state = 64},
  [526] = {.lex_state = 64},
  [527] = {.lex_state = 64},
  [528] = {.lex_state = 64},
  [529] = {.lex_state = 64},
  [530] = {.lex_state = 64},
  [531] = {.lex_state = 64},
  [532] = {.lex_state = 64},
  [533] = {.lex_state = 64},
  [534] = {.lex_state = 64},
  [535] = {.lex_state = 64},
  [536] = {.lex_state = 64},
  [537] = {.lex_state = 64},
  [538] = {.lex_state = 64},
  [539] = {.lex_state = 64},
  [540] = {.lex_state = 64},
  [541] = {.lex_state = 64},
  [542] = {.lex_state = 64},
  [543] = {.lex_state = 64},
  [544] = {.lex_state = 64},
  [545] = {.lex_state = 64},
  [546] = {.lex_state = 64},
  [547] = {.lex_state = 64},
  [548] = {.lex_state = 64},
  [549] = {.lex_state = 64},
  [550] = {.lex_state = 64},
  [551] = {.lex_state = 64},
  [552] = {.lex_state = 64},
  [553] = {.lex_state = 64},
  [554] = {.lex_state = 64},
  [555] = {.lex_state = 64},
  [556] = {.lex_state = 64},
  [557] = {.lex_state = 64},
  [558] = {.lex_state = 64},
  [559] = {.lex_state = 64},
  [560] = {.lex_state = 64},
  [561] = {.lex_state = 64},
  [562] = {.lex_state = 64},
  [563] = {.lex_state = 64},
  [564] = {.lex_state = 64},
  [565] = {.lex_state = 64},
  [566] = {.lex_state = 64},
  [567] = {.lex_state = 64},
  [568] = {.lex_state = 64},
  [569] = {.lex_state = 64},
  [570] = {.lex_state = 64},
  [571] = {.lex_state = 64},
  [572] = {.lex_state = 64},
  [573] = {.lex_state = 64},
  [574] = {.lex_state = 64},
  [575] = {.lex_state = 64},
  [576] = {.lex_state = 64},
  [577] = {.lex_state = 64},
  [578] = {.lex_state = 64},
  [579] = {.lex_state = 64},
  [580] = {.lex_state = 64},
  [581] = {.lex_state = 64},
  [582] = {.lex_state = 64},
  [583] = {.lex_state = 64},
  [584] = {.lex_state = 64},
  [585] = {.lex_state = 64},
  [586] = {.lex_state = 64},
  [587] = {.lex_state = 64},
  [588] = {.lex_state = 64},
  [589] = {.lex_state = 64},
  [590] = {.lex_state = 64},
  [591] = {.lex_state = 64},
  [592] = {.lex_state = 64},
  [593] = {.lex_state = 64},
  [594] = {.lex_state = 64},
  [595] = {.lex_state = 64},
  [596] = {.lex_state = 64},
  [597] = {.lex_state = 64},
  [598] = {.lex_state = 64},
  [599] = {.lex_state = 64},
  [600] = {.lex_state = 64},
  [601] = {.lex_state = 64},
  [602] = {.lex_state = 64},
  [603] = {.lex_state = 64},
  [604] = {.lex_state = 64},
  [605] = {.lex_state = 64},
  [606] = {.lex_state = 64},
  [607] = {.lex_state = 64},
  [608] = {.lex_state = 64},
  [609] = {.lex_state = 64},
  [610] = {.lex_state = 64},
  [611] = {.lex_state = 64},
  [612] = {.lex_state = 64},
  [613] = {.lex_state = 64},
  [614] = {.lex_state = 64},
  [615] = {.lex_state = 64},
  [616] = {.lex_state = 64},
  [617] = {.lex_state = 64},
  [618] = {.lex_state = 64},
  [619] = {.lex_state = 64},
  [620] = {.lex_state = 64},
  [621] = {.lex_state = 64},
  [622] = {.lex_state = 64},
  [623] = {.lex_state = 64},
  [624] = {.lex_state = 64},
  [625] = {.lex_state = 64},
  [626] = {.lex_state = 64},
  [627] = {.lex_state = 64},
  [628] = {.lex_state = 64},
  [629] = {.lex_state = 64},
  [630] = {.lex_state = 64},
  [631] = {.lex_state = 64},
  [632] = {.lex_state = 64},
  [633] = {.lex_state = 64},
  [634] = {.lex_state = 64},
  [635] = {.lex_state = 64},
  [636] = {.lex_state = 64},
  [637] = {.lex_state = 64},
  [638] = {.lex_state = 64},
  [639] = {.lex_state = 64},
  [640] = {.lex_state = 64},
  [641] = {.lex_state = 64},
  [642] = {.lex_state = 64},
  [643] = {.lex_state = 64},
  [644] = {.lex_state = 64},
  [645] = {.lex_state = 64},
  [646] = {.lex_state = 64},
  [647] = {.lex_state = 64},
  [648] = {.lex_state = 64},
  [649] = {.lex_state = 64},
  [650] = {.lex_state = 64},
  [651] = {.lex_state = 64},
  [652] = {.lex_state = 64},
  [653] = {.lex_state = 64},
  [654] = {.lex_state = 64},
  [655] = {.lex_state = 64},
  [656] = {.lex_state = 64},
  [657] = {.lex_state = 64},
  [658] = {.lex_state = 64},
  [659] = {.lex_state = 64},
  [660] = {.lex_state = 64},
  [661] = {.lex_state = 64},
  [662] = {.lex_state = 64},
  [663] = {.lex_state = 64},
  [664] = {.lex_state = 64},
  [665] = {.lex_state = 64},
  [666] = {.lex_state = 64},
  [667] = {.lex_state = 64},
  [668] = {.lex_state = 64},
  [669] = {.lex_state = 64},
  [670] = {.lex_state = 64},
  [671] = {.lex_state = 64},
  [672] = {.lex_state = 64},
  [673] = {.lex_state = 64},
  [674] = {.lex_state = 64},
  [675] = {.lex_state = 64},
  [676] = {.lex_state = 64},
  [677] = {.lex_state = 64},
  [678] = {.lex_state = 64},
  [679] = {.lex_state = 64},
  [680] = {.lex_state = 64},
  [681] = {.lex_state = 64},
  [682] = {.lex_state = 64},
  [683] = {.lex_state = 64},
  [684] = {.lex_state = 64},
  [685] = {.lex_state = 64},
  [686] = {.lex_state = 64},
  [687] = {.lex_state = 64},
  [688] = {.lex_state = 64},
  [689] = {.lex_state = 64},
  [690] = {.lex_state = 64},
  [691] = {.lex_state = 64},
  [692] = {.lex_state = 64},
  [693] = {.lex_state = 64},
  [694] = {.lex_state = 64},
  [695] = {.lex_state = 64},
  [696] = {.lex_state = 64},
  [697] = {.lex_state = 64},
  [698] = {.lex_state = 64},
  [699] = {.lex_state = 64},
  [700] = {.lex_state = 64},
  [701] = {.lex_state = 64},
  [702] = {.lex_state = 64},
  [703] = {.lex_state = 64},
  [704] = {.lex_state = 64},
  [705] = {.lex_state = 64},
  [706] = {.lex_state = 64},
  [707] = {.lex_state = 64},
  [708] = {.lex_state = 64},
  [709] = {.lex_state = 64},
  [710] = {.lex_state = 64},
  [711] = {.lex_state = 64},
  [712] = {.lex_state = 64},
  [713] = {.lex_state = 64},
  [714] = {.lex_state = 64},
  [715] = {.lex_state = 64},
  [716] = {.lex_state = 64},
  [717] = {.lex_state = 64},
  [718] = {.lex_state = 64},
  [719] = {.lex_state = 64},
  [720] = {.lex_state = 64},
  [721] = {.lex_state = 64},
  [722] = {.lex_state = 64},
  [723] = {.lex_state = 64},
  [724] = {.lex_state = 64},
  [725] = {.lex_state = 64},
  [726] = {.lex_state = 64},
  [727] = {.lex_state = 64},
  [728] = {.lex_state = 64},
  [729] = {.lex_state = 64},
  [730] = {.lex_state = 64},
  [731] = {.lex_state = 64},
  [732] = {.lex_state = 64},
  [733] = {.lex_state = 64},
  [734] = {.lex_state = 64},
  [735] = {.lex_state = 64},
  [736] = {.lex_state = 64},
  [737] = {.lex_state = 64},
  [738] = {.lex_state = 64},
  [739] = {.lex_state = 64},
  [740] = {.lex_state = 64},
  [741] = {.lex_state = 64},
  [742] = {.lex_state = 64},
  [743] = {.lex_state = 64},
  [744] = {.lex_state = 64},
  [745] = {.lex_state = 64},
  [746] = {.lex_state = 64},
  [747] = {.lex_state = 64},
  [748] = {.lex_state = 64},
  [749] = {.lex_state = 64},
  [750] = {.lex_state = 64},
  [751] = {.lex_state = 64},
  [752] = {.lex_state = 64},
  [753] = {.lex_state = 64},
  [754] = {.lex_state = 64},
  [755] = {.lex_state = 64},
  [756] = {.lex_state = 64},
  [757] = {.lex_state = 64},
  [758] = {.lex_state = 64},
  [759] = {.lex_state = 64},
  [760] = {.lex_state = 64},
  [761] = {.lex_state = 64},
  [762] = {.lex_state = 64},
  [763] = {.lex_state = 64},
  [764] = {.lex_state = 64},
  [765] = {.lex_state = 64},
  [766] = {.lex_state = 64},
  [767] = {.lex_state = 64},
  [768] = {.lex_state = 64},
  [769] = {.lex_state = 64},
  [770] = {.lex_state = 64},
  [771] = {.lex_state = 64},
  [772] = {.lex_state = 64},
  [773] = {.lex_state = 64},
  [774] = {.lex_state = 64},
  [775] = {.lex_state = 64},
  [776] = {.lex_state = 64},
  [777] = {.lex_state = 64},
  [778] = {.lex_state = 64},
  [779] = {.lex_state = 64},
  [780] = {.lex_state = 64},
  [781] = {.lex_state = 64},
  [782] = {.lex_state = 64},
  [783] = {.lex_state = 64},
  [784] = {.lex_state = 64},
  [785] = {.lex_state = 64},
  [786] = {.lex_state = 64},
  [787] = {.lex_state = 64},
  [788] = {.lex_state = 64},
  [789] = {.lex_state = 64},
  [790] = {.lex_state = 64},
  [791] = {.lex_state = 64},
  [792] = {.lex_state = 64},
  [793] = {.lex_state = 64},
  [794] = {.lex_state = 64},
  [795] = {.lex_state = 64},
  [796] = {.lex_state = 64},
  [797] = {.lex_state = 64},
  [798] = {.lex_state = 64},
  [799] = {.lex_state = 64},
  [800] = {.lex_state = 64},
  [801] = {.lex_state = 64},
  [802] = {.lex_state = 64},
  [803] = {.lex_state = 64},
  [804] = {.lex_state = 64},
  [805] = {.lex_state = 64},
  [806] = {.lex_state = 64},
  [807] = {.lex_state = 64},
  [808] = {.lex_state = 64},
  [809] = {.lex_state = 64},
  [810] = {.lex_state = 64},
  [811] = {.lex_state = 64},
  [812] = {.lex_state = 64},
  [813] = {.lex_state = 64},
  [814] = {.lex_state = 64},
  [815] = {.lex_state = 64},
  [816] = {.lex_state = 64},
  [817] = {.lex_state = 64},
  [818] = {.lex_state = 64},
  [819] = {.lex_state = 64},
  [820] = {.lex_state = 64},
  [821] = {.lex_state = 64},
  [822] = {.lex_state = 64},
  [823] = {.lex_state = 64},
  [824] = {.lex_state = 64},
  [825] = {.lex_state = 64},
  [826] = {.lex_state = 64},
  [827] = {.lex_state = 64},
  [828] = {.lex_state = 64},
  [829] = {.lex_state = 64},
  [830] = {.lex_state = 64},
  [831] = {.lex_state = 64},
  [832] = {.lex_state = 64},
  [833] = {.lex_state = 64},
  [834] = {.lex_state = 64},
  [835] = {.lex_state = 64},
  [836] = {.lex_state = 64},
  [837] = {.lex_state = 64},
  [838] = {.lex_state = 64},
  [839] = {.lex_state = 64},
  [840] = {.lex_state = 64},
  [841] = {.lex_state = 64},
  [842] = {.lex_state = 64},
  [843] = {.lex_state = 64},
  [844] = {.lex_state = 64},
  [845] = {.lex_state = 64},
  [846] = {.lex_state = 64},
  [847] = {.lex_state = 64},
  [848] = {.lex_state = 64},
  [849] = {.lex_state = 64},
  [850] = {.lex_state = 64},
  [851] = {.lex_state = 64},
  [852] = {.lex_state = 64},
  [853] = {.lex_state = 64},
  [854] = {.lex_state = 64},
  [855] = {.lex_state = 64},
  [856] = {.lex_state = 64},
  [857] = {.lex_state = 64},
  [858] = {.lex_state = 64},
  [859] = {.lex_state = 64},
  [860] = {.lex_state = 64},
  [861] = {.lex_state = 64},
  [862] = {.lex_state = 64},
  [863] = {.lex_state = 64},
  [864] = {.lex_state = 64},
  [865] = {.lex_state = 64},
  [866] = {.lex_state = 64},
  [867] = {.lex_state = 64},
  [868] = {.lex_state = 64},
  [869] = {.lex_state = 64},
  [870] = {.lex_state = 64},
  [871] = {.lex_state = 64},
  [872] = {.lex_state = 64},
  [873] = {.lex_state = 64},
  [874] = {.lex_state = 64},
  [875] = {.lex_state = 64},
  [876] = {.lex_state = 64},
  [877] = {.lex_state = 64},
  [878] = {.lex_state = 64},
  [879] = {.lex_state = 64},
  [880] = {.lex_state = 64},
  [881] = {.lex_state = 64},
  [882] = {.lex_state = 64},
  [883] = {.lex_state = 64},
  [884] = {.lex_state = 64},
  [885] = {.lex_state = 64},
  [886] = {.lex_state = 64},
  [887] = {.lex_state = 64},
  [888] = {.lex_state = 64},
  [889] = {.lex_state = 64},
  [890] = {.lex_state = 64},
  [891] = {.lex_state = 64},
  [892] = {.lex_state = 64},
  [893] = {.lex_state = 64},
  [894] = {.lex_state = 64},
  [895] = {.lex_state = 64},
  [896] = {.lex_state = 64},
  [897] = {.lex_state = 64},
  [898] = {.lex_state = 64},
  [899] = {.lex_state = 64},
  [900] = {.lex_state = 64},
  [901] = {.lex_state = 64},
  [902] = {.lex_state = 64},
  [903] = {.lex_state = 64},
  [904] = {.lex_state = 64},
  [905] = {.lex_state = 64},
  [906] = {.lex_state = 64},
  [907] = {.lex_state = 64},
  [908] = {.lex_state = 2, .external_lex_state = 2},
  [909] = {.lex_state = 2, .external_lex_state = 2},
  [910] = {.lex_state = 2, .external_lex_state = 2},
  [911] = {.lex_state = 2, .external_lex_state = 2},
  [912] = {.lex_state = 2, .external_lex_state = 2},
  [913] = {.lex_state = 2, .external_lex_state = 2},
  [914] = {.lex_state = 2, .external_lex_state = 2},
  [915] = {.lex_state = 2, .external_lex_state = 2},
  [916] = {.lex_state = 2, .external_lex_state = 2},
  [917] = {.lex_state = 64},
  [918] = {.lex_state = 64},
  [919] = {.lex_state = 64},
  [920] = {.lex_state = 64},
  [921] = {.lex_state = 64},
  [922] = {.lex_state = 64},
  [923] = {.lex_state = 64},
  [924] = {.lex_state = 2, .external_lex_state = 2},
  [925] = {.lex_state = 2, .external_lex_state = 2},
  [926] = {.lex_state = 2, .external_lex_state = 2},
  [927] = {.lex_state = 2, .external_lex_state = 2},
  [928] = {.lex_state = 2, .external_lex_state = 2},
  [929] = {.lex_state = 2, .external_lex_state = 2},
  [930] = {.lex_state = 2, .external_lex_state = 2},
  [931] = {.lex_state = 2, .external_lex_state = 2},
  [932] = {.lex_state = 2, .external_lex_state = 2},
  [933] = {.lex_state = 2, .external_lex_state = 2},
  [934] = {.lex_state = 2, .external_lex_state = 2},
  [935] = {.lex_state = 2, .external_lex_state = 2},
  [936] = {.lex_state = 2, .external_lex_state = 2},
  [937] = {.lex_state = 2, .external_lex_state = 2},
  [938] = {.lex_state = 2, .external_lex_state = 2},
  [939] = {.lex_state = 2, .external_lex_state = 2},
  [940] = {.lex_state = 2, .external_lex_state = 2},
  [941] = {.lex_state = 2, .external_lex_state = 2},
  [942] = {.lex_state = 2, .external_lex_state = 2},
  [943] = {.lex_state = 2, .external_lex_state = 2},
  [944] = {.lex_state = 2, .external_lex_state = 2},
  [945] = {.lex_state = 11},
  [946] = {.lex_state = 11},
  [947] = {.lex_state = 11},
  [948] = {.lex_state = 11},
  [949] = {.lex_state = 11},
  [950] = {.lex_state = 11},
  [951] = {.lex_state = 11},
  [952] = {.lex_state = 11},
  [953] = {.lex_state = 11},
  [954] = {.lex_state = 11},
  [955] = {.lex_state = 11},
  [956] = {.lex_state = 3, .external_lex_state = 3},
  [957] = {.lex_state = 3, .external_lex_state = 2},
  [958] = {.lex_state = 3, .external_lex_state = 3},
  [959] = {.lex_state = 3, .external_lex_state = 3},
  [960] = {.lex_state = 3, .external_lex_state = 2},
  [961] = {.lex_state = 2, .external_lex_state = 2},
  [962] = {.lex_state = 2, .external_lex_state = 2},
  [963] = {.lex_state = 2, .external_lex_state = 2},
  [964] = {.lex_state = 2, .external_lex_state = 2},
  [965] = {.lex_state = 2, .external_lex_state = 2},
  [966] = {.lex_state = 3, .external_lex_state = 4},
  [967] = {.lex_state = 2, .external_lex_state = 2},
  [968] = {.lex_state = 2, .external_lex_state = 3},
  [969] = {.lex_state = 3, .external_lex_state = 4},
  [970] = {.lex_state = 3, .external_lex_state = 4},
  [971] = {.lex_state = 2, .external_lex_state = 2},
  [972] = {.lex_state = 2, .external_lex_state = 2},
  [973] = {.lex_state = 2, .external_lex_state = 2},
  [974] = {.lex_state = 3, .external_lex_state = 3},
  [975] = {.lex_state = 2, .external_lex_state = 3},
  [976] = {.lex_state = 3, .external_lex_state = 4},
  [977] = {.lex_state = 3, .external_lex_state = 4},
  [978] = {.lex_state = 2, .external_lex_state = 3},
  [979] = {.lex_state = 3, .external_lex_state = 3},
  [980] = {.lex_state = 2, .external_lex_state = 2},
  [981] = {.lex_state = 2, .external_lex_state = 3},
  [982] = {.lex_state = 2, .external_lex_state = 3},
  [983] = {.lex_state = 2, .external_lex_state = 2},
  [984] = {.lex_state = 2, .external_lex_state = 2},
  [985] = {.lex_state = 3, .external_lex_state = 3},
  [986] = {.lex_state = 2, .external_lex_state = 2},
  [987] = {.lex_state = 2, .external_lex_state = 2},
  [988] = {.lex_state = 2, .external_lex_state = 2},
  [989] = {.lex_state = 3, .external_lex_state = 3},
  [990] = {.lex_state = 2, .external_lex_state = 2},
  [991] = {.lex_state = 3, .external_lex_state = 3},
  [992] = {.lex_state = 2, .external_lex_state = 2},
  [993] = {.lex_state = 3, .external_lex_state = 3},
  [994] = {.lex_state = 2, .external_lex_state = 2},
  [995] = {.lex_state = 2, .external_lex_state = 3},
  [996] = {.lex_state = 2, .external_lex_state = 2},
  [997] = {.lex_state = 3, .external_lex_state = 3},
  [998] = {.lex_state = 2, .external_lex_state = 2},
  [999] = {.lex_state = 2, .external_lex_state = 3},
  [1000] = {.lex_state = 2, .external_lex_state = 3},
  [1001] = {.lex_state = 2, .external_lex_state = 3},
  [1002] = {.lex_state = 11},
  [1003] = {.lex_state = 64, .external_lex_state = 5},
  [1004] = {.lex_state = 2, .external_lex_state = 3},
  [1005] = {.lex_state = 64, .external_lex_state = 5},
  [1006] = {.lex_state = 2, .external_lex_state = 3},
  [1007] = {.lex_state = 64},
  [1008] = {.lex_state = 3, .external_lex_state = 3},
  [1009] = {.lex_state = 2, .external_lex_state = 3},
  [1010] = {.lex_state = 2, .external_lex_state = 3},
  [1011] = {.lex_state = 2, .external_lex_state = 3},
  [1012] = {.lex_state = 2, .external_lex_state = 2},
  [1013] = {.lex_state = 2, .external_lex_state = 3},
  [1014] = {.lex_state = 2, .external_lex_state = 3},
  [1015] = {.lex_state = 2, .external_lex_state = 2},
  [1016] = {.lex_state = 2, .external_lex_state = 3},
  [1017] = {.lex_state = 2, .external_lex_state = 3},
  [1018] = {.lex_state = 64},
  [1019] = {.lex_state = 2, .external_lex_state = 3},
  [1020] = {.lex_state = 64, .external_lex_state = 5},
  [1021] = {.lex_state = 2, .external_lex_state = 3},
  [1022] = {.lex_state = 64, .external_lex_state = 5},
  [1023] = {.lex_state = 2, .external_lex_state = 2},
  [1024] = {.lex_state = 2, .external_lex_state = 2},
  [1025] = {.lex_state = 64, .external_lex_state = 5},
  [1026] = {.lex_state = 2, .external_lex_state = 3},
  [1027] = {.lex_state = 2, .external_lex_state = 3},
  [1028] = {.lex_state = 64, .external_lex_state = 5},
  [1029] = {.lex_state = 64},
  [1030] = {.lex_state = 2, .external_lex_state = 3},
  [1031] = {.lex_state = 64, .external_lex_state = 5},
  [1032] = {.lex_state = 64, .external_lex_state = 5},
  [1033] = {.lex_state = 3, .external_lex_state = 3},
  [1034] = {.lex_state = 2, .external_lex_state = 3},
  [1035] = {.lex_state = 64},
  [1036] = {.lex_state = 2, .external_lex_state = 3},
  [1037] = {.lex_state = 2, .external_lex_state = 3},
  [1038] = {.lex_state = 2, .external_lex_state = 3},
  [1039] = {.lex_state = 2, .external_lex_state = 3},
  [1040] = {.lex_state = 64},
  [1041] = {.lex_state = 2, .external_lex_state = 3},
  [1042] = {.lex_state = 2, .external_lex_state = 3},
  [1043] = {.lex_state = 64, .external_lex_state = 5},
  [1044] = {.lex_state = 64},
  [1045] = {.lex_state = 64},
  [1046] = {.lex_state = 64, .external_lex_state = 5},
  [1047] = {.lex_state = 64, .external_lex_state = 5},
  [1048] = {.lex_state = 64, .external_lex_state = 5},
  [1049] = {.lex_state = 64, .external_lex_state = 5},
  [1050] = {.lex_state = 64},
  [1051] = {.lex_state = 64, .external_lex_state = 5},
  [1052] = {.lex_state = 64, .external_lex_state = 5},
  [1053] = {.lex_state = 64, .external_lex_state = 5},
  [1054] = {.lex_state = 64, .external_lex_state = 5},
  [1055] = {.lex_state = 64, .external_lex_state = 5},
  [1056] = {.lex_state = 64},
  [1057] = {.lex_state = 64, .external_lex_state = 5},
  [1058] = {.lex_state = 64},
  [1059] = {.lex_state = 64, .external_lex_state = 5},
  [1060] = {.lex_state = 64},
  [1061] = {.lex_state = 64},
  [1062] = {.lex_state = 64},
  [1063] = {.lex_state = 64},
  [1064] = {.lex_state = 64},
  [1065] = {.lex_state = 64},
  [1066] = {.lex_state = 64},
  [1067] = {.lex_state = 64},
  [1068] = {.lex_state = 64},
  [1069] = {.lex_state = 64},
  [1070] = {.lex_state = 64},
  [1071] = {.lex_state = 64},
  [1072] = {.lex_state = 64},
  [1073] = {.lex_state = 64},
  [1074] = {.lex_state = 64},
  [1075] = {.lex_state = 64},
  [1076] = {.lex_state = 64},
  [1077] = {.lex_state = 64},
  [1078] = {.lex_state = 64},
  [1079] = {.lex_state = 64},
  [1080] = {.lex_state = 64},
  [1081] = {.lex_state = 64},
  [1082] = {.lex_state = 64},
  [1083] = {.lex_state = 64},
  [1084] = {.lex_state = 64},
  [1085] = {.lex_state = 64},
  [1086] = {.lex_state = 64},
  [1087] = {.lex_state = 64},
  [1088] = {.lex_state = 64},
  [1089] = {.lex_state = 64},
  [1090] = {.lex_state = 64},
  [1091] = {.lex_state = 64},
  [1092] = {.lex_state = 64},
  [1093] = {.lex_state = 64},
  [1094] = {.lex_state = 64},
  [1095] = {.lex_state = 64},
  [1096] = {.lex_state = 64},
  [1097] = {.lex_state = 64},
  [1098] = {.lex_state = 64},
  [1099] = {.lex_state = 64},
  [1100] = {.lex_state = 64},
  [1101] = {.lex_state = 64},
  [1102] = {.lex_state = 64},
  [1103] = {.lex_state = 64},
  [1104] = {.lex_state = 64},
  [1105] = {.lex_state = 64},
  [1106] = {.lex_state = 64},
  [1107] = {.lex_state = 64},
  [1108] = {.lex_state = 64},
  [1109] = {.lex_state = 64},
  [1110] = {.lex_state = 64},
  [1111] = {.lex_state = 64},
  [1112] = {.lex_state = 64},
  [1113] = {.lex_state = 64},
  [1114] = {.lex_state = 64},
  [1115] = {.lex_state = 64},
  [1116] = {.lex_state = 64},
  [1117] = {.lex_state = 64},
  [1118] = {.lex_state = 64},
  [1119] = {.lex_state = 64},
  [1120] = {.lex_state = 64},
  [1121] = {.lex_state = 64},
  [1122] = {.lex_state = 64},
  [1123] = {.lex_state = 64},
  [1124] = {.lex_state = 64},
  [1125] = {.lex_state = 64},
  [1126] = {.lex_state = 64},
  [1127] = {.lex_state = 64},
  [1128] = {.lex_state = 64},
  [1129] = {.lex_state = 64},
  [1130] = {.lex_state = 64},
  [1131] = {.lex_state = 11},
  [1132] = {.lex_state = 64},
  [1133] = {.lex_state = 64},
  [1134] = {.lex_state = 64},
  [1135] = {.lex_state = 64},
  [1136] = {.lex_state = 64},
  [1137] = {.lex_state = 64},
  [1138] = {.lex_state = 64},
  [1139] = {.lex_state = 64},
  [1140] = {.lex_state = 64},
  [1141] = {.lex_state = 64},
  [1142] = {.lex_state = 64},
  [1143] = {.lex_state = 64},
  [1144] = {.lex_state = 64},
  [1145] = {.lex_state = 64},
  [1146] = {.lex_state = 64},
  [1147] = {.lex_state = 64},
  [1148] = {.lex_state = 64},
  [1149] = {.lex_state = 64},
  [1150] = {.lex_state = 64},
  [1151] = {.lex_state = 2, .external_lex_state = 2},
  [1152] = {.lex_state = 2, .external_lex_state = 2},
  [1153] = {.lex_state = 2, .external_lex_state = 2},
  [1154] = {.lex_state = 2, .external_lex_state = 2},
  [1155] = {.lex_state = 2, .external_lex_state = 2},
  [1156] = {.lex_state = 2, .external_lex_state = 2},
  [1157] = {.lex_state = 2, .external_lex_state = 2},
  [1158] = {.lex_state = 2, .external_lex_state = 2},
  [1159] = {.lex_state = 2, .external_lex_state = 2},
  [1160] = {.lex_state = 2, .external_lex_state = 2},
  [1161] = {.lex_state = 3, .external_lex_state = 3},
  [1162] = {.lex_state = 2, .external_lex_state = 2},
  [1163] = {.lex_state = 2, .external_lex_state = 2},
  [1164] = {.lex_state = 3, .external_lex_state = 2},
  [1165] = {.lex_state = 2, .external_lex_state = 2},
  [1166] = {.lex_state = 2, .external_lex_state = 2},
  [1167] = {.lex_state = 3, .external_lex_state = 3},
  [1168] = {.lex_state = 3, .external_lex_state = 2},
  [1169] = {.lex_state = 11},
  [1170] = {.lex_state = 3, .external_lex_state = 4},
  [1171] = {.lex_state = 11},
  [1172] = {.lex_state = 11},
  [1173] = {.lex_state = 11},
  [1174] = {.lex_state = 11},
  [1175] = {.lex_state = 2, .external_lex_state = 3},
  [1176] = {.lex_state = 3, .external_lex_state = 4},
  [1177] = {.lex_state = 3, .external_lex_state = 4},
  [1178] = {.lex_state = 2, .external_lex_state = 2},
  [1179] = {.lex_state = 11},
  [1180] = {.lex_state = 11},
  [1181] = {.lex_state = 3, .external_lex_state = 4},
  [1182] = {.lex_state = 2, .external_lex_state = 2},
  [1183] = {.lex_state = 2, .external_lex_state = 3},
  [1184] = {.lex_state = 3, .external_lex_state = 3},
  [1185] = {.lex_state = 11},
  [1186] = {.lex_state = 3, .external_lex_state = 4},
  [1187] = {.lex_state = 2, .external_lex_state = 3},
  [1188] = {.lex_state = 2, .external_lex_state = 2},
  [1189] = {.lex_state = 2, .external_lex_state = 2},
  [1190] = {.lex_state = 64},
  [1191] = {.lex_state = 2, .external_lex_state = 2},
  [1192] = {.lex_state = 2, .external_lex_state = 3},
  [1193] = {.lex_state = 2, .external_lex_state = 2},
  [1194] = {.lex_state = 2, .external_lex_state = 2},
  [1195] = {.lex_state = 64},
  [1196] = {.lex_state = 3, .external_lex_state = 3},
  [1197] = {.lex_state = 2, .external_lex_state = 3},
  [1198] = {.lex_state = 3, .external_lex_state = 3},
  [1199] = {.lex_state = 3, .external_lex_state = 3},
  [1200] = {.lex_state = 2, .external_lex_state = 3},
  [1201] = {.lex_state = 2, .external_lex_state = 2},
  [1202] = {.lex_state = 2, .external_lex_state = 2},
  [1203] = {.lex_state = 2, .external_lex_state = 2},
  [1204] = {.lex_state = 2, .external_lex_state = 2},
  [1205] = {.lex_state = 3, .external_lex_state = 3},
  [1206] = {.lex_state = 2, .external_lex_state = 2},
  [1207] = {.lex_state = 2, .external_lex_state = 2},
  [1208] = {.lex_state = 3, .external_lex_state = 3},
  [1209] = {.lex_state = 64},
  [1210] = {.lex_state = 3, .external_lex_state = 3},
  [1211] = {.lex_state = 13},
  [1212] = {.lex_state = 2, .external_lex_state = 3},
  [1213] = {.lex_state = 13},
  [1214] = {.lex_state = 3, .external_lex_state = 3},
  [1215] = {.lex_state = 13},
  [1216] = {.lex_state = 3, .external_lex_state = 3},
  [1217] = {.lex_state = 3, .external_lex_state = 3},
  [1218] = {.lex_state = 2, .external_lex_state = 3},
  [1219] = {.lex_state = 13},
  [1220] = {.lex_state = 13},
  [1221] = {.lex_state = 3, .external_lex_state = 3},
  [1222] = {.lex_state = 13},
  [1223] = {.lex_state = 2, .external_lex_state = 2},
  [1224] = {.lex_state = 13},
  [1225] = {.lex_state = 2, .external_lex_state = 3},
  [1226] = {.lex_state = 13},
  [1227] = {.lex_state = 2, .external_lex_state = 3},
  [1228] = {.lex_state = 13},
  [1229] = {.lex_state = 3, .external_lex_state = 3},
  [1230] = {.lex_state = 13},
  [1231] = {.lex_state = 13},
  [1232] = {.lex_state = 2, .external_lex_state = 3},
  [1233] = {.lex_state = 13},
  [1234] = {.lex_state = 13},
  [1235] = {.lex_state = 13},
  [1236] = {.lex_state = 13},
  [1237] = {.lex_state = 3, .external_lex_state = 3},
  [1238] = {.lex_state = 2, .external_lex_state = 2},
  [1239] = {.lex_state = 3, .external_lex_state = 3},
  [1240] = {.lex_state = 13},
  [1241] = {.lex_state = 2, .external_lex_state = 3},
  [1242] = {.lex_state = 2, .external_lex_state = 3},
  [1243] = {.lex_state = 13},
  [1244] = {.lex_state = 13},
  [1245] = {.lex_state = 13},
  [1246] = {.lex_state = 13},
  [1247] = {.lex_state = 2, .external_lex_state = 3},
  [1248] = {.lex_state = 2, .external_lex_state = 3},
  [1249] = {.lex_state = 2, .external_lex_state = 2},
  [1250] = {.lex_state = 2, .external_lex_state = 3},
  [1251] = {.lex_state = 2, .external_lex_state = 2},
  [1252] = {.lex_state = 2, .external_lex_state = 3},
  [1253] = {.lex_state = 2, .external_lex_state = 3},
  [1254] = {.lex_state = 2, .external_lex_state = 2},
  [1255] = {.lex_state = 2, .external_lex_state = 3},
  [1256] = {.lex_state = 2, .external_lex_state = 2},
  [1257] = {.lex_state = 11},
  [1258] = {.lex_state = 3, .external_lex_state = 3},
  [1259] = {.lex_state = 3, .external_lex_state = 2},
  [1260] = {.lex_state = 3, .external_lex_state = 2},
  [1261] = {.lex_state = 2, .external_lex_state = 2},
  [1262] = {.lex_state = 3, .external_lex_state = 3},
  [1263] = {.lex_state = 2, .external_lex_state = 3},
  [1264] = {.lex_state = 2, .external_lex_state = 3},
  [1265] = {.lex_state = 2, .external_lex_state = 2},
  [1266] = {.lex_state = 2, .external_lex_state = 3},
  [1267] = {.lex_state = 2, .external_lex_state = 2},
  [1268] = {.lex_state = 2, .external_lex_state = 3},
  [1269] = {.lex_state = 2, .external_lex_state = 3},
  [1270] = {.lex_state = 2, .external_lex_state = 2},
  [1271] = {.lex_state = 3, .external_lex_state = 2},
  [1272] = {.lex_state = 3, .external_lex_state = 3},
  [1273] = {.lex_state = 3, .external_lex_state = 3},
  [1274] = {.lex_state = 2, .external_lex_state = 2},
  [1275] = {.lex_state = 3, .external_lex_state = 2},
  [1276] = {.lex_state = 2, .external_lex_state = 2},
  [1277] = {.lex_state = 3, .external_lex_state = 4},
  [1278] = {.lex_state = 11},
  [1279] = {.lex_state = 2, .external_lex_state = 2},
  [1280] = {.lex_state = 3, .external_lex_state = 2},
  [1281] = {.lex_state = 11},
  [1282] = {.lex_state = 3, .external_lex_state = 3},
  [1283] = {.lex_state = 2, .external_lex_state = 2},
  [1284] = {.lex_state = 3, .external_lex_state = 3},
  [1285] = {.lex_state = 2, .external_lex_state = 2},
  [1286] = {.lex_state = 2, .external_lex_state = 2},
  [1287] = {.lex_state = 3, .external_lex_state = 2},
  [1288] = {.lex_state = 3, .external_lex_state = 3},
  [1289] = {.lex_state = 11},
  [1290] = {.lex_state = 3, .external_lex_state = 3},
  [1291] = {.lex_state = 3, .external_lex_state = 3},
  [1292] = {.lex_state = 3, .external_lex_state = 2},
  [1293] = {.lex_state = 2, .external_lex_state = 3},
  [1294] = {.lex_state = 2, .external_lex_state = 3},
  [1295] = {.lex_state = 3, .external_lex_state = 4},
  [1296] = {.lex_state = 2, .external_lex_state = 2},
  [1297] = {.lex_state = 2, .external_lex_state = 2},
  [1298] = {.lex_state = 2, .external_lex_state = 2},
  [1299] = {.lex_state = 3, .external_lex_state = 2},
  [1300] = {.lex_state = 3, .external_lex_state = 4},
  [1301] = {.lex_state = 3, .external_lex_state = 2},
  [1302] = {.lex_state = 3, .external_lex_state = 2},
  [1303] = {.lex_state = 2, .external_lex_state = 2},
  [1304] = {.lex_state = 3, .external_lex_state = 4},
  [1305] = {.lex_state = 3, .external_lex_state = 2},
  [1306] = {.lex_state = 2, .external_lex_state = 2},
  [1307] = {.lex_state = 3, .external_lex_state = 2},
  [1308] = {.lex_state = 2, .external_lex_state = 3},
  [1309] = {.lex_state = 2, .external_lex_state = 2},
  [1310] = {.lex_state = 2, .external_lex_state = 3},
  [1311] = {.lex_state = 2, .external_lex_state = 2},
  [1312] = {.lex_state = 2, .external_lex_state = 3},
  [1313] = {.lex_state = 3, .external_lex_state = 2},
  [1314] = {.lex_state = 3, .external_lex_state = 2},
  [1315] = {.lex_state = 2, .external_lex_state = 2},
  [1316] = {.lex_state = 2, .external_lex_state = 2},
  [1317] = {.lex_state = 2, .external_lex_state = 2},
  [1318] = {.lex_state = 3, .external_lex_state = 2},
  [1319] = {.lex_state = 3, .external_lex_state = 4},
  [1320] = {.lex_state = 2, .external_lex_state = 3},
  [1321] = {.lex_state = 2, .external_lex_state = 3},
  [1322] = {.lex_state = 2, .external_lex_state = 2},
  [1323] = {.lex_state = 2, .external_lex_state = 3},
  [1324] = {.lex_state = 3, .external_lex_state = 3},
  [1325] = {.lex_state = 2, .external_lex_state = 2},
  [1326] = {.lex_state = 2, .external_lex_state = 3},
  [1327] = {.lex_state = 11},
  [1328] = {.lex_state = 11},
  [1329] = {.lex_state = 3, .external_lex_state = 4},
  [1330] = {.lex_state = 11},
  [1331] = {.lex_state = 11},
  [1332] = {.lex_state = 3, .external_lex_state = 2},
  [1333] = {.lex_state = 3, .external_lex_state = 4},
  [1334] = {.lex_state = 3, .external_lex_state = 3},
  [1335] = {.lex_state = 11},
  [1336] = {.lex_state = 11},
  [1337] = {.lex_state = 3, .external_lex_state = 2},
  [1338] = {.lex_state = 11},
  [1339] = {.lex_state = 2, .external_lex_state = 2},
  [1340] = {.lex_state = 3, .external_lex_state = 4},
  [1341] = {.lex_state = 11},
  [1342] = {.lex_state = 2, .external_lex_state = 3},
  [1343] = {.lex_state = 2, .external_lex_state = 2},
  [1344] = {.lex_state = 11},
  [1345] = {.lex_state = 11},
  [1346] = {.lex_state = 3, .external_lex_state = 4},
  [1347] = {.lex_state = 11},
  [1348] = {.lex_state = 11},
  [1349] = {.lex_state = 3, .external_lex_state = 3},
  [1350] = {.lex_state = 11},
  [1351] = {.lex_state = 3, .external_lex_state = 4},
  [1352] = {.lex_state = 11},
  [1353] = {.lex_state = 11},
  [1354] = {.lex_state = 3, .external_lex_state = 4},
  [1355] = {.lex_state = 2, .external_lex_state = 3},
  [1356] = {.lex_state = 3, .external_lex_state = 4},
  [1357] = {.lex_state = 3, .external_lex_state = 3},
  [1358] = {.lex_state = 3, .external_lex_state = 4},
  [1359] = {.lex_state = 11},
  [1360] = {.lex_state = 11},
  [1361] = {.lex_state = 2, .external_lex_state = 2},
  [1362] = {.lex_state = 3, .external_lex_state = 4},
  [1363] = {.lex_state = 11},
  [1364] = {.lex_state = 3, .external_lex_state = 4},
  [1365] = {.lex_state = 3, .external_lex_state = 3},
  [1366] = {.lex_state = 11},
  [1367] = {.lex_state = 2, .external_lex_state = 2},
  [1368] = {.lex_state = 2, .external_lex_state = 2},
  [1369] = {.lex_state = 2, .external_lex_state = 3},
  [1370] = {.lex_state = 2, .external_lex_state = 3},
  [1371] = {.lex_state = 11},
  [1372] = {.lex_state = 11},
  [1373] = {.lex_state = 11},
  [1374] = {.lex_state = 11},
  [1375] = {.lex_state = 2, .external_lex_state = 3},
  [1376] = {.lex_state = 2, .external_lex_state = 2},
  [1377] = {.lex_state = 11},
  [1378] = {.lex_state = 11},
  [1379] = {.lex_state = 2, .external_lex_state = 2},
  [1380] = {.lex_state = 11},
  [1381] = {.lex_state = 11},
  [1382] = {.lex_state = 3, .external_lex_state = 4},
  [1383] = {.lex_state = 11},
  [1384] = {.lex_state = 11},
  [1385] = {.lex_state = 2, .external_lex_state = 3},
  [1386] = {.lex_state = 11},
  [1387] = {.lex_state = 11},
  [1388] = {.lex_state = 11},
  [1389] = {.lex_state = 11},
  [1390] = {.lex_state = 11},
  [1391] = {.lex_state = 11},
  [1392] = {.lex_state = 2, .external_lex_state = 2},
  [1393] = {.lex_state = 11},
  [1394] = {.lex_state = 11},
  [1395] = {.lex_state = 2, .external_lex_state = 3},
  [1396] = {.lex_state = 11},
  [1397] = {.lex_state = 11},
  [1398] = {.lex_state = 11},
  [1399] = {.lex_state = 11},
  [1400] = {.lex_state = 2, .external_lex_state = 2},
  [1401] = {.lex_state = 3, .external_lex_state = 3},
  [1402] = {.lex_state = 11},
  [1403] = {.lex_state = 13},
  [1404] = {.lex_state = 11},
  [1405] = {.lex_state = 3, .external_lex_state = 4},
  [1406] = {.lex_state = 11},
  [1407] = {.lex_state = 11},
  [1408] = {.lex_state = 2, .external_lex_state = 2},
  [1409] = {.lex_state = 11},
  [1410] = {.lex_state = 11},
  [1411] = {.lex_state = 3, .external_lex_state = 3},
  [1412] = {.lex_state = 2, .external_lex_state = 2},
  [1413] = {.lex_state = 11},
  [1414] = {.lex_state = 11},
  [1415] = {.lex_state = 3, .external_lex_state = 4},
  [1416] = {.lex_state = 11},
  [1417] = {.lex_state = 11},
  [1418] = {.lex_state = 11},
  [1419] = {.lex_state = 11},
  [1420] = {.lex_state = 2, .external_lex_state = 2},
  [1421] = {.lex_state = 2, .external_lex_state = 2},
  [1422] = {.lex_state = 2, .external_lex_state = 3},
  [1423] = {.lex_state = 11},
  [1424] = {.lex_state = 3, .external_lex_state = 4},
  [1425] = {.lex_state = 11},
  [1426] = {.lex_state = 11},
  [1427] = {.lex_state = 3, .external_lex_state = 3},
  [1428] = {.lex_state = 3, .external_lex_state = 3},
  [1429] = {.lex_state = 11},
  [1430] = {.lex_state = 3, .external_lex_state = 3},
  [1431] = {.lex_state = 2, .external_lex_state = 3},
  [1432] = {.lex_state = 11},
  [1433] = {.lex_state = 3, .external_lex_state = 4},
  [1434] = {.lex_state = 11},
  [1435] = {.lex_state = 11},
  [1436] = {.lex_state = 11},
  [1437] = {.lex_state = 11},
  [1438] = {.lex_state = 11},
  [1439] = {.lex_state = 3, .external_lex_state = 4},
  [1440] = {.lex_state = 11},
  [1441] = {.lex_state = 11},
  [1442] = {.lex_state = 11},
  [1443] = {.lex_state = 11},
  [1444] = {.lex_state = 2, .external_lex_state = 2},
  [1445] = {.lex_state = 11},
  [1446] = {.lex_state = 11},
  [1447] = {.lex_state = 11},
  [1448] = {.lex_state = 11},
  [1449] = {.lex_state = 3, .external_lex_state = 3},
  [1450] = {.lex_state = 11},
  [1451] = {.lex_state = 11},
  [1452] = {.lex_state = 3, .external_lex_state = 4},
  [1453] = {.lex_state = 3, .external_lex_state = 4},
  [1454] = {.lex_state = 2, .external_lex_state = 3},
  [1455] = {.lex_state = 11},
  [1456] = {.lex_state = 11},
  [1457] = {.lex_state = 13},
  [1458] = {.lex_state = 3, .external_lex_state = 3},
  [1459] = {.lex_state = 2, .external_lex_state = 3},
  [1460] = {.lex_state = 11},
  [1461] = {.lex_state = 11},
  [1462] = {.lex_state = 3, .external_lex_state = 4},
  [1463] = {.lex_state = 11},
  [1464] = {.lex_state = 11},
  [1465] = {.lex_state = 11},
  [1466] = {.lex_state = 11},
  [1467] = {.lex_state = 2, .external_lex_state = 3},
  [1468] = {.lex_state = 11},
  [1469] = {.lex_state = 11},
  [1470] = {.lex_state = 2, .external_lex_state = 3},
  [1471] = {.lex_state = 11},
  [1472] = {.lex_state = 11},
  [1473] = {.lex_state = 11},
  [1474] = {.lex_state = 11},
  [1475] = {.lex_state = 11},
  [1476] = {.lex_state = 13},
  [1477] = {.lex_state = 3, .external_lex_state = 4},
  [1478] = {.lex_state = 11},
  [1479] = {.lex_state = 11},
  [1480] = {.lex_state = 13},
  [1481] = {.lex_state = 2, .external_lex_state = 3},
  [1482] = {.lex_state = 11},
  [1483] = {.lex_state = 3, .external_lex_state = 3},
  [1484] = {.lex_state = 3, .external_lex_state = 3},
  [1485] = {.lex_state = 3, .external_lex_state = 4},
  [1486] = {.lex_state = 2, .external_lex_state = 2},
  [1487] = {.lex_state = 13},
  [1488] = {.lex_state = 13},
  [1489] = {.lex_state = 2, .external_lex_state = 3},
  [1490] = {.lex_state = 2, .external_lex_state = 2},
  [1491] = {.lex_state = 11},
  [1492] = {.lex_state = 3, .external_lex_state = 4},
  [1493] = {.lex_state = 11},
  [1494] = {.lex_state = 11},
  [1495] = {.lex_state = 11},
  [1496] = {.lex_state = 11},
  [1497] = {.lex_state = 11},
  [1498] = {.lex_state = 11},
  [1499] = {.lex_state = 11},
  [1500] = {.lex_state = 11},
  [1501] = {.lex_state = 3, .external_lex_state = 3},
  [1502] = {.lex_state = 11},
  [1503] = {.lex_state = 11},
  [1504] = {.lex_state = 11},
  [1505] = {.lex_state = 11},
  [1506] = {.lex_state = 11},
  [1507] = {.lex_state = 11},
  [1508] = {.lex_state = 11},
  [1509] = {.lex_state = 11},
  [1510] = {.lex_state = 11},
  [1511] = {.lex_state = 11},
  [1512] = {.lex_state = 11},
  [1513] = {.lex_state = 11},
  [1514] = {.lex_state = 11},
  [1515] = {.lex_state = 11},
  [1516] = {.lex_state = 2, .external_lex_state = 3},
  [1517] = {.lex_state = 11},
  [1518] = {.lex_state = 11},
  [1519] = {.lex_state = 11},
  [1520] = {.lex_state = 11},
  [1521] = {.lex_state = 11},
  [1522] = {.lex_state = 11},
  [1523] = {.lex_state = 11},
  [1524] = {.lex_state = 11},
  [1525] = {.lex_state = 2, .external_lex_state = 3},
  [1526] = {.lex_state = 2, .external_lex_state = 3},
  [1527] = {.lex_state = 11},
  [1528] = {.lex_state = 11},
  [1529] = {.lex_state = 11},
  [1530] = {.lex_state = 11},
  [1531] = {.lex_state = 11},
  [1532] = {.lex_state = 11},
  [1533] = {.lex_state = 2, .external_lex_state = 2},
  [1534] = {.lex_state = 11},
  [1535] = {.lex_state = 11},
  [1536] = {.lex_state = 3, .external_lex_state = 3},
  [1537] = {.lex_state = 11},
  [1538] = {.lex_state = 11},
  [1539] = {.lex_state = 2, .external_lex_state = 2},
  [1540] = {.lex_state = 11},
  [1541] = {.lex_state = 11},
  [1542] = {.lex_state = 11},
  [1543] = {.lex_state = 3, .external_lex_state = 3},
  [1544] = {.lex_state = 11},
  [1545] = {.lex_state = 11},
  [1546] = {.lex_state = 11},
  [1547] = {.lex_state = 2, .external_lex_state = 2},
  [1548] = {.lex_state = 11},
  [1549] = {.lex_state = 11},
  [1550] = {.lex_state = 11},
  [1551] = {.lex_state = 11},
  [1552] = {.lex_state = 11},
  [1553] = {.lex_state = 11},
  [1554] = {.lex_state = 11},
  [1555] = {.lex_state = 11},
  [1556] = {.lex_state = 11},
  [1557] = {.lex_state = 11},
  [1558] = {.lex_state = 11},
  [1559] = {.lex_state = 11},
  [1560] = {.lex_state = 2, .external_lex_state = 3},
  [1561] = {.lex_state = 11},
  [1562] = {.lex_state = 11},
  [1563] = {.lex_state = 11},
  [1564] = {.lex_state = 11},
  [1565] = {.lex_state = 11},
  [1566] = {.lex_state = 11},
  [1567] = {.lex_state = 11},
  [1568] = {.lex_state = 11},
  [1569] = {.lex_state = 11},
  [1570] = {.lex_state = 11},
  [1571] = {.lex_state = 2, .external_lex_state = 2},
  [1572] = {.lex_state = 2, .external_lex_state = 2},
  [1573] = {.lex_state = 11},
  [1574] = {.lex_state = 11},
  [1575] = {.lex_state = 11},
  [1576] = {.lex_state = 11},
  [1577] = {.lex_state = 11},
  [1578] = {.lex_state = 2, .external_lex_state = 2},
  [1579] = {.lex_state = 11},
  [1580] = {.lex_state = 11},
  [1581] = {.lex_state = 11},
  [1582] = {.lex_state = 11},
  [1583] = {.lex_state = 11},
  [1584] = {.lex_state = 11},
  [1585] = {.lex_state = 11},
  [1586] = {.lex_state = 11},
  [1587] = {.lex_state = 11},
  [1588] = {.lex_state = 11},
  [1589] = {.lex_state = 11},
  [1590] = {.lex_state = 3, .external_lex_state = 3},
  [1591] = {.lex_state = 11},
  [1592] = {.lex_state = 11},
  [1593] = {.lex_state = 11},
  [1594] = {.lex_state = 2, .external_lex_state = 2},
  [1595] = {.lex_state = 11},
  [1596] = {.lex_state = 11},
  [1597] = {.lex_state = 11},
  [1598] = {.lex_state = 11},
  [1599] = {.lex_state = 11},
  [1600] = {.lex_state = 11},
  [1601] = {.lex_state = 11},
  [1602] = {.lex_state = 11},
  [1603] = {.lex_state = 11},
  [1604] = {.lex_state = 2, .external_lex_state = 3},
  [1605] = {.lex_state = 11},
  [1606] = {.lex_state = 11},
  [1607] = {.lex_state = 11},
  [1608] = {.lex_state = 11},
  [1609] = {.lex_state = 11},
  [1610] = {.lex_state = 2, .external_lex_state = 3},
  [1611] = {.lex_state = 11},
  [1612] = {.lex_state = 11},
  [1613] = {.lex_state = 11},
  [1614] = {.lex_state = 11},
  [1615] = {.lex_state = 2, .external_lex_state = 2},
  [1616] = {.lex_state = 11},
  [1617] = {.lex_state = 11},
  [1618] = {.lex_state = 11},
  [1619] = {.lex_state = 11},
  [1620] = {.lex_state = 11},
  [1621] = {.lex_state = 11},
  [1622] = {.lex_state = 11},
  [1623] = {.lex_state = 11},
  [1624] = {.lex_state = 2, .external_lex_state = 2},
  [1625] = {.lex_state = 11},
  [1626] = {.lex_state = 11},
  [1627] = {.lex_state = 11},
  [1628] = {.lex_state = 11},
  [1629] = {.lex_state = 11},
  [1630] = {.lex_state = 11},
  [1631] = {.lex_state = 11},
  [1632] = {.lex_state = 11},
  [1633] = {.lex_state = 11},
  [1634] = {.lex_state = 11},
  [1635] = {.lex_state = 11},
  [1636] = {.lex_state = 11},
  [1637] = {.lex_state = 11},
  [1638] = {.lex_state = 11},
  [1639] = {.lex_state = 11},
  [1640] = {.lex_state = 11},
  [1641] = {.lex_state = 11},
  [1642] = {.lex_state = 11},
  [1643] = {.lex_state = 11},
  [1644] = {.lex_state = 11},
  [1645] = {.lex_state = 11},
  [1646] = {.lex_state = 11},
  [1647] = {.lex_state = 11},
  [1648] = {.lex_state = 2, .external_lex_state = 2},
  [1649] = {.lex_state = 2, .external_lex_state = 2},
  [1650] = {.lex_state = 11},
  [1651] = {.lex_state = 2, .external_lex_state = 2},
  [1652] = {.lex_state = 11},
  [1653] = {.lex_state = 2, .external_lex_state = 2},
  [1654] = {.lex_state = 2, .external_lex_state = 2},
  [1655] = {.lex_state = 11},
  [1656] = {.lex_state = 11},
  [1657] = {.lex_state = 11},
  [1658] = {.lex_state = 11},
  [1659] = {.lex_state = 11},
  [1660] = {.lex_state = 11},
  [1661] = {.lex_state = 11},
  [1662] = {.lex_state = 11},
  [1663] = {.lex_state = 11},
  [1664] = {.lex_state = 11},
  [1665] = {.lex_state = 11},
  [1666] = {.lex_state = 11},
  [1667] = {.lex_state = 11},
  [1668] = {.lex_state = 11},
  [1669] = {.lex_state = 2, .external_lex_state = 3},
  [1670] = {.lex_state = 11},
  [1671] = {.lex_state = 11},
  [1672] = {.lex_state = 11},
  [1673] = {.lex_state = 11},
  [1674] = {.lex_state = 11},
  [1675] = {.lex_state = 11},
  [1676] = {.lex_state = 11},
  [1677] = {.lex_state = 11},
  [1678] = {.lex_state = 11},
  [1679] = {.lex_state = 11},
  [1680] = {.lex_state = 2, .external_lex_state = 2},
  [1681] = {.lex_state = 11},
  [1682] = {.lex_state = 11},
  [1683] = {.lex_state = 11},
  [1684] = {.lex_state = 11},
  [1685] = {.lex_state = 11},
  [1686] = {.lex_state = 11},
  [1687] = {.lex_state = 11},
  [1688] = {.lex_state = 3, .external_lex_state = 3},
  [1689] = {.lex_state = 11},
  [1690] = {.lex_state = 11},
  [1691] = {.lex_state = 11},
  [1692] = {.lex_state = 11},
  [1693] = {.lex_state = 11},
  [1694] = {.lex_state = 11},
  [1695] = {.lex_state = 11},
  [1696] = {.lex_state = 11},
  [1697] = {.lex_state = 11},
  [1698] = {.lex_state = 11},
  [1699] = {.lex_state = 11},
  [1700] = {.lex_state = 11},
  [1701] = {.lex_state = 11},
  [1702] = {.lex_state = 11},
  [1703] = {.lex_state = 2, .external_lex_state = 2},
  [1704] = {.lex_state = 11},
  [1705] = {.lex_state = 11},
  [1706] = {.lex_state = 11},
  [1707] = {.lex_state = 11},
  [1708] = {.lex_state = 11},
  [1709] = {.lex_state = 11},
  [1710] = {.lex_state = 2, .external_lex_state = 2},
  [1711] = {.lex_state = 11},
  [1712] = {.lex_state = 11},
  [1713] = {.lex_state = 2, .external_lex_state = 2},
  [1714] = {.lex_state = 11},
  [1715] = {.lex_state = 11},
  [1716] = {.lex_state = 11},
  [1717] = {.lex_state = 11},
  [1718] = {.lex_state = 11},
  [1719] = {.lex_state = 11},
  [1720] = {.lex_state = 11},
  [1721] = {.lex_state = 11},
  [1722] = {.lex_state = 11},
  [1723] = {.lex_state = 11},
  [1724] = {.lex_state = 11},
  [1725] = {.lex_state = 11},
  [1726] = {.lex_state = 11},
  [1727] = {.lex_state = 11},
  [1728] = {.lex_state = 11},
  [1729] = {.lex_state = 11},
  [1730] = {.lex_state = 11},
  [1731] = {.lex_state = 11},
  [1732] = {.lex_state = 11},
  [1733] = {.lex_state = 11},
  [1734] = {.lex_state = 11},
  [1735] = {.lex_state = 11},
  [1736] = {.lex_state = 11},
  [1737] = {.lex_state = 11},
  [1738] = {.lex_state = 11},
  [1739] = {.lex_state = 11},
  [1740] = {.lex_state = 11},
  [1741] = {.lex_state = 11},
  [1742] = {.lex_state = 2, .external_lex_state = 3},
  [1743] = {.lex_state = 11},
  [1744] = {.lex_state = 2, .external_lex_state = 2},
  [1745] = {.lex_state = 11},
  [1746] = {.lex_state = 11},
  [1747] = {.lex_state = 11},
  [1748] = {.lex_state = 11},
  [1749] = {.lex_state = 11},
  [1750] = {.lex_state = 11},
  [1751] = {.lex_state = 11},
  [1752] = {.lex_state = 11},
  [1753] = {.lex_state = 2, .external_lex_state = 2},
  [1754] = {.lex_state = 11},
  [1755] = {.lex_state = 11},
  [1756] = {.lex_state = 11},
  [1757] = {.lex_state = 11},
  [1758] = {.lex_state = 11},
  [1759] = {.lex_state = 11},
  [1760] = {.lex_state = 11},
  [1761] = {.lex_state = 11},
  [1762] = {.lex_state = 11},
  [1763] = {.lex_state = 11},
  [1764] = {.lex_state = 11},
  [1765] = {.lex_state = 11},
  [1766] = {.lex_state = 11},
  [1767] = {.lex_state = 11},
  [1768] = {.lex_state = 11},
  [1769] = {.lex_state = 11},
  [1770] = {.lex_state = 11},
  [1771] = {.lex_state = 11},
  [1772] = {.lex_state = 11},
  [1773] = {.lex_state = 11},
  [1774] = {.lex_state = 11},
  [1775] = {.lex_state = 11},
  [1776] = {.lex_state = 11},
  [1777] = {.lex_state = 11},
  [1778] = {.lex_state = 11},
  [1779] = {.lex_state = 11},
  [1780] = {.lex_state = 2, .external_lex_state = 3},
  [1781] = {.lex_state = 11},
  [1782] = {.lex_state = 11},
  [1783] = {.lex_state = 11},
  [1784] = {.lex_state = 11},
  [1785] = {.lex_state = 11},
  [1786] = {.lex_state = 11},
  [1787] = {.lex_state = 11},
  [1788] = {.lex_state = 11},
  [1789] = {.lex_state = 2, .external_lex_state = 3},
  [1790] = {.lex_state = 2, .external_lex_state = 3},
  [1791] = {.lex_state = 11},
  [1792] = {.lex_state = 3, .external_lex_state = 3},
  [1793] = {.lex_state = 11},
  [1794] = {.lex_state = 11},
  [1795] = {.lex_state = 2, .external_lex_state = 3},
  [1796] = {.lex_state = 11},
  [1797] = {.lex_state = 3, .external_lex_state = 3},
  [1798] = {.lex_state = 11},
  [1799] = {.lex_state = 11},
  [1800] = {.lex_state = 11},
  [1801] = {.lex_state = 11},
  [1802] = {.lex_state = 11},
  [1803] = {.lex_state = 11},
  [1804] = {.lex_state = 11},
  [1805] = {.lex_state = 2, .external_lex_state = 2},
  [1806] = {.lex_state = 11},
  [1807] = {.lex_state = 2, .external_lex_state = 2},
  [1808] = {.lex_state = 11},
  [1809] = {.lex_state = 3, .external_lex_state = 3},
  [1810] = {.lex_state = 11},
  [1811] = {.lex_state = 11},
  [1812] = {.lex_state = 11},
  [1813] = {.lex_state = 2, .external_lex_state = 2},
  [1814] = {.lex_state = 11},
  [1815] = {.lex_state = 11},
  [1816] = {.lex_state = 11},
  [1817] = {.lex_state = 11},
  [1818] = {.lex_state = 11},
  [1819] = {.lex_state = 11},
  [1820] = {.lex_state = 11},
  [1821] = {.lex_state = 11},
  [1822] = {.lex_state = 11},
  [1823] = {.lex_state = 11},
  [1824] = {.lex_state = 11},
  [1825] = {.lex_state = 2, .external_lex_state = 3},
  [1826] = {.lex_state = 11},
  [1827] = {.lex_state = 11},
  [1828] = {.lex_state = 11},
  [1829] = {.lex_state = 11},
  [1830] = {.lex_state = 11},
  [1831] = {.lex_state = 11},
  [1832] = {.lex_state = 11},
  [1833] = {.lex_state = 11},
  [1834] = {.lex_state = 3, .external_lex_state = 3},
  [1835] = {.lex_state = 11},
  [1836] = {.lex_state = 2, .external_lex_state = 2},
  [1837] = {.lex_state = 11},
  [1838] = {.lex_state = 11},
  [1839] = {.lex_state = 11},
  [1840] = {.lex_state = 11},
  [1841] = {.lex_state = 11},
  [1842] = {.lex_state = 11},
  [1843] = {.lex_state = 3, .external_lex_state = 3},
  [1844] = {.lex_state = 11},
  [1845] = {.lex_state = 11},
  [1846] = {.lex_state = 11},
  [1847] = {.lex_state = 11},
  [1848] = {.lex_state = 2, .external_lex_state = 3},
  [1849] = {.lex_state = 11},
  [1850] = {.lex_state = 11},
  [1851] = {.lex_state = 11},
  [1852] = {.lex_state = 2, .external_lex_state = 3},
  [1853] = {.lex_state = 3, .external_lex_state = 3},
  [1854] = {.lex_state = 11},
  [1855] = {.lex_state = 11},
  [1856] = {.lex_state = 2, .external_lex_state = 3},
  [1857] = {.lex_state = 11},
  [1858] = {.lex_state = 11},
  [1859] = {.lex_state = 11},
  [1860] = {.lex_state = 11},
  [1861] = {.lex_state = 11},
  [1862] = {.lex_state = 11},
  [1863] = {.lex_state = 11},
  [1864] = {.lex_state = 11},
  [1865] = {.lex_state = 11},
  [1866] = {.lex_state = 11},
  [1867] = {.lex_state = 11},
  [1868] = {.lex_state = 2, .external_lex_state = 3},
  [1869] = {.lex_state = 11},
  [1870] = {.lex_state = 11},
  [1871] = {.lex_state = 3, .external_lex_state = 3},
  [1872] = {.lex_state = 11},
  [1873] = {.lex_state = 11},
  [1874] = {.lex_state = 11},
  [1875] = {.lex_state = 11},
  [1876] = {.lex_state = 11},
  [1877] = {.lex_state = 11},
  [1878] = {.lex_state = 11},
  [1879] = {.lex_state = 11},
  [1880] = {.lex_state = 11},
  [1881] = {.lex_state = 11},
  [1882] = {.lex_state = 11},
  [1883] = {.lex_state = 11},
  [1884] = {.lex_state = 11},
  [1885] = {.lex_state = 11},
  [1886] = {.lex_state = 11},
  [1887] = {.lex_state = 11},
  [1888] = {.lex_state = 11},
  [1889] = {.lex_state = 11},
  [1890] = {.lex_state = 2, .external_lex_state = 3},
  [1891] = {.lex_state = 11},
  [1892] = {.lex_state = 3, .external_lex_state = 3},
  [1893] = {.lex_state = 11},
  [1894] = {.lex_state = 11},
  [1895] = {.lex_state = 2, .external_lex_state = 3},
  [1896] = {.lex_state = 2, .external_lex_state = 3},
  [1897] = {.lex_state = 2, .external_lex_state = 3},
  [1898] = {.lex_state = 2, .external_lex_state = 3},
  [1899] = {.lex_state = 2, .external_lex_state = 3},
  [1900] = {.lex_state = 2, .external_lex_state = 2},
  [1901] = {.lex_state = 2, .external_lex_state = 2},
  [1902] = {.lex_state = 3, .external_lex_state = 3},
  [1903] = {.lex_state = 2, .external_lex_state = 3},
  [1904] = {.lex_state = 2, .external_lex_state = 3},
  [1905] = {.lex_state = 2, .external_lex_state = 3},
  [1906] = {.lex_state = 3, .external_lex_state = 3},
  [1907] = {.lex_state = 2, .external_lex_state = 3},
  [1908] = {.lex_state = 2, .external_lex_state = 3},
  [1909] = {.lex_state = 2, .external_lex_state = 3},
  [1910] = {.lex_state = 2, .external_lex_state = 3},
  [1911] = {.lex_state = 2, .external_lex_state = 3},
  [1912] = {.lex_state = 2, .external_lex_state = 3},
  [1913] = {.lex_state = 3, .external_lex_state = 3},
  [1914] = {.lex_state = 3, .external_lex_state = 3},
  [1915] = {.lex_state = 2, .external_lex_state = 3},
  [1916] = {.lex_state = 3, .external_lex_state = 3},
  [1917] = {.lex_state = 2, .external_lex_state = 3},
  [1918] = {.lex_state = 2, .external_lex_state = 3},
  [1919] = {.lex_state = 2, .external_lex_state = 2},
  [1920] = {.lex_state = 2, .external_lex_state = 3},
  [1921] = {.lex_state = 2, .external_lex_state = 3},
  [1922] = {.lex_state = 2, .external_lex_state = 2},
  [1923] = {.lex_state = 2, .external_lex_state = 3},
  [1924] = {.lex_state = 2, .external_lex_state = 3},
  [1925] = {.lex_state = 2, .external_lex_state = 2},
  [1926] = {.lex_state = 2, .external_lex_state = 2},
  [1927] = {.lex_state = 2, .external_lex_state = 2},
  [1928] = {.lex_state = 2, .external_lex_state = 3},
  [1929] = {.lex_state = 2, .external_lex_state = 3},
  [1930] = {.lex_state = 2, .external_lex_state = 3},
  [1931] = {.lex_state = 2, .external_lex_state = 2},
  [1932] = {.lex_state = 2, .external_lex_state = 3},
  [1933] = {.lex_state = 2, .external_lex_state = 3},
  [1934] = {.lex_state = 2, .external_lex_state = 3},
  [1935] = {.lex_state = 2, .external_lex_state = 3},
  [1936] = {.lex_state = 2, .external_lex_state = 3},
  [1937] = {.lex_state = 2, .external_lex_state = 3},
  [1938] = {.lex_state = 2, .external_lex_state = 3},
  [1939] = {.lex_state = 2, .external_lex_state = 3},
  [1940] = {.lex_state = 2, .external_lex_state = 3},
  [1941] = {.lex_state = 2, .external_lex_state = 3},
  [1942] = {.lex_state = 2, .external_lex_state = 3},
  [1943] = {.lex_state = 3, .external_lex_state = 3},
  [1944] = {.lex_state = 2, .external_lex_state = 3},
  [1945] = {.lex_state = 2, .external_lex_state = 3},
  [1946] = {.lex_state = 2, .external_lex_state = 2},
  [1947] = {.lex_state = 2, .external_lex_state = 3},
  [1948] = {.lex_state = 13},
  [1949] = {.lex_state = 2, .external_lex_state = 3},
  [1950] = {.lex_state = 2, .external_lex_state = 2},
  [1951] = {.lex_state = 2, .external_lex_state = 3},
  [1952] = {.lex_state = 2, .external_lex_state = 3},
  [1953] = {.lex_state = 2, .external_lex_state = 3},
  [1954] = {.lex_state = 2, .external_lex_state = 3},
  [1955] = {.lex_state = 2, .external_lex_state = 3},
  [1956] = {.lex_state = 2, .external_lex_state = 3},
  [1957] = {.lex_state = 2, .external_lex_state = 3},
  [1958] = {.lex_state = 2, .external_lex_state = 3},
  [1959] = {.lex_state = 2, .external_lex_state = 3},
  [1960] = {.lex_state = 2, .external_lex_state = 3},
  [1961] = {.lex_state = 2, .external_lex_state = 3},
  [1962] = {.lex_state = 2, .external_lex_state = 3},
  [1963] = {.lex_state = 2, .external_lex_state = 3},
  [1964] = {.lex_state = 2, .external_lex_state = 3},
  [1965] = {.lex_state = 2, .external_lex_state = 3},
  [1966] = {.lex_state = 2, .external_lex_state = 3},
  [1967] = {.lex_state = 2, .external_lex_state = 3},
  [1968] = {.lex_state = 2, .external_lex_state = 3},
  [1969] = {.lex_state = 2, .external_lex_state = 2},
  [1970] = {.lex_state = 2, .external_lex_state = 3},
  [1971] = {.lex_state = 2, .external_lex_state = 3},
  [1972] = {.lex_state = 2, .external_lex_state = 3},
  [1973] = {.lex_state = 2, .external_lex_state = 3},
  [1974] = {.lex_state = 2, .external_lex_state = 3},
  [1975] = {.lex_state = 2, .external_lex_state = 3},
  [1976] = {.lex_state = 13},
  [1977] = {.lex_state = 2, .external_lex_state = 3},
  [1978] = {.lex_state = 2, .external_lex_state = 3},
  [1979] = {.lex_state = 2, .external_lex_state = 3},
  [1980] = {.lex_state = 2, .external_lex_state = 2},
  [1981] = {.lex_state = 2, .external_lex_state = 3},
  [1982] = {.lex_state = 2, .external_lex_state = 3},
  [1983] = {.lex_state = 2, .external_lex_state = 3},
  [1984] = {.lex_state = 2, .external_lex_state = 3},
  [1985] = {.lex_state = 2, .external_lex_state = 3},
  [1986] = {.lex_state = 2, .external_lex_state = 3},
  [1987] = {.lex_state = 2, .external_lex_state = 3},
  [1988] = {.lex_state = 2, .external_lex_state = 3},
  [1989] = {.lex_state = 2, .external_lex_state = 3},
  [1990] = {.lex_state = 2, .external_lex_state = 3},
  [1991] = {.lex_state = 2, .external_lex_state = 3},
  [1992] = {.lex_state = 2, .external_lex_state = 3},
  [1993] = {.lex_state = 2, .external_lex_state = 3},
  [1994] = {.lex_state = 64, .external_lex_state = 5},
  [1995] = {.lex_state = 63, .external_lex_state = 2},
  [1996] = {.lex_state = 64, .external_lex_state = 5},
  [1997] = {.lex_state = 64, .external_lex_state = 5},
  [1998] = {.lex_state = 64, .external_lex_state = 5},
  [1999] = {.lex_state = 64, .external_lex_state = 5},
  [2000] = {.lex_state = 64, .external_lex_state = 5},
  [2001] = {.lex_state = 64, .external_lex_state = 5},
  [2002] = {.lex_state = 64, .external_lex_state = 5},
  [2003] = {.lex_state = 64, .external_lex_state = 5},
  [2004] = {.lex_state = 11},
  [2005] = {.lex_state = 11},
  [2006] = {.lex_state = 11},
  [2007] = {.lex_state = 11},
  [2008] = {.lex_state = 64, .external_lex_state = 5},
  [2009] = {.lex_state = 11},
  [2010] = {.lex_state = 11},
  [2011] = {.lex_state = 11},
  [2012] = {.lex_state = 64, .external_lex_state = 5},
  [2013] = {.lex_state = 63, .external_lex_state = 3},
  [2014] = {.lex_state = 64, .external_lex_state = 5},
  [2015] = {.lex_state = 64, .external_lex_state = 5},
  [2016] = {.lex_state = 11},
  [2017] = {.lex_state = 11},
  [2018] = {.lex_state = 63, .external_lex_state = 2},
  [2019] = {.lex_state = 11},
  [2020] = {.lex_state = 11},
  [2021] = {.lex_state = 11},
  [2022] = {.lex_state = 11},
  [2023] = {.lex_state = 63, .external_lex_state = 2},
  [2024] = {.lex_state = 11},
  [2025] = {.lex_state = 11},
  [2026] = {.lex_state = 11},
  [2027] = {.lex_state = 63, .external_lex_state = 2},
  [2028] = {.lex_state = 11},
  [2029] = {.lex_state = 11},
  [2030] = {.lex_state = 11},
  [2031] = {.lex_state = 11},
  [2032] = {.lex_state = 63, .external_lex_state = 3},
  [2033] = {.lex_state = 63, .external_lex_state = 3},
  [2034] = {.lex_state = 63, .external_lex_state = 3},
  [2035] = {.lex_state = 11},
  [2036] = {.lex_state = 63, .external_lex_state = 3},
  [2037] = {.lex_state = 11},
  [2038] = {.lex_state = 11},
  [2039] = {.lex_state = 63, .external_lex_state = 2},
  [2040] = {.lex_state = 63, .external_lex_state = 2},
  [2041] = {.lex_state = 11},
  [2042] = {.lex_state = 11},
  [2043] = {.lex_state = 63, .external_lex_state = 3},
  [2044] = {.lex_state = 63, .external_lex_state = 3},
  [2045] = {.lex_state = 63, .external_lex_state = 2},
  [2046] = {.lex_state = 63, .external_lex_state = 3},
  [2047] = {.lex_state = 11},
  [2048] = {.lex_state = 63, .external_lex_state = 2},
  [2049] = {.lex_state = 11},
  [2050] = {.lex_state = 11},
  [2051] = {.lex_state = 63, .external_lex_state = 3},
  [2052] = {.lex_state = 63, .external_lex_state = 3},
  [2053] = {.lex_state = 63, .external_lex_state = 2},
  [2054] = {.lex_state = 63, .external_lex_state = 2},
  [2055] = {.lex_state = 63, .external_lex_state = 2},
  [2056] = {.lex_state = 63, .external_lex_state = 2},
  [2057] = {.lex_state = 63, .external_lex_state = 2},
  [2058] = {.lex_state = 63, .external_lex_state = 3},
  [2059] = {.lex_state = 63, .external_lex_state = 2},
  [2060] = {.lex_state = 63, .external_lex_state = 3},
  [2061] = {.lex_state = 63, .external_lex_state = 3},
  [2062] = {.lex_state = 63, .external_lex_state = 3},
  [2063] = {.lex_state = 63, .external_lex_state = 3},
  [2064] = {.lex_state = 63, .external_lex_state = 2},
  [2065] = {.lex_state = 63, .external_lex_state = 3},
  [2066] = {.lex_state = 63, .external_lex_state = 3},
  [2067] = {.lex_state = 63, .external_lex_state = 2},
  [2068] = {.lex_state = 63, .external_lex_state = 3},
  [2069] = {.lex_state = 63, .external_lex_state = 3},
  [2070] = {.lex_state = 63, .external_lex_state = 3},
  [2071] = {.lex_state = 63, .external_lex_state = 2},
  [2072] = {.lex_state = 63, .external_lex_state = 3},
  [2073] = {.lex_state = 63, .external_lex_state = 3},
  [2074] = {.lex_state = 63, .external_lex_state = 3},
  [2075] = {.lex_state = 63, .external_lex_state = 3},
  [2076] = {.lex_state = 63, .external_lex_state = 3},
  [2077] = {.lex_state = 63, .external_lex_state = 3},
  [2078] = {.lex_state = 63, .external_lex_state = 3},
  [2079] = {.lex_state = 63, .external_lex_state = 3},
  [2080] = {.lex_state = 63, .external_lex_state = 2},
  [2081] = {.lex_state = 63, .external_lex_state = 3},
  [2082] = {.lex_state = 63, .external_lex_state = 3},
  [2083] = {.lex_state = 63, .external_lex_state = 3},
  [2084] = {.lex_state = 63, .external_lex_state = 3},
  [2085] = {.lex_state = 63, .external_lex_state = 3},
  [2086] = {.lex_state = 63, .external_lex_state = 3},
  [2087] = {.lex_state = 63, .external_lex_state = 3},
  [2088] = {.lex_state = 63, .external_lex_state = 3},
  [2089] = {.lex_state = 63, .external_lex_state = 3},
  [2090] = {.lex_state = 63, .external_lex_state = 3},
  [2091] = {.lex_state = 63, .external_lex_state = 3},
  [2092] = {.lex_state = 63, .external_lex_state = 3},
  [2093] = {.lex_state = 63, .external_lex_state = 2},
  [2094] = {.lex_state = 63, .external_lex_state = 3},
  [2095] = {.lex_state = 63, .external_lex_state = 3},
  [2096] = {.lex_state = 63, .external_lex_state = 3},
  [2097] = {.lex_state = 63, .external_lex_state = 3},
  [2098] = {.lex_state = 63, .external_lex_state = 3},
  [2099] = {.lex_state = 63, .external_lex_state = 3},
  [2100] = {.lex_state = 63, .external_lex_state = 3},
  [2101] = {.lex_state = 63, .external_lex_state = 3},
  [2102] = {.lex_state = 63, .external_lex_state = 3},
  [2103] = {.lex_state = 63, .external_lex_state = 3},
  [2104] = {.lex_state = 63, .external_lex_state = 3},
  [2105] = {.lex_state = 63, .external_lex_state = 3},
  [2106] = {.lex_state = 63, .external_lex_state = 3},
  [2107] = {.lex_state = 63, .external_lex_state = 2},
  [2108] = {.lex_state = 63, .external_lex_state = 3},
  [2109] = {.lex_state = 63, .external_lex_state = 3},
  [2110] = {.lex_state = 63, .external_lex_state = 2},
  [2111] = {.lex_state = 63, .external_lex_state = 3},
  [2112] = {.lex_state = 63, .external_lex_state = 2},
  [2113] = {.lex_state = 63, .external_lex_state = 3},
  [2114] = {.lex_state = 63, .external_lex_state = 3},
  [2115] = {.lex_state = 63, .external_lex_state = 2},
  [2116] = {.lex_state = 63, .external_lex_state = 3},
  [2117] = {.lex_state = 63, .external_lex_state = 3},
  [2118] = {.lex_state = 63, .external_lex_state = 3},
  [2119] = {.lex_state = 63, .external_lex_state = 3},
  [2120] = {.lex_state = 63, .external_lex_state = 3},
  [2121] = {.lex_state = 63, .external_lex_state = 3},
  [2122] = {.lex_state = 63, .external_lex_state = 2},
  [2123] = {.lex_state = 63, .external_lex_state = 3},
  [2124] = {.lex_state = 63, .external_lex_state = 3},
  [2125] = {.lex_state = 63, .external_lex_state = 3},
  [2126] = {.lex_state = 63, .external_lex_state = 3},
  [2127] = {.lex_state = 63, .external_lex_state = 3},
  [2128] = {.lex_state = 63, .external_lex_state = 3},
  [2129] = {.lex_state = 63, .external_lex_state = 3},
  [2130] = {.lex_state = 63, .external_lex_state = 3},
  [2131] = {.lex_state = 63, .external_lex_state = 3},
  [2132] = {.lex_state = 63, .external_lex_state = 3},
  [2133] = {.lex_state = 63, .external_lex_state = 3},
  [2134] = {.lex_state = 63, .external_lex_state = 2},
  [2135] = {.lex_state = 63, .external_lex_state = 3},
  [2136] = {.lex_state = 63, .external_lex_state = 3},
  [2137] = {.lex_state = 63, .external_lex_state = 3},
  [2138] = {.lex_state = 63, .external_lex_state = 2},
  [2139] = {.lex_state = 63, .external_lex_state = 3},
  [2140] = {.lex_state = 63, .external_lex_state = 2},
  [2141] = {.lex_state = 63, .external_lex_state = 2},
  [2142] = {.lex_state = 63, .external_lex_state = 3},
  [2143] = {.lex_state = 63, .external_lex_state = 3},
  [2144] = {.lex_state = 63, .external_lex_state = 3},
  [2145] = {.lex_state = 63, .external_lex_state = 3},
  [2146] = {.lex_state = 63, .external_lex_state = 3},
  [2147] = {.lex_state = 63, .external_lex_state = 2},
  [2148] = {.lex_state = 63, .external_lex_state = 2},
  [2149] = {.lex_state = 63, .external_lex_state = 3},
  [2150] = {.lex_state = 63, .external_lex_state = 2},
  [2151] = {.lex_state = 63, .external_lex_state = 3},
  [2152] = {.lex_state = 63, .external_lex_state = 3},
  [2153] = {.lex_state = 63, .external_lex_state = 3},
  [2154] = {.lex_state = 63, .external_lex_state = 2},
  [2155] = {.lex_state = 63, .external_lex_state = 3},
  [2156] = {.lex_state = 63, .external_lex_state = 3},
  [2157] = {.lex_state = 63, .external_lex_state = 3},
  [2158] = {.lex_state = 63, .external_lex_state = 3},
  [2159] = {.lex_state = 63, .external_lex_state = 3},
  [2160] = {.lex_state = 63, .external_lex_state = 3},
  [2161] = {.lex_state = 63, .external_lex_state = 3},
  [2162] = {.lex_state = 63, .external_lex_state = 3},
  [2163] = {.lex_state = 63, .external_lex_state = 3},
  [2164] = {.lex_state = 63, .external_lex_state = 3},
  [2165] = {.lex_state = 63, .external_lex_state = 3},
  [2166] = {.lex_state = 63, .external_lex_state = 3},
  [2167] = {.lex_state = 63, .external_lex_state = 3},
  [2168] = {.lex_state = 63, .external_lex_state = 3},
  [2169] = {.lex_state = 63, .external_lex_state = 3},
  [2170] = {.lex_state = 63, .external_lex_state = 3},
  [2171] = {.lex_state = 63, .external_lex_state = 3},
  [2172] = {.lex_state = 63, .external_lex_state = 3},
  [2173] = {.lex_state = 63, .external_lex_state = 3},
  [2174] = {.lex_state = 63, .external_lex_state = 3},
  [2175] = {.lex_state = 63, .external_lex_state = 3},
  [2176] = {.lex_state = 63, .external_lex_state = 2},
  [2177] = {.lex_state = 63, .external_lex_state = 3},
  [2178] = {.lex_state = 63, .external_lex_state = 3},
  [2179] = {.lex_state = 63, .external_lex_state = 3},
  [2180] = {.lex_state = 63, .external_lex_state = 3},
  [2181] = {.lex_state = 63, .external_lex_state = 3},
  [2182] = {.lex_state = 63, .external_lex_state = 3},
  [2183] = {.lex_state = 63, .external_lex_state = 3},
  [2184] = {.lex_state = 63, .external_lex_state = 2},
  [2185] = {.lex_state = 63, .external_lex_state = 3},
  [2186] = {.lex_state = 63, .external_lex_state = 3},
  [2187] = {.lex_state = 63, .external_lex_state = 3},
  [2188] = {.lex_state = 63, .external_lex_state = 2},
  [2189] = {.lex_state = 63, .external_lex_state = 3},
  [2190] = {.lex_state = 5, .external_lex_state = 3},
  [2191] = {.lex_state = 63, .external_lex_state = 3},
  [2192] = {.lex_state = 63, .external_lex_state = 3},
  [2193] = {.lex_state = 63, .external_lex_state = 2},
  [2194] = {.lex_state = 63, .external_lex_state = 3},
  [2195] = {.lex_state = 63, .external_lex_state = 3},
  [2196] = {.lex_state = 63, .external_lex_state = 2},
  [2197] = {.lex_state = 63, .external_lex_state = 3},
  [2198] = {.lex_state = 63, .external_lex_state = 3},
  [2199] = {.lex_state = 63, .external_lex_state = 3},
  [2200] = {.lex_state = 63, .external_lex_state = 3},
  [2201] = {.lex_state = 63, .external_lex_state = 3},
  [2202] = {.lex_state = 63, .external_lex_state = 3},
  [2203] = {.lex_state = 63, .external_lex_state = 3},
  [2204] = {.lex_state = 63, .external_lex_state = 3},
  [2205] = {.lex_state = 63, .external_lex_state = 2},
  [2206] = {.lex_state = 63, .external_lex_state = 3},
  [2207] = {.lex_state = 63, .external_lex_state = 3},
  [2208] = {.lex_state = 63, .external_lex_state = 3},
  [2209] = {.lex_state = 63, .external_lex_state = 3},
  [2210] = {.lex_state = 63, .external_lex_state = 3},
  [2211] = {.lex_state = 63, .external_lex_state = 3},
  [2212] = {.lex_state = 63, .external_lex_state = 2},
  [2213] = {.lex_state = 63, .external_lex_state = 2},
  [2214] = {.lex_state = 63, .external_lex_state = 2},
  [2215] = {.lex_state = 63, .external_lex_state = 2},
  [2216] = {.lex_state = 63, .external_lex_state = 2},
  [2217] = {.lex_state = 63, .external_lex_state = 3},
  [2218] = {.lex_state = 11},
  [2219] = {.lex_state = 63, .external_lex_state = 4},
  [2220] = {.lex_state = 63, .external_lex_state = 4},
  [2221] = {.lex_state = 63, .external_lex_state = 4},
  [2222] = {.lex_state = 63, .external_lex_state = 4},
  [2223] = {.lex_state = 63, .external_lex_state = 4},
  [2224] = {.lex_state = 63, .external_lex_state = 4},
  [2225] = {.lex_state = 63, .external_lex_state = 4},
  [2226] = {.lex_state = 63, .external_lex_state = 2},
  [2227] = {.lex_state = 11},
  [2228] = {.lex_state = 63, .external_lex_state = 4},
  [2229] = {.lex_state = 63, .external_lex_state = 4},
  [2230] = {.lex_state = 63, .external_lex_state = 4},
  [2231] = {.lex_state = 63, .external_lex_state = 4},
  [2232] = {.lex_state = 11},
  [2233] = {.lex_state = 63, .external_lex_state = 4},
  [2234] = {.lex_state = 11},
  [2235] = {.lex_state = 63, .external_lex_state = 4},
  [2236] = {.lex_state = 63, .external_lex_state = 4},
  [2237] = {.lex_state = 63, .external_lex_state = 4},
  [2238] = {.lex_state = 63, .external_lex_state = 4},
  [2239] = {.lex_state = 63, .external_lex_state = 4},
  [2240] = {.lex_state = 63, .external_lex_state = 4},
  [2241] = {.lex_state = 11},
  [2242] = {.lex_state = 63, .external_lex_state = 4},
  [2243] = {.lex_state = 63, .external_lex_state = 3},
  [2244] = {.lex_state = 63, .external_lex_state = 4},
  [2245] = {.lex_state = 63, .external_lex_state = 4},
  [2246] = {.lex_state = 63, .external_lex_state = 4},
  [2247] = {.lex_state = 63, .external_lex_state = 2},
  [2248] = {.lex_state = 11},
  [2249] = {.lex_state = 63, .external_lex_state = 4},
  [2250] = {.lex_state = 63, .external_lex_state = 4},
  [2251] = {.lex_state = 63, .external_lex_state = 4},
  [2252] = {.lex_state = 11},
  [2253] = {.lex_state = 63, .external_lex_state = 3},
  [2254] = {.lex_state = 63, .external_lex_state = 2},
  [2255] = {.lex_state = 63, .external_lex_state = 2},
  [2256] = {.lex_state = 63, .external_lex_state = 2},
  [2257] = {.lex_state = 63, .external_lex_state = 3},
  [2258] = {.lex_state = 11},
  [2259] = {.lex_state = 63, .external_lex_state = 3},
  [2260] = {.lex_state = 5, .external_lex_state = 2},
  [2261] = {.lex_state = 63, .external_lex_state = 2},
  [2262] = {.lex_state = 63, .external_lex_state = 3},
  [2263] = {.lex_state = 63, .external_lex_state = 2},
  [2264] = {.lex_state = 63, .external_lex_state = 2},
  [2265] = {.lex_state = 63, .external_lex_state = 3},
  [2266] = {.lex_state = 63, .external_lex_state = 2},
  [2267] = {.lex_state = 63, .external_lex_state = 3},
  [2268] = {.lex_state = 63, .external_lex_state = 3},
  [2269] = {.lex_state = 63, .external_lex_state = 3},
  [2270] = {.lex_state = 63, .external_lex_state = 4},
  [2271] = {.lex_state = 63, .external_lex_state = 2},
  [2272] = {.lex_state = 63, .external_lex_state = 2},
  [2273] = {.lex_state = 64},
  [2274] = {.lex_state = 63, .external_lex_state = 2},
  [2275] = {.lex_state = 63, .external_lex_state = 2},
  [2276] = {.lex_state = 63, .external_lex_state = 2},
  [2277] = {.lex_state = 63, .external_lex_state = 2},
  [2278] = {.lex_state = 63, .external_lex_state = 2},
  [2279] = {.lex_state = 63, .external_lex_state = 2},
  [2280] = {.lex_state = 63, .external_lex_state = 4},
  [2281] = {.lex_state = 63, .external_lex_state = 4},
  [2282] = {.lex_state = 63, .external_lex_state = 4},
  [2283] = {.lex_state = 63, .external_lex_state = 3},
  [2284] = {.lex_state = 63, .external_lex_state = 4},
  [2285] = {.lex_state = 64},
  [2286] = {.lex_state = 63, .external_lex_state = 3},
  [2287] = {.lex_state = 63, .external_lex_state = 4},
  [2288] = {.lex_state = 63, .external_lex_state = 4},
  [2289] = {.lex_state = 63, .external_lex_state = 4},
  [2290] = {.lex_state = 63, .external_lex_state = 4},
  [2291] = {.lex_state = 63, .external_lex_state = 4},
  [2292] = {.lex_state = 63, .external_lex_state = 4},
  [2293] = {.lex_state = 63, .external_lex_state = 4},
  [2294] = {.lex_state = 63, .external_lex_state = 3},
  [2295] = {.lex_state = 63, .external_lex_state = 2},
  [2296] = {.lex_state = 63, .external_lex_state = 3},
  [2297] = {.lex_state = 63, .external_lex_state = 3},
  [2298] = {.lex_state = 63, .external_lex_state = 2},
  [2299] = {.lex_state = 64},
  [2300] = {.lex_state = 63, .external_lex_state = 2},
  [2301] = {.lex_state = 64},
  [2302] = {.lex_state = 64},
  [2303] = {.lex_state = 63, .external_lex_state = 4},
  [2304] = {.lex_state = 63, .external_lex_state = 2},
  [2305] = {.lex_state = 63, .external_lex_state = 2},
  [2306] = {.lex_state = 63, .external_lex_state = 4},
  [2307] = {.lex_state = 63, .external_lex_state = 4},
  [2308] = {.lex_state = 63, .external_lex_state = 4},
  [2309] = {.lex_state = 63, .external_lex_state = 2},
  [2310] = {.lex_state = 63, .external_lex_state = 2},
  [2311] = {.lex_state = 63, .external_lex_state = 2},
  [2312] = {.lex_state = 63, .external_lex_state = 2},
  [2313] = {.lex_state = 63, .external_lex_state = 2},
  [2314] = {.lex_state = 64},
  [2315] = {.lex_state = 63, .external_lex_state = 2},
  [2316] = {.lex_state = 63, .external_lex_state = 4},
  [2317] = {.lex_state = 63, .external_lex_state = 3},
  [2318] = {.lex_state = 63, .external_lex_state = 2},
  [2319] = {.lex_state = 63, .external_lex_state = 2},
  [2320] = {.lex_state = 63, .external_lex_state = 2},
  [2321] = {.lex_state = 63, .external_lex_state = 3},
  [2322] = {.lex_state = 63, .external_lex_state = 4},
  [2323] = {.lex_state = 63, .external_lex_state = 2},
  [2324] = {.lex_state = 63, .external_lex_state = 2},
  [2325] = {.lex_state = 63, .external_lex_state = 2},
  [2326] = {.lex_state = 63, .external_lex_state = 2},
  [2327] = {.lex_state = 63, .external_lex_state = 2},
  [2328] = {.lex_state = 64},
  [2329] = {.lex_state = 63, .external_lex_state = 4},
  [2330] = {.lex_state = 63, .external_lex_state = 2},
  [2331] = {.lex_state = 63, .external_lex_state = 2},
  [2332] = {.lex_state = 63, .external_lex_state = 2},
  [2333] = {.lex_state = 63, .external_lex_state = 3},
  [2334] = {.lex_state = 63, .external_lex_state = 2},
  [2335] = {.lex_state = 63, .external_lex_state = 3},
  [2336] = {.lex_state = 63, .external_lex_state = 2},
  [2337] = {.lex_state = 63, .external_lex_state = 2},
  [2338] = {.lex_state = 63, .external_lex_state = 2},
  [2339] = {.lex_state = 63, .external_lex_state = 2},
  [2340] = {.lex_state = 63, .external_lex_state = 2},
  [2341] = {.lex_state = 63, .external_lex_state = 3},
  [2342] = {.lex_state = 63, .external_lex_state = 3},
  [2343] = {.lex_state = 63, .external_lex_state = 3},
  [2344] = {.lex_state = 63, .external_lex_state = 2},
  [2345] = {.lex_state = 63, .external_lex_state = 2},
  [2346] = {.lex_state = 63, .external_lex_state = 2},
  [2347] = {.lex_state = 63, .external_lex_state = 2},
  [2348] = {.lex_state = 63, .external_lex_state = 2},
  [2349] = {.lex_state = 63, .external_lex_state = 2},
  [2350] = {.lex_state = 63, .external_lex_state = 2},
  [2351] = {.lex_state = 63, .external_lex_state = 2},
  [2352] = {.lex_state = 63, .external_lex_state = 2},
  [2353] = {.lex_state = 63, .external_lex_state = 2},
  [2354] = {.lex_state = 63, .external_lex_state = 2},
  [2355] = {.lex_state = 63, .external_lex_state = 2},
  [2356] = {.lex_state = 63, .external_lex_state = 2},
  [2357] = {.lex_state = 63, .external_lex_state = 2},
  [2358] = {.lex_state = 63, .external_lex_state = 2},
  [2359] = {.lex_state = 63, .external_lex_state = 2},
  [2360] = {.lex_state = 63, .external_lex_state = 2},
  [2361] = {.lex_state = 64},
  [2362] = {.lex_state = 63, .external_lex_state = 2},
  [2363] = {.lex_state = 63, .external_lex_state = 2},
  [2364] = {.lex_state = 63, .external_lex_state = 2},
  [2365] = {.lex_state = 63, .external_lex_state = 2},
  [2366] = {.lex_state = 63, .external_lex_state = 2},
  [2367] = {.lex_state = 63, .external_lex_state = 2},
  [2368] = {.lex_state = 63, .external_lex_state = 2},
  [2369] = {.lex_state = 63, .external_lex_state = 2},
  [2370] = {.lex_state = 64},
  [2371] = {.lex_state = 63, .external_lex_state = 2},
  [2372] = {.lex_state = 63, .external_lex_state = 2},
  [2373] = {.lex_state = 63, .external_lex_state = 3},
  [2374] = {.lex_state = 63, .external_lex_state = 2},
  [2375] = {.lex_state = 63, .external_lex_state = 2},
  [2376] = {.lex_state = 63, .external_lex_state = 2},
  [2377] = {.lex_state = 63, .external_lex_state = 2},
  [2378] = {.lex_state = 63, .external_lex_state = 2},
  [2379] = {.lex_state = 63, .external_lex_state = 2},
  [2380] = {.lex_state = 63, .external_lex_state = 2},
  [2381] = {.lex_state = 63, .external_lex_state = 2},
  [2382] = {.lex_state = 63, .external_lex_state = 4},
  [2383] = {.lex_state = 64},
  [2384] = {.lex_state = 63, .external_lex_state = 4},
  [2385] = {.lex_state = 63, .external_lex_state = 2},
  [2386] = {.lex_state = 63, .external_lex_state = 2},
  [2387] = {.lex_state = 63, .external_lex_state = 2},
  [2388] = {.lex_state = 64},
  [2389] = {.lex_state = 63, .external_lex_state = 2},
  [2390] = {.lex_state = 63, .external_lex_state = 2},
  [2391] = {.lex_state = 63, .external_lex_state = 3},
  [2392] = {.lex_state = 63, .external_lex_state = 2},
  [2393] = {.lex_state = 63, .external_lex_state = 2},
  [2394] = {.lex_state = 63, .external_lex_state = 2},
  [2395] = {.lex_state = 63, .external_lex_state = 3},
  [2396] = {.lex_state = 63, .external_lex_state = 2},
  [2397] = {.lex_state = 63, .external_lex_state = 2},
  [2398] = {.lex_state = 63, .external_lex_state = 2},
  [2399] = {.lex_state = 63, .external_lex_state = 2},
  [2400] = {.lex_state = 63, .external_lex_state = 2},
  [2401] = {.lex_state = 63, .external_lex_state = 2},
  [2402] = {.lex_state = 63, .external_lex_state = 2},
  [2403] = {.lex_state = 63, .external_lex_state = 2},
  [2404] = {.lex_state = 63, .external_lex_state = 2},
  [2405] = {.lex_state = 63, .external_lex_state = 3},
  [2406] = {.lex_state = 63, .external_lex_state = 2},
  [2407] = {.lex_state = 63, .external_lex_state = 2},
  [2408] = {.lex_state = 63, .external_lex_state = 2},
  [2409] = {.lex_state = 63, .external_lex_state = 2},
  [2410] = {.lex_state = 63, .external_lex_state = 2},
  [2411] = {.lex_state = 63, .external_lex_state = 2},
  [2412] = {.lex_state = 63, .external_lex_state = 2},
  [2413] = {.lex_state = 63, .external_lex_state = 2},
  [2414] = {.lex_state = 63, .external_lex_state = 2},
  [2415] = {.lex_state = 63, .external_lex_state = 2},
  [2416] = {.lex_state = 63, .external_lex_state = 2},
  [2417] = {.lex_state = 63, .external_lex_state = 3},
  [2418] = {.lex_state = 63, .external_lex_state = 3},
  [2419] = {.lex_state = 63, .external_lex_state = 2},
  [2420] = {.lex_state = 63, .external_lex_state = 2},
  [2421] = {.lex_state = 63, .external_lex_state = 2},
  [2422] = {.lex_state = 63, .external_lex_state = 3},
  [2423] = {.lex_state = 63, .external_lex_state = 2},
  [2424] = {.lex_state = 63, .external_lex_state = 4},
  [2425] = {.lex_state = 63, .external_lex_state = 4},
  [2426] = {.lex_state = 63, .external_lex_state = 3},
  [2427] = {.lex_state = 63, .external_lex_state = 2},
  [2428] = {.lex_state = 63, .external_lex_state = 2},
  [2429] = {.lex_state = 63, .external_lex_state = 2},
  [2430] = {.lex_state = 63, .external_lex_state = 3},
  [2431] = {.lex_state = 63, .external_lex_state = 2},
  [2432] = {.lex_state = 63, .external_lex_state = 2},
  [2433] = {.lex_state = 63, .external_lex_state = 2},
  [2434] = {.lex_state = 63, .external_lex_state = 3},
  [2435] = {.lex_state = 63, .external_lex_state = 3},
  [2436] = {.lex_state = 63, .external_lex_state = 3},
  [2437] = {.lex_state = 63, .external_lex_state = 3},
  [2438] = {.lex_state = 63, .external_lex_state = 2},
  [2439] = {.lex_state = 63, .external_lex_state = 3},
  [2440] = {.lex_state = 63, .external_lex_state = 2},
  [2441] = {.lex_state = 63, .external_lex_state = 2},
  [2442] = {.lex_state = 63, .external_lex_state = 2},
  [2443] = {.lex_state = 63, .external_lex_state = 2},
  [2444] = {.lex_state = 63, .external_lex_state = 2},
  [2445] = {.lex_state = 63, .external_lex_state = 4},
  [2446] = {.lex_state = 63, .external_lex_state = 2},
  [2447] = {.lex_state = 63, .external_lex_state = 4},
  [2448] = {.lex_state = 63, .external_lex_state = 4},
  [2449] = {.lex_state = 63, .external_lex_state = 2},
  [2450] = {.lex_state = 63, .external_lex_state = 2},
  [2451] = {.lex_state = 63, .external_lex_state = 3},
  [2452] = {.lex_state = 63, .external_lex_state = 2},
  [2453] = {.lex_state = 63, .external_lex_state = 2},
  [2454] = {.lex_state = 63, .external_lex_state = 3},
  [2455] = {.lex_state = 63, .external_lex_state = 2},
  [2456] = {.lex_state = 63, .external_lex_state = 4},
  [2457] = {.lex_state = 63, .external_lex_state = 3},
  [2458] = {.lex_state = 63, .external_lex_state = 3},
  [2459] = {.lex_state = 63, .external_lex_state = 3},
  [2460] = {.lex_state = 63, .external_lex_state = 3},
  [2461] = {.lex_state = 63, .external_lex_state = 2},
  [2462] = {.lex_state = 63, .external_lex_state = 3},
  [2463] = {.lex_state = 63, .external_lex_state = 3},
  [2464] = {.lex_state = 63, .external_lex_state = 3},
  [2465] = {.lex_state = 63, .external_lex_state = 3},
  [2466] = {.lex_state = 63, .external_lex_state = 3},
  [2467] = {.lex_state = 63, .external_lex_state = 3},
  [2468] = {.lex_state = 4, .external_lex_state = 3},
  [2469] = {.lex_state = 63, .external_lex_state = 3},
  [2470] = {.lex_state = 63, .external_lex_state = 3},
  [2471] = {.lex_state = 63, .external_lex_state = 3},
  [2472] = {.lex_state = 63, .external_lex_state = 2},
  [2473] = {.lex_state = 63, .external_lex_state = 3},
  [2474] = {.lex_state = 63, .external_lex_state = 3},
  [2475] = {.lex_state = 63, .external_lex_state = 2},
  [2476] = {.lex_state = 63, .external_lex_state = 2},
  [2477] = {.lex_state = 63, .external_lex_state = 3},
  [2478] = {.lex_state = 63, .external_lex_state = 3},
  [2479] = {.lex_state = 63, .external_lex_state = 3},
  [2480] = {.lex_state = 5, .external_lex_state = 4},
  [2481] = {.lex_state = 63, .external_lex_state = 3},
  [2482] = {.lex_state = 63, .external_lex_state = 3},
  [2483] = {.lex_state = 63, .external_lex_state = 3},
  [2484] = {.lex_state = 63, .external_lex_state = 4},
  [2485] = {.lex_state = 63, .external_lex_state = 3},
  [2486] = {.lex_state = 63, .external_lex_state = 3},
  [2487] = {.lex_state = 63, .external_lex_state = 4},
  [2488] = {.lex_state = 63, .external_lex_state = 4},
  [2489] = {.lex_state = 63, .external_lex_state = 2},
  [2490] = {.lex_state = 63, .external_lex_state = 2},
  [2491] = {.lex_state = 63, .external_lex_state = 2},
  [2492] = {.lex_state = 63, .external_lex_state = 3},
  [2493] = {.lex_state = 63, .external_lex_state = 3},
  [2494] = {.lex_state = 63, .external_lex_state = 2},
  [2495] = {.lex_state = 63, .external_lex_state = 3},
  [2496] = {.lex_state = 63, .external_lex_state = 3},
  [2497] = {.lex_state = 63, .external_lex_state = 3},
  [2498] = {.lex_state = 63, .external_lex_state = 3},
  [2499] = {.lex_state = 63, .external_lex_state = 2},
  [2500] = {.lex_state = 63, .external_lex_state = 2},
  [2501] = {.lex_state = 63, .external_lex_state = 2},
  [2502] = {.lex_state = 63, .external_lex_state = 2},
  [2503] = {.lex_state = 63, .external_lex_state = 2},
  [2504] = {.lex_state = 63, .external_lex_state = 3},
  [2505] = {.lex_state = 63, .external_lex_state = 3},
  [2506] = {.lex_state = 63, .external_lex_state = 3},
  [2507] = {.lex_state = 63, .external_lex_state = 3},
  [2508] = {.lex_state = 63, .external_lex_state = 2},
  [2509] = {.lex_state = 63, .external_lex_state = 3},
  [2510] = {.lex_state = 63, .external_lex_state = 2},
  [2511] = {.lex_state = 63, .external_lex_state = 4},
  [2512] = {.lex_state = 63, .external_lex_state = 3},
  [2513] = {.lex_state = 63, .external_lex_state = 3},
  [2514] = {.lex_state = 63, .external_lex_state = 3},
  [2515] = {.lex_state = 63, .external_lex_state = 3},
  [2516] = {.lex_state = 63, .external_lex_state = 2},
  [2517] = {.lex_state = 63, .external_lex_state = 2},
  [2518] = {.lex_state = 63, .external_lex_state = 2},
  [2519] = {.lex_state = 63, .external_lex_state = 3},
  [2520] = {.lex_state = 63, .external_lex_state = 2},
  [2521] = {.lex_state = 63, .external_lex_state = 2},
  [2522] = {.lex_state = 63, .external_lex_state = 3},
  [2523] = {.lex_state = 63, .external_lex_state = 3},
  [2524] = {.lex_state = 63, .external_lex_state = 3},
  [2525] = {.lex_state = 63, .external_lex_state = 2},
  [2526] = {.lex_state = 63, .external_lex_state = 3},
  [2527] = {.lex_state = 63, .external_lex_state = 3},
  [2528] = {.lex_state = 63, .external_lex_state = 2},
  [2529] = {.lex_state = 63, .external_lex_state = 3},
  [2530] = {.lex_state = 63, .external_lex_state = 2},
  [2531] = {.lex_state = 63, .external_lex_state = 3},
  [2532] = {.lex_state = 63, .external_lex_state = 3},
  [2533] = {.lex_state = 63, .external_lex_state = 3},
  [2534] = {.lex_state = 63, .external_lex_state = 3},
  [2535] = {.lex_state = 63, .external_lex_state = 3},
  [2536] = {.lex_state = 4, .external_lex_state = 3},
  [2537] = {.lex_state = 63, .external_lex_state = 3},
  [2538] = {.lex_state = 63, .external_lex_state = 3},
  [2539] = {.lex_state = 63, .external_lex_state = 2},
  [2540] = {.lex_state = 63, .external_lex_state = 4},
  [2541] = {.lex_state = 63, .external_lex_state = 4},
  [2542] = {.lex_state = 63, .external_lex_state = 2},
  [2543] = {.lex_state = 63, .external_lex_state = 3},
  [2544] = {.lex_state = 63, .external_lex_state = 2},
  [2545] = {.lex_state = 63, .external_lex_state = 2},
  [2546] = {.lex_state = 63, .external_lex_state = 3},
  [2547] = {.lex_state = 63, .external_lex_state = 4},
  [2548] = {.lex_state = 63, .external_lex_state = 3},
  [2549] = {.lex_state = 63, .external_lex_state = 2},
  [2550] = {.lex_state = 63, .external_lex_state = 3},
  [2551] = {.lex_state = 63, .external_lex_state = 3},
  [2552] = {.lex_state = 63, .external_lex_state = 2},
  [2553] = {.lex_state = 63, .external_lex_state = 2},
  [2554] = {.lex_state = 63, .external_lex_state = 3},
  [2555] = {.lex_state = 63, .external_lex_state = 4},
  [2556] = {.lex_state = 63, .external_lex_state = 3},
  [2557] = {.lex_state = 63, .external_lex_state = 2},
  [2558] = {.lex_state = 63, .external_lex_state = 2},
  [2559] = {.lex_state = 63, .external_lex_state = 4},
  [2560] = {.lex_state = 63, .external_lex_state = 2},
  [2561] = {.lex_state = 63, .external_lex_state = 2},
  [2562] = {.lex_state = 63, .external_lex_state = 2},
  [2563] = {.lex_state = 63, .external_lex_state = 3},
  [2564] = {.lex_state = 63, .external_lex_state = 3},
  [2565] = {.lex_state = 4, .external_lex_state = 3},
  [2566] = {.lex_state = 63, .external_lex_state = 3},
  [2567] = {.lex_state = 4, .external_lex_state = 3},
  [2568] = {.lex_state = 63, .external_lex_state = 3},
  [2569] = {.lex_state = 63, .external_lex_state = 3},
  [2570] = {.lex_state = 4, .external_lex_state = 3},
  [2571] = {.lex_state = 63, .external_lex_state = 3},
  [2572] = {.lex_state = 63, .external_lex_state = 2},
  [2573] = {.lex_state = 63, .external_lex_state = 4},
  [2574] = {.lex_state = 63, .external_lex_state = 4},
  [2575] = {.lex_state = 63, .external_lex_state = 3},
  [2576] = {.lex_state = 63, .external_lex_state = 4},
  [2577] = {.lex_state = 63, .external_lex_state = 3},
  [2578] = {.lex_state = 4, .external_lex_state = 3},
  [2579] = {.lex_state = 63, .external_lex_state = 3},
  [2580] = {.lex_state = 63, .external_lex_state = 3},
  [2581] = {.lex_state = 63, .external_lex_state = 3},
  [2582] = {.lex_state = 63, .external_lex_state = 2},
  [2583] = {.lex_state = 63, .external_lex_state = 3},
  [2584] = {.lex_state = 4, .external_lex_state = 3},
  [2585] = {.lex_state = 63, .external_lex_state = 2},
  [2586] = {.lex_state = 63, .external_lex_state = 3},
  [2587] = {.lex_state = 63, .external_lex_state = 2},
  [2588] = {.lex_state = 4, .external_lex_state = 3},
  [2589] = {.lex_state = 63, .external_lex_state = 3},
  [2590] = {.lex_state = 63, .external_lex_state = 3},
  [2591] = {.lex_state = 4, .external_lex_state = 3},
  [2592] = {.lex_state = 63, .external_lex_state = 3},
  [2593] = {.lex_state = 63, .external_lex_state = 3},
  [2594] = {.lex_state = 63, .external_lex_state = 3},
  [2595] = {.lex_state = 4, .external_lex_state = 3},
  [2596] = {.lex_state = 4, .external_lex_state = 3},
  [2597] = {.lex_state = 63, .external_lex_state = 3},
  [2598] = {.lex_state = 63, .external_lex_state = 3},
  [2599] = {.lex_state = 63, .external_lex_state = 3},
  [2600] = {.lex_state = 63, .external_lex_state = 3},
  [2601] = {.lex_state = 63, .external_lex_state = 3},
  [2602] = {.lex_state = 63, .external_lex_state = 3},
  [2603] = {.lex_state = 4, .external_lex_state = 3},
  [2604] = {.lex_state = 63, .external_lex_state = 3},
  [2605] = {.lex_state = 4, .external_lex_state = 3},
  [2606] = {.lex_state = 4, .external_lex_state = 3},
  [2607] = {.lex_state = 63, .external_lex_state = 3},
  [2608] = {.lex_state = 4, .external_lex_state = 3},
  [2609] = {.lex_state = 4, .external_lex_state = 3},
  [2610] = {.lex_state = 63, .external_lex_state = 3},
  [2611] = {.lex_state = 4, .external_lex_state = 3},
  [2612] = {.lex_state = 4, .external_lex_state = 3},
  [2613] = {.lex_state = 63, .external_lex_state = 3},
  [2614] = {.lex_state = 4, .external_lex_state = 3},
  [2615] = {.lex_state = 4, .external_lex_state = 3},
  [2616] = {.lex_state = 63, .external_lex_state = 3},
  [2617] = {.lex_state = 63, .external_lex_state = 3},
  [2618] = {.lex_state = 63, .external_lex_state = 4},
  [2619] = {.lex_state = 4, .external_lex_state = 3},
  [2620] = {.lex_state = 4, .external_lex_state = 3},
  [2621] = {.lex_state = 4, .external_lex_state = 3},
  [2622] = {.lex_state = 4, .external_lex_state = 3},
  [2623] = {.lex_state = 4, .external_lex_state = 3},
  [2624] = {.lex_state = 63, .external_lex_state = 3},
  [2625] = {.lex_state = 63, .external_lex_state = 3},
  [2626] = {.lex_state = 63, .external_lex_state = 3},
  [2627] = {.lex_state = 63, .external_lex_state = 3},
  [2628] = {.lex_state = 4, .external_lex_state = 3},
  [2629] = {.lex_state = 63, .external_lex_state = 4},
  [2630] = {.lex_state = 63, .external_lex_state = 4},
  [2631] = {.lex_state = 63, .external_lex_state = 4},
  [2632] = {.lex_state = 63, .external_lex_state = 4},
  [2633] = {.lex_state = 63, .external_lex_state = 3},
  [2634] = {.lex_state = 63, .external_lex_state = 3},
  [2635] = {.lex_state = 63, .external_lex_state = 3},
  [2636] = {.lex_state = 63, .external_lex_state = 2},
  [2637] = {.lex_state = 63, .external_lex_state = 2},
  [2638] = {.lex_state = 63, .external_lex_state = 2},
  [2639] = {.lex_state = 63, .external_lex_state = 2},
  [2640] = {.lex_state = 63, .external_lex_state = 2},
  [2641] = {.lex_state = 63, .external_lex_state = 2},
  [2642] = {.lex_state = 63, .external_lex_state = 2},
  [2643] = {.lex_state = 63, .external_lex_state = 3},
  [2644] = {.lex_state = 63, .external_lex_state = 4},
  [2645] = {.lex_state = 63, .external_lex_state = 2},
  [2646] = {.lex_state = 63, .external_lex_state = 2},
  [2647] = {.lex_state = 63, .external_lex_state = 2},
  [2648] = {.lex_state = 63, .external_lex_state = 4},
  [2649] = {.lex_state = 63, .external_lex_state = 2},
  [2650] = {.lex_state = 63, .external_lex_state = 3},
  [2651] = {.lex_state = 63, .external_lex_state = 2},
  [2652] = {.lex_state = 64},
  [2653] = {.lex_state = 63, .external_lex_state = 4},
  [2654] = {.lex_state = 63, .external_lex_state = 4},
  [2655] = {.lex_state = 63, .external_lex_state = 2},
  [2656] = {.lex_state = 63, .external_lex_state = 2},
  [2657] = {.lex_state = 63, .external_lex_state = 4},
  [2658] = {.lex_state = 63, .external_lex_state = 3},
  [2659] = {.lex_state = 63, .external_lex_state = 4},
  [2660] = {.lex_state = 63, .external_lex_state = 4},
  [2661] = {.lex_state = 4, .external_lex_state = 3},
  [2662] = {.lex_state = 4, .external_lex_state = 3},
  [2663] = {.lex_state = 63, .external_lex_state = 4},
  [2664] = {.lex_state = 63, .external_lex_state = 4},
  [2665] = {.lex_state = 63, .external_lex_state = 4},
  [2666] = {.lex_state = 63, .external_lex_state = 4},
  [2667] = {.lex_state = 63, .external_lex_state = 4},
  [2668] = {.lex_state = 63, .external_lex_state = 4},
  [2669] = {.lex_state = 63, .external_lex_state = 4},
  [2670] = {.lex_state = 63, .external_lex_state = 4},
  [2671] = {.lex_state = 63, .external_lex_state = 4},
  [2672] = {.lex_state = 63, .external_lex_state = 4},
  [2673] = {.lex_state = 4, .external_lex_state = 3},
  [2674] = {.lex_state = 63, .external_lex_state = 4},
  [2675] = {.lex_state = 4, .external_lex_state = 3},
  [2676] = {.lex_state = 4, .external_lex_state = 3},
  [2677] = {.lex_state = 4, .external_lex_state = 3},
  [2678] = {.lex_state = 63, .external_lex_state = 4},
  [2679] = {.lex_state = 4, .external_lex_state = 3},
  [2680] = {.lex_state = 4, .external_lex_state = 3},
  [2681] = {.lex_state = 4, .external_lex_state = 3},
  [2682] = {.lex_state = 63, .external_lex_state = 4},
  [2683] = {.lex_state = 63, .external_lex_state = 4},
  [2684] = {.lex_state = 4, .external_lex_state = 3},
  [2685] = {.lex_state = 63, .external_lex_state = 3},
  [2686] = {.lex_state = 63, .external_lex_state = 2},
  [2687] = {.lex_state = 63, .external_lex_state = 3},
  [2688] = {.lex_state = 4, .external_lex_state = 3},
  [2689] = {.lex_state = 63, .external_lex_state = 2},
  [2690] = {.lex_state = 63, .external_lex_state = 2},
  [2691] = {.lex_state = 63, .external_lex_state = 2},
  [2692] = {.lex_state = 63, .external_lex_state = 2},
  [2693] = {.lex_state = 63, .external_lex_state = 4},
  [2694] = {.lex_state = 63, .external_lex_state = 2},
  [2695] = {.lex_state = 63, .external_lex_state = 2},
  [2696] = {.lex_state = 4, .external_lex_state = 3},
  [2697] = {.lex_state = 63, .external_lex_state = 4},
  [2698] = {.lex_state = 63, .external_lex_state = 4},
  [2699] = {.lex_state = 5, .external_lex_state = 3},
  [2700] = {.lex_state = 63, .external_lex_state = 4},
  [2701] = {.lex_state = 63, .external_lex_state = 4},
  [2702] = {.lex_state = 63, .external_lex_state = 4},
  [2703] = {.lex_state = 63, .external_lex_state = 4},
  [2704] = {.lex_state = 63, .external_lex_state = 4},
  [2705] = {.lex_state = 63, .external_lex_state = 4},
  [2706] = {.lex_state = 63, .external_lex_state = 3},
  [2707] = {.lex_state = 63, .external_lex_state = 2},
  [2708] = {.lex_state = 63, .external_lex_state = 3},
  [2709] = {.lex_state = 63, .external_lex_state = 4},
  [2710] = {.lex_state = 63, .external_lex_state = 3},
  [2711] = {.lex_state = 63, .external_lex_state = 2},
  [2712] = {.lex_state = 4, .external_lex_state = 3},
  [2713] = {.lex_state = 63, .external_lex_state = 4},
  [2714] = {.lex_state = 63, .external_lex_state = 4},
  [2715] = {.lex_state = 63, .external_lex_state = 4},
  [2716] = {.lex_state = 4, .external_lex_state = 3},
  [2717] = {.lex_state = 63, .external_lex_state = 4},
  [2718] = {.lex_state = 63, .external_lex_state = 3},
  [2719] = {.lex_state = 4, .external_lex_state = 3},
  [2720] = {.lex_state = 63, .external_lex_state = 4},
  [2721] = {.lex_state = 63, .external_lex_state = 3},
  [2722] = {.lex_state = 63, .external_lex_state = 4},
  [2723] = {.lex_state = 63, .external_lex_state = 2},
  [2724] = {.lex_state = 63, .external_lex_state = 4},
  [2725] = {.lex_state = 63, .external_lex_state = 4},
  [2726] = {.lex_state = 63, .external_lex_state = 4},
  [2727] = {.lex_state = 63, .external_lex_state = 4},
  [2728] = {.lex_state = 63, .external_lex_state = 4},
  [2729] = {.lex_state = 63, .external_lex_state = 4},
  [2730] = {.lex_state = 63, .external_lex_state = 4},
  [2731] = {.lex_state = 63, .external_lex_state = 4},
  [2732] = {.lex_state = 63, .external_lex_state = 4},
  [2733] = {.lex_state = 63, .external_lex_state = 2},
  [2734] = {.lex_state = 63, .external_lex_state = 4},
  [2735] = {.lex_state = 63, .external_lex_state = 3},
  [2736] = {.lex_state = 63, .external_lex_state = 4},
  [2737] = {.lex_state = 63, .external_lex_state = 4},
  [2738] = {.lex_state = 63, .external_lex_state = 4},
  [2739] = {.lex_state = 63, .external_lex_state = 3},
  [2740] = {.lex_state = 4, .external_lex_state = 3},
  [2741] = {.lex_state = 63, .external_lex_state = 3},
  [2742] = {.lex_state = 63, .external_lex_state = 3},
  [2743] = {.lex_state = 63, .external_lex_state = 3},
  [2744] = {.lex_state = 63, .external_lex_state = 2},
  [2745] = {.lex_state = 63, .external_lex_state = 2},
  [2746] = {.lex_state = 63, .external_lex_state = 4},
  [2747] = {.lex_state = 63, .external_lex_state = 3},
  [2748] = {.lex_state = 63, .external_lex_state = 3},
  [2749] = {.lex_state = 63, .external_lex_state = 3},
  [2750] = {.lex_state = 63, .external_lex_state = 3},
  [2751] = {.lex_state = 63, .external_lex_state = 4},
  [2752] = {.lex_state = 4, .external_lex_state = 3},
  [2753] = {.lex_state = 63, .external_lex_state = 4},
  [2754] = {.lex_state = 4, .external_lex_state = 2},
  [2755] = {.lex_state = 63, .external_lex_state = 4},
  [2756] = {.lex_state = 63, .external_lex_state = 3},
  [2757] = {.lex_state = 63, .external_lex_state = 4},
  [2758] = {.lex_state = 63, .external_lex_state = 4},
  [2759] = {.lex_state = 63, .external_lex_state = 4},
  [2760] = {.lex_state = 4, .external_lex_state = 3},
  [2761] = {.lex_state = 4, .external_lex_state = 3},
  [2762] = {.lex_state = 63, .external_lex_state = 3},
  [2763] = {.lex_state = 4, .external_lex_state = 3},
  [2764] = {.lex_state = 63, .external_lex_state = 4},
  [2765] = {.lex_state = 4, .external_lex_state = 3},
  [2766] = {.lex_state = 63, .external_lex_state = 3},
  [2767] = {.lex_state = 63, .external_lex_state = 3},
  [2768] = {.lex_state = 63, .external_lex_state = 4},
  [2769] = {.lex_state = 63, .external_lex_state = 3},
  [2770] = {.lex_state = 63, .external_lex_state = 3},
  [2771] = {.lex_state = 63, .external_lex_state = 3},
  [2772] = {.lex_state = 63, .external_lex_state = 3},
  [2773] = {.lex_state = 63, .external_lex_state = 3},
  [2774] = {.lex_state = 63, .external_lex_state = 4},
  [2775] = {.lex_state = 63, .external_lex_state = 3},
  [2776] = {.lex_state = 63, .external_lex_state = 4},
  [2777] = {.lex_state = 63, .external_lex_state = 3},
  [2778] = {.lex_state = 4, .external_lex_state = 3},
  [2779] = {.lex_state = 63, .external_lex_state = 3},
  [2780] = {.lex_state = 63, .external_lex_state = 4},
  [2781] = {.lex_state = 63, .external_lex_state = 4},
  [2782] = {.lex_state = 63, .external_lex_state = 4},
  [2783] = {.lex_state = 63, .external_lex_state = 4},
  [2784] = {.lex_state = 63, .external_lex_state = 4},
  [2785] = {.lex_state = 4, .external_lex_state = 3},
  [2786] = {.lex_state = 63, .external_lex_state = 4},
  [2787] = {.lex_state = 63, .external_lex_state = 4},
  [2788] = {.lex_state = 63, .external_lex_state = 4},
  [2789] = {.lex_state = 63, .external_lex_state = 4},
  [2790] = {.lex_state = 63, .external_lex_state = 2},
  [2791] = {.lex_state = 63, .external_lex_state = 2},
  [2792] = {.lex_state = 63, .external_lex_state = 4},
  [2793] = {.lex_state = 4, .external_lex_state = 3},
  [2794] = {.lex_state = 63, .external_lex_state = 3},
  [2795] = {.lex_state = 63, .external_lex_state = 4},
  [2796] = {.lex_state = 4, .external_lex_state = 3},
  [2797] = {.lex_state = 63, .external_lex_state = 4},
  [2798] = {.lex_state = 63, .external_lex_state = 4},
  [2799] = {.lex_state = 63, .external_lex_state = 3},
  [2800] = {.lex_state = 63, .external_lex_state = 3},
  [2801] = {.lex_state = 63, .external_lex_state = 3},
  [2802] = {.lex_state = 63, .external_lex_state = 4},
  [2803] = {.lex_state = 63, .external_lex_state = 2},
  [2804] = {.lex_state = 63, .external_lex_state = 3},
  [2805] = {.lex_state = 63, .external_lex_state = 4},
  [2806] = {.lex_state = 63, .external_lex_state = 4},
  [2807] = {.lex_state = 63, .external_lex_state = 4},
  [2808] = {.lex_state = 63, .external_lex_state = 3},
  [2809] = {.lex_state = 63, .external_lex_state = 3},
  [2810] = {.lex_state = 63, .external_lex_state = 4},
  [2811] = {.lex_state = 4, .external_lex_state = 3},
  [2812] = {.lex_state = 63, .external_lex_state = 4},
  [2813] = {.lex_state = 63, .external_lex_state = 3},
  [2814] = {.lex_state = 63, .external_lex_state = 2},
  [2815] = {.lex_state = 63, .external_lex_state = 3},
  [2816] = {.lex_state = 63, .external_lex_state = 2},
  [2817] = {.lex_state = 63, .external_lex_state = 2},
  [2818] = {.lex_state = 63, .external_lex_state = 4},
  [2819] = {.lex_state = 63, .external_lex_state = 4},
  [2820] = {.lex_state = 63, .external_lex_state = 2},
  [2821] = {.lex_state = 63, .external_lex_state = 3},
  [2822] = {.lex_state = 63, .external_lex_state = 4},
  [2823] = {.lex_state = 63, .external_lex_state = 4},
  [2824] = {.lex_state = 63, .external_lex_state = 3},
  [2825] = {.lex_state = 63, .external_lex_state = 3},
  [2826] = {.lex_state = 63, .external_lex_state = 4},
  [2827] = {.lex_state = 63, .external_lex_state = 2},
  [2828] = {.lex_state = 63, .external_lex_state = 4},
  [2829] = {.lex_state = 63, .external_lex_state = 3},
  [2830] = {.lex_state = 63, .external_lex_state = 4},
  [2831] = {.lex_state = 63, .external_lex_state = 4},
  [2832] = {.lex_state = 63, .external_lex_state = 4},
  [2833] = {.lex_state = 63, .external_lex_state = 4},
  [2834] = {.lex_state = 63, .external_lex_state = 4},
  [2835] = {.lex_state = 63, .external_lex_state = 4},
  [2836] = {.lex_state = 63, .external_lex_state = 4},
  [2837] = {.lex_state = 63, .external_lex_state = 4},
  [2838] = {.lex_state = 63, .external_lex_state = 4},
  [2839] = {.lex_state = 63, .external_lex_state = 4},
  [2840] = {.lex_state = 4, .external_lex_state = 3},
  [2841] = {.lex_state = 63, .external_lex_state = 3},
  [2842] = {.lex_state = 63, .external_lex_state = 4},
  [2843] = {.lex_state = 63, .external_lex_state = 2},
  [2844] = {.lex_state = 63, .external_lex_state = 3},
  [2845] = {.lex_state = 63, .external_lex_state = 4},
  [2846] = {.lex_state = 63, .external_lex_state = 4},
  [2847] = {.lex_state = 4, .external_lex_state = 3},
  [2848] = {.lex_state = 63, .external_lex_state = 4},
  [2849] = {.lex_state = 63, .external_lex_state = 4},
  [2850] = {.lex_state = 63, .external_lex_state = 4},
  [2851] = {.lex_state = 63, .external_lex_state = 4},
  [2852] = {.lex_state = 63, .external_lex_state = 3},
  [2853] = {.lex_state = 63, .external_lex_state = 4},
  [2854] = {.lex_state = 63, .external_lex_state = 4},
  [2855] = {.lex_state = 63, .external_lex_state = 3},
  [2856] = {.lex_state = 63, .external_lex_state = 3},
  [2857] = {.lex_state = 63, .external_lex_state = 3},
  [2858] = {.lex_state = 63, .external_lex_state = 3},
  [2859] = {.lex_state = 63, .external_lex_state = 3},
  [2860] = {.lex_state = 63, .external_lex_state = 4},
  [2861] = {.lex_state = 63, .external_lex_state = 3},
  [2862] = {.lex_state = 63, .external_lex_state = 3},
  [2863] = {.lex_state = 63, .external_lex_state = 3},
  [2864] = {.lex_state = 63, .external_lex_state = 3},
  [2865] = {.lex_state = 63, .external_lex_state = 4},
  [2866] = {.lex_state = 63, .external_lex_state = 3},
  [2867] = {.lex_state = 63, .external_lex_state = 3},
  [2868] = {.lex_state = 63, .external_lex_state = 4},
  [2869] = {.lex_state = 63, .external_lex_state = 4},
  [2870] = {.lex_state = 63, .external_lex_state = 4},
  [2871] = {.lex_state = 63, .external_lex_state = 3},
  [2872] = {.lex_state = 63, .external_lex_state = 4},
  [2873] = {.lex_state = 63, .external_lex_state = 4},
  [2874] = {.lex_state = 63, .external_lex_state = 3},
  [2875] = {.lex_state = 63, .external_lex_state = 3},
  [2876] = {.lex_state = 63, .external_lex_state = 3},
  [2877] = {.lex_state = 63, .external_lex_state = 2},
  [2878] = {.lex_state = 63, .external_lex_state = 3},
  [2879] = {.lex_state = 63, .external_lex_state = 4},
  [2880] = {.lex_state = 63, .external_lex_state = 3},
  [2881] = {.lex_state = 63, .external_lex_state = 3},
  [2882] = {.lex_state = 63, .external_lex_state = 3},
  [2883] = {.lex_state = 63, .external_lex_state = 3},
  [2884] = {.lex_state = 63, .external_lex_state = 3},
  [2885] = {.lex_state = 63, .external_lex_state = 3},
  [2886] = {.lex_state = 63, .external_lex_state = 3},
  [2887] = {.lex_state = 63, .external_lex_state = 3},
  [2888] = {.lex_state = 63, .external_lex_state = 3},
  [2889] = {.lex_state = 63, .external_lex_state = 3},
  [2890] = {.lex_state = 63, .external_lex_state = 3},
  [2891] = {.lex_state = 4, .external_lex_state = 2},
  [2892] = {.lex_state = 63, .external_lex_state = 2},
  [2893] = {.lex_state = 4, .external_lex_state = 3},
  [2894] = {.lex_state = 63, .external_lex_state = 2},
  [2895] = {.lex_state = 63, .external_lex_state = 2},
  [2896] = {.lex_state = 63, .external_lex_state = 2},
  [2897] = {.lex_state = 63, .external_lex_state = 2},
  [2898] = {.lex_state = 63, .external_lex_state = 2},
  [2899] = {.lex_state = 63, .external_lex_state = 2},
  [2900] = {.lex_state = 63, .external_lex_state = 2},
  [2901] = {.lex_state = 63, .external_lex_state = 2},
  [2902] = {.lex_state = 63, .external_lex_state = 2},
  [2903] = {.lex_state = 4, .external_lex_state = 3},
  [2904] = {.lex_state = 63, .external_lex_state = 3},
  [2905] = {.lex_state = 63, .external_lex_state = 2},
  [2906] = {.lex_state = 63, .external_lex_state = 3},
  [2907] = {.lex_state = 63, .external_lex_state = 2},
  [2908] = {.lex_state = 63, .external_lex_state = 3},
  [2909] = {.lex_state = 63, .external_lex_state = 2},
  [2910] = {.lex_state = 63, .external_lex_state = 3},
  [2911] = {.lex_state = 63, .external_lex_state = 2},
  [2912] = {.lex_state = 63, .external_lex_state = 2},
  [2913] = {.lex_state = 4, .external_lex_state = 3},
  [2914] = {.lex_state = 63, .external_lex_state = 2},
  [2915] = {.lex_state = 63, .external_lex_state = 2},
  [2916] = {.lex_state = 63, .external_lex_state = 3},
  [2917] = {.lex_state = 63, .external_lex_state = 2},
  [2918] = {.lex_state = 63, .external_lex_state = 2},
  [2919] = {.lex_state = 63, .external_lex_state = 2},
  [2920] = {.lex_state = 63, .external_lex_state = 3},
  [2921] = {.lex_state = 63, .external_lex_state = 3},
  [2922] = {.lex_state = 63, .external_lex_state = 2},
  [2923] = {.lex_state = 63, .external_lex_state = 2},
  [2924] = {.lex_state = 4, .external_lex_state = 3},
  [2925] = {.lex_state = 63, .external_lex_state = 2},
  [2926] = {.lex_state = 63, .external_lex_state = 2},
  [2927] = {.lex_state = 63, .external_lex_state = 3},
  [2928] = {.lex_state = 63, .external_lex_state = 2},
  [2929] = {.lex_state = 63, .external_lex_state = 4},
  [2930] = {.lex_state = 63, .external_lex_state = 4},
  [2931] = {.lex_state = 63, .external_lex_state = 3},
  [2932] = {.lex_state = 63, .external_lex_state = 2},
  [2933] = {.lex_state = 63, .external_lex_state = 2},
  [2934] = {.lex_state = 63, .external_lex_state = 3},
  [2935] = {.lex_state = 63, .external_lex_state = 2},
  [2936] = {.lex_state = 63, .external_lex_state = 3},
  [2937] = {.lex_state = 63, .external_lex_state = 2},
  [2938] = {.lex_state = 63, .external_lex_state = 2},
  [2939] = {.lex_state = 63, .external_lex_state = 2},
  [2940] = {.lex_state = 63, .external_lex_state = 3},
  [2941] = {.lex_state = 63, .external_lex_state = 2},
  [2942] = {.lex_state = 63, .external_lex_state = 4},
  [2943] = {.lex_state = 63, .external_lex_state = 3},
  [2944] = {.lex_state = 63, .external_lex_state = 3},
  [2945] = {.lex_state = 63, .external_lex_state = 4},
  [2946] = {.lex_state = 63, .external_lex_state = 2},
  [2947] = {.lex_state = 5, .external_lex_state = 3},
  [2948] = {.lex_state = 63, .external_lex_state = 3},
  [2949] = {.lex_state = 63, .external_lex_state = 3},
  [2950] = {.lex_state = 63, .external_lex_state = 2},
  [2951] = {.lex_state = 63, .external_lex_state = 4},
  [2952] = {.lex_state = 63, .external_lex_state = 3},
  [2953] = {.lex_state = 63, .external_lex_state = 3},
  [2954] = {.lex_state = 63, .external_lex_state = 3},
  [2955] = {.lex_state = 63, .external_lex_state = 2},
  [2956] = {.lex_state = 63, .external_lex_state = 2},
  [2957] = {.lex_state = 63, .external_lex_state = 3},
  [2958] = {.lex_state = 63, .external_lex_state = 4},
  [2959] = {.lex_state = 63, .external_lex_state = 2},
  [2960] = {.lex_state = 63, .external_lex_state = 2},
  [2961] = {.lex_state = 63, .external_lex_state = 2},
  [2962] = {.lex_state = 63, .external_lex_state = 4},
  [2963] = {.lex_state = 63, .external_lex_state = 4},
  [2964] = {.lex_state = 63, .external_lex_state = 2},
  [2965] = {.lex_state = 7, .external_lex_state = 3},
  [2966] = {.lex_state = 63, .external_lex_state = 3},
  [2967] = {.lex_state = 63, .external_lex_state = 3},
  [2968] = {.lex_state = 63, .external_lex_state = 3},
  [2969] = {.lex_state = 4, .external_lex_state = 3},
  [2970] = {.lex_state = 63, .external_lex_state = 2},
  [2971] = {.lex_state = 63, .external_lex_state = 3},
  [2972] = {.lex_state = 63, .external_lex_state = 2},
  [2973] = {.lex_state = 63, .external_lex_state = 3},
  [2974] = {.lex_state = 63, .external_lex_state = 3},
  [2975] = {.lex_state = 63, .external_lex_state = 3},
  [2976] = {.lex_state = 63, .external_lex_state = 2},
  [2977] = {.lex_state = 63, .external_lex_state = 3},
  [2978] = {.lex_state = 63, .external_lex_state = 3},
  [2979] = {.lex_state = 63, .external_lex_state = 3},
  [2980] = {.lex_state = 63, .external_lex_state = 3},
  [2981] = {.lex_state = 4, .external_lex_state = 3},
  [2982] = {.lex_state = 63, .external_lex_state = 3},
  [2983] = {.lex_state = 4, .external_lex_state = 3},
  [2984] = {.lex_state = 4, .external_lex_state = 3},
  [2985] = {.lex_state = 63, .external_lex_state = 2},
  [2986] = {.lex_state = 63, .external_lex_state = 2},
  [2987] = {.lex_state = 63, .external_lex_state = 3},
  [2988] = {.lex_state = 63, .external_lex_state = 2},
  [2989] = {.lex_state = 63, .external_lex_state = 3},
  [2990] = {.lex_state = 63, .external_lex_state = 3},
  [2991] = {.lex_state = 63, .external_lex_state = 2},
  [2992] = {.lex_state = 63, .external_lex_state = 2},
  [2993] = {.lex_state = 63, .external_lex_state = 2},
  [2994] = {.lex_state = 63, .external_lex_state = 2},
  [2995] = {.lex_state = 63, .external_lex_state = 2},
  [2996] = {.lex_state = 63, .external_lex_state = 2},
  [2997] = {.lex_state = 4, .external_lex_state = 2},
  [2998] = {.lex_state = 63, .external_lex_state = 3},
  [2999] = {.lex_state = 63, .external_lex_state = 3},
  [3000] = {.lex_state = 5, .external_lex_state = 2},
  [3001] = {.lex_state = 63, .external_lex_state = 3},
  [3002] = {.lex_state = 4, .external_lex_state = 3},
  [3003] = {.lex_state = 63, .external_lex_state = 3},
  [3004] = {.lex_state = 63, .external_lex_state = 3},
  [3005] = {.lex_state = 63, .external_lex_state = 4},
  [3006] = {.lex_state = 63, .external_lex_state = 3},
  [3007] = {.lex_state = 63, .external_lex_state = 3},
  [3008] = {.lex_state = 63, .external_lex_state = 3},
  [3009] = {.lex_state = 63, .external_lex_state = 3},
  [3010] = {.lex_state = 63, .external_lex_state = 3},
  [3011] = {.lex_state = 63, .external_lex_state = 3},
  [3012] = {.lex_state = 63, .external_lex_state = 3},
  [3013] = {.lex_state = 63, .external_lex_state = 3},
  [3014] = {.lex_state = 63, .external_lex_state = 3},
  [3015] = {.lex_state = 63, .external_lex_state = 3},
  [3016] = {.lex_state = 63, .external_lex_state = 2},
  [3017] = {.lex_state = 63, .external_lex_state = 2},
  [3018] = {.lex_state = 63, .external_lex_state = 3},
  [3019] = {.lex_state = 63, .external_lex_state = 3},
  [3020] = {.lex_state = 63, .external_lex_state = 3},
  [3021] = {.lex_state = 63, .external_lex_state = 3},
  [3022] = {.lex_state = 63, .external_lex_state = 3},
  [3023] = {.lex_state = 63, .external_lex_state = 2},
  [3024] = {.lex_state = 63, .external_lex_state = 3},
  [3025] = {.lex_state = 63, .external_lex_state = 3},
  [3026] = {.lex_state = 63, .external_lex_state = 3},
  [3027] = {.lex_state = 63, .external_lex_state = 3},
  [3028] = {.lex_state = 63, .external_lex_state = 2},
  [3029] = {.lex_state = 63, .external_lex_state = 3},
  [3030] = {.lex_state = 63, .external_lex_state = 3},
  [3031] = {.lex_state = 63, .external_lex_state = 2},
  [3032] = {.lex_state = 63, .external_lex_state = 3},
  [3033] = {.lex_state = 63, .external_lex_state = 3},
  [3034] = {.lex_state = 63, .external_lex_state = 3},
  [3035] = {.lex_state = 63, .external_lex_state = 2},
  [3036] = {.lex_state = 63, .external_lex_state = 3},
  [3037] = {.lex_state = 63, .external_lex_state = 2},
  [3038] = {.lex_state = 63, .external_lex_state = 3},
  [3039] = {.lex_state = 4, .external_lex_state = 3},
  [3040] = {.lex_state = 4, .external_lex_state = 3},
  [3041] = {.lex_state = 63, .external_lex_state = 2},
  [3042] = {.lex_state = 63, .external_lex_state = 2},
  [3043] = {.lex_state = 63, .external_lex_state = 3},
  [3044] = {.lex_state = 63, .external_lex_state = 2},
  [3045] = {.lex_state = 63, .external_lex_state = 2},
  [3046] = {.lex_state = 63, .external_lex_state = 2},
  [3047] = {.lex_state = 63, .external_lex_state = 2},
  [3048] = {.lex_state = 63, .external_lex_state = 2},
  [3049] = {.lex_state = 63, .external_lex_state = 2},
  [3050] = {.lex_state = 63, .external_lex_state = 3},
  [3051] = {.lex_state = 4, .external_lex_state = 3},
  [3052] = {.lex_state = 4, .external_lex_state = 3},
  [3053] = {.lex_state = 4, .external_lex_state = 3},
  [3054] = {.lex_state = 4, .external_lex_state = 3},
  [3055] = {.lex_state = 63, .external_lex_state = 3},
  [3056] = {.lex_state = 63, .external_lex_state = 3},
  [3057] = {.lex_state = 63, .external_lex_state = 3},
  [3058] = {.lex_state = 4, .external_lex_state = 3},
  [3059] = {.lex_state = 63, .external_lex_state = 3},
  [3060] = {.lex_state = 63, .external_lex_state = 3},
  [3061] = {.lex_state = 63, .external_lex_state = 3},
  [3062] = {.lex_state = 63, .external_lex_state = 3},
  [3063] = {.lex_state = 63, .external_lex_state = 3},
  [3064] = {.lex_state = 64, .external_lex_state = 5},
  [3065] = {.lex_state = 64, .external_lex_state = 5},
  [3066] = {.lex_state = 64, .external_lex_state = 5},
  [3067] = {.lex_state = 63, .external_lex_state = 3},
  [3068] = {.lex_state = 63, .external_lex_state = 3},
  [3069] = {.lex_state = 63, .external_lex_state = 3},
  [3070] = {.lex_state = 63, .external_lex_state = 3},
  [3071] = {.lex_state = 63, .external_lex_state = 3},
  [3072] = {.lex_state = 63, .external_lex_state = 3},
  [3073] = {.lex_state = 63, .external_lex_state = 3},
  [3074] = {.lex_state = 63, .external_lex_state = 3},
  [3075] = {.lex_state = 63, .external_lex_state = 3},
  [3076] = {.lex_state = 63, .external_lex_state = 3},
  [3077] = {.lex_state = 4, .external_lex_state = 3},
  [3078] = {.lex_state = 63, .external_lex_state = 3},
  [3079] = {.lex_state = 63, .external_lex_state = 2},
  [3080] = {.lex_state = 63, .external_lex_state = 3},
  [3081] = {.lex_state = 63, .external_lex_state = 3},
  [3082] = {.lex_state = 63, .external_lex_state = 3},
  [3083] = {.lex_state = 63, .external_lex_state = 3},
  [3084] = {.lex_state = 7, .external_lex_state = 3},
  [3085] = {.lex_state = 63, .external_lex_state = 3},
  [3086] = {.lex_state = 63, .external_lex_state = 3},
  [3087] = {.lex_state = 63, .external_lex_state = 3},
  [3088] = {.lex_state = 11},
  [3089] = {.lex_state = 64, .external_lex_state = 5},
  [3090] = {.lex_state = 64, .external_lex_state = 5},
  [3091] = {.lex_state = 64, .external_lex_state = 5},
  [3092] = {.lex_state = 4, .external_lex_state = 3},
  [3093] = {.lex_state = 64, .external_lex_state = 5},
  [3094] = {.lex_state = 64, .external_lex_state = 5},
  [3095] = {.lex_state = 11},
  [3096] = {.lex_state = 63, .external_lex_state = 3},
  [3097] = {.lex_state = 63, .external_lex_state = 3},
  [3098] = {.lex_state = 63, .external_lex_state = 3},
  [3099] = {.lex_state = 11},
  [3100] = {.lex_state = 63, .external_lex_state = 3},
  [3101] = {.lex_state = 63, .external_lex_state = 3},
  [3102] = {.lex_state = 63, .external_lex_state = 3},
  [3103] = {.lex_state = 63, .external_lex_state = 3},
  [3104] = {.lex_state = 63, .external_lex_state = 3},
  [3105] = {.lex_state = 63, .external_lex_state = 3},
  [3106] = {.lex_state = 63, .external_lex_state = 3},
  [3107] = {.lex_state = 63, .external_lex_state = 2},
  [3108] = {.lex_state = 4, .external_lex_state = 3},
  [3109] = {.lex_state = 63, .external_lex_state = 2},
  [3110] = {.lex_state = 64, .external_lex_state = 5},
  [3111] = {.lex_state = 64, .external_lex_state = 5},
  [3112] = {.lex_state = 64, .external_lex_state = 5},
  [3113] = {.lex_state = 63, .external_lex_state = 3},
  [3114] = {.lex_state = 63, .external_lex_state = 3},
  [3115] = {.lex_state = 63, .external_lex_state = 3},
  [3116] = {.lex_state = 63, .external_lex_state = 3},
  [3117] = {.lex_state = 63, .external_lex_state = 3},
  [3118] = {.lex_state = 63, .external_lex_state = 3},
  [3119] = {.lex_state = 63, .external_lex_state = 3},
  [3120] = {.lex_state = 11},
  [3121] = {.lex_state = 11},
  [3122] = {.lex_state = 4, .external_lex_state = 3},
  [3123] = {.lex_state = 63, .external_lex_state = 2},
  [3124] = {.lex_state = 4, .external_lex_state = 3},
  [3125] = {.lex_state = 4, .external_lex_state = 3},
  [3126] = {.lex_state = 4, .external_lex_state = 3},
  [3127] = {.lex_state = 4, .external_lex_state = 3},
  [3128] = {.lex_state = 63, .external_lex_state = 3},
  [3129] = {.lex_state = 4, .external_lex_state = 3},
  [3130] = {.lex_state = 4, .external_lex_state = 3},
  [3131] = {.lex_state = 63, .external_lex_state = 3},
  [3132] = {.lex_state = 4, .external_lex_state = 3},
  [3133] = {.lex_state = 4, .external_lex_state = 3},
  [3134] = {.lex_state = 4, .external_lex_state = 3},
  [3135] = {.lex_state = 4, .external_lex_state = 3},
  [3136] = {.lex_state = 4, .external_lex_state = 3},
  [3137] = {.lex_state = 64, .external_lex_state = 5},
  [3138] = {.lex_state = 63, .external_lex_state = 3},
  [3139] = {.lex_state = 64, .external_lex_state = 5},
  [3140] = {.lex_state = 64, .external_lex_state = 5},
  [3141] = {.lex_state = 4, .external_lex_state = 3},
  [3142] = {.lex_state = 4, .external_lex_state = 3},
  [3143] = {.lex_state = 4, .external_lex_state = 3},
  [3144] = {.lex_state = 4, .external_lex_state = 3},
  [3145] = {.lex_state = 4, .external_lex_state = 3},
  [3146] = {.lex_state = 11},
  [3147] = {.lex_state = 4, .external_lex_state = 3},
  [3148] = {.lex_state = 4, .external_lex_state = 3},
  [3149] = {.lex_state = 4, .external_lex_state = 3},
  [3150] = {.lex_state = 63, .external_lex_state = 3},
  [3151] = {.lex_state = 63, .external_lex_state = 2},
  [3152] = {.lex_state = 4, .external_lex_state = 3},
  [3153] = {.lex_state = 4, .external_lex_state = 3},
  [3154] = {.lex_state = 4, .external_lex_state = 3},
  [3155] = {.lex_state = 4, .external_lex_state = 3},
  [3156] = {.lex_state = 4, .external_lex_state = 3},
  [3157] = {.lex_state = 4, .external_lex_state = 3},
  [3158] = {.lex_state = 4, .external_lex_state = 3},
  [3159] = {.lex_state = 4, .external_lex_state = 3},
  [3160] = {.lex_state = 4, .external_lex_state = 3},
  [3161] = {.lex_state = 4, .external_lex_state = 3},
  [3162] = {.lex_state = 4, .external_lex_state = 3},
  [3163] = {.lex_state = 4, .external_lex_state = 3},
  [3164] = {.lex_state = 4, .external_lex_state = 3},
  [3165] = {.lex_state = 4, .external_lex_state = 3},
  [3166] = {.lex_state = 4, .external_lex_state = 3},
  [3167] = {.lex_state = 4, .external_lex_state = 3},
  [3168] = {.lex_state = 4, .external_lex_state = 3},
  [3169] = {.lex_state = 4, .external_lex_state = 3},
  [3170] = {.lex_state = 4, .external_lex_state = 3},
  [3171] = {.lex_state = 63, .external_lex_state = 3},
  [3172] = {.lex_state = 4, .external_lex_state = 3},
  [3173] = {.lex_state = 4, .external_lex_state = 3},
  [3174] = {.lex_state = 63, .external_lex_state = 3},
  [3175] = {.lex_state = 4, .external_lex_state = 3},
  [3176] = {.lex_state = 4, .external_lex_state = 3},
  [3177] = {.lex_state = 64, .external_lex_state = 5},
  [3178] = {.lex_state = 4, .external_lex_state = 3},
  [3179] = {.lex_state = 4, .external_lex_state = 3},
  [3180] = {.lex_state = 4, .external_lex_state = 3},
  [3181] = {.lex_state = 4, .external_lex_state = 3},
  [3182] = {.lex_state = 4, .external_lex_state = 3},
  [3183] = {.lex_state = 4, .external_lex_state = 3},
  [3184] = {.lex_state = 11},
  [3185] = {.lex_state = 4, .external_lex_state = 3},
  [3186] = {.lex_state = 4, .external_lex_state = 3},
  [3187] = {.lex_state = 4, .external_lex_state = 3},
  [3188] = {.lex_state = 4, .external_lex_state = 3},
  [3189] = {.lex_state = 4, .external_lex_state = 3},
  [3190] = {.lex_state = 4, .external_lex_state = 3},
  [3191] = {.lex_state = 63, .external_lex_state = 3},
  [3192] = {.lex_state = 63, .external_lex_state = 3},
  [3193] = {.lex_state = 11},
  [3194] = {.lex_state = 63, .external_lex_state = 3},
  [3195] = {.lex_state = 63, .external_lex_state = 3},
  [3196] = {.lex_state = 63, .external_lex_state = 3},
  [3197] = {.lex_state = 63, .external_lex_state = 3},
  [3198] = {.lex_state = 63, .external_lex_state = 3},
  [3199] = {.lex_state = 63, .external_lex_state = 3},
  [3200] = {.lex_state = 4, .external_lex_state = 3},
  [3201] = {.lex_state = 63, .external_lex_state = 3},
  [3202] = {.lex_state = 4, .external_lex_state = 3},
  [3203] = {.lex_state = 4, .external_lex_state = 3},
  [3204] = {.lex_state = 4, .external_lex_state = 3},
  [3205] = {.lex_state = 4, .external_lex_state = 3},
  [3206] = {.lex_state = 63, .external_lex_state = 3},
  [3207] = {.lex_state = 11},
  [3208] = {.lex_state = 4, .external_lex_state = 3},
  [3209] = {.lex_state = 63, .external_lex_state = 3},
  [3210] = {.lex_state = 4, .external_lex_state = 3},
  [3211] = {.lex_state = 63, .external_lex_state = 3},
  [3212] = {.lex_state = 63, .external_lex_state = 3},
  [3213] = {.lex_state = 63, .external_lex_state = 3},
  [3214] = {.lex_state = 4, .external_lex_state = 3},
  [3215] = {.lex_state = 63, .external_lex_state = 3},
  [3216] = {.lex_state = 4, .external_lex_state = 3},
  [3217] = {.lex_state = 63, .external_lex_state = 3},
  [3218] = {.lex_state = 63, .external_lex_state = 3},
  [3219] = {.lex_state = 63, .external_lex_state = 3},
  [3220] = {.lex_state = 4, .external_lex_state = 3},
  [3221] = {.lex_state = 4, .external_lex_state = 3},
  [3222] = {.lex_state = 4, .external_lex_state = 3},
  [3223] = {.lex_state = 4, .external_lex_state = 3},
  [3224] = {.lex_state = 4, .external_lex_state = 3},
  [3225] = {.lex_state = 64, .external_lex_state = 5},
  [3226] = {.lex_state = 64, .external_lex_state = 5},
  [3227] = {.lex_state = 64, .external_lex_state = 5},
  [3228] = {.lex_state = 4, .external_lex_state = 3},
  [3229] = {.lex_state = 63, .external_lex_state = 3},
  [3230] = {.lex_state = 63, .external_lex_state = 3},
  [3231] = {.lex_state = 4, .external_lex_state = 3},
  [3232] = {.lex_state = 63, .external_lex_state = 2},
  [3233] = {.lex_state = 4, .external_lex_state = 3},
  [3234] = {.lex_state = 63, .external_lex_state = 3},
  [3235] = {.lex_state = 64, .external_lex_state = 5},
  [3236] = {.lex_state = 63, .external_lex_state = 2},
  [3237] = {.lex_state = 4, .external_lex_state = 3},
  [3238] = {.lex_state = 63, .external_lex_state = 3},
  [3239] = {.lex_state = 64, .external_lex_state = 5},
  [3240] = {.lex_state = 64, .external_lex_state = 5},
  [3241] = {.lex_state = 63, .external_lex_state = 3},
  [3242] = {.lex_state = 4, .external_lex_state = 3},
  [3243] = {.lex_state = 63, .external_lex_state = 3},
  [3244] = {.lex_state = 63, .external_lex_state = 3},
  [3245] = {.lex_state = 63, .external_lex_state = 3},
  [3246] = {.lex_state = 63, .external_lex_state = 3},
  [3247] = {.lex_state = 63, .external_lex_state = 3},
  [3248] = {.lex_state = 63, .external_lex_state = 3},
  [3249] = {.lex_state = 63, .external_lex_state = 3},
  [3250] = {.lex_state = 63, .external_lex_state = 3},
  [3251] = {.lex_state = 4, .external_lex_state = 3},
  [3252] = {.lex_state = 63, .external_lex_state = 3},
  [3253] = {.lex_state = 63, .external_lex_state = 3},
  [3254] = {.lex_state = 63, .external_lex_state = 3},
  [3255] = {.lex_state = 63, .external_lex_state = 3},
  [3256] = {.lex_state = 63, .external_lex_state = 3},
  [3257] = {.lex_state = 63, .external_lex_state = 3},
  [3258] = {.lex_state = 11},
  [3259] = {.lex_state = 63, .external_lex_state = 3},
  [3260] = {.lex_state = 63, .external_lex_state = 3},
  [3261] = {.lex_state = 63, .external_lex_state = 3},
  [3262] = {.lex_state = 63, .external_lex_state = 3},
  [3263] = {.lex_state = 4, .external_lex_state = 3},
  [3264] = {.lex_state = 4, .external_lex_state = 3},
  [3265] = {.lex_state = 4, .external_lex_state = 3},
  [3266] = {.lex_state = 63, .external_lex_state = 3},
  [3267] = {.lex_state = 4, .external_lex_state = 3},
  [3268] = {.lex_state = 63, .external_lex_state = 3},
  [3269] = {.lex_state = 63, .external_lex_state = 3},
  [3270] = {.lex_state = 63, .external_lex_state = 3},
  [3271] = {.lex_state = 63, .external_lex_state = 3},
  [3272] = {.lex_state = 63, .external_lex_state = 3},
  [3273] = {.lex_state = 63, .external_lex_state = 3},
  [3274] = {.lex_state = 63, .external_lex_state = 3},
  [3275] = {.lex_state = 63, .external_lex_state = 3},
  [3276] = {.lex_state = 63, .external_lex_state = 3},
  [3277] = {.lex_state = 63, .external_lex_state = 3},
  [3278] = {.lex_state = 4, .external_lex_state = 3},
  [3279] = {.lex_state = 63, .external_lex_state = 3},
  [3280] = {.lex_state = 4, .external_lex_state = 3},
  [3281] = {.lex_state = 4, .external_lex_state = 3},
  [3282] = {.lex_state = 63, .external_lex_state = 3},
  [3283] = {.lex_state = 4, .external_lex_state = 3},
  [3284] = {.lex_state = 4, .external_lex_state = 3},
  [3285] = {.lex_state = 4, .external_lex_state = 3},
  [3286] = {.lex_state = 63, .external_lex_state = 3},
  [3287] = {.lex_state = 63, .external_lex_state = 3},
  [3288] = {.lex_state = 63, .external_lex_state = 3},
  [3289] = {.lex_state = 11},
  [3290] = {.lex_state = 63, .external_lex_state = 3},
  [3291] = {.lex_state = 63, .external_lex_state = 3},
  [3292] = {.lex_state = 63, .external_lex_state = 3},
  [3293] = {.lex_state = 4, .external_lex_state = 3},
  [3294] = {.lex_state = 64, .external_lex_state = 5},
  [3295] = {.lex_state = 64, .external_lex_state = 5},
  [3296] = {.lex_state = 64, .external_lex_state = 5},
  [3297] = {.lex_state = 63, .external_lex_state = 3},
  [3298] = {.lex_state = 63, .external_lex_state = 3},
  [3299] = {.lex_state = 4, .external_lex_state = 3},
  [3300] = {.lex_state = 4, .external_lex_state = 3},
  [3301] = {.lex_state = 4, .external_lex_state = 3},
  [3302] = {.lex_state = 4, .external_lex_state = 3},
  [3303] = {.lex_state = 4, .external_lex_state = 3},
  [3304] = {.lex_state = 63, .external_lex_state = 3},
  [3305] = {.lex_state = 4, .external_lex_state = 3},
  [3306] = {.lex_state = 4, .external_lex_state = 3},
  [3307] = {.lex_state = 4, .external_lex_state = 3},
  [3308] = {.lex_state = 11},
  [3309] = {.lex_state = 4, .external_lex_state = 3},
  [3310] = {.lex_state = 4, .external_lex_state = 3},
  [3311] = {.lex_state = 4, .external_lex_state = 3},
  [3312] = {.lex_state = 4, .external_lex_state = 3},
  [3313] = {.lex_state = 5, .external_lex_state = 3},
  [3314] = {.lex_state = 63, .external_lex_state = 3},
  [3315] = {.lex_state = 4, .external_lex_state = 3},
  [3316] = {.lex_state = 63, .external_lex_state = 3},
  [3317] = {.lex_state = 63, .external_lex_state = 3},
  [3318] = {.lex_state = 11},
  [3319] = {.lex_state = 63, .external_lex_state = 3},
  [3320] = {.lex_state = 4, .external_lex_state = 3},
  [3321] = {.lex_state = 4, .external_lex_state = 3},
  [3322] = {.lex_state = 4, .external_lex_state = 3},
  [3323] = {.lex_state = 4, .external_lex_state = 3},
  [3324] = {.lex_state = 4, .external_lex_state = 3},
  [3325] = {.lex_state = 63, .external_lex_state = 3},
  [3326] = {.lex_state = 63, .external_lex_state = 3},
  [3327] = {.lex_state = 4, .external_lex_state = 3},
  [3328] = {.lex_state = 11},
  [3329] = {.lex_state = 63, .external_lex_state = 3},
  [3330] = {.lex_state = 4, .external_lex_state = 3},
  [3331] = {.lex_state = 64, .external_lex_state = 5},
  [3332] = {.lex_state = 64, .external_lex_state = 5},
  [3333] = {.lex_state = 11},
  [3334] = {.lex_state = 64, .external_lex_state = 5},
  [3335] = {.lex_state = 64, .external_lex_state = 5},
  [3336] = {.lex_state = 64, .external_lex_state = 5},
  [3337] = {.lex_state = 63, .external_lex_state = 2},
  [3338] = {.lex_state = 63, .external_lex_state = 3},
  [3339] = {.lex_state = 64, .external_lex_state = 5},
  [3340] = {.lex_state = 63, .external_lex_state = 3},
  [3341] = {.lex_state = 63, .external_lex_state = 3},
  [3342] = {.lex_state = 64, .external_lex_state = 5},
  [3343] = {.lex_state = 63, .external_lex_state = 3},
  [3344] = {.lex_state = 63, .external_lex_state = 2},
  [3345] = {.lex_state = 64, .external_lex_state = 5},
  [3346] = {.lex_state = 63, .external_lex_state = 2},
  [3347] = {.lex_state = 64, .external_lex_state = 5},
  [3348] = {.lex_state = 64, .external_lex_state = 5},
  [3349] = {.lex_state = 64, .external_lex_state = 5},
  [3350] = {.lex_state = 64, .external_lex_state = 5},
  [3351] = {.lex_state = 63, .external_lex_state = 3},
  [3352] = {.lex_state = 63, .external_lex_state = 3},
  [3353] = {.lex_state = 64, .external_lex_state = 5},
  [3354] = {.lex_state = 63, .external_lex_state = 3},
  [3355] = {.lex_state = 63, .external_lex_state = 2},
  [3356] = {.lex_state = 63, .external_lex_state = 3},
  [3357] = {.lex_state = 63, .external_lex_state = 2},
  [3358] = {.lex_state = 63, .external_lex_state = 3},
  [3359] = {.lex_state = 63, .external_lex_state = 3},
  [3360] = {.lex_state = 63, .external_lex_state = 2},
  [3361] = {.lex_state = 64, .external_lex_state = 5},
  [3362] = {.lex_state = 63, .external_lex_state = 3},
  [3363] = {.lex_state = 63, .external_lex_state = 3},
  [3364] = {.lex_state = 63, .external_lex_state = 3},
  [3365] = {.lex_state = 63, .external_lex_state = 3},
  [3366] = {.lex_state = 63, .external_lex_state = 3},
  [3367] = {.lex_state = 63, .external_lex_state = 3},
  [3368] = {.lex_state = 63, .external_lex_state = 3},
  [3369] = {.lex_state = 63, .external_lex_state = 3},
  [3370] = {.lex_state = 63, .external_lex_state = 3},
  [3371] = {.lex_state = 63, .external_lex_state = 3},
  [3372] = {.lex_state = 63, .external_lex_state = 3},
  [3373] = {.lex_state = 63, .external_lex_state = 2},
  [3374] = {.lex_state = 64, .external_lex_state = 5},
  [3375] = {.lex_state = 63, .external_lex_state = 3},
  [3376] = {.lex_state = 63, .external_lex_state = 3},
  [3377] = {.lex_state = 63, .external_lex_state = 3},
  [3378] = {.lex_state = 63, .external_lex_state = 2},
  [3379] = {.lex_state = 63, .external_lex_state = 3},
  [3380] = {.lex_state = 63, .external_lex_state = 3},
  [3381] = {.lex_state = 64},
  [3382] = {.lex_state = 63, .external_lex_state = 3},
  [3383] = {.lex_state = 64, .external_lex_state = 5},
  [3384] = {.lex_state = 63, .external_lex_state = 3},
  [3385] = {.lex_state = 63, .external_lex_state = 3},
  [3386] = {.lex_state = 63, .external_lex_state = 3},
  [3387] = {.lex_state = 64},
  [3388] = {.lex_state = 63, .external_lex_state = 3},
  [3389] = {.lex_state = 63, .external_lex_state = 3},
  [3390] = {.lex_state = 63, .external_lex_state = 3},
  [3391] = {.lex_state = 64, .external_lex_state = 5},
  [3392] = {.lex_state = 63, .external_lex_state = 3},
  [3393] = {.lex_state = 64, .external_lex_state = 5},
  [3394] = {.lex_state = 64, .external_lex_state = 5},
  [3395] = {.lex_state = 64, .external_lex_state = 5},
  [3396] = {.lex_state = 63, .external_lex_state = 3},
  [3397] = {.lex_state = 64},
  [3398] = {.lex_state = 64},
  [3399] = {.lex_state = 64},
  [3400] = {.lex_state = 64},
  [3401] = {.lex_state = 64},
  [3402] = {.lex_state = 64},
  [3403] = {.lex_state = 64, .external_lex_state = 5},
  [3404] = {.lex_state = 64, .external_lex_state = 5},
  [3405] = {.lex_state = 64, .external_lex_state = 5},
  [3406] = {.lex_state = 64, .external_lex_state = 5},
  [3407] = {.lex_state = 64},
  [3408] = {.lex_state = 63, .external_lex_state = 3},
  [3409] = {.lex_state = 64},
  [3410] = {.lex_state = 64, .external_lex_state = 5},
  [3411] = {.lex_state = 63, .external_lex_state = 3},
  [3412] = {.lex_state = 63, .external_lex_state = 3},
  [3413] = {.lex_state = 64},
  [3414] = {.lex_state = 63, .external_lex_state = 3},
  [3415] = {.lex_state = 63, .external_lex_state = 3},
  [3416] = {.lex_state = 63, .external_lex_state = 3},
  [3417] = {.lex_state = 63, .external_lex_state = 3},
  [3418] = {.lex_state = 63, .external_lex_state = 3},
  [3419] = {.lex_state = 64},
  [3420] = {.lex_state = 64},
  [3421] = {.lex_state = 64, .external_lex_state = 5},
  [3422] = {.lex_state = 64, .external_lex_state = 5},
  [3423] = {.lex_state = 64},
  [3424] = {.lex_state = 64},
  [3425] = {.lex_state = 64, .external_lex_state = 5},
  [3426] = {.lex_state = 64, .external_lex_state = 5},
  [3427] = {.lex_state = 64, .external_lex_state = 5},
  [3428] = {.lex_state = 64, .external_lex_state = 5},
  [3429] = {.lex_state = 64, .external_lex_state = 5},
  [3430] = {.lex_state = 64, .external_lex_state = 5},
  [3431] = {.lex_state = 64, .external_lex_state = 5},
  [3432] = {.lex_state = 64, .external_lex_state = 5},
  [3433] = {.lex_state = 64, .external_lex_state = 5},
  [3434] = {.lex_state = 64, .external_lex_state = 5},
  [3435] = {.lex_state = 64},
  [3436] = {.lex_state = 64},
  [3437] = {.lex_state = 64},
  [3438] = {.lex_state = 64, .external_lex_state = 5},
  [3439] = {.lex_state = 64, .external_lex_state = 5},
  [3440] = {.lex_state = 64, .external_lex_state = 5},
  [3441] = {.lex_state = 64},
  [3442] = {.lex_state = 64},
  [3443] = {.lex_state = 64, .external_lex_state = 5},
  [3444] = {.lex_state = 64},
  [3445] = {.lex_state = 64},
  [3446] = {.lex_state = 64, .external_lex_state = 5},
  [3447] = {.lex_state = 64},
  [3448] = {.lex_state = 64},
  [3449] = {.lex_state = 64},
  [3450] = {.lex_state = 64},
  [3451] = {.lex_state = 64},
  [3452] = {.lex_state = 64},
  [3453] = {.lex_state = 64},
  [3454] = {.lex_state = 64},
  [3455] = {.lex_state = 64},
  [3456] = {.lex_state = 64},
  [3457] = {.lex_state = 64, .external_lex_state = 5},
  [3458] = {.lex_state = 64},
  [3459] = {.lex_state = 64, .external_lex_state = 5},
  [3460] = {.lex_state = 64, .external_lex_state = 5},
  [3461] = {.lex_state = 64},
  [3462] = {.lex_state = 64, .external_lex_state = 5},
  [3463] = {.lex_state = 64, .external_lex_state = 5},
  [3464] = {.lex_state = 64},
  [3465] = {.lex_state = 64},
  [3466] = {.lex_state = 64, .external_lex_state = 5},
  [3467] = {.lex_state = 64},
  [3468] = {.lex_state = 64},
  [3469] = {.lex_state = 64, .external_lex_state = 5},
  [3470] = {.lex_state = 64},
  [3471] = {.lex_state = 64},
  [3472] = {.lex_state = 64, .external_lex_state = 5},
  [3473] = {.lex_state = 64},
  [3474] = {.lex_state = 64},
  [3475] = {.lex_state = 64},
  [3476] = {.lex_state = 64, .external_lex_state = 5},
  [3477] = {.lex_state = 64, .external_lex_state = 5},
  [3478] = {.lex_state = 64},
  [3479] = {.lex_state = 64, .external_lex_state = 5},
  [3480] = {.lex_state = 64, .external_lex_state = 5},
  [3481] = {.lex_state = 64, .external_lex_state = 5},
  [3482] = {.lex_state = 64, .external_lex_state = 5},
  [3483] = {.lex_state = 64, .external_lex_state = 5},
  [3484] = {.lex_state = 64, .external_lex_state = 5},
  [3485] = {.lex_state = 64, .external_lex_state = 5},
  [3486] = {.lex_state = 64, .external_lex_state = 5},
  [3487] = {.lex_state = 64},
  [3488] = {.lex_state = 64},
  [3489] = {.lex_state = 64, .external_lex_state = 5},
  [3490] = {.lex_state = 64},
  [3491] = {.lex_state = 64, .external_lex_state = 5},
  [3492] = {.lex_state = 64, .external_lex_state = 5},
  [3493] = {.lex_state = 64},
  [3494] = {.lex_state = 64},
  [3495] = {.lex_state = 64, .external_lex_state = 5},
  [3496] = {.lex_state = 64, .external_lex_state = 5},
  [3497] = {.lex_state = 64},
  [3498] = {.lex_state = 64},
  [3499] = {.lex_state = 13},
  [3500] = {.lex_state = 64, .external_lex_state = 5},
  [3501] = {.lex_state = 64, .external_lex_state = 5},
  [3502] = {.lex_state = 64},
  [3503] = {.lex_state = 64},
  [3504] = {.lex_state = 64},
  [3505] = {.lex_state = 64, .external_lex_state = 5},
  [3506] = {.lex_state = 64, .external_lex_state = 5},
  [3507] = {.lex_state = 64, .external_lex_state = 5},
  [3508] = {.lex_state = 64, .external_lex_state = 5},
  [3509] = {.lex_state = 64, .external_lex_state = 5},
  [3510] = {.lex_state = 64},
  [3511] = {.lex_state = 64, .external_lex_state = 5},
  [3512] = {.lex_state = 64},
  [3513] = {.lex_state = 64, .external_lex_state = 5},
  [3514] = {.lex_state = 64},
  [3515] = {.lex_state = 64, .external_lex_state = 5},
  [3516] = {.lex_state = 64, .external_lex_state = 5},
  [3517] = {.lex_state = 64},
  [3518] = {.lex_state = 64, .external_lex_state = 5},
  [3519] = {.lex_state = 64, .external_lex_state = 5},
  [3520] = {.lex_state = 64, .external_lex_state = 5},
  [3521] = {.lex_state = 13},
  [3522] = {.lex_state = 64},
  [3523] = {.lex_state = 64, .external_lex_state = 5},
  [3524] = {.lex_state = 64},
  [3525] = {.lex_state = 64},
  [3526] = {.lex_state = 64},
  [3527] = {.lex_state = 64},
  [3528] = {.lex_state = 64},
  [3529] = {.lex_state = 64, .external_lex_state = 5},
  [3530] = {.lex_state = 64, .external_lex_state = 5},
  [3531] = {.lex_state = 64, .external_lex_state = 5},
  [3532] = {.lex_state = 64},
  [3533] = {.lex_state = 64},
  [3534] = {.lex_state = 64},
  [3535] = {.lex_state = 64},
  [3536] = {.lex_state = 64},
  [3537] = {.lex_state = 64},
  [3538] = {.lex_state = 64},
  [3539] = {.lex_state = 64},
  [3540] = {.lex_state = 64},
  [3541] = {.lex_state = 64},
  [3542] = {.lex_state = 64},
  [3543] = {.lex_state = 64},
  [3544] = {.lex_state = 64},
  [3545] = {.lex_state = 64},
  [3546] = {.lex_state = 64},
  [3547] = {.lex_state = 64},
  [3548] = {.lex_state = 64},
  [3549] = {.lex_state = 64},
  [3550] = {.lex_state = 64},
  [3551] = {.lex_state = 64},
  [3552] = {.lex_state = 13},
  [3553] = {.lex_state = 64},
  [3554] = {.lex_state = 13},
  [3555] = {.lex_state = 64},
  [3556] = {.lex_state = 13},
  [3557] = {.lex_state = 13},
  [3558] = {.lex_state = 13},
  [3559] = {.lex_state = 64},
  [3560] = {.lex_state = 64},
  [3561] = {.lex_state = 64},
  [3562] = {.lex_state = 11, .external_lex_state = 5},
  [3563] = {.lex_state = 64},
  [3564] = {.lex_state = 11, .external_lex_state = 5},
  [3565] = {.lex_state = 11, .external_lex_state = 5},
  [3566] = {.lex_state = 11, .external_lex_state = 5},
  [3567] = {.lex_state = 11, .external_lex_state = 5},
  [3568] = {.lex_state = 11, .external_lex_state = 5},
  [3569] = {.lex_state = 11, .external_lex_state = 5},
  [3570] = {.lex_state = 64},
  [3571] = {.lex_state = 64},
  [3572] = {.lex_state = 11, .external_lex_state = 5},
  [3573] = {.lex_state = 64},
  [3574] = {.lex_state = 11, .external_lex_state = 5},
  [3575] = {.lex_state = 64},
  [3576] = {.lex_state = 64},
  [3577] = {.lex_state = 11, .external_lex_state = 5},
  [3578] = {.lex_state = 64},
  [3579] = {.lex_state = 11, .external_lex_state = 5},
  [3580] = {.lex_state = 11, .external_lex_state = 5},
  [3581] = {.lex_state = 64},
  [3582] = {.lex_state = 11, .external_lex_state = 5},
  [3583] = {.lex_state = 11, .external_lex_state = 5},
  [3584] = {.lex_state = 11, .external_lex_state = 5},
  [3585] = {.lex_state = 11, .external_lex_state = 5},
  [3586] = {.lex_state = 11, .external_lex_state = 5},
  [3587] = {.lex_state = 64},
  [3588] = {.lex_state = 64},
  [3589] = {.lex_state = 64},
  [3590] = {.lex_state = 64},
  [3591] = {.lex_state = 64},
  [3592] = {.lex_state = 64},
  [3593] = {.lex_state = 64},
  [3594] = {.lex_state = 64},
  [3595] = {.lex_state = 64},
  [3596] = {.lex_state = 64},
  [3597] = {.lex_state = 64},
  [3598] = {.lex_state = 64},
  [3599] = {.lex_state = 64},
  [3600] = {.lex_state = 64},
  [3601] = {.lex_state = 64},
  [3602] = {.lex_state = 64},
  [3603] = {.lex_state = 64},
  [3604] = {.lex_state = 64},
  [3605] = {.lex_state = 64},
  [3606] = {.lex_state = 64},
  [3607] = {.lex_state = 64},
  [3608] = {.lex_state = 11},
  [3609] = {.lex_state = 64},
  [3610] = {.lex_state = 64},
  [3611] = {.lex_state = 64},
  [3612] = {.lex_state = 64},
  [3613] = {.lex_state = 64},
  [3614] = {.lex_state = 64},
  [3615] = {.lex_state = 64},
  [3616] = {.lex_state = 64},
  [3617] = {.lex_state = 64},
  [3618] = {.lex_state = 64},
  [3619] = {.lex_state = 64},
  [3620] = {.lex_state = 64},
  [3621] = {.lex_state = 64},
  [3622] = {.lex_state = 64},
  [3623] = {.lex_state = 64},
  [3624] = {.lex_state = 64},
  [3625] = {.lex_state = 64},
  [3626] = {.lex_state = 64},
  [3627] = {.lex_state = 64},
  [3628] = {.lex_state = 64},
  [3629] = {.lex_state = 64},
  [3630] = {.lex_state = 64},
  [3631] = {.lex_state = 64},
  [3632] = {.lex_state = 64},
  [3633] = {.lex_state = 64},
  [3634] = {.lex_state = 64},
  [3635] = {.lex_state = 64},
  [3636] = {.lex_state = 64},
  [3637] = {.lex_state = 64},
  [3638] = {.lex_state = 64},
  [3639] = {.lex_state = 64},
  [3640] = {.lex_state = 64},
  [3641] = {.lex_state = 64},
  [3642] = {.lex_state = 64},
  [3643] = {.lex_state = 64},
  [3644] = {.lex_state = 64},
  [3645] = {.lex_state = 64},
  [3646] = {.lex_state = 64},
  [3647] = {.lex_state = 64},
  [3648] = {.lex_state = 64},
  [3649] = {.lex_state = 64},
  [3650] = {.lex_state = 64},
  [3651] = {.lex_state = 64},
  [3652] = {.lex_state = 64},
  [3653] = {.lex_state = 64},
  [3654] = {.lex_state = 64, .external_lex_state = 5},
  [3655] = {.lex_state = 64},
  [3656] = {.lex_state = 64, .external_lex_state = 5},
  [3657] = {.lex_state = 64},
  [3658] = {.lex_state = 64},
  [3659] = {.lex_state = 2},
  [3660] = {.lex_state = 64},
  [3661] = {.lex_state = 2},
  [3662] = {.lex_state = 2},
  [3663] = {.lex_state = 2},
  [3664] = {.lex_state = 2},
  [3665] = {.lex_state = 2},
  [3666] = {.lex_state = 2},
  [3667] = {.lex_state = 2},
  [3668] = {.lex_state = 2},
  [3669] = {.lex_state = 2},
  [3670] = {.lex_state = 2},
  [3671] = {.lex_state = 2},
  [3672] = {.lex_state = 2},
  [3673] = {.lex_state = 2},
  [3674] = {.lex_state = 2},
  [3675] = {.lex_state = 2},
  [3676] = {.lex_state = 2},
  [3677] = {.lex_state = 2},
  [3678] = {.lex_state = 2},
  [3679] = {.lex_state = 2},
  [3680] = {.lex_state = 64, .external_lex_state = 5},
  [3681] = {.lex_state = 64},
  [3682] = {.lex_state = 64, .external_lex_state = 5},
  [3683] = {.lex_state = 64, .external_lex_state = 5},
  [3684] = {.lex_state = 64},
  [3685] = {.lex_state = 64, .external_lex_state = 5},
  [3686] = {.lex_state = 64, .external_lex_state = 5},
  [3687] = {.lex_state = 64, .external_lex_state = 5},
  [3688] = {.lex_state = 64, .external_lex_state = 5},
  [3689] = {.lex_state = 64, .external_lex_state = 5},
  [3690] = {.lex_state = 64, .external_lex_state = 5},
  [3691] = {.lex_state = 64},
  [3692] = {.lex_state = 64, .external_lex_state = 5},
  [3693] = {.lex_state = 64, .external_lex_state = 5},
  [3694] = {.lex_state = 64},
  [3695] = {.lex_state = 64},
  [3696] = {.lex_state = 64, .external_lex_state = 5},
  [3697] = {.lex_state = 64},
  [3698] = {.lex_state = 64, .external_lex_state = 5},
  [3699] = {.lex_state = 64},
  [3700] = {.lex_state = 64},
  [3701] = {.lex_state = 64},
  [3702] = {.lex_state = 64, .external_lex_state = 5},
  [3703] = {.lex_state = 64, .external_lex_state = 5},
  [3704] = {.lex_state = 64},
  [3705] = {.lex_state = 64},
  [3706] = {.lex_state = 64, .external_lex_state = 5},
  [3707] = {.lex_state = 64},
  [3708] = {.lex_state = 64},
  [3709] = {.lex_state = 64, .external_lex_state = 5},
  [3710] = {.lex_state = 64},
  [3711] = {.lex_state = 64},
  [3712] = {.lex_state = 64},
  [3713] = {.lex_state = 64},
  [3714] = {.lex_state = 64},
  [3715] = {.lex_state = 64},
  [3716] = {.lex_state = 64},
  [3717] = {.lex_state = 64, .external_lex_state = 5},
  [3718] = {.lex_state = 64, .external_lex_state = 5},
  [3719] = {.lex_state = 64},
  [3720] = {.lex_state = 64},
  [3721] = {.lex_state = 64},
  [3722] = {.lex_state = 64},
  [3723] = {.lex_state = 64, .external_lex_state = 5},
  [3724] = {.lex_state = 64},
  [3725] = {.lex_state = 64, .external_lex_state = 5},
  [3726] = {.lex_state = 64},
  [3727] = {.lex_state = 64, .external_lex_state = 5},
  [3728] = {.lex_state = 64, .external_lex_state = 5},
  [3729] = {.lex_state = 64, .external_lex_state = 5},
  [3730] = {.lex_state = 64, .external_lex_state = 5},
  [3731] = {.lex_state = 64, .external_lex_state = 5},
  [3732] = {.lex_state = 64, .external_lex_state = 5},
  [3733] = {.lex_state = 64, .external_lex_state = 5},
  [3734] = {.lex_state = 64, .external_lex_state = 5},
  [3735] = {.lex_state = 64, .external_lex_state = 5},
  [3736] = {.lex_state = 64, .external_lex_state = 5},
  [3737] = {.lex_state = 64, .external_lex_state = 5},
  [3738] = {.lex_state = 64, .external_lex_state = 5},
  [3739] = {.lex_state = 64, .external_lex_state = 5},
  [3740] = {.lex_state = 64},
  [3741] = {.lex_state = 64, .external_lex_state = 5},
  [3742] = {.lex_state = 64, .external_lex_state = 5},
  [3743] = {.lex_state = 64, .external_lex_state = 5},
  [3744] = {.lex_state = 64, .external_lex_state = 5},
  [3745] = {.lex_state = 64, .external_lex_state = 5},
  [3746] = {.lex_state = 64},
  [3747] = {.lex_state = 64, .external_lex_state = 5},
  [3748] = {.lex_state = 64, .external_lex_state = 5},
  [3749] = {.lex_state = 64, .external_lex_state = 5},
  [3750] = {.lex_state = 64, .external_lex_state = 6},
  [3751] = {.lex_state = 64, .external_lex_state = 5},
  [3752] = {.lex_state = 64, .external_lex_state = 5},
  [3753] = {.lex_state = 64, .external_lex_state = 5},
  [3754] = {.lex_state = 64, .external_lex_state = 5},
  [3755] = {.lex_state = 64, .external_lex_state = 5},
  [3756] = {.lex_state = 64},
  [3757] = {.lex_state = 64},
  [3758] = {.lex_state = 64, .external_lex_state = 5},
  [3759] = {.lex_state = 64, .external_lex_state = 6},
  [3760] = {.lex_state = 64, .external_lex_state = 5},
  [3761] = {.lex_state = 64},
  [3762] = {.lex_state = 64, .external_lex_state = 5},
  [3763] = {.lex_state = 64, .external_lex_state = 5},
  [3764] = {.lex_state = 64},
  [3765] = {.lex_state = 64, .external_lex_state = 5},
  [3766] = {.lex_state = 64},
  [3767] = {.lex_state = 64},
  [3768] = {.lex_state = 64, .external_lex_state = 5},
  [3769] = {.lex_state = 64, .external_lex_state = 5},
  [3770] = {.lex_state = 64, .external_lex_state = 5},
  [3771] = {.lex_state = 64, .external_lex_state = 5},
  [3772] = {.lex_state = 64, .external_lex_state = 6},
  [3773] = {.lex_state = 64, .external_lex_state = 5},
  [3774] = {.lex_state = 64, .external_lex_state = 5},
  [3775] = {.lex_state = 64, .external_lex_state = 5},
  [3776] = {.lex_state = 64, .external_lex_state = 5},
  [3777] = {.lex_state = 64, .external_lex_state = 5},
  [3778] = {.lex_state = 64, .external_lex_state = 5},
  [3779] = {.lex_state = 64, .external_lex_state = 5},
  [3780] = {.lex_state = 64, .external_lex_state = 5},
  [3781] = {.lex_state = 64, .external_lex_state = 5},
  [3782] = {.lex_state = 64, .external_lex_state = 5},
  [3783] = {.lex_state = 64, .external_lex_state = 5},
  [3784] = {.lex_state = 64, .external_lex_state = 5},
  [3785] = {.lex_state = 64, .external_lex_state = 5},
  [3786] = {.lex_state = 64, .external_lex_state = 5},
  [3787] = {.lex_state = 64, .external_lex_state = 5},
  [3788] = {.lex_state = 64, .external_lex_state = 5},
  [3789] = {.lex_state = 64, .external_lex_state = 5},
  [3790] = {.lex_state = 64, .external_lex_state = 5},
  [3791] = {.lex_state = 64, .external_lex_state = 5},
  [3792] = {.lex_state = 64, .external_lex_state = 5},
  [3793] = {.lex_state = 64, .external_lex_state = 5},
  [3794] = {.lex_state = 64, .external_lex_state = 5},
  [3795] = {.lex_state = 64, .external_lex_state = 5},
  [3796] = {.lex_state = 64, .external_lex_state = 5},
  [3797] = {.lex_state = 64, .external_lex_state = 5},
  [3798] = {.lex_state = 64, .external_lex_state = 5},
  [3799] = {.lex_state = 64, .external_lex_state = 5},
  [3800] = {.lex_state = 64, .external_lex_state = 5},
  [3801] = {.lex_state = 64, .external_lex_state = 5},
  [3802] = {.lex_state = 64, .external_lex_state = 5},
  [3803] = {.lex_state = 64, .external_lex_state = 5},
  [3804] = {.lex_state = 64},
  [3805] = {.lex_state = 64},
  [3806] = {.lex_state = 64},
  [3807] = {.lex_state = 64},
  [3808] = {.lex_state = 64},
  [3809] = {.lex_state = 64, .external_lex_state = 6},
  [3810] = {.lex_state = 64, .external_lex_state = 5},
  [3811] = {.lex_state = 64, .external_lex_state = 6},
  [3812] = {.lex_state = 64},
  [3813] = {.lex_state = 64, .external_lex_state = 6},
  [3814] = {.lex_state = 64},
  [3815] = {.lex_state = 64},
  [3816] = {.lex_state = 64},
  [3817] = {.lex_state = 64, .external_lex_state = 5},
  [3818] = {.lex_state = 64, .external_lex_state = 5},
  [3819] = {.lex_state = 64, .external_lex_state = 5},
  [3820] = {.lex_state = 64, .external_lex_state = 5},
  [3821] = {.lex_state = 64, .external_lex_state = 5},
  [3822] = {.lex_state = 64},
  [3823] = {.lex_state = 64},
  [3824] = {.lex_state = 64},
  [3825] = {.lex_state = 64, .external_lex_state = 5},
  [3826] = {.lex_state = 64, .external_lex_state = 5},
  [3827] = {.lex_state = 64},
  [3828] = {.lex_state = 64},
  [3829] = {.lex_state = 64},
  [3830] = {.lex_state = 64},
  [3831] = {.lex_state = 64},
  [3832] = {.lex_state = 64, .external_lex_state = 5},
  [3833] = {.lex_state = 64},
  [3834] = {.lex_state = 64},
  [3835] = {.lex_state = 64},
  [3836] = {.lex_state = 64},
  [3837] = {.lex_state = 64, .external_lex_state = 5},
  [3838] = {.lex_state = 64, .external_lex_state = 5},
  [3839] = {.lex_state = 64},
  [3840] = {.lex_state = 64},
  [3841] = {.lex_state = 64},
  [3842] = {.lex_state = 64},
  [3843] = {.lex_state = 64, .external_lex_state = 5},
  [3844] = {.lex_state = 64},
  [3845] = {.lex_state = 64},
  [3846] = {.lex_state = 64},
  [3847] = {.lex_state = 64},
  [3848] = {.lex_state = 64},
  [3849] = {.lex_state = 64},
  [3850] = {.lex_state = 64},
  [3851] = {.lex_state = 64},
  [3852] = {.lex_state = 64},
  [3853] = {.lex_state = 64},
  [3854] = {.lex_state = 64},
  [3855] = {.lex_state = 64},
  [3856] = {.lex_state = 64, .external_lex_state = 5},
  [3857] = {.lex_state = 64, .external_lex_state = 5},
  [3858] = {.lex_state = 64, .external_lex_state = 5},
  [3859] = {.lex_state = 64},
  [3860] = {.lex_state = 64},
  [3861] = {.lex_state = 64},
  [3862] = {.lex_state = 64},
  [3863] = {.lex_state = 64},
  [3864] = {.lex_state = 64},
  [3865] = {.lex_state = 64},
  [3866] = {.lex_state = 64},
  [3867] = {.lex_state = 64},
  [3868] = {.lex_state = 64},
  [3869] = {.lex_state = 64},
  [3870] = {.lex_state = 64},
  [3871] = {.lex_state = 64, .external_lex_state = 5},
  [3872] = {.lex_state = 64},
  [3873] = {.lex_state = 64, .external_lex_state = 5},
  [3874] = {.lex_state = 64},
  [3875] = {.lex_state = 64},
  [3876] = {.lex_state = 64},
  [3877] = {.lex_state = 64},
  [3878] = {.lex_state = 64},
  [3879] = {.lex_state = 64},
  [3880] = {.lex_state = 64},
  [3881] = {.lex_state = 64},
  [3882] = {.lex_state = 64},
  [3883] = {.lex_state = 64},
  [3884] = {.lex_state = 64},
  [3885] = {.lex_state = 64},
  [3886] = {.lex_state = 64},
  [3887] = {.lex_state = 64},
  [3888] = {.lex_state = 64, .external_lex_state = 6},
  [3889] = {.lex_state = 64, .external_lex_state = 5},
  [3890] = {.lex_state = 64, .external_lex_state = 6},
  [3891] = {.lex_state = 64, .external_lex_state = 6},
  [3892] = {.lex_state = 64, .external_lex_state = 6},
  [3893] = {.lex_state = 64, .external_lex_state = 6},
  [3894] = {.lex_state = 64, .external_lex_state = 6},
  [3895] = {.lex_state = 64, .external_lex_state = 6},
  [3896] = {.lex_state = 64, .external_lex_state = 6},
  [3897] = {.lex_state = 64, .external_lex_state = 6},
  [3898] = {.lex_state = 64, .external_lex_state = 6},
  [3899] = {.lex_state = 64, .external_lex_state = 6},
  [3900] = {.lex_state = 64, .external_lex_state = 6},
  [3901] = {.lex_state = 64, .external_lex_state = 6},
  [3902] = {.lex_state = 64, .external_lex_state = 5},
  [3903] = {.lex_state = 64, .external_lex_state = 6},
  [3904] = {.lex_state = 64, .external_lex_state = 6},
  [3905] = {.lex_state = 64, .external_lex_state = 6},
  [3906] = {.lex_state = 64, .external_lex_state = 6},
  [3907] = {.lex_state = 64, .external_lex_state = 6},
  [3908] = {.lex_state = 64, .external_lex_state = 6},
  [3909] = {.lex_state = 64, .external_lex_state = 6},
  [3910] = {.lex_state = 64, .external_lex_state = 6},
  [3911] = {.lex_state = 64, .external_lex_state = 6},
  [3912] = {.lex_state = 64},
  [3913] = {.lex_state = 64, .external_lex_state = 6},
  [3914] = {.lex_state = 64, .external_lex_state = 6},
  [3915] = {.lex_state = 64, .external_lex_state = 6},
  [3916] = {.lex_state = 64, .external_lex_state = 6},
  [3917] = {.lex_state = 64, .external_lex_state = 6},
  [3918] = {.lex_state = 64, .external_lex_state = 6},
  [3919] = {.lex_state = 64, .external_lex_state = 6},
  [3920] = {.lex_state = 64, .external_lex_state = 5},
  [3921] = {.lex_state = 64, .external_lex_state = 6},
  [3922] = {.lex_state = 64},
  [3923] = {.lex_state = 64, .external_lex_state = 5},
  [3924] = {.lex_state = 64, .external_lex_state = 5},
  [3925] = {.lex_state = 64, .external_lex_state = 6},
  [3926] = {.lex_state = 64, .external_lex_state = 6},
  [3927] = {.lex_state = 64, .external_lex_state = 6},
  [3928] = {.lex_state = 64, .external_lex_state = 6},
  [3929] = {.lex_state = 64, .external_lex_state = 6},
  [3930] = {.lex_state = 64},
  [3931] = {.lex_state = 64, .external_lex_state = 6},
  [3932] = {.lex_state = 64, .external_lex_state = 5},
  [3933] = {.lex_state = 64, .external_lex_state = 6},
  [3934] = {.lex_state = 64, .external_lex_state = 6},
  [3935] = {.lex_state = 64, .external_lex_state = 5},
  [3936] = {.lex_state = 64, .external_lex_state = 5},
  [3937] = {.lex_state = 64, .external_lex_state = 6},
  [3938] = {.lex_state = 64},
  [3939] = {.lex_state = 64},
  [3940] = {.lex_state = 64},
  [3941] = {.lex_state = 64},
  [3942] = {.lex_state = 64, .external_lex_state = 6},
  [3943] = {.lex_state = 64, .external_lex_state = 6},
  [3944] = {.lex_state = 64, .external_lex_state = 5},
  [3945] = {.lex_state = 64, .external_lex_state = 5},
  [3946] = {.lex_state = 64, .external_lex_state = 6},
  [3947] = {.lex_state = 64, .external_lex_state = 6},
  [3948] = {.lex_state = 64, .external_lex_state = 5},
  [3949] = {.lex_state = 64, .external_lex_state = 6},
  [3950] = {.lex_state = 64, .external_lex_state = 5},
  [3951] = {.lex_state = 64},
  [3952] = {.lex_state = 64},
  [3953] = {.lex_state = 64},
  [3954] = {.lex_state = 64},
  [3955] = {.lex_state = 64},
  [3956] = {.lex_state = 64},
  [3957] = {.lex_state = 64},
  [3958] = {.lex_state = 64, .external_lex_state = 5},
  [3959] = {.lex_state = 64},
  [3960] = {.lex_state = 64},
  [3961] = {.lex_state = 64},
  [3962] = {.lex_state = 64},
  [3963] = {.lex_state = 64},
  [3964] = {.lex_state = 64, .external_lex_state = 5},
  [3965] = {.lex_state = 64},
  [3966] = {.lex_state = 64},
  [3967] = {.lex_state = 0, .external_lex_state = 5},
  [3968] = {.lex_state = 64, .external_lex_state = 5},
  [3969] = {.lex_state = 64, .external_lex_state = 5},
  [3970] = {.lex_state = 64},
  [3971] = {.lex_state = 64},
  [3972] = {.lex_state = 64, .external_lex_state = 5},
  [3973] = {.lex_state = 64, .external_lex_state = 5},
  [3974] = {.lex_state = 64},
  [3975] = {.lex_state = 64},
  [3976] = {.lex_state = 64},
  [3977] = {.lex_state = 64},
  [3978] = {.lex_state = 64},
  [3979] = {.lex_state = 64},
  [3980] = {.lex_state = 64},
  [3981] = {.lex_state = 64},
  [3982] = {.lex_state = 64, .external_lex_state = 5},
  [3983] = {.lex_state = 64},
  [3984] = {.lex_state = 64},
  [3985] = {.lex_state = 64, .external_lex_state = 5},
  [3986] = {.lex_state = 64},
  [3987] = {.lex_state = 64},
  [3988] = {.lex_state = 64, .external_lex_state = 5},
  [3989] = {.lex_state = 64, .external_lex_state = 5},
  [3990] = {.lex_state = 64},
  [3991] = {.lex_state = 64},
  [3992] = {.lex_state = 64, .external_lex_state = 5},
  [3993] = {.lex_state = 64},
  [3994] = {.lex_state = 64},
  [3995] = {.lex_state = 64},
  [3996] = {.lex_state = 64},
  [3997] = {.lex_state = 0, .external_lex_state = 5},
  [3998] = {.lex_state = 64, .external_lex_state = 5},
  [3999] = {.lex_state = 64, .external_lex_state = 5},
  [4000] = {.lex_state = 64, .external_lex_state = 5},
  [4001] = {.lex_state = 64, .external_lex_state = 5},
  [4002] = {.lex_state = 64, .external_lex_state = 5},
  [4003] = {.lex_state = 64},
  [4004] = {.lex_state = 64},
  [4005] = {.lex_state = 64},
  [4006] = {.lex_state = 64},
  [4007] = {.lex_state = 64},
  [4008] = {.lex_state = 0, .external_lex_state = 5},
  [4009] = {.lex_state = 64},
  [4010] = {.lex_state = 64},
  [4011] = {.lex_state = 64},
  [4012] = {.lex_state = 64},
  [4013] = {.lex_state = 64},
  [4014] = {.lex_state = 64},
  [4015] = {.lex_state = 64},
  [4016] = {.lex_state = 64},
  [4017] = {.lex_state = 64},
  [4018] = {.lex_state = 64},
  [4019] = {.lex_state = 64},
  [4020] = {.lex_state = 64},
  [4021] = {.lex_state = 64},
  [4022] = {.lex_state = 64},
  [4023] = {.lex_state = 0, .external_lex_state = 5},
  [4024] = {.lex_state = 64, .external_lex_state = 6},
  [4025] = {.lex_state = 64},
  [4026] = {.lex_state = 64},
  [4027] = {.lex_state = 64},
  [4028] = {.lex_state = 64},
  [4029] = {.lex_state = 64},
  [4030] = {.lex_state = 64},
  [4031] = {.lex_state = 64},
  [4032] = {.lex_state = 64, .external_lex_state = 5},
  [4033] = {.lex_state = 64, .external_lex_state = 5},
  [4034] = {.lex_state = 0, .external_lex_state = 5},
  [4035] = {.lex_state = 64, .external_lex_state = 5},
  [4036] = {.lex_state = 64},
  [4037] = {.lex_state = 64},
  [4038] = {.lex_state = 0, .external_lex_state = 5},
  [4039] = {.lex_state = 64, .external_lex_state = 5},
  [4040] = {.lex_state = 64},
  [4041] = {.lex_state = 64},
  [4042] = {.lex_state = 64, .external_lex_state = 5},
  [4043] = {.lex_state = 0, .external_lex_state = 5},
  [4044] = {.lex_state = 64},
  [4045] = {.lex_state = 64, .external_lex_state = 5},
  [4046] = {.lex_state = 64},
  [4047] = {.lex_state = 64},
  [4048] = {.lex_state = 64},
  [4049] = {.lex_state = 64},
  [4050] = {.lex_state = 64},
  [4051] = {.lex_state = 64},
  [4052] = {.lex_state = 64},
  [4053] = {.lex_state = 64},
  [4054] = {.lex_state = 64},
  [4055] = {.lex_state = 64},
  [4056] = {.lex_state = 64, .external_lex_state = 5},
  [4057] = {.lex_state = 64},
  [4058] = {.lex_state = 64},
  [4059] = {.lex_state = 10},
  [4060] = {.lex_state = 64},
  [4061] = {.lex_state = 64},
  [4062] = {.lex_state = 64},
  [4063] = {.lex_state = 64},
  [4064] = {.lex_state = 64},
  [4065] = {.lex_state = 64, .external_lex_state = 5},
  [4066] = {.lex_state = 64},
  [4067] = {.lex_state = 64},
  [4068] = {.lex_state = 64},
  [4069] = {.lex_state = 64},
  [4070] = {.lex_state = 64},
  [4071] = {.lex_state = 64, .external_lex_state = 5},
  [4072] = {.lex_state = 64},
  [4073] = {.lex_state = 64},
  [4074] = {.lex_state = 0, .external_lex_state = 5},
  [4075] = {.lex_state = 64},
  [4076] = {.lex_state = 64, .external_lex_state = 5},
  [4077] = {.lex_state = 10},
  [4078] = {.lex_state = 64, .external_lex_state = 5},
  [4079] = {.lex_state = 64},
  [4080] = {.lex_state = 64},
  [4081] = {.lex_state = 64},
  [4082] = {.lex_state = 64, .external_lex_state = 5},
  [4083] = {.lex_state = 64},
  [4084] = {.lex_state = 64},
  [4085] = {.lex_state = 64, .external_lex_state = 5},
  [4086] = {.lex_state = 64},
  [4087] = {.lex_state = 64},
  [4088] = {.lex_state = 64},
  [4089] = {.lex_state = 64},
  [4090] = {.lex_state = 64},
  [4091] = {.lex_state = 64},
  [4092] = {.lex_state = 64},
  [4093] = {.lex_state = 64},
  [4094] = {.lex_state = 0, .external_lex_state = 5},
  [4095] = {.lex_state = 64, .external_lex_state = 5},
  [4096] = {.lex_state = 0, .external_lex_state = 5},
  [4097] = {.lex_state = 64},
  [4098] = {.lex_state = 64},
  [4099] = {.lex_state = 64},
  [4100] = {.lex_state = 64},
  [4101] = {.lex_state = 64},
  [4102] = {.lex_state = 64},
  [4103] = {.lex_state = 64},
  [4104] = {.lex_state = 64},
  [4105] = {.lex_state = 64},
  [4106] = {.lex_state = 64},
  [4107] = {.lex_state = 0, .external_lex_state = 5},
  [4108] = {.lex_state = 64, .external_lex_state = 5},
  [4109] = {.lex_state = 64},
  [4110] = {.lex_state = 64, .external_lex_state = 5},
  [4111] = {.lex_state = 64},
  [4112] = {.lex_state = 64},
  [4113] = {.lex_state = 64},
  [4114] = {.lex_state = 64},
  [4115] = {.lex_state = 15, .external_lex_state = 7},
  [4116] = {.lex_state = 64},
  [4117] = {.lex_state = 15, .external_lex_state = 7},
  [4118] = {.lex_state = 0, .external_lex_state = 5},
  [4119] = {.lex_state = 64},
  [4120] = {.lex_state = 64},
  [4121] = {.lex_state = 0, .external_lex_state = 5},
  [4122] = {.lex_state = 15, .external_lex_state = 7},
  [4123] = {.lex_state = 0, .external_lex_state = 5},
  [4124] = {.lex_state = 0, .external_lex_state = 5},
  [4125] = {.lex_state = 0, .external_lex_state = 5},
  [4126] = {.lex_state = 0, .external_lex_state = 5},
  [4127] = {.lex_state = 64, .external_lex_state = 5},
  [4128] = {.lex_state = 0, .external_lex_state = 5},
  [4129] = {.lex_state = 64},
  [4130] = {.lex_state = 64},
  [4131] = {.lex_state = 10},
  [4132] = {.lex_state = 64},
  [4133] = {.lex_state = 0, .external_lex_state = 5},
  [4134] = {.lex_state = 64},
  [4135] = {.lex_state = 0, .external_lex_state = 5},
  [4136] = {.lex_state = 15},
  [4137] = {.lex_state = 64},
  [4138] = {.lex_state = 64},
  [4139] = {.lex_state = 64},
  [4140] = {.lex_state = 15},
  [4141] = {.lex_state = 64},
  [4142] = {.lex_state = 64},
  [4143] = {.lex_state = 0, .external_lex_state = 5},
  [4144] = {.lex_state = 64},
  [4145] = {.lex_state = 64},
  [4146] = {.lex_state = 15, .external_lex_state = 7},
  [4147] = {.lex_state = 64},
  [4148] = {.lex_state = 64},
  [4149] = {.lex_state = 64},
  [4150] = {.lex_state = 64},
  [4151] = {.lex_state = 0, .external_lex_state = 5},
  [4152] = {.lex_state = 64, .external_lex_state = 5},
  [4153] = {.lex_state = 0, .external_lex_state = 5},
  [4154] = {.lex_state = 15},
  [4155] = {.lex_state = 64},
  [4156] = {.lex_state = 64},
  [4157] = {.lex_state = 0, .external_lex_state = 5},
  [4158] = {.lex_state = 64},
  [4159] = {.lex_state = 64},
  [4160] = {.lex_state = 0, .external_lex_state = 5},
  [4161] = {.lex_state = 64},
  [4162] = {.lex_state = 64},
  [4163] = {.lex_state = 64},
  [4164] = {.lex_state = 64},
  [4165] = {.lex_state = 64},
  [4166] = {.lex_state = 64},
  [4167] = {.lex_state = 64},
  [4168] = {.lex_state = 64},
  [4169] = {.lex_state = 64, .external_lex_state = 5},
  [4170] = {.lex_state = 15, .external_lex_state = 7},
  [4171] = {.lex_state = 64},
  [4172] = {.lex_state = 64},
  [4173] = {.lex_state = 0, .external_lex_state = 5},
  [4174] = {.lex_state = 64, .external_lex_state = 5},
  [4175] = {.lex_state = 0, .external_lex_state = 5},
  [4176] = {.lex_state = 64},
  [4177] = {.lex_state = 64},
  [4178] = {.lex_state = 64},
  [4179] = {.lex_state = 64},
  [4180] = {.lex_state = 64},
  [4181] = {.lex_state = 64},
  [4182] = {.lex_state = 15, .external_lex_state = 7},
  [4183] = {.lex_state = 64},
  [4184] = {.lex_state = 64},
  [4185] = {.lex_state = 64},
  [4186] = {.lex_state = 64},
  [4187] = {.lex_state = 15, .external_lex_state = 7},
  [4188] = {.lex_state = 64},
  [4189] = {.lex_state = 64},
  [4190] = {.lex_state = 64},
  [4191] = {.lex_state = 15, .external_lex_state = 7},
  [4192] = {.lex_state = 64},
  [4193] = {.lex_state = 64},
  [4194] = {.lex_state = 15, .external_lex_state = 7},
  [4195] = {.lex_state = 64, .external_lex_state = 5},
  [4196] = {.lex_state = 64},
  [4197] = {.lex_state = 0, .external_lex_state = 5},
  [4198] = {.lex_state = 64},
  [4199] = {.lex_state = 64, .external_lex_state = 5},
  [4200] = {.lex_state = 64},
  [4201] = {.lex_state = 64},
  [4202] = {.lex_state = 64},
  [4203] = {.lex_state = 64},
  [4204] = {.lex_state = 15},
  [4205] = {.lex_state = 15},
  [4206] = {.lex_state = 64},
  [4207] = {.lex_state = 64},
  [4208] = {.lex_state = 64},
  [4209] = {.lex_state = 0, .external_lex_state = 5},
  [4210] = {.lex_state = 64},
  [4211] = {.lex_state = 64, .external_lex_state = 5},
  [4212] = {.lex_state = 64},
  [4213] = {.lex_state = 64},
  [4214] = {.lex_state = 64},
  [4215] = {.lex_state = 0, .external_lex_state = 5},
  [4216] = {.lex_state = 64},
  [4217] = {.lex_state = 64},
  [4218] = {.lex_state = 64},
  [4219] = {.lex_state = 64},
  [4220] = {.lex_state = 64},
  [4221] = {.lex_state = 64},
  [4222] = {.lex_state = 64},
  [4223] = {.lex_state = 15},
  [4224] = {.lex_state = 64},
  [4225] = {.lex_state = 0, .external_lex_state = 5},
  [4226] = {.lex_state = 64},
  [4227] = {.lex_state = 64},
  [4228] = {.lex_state = 0},
  [4229] = {.lex_state = 15},
  [4230] = {.lex_state = 64},
  [4231] = {.lex_state = 64},
  [4232] = {.lex_state = 64},
  [4233] = {.lex_state = 0, .external_lex_state = 5},
  [4234] = {.lex_state = 64},
  [4235] = {.lex_state = 0, .external_lex_state = 5},
  [4236] = {.lex_state = 64},
  [4237] = {.lex_state = 64},
  [4238] = {.lex_state = 15},
  [4239] = {.lex_state = 64},
  [4240] = {.lex_state = 64},
  [4241] = {.lex_state = 15},
  [4242] = {.lex_state = 64},
  [4243] = {.lex_state = 0, .external_lex_state = 5},
  [4244] = {.lex_state = 64},
  [4245] = {.lex_state = 0, .external_lex_state = 5},
  [4246] = {.lex_state = 64},
  [4247] = {.lex_state = 64},
  [4248] = {.lex_state = 64, .external_lex_state = 5},
  [4249] = {.lex_state = 0, .external_lex_state = 5},
  [4250] = {.lex_state = 64},
  [4251] = {.lex_state = 64},
  [4252] = {.lex_state = 64},
  [4253] = {.lex_state = 64},
  [4254] = {.lex_state = 64},
  [4255] = {.lex_state = 0, .external_lex_state = 5},
  [4256] = {.lex_state = 0, .external_lex_state = 5},
  [4257] = {.lex_state = 64},
  [4258] = {.lex_state = 64},
  [4259] = {.lex_state = 64},
  [4260] = {.lex_state = 64, .external_lex_state = 5},
  [4261] = {.lex_state = 64, .external_lex_state = 6},
  [4262] = {.lex_state = 0, .external_lex_state = 5},
  [4263] = {.lex_state = 64},
  [4264] = {.lex_state = 64},
  [4265] = {.lex_state = 0, .external_lex_state = 5},
  [4266] = {.lex_state = 64, .external_lex_state = 6},
  [4267] = {.lex_state = 64},
  [4268] = {.lex_state = 0, .external_lex_state = 5},
  [4269] = {.lex_state = 0, .external_lex_state = 5},
  [4270] = {.lex_state = 0, .external_lex_state = 5},
  [4271] = {.lex_state = 0, .external_lex_state = 5},
  [4272] = {.lex_state = 0},
  [4273] = {.lex_state = 64},
  [4274] = {.lex_state = 64},
  [4275] = {.lex_state = 0, .external_lex_state = 5},
  [4276] = {.lex_state = 64, .external_lex_state = 5},
  [4277] = {.lex_state = 0, .external_lex_state = 5},
  [4278] = {.lex_state = 0, .external_lex_state = 5},
  [4279] = {.lex_state = 64},
  [4280] = {.lex_state = 0, .external_lex_state = 5},
  [4281] = {.lex_state = 64},
  [4282] = {.lex_state = 0, .external_lex_state = 5},
  [4283] = {.lex_state = 0, .external_lex_state = 5},
  [4284] = {.lex_state = 0, .external_lex_state = 5},
  [4285] = {.lex_state = 0},
  [4286] = {.lex_state = 64, .external_lex_state = 5},
  [4287] = {.lex_state = 64},
  [4288] = {.lex_state = 64, .external_lex_state = 5},
  [4289] = {.lex_state = 0, .external_lex_state = 5},
  [4290] = {.lex_state = 64},
  [4291] = {.lex_state = 0, .external_lex_state = 5},
  [4292] = {.lex_state = 64},
  [4293] = {.lex_state = 64},
  [4294] = {.lex_state = 0},
  [4295] = {.lex_state = 0, .external_lex_state = 5},
  [4296] = {.lex_state = 0, .external_lex_state = 5},
  [4297] = {.lex_state = 0, .external_lex_state = 5},
  [4298] = {.lex_state = 64},
  [4299] = {.lex_state = 0, .external_lex_state = 5},
  [4300] = {.lex_state = 0},
  [4301] = {.lex_state = 64},
  [4302] = {.lex_state = 0, .external_lex_state = 5},
  [4303] = {.lex_state = 64},
  [4304] = {.lex_state = 0, .external_lex_state = 5},
  [4305] = {.lex_state = 64},
  [4306] = {.lex_state = 64, .external_lex_state = 6},
  [4307] = {.lex_state = 64},
  [4308] = {.lex_state = 64, .external_lex_state = 5},
  [4309] = {.lex_state = 64},
  [4310] = {.lex_state = 0, .external_lex_state = 5},
  [4311] = {.lex_state = 64},
  [4312] = {.lex_state = 64},
  [4313] = {.lex_state = 64},
  [4314] = {.lex_state = 64},
  [4315] = {.lex_state = 64},
  [4316] = {.lex_state = 64},
  [4317] = {.lex_state = 64, .external_lex_state = 6},
  [4318] = {.lex_state = 0},
  [4319] = {.lex_state = 64},
  [4320] = {.lex_state = 64},
  [4321] = {.lex_state = 64},
  [4322] = {.lex_state = 64},
  [4323] = {.lex_state = 64},
  [4324] = {.lex_state = 64, .external_lex_state = 6},
  [4325] = {.lex_state = 64},
  [4326] = {.lex_state = 0, .external_lex_state = 5},
  [4327] = {.lex_state = 64},
  [4328] = {.lex_state = 0, .external_lex_state = 5},
  [4329] = {.lex_state = 64},
  [4330] = {.lex_state = 64},
  [4331] = {.lex_state = 0, .external_lex_state = 5},
  [4332] = {.lex_state = 0, .external_lex_state = 5},
  [4333] = {.lex_state = 64, .external_lex_state = 5},
  [4334] = {.lex_state = 64},
  [4335] = {.lex_state = 64, .external_lex_state = 5},
  [4336] = {.lex_state = 64},
  [4337] = {.lex_state = 64},
  [4338] = {.lex_state = 64},
  [4339] = {.lex_state = 0, .external_lex_state = 5},
  [4340] = {.lex_state = 64},
  [4341] = {.lex_state = 0, .external_lex_state = 5},
  [4342] = {.lex_state = 10},
  [4343] = {.lex_state = 64, .external_lex_state = 6},
  [4344] = {.lex_state = 0},
  [4345] = {.lex_state = 64},
  [4346] = {.lex_state = 64},
  [4347] = {.lex_state = 0, .external_lex_state = 5},
  [4348] = {.lex_state = 64, .external_lex_state = 6},
  [4349] = {.lex_state = 64},
  [4350] = {.lex_state = 0, .external_lex_state = 5},
  [4351] = {.lex_state = 0},
  [4352] = {.lex_state = 0},
  [4353] = {.lex_state = 0, .external_lex_state = 5},
  [4354] = {.lex_state = 64},
  [4355] = {.lex_state = 64, .external_lex_state = 6},
  [4356] = {.lex_state = 64},
  [4357] = {.lex_state = 0},
  [4358] = {.lex_state = 0, .external_lex_state = 5},
  [4359] = {.lex_state = 64},
  [4360] = {.lex_state = 0, .external_lex_state = 5},
  [4361] = {.lex_state = 0},
  [4362] = {.lex_state = 10},
  [4363] = {.lex_state = 0},
  [4364] = {.lex_state = 64},
  [4365] = {.lex_state = 0, .external_lex_state = 5},
  [4366] = {.lex_state = 0, .external_lex_state = 5},
  [4367] = {.lex_state = 64},
  [4368] = {.lex_state = 0, .external_lex_state = 5},
  [4369] = {.lex_state = 64},
  [4370] = {.lex_state = 64, .external_lex_state = 5},
  [4371] = {.lex_state = 0, .external_lex_state = 5},
  [4372] = {.lex_state = 64, .external_lex_state = 6},
  [4373] = {.lex_state = 0, .external_lex_state = 5},
  [4374] = {.lex_state = 64},
  [4375] = {.lex_state = 64, .external_lex_state = 5},
  [4376] = {.lex_state = 0},
  [4377] = {.lex_state = 64},
  [4378] = {.lex_state = 64, .external_lex_state = 5},
  [4379] = {.lex_state = 64},
  [4380] = {.lex_state = 64},
  [4381] = {.lex_state = 64, .external_lex_state = 6},
  [4382] = {.lex_state = 0, .external_lex_state = 5},
  [4383] = {.lex_state = 0, .external_lex_state = 5},
  [4384] = {.lex_state = 0, .external_lex_state = 5},
  [4385] = {.lex_state = 64},
  [4386] = {.lex_state = 64},
  [4387] = {.lex_state = 0, .external_lex_state = 5},
  [4388] = {.lex_state = 64},
  [4389] = {.lex_state = 0, .external_lex_state = 5},
  [4390] = {.lex_state = 0, .external_lex_state = 5},
  [4391] = {.lex_state = 0, .external_lex_state = 5},
  [4392] = {.lex_state = 0, .external_lex_state = 5},
  [4393] = {.lex_state = 64},
  [4394] = {.lex_state = 0, .external_lex_state = 5},
  [4395] = {.lex_state = 64, .external_lex_state = 5},
  [4396] = {.lex_state = 64, .external_lex_state = 6},
  [4397] = {.lex_state = 64},
  [4398] = {.lex_state = 0, .external_lex_state = 5},
  [4399] = {.lex_state = 0, .external_lex_state = 5},
  [4400] = {.lex_state = 64},
  [4401] = {.lex_state = 64},
  [4402] = {.lex_state = 64},
  [4403] = {.lex_state = 0},
  [4404] = {.lex_state = 0, .external_lex_state = 5},
  [4405] = {.lex_state = 0, .external_lex_state = 5},
  [4406] = {.lex_state = 0},
  [4407] = {.lex_state = 0, .external_lex_state = 5},
  [4408] = {.lex_state = 64},
  [4409] = {.lex_state = 0, .external_lex_state = 5},
  [4410] = {.lex_state = 0, .external_lex_state = 5},
  [4411] = {.lex_state = 64},
  [4412] = {.lex_state = 64, .external_lex_state = 6},
  [4413] = {.lex_state = 0, .external_lex_state = 5},
  [4414] = {.lex_state = 0},
  [4415] = {.lex_state = 64},
  [4416] = {.lex_state = 0, .external_lex_state = 5},
  [4417] = {.lex_state = 0, .external_lex_state = 5},
  [4418] = {.lex_state = 0, .external_lex_state = 5},
  [4419] = {.lex_state = 0},
  [4420] = {.lex_state = 0, .external_lex_state = 5},
  [4421] = {.lex_state = 0, .external_lex_state = 5},
  [4422] = {.lex_state = 10},
  [4423] = {.lex_state = 64},
  [4424] = {.lex_state = 64, .external_lex_state = 6},
  [4425] = {.lex_state = 64},
  [4426] = {.lex_state = 64},
  [4427] = {.lex_state = 64},
  [4428] = {.lex_state = 0, .external_lex_state = 5},
  [4429] = {.lex_state = 10},
  [4430] = {.lex_state = 64},
  [4431] = {.lex_state = 0, .external_lex_state = 5},
  [4432] = {.lex_state = 0, .external_lex_state = 5},
  [4433] = {.lex_state = 0, .external_lex_state = 5},
  [4434] = {.lex_state = 64, .external_lex_state = 6},
  [4435] = {.lex_state = 64, .external_lex_state = 6},
  [4436] = {.lex_state = 64},
  [4437] = {.lex_state = 0, .external_lex_state = 5},
  [4438] = {.lex_state = 0, .external_lex_state = 5},
  [4439] = {.lex_state = 0, .external_lex_state = 5},
  [4440] = {.lex_state = 64},
  [4441] = {.lex_state = 64},
  [4442] = {.lex_state = 64, .external_lex_state = 5},
  [4443] = {.lex_state = 64},
  [4444] = {.lex_state = 64},
  [4445] = {.lex_state = 64},
  [4446] = {.lex_state = 0},
  [4447] = {.lex_state = 64},
  [4448] = {.lex_state = 64},
  [4449] = {.lex_state = 0, .external_lex_state = 5},
  [4450] = {.lex_state = 0},
  [4451] = {.lex_state = 0, .external_lex_state = 5},
  [4452] = {.lex_state = 0, .external_lex_state = 5},
  [4453] = {.lex_state = 0, .external_lex_state = 5},
  [4454] = {.lex_state = 64},
  [4455] = {.lex_state = 0},
  [4456] = {.lex_state = 0, .external_lex_state = 5},
  [4457] = {.lex_state = 64, .external_lex_state = 5},
  [4458] = {.lex_state = 64, .external_lex_state = 6},
  [4459] = {.lex_state = 64},
  [4460] = {.lex_state = 64},
  [4461] = {.lex_state = 0, .external_lex_state = 5},
  [4462] = {.lex_state = 0, .external_lex_state = 5},
  [4463] = {.lex_state = 0, .external_lex_state = 5},
  [4464] = {.lex_state = 64},
  [4465] = {.lex_state = 0},
  [4466] = {.lex_state = 0, .external_lex_state = 5},
  [4467] = {.lex_state = 0, .external_lex_state = 5},
  [4468] = {.lex_state = 0, .external_lex_state = 5},
  [4469] = {.lex_state = 64},
  [4470] = {.lex_state = 0, .external_lex_state = 5},
  [4471] = {.lex_state = 0, .external_lex_state = 5},
  [4472] = {.lex_state = 0, .external_lex_state = 5},
  [4473] = {.lex_state = 64},
  [4474] = {.lex_state = 0},
  [4475] = {.lex_state = 0, .external_lex_state = 5},
  [4476] = {.lex_state = 0, .external_lex_state = 5},
  [4477] = {.lex_state = 64},
  [4478] = {.lex_state = 64, .external_lex_state = 5},
  [4479] = {.lex_state = 0, .external_lex_state = 5},
  [4480] = {.lex_state = 64},
  [4481] = {.lex_state = 0, .external_lex_state = 5},
  [4482] = {.lex_state = 64, .external_lex_state = 6},
  [4483] = {.lex_state = 64},
  [4484] = {.lex_state = 64},
  [4485] = {.lex_state = 0, .external_lex_state = 5},
  [4486] = {.lex_state = 0},
  [4487] = {.lex_state = 0, .external_lex_state = 5},
  [4488] = {.lex_state = 0, .external_lex_state = 5},
  [4489] = {.lex_state = 0},
  [4490] = {.lex_state = 0, .external_lex_state = 5},
  [4491] = {.lex_state = 64, .external_lex_state = 5},
  [4492] = {.lex_state = 64},
  [4493] = {.lex_state = 64},
  [4494] = {.lex_state = 0, .external_lex_state = 5},
  [4495] = {.lex_state = 0, .external_lex_state = 5},
  [4496] = {.lex_state = 0, .external_lex_state = 5},
  [4497] = {.lex_state = 0, .external_lex_state = 5},
  [4498] = {.lex_state = 0, .external_lex_state = 5},
  [4499] = {.lex_state = 0, .external_lex_state = 5},
  [4500] = {.lex_state = 0, .external_lex_state = 5},
  [4501] = {.lex_state = 0, .external_lex_state = 5},
  [4502] = {.lex_state = 64},
  [4503] = {.lex_state = 0},
  [4504] = {.lex_state = 64},
  [4505] = {.lex_state = 0, .external_lex_state = 5},
  [4506] = {.lex_state = 64},
  [4507] = {.lex_state = 64},
  [4508] = {.lex_state = 64},
  [4509] = {.lex_state = 64},
  [4510] = {.lex_state = 64, .external_lex_state = 5},
  [4511] = {.lex_state = 64},
  [4512] = {.lex_state = 0},
  [4513] = {.lex_state = 64, .external_lex_state = 5},
  [4514] = {.lex_state = 64},
  [4515] = {.lex_state = 64},
  [4516] = {.lex_state = 64},
  [4517] = {.lex_state = 64, .external_lex_state = 5},
  [4518] = {.lex_state = 0, .external_lex_state = 5},
  [4519] = {.lex_state = 0},
  [4520] = {.lex_state = 64},
  [4521] = {.lex_state = 0},
  [4522] = {.lex_state = 64},
  [4523] = {.lex_state = 0, .external_lex_state = 5},
  [4524] = {.lex_state = 0, .external_lex_state = 5},
  [4525] = {.lex_state = 15, .external_lex_state = 7},
  [4526] = {.lex_state = 0},
  [4527] = {.lex_state = 64},
  [4528] = {.lex_state = 64},
  [4529] = {.lex_state = 64},
  [4530] = {.lex_state = 17},
  [4531] = {.lex_state = 64},
  [4532] = {.lex_state = 14},
  [4533] = {.lex_state = 17},
  [4534] = {.lex_state = 64},
  [4535] = {.lex_state = 64},
  [4536] = {.lex_state = 64},
  [4537] = {.lex_state = 64},
  [4538] = {.lex_state = 64},
  [4539] = {.lex_state = 64},
  [4540] = {.lex_state = 64},
  [4541] = {.lex_state = 64},
  [4542] = {.lex_state = 14},
  [4543] = {.lex_state = 64},
  [4544] = {.lex_state = 64},
  [4545] = {.lex_state = 64},
  [4546] = {.lex_state = 64},
  [4547] = {.lex_state = 64},
  [4548] = {.lex_state = 64},
  [4549] = {.lex_state = 64},
  [4550] = {.lex_state = 64},
  [4551] = {.lex_state = 64},
  [4552] = {.lex_state = 64},
  [4553] = {.lex_state = 0},
  [4554] = {.lex_state = 64},
  [4555] = {.lex_state = 64, .external_lex_state = 6},
  [4556] = {.lex_state = 64},
  [4557] = {.lex_state = 64},
  [4558] = {.lex_state = 64},
  [4559] = {.lex_state = 64},
  [4560] = {.lex_state = 64},
  [4561] = {.lex_state = 64},
  [4562] = {.lex_state = 64},
  [4563] = {.lex_state = 0},
  [4564] = {.lex_state = 17},
  [4565] = {.lex_state = 64},
  [4566] = {.lex_state = 64},
  [4567] = {.lex_state = 0},
  [4568] = {.lex_state = 64},
  [4569] = {.lex_state = 64},
  [4570] = {.lex_state = 64},
  [4571] = {.lex_state = 64},
  [4572] = {.lex_state = 64},
  [4573] = {.lex_state = 64},
  [4574] = {.lex_state = 0},
  [4575] = {.lex_state = 64},
  [4576] = {.lex_state = 14},
  [4577] = {.lex_state = 64},
  [4578] = {.lex_state = 17},
  [4579] = {.lex_state = 64},
  [4580] = {.lex_state = 14},
  [4581] = {.lex_state = 17},
  [4582] = {.lex_state = 64},
  [4583] = {.lex_state = 64},
  [4584] = {.lex_state = 64},
  [4585] = {.lex_state = 64},
  [4586] = {.lex_state = 0, .external_lex_state = 5},
  [4587] = {.lex_state = 64},
  [4588] = {.lex_state = 17},
  [4589] = {.lex_state = 0},
  [4590] = {.lex_state = 0},
  [4591] = {.lex_state = 64},
  [4592] = {.lex_state = 64},
  [4593] = {.lex_state = 0, .external_lex_state = 5},
  [4594] = {.lex_state = 64},
  [4595] = {.lex_state = 64},
  [4596] = {.lex_state = 64},
  [4597] = {.lex_state = 64},
  [4598] = {.lex_state = 64},
  [4599] = {.lex_state = 0},
  [4600] = {.lex_state = 64},
  [4601] = {.lex_state = 0, .external_lex_state = 5},
  [4602] = {.lex_state = 64},
  [4603] = {.lex_state = 64},
  [4604] = {.lex_state = 17},
  [4605] = {.lex_state = 64},
  [4606] = {.lex_state = 64},
  [4607] = {.lex_state = 64},
  [4608] = {.lex_state = 64},
  [4609] = {.lex_state = 64},
  [4610] = {.lex_state = 64},
  [4611] = {.lex_state = 14},
  [4612] = {.lex_state = 0},
  [4613] = {.lex_state = 64},
  [4614] = {.lex_state = 0, .external_lex_state = 5},
  [4615] = {.lex_state = 64},
  [4616] = {.lex_state = 14},
  [4617] = {.lex_state = 17},
  [4618] = {.lex_state = 0, .external_lex_state = 5},
  [4619] = {.lex_state = 64},
  [4620] = {.lex_state = 0, .external_lex_state = 5},
  [4621] = {.lex_state = 64},
  [4622] = {.lex_state = 64},
  [4623] = {.lex_state = 64},
  [4624] = {.lex_state = 64, .external_lex_state = 6},
  [4625] = {.lex_state = 64, .external_lex_state = 6},
  [4626] = {.lex_state = 64},
  [4627] = {.lex_state = 14},
  [4628] = {.lex_state = 64},
  [4629] = {.lex_state = 0, .external_lex_state = 5},
  [4630] = {.lex_state = 0},
  [4631] = {.lex_state = 0, .external_lex_state = 5},
  [4632] = {.lex_state = 17},
  [4633] = {.lex_state = 14},
  [4634] = {.lex_state = 14},
  [4635] = {.lex_state = 17},
  [4636] = {.lex_state = 64},
  [4637] = {.lex_state = 17},
  [4638] = {.lex_state = 64},
  [4639] = {.lex_state = 64},
  [4640] = {.lex_state = 64},
  [4641] = {.lex_state = 64},
  [4642] = {.lex_state = 14},
  [4643] = {.lex_state = 64},
  [4644] = {.lex_state = 14},
  [4645] = {.lex_state = 14},
  [4646] = {.lex_state = 64},
  [4647] = {.lex_state = 64},
  [4648] = {.lex_state = 64},
  [4649] = {.lex_state = 64},
  [4650] = {.lex_state = 64},
  [4651] = {.lex_state = 64},
  [4652] = {.lex_state = 64},
  [4653] = {.lex_state = 64},
  [4654] = {.lex_state = 64},
  [4655] = {.lex_state = 64},
  [4656] = {.lex_state = 64},
  [4657] = {.lex_state = 64},
  [4658] = {.lex_state = 64},
  [4659] = {.lex_state = 64},
  [4660] = {.lex_state = 64},
  [4661] = {.lex_state = 64},
  [4662] = {.lex_state = 64},
  [4663] = {.lex_state = 64},
  [4664] = {.lex_state = 64},
  [4665] = {.lex_state = 64},
  [4666] = {.lex_state = 64},
  [4667] = {.lex_state = 64},
  [4668] = {.lex_state = 64},
  [4669] = {.lex_state = 64},
  [4670] = {.lex_state = 64},
  [4671] = {.lex_state = 64},
  [4672] = {.lex_state = 64},
  [4673] = {.lex_state = 64},
  [4674] = {.lex_state = 14},
  [4675] = {.lex_state = 64, .external_lex_state = 5},
  [4676] = {.lex_state = 64, .external_lex_state = 6},
  [4677] = {.lex_state = 64},
  [4678] = {.lex_state = 14},
  [4679] = {.lex_state = 17},
  [4680] = {.lex_state = 64},
  [4681] = {.lex_state = 0},
  [4682] = {.lex_state = 0},
  [4683] = {.lex_state = 14},
  [4684] = {.lex_state = 17},
  [4685] = {.lex_state = 0},
  [4686] = {.lex_state = 17},
  [4687] = {.lex_state = 14},
  [4688] = {.lex_state = 64, .external_lex_state = 5},
  [4689] = {.lex_state = 0},
  [4690] = {.lex_state = 0},
  [4691] = {.lex_state = 0},
  [4692] = {.lex_state = 64},
  [4693] = {.lex_state = 17},
  [4694] = {.lex_state = 64},
  [4695] = {.lex_state = 0, .external_lex_state = 5},
  [4696] = {.lex_state = 64},
  [4697] = {.lex_state = 64},
  [4698] = {.lex_state = 64},
  [4699] = {.lex_state = 64},
  [4700] = {.lex_state = 14},
  [4701] = {.lex_state = 64},
  [4702] = {.lex_state = 17},
  [4703] = {.lex_state = 64},
  [4704] = {.lex_state = 64},
  [4705] = {.lex_state = 17},
  [4706] = {.lex_state = 64},
  [4707] = {.lex_state = 0},
  [4708] = {.lex_state = 0},
  [4709] = {.lex_state = 64},
  [4710] = {.lex_state = 0},
  [4711] = {.lex_state = 0},
  [4712] = {.lex_state = 0},
  [4713] = {.lex_state = 0},
  [4714] = {.lex_state = 64},
  [4715] = {.lex_state = 0},
  [4716] = {.lex_state = 64},
  [4717] = {.lex_state = 64, .external_lex_state = 5},
  [4718] = {.lex_state = 0},
  [4719] = {.lex_state = 0},
  [4720] = {.lex_state = 0},
  [4721] = {.lex_state = 0},
  [4722] = {.lex_state = 0},
  [4723] = {.lex_state = 0},
  [4724] = {.lex_state = 0},
  [4725] = {.lex_state = 0, .external_lex_state = 5},
  [4726] = {.lex_state = 10},
  [4727] = {.lex_state = 0, .external_lex_state = 5},
  [4728] = {.lex_state = 64},
  [4729] = {.lex_state = 0},
  [4730] = {.lex_state = 0},
  [4731] = {.lex_state = 0, .external_lex_state = 5},
  [4732] = {.lex_state = 64},
  [4733] = {.lex_state = 0},
  [4734] = {.lex_state = 0},
  [4735] = {.lex_state = 0},
  [4736] = {.lex_state = 0},
  [4737] = {.lex_state = 64},
  [4738] = {.lex_state = 0},
  [4739] = {.lex_state = 0, .external_lex_state = 5},
  [4740] = {.lex_state = 0, .external_lex_state = 5},
  [4741] = {.lex_state = 64},
  [4742] = {.lex_state = 0},
  [4743] = {.lex_state = 10},
  [4744] = {.lex_state = 0},
  [4745] = {.lex_state = 0},
  [4746] = {.lex_state = 0},
  [4747] = {.lex_state = 0},
  [4748] = {.lex_state = 0},
  [4749] = {.lex_state = 0},
  [4750] = {.lex_state = 0, .external_lex_state = 5},
  [4751] = {.lex_state = 64},
  [4752] = {.lex_state = 64},
  [4753] = {.lex_state = 0},
  [4754] = {.lex_state = 0},
  [4755] = {.lex_state = 0},
  [4756] = {.lex_state = 64},
  [4757] = {.lex_state = 64},
  [4758] = {.lex_state = 0},
  [4759] = {.lex_state = 64},
  [4760] = {.lex_state = 0},
  [4761] = {.lex_state = 0},
  [4762] = {.lex_state = 64},
  [4763] = {.lex_state = 64},
  [4764] = {.lex_state = 64},
  [4765] = {.lex_state = 64},
  [4766] = {.lex_state = 64, .external_lex_state = 5},
  [4767] = {.lex_state = 64},
  [4768] = {.lex_state = 64, .external_lex_state = 5},
  [4769] = {.lex_state = 64, .external_lex_state = 5},
  [4770] = {.lex_state = 0, .external_lex_state = 5},
  [4771] = {.lex_state = 0},
  [4772] = {.lex_state = 0},
  [4773] = {.lex_state = 64, .external_lex_state = 5},
  [4774] = {.lex_state = 0},
  [4775] = {.lex_state = 0, .external_lex_state = 5},
  [4776] = {.lex_state = 0},
  [4777] = {.lex_state = 64},
  [4778] = {.lex_state = 0},
  [4779] = {.lex_state = 64},
  [4780] = {.lex_state = 0},
  [4781] = {.lex_state = 0},
  [4782] = {.lex_state = 64},
  [4783] = {.lex_state = 0},
  [4784] = {.lex_state = 0, .external_lex_state = 5},
  [4785] = {.lex_state = 64},
  [4786] = {.lex_state = 0},
  [4787] = {.lex_state = 0},
  [4788] = {.lex_state = 0},
  [4789] = {.lex_state = 0},
  [4790] = {.lex_state = 0, .external_lex_state = 5},
  [4791] = {.lex_state = 0},
  [4792] = {.lex_state = 0, .external_lex_state = 5},
  [4793] = {.lex_state = 0},
  [4794] = {.lex_state = 0},
  [4795] = {.lex_state = 64},
  [4796] = {.lex_state = 0, .external_lex_state = 5},
  [4797] = {.lex_state = 0},
  [4798] = {.lex_state = 64},
  [4799] = {.lex_state = 0},
  [4800] = {.lex_state = 64},
  [4801] = {.lex_state = 64},
  [4802] = {.lex_state = 0},
  [4803] = {.lex_state = 64, .external_lex_state = 5},
  [4804] = {.lex_state = 10},
  [4805] = {.lex_state = 0},
  [4806] = {.lex_state = 0},
  [4807] = {.lex_state = 0, .external_lex_state = 5},
  [4808] = {.lex_state = 0},
  [4809] = {.lex_state = 0},
  [4810] = {.lex_state = 0, .external_lex_state = 5},
  [4811] = {.lex_state = 0, .external_lex_state = 5},
  [4812] = {.lex_state = 0, .external_lex_state = 5},
  [4813] = {.lex_state = 0},
  [4814] = {.lex_state = 0},
  [4815] = {.lex_state = 64},
  [4816] = {.lex_state = 0},
  [4817] = {.lex_state = 64},
  [4818] = {.lex_state = 64},
  [4819] = {.lex_state = 0},
  [4820] = {.lex_state = 0},
  [4821] = {.lex_state = 0},
  [4822] = {.lex_state = 64},
  [4823] = {.lex_state = 0, .external_lex_state = 5},
  [4824] = {.lex_state = 0},
  [4825] = {.lex_state = 0},
  [4826] = {.lex_state = 0},
  [4827] = {.lex_state = 0},
  [4828] = {.lex_state = 0},
  [4829] = {.lex_state = 64},
  [4830] = {.lex_state = 64},
  [4831] = {.lex_state = 0},
  [4832] = {.lex_state = 0},
  [4833] = {.lex_state = 0, .external_lex_state = 5},
  [4834] = {.lex_state = 0, .external_lex_state = 5},
  [4835] = {.lex_state = 64},
  [4836] = {.lex_state = 0},
  [4837] = {.lex_state = 64},
  [4838] = {.lex_state = 64},
  [4839] = {.lex_state = 0, .external_lex_state = 5},
  [4840] = {.lex_state = 0},
  [4841] = {.lex_state = 64},
  [4842] = {.lex_state = 0, .external_lex_state = 5},
  [4843] = {.lex_state = 0, .external_lex_state = 5},
  [4844] = {.lex_state = 0},
  [4845] = {.lex_state = 64},
  [4846] = {.lex_state = 64},
  [4847] = {.lex_state = 0},
  [4848] = {.lex_state = 64},
  [4849] = {.lex_state = 0, .external_lex_state = 5},
  [4850] = {.lex_state = 0},
  [4851] = {.lex_state = 64},
  [4852] = {.lex_state = 64},
  [4853] = {.lex_state = 64},
  [4854] = {.lex_state = 64},
  [4855] = {.lex_state = 64},
  [4856] = {.lex_state = 64},
  [4857] = {.lex_state = 0},
  [4858] = {.lex_state = 0},
  [4859] = {.lex_state = 0, .external_lex_state = 5},
  [4860] = {.lex_state = 0},
  [4861] = {.lex_state = 0},
  [4862] = {.lex_state = 0},
  [4863] = {.lex_state = 64},
  [4864] = {.lex_state = 0},
  [4865] = {.lex_state = 0},
  [4866] = {.lex_state = 0},
  [4867] = {.lex_state = 0, .external_lex_state = 5},
  [4868] = {.lex_state = 64},
  [4869] = {.lex_state = 0},
  [4870] = {.lex_state = 0, .external_lex_state = 5},
  [4871] = {.lex_state = 64},
  [4872] = {.lex_state = 0},
  [4873] = {.lex_state = 0},
  [4874] = {.lex_state = 64},
  [4875] = {.lex_state = 64},
  [4876] = {.lex_state = 0},
  [4877] = {.lex_state = 0, .external_lex_state = 5},
  [4878] = {.lex_state = 0},
  [4879] = {.lex_state = 64},
  [4880] = {.lex_state = 64},
  [4881] = {.lex_state = 64},
  [4882] = {.lex_state = 0, .external_lex_state = 5},
  [4883] = {.lex_state = 0},
  [4884] = {.lex_state = 0},
  [4885] = {.lex_state = 64},
  [4886] = {.lex_state = 0},
  [4887] = {.lex_state = 0},
  [4888] = {.lex_state = 64},
  [4889] = {.lex_state = 64},
  [4890] = {.lex_state = 64},
  [4891] = {.lex_state = 0, .external_lex_state = 5},
  [4892] = {.lex_state = 64},
  [4893] = {.lex_state = 0},
  [4894] = {.lex_state = 0, .external_lex_state = 5},
  [4895] = {.lex_state = 0},
  [4896] = {.lex_state = 0},
  [4897] = {.lex_state = 0},
  [4898] = {.lex_state = 0},
  [4899] = {.lex_state = 64},
  [4900] = {.lex_state = 0},
  [4901] = {.lex_state = 64},
  [4902] = {.lex_state = 0},
  [4903] = {.lex_state = 64},
  [4904] = {.lex_state = 64},
  [4905] = {.lex_state = 64},
  [4906] = {.lex_state = 64},
  [4907] = {.lex_state = 64},
  [4908] = {.lex_state = 64},
  [4909] = {.lex_state = 0, .external_lex_state = 5},
  [4910] = {.lex_state = 64},
  [4911] = {.lex_state = 0},
  [4912] = {.lex_state = 64},
  [4913] = {.lex_state = 0},
  [4914] = {.lex_state = 0, .external_lex_state = 5},
  [4915] = {.lex_state = 64},
  [4916] = {.lex_state = 64},
  [4917] = {.lex_state = 0},
  [4918] = {.lex_state = 0},
  [4919] = {.lex_state = 0},
  [4920] = {.lex_state = 0},
  [4921] = {.lex_state = 0},
  [4922] = {.lex_state = 0},
  [4923] = {.lex_state = 0},
  [4924] = {.lex_state = 0, .external_lex_state = 5},
  [4925] = {.lex_state = 64},
  [4926] = {.lex_state = 0},
  [4927] = {.lex_state = 0},
  [4928] = {.lex_state = 0},
  [4929] = {.lex_state = 0},
  [4930] = {.lex_state = 64},
  [4931] = {.lex_state = 64},
  [4932] = {.lex_state = 64},
  [4933] = {.lex_state = 0},
  [4934] = {.lex_state = 64},
  [4935] = {.lex_state = 64},
  [4936] = {.lex_state = 64},
  [4937] = {.lex_state = 0},
  [4938] = {.lex_state = 0},
  [4939] = {.lex_state = 64},
  [4940] = {.lex_state = 64},
  [4941] = {.lex_state = 0},
  [4942] = {.lex_state = 0},
  [4943] = {.lex_state = 64},
  [4944] = {.lex_state = 64},
  [4945] = {.lex_state = 0},
  [4946] = {.lex_state = 0},
  [4947] = {.lex_state = 0},
  [4948] = {.lex_state = 64},
  [4949] = {.lex_state = 0},
  [4950] = {.lex_state = 0},
  [4951] = {.lex_state = 64},
  [4952] = {.lex_state = 64},
  [4953] = {.lex_state = 0, .external_lex_state = 5},
  [4954] = {.lex_state = 64},
  [4955] = {.lex_state = 0},
  [4956] = {.lex_state = 64},
  [4957] = {.lex_state = 0},
  [4958] = {.lex_state = 64},
  [4959] = {.lex_state = 64},
  [4960] = {.lex_state = 64},
  [4961] = {.lex_state = 64},
  [4962] = {.lex_state = 64},
  [4963] = {.lex_state = 64},
  [4964] = {.lex_state = 0},
  [4965] = {.lex_state = 64},
  [4966] = {.lex_state = 0},
  [4967] = {.lex_state = 0},
  [4968] = {.lex_state = 0},
  [4969] = {.lex_state = 0},
  [4970] = {.lex_state = 64},
  [4971] = {.lex_state = 64},
  [4972] = {.lex_state = 0},
  [4973] = {.lex_state = 0},
  [4974] = {.lex_state = 0},
  [4975] = {.lex_state = 64},
  [4976] = {.lex_state = 0},
  [4977] = {.lex_state = 64},
  [4978] = {.lex_state = 0},
  [4979] = {.lex_state = 0},
  [4980] = {.lex_state = 64},
  [4981] = {.lex_state = 64},
  [4982] = {.lex_state = 0},
  [4983] = {.lex_state = 64},
  [4984] = {.lex_state = 64},
  [4985] = {.lex_state = 64},
  [4986] = {.lex_state = 64},
  [4987] = {.lex_state = 64},
  [4988] = {.lex_state = 64},
  [4989] = {.lex_state = 64},
  [4990] = {.lex_state = 64},
  [4991] = {.lex_state = 0},
  [4992] = {.lex_state = 0},
  [4993] = {.lex_state = 64},
  [4994] = {.lex_state = 64},
  [4995] = {.lex_state = 64},
  [4996] = {.lex_state = 64},
  [4997] = {.lex_state = 64},
  [4998] = {.lex_state = 0},
  [4999] = {.lex_state = 0},
  [5000] = {.lex_state = 0},
  [5001] = {.lex_state = 64},
  [5002] = {.lex_state = 0},
  [5003] = {.lex_state = 64},
  [5004] = {.lex_state = 0},
  [5005] = {.lex_state = 0, .external_lex_state = 5},
  [5006] = {.lex_state = 64},
  [5007] = {.lex_state = 0},
  [5008] = {.lex_state = 64},
  [5009] = {.lex_state = 0},
  [5010] = {.lex_state = 64},
  [5011] = {.lex_state = 64},
  [5012] = {.lex_state = 64},
  [5013] = {.lex_state = 0},
  [5014] = {.lex_state = 64},
  [5015] = {.lex_state = 64},
  [5016] = {.lex_state = 64},
  [5017] = {.lex_state = 0},
  [5018] = {.lex_state = 64},
  [5019] = {.lex_state = 0},
  [5020] = {.lex_state = 0},
  [5021] = {.lex_state = 0},
  [5022] = {.lex_state = 64},
  [5023] = {.lex_state = 0, .external_lex_state = 5},
  [5024] = {.lex_state = 64},
  [5025] = {.lex_state = 0},
  [5026] = {.lex_state = 0},
  [5027] = {.lex_state = 64},
  [5028] = {.lex_state = 64},
  [5029] = {.lex_state = 0},
  [5030] = {.lex_state = 0},
  [5031] = {.lex_state = 64},
  [5032] = {.lex_state = 0},
  [5033] = {.lex_state = 64},
  [5034] = {.lex_state = 0},
  [5035] = {.lex_state = 0},
  [5036] = {.lex_state = 64},
  [5037] = {.lex_state = 0, .external_lex_state = 5},
  [5038] = {.lex_state = 64},
  [5039] = {.lex_state = 64},
  [5040] = {.lex_state = 0},
  [5041] = {.lex_state = 64},
  [5042] = {.lex_state = 0},
  [5043] = {.lex_state = 64},
  [5044] = {.lex_state = 0},
  [5045] = {.lex_state = 64},
  [5046] = {.lex_state = 64},
  [5047] = {.lex_state = 0},
  [5048] = {.lex_state = 0},
  [5049] = {.lex_state = 64},
  [5050] = {.lex_state = 0},
  [5051] = {.lex_state = 64},
  [5052] = {.lex_state = 64},
  [5053] = {.lex_state = 64},
  [5054] = {.lex_state = 64},
  [5055] = {.lex_state = 64},
  [5056] = {.lex_state = 64},
  [5057] = {.lex_state = 0, .external_lex_state = 5},
  [5058] = {.lex_state = 64},
  [5059] = {.lex_state = 0},
  [5060] = {.lex_state = 0},
  [5061] = {.lex_state = 0},
  [5062] = {.lex_state = 64},
  [5063] = {.lex_state = 0},
  [5064] = {.lex_state = 64},
  [5065] = {.lex_state = 0, .external_lex_state = 5},
  [5066] = {.lex_state = 64},
  [5067] = {.lex_state = 64},
  [5068] = {.lex_state = 0},
  [5069] = {.lex_state = 0},
  [5070] = {.lex_state = 64},
  [5071] = {.lex_state = 0},
  [5072] = {.lex_state = 0},
  [5073] = {.lex_state = 64},
  [5074] = {.lex_state = 64},
  [5075] = {.lex_state = 64},
  [5076] = {.lex_state = 0},
  [5077] = {.lex_state = 0},
  [5078] = {.lex_state = 64},
  [5079] = {.lex_state = 64},
  [5080] = {.lex_state = 64},
  [5081] = {.lex_state = 64},
  [5082] = {.lex_state = 0},
  [5083] = {.lex_state = 64},
  [5084] = {.lex_state = 64},
  [5085] = {.lex_state = 64},
  [5086] = {.lex_state = 64},
  [5087] = {.lex_state = 0},
  [5088] = {.lex_state = 64},
  [5089] = {.lex_state = 64},
  [5090] = {.lex_state = 64},
  [5091] = {.lex_state = 0},
  [5092] = {.lex_state = 0},
  [5093] = {.lex_state = 0, .external_lex_state = 5},
  [5094] = {.lex_state = 64},
  [5095] = {.lex_state = 0, .external_lex_state = 5},
  [5096] = {.lex_state = 0},
  [5097] = {.lex_state = 0, .external_lex_state = 5},
  [5098] = {.lex_state = 64},
  [5099] = {.lex_state = 64},
  [5100] = {.lex_state = 64},
  [5101] = {.lex_state = 64},
  [5102] = {.lex_state = 0},
  [5103] = {.lex_state = 0},
  [5104] = {.lex_state = 0},
  [5105] = {.lex_state = 64},
  [5106] = {.lex_state = 64},
  [5107] = {.lex_state = 64},
  [5108] = {.lex_state = 64},
  [5109] = {.lex_state = 0},
  [5110] = {.lex_state = 64},
  [5111] = {.lex_state = 64},
  [5112] = {.lex_state = 0, .external_lex_state = 5},
  [5113] = {.lex_state = 0},
  [5114] = {.lex_state = 0},
  [5115] = {.lex_state = 0, .external_lex_state = 5},
  [5116] = {.lex_state = 64},
  [5117] = {.lex_state = 64},
  [5118] = {.lex_state = 0, .external_lex_state = 5},
  [5119] = {.lex_state = 0, .external_lex_state = 5},
  [5120] = {.lex_state = 0, .external_lex_state = 5},
  [5121] = {.lex_state = 64},
  [5122] = {.lex_state = 0},
  [5123] = {.lex_state = 64},
  [5124] = {.lex_state = 0},
  [5125] = {.lex_state = 0},
  [5126] = {.lex_state = 0},
  [5127] = {.lex_state = 0},
  [5128] = {.lex_state = 0},
  [5129] = {.lex_state = 0},
  [5130] = {.lex_state = 0},
  [5131] = {.lex_state = 0},
  [5132] = {.lex_state = 0},
  [5133] = {.lex_state = 64},
  [5134] = {.lex_state = 0},
  [5135] = {.lex_state = 64},
  [5136] = {.lex_state = 64},
  [5137] = {.lex_state = 64},
  [5138] = {.lex_state = 0},
  [5139] = {.lex_state = 64},
  [5140] = {.lex_state = 0},
  [5141] = {.lex_state = 64},
  [5142] = {.lex_state = 64},
  [5143] = {.lex_state = 64},
  [5144] = {.lex_state = 64},
  [5145] = {.lex_state = 64},
  [5146] = {.lex_state = 0},
  [5147] = {.lex_state = 64},
  [5148] = {.lex_state = 0},
  [5149] = {.lex_state = 0},
  [5150] = {.lex_state = 0},
  [5151] = {.lex_state = 0},
  [5152] = {.lex_state = 64},
  [5153] = {.lex_state = 0},
  [5154] = {.lex_state = 64},
  [5155] = {.lex_state = 64},
  [5156] = {.lex_state = 64},
  [5157] = {.lex_state = 64},
  [5158] = {.lex_state = 64},
  [5159] = {.lex_state = 0},
  [5160] = {.lex_state = 64},
  [5161] = {.lex_state = 64},
  [5162] = {.lex_state = 0},
  [5163] = {.lex_state = 64},
  [5164] = {.lex_state = 64},
  [5165] = {.lex_state = 0},
  [5166] = {.lex_state = 64},
  [5167] = {.lex_state = 0},
  [5168] = {.lex_state = 64},
  [5169] = {.lex_state = 0},
  [5170] = {.lex_state = 64},
  [5171] = {.lex_state = 64},
  [5172] = {.lex_state = 64},
  [5173] = {.lex_state = 64},
  [5174] = {.lex_state = 64},
  [5175] = {.lex_state = 64},
  [5176] = {.lex_state = 64},
  [5177] = {.lex_state = 64},
  [5178] = {.lex_state = 0},
  [5179] = {.lex_state = 0},
  [5180] = {.lex_state = 0},
  [5181] = {.lex_state = 64},
  [5182] = {.lex_state = 0},
  [5183] = {.lex_state = 64},
  [5184] = {.lex_state = 0, .external_lex_state = 5},
  [5185] = {.lex_state = 64},
  [5186] = {.lex_state = 0, .external_lex_state = 5},
  [5187] = {.lex_state = 0},
  [5188] = {.lex_state = 0},
  [5189] = {.lex_state = 0},
  [5190] = {.lex_state = 0, .external_lex_state = 5},
  [5191] = {.lex_state = 0, .external_lex_state = 5},
  [5192] = {.lex_state = 0},
  [5193] = {.lex_state = 0},
  [5194] = {.lex_state = 0},
  [5195] = {.lex_state = 64},
  [5196] = {.lex_state = 0},
  [5197] = {.lex_state = 64},
  [5198] = {.lex_state = 0},
  [5199] = {.lex_state = 64},
  [5200] = {.lex_state = 0},
  [5201] = {.lex_state = 0, .external_lex_state = 5},
  [5202] = {.lex_state = 64},
  [5203] = {.lex_state = 0},
  [5204] = {.lex_state = 64},
  [5205] = {.lex_state = 0},
  [5206] = {.lex_state = 64},
  [5207] = {.lex_state = 64},
  [5208] = {.lex_state = 0},
  [5209] = {.lex_state = 64},
  [5210] = {.lex_state = 0},
  [5211] = {.lex_state = 64},
  [5212] = {.lex_state = 0},
  [5213] = {.lex_state = 64},
  [5214] = {.lex_state = 0},
  [5215] = {.lex_state = 64},
  [5216] = {.lex_state = 64},
  [5217] = {.lex_state = 0},
  [5218] = {.lex_state = 64},
  [5219] = {.lex_state = 0},
  [5220] = {.lex_state = 0},
  [5221] = {.lex_state = 0},
  [5222] = {.lex_state = 0},
  [5223] = {.lex_state = 0},
  [5224] = {.lex_state = 64},
  [5225] = {.lex_state = 0},
  [5226] = {.lex_state = 0},
  [5227] = {.lex_state = 0},
  [5228] = {.lex_state = 0},
  [5229] = {.lex_state = 0},
  [5230] = {.lex_state = 0},
  [5231] = {.lex_state = 64},
  [5232] = {.lex_state = 0},
  [5233] = {.lex_state = 0},
  [5234] = {.lex_state = 0},
  [5235] = {.lex_state = 0},
  [5236] = {.lex_state = 0},
  [5237] = {.lex_state = 64},
  [5238] = {.lex_state = 64},
  [5239] = {.lex_state = 64},
  [5240] = {.lex_state = 0},
  [5241] = {.lex_state = 11},
  [5242] = {.lex_state = 0},
  [5243] = {.lex_state = 64},
  [5244] = {.lex_state = 0},
  [5245] = {.lex_state = 0},
  [5246] = {.lex_state = 64},
  [5247] = {.lex_state = 64},
  [5248] = {.lex_state = 0},
  [5249] = {.lex_state = 64},
  [5250] = {.lex_state = 64},
  [5251] = {.lex_state = 0},
  [5252] = {.lex_state = 0},
  [5253] = {.lex_state = 0},
  [5254] = {.lex_state = 64},
  [5255] = {.lex_state = 64},
  [5256] = {.lex_state = 64},
  [5257] = {.lex_state = 64},
  [5258] = {.lex_state = 0},
  [5259] = {.lex_state = 0},
  [5260] = {.lex_state = 0},
  [5261] = {.lex_state = 0},
  [5262] = {.lex_state = 0},
  [5263] = {.lex_state = 0},
  [5264] = {.lex_state = 0},
  [5265] = {.lex_state = 0},
  [5266] = {.lex_state = 0},
  [5267] = {.lex_state = 64},
  [5268] = {.lex_state = 0},
  [5269] = {.lex_state = 0},
  [5270] = {.lex_state = 1},
  [5271] = {.lex_state = 64},
  [5272] = {.lex_state = 0},
  [5273] = {.lex_state = 0},
  [5274] = {.lex_state = 0},
  [5275] = {.lex_state = 0},
  [5276] = {.lex_state = 0},
  [5277] = {.lex_state = 0},
  [5278] = {.lex_state = 1},
  [5279] = {.lex_state = 0},
  [5280] = {.lex_state = 0},
  [5281] = {.lex_state = 0},
  [5282] = {.lex_state = 0},
  [5283] = {.lex_state = 0},
  [5284] = {.lex_state = 64},
  [5285] = {.lex_state = 0},
  [5286] = {.lex_state = 0},
  [5287] = {.lex_state = 0},
  [5288] = {.lex_state = 64},
  [5289] = {.lex_state = 0},
  [5290] = {.lex_state = 0},
  [5291] = {.lex_state = 11},
  [5292] = {.lex_state = 0},
  [5293] = {.lex_state = 64},
  [5294] = {.lex_state = 0},
  [5295] = {.lex_state = 0},
  [5296] = {.lex_state = 0},
  [5297] = {.lex_state = 64},
  [5298] = {.lex_state = 0},
  [5299] = {.lex_state = 0},
  [5300] = {.lex_state = 0},
  [5301] = {.lex_state = 0},
  [5302] = {.lex_state = 0},
  [5303] = {.lex_state = 0},
  [5304] = {.lex_state = 0},
  [5305] = {.lex_state = 0},
  [5306] = {.lex_state = 0},
  [5307] = {.lex_state = 0},
  [5308] = {.lex_state = 0},
  [5309] = {.lex_state = 0},
  [5310] = {.lex_state = 0},
  [5311] = {.lex_state = 0},
  [5312] = {.lex_state = 64},
  [5313] = {.lex_state = 64},
  [5314] = {.lex_state = 0},
  [5315] = {.lex_state = 0},
  [5316] = {.lex_state = 0},
  [5317] = {.lex_state = 0},
  [5318] = {.lex_state = 64},
  [5319] = {.lex_state = 0},
  [5320] = {.lex_state = 0},
  [5321] = {.lex_state = 64},
  [5322] = {.lex_state = 0},
  [5323] = {.lex_state = 0},
  [5324] = {.lex_state = 11},
  [5325] = {.lex_state = 0},
  [5326] = {.lex_state = 0},
  [5327] = {.lex_state = 0},
  [5328] = {.lex_state = 64},
  [5329] = {.lex_state = 0},
  [5330] = {.lex_state = 0},
  [5331] = {.lex_state = 0},
  [5332] = {.lex_state = 0},
  [5333] = {.lex_state = 64},
  [5334] = {.lex_state = 0},
  [5335] = {.lex_state = 0},
  [5336] = {.lex_state = 0},
  [5337] = {.lex_state = 0},
  [5338] = {.lex_state = 64},
  [5339] = {.lex_state = 1},
  [5340] = {.lex_state = 0},
  [5341] = {.lex_state = 64},
  [5342] = {.lex_state = 64},
  [5343] = {.lex_state = 64},
  [5344] = {.lex_state = 0},
  [5345] = {.lex_state = 0},
  [5346] = {.lex_state = 0},
  [5347] = {.lex_state = 0},
  [5348] = {.lex_state = 0},
  [5349] = {.lex_state = 0},
  [5350] = {.lex_state = 0},
  [5351] = {.lex_state = 64},
  [5352] = {.lex_state = 0},
  [5353] = {.lex_state = 0},
  [5354] = {.lex_state = 0},
  [5355] = {.lex_state = 0},
  [5356] = {.lex_state = 0},
  [5357] = {.lex_state = 0},
  [5358] = {.lex_state = 0},
  [5359] = {.lex_state = 0},
  [5360] = {.lex_state = 64},
  [5361] = {.lex_state = 0},
  [5362] = {.lex_state = 64},
  [5363] = {.lex_state = 64},
  [5364] = {.lex_state = 0},
  [5365] = {.lex_state = 0},
  [5366] = {.lex_state = 64},
  [5367] = {.lex_state = 64},
  [5368] = {.lex_state = 0},
  [5369] = {.lex_state = 0},
  [5370] = {.lex_state = 0},
  [5371] = {.lex_state = 0},
  [5372] = {.lex_state = 64},
  [5373] = {.lex_state = 64},
  [5374] = {.lex_state = 64},
  [5375] = {.lex_state = 0},
  [5376] = {.lex_state = 0},
  [5377] = {.lex_state = 11},
  [5378] = {.lex_state = 0},
  [5379] = {.lex_state = 0},
  [5380] = {.lex_state = 64},
  [5381] = {.lex_state = 0},
  [5382] = {.lex_state = 0},
  [5383] = {.lex_state = 0},
  [5384] = {.lex_state = 0},
  [5385] = {.lex_state = 1},
  [5386] = {.lex_state = 64},
  [5387] = {.lex_state = 0},
  [5388] = {.lex_state = 0},
  [5389] = {.lex_state = 0},
  [5390] = {.lex_state = 0},
  [5391] = {.lex_state = 0},
  [5392] = {.lex_state = 0},
  [5393] = {.lex_state = 0},
  [5394] = {.lex_state = 64},
  [5395] = {.lex_state = 0},
  [5396] = {.lex_state = 0},
  [5397] = {.lex_state = 0},
  [5398] = {.lex_state = 64},
  [5399] = {.lex_state = 64},
  [5400] = {.lex_state = 64},
  [5401] = {.lex_state = 0},
  [5402] = {.lex_state = 0},
  [5403] = {.lex_state = 0},
  [5404] = {.lex_state = 0},
  [5405] = {.lex_state = 11},
  [5406] = {.lex_state = 64},
  [5407] = {.lex_state = 0},
  [5408] = {.lex_state = 1},
  [5409] = {.lex_state = 64},
  [5410] = {.lex_state = 0},
  [5411] = {.lex_state = 64},
  [5412] = {.lex_state = 0},
  [5413] = {.lex_state = 0},
  [5414] = {.lex_state = 64},
  [5415] = {.lex_state = 0},
  [5416] = {.lex_state = 0},
  [5417] = {.lex_state = 0},
  [5418] = {.lex_state = 0},
  [5419] = {.lex_state = 0},
  [5420] = {.lex_state = 0},
  [5421] = {.lex_state = 0},
  [5422] = {.lex_state = 64},
  [5423] = {.lex_state = 0},
  [5424] = {.lex_state = 0},
  [5425] = {.lex_state = 0},
  [5426] = {.lex_state = 64},
  [5427] = {.lex_state = 0},
  [5428] = {.lex_state = 0},
  [5429] = {.lex_state = 64},
  [5430] = {.lex_state = 0},
  [5431] = {.lex_state = 0},
  [5432] = {.lex_state = 0},
  [5433] = {.lex_state = 0},
  [5434] = {.lex_state = 0},
  [5435] = {.lex_state = 0},
  [5436] = {.lex_state = 0},
  [5437] = {.lex_state = 0},
  [5438] = {.lex_state = 0},
  [5439] = {.lex_state = 0},
  [5440] = {.lex_state = 0},
  [5441] = {.lex_state = 0},
  [5442] = {.lex_state = 0},
  [5443] = {.lex_state = 0},
  [5444] = {.lex_state = 0},
  [5445] = {.lex_state = 0},
  [5446] = {.lex_state = 11},
  [5447] = {.lex_state = 0},
  [5448] = {.lex_state = 0},
  [5449] = {.lex_state = 0},
  [5450] = {.lex_state = 64},
  [5451] = {.lex_state = 64},
  [5452] = {.lex_state = 0},
  [5453] = {.lex_state = 0},
  [5454] = {.lex_state = 64},
  [5455] = {.lex_state = 64},
  [5456] = {.lex_state = 0},
  [5457] = {.lex_state = 0},
  [5458] = {.lex_state = 64},
  [5459] = {.lex_state = 64},
  [5460] = {.lex_state = 0},
  [5461] = {.lex_state = 1},
  [5462] = {.lex_state = 0},
  [5463] = {.lex_state = 0},
  [5464] = {.lex_state = 0},
  [5465] = {.lex_state = 0},
  [5466] = {.lex_state = 0},
  [5467] = {.lex_state = 0},
  [5468] = {.lex_state = 0},
  [5469] = {.lex_state = 0},
  [5470] = {.lex_state = 0},
  [5471] = {.lex_state = 0},
  [5472] = {.lex_state = 0},
  [5473] = {.lex_state = 0},
  [5474] = {.lex_state = 0},
  [5475] = {.lex_state = 0},
  [5476] = {.lex_state = 0},
  [5477] = {.lex_state = 0},
  [5478] = {.lex_state = 64},
  [5479] = {.lex_state = 0},
  [5480] = {.lex_state = 0},
  [5481] = {.lex_state = 64},
  [5482] = {.lex_state = 64},
  [5483] = {.lex_state = 0},
  [5484] = {.lex_state = 0},
  [5485] = {.lex_state = 64},
  [5486] = {.lex_state = 64},
  [5487] = {.lex_state = 0},
  [5488] = {.lex_state = 0},
  [5489] = {.lex_state = 0},
  [5490] = {.lex_state = 64},
  [5491] = {.lex_state = 0},
  [5492] = {.lex_state = 64},
  [5493] = {.lex_state = 0},
  [5494] = {.lex_state = 0},
  [5495] = {.lex_state = 11},
  [5496] = {.lex_state = 0},
  [5497] = {.lex_state = 0},
  [5498] = {.lex_state = 0},
  [5499] = {.lex_state = 0},
  [5500] = {.lex_state = 0},
  [5501] = {.lex_state = 0},
  [5502] = {.lex_state = 0},
  [5503] = {.lex_state = 64},
  [5504] = {.lex_state = 0},
  [5505] = {.lex_state = 11},
  [5506] = {.lex_state = 0},
  [5507] = {.lex_state = 0},
  [5508] = {.lex_state = 0},
  [5509] = {.lex_state = 0},
  [5510] = {.lex_state = 0},
  [5511] = {.lex_state = 0},
  [5512] = {.lex_state = 0},
  [5513] = {.lex_state = 0},
  [5514] = {.lex_state = 0},
  [5515] = {.lex_state = 64},
  [5516] = {.lex_state = 0},
  [5517] = {.lex_state = 0},
  [5518] = {.lex_state = 1},
  [5519] = {.lex_state = 64},
  [5520] = {.lex_state = 0},
  [5521] = {.lex_state = 64},
  [5522] = {.lex_state = 0},
  [5523] = {.lex_state = 64},
  [5524] = {.lex_state = 64},
  [5525] = {.lex_state = 0},
  [5526] = {.lex_state = 0},
  [5527] = {.lex_state = 0},
  [5528] = {.lex_state = 0},
  [5529] = {.lex_state = 0},
  [5530] = {.lex_state = 0},
  [5531] = {.lex_state = 64},
  [5532] = {.lex_state = 0},
  [5533] = {.lex_state = 1},
  [5534] = {.lex_state = 0},
  [5535] = {.lex_state = 0},
  [5536] = {.lex_state = 0},
  [5537] = {.lex_state = 0},
  [5538] = {.lex_state = 0},
  [5539] = {.lex_state = 0},
  [5540] = {.lex_state = 0},
  [5541] = {.lex_state = 64},
  [5542] = {.lex_state = 64},
  [5543] = {.lex_state = 0},
  [5544] = {.lex_state = 0},
  [5545] = {.lex_state = 0},
  [5546] = {.lex_state = 64},
  [5547] = {.lex_state = 0},
  [5548] = {.lex_state = 0},
  [5549] = {.lex_state = 0},
  [5550] = {.lex_state = 0},
  [5551] = {.lex_state = 0},
  [5552] = {.lex_state = 0},
  [5553] = {.lex_state = 64},
  [5554] = {.lex_state = 0},
  [5555] = {.lex_state = 64},
  [5556] = {.lex_state = 0},
  [5557] = {.lex_state = 0},
  [5558] = {.lex_state = 0},
  [5559] = {.lex_state = 64},
  [5560] = {.lex_state = 0},
  [5561] = {.lex_state = 0},
  [5562] = {.lex_state = 0},
  [5563] = {.lex_state = 11},
  [5564] = {.lex_state = 0},
  [5565] = {.lex_state = 64},
  [5566] = {.lex_state = 0},
  [5567] = {.lex_state = 0},
  [5568] = {.lex_state = 1},
  [5569] = {.lex_state = 64},
  [5570] = {.lex_state = 0},
  [5571] = {.lex_state = 0},
  [5572] = {.lex_state = 0},
  [5573] = {.lex_state = 0},
  [5574] = {.lex_state = 0},
  [5575] = {.lex_state = 0},
  [5576] = {.lex_state = 0},
  [5577] = {.lex_state = 0},
  [5578] = {.lex_state = 0},
  [5579] = {.lex_state = 0},
  [5580] = {.lex_state = 64},
  [5581] = {.lex_state = 0},
  [5582] = {.lex_state = 64},
  [5583] = {.lex_state = 0},
  [5584] = {.lex_state = 64},
  [5585] = {.lex_state = 0},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
  ts_external_token__function_signature_automatic_semicolon = 3,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [7] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(5517),
    [sym_export_statement] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [2] = {
    [sym_export_statement] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5444),
    [sym_object_assignment_pattern] = STATE(4923),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5444),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5444),
    [sym_spread_element] = STATE(4921),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(3109),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_rest_pattern] = STATE(4923),
    [sym_method_definition] = STATE(4921),
    [sym_pair] = STATE(4921),
    [sym_pair_pattern] = STATE(4923),
    [sym__property_name] = STATE(3959),
    [sym_computed_property_name] = STATE(3959),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_accessibility_modifier] = STATE(3620),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [aux_sym_object_repeat1] = STATE(4918),
    [aux_sym_object_pattern_repeat1] = STATE(4917),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(115),
    [anon_sym_type] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(127),
    [anon_sym_static] = ACTIONS(129),
    [anon_sym_readonly] = ACTIONS(131),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(133),
    [anon_sym_set] = ACTIONS(133),
    [anon_sym_public] = ACTIONS(135),
    [anon_sym_private] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [3] = {
    [sym_export_statement] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5444),
    [sym_object_assignment_pattern] = STATE(4923),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5444),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5444),
    [sym_spread_element] = STATE(4921),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(3109),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_rest_pattern] = STATE(4923),
    [sym_method_definition] = STATE(4921),
    [sym_pair] = STATE(4921),
    [sym_pair_pattern] = STATE(4923),
    [sym__property_name] = STATE(3959),
    [sym_computed_property_name] = STATE(3959),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_accessibility_modifier] = STATE(3620),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [aux_sym_object_repeat1] = STATE(4918),
    [aux_sym_object_pattern_repeat1] = STATE(4917),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(127),
    [anon_sym_static] = ACTIONS(129),
    [anon_sym_readonly] = ACTIONS(131),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(133),
    [anon_sym_set] = ACTIONS(133),
    [anon_sym_public] = ACTIONS(135),
    [anon_sym_private] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [4] = {
    [sym_export_statement] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5444),
    [sym_object_assignment_pattern] = STATE(4923),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5444),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5444),
    [sym_spread_element] = STATE(4814),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(3109),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_rest_pattern] = STATE(4923),
    [sym_method_definition] = STATE(4814),
    [sym_pair] = STATE(4814),
    [sym_pair_pattern] = STATE(4923),
    [sym__property_name] = STATE(3959),
    [sym_computed_property_name] = STATE(3959),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_accessibility_modifier] = STATE(3620),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [aux_sym_object_repeat1] = STATE(4791),
    [aux_sym_object_pattern_repeat1] = STATE(4917),
    [sym_identifier] = ACTIONS(143),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(153),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(155),
    [anon_sym_static] = ACTIONS(157),
    [anon_sym_readonly] = ACTIONS(159),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(161),
    [anon_sym_set] = ACTIONS(161),
    [anon_sym_public] = ACTIONS(163),
    [anon_sym_private] = ACTIONS(163),
    [anon_sym_protected] = ACTIONS(163),
    [anon_sym_module] = ACTIONS(165),
    [anon_sym_any] = ACTIONS(167),
    [anon_sym_number] = ACTIONS(167),
    [anon_sym_boolean] = ACTIONS(167),
    [anon_sym_string] = ACTIONS(167),
    [anon_sym_symbol] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [5] = {
    [sym_export_statement] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_for_in_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_debugger_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_empty_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5444),
    [sym_object_assignment_pattern] = STATE(4923),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5444),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5444),
    [sym_spread_element] = STATE(4921),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(3109),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_rest_pattern] = STATE(4923),
    [sym_method_definition] = STATE(4921),
    [sym_pair] = STATE(4921),
    [sym_pair_pattern] = STATE(4923),
    [sym__property_name] = STATE(3959),
    [sym_computed_property_name] = STATE(3959),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_accessibility_modifier] = STATE(3620),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(33),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [aux_sym_object_repeat1] = STATE(4918),
    [aux_sym_object_pattern_repeat1] = STATE(4917),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_export] = ACTIONS(171),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(175),
    [anon_sym_type] = ACTIONS(177),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(179),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(181),
    [anon_sym_static] = ACTIONS(183),
    [anon_sym_readonly] = ACTIONS(185),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(187),
    [anon_sym_set] = ACTIONS(187),
    [anon_sym_public] = ACTIONS(189),
    [anon_sym_private] = ACTIONS(189),
    [anon_sym_protected] = ACTIONS(189),
    [anon_sym_module] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [6] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5444),
    [sym_object_assignment_pattern] = STATE(4923),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5444),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5444),
    [sym_spread_element] = STATE(4919),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(3109),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_rest_pattern] = STATE(4923),
    [sym_method_definition] = STATE(4919),
    [sym_pair] = STATE(4919),
    [sym_pair_pattern] = STATE(4923),
    [sym__property_name] = STATE(3959),
    [sym_computed_property_name] = STATE(3959),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_accessibility_modifier] = STATE(3620),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [aux_sym_object_repeat1] = STATE(4819),
    [aux_sym_object_pattern_repeat1] = STATE(4917),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_export] = ACTIONS(197),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(199),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_type] = ACTIONS(203),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(205),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(207),
    [anon_sym_static] = ACTIONS(209),
    [anon_sym_readonly] = ACTIONS(211),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(213),
    [anon_sym_public] = ACTIONS(215),
    [anon_sym_private] = ACTIONS(215),
    [anon_sym_protected] = ACTIONS(215),
    [anon_sym_module] = ACTIONS(217),
    [anon_sym_any] = ACTIONS(219),
    [anon_sym_number] = ACTIONS(219),
    [anon_sym_boolean] = ACTIONS(219),
    [anon_sym_string] = ACTIONS(219),
    [anon_sym_symbol] = ACTIONS(219),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [7] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5444),
    [sym_object_assignment_pattern] = STATE(4923),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5444),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5444),
    [sym_spread_element] = STATE(4789),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(3109),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_rest_pattern] = STATE(4923),
    [sym_method_definition] = STATE(4789),
    [sym_pair] = STATE(4789),
    [sym_pair_pattern] = STATE(4923),
    [sym__property_name] = STATE(3959),
    [sym_computed_property_name] = STATE(3959),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_accessibility_modifier] = STATE(3620),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [aux_sym_object_repeat1] = STATE(4760),
    [aux_sym_object_pattern_repeat1] = STATE(4917),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_export] = ACTIONS(223),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(225),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(227),
    [anon_sym_type] = ACTIONS(229),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(231),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(233),
    [anon_sym_static] = ACTIONS(235),
    [anon_sym_readonly] = ACTIONS(237),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(239),
    [anon_sym_set] = ACTIONS(239),
    [anon_sym_public] = ACTIONS(241),
    [anon_sym_private] = ACTIONS(241),
    [anon_sym_protected] = ACTIONS(241),
    [anon_sym_module] = ACTIONS(243),
    [anon_sym_any] = ACTIONS(245),
    [anon_sym_number] = ACTIONS(245),
    [anon_sym_boolean] = ACTIONS(245),
    [anon_sym_string] = ACTIONS(245),
    [anon_sym_symbol] = ACTIONS(245),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [8] = {
    [sym_export_statement] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_for_in_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_debugger_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_empty_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5444),
    [sym_object_assignment_pattern] = STATE(4923),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5444),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5444),
    [sym_spread_element] = STATE(4921),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(3109),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_rest_pattern] = STATE(4923),
    [sym_method_definition] = STATE(4921),
    [sym_pair] = STATE(4921),
    [sym_pair_pattern] = STATE(4923),
    [sym__property_name] = STATE(3959),
    [sym_computed_property_name] = STATE(3959),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_accessibility_modifier] = STATE(3620),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(33),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [aux_sym_object_repeat1] = STATE(4918),
    [aux_sym_object_pattern_repeat1] = STATE(4917),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_type] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(127),
    [anon_sym_static] = ACTIONS(129),
    [anon_sym_readonly] = ACTIONS(131),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(133),
    [anon_sym_set] = ACTIONS(133),
    [anon_sym_public] = ACTIONS(135),
    [anon_sym_private] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [9] = {
    [sym_export_statement] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5444),
    [sym_object_assignment_pattern] = STATE(4923),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5444),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5444),
    [sym_spread_element] = STATE(4814),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(3109),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_rest_pattern] = STATE(4923),
    [sym_method_definition] = STATE(4814),
    [sym_pair] = STATE(4814),
    [sym_pair_pattern] = STATE(4923),
    [sym__property_name] = STATE(3959),
    [sym_computed_property_name] = STATE(3959),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_accessibility_modifier] = STATE(3620),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [aux_sym_object_repeat1] = STATE(4791),
    [aux_sym_object_pattern_repeat1] = STATE(4917),
    [sym_identifier] = ACTIONS(249),
    [anon_sym_export] = ACTIONS(251),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_type] = ACTIONS(257),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(261),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(267),
    [anon_sym_set] = ACTIONS(267),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(271),
    [anon_sym_any] = ACTIONS(273),
    [anon_sym_number] = ACTIONS(273),
    [anon_sym_boolean] = ACTIONS(273),
    [anon_sym_string] = ACTIONS(273),
    [anon_sym_symbol] = ACTIONS(273),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [10] = {
    [sym_export_statement] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5444),
    [sym_object_assignment_pattern] = STATE(4923),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5444),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5444),
    [sym_spread_element] = STATE(4814),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(3109),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_rest_pattern] = STATE(4923),
    [sym_method_definition] = STATE(4814),
    [sym_pair] = STATE(4814),
    [sym_pair_pattern] = STATE(4923),
    [sym__property_name] = STATE(3959),
    [sym_computed_property_name] = STATE(3959),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_accessibility_modifier] = STATE(3620),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [aux_sym_object_repeat1] = STATE(4791),
    [aux_sym_object_pattern_repeat1] = STATE(4917),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(281),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(283),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(285),
    [anon_sym_static] = ACTIONS(287),
    [anon_sym_readonly] = ACTIONS(289),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(291),
    [anon_sym_set] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(293),
    [anon_sym_private] = ACTIONS(293),
    [anon_sym_protected] = ACTIONS(293),
    [anon_sym_module] = ACTIONS(295),
    [anon_sym_any] = ACTIONS(297),
    [anon_sym_number] = ACTIONS(297),
    [anon_sym_boolean] = ACTIONS(297),
    [anon_sym_string] = ACTIONS(297),
    [anon_sym_symbol] = ACTIONS(297),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [11] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [ts_builtin_sym_end] = ACTIONS(299),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_export] = ACTIONS(304),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_namespace] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(312),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_type] = ACTIONS(315),
    [anon_sym_typeof] = ACTIONS(318),
    [anon_sym_import] = ACTIONS(321),
    [anon_sym_var] = ACTIONS(324),
    [anon_sym_let] = ACTIONS(327),
    [anon_sym_const] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(336),
    [anon_sym_switch] = ACTIONS(339),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_LPAREN] = ACTIONS(345),
    [anon_sym_await] = ACTIONS(348),
    [anon_sym_while] = ACTIONS(351),
    [anon_sym_do] = ACTIONS(354),
    [anon_sym_try] = ACTIONS(357),
    [anon_sym_with] = ACTIONS(360),
    [anon_sym_break] = ACTIONS(363),
    [anon_sym_continue] = ACTIONS(366),
    [anon_sym_debugger] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(372),
    [anon_sym_throw] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(378),
    [anon_sym_case] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(390),
    [anon_sym_class] = ACTIONS(393),
    [anon_sym_async] = ACTIONS(396),
    [anon_sym_function] = ACTIONS(399),
    [anon_sym_new] = ACTIONS(402),
    [anon_sym_PLUS] = ACTIONS(405),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_TILDE] = ACTIONS(333),
    [anon_sym_void] = ACTIONS(318),
    [anon_sym_delete] = ACTIONS(318),
    [anon_sym_PLUS_PLUS] = ACTIONS(408),
    [anon_sym_DASH_DASH] = ACTIONS(408),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [anon_sym_SQUOTE] = ACTIONS(414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_number] = ACTIONS(420),
    [sym_this] = ACTIONS(423),
    [sym_super] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_null] = ACTIONS(423),
    [sym_undefined] = ACTIONS(423),
    [anon_sym_AT] = ACTIONS(426),
    [anon_sym_declare] = ACTIONS(429),
    [anon_sym_static] = ACTIONS(432),
    [anon_sym_readonly] = ACTIONS(432),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(432),
    [anon_sym_private] = ACTIONS(432),
    [anon_sym_protected] = ACTIONS(432),
    [anon_sym_module] = ACTIONS(438),
    [anon_sym_any] = ACTIONS(432),
    [anon_sym_number] = ACTIONS(432),
    [anon_sym_boolean] = ACTIONS(432),
    [anon_sym_string] = ACTIONS(432),
    [anon_sym_symbol] = ACTIONS(432),
    [anon_sym_interface] = ACTIONS(441),
    [anon_sym_enum] = ACTIONS(444),
  },
  [12] = {
    [sym_export_statement] = STATE(13),
    [sym_declaration] = STATE(13),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(447),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(447),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [13] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(451),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [14] = {
    [sym_export_statement] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(455),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [15] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(459),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [16] = {
    [sym_export_statement] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [17] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(465),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [18] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(467),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [19] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [20] = {
    [sym_export_statement] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [21] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [ts_builtin_sym_end] = ACTIONS(473),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [22] = {
    [sym_export_statement] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_for_in_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_debugger_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_throw_statement] = STATE(29),
    [sym_empty_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(475),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [23] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [24] = {
    [sym_export_statement] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(34),
    [sym_if_statement] = STATE(34),
    [sym_switch_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_for_in_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_do_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_debugger_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_throw_statement] = STATE(34),
    [sym_empty_statement] = STATE(34),
    [sym_labeled_statement] = STATE(34),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(34),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [ts_builtin_sym_end] = ACTIONS(473),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [25] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [26] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [27] = {
    [sym_export_statement] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_for_in_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_debugger_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_empty_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(33),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [28] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [29] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [30] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [31] = {
    [sym_export_statement] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(491),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [32] = {
    [sym_export_statement] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(26),
    [sym_expression_statement] = STATE(26),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_switch_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_for_in_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_do_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_break_statement] = STATE(26),
    [sym_continue_statement] = STATE(26),
    [sym_debugger_statement] = STATE(26),
    [sym_return_statement] = STATE(26),
    [sym_throw_statement] = STATE(26),
    [sym_empty_statement] = STATE(26),
    [sym_labeled_statement] = STATE(26),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(26),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(493),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [33] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [34] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [ts_builtin_sym_end] = ACTIONS(497),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [35] = {
    [sym_export_statement] = STATE(1121),
    [sym_declaration] = STATE(1121),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1121),
    [sym_expression_statement] = STATE(1121),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1121),
    [sym_if_statement] = STATE(1121),
    [sym_switch_statement] = STATE(1121),
    [sym_for_statement] = STATE(1121),
    [sym_for_in_statement] = STATE(1121),
    [sym_while_statement] = STATE(1121),
    [sym_do_statement] = STATE(1121),
    [sym_try_statement] = STATE(1121),
    [sym_with_statement] = STATE(1121),
    [sym_break_statement] = STATE(1121),
    [sym_continue_statement] = STATE(1121),
    [sym_debugger_statement] = STATE(1121),
    [sym_return_statement] = STATE(1121),
    [sym_throw_statement] = STATE(1121),
    [sym_empty_statement] = STATE(1121),
    [sym_labeled_statement] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [36] = {
    [sym_export_statement] = STATE(1121),
    [sym_declaration] = STATE(1121),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1121),
    [sym_expression_statement] = STATE(1121),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1121),
    [sym_if_statement] = STATE(1121),
    [sym_switch_statement] = STATE(1121),
    [sym_for_statement] = STATE(1121),
    [sym_for_in_statement] = STATE(1121),
    [sym_while_statement] = STATE(1121),
    [sym_do_statement] = STATE(1121),
    [sym_try_statement] = STATE(1121),
    [sym_with_statement] = STATE(1121),
    [sym_break_statement] = STATE(1121),
    [sym_continue_statement] = STATE(1121),
    [sym_debugger_statement] = STATE(1121),
    [sym_return_statement] = STATE(1121),
    [sym_throw_statement] = STATE(1121),
    [sym_empty_statement] = STATE(1121),
    [sym_labeled_statement] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(2933),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4207),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_export] = ACTIONS(501),
    [anon_sym_namespace] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(507),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(527),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [37] = {
    [sym_export_statement] = STATE(1064),
    [sym_declaration] = STATE(1064),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1064),
    [sym_expression_statement] = STATE(1064),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1064),
    [sym_if_statement] = STATE(1064),
    [sym_switch_statement] = STATE(1064),
    [sym_for_statement] = STATE(1064),
    [sym_for_in_statement] = STATE(1064),
    [sym_while_statement] = STATE(1064),
    [sym_do_statement] = STATE(1064),
    [sym_try_statement] = STATE(1064),
    [sym_with_statement] = STATE(1064),
    [sym_break_statement] = STATE(1064),
    [sym_continue_statement] = STATE(1064),
    [sym_debugger_statement] = STATE(1064),
    [sym_return_statement] = STATE(1064),
    [sym_throw_statement] = STATE(1064),
    [sym_empty_statement] = STATE(1064),
    [sym_labeled_statement] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(2933),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4207),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_export] = ACTIONS(501),
    [anon_sym_namespace] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(507),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(527),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [38] = {
    [sym_export_statement] = STATE(1120),
    [sym_declaration] = STATE(1120),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1120),
    [sym_expression_statement] = STATE(1120),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1120),
    [sym_if_statement] = STATE(1120),
    [sym_switch_statement] = STATE(1120),
    [sym_for_statement] = STATE(1120),
    [sym_for_in_statement] = STATE(1120),
    [sym_while_statement] = STATE(1120),
    [sym_do_statement] = STATE(1120),
    [sym_try_statement] = STATE(1120),
    [sym_with_statement] = STATE(1120),
    [sym_break_statement] = STATE(1120),
    [sym_continue_statement] = STATE(1120),
    [sym_debugger_statement] = STATE(1120),
    [sym_return_statement] = STATE(1120),
    [sym_throw_statement] = STATE(1120),
    [sym_empty_statement] = STATE(1120),
    [sym_labeled_statement] = STATE(1120),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(2933),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4207),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_export] = ACTIONS(501),
    [anon_sym_namespace] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(507),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(527),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [39] = {
    [sym_export_statement] = STATE(1066),
    [sym_declaration] = STATE(1066),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1066),
    [sym_expression_statement] = STATE(1066),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1066),
    [sym_if_statement] = STATE(1066),
    [sym_switch_statement] = STATE(1066),
    [sym_for_statement] = STATE(1066),
    [sym_for_in_statement] = STATE(1066),
    [sym_while_statement] = STATE(1066),
    [sym_do_statement] = STATE(1066),
    [sym_try_statement] = STATE(1066),
    [sym_with_statement] = STATE(1066),
    [sym_break_statement] = STATE(1066),
    [sym_continue_statement] = STATE(1066),
    [sym_debugger_statement] = STATE(1066),
    [sym_return_statement] = STATE(1066),
    [sym_throw_statement] = STATE(1066),
    [sym_empty_statement] = STATE(1066),
    [sym_labeled_statement] = STATE(1066),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(2933),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4207),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_export] = ACTIONS(501),
    [anon_sym_namespace] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(507),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(527),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [40] = {
    [sym_export_statement] = STATE(1083),
    [sym_declaration] = STATE(1083),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1083),
    [sym_expression_statement] = STATE(1083),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1083),
    [sym_if_statement] = STATE(1083),
    [sym_switch_statement] = STATE(1083),
    [sym_for_statement] = STATE(1083),
    [sym_for_in_statement] = STATE(1083),
    [sym_while_statement] = STATE(1083),
    [sym_do_statement] = STATE(1083),
    [sym_try_statement] = STATE(1083),
    [sym_with_statement] = STATE(1083),
    [sym_break_statement] = STATE(1083),
    [sym_continue_statement] = STATE(1083),
    [sym_debugger_statement] = STATE(1083),
    [sym_return_statement] = STATE(1083),
    [sym_throw_statement] = STATE(1083),
    [sym_empty_statement] = STATE(1083),
    [sym_labeled_statement] = STATE(1083),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [41] = {
    [sym_export_statement] = STATE(1120),
    [sym_declaration] = STATE(1120),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1120),
    [sym_expression_statement] = STATE(1120),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1120),
    [sym_if_statement] = STATE(1120),
    [sym_switch_statement] = STATE(1120),
    [sym_for_statement] = STATE(1120),
    [sym_for_in_statement] = STATE(1120),
    [sym_while_statement] = STATE(1120),
    [sym_do_statement] = STATE(1120),
    [sym_try_statement] = STATE(1120),
    [sym_with_statement] = STATE(1120),
    [sym_break_statement] = STATE(1120),
    [sym_continue_statement] = STATE(1120),
    [sym_debugger_statement] = STATE(1120),
    [sym_return_statement] = STATE(1120),
    [sym_throw_statement] = STATE(1120),
    [sym_empty_statement] = STATE(1120),
    [sym_labeled_statement] = STATE(1120),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [42] = {
    [sym_export_statement] = STATE(1068),
    [sym_declaration] = STATE(1068),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1068),
    [sym_expression_statement] = STATE(1068),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1068),
    [sym_if_statement] = STATE(1068),
    [sym_switch_statement] = STATE(1068),
    [sym_for_statement] = STATE(1068),
    [sym_for_in_statement] = STATE(1068),
    [sym_while_statement] = STATE(1068),
    [sym_do_statement] = STATE(1068),
    [sym_try_statement] = STATE(1068),
    [sym_with_statement] = STATE(1068),
    [sym_break_statement] = STATE(1068),
    [sym_continue_statement] = STATE(1068),
    [sym_debugger_statement] = STATE(1068),
    [sym_return_statement] = STATE(1068),
    [sym_throw_statement] = STATE(1068),
    [sym_empty_statement] = STATE(1068),
    [sym_labeled_statement] = STATE(1068),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(2933),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4207),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_export] = ACTIONS(501),
    [anon_sym_namespace] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(507),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(527),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [43] = {
    [sym_export_statement] = STATE(5367),
    [sym_declaration] = STATE(5367),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(5367),
    [sym_expression_statement] = STATE(5367),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(5367),
    [sym_if_statement] = STATE(5367),
    [sym_switch_statement] = STATE(5367),
    [sym_for_statement] = STATE(5367),
    [sym_for_in_statement] = STATE(5367),
    [sym_while_statement] = STATE(5367),
    [sym_do_statement] = STATE(5367),
    [sym_try_statement] = STATE(5367),
    [sym_with_statement] = STATE(5367),
    [sym_break_statement] = STATE(5367),
    [sym_continue_statement] = STATE(5367),
    [sym_debugger_statement] = STATE(5367),
    [sym_return_statement] = STATE(5367),
    [sym_throw_statement] = STATE(5367),
    [sym_empty_statement] = STATE(5367),
    [sym_labeled_statement] = STATE(5367),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(2933),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4207),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_export] = ACTIONS(501),
    [anon_sym_namespace] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(507),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(527),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [44] = {
    [sym_export_statement] = STATE(1063),
    [sym_declaration] = STATE(1063),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1063),
    [sym_expression_statement] = STATE(1063),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1063),
    [sym_if_statement] = STATE(1063),
    [sym_switch_statement] = STATE(1063),
    [sym_for_statement] = STATE(1063),
    [sym_for_in_statement] = STATE(1063),
    [sym_while_statement] = STATE(1063),
    [sym_do_statement] = STATE(1063),
    [sym_try_statement] = STATE(1063),
    [sym_with_statement] = STATE(1063),
    [sym_break_statement] = STATE(1063),
    [sym_continue_statement] = STATE(1063),
    [sym_debugger_statement] = STATE(1063),
    [sym_return_statement] = STATE(1063),
    [sym_throw_statement] = STATE(1063),
    [sym_empty_statement] = STATE(1063),
    [sym_labeled_statement] = STATE(1063),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [45] = {
    [sym_export_statement] = STATE(1066),
    [sym_declaration] = STATE(1066),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1066),
    [sym_expression_statement] = STATE(1066),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1066),
    [sym_if_statement] = STATE(1066),
    [sym_switch_statement] = STATE(1066),
    [sym_for_statement] = STATE(1066),
    [sym_for_in_statement] = STATE(1066),
    [sym_while_statement] = STATE(1066),
    [sym_do_statement] = STATE(1066),
    [sym_try_statement] = STATE(1066),
    [sym_with_statement] = STATE(1066),
    [sym_break_statement] = STATE(1066),
    [sym_continue_statement] = STATE(1066),
    [sym_debugger_statement] = STATE(1066),
    [sym_return_statement] = STATE(1066),
    [sym_throw_statement] = STATE(1066),
    [sym_empty_statement] = STATE(1066),
    [sym_labeled_statement] = STATE(1066),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [46] = {
    [sym_export_statement] = STATE(1140),
    [sym_declaration] = STATE(1140),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1140),
    [sym_expression_statement] = STATE(1140),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1140),
    [sym_if_statement] = STATE(1140),
    [sym_switch_statement] = STATE(1140),
    [sym_for_statement] = STATE(1140),
    [sym_for_in_statement] = STATE(1140),
    [sym_while_statement] = STATE(1140),
    [sym_do_statement] = STATE(1140),
    [sym_try_statement] = STATE(1140),
    [sym_with_statement] = STATE(1140),
    [sym_break_statement] = STATE(1140),
    [sym_continue_statement] = STATE(1140),
    [sym_debugger_statement] = STATE(1140),
    [sym_return_statement] = STATE(1140),
    [sym_throw_statement] = STATE(1140),
    [sym_empty_statement] = STATE(1140),
    [sym_labeled_statement] = STATE(1140),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [47] = {
    [sym_export_statement] = STATE(1064),
    [sym_declaration] = STATE(1064),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1064),
    [sym_expression_statement] = STATE(1064),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1064),
    [sym_if_statement] = STATE(1064),
    [sym_switch_statement] = STATE(1064),
    [sym_for_statement] = STATE(1064),
    [sym_for_in_statement] = STATE(1064),
    [sym_while_statement] = STATE(1064),
    [sym_do_statement] = STATE(1064),
    [sym_try_statement] = STATE(1064),
    [sym_with_statement] = STATE(1064),
    [sym_break_statement] = STATE(1064),
    [sym_continue_statement] = STATE(1064),
    [sym_debugger_statement] = STATE(1064),
    [sym_return_statement] = STATE(1064),
    [sym_throw_statement] = STATE(1064),
    [sym_empty_statement] = STATE(1064),
    [sym_labeled_statement] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [48] = {
    [sym_export_statement] = STATE(4892),
    [sym_declaration] = STATE(4892),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(4892),
    [sym_expression_statement] = STATE(4892),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(4892),
    [sym_if_statement] = STATE(4892),
    [sym_switch_statement] = STATE(4892),
    [sym_for_statement] = STATE(4892),
    [sym_for_in_statement] = STATE(4892),
    [sym_while_statement] = STATE(4892),
    [sym_do_statement] = STATE(4892),
    [sym_try_statement] = STATE(4892),
    [sym_with_statement] = STATE(4892),
    [sym_break_statement] = STATE(4892),
    [sym_continue_statement] = STATE(4892),
    [sym_debugger_statement] = STATE(4892),
    [sym_return_statement] = STATE(4892),
    [sym_throw_statement] = STATE(4892),
    [sym_empty_statement] = STATE(4892),
    [sym_labeled_statement] = STATE(4892),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(2933),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4207),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_export] = ACTIONS(501),
    [anon_sym_namespace] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(507),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(527),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [49] = {
    [sym_export_statement] = STATE(1140),
    [sym_declaration] = STATE(1140),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1140),
    [sym_expression_statement] = STATE(1140),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1140),
    [sym_if_statement] = STATE(1140),
    [sym_switch_statement] = STATE(1140),
    [sym_for_statement] = STATE(1140),
    [sym_for_in_statement] = STATE(1140),
    [sym_while_statement] = STATE(1140),
    [sym_do_statement] = STATE(1140),
    [sym_try_statement] = STATE(1140),
    [sym_with_statement] = STATE(1140),
    [sym_break_statement] = STATE(1140),
    [sym_continue_statement] = STATE(1140),
    [sym_debugger_statement] = STATE(1140),
    [sym_return_statement] = STATE(1140),
    [sym_throw_statement] = STATE(1140),
    [sym_empty_statement] = STATE(1140),
    [sym_labeled_statement] = STATE(1140),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(2933),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4207),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_export] = ACTIONS(501),
    [anon_sym_namespace] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(507),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(527),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [50] = {
    [sym_export_statement] = STATE(1083),
    [sym_declaration] = STATE(1083),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1083),
    [sym_expression_statement] = STATE(1083),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1083),
    [sym_if_statement] = STATE(1083),
    [sym_switch_statement] = STATE(1083),
    [sym_for_statement] = STATE(1083),
    [sym_for_in_statement] = STATE(1083),
    [sym_while_statement] = STATE(1083),
    [sym_do_statement] = STATE(1083),
    [sym_try_statement] = STATE(1083),
    [sym_with_statement] = STATE(1083),
    [sym_break_statement] = STATE(1083),
    [sym_continue_statement] = STATE(1083),
    [sym_debugger_statement] = STATE(1083),
    [sym_return_statement] = STATE(1083),
    [sym_throw_statement] = STATE(1083),
    [sym_empty_statement] = STATE(1083),
    [sym_labeled_statement] = STATE(1083),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(2933),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4207),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_export] = ACTIONS(501),
    [anon_sym_namespace] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(507),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(527),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [51] = {
    [sym_export_statement] = STATE(1061),
    [sym_declaration] = STATE(1061),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1061),
    [sym_expression_statement] = STATE(1061),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1061),
    [sym_if_statement] = STATE(1061),
    [sym_switch_statement] = STATE(1061),
    [sym_for_statement] = STATE(1061),
    [sym_for_in_statement] = STATE(1061),
    [sym_while_statement] = STATE(1061),
    [sym_do_statement] = STATE(1061),
    [sym_try_statement] = STATE(1061),
    [sym_with_statement] = STATE(1061),
    [sym_break_statement] = STATE(1061),
    [sym_continue_statement] = STATE(1061),
    [sym_debugger_statement] = STATE(1061),
    [sym_return_statement] = STATE(1061),
    [sym_throw_statement] = STATE(1061),
    [sym_empty_statement] = STATE(1061),
    [sym_labeled_statement] = STATE(1061),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [52] = {
    [sym_export_statement] = STATE(1068),
    [sym_declaration] = STATE(1068),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1068),
    [sym_expression_statement] = STATE(1068),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1068),
    [sym_if_statement] = STATE(1068),
    [sym_switch_statement] = STATE(1068),
    [sym_for_statement] = STATE(1068),
    [sym_for_in_statement] = STATE(1068),
    [sym_while_statement] = STATE(1068),
    [sym_do_statement] = STATE(1068),
    [sym_try_statement] = STATE(1068),
    [sym_with_statement] = STATE(1068),
    [sym_break_statement] = STATE(1068),
    [sym_continue_statement] = STATE(1068),
    [sym_debugger_statement] = STATE(1068),
    [sym_return_statement] = STATE(1068),
    [sym_throw_statement] = STATE(1068),
    [sym_empty_statement] = STATE(1068),
    [sym_labeled_statement] = STATE(1068),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(157),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [53] = {
    [sym_export_statement] = STATE(1063),
    [sym_declaration] = STATE(1063),
    [sym_import] = STATE(2275),
    [sym_import_statement] = STATE(1063),
    [sym_expression_statement] = STATE(1063),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_statement_block] = STATE(1063),
    [sym_if_statement] = STATE(1063),
    [sym_switch_statement] = STATE(1063),
    [sym_for_statement] = STATE(1063),
    [sym_for_in_statement] = STATE(1063),
    [sym_while_statement] = STATE(1063),
    [sym_do_statement] = STATE(1063),
    [sym_try_statement] = STATE(1063),
    [sym_with_statement] = STATE(1063),
    [sym_break_statement] = STATE(1063),
    [sym_continue_statement] = STATE(1063),
    [sym_debugger_statement] = STATE(1063),
    [sym_return_statement] = STATE(1063),
    [sym_throw_statement] = STATE(1063),
    [sym_empty_statement] = STATE(1063),
    [sym_labeled_statement] = STATE(1063),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_class_declaration] = STATE(1094),
    [sym_function] = STATE(2275),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function] = STATE(2275),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_function_signature] = STATE(1094),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(2933),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4207),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_export] = ACTIONS(501),
    [anon_sym_namespace] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(507),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(527),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [54] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [55] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2777),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4745),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4744),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [56] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2718),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4738),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4735),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [57] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4776),
    [sym_optional_tuple_parameter] = STATE(4776),
    [sym_optional_type] = STATE(4776),
    [sym_rest_type] = STATE(4776),
    [sym__tuple_type_member] = STATE(4776),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [58] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [59] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [60] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2718),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4738),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4735),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [61] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [62] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [63] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2718),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4738),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4735),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [64] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2718),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4738),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4735),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [65] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [66] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [67] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2718),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4738),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4735),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [68] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(633),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [69] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2721),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4730),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4736),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [70] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2777),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4745),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4744),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(637),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [71] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2721),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4730),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3341),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4489),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5127),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4736),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(599),
    [anon_sym_number] = ACTIONS(599),
    [anon_sym_boolean] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_symbol] = ACTIONS(599),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [72] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2522),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym__formal_parameter] = STATE(4828),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5550),
    [sym_string] = STATE(3298),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4414),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4529),
    [sym_constructor_type] = STATE(4529),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4529),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5013),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4529),
    [sym_union_type] = STATE(4529),
    [sym_intersection_type] = STATE(4529),
    [sym_function_type] = STATE(4529),
    [aux_sym_export_statement_repeat1] = STATE(3534),
    [sym_identifier] = ACTIONS(641),
    [anon_sym_export] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_typeof] = ACTIONS(649),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(667),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(669),
    [sym_this] = ACTIONS(671),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(643),
    [anon_sym_set] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(677),
    [anon_sym_private] = ACTIONS(677),
    [anon_sym_protected] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_any] = ACTIONS(679),
    [anon_sym_number] = ACTIONS(679),
    [anon_sym_boolean] = ACTIONS(679),
    [anon_sym_string] = ACTIONS(679),
    [anon_sym_symbol] = ACTIONS(679),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [73] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2551),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym__formal_parameter] = STATE(4828),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5494),
    [sym_string] = STATE(3298),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4414),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4529),
    [sym_constructor_type] = STATE(4529),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4529),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5013),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4529),
    [sym_union_type] = STATE(4529),
    [sym_intersection_type] = STATE(4529),
    [sym_function_type] = STATE(4529),
    [aux_sym_export_statement_repeat1] = STATE(3534),
    [sym_identifier] = ACTIONS(641),
    [anon_sym_export] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_typeof] = ACTIONS(649),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(667),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(669),
    [sym_this] = ACTIONS(671),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(643),
    [anon_sym_set] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(677),
    [anon_sym_private] = ACTIONS(677),
    [anon_sym_protected] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_any] = ACTIONS(679),
    [anon_sym_number] = ACTIONS(679),
    [anon_sym_boolean] = ACTIONS(679),
    [anon_sym_string] = ACTIONS(679),
    [anon_sym_symbol] = ACTIONS(679),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [74] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2514),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym__formal_parameter] = STATE(4828),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5410),
    [sym_string] = STATE(3298),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4414),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4529),
    [sym_constructor_type] = STATE(4529),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4529),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5013),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4529),
    [sym_union_type] = STATE(4529),
    [sym_intersection_type] = STATE(4529),
    [sym_function_type] = STATE(4529),
    [aux_sym_export_statement_repeat1] = STATE(3534),
    [sym_identifier] = ACTIONS(641),
    [anon_sym_export] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_typeof] = ACTIONS(649),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(667),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(669),
    [sym_this] = ACTIONS(671),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(643),
    [anon_sym_set] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(677),
    [anon_sym_private] = ACTIONS(677),
    [anon_sym_protected] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_any] = ACTIONS(679),
    [anon_sym_number] = ACTIONS(679),
    [anon_sym_boolean] = ACTIONS(679),
    [anon_sym_string] = ACTIONS(679),
    [anon_sym_symbol] = ACTIONS(679),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [75] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2482),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym__formal_parameter] = STATE(4828),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5378),
    [sym_string] = STATE(3298),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4414),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4529),
    [sym_constructor_type] = STATE(4529),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4529),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5013),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4529),
    [sym_union_type] = STATE(4529),
    [sym_intersection_type] = STATE(4529),
    [sym_function_type] = STATE(4529),
    [aux_sym_export_statement_repeat1] = STATE(3534),
    [sym_identifier] = ACTIONS(641),
    [anon_sym_export] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_typeof] = ACTIONS(649),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(667),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(669),
    [sym_this] = ACTIONS(671),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(643),
    [anon_sym_set] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(677),
    [anon_sym_private] = ACTIONS(677),
    [anon_sym_protected] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_any] = ACTIONS(679),
    [anon_sym_number] = ACTIONS(679),
    [anon_sym_boolean] = ACTIONS(679),
    [anon_sym_string] = ACTIONS(679),
    [anon_sym_symbol] = ACTIONS(679),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [76] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2514),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym__formal_parameter] = STATE(4828),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5410),
    [sym_string] = STATE(3298),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4414),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4649),
    [sym_constructor_type] = STATE(4649),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4649),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5013),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4649),
    [sym_union_type] = STATE(4649),
    [sym_intersection_type] = STATE(4649),
    [sym_function_type] = STATE(4649),
    [aux_sym_export_statement_repeat1] = STATE(3534),
    [sym_identifier] = ACTIONS(641),
    [anon_sym_export] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_typeof] = ACTIONS(649),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(667),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(669),
    [sym_this] = ACTIONS(671),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(643),
    [anon_sym_set] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(677),
    [anon_sym_private] = ACTIONS(677),
    [anon_sym_protected] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_any] = ACTIONS(679),
    [anon_sym_number] = ACTIONS(679),
    [anon_sym_boolean] = ACTIONS(679),
    [anon_sym_string] = ACTIONS(679),
    [anon_sym_symbol] = ACTIONS(679),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [77] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2890),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4927),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4927),
    [sym_nested_identifier] = STATE(5331),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4927),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2733),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4446),
    [sym_pattern] = STATE(5140),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3717),
    [sym__type] = STATE(3857),
    [sym_constructor_type] = STATE(3857),
    [sym__primary_type] = STATE(3784),
    [sym_infer_type] = STATE(3857),
    [sym_conditional_type] = STATE(3782),
    [sym_generic_type] = STATE(3782),
    [sym_type_query] = STATE(3782),
    [sym_index_type_query] = STATE(3782),
    [sym_lookup_type] = STATE(3782),
    [sym_literal_type] = STATE(3782),
    [sym__number] = STATE(3780),
    [sym_existential_type] = STATE(3782),
    [sym_flow_maybe_type] = STATE(3782),
    [sym_parenthesized_type] = STATE(3782),
    [sym_predefined_type] = STATE(3782),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3782),
    [sym_type_parameters] = STATE(5104),
    [sym_array_type] = STATE(3782),
    [sym_tuple_type] = STATE(3782),
    [sym_readonly_type] = STATE(3857),
    [sym_union_type] = STATE(3857),
    [sym_intersection_type] = STATE(3857),
    [sym_function_type] = STATE(3857),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(683),
    [anon_sym_export] = ACTIONS(685),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_namespace] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(691),
    [anon_sym_type] = ACTIONS(685),
    [anon_sym_typeof] = ACTIONS(693),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(699),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(711),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(713),
    [sym_this] = ACTIONS(715),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(717),
    [sym_false] = ACTIONS(717),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(685),
    [anon_sym_static] = ACTIONS(685),
    [anon_sym_readonly] = ACTIONS(719),
    [anon_sym_get] = ACTIONS(685),
    [anon_sym_set] = ACTIONS(685),
    [anon_sym_public] = ACTIONS(685),
    [anon_sym_private] = ACTIONS(685),
    [anon_sym_protected] = ACTIONS(685),
    [anon_sym_module] = ACTIONS(685),
    [anon_sym_any] = ACTIONS(721),
    [anon_sym_number] = ACTIONS(721),
    [anon_sym_boolean] = ACTIONS(721),
    [anon_sym_string] = ACTIONS(721),
    [anon_sym_symbol] = ACTIONS(721),
    [anon_sym_infer] = ACTIONS(723),
    [anon_sym_keyof] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [78] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2434),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2426),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(729),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(737),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(753),
    [sym_this] = ACTIONS(755),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(759),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(761),
    [anon_sym_number] = ACTIONS(761),
    [anon_sym_boolean] = ACTIONS(761),
    [anon_sym_string] = ACTIONS(761),
    [anon_sym_symbol] = ACTIONS(761),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [79] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3013),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2579),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(819),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(765),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(787),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(789),
    [anon_sym_DASH] = ACTIONS(789),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(803),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(805),
    [anon_sym_number] = ACTIONS(805),
    [anon_sym_boolean] = ACTIONS(805),
    [anon_sym_string] = ACTIONS(805),
    [anon_sym_symbol] = ACTIONS(805),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [80] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3250),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3073),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(858),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(815),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(827),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(829),
    [anon_sym_DASH] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(837),
    [sym_this] = ACTIONS(839),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(841),
    [sym_false] = ACTIONS(841),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(845),
    [anon_sym_number] = ACTIONS(845),
    [anon_sym_boolean] = ACTIONS(845),
    [anon_sym_string] = ACTIONS(845),
    [anon_sym_symbol] = ACTIONS(845),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [81] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2146),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(513),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(855),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(881),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(883),
    [sym_false] = ACTIONS(883),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(885),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(887),
    [anon_sym_number] = ACTIONS(887),
    [anon_sym_boolean] = ACTIONS(887),
    [anon_sym_string] = ACTIONS(887),
    [anon_sym_symbol] = ACTIONS(887),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [82] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2647),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(3236),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(818),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(897),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(923),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(931),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(933),
    [sym_false] = ACTIONS(933),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(935),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(937),
    [anon_sym_number] = ACTIONS(937),
    [anon_sym_boolean] = ACTIONS(937),
    [anon_sym_string] = ACTIONS(937),
    [anon_sym_symbol] = ACTIONS(937),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [83] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2464),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2146),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(608),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(939),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(945),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(959),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(963),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(881),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(883),
    [sym_false] = ACTIONS(883),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(971),
    [anon_sym_number] = ACTIONS(971),
    [anon_sym_boolean] = ACTIONS(971),
    [anon_sym_string] = ACTIONS(971),
    [anon_sym_symbol] = ACTIONS(971),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [84] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2542),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2956),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(694),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(981),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(989),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(993),
    [sym_this] = ACTIONS(995),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(997),
    [sym_false] = ACTIONS(997),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(999),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(1001),
    [anon_sym_number] = ACTIONS(1001),
    [anon_sym_boolean] = ACTIONS(1001),
    [anon_sym_string] = ACTIONS(1001),
    [anon_sym_symbol] = ACTIONS(1001),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [85] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3020),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2579),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(551),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1003),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1011),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_DASH] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [86] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2112),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2330),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(698),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1035),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1041),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1043),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1065),
    [sym_this] = ACTIONS(1067),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1071),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1073),
    [anon_sym_boolean] = ACTIONS(1073),
    [anon_sym_string] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1073),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [87] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2287),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2704),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(851),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1075),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1109),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1121),
    [sym_this] = ACTIONS(1123),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1127),
    [sym_false] = ACTIONS(1127),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1129),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [88] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2773),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2146),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(616),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1133),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1139),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1149),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(881),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(883),
    [sym_false] = ACTIONS(883),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1159),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1161),
    [anon_sym_number] = ACTIONS(1161),
    [anon_sym_boolean] = ACTIONS(1161),
    [anon_sym_string] = ACTIONS(1161),
    [anon_sym_symbol] = ACTIONS(1161),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [89] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2473),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4526),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4526),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4526),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3358),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4363),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4516),
    [sym_constructor_type] = STATE(4516),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4516),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(681),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5205),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4516),
    [sym_union_type] = STATE(4516),
    [sym_intersection_type] = STATE(4516),
    [sym_function_type] = STATE(4516),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1163),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1165),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(1167),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1181),
    [sym_this] = ACTIONS(1183),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(1185),
    [sym_false] = ACTIONS(1185),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(1187),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(1189),
    [anon_sym_number] = ACTIONS(1189),
    [anon_sym_boolean] = ACTIONS(1189),
    [anon_sym_string] = ACTIONS(1189),
    [anon_sym_symbol] = ACTIONS(1189),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(1191),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [90] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2086),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2146),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(775),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1193),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1199),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1213),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(881),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(883),
    [sym_false] = ACTIONS(883),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1221),
    [anon_sym_number] = ACTIONS(1221),
    [anon_sym_boolean] = ACTIONS(1221),
    [anon_sym_string] = ACTIONS(1221),
    [anon_sym_symbol] = ACTIONS(1221),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [91] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2215),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_STAR] = ACTIONS(1225),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1233),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
    [anon_sym_extends] = ACTIONS(1227),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1231),
    [sym__automatic_semicolon] = ACTIONS(1231),
  },
  [92] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2593),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2579),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(673),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1245),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1259),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1265),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1267),
    [anon_sym_number] = ACTIONS(1267),
    [anon_sym_boolean] = ACTIONS(1267),
    [anon_sym_string] = ACTIONS(1267),
    [anon_sym_symbol] = ACTIONS(1267),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [93] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2859),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2426),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(630),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1269),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1275),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1287),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1291),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(753),
    [sym_this] = ACTIONS(755),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1297),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1299),
    [anon_sym_number] = ACTIONS(1299),
    [anon_sym_boolean] = ACTIONS(1299),
    [anon_sym_string] = ACTIONS(1299),
    [anon_sym_symbol] = ACTIONS(1299),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [94] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2399),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2330),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(693),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1301),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1309),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1317),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1325),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1065),
    [sym_this] = ACTIONS(1067),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1331),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1333),
    [anon_sym_number] = ACTIONS(1333),
    [anon_sym_boolean] = ACTIONS(1333),
    [anon_sym_string] = ACTIONS(1333),
    [anon_sym_symbol] = ACTIONS(1333),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [95] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2251),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2698),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(729),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1335),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1343),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1355),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1359),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1365),
    [sym_this] = ACTIONS(1367),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1371),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1373),
    [anon_sym_number] = ACTIONS(1373),
    [anon_sym_boolean] = ACTIONS(1373),
    [anon_sym_string] = ACTIONS(1373),
    [anon_sym_symbol] = ACTIONS(1373),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [96] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2603),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3267),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(864),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1383),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1389),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1421),
    [sym_this] = ACTIONS(1423),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1427),
    [sym_false] = ACTIONS(1427),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1431),
    [anon_sym_number] = ACTIONS(1431),
    [anon_sym_boolean] = ACTIONS(1431),
    [anon_sym_string] = ACTIONS(1431),
    [anon_sym_symbol] = ACTIONS(1431),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [97] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2905),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(3123),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(714),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1439),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1453),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1457),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1463),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1469),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1471),
    [anon_sym_number] = ACTIONS(1471),
    [anon_sym_boolean] = ACTIONS(1471),
    [anon_sym_string] = ACTIONS(1471),
    [anon_sym_symbol] = ACTIONS(1471),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [98] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2208),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_COLON] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_RBRACK] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
    [anon_sym_extends] = ACTIONS(1227),
  },
  [99] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3076),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3073),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(823),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1489),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1495),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1497),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1507),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1511),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(837),
    [sym_this] = ACTIONS(839),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(841),
    [sym_false] = ACTIONS(841),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1519),
    [anon_sym_number] = ACTIONS(1519),
    [anon_sym_boolean] = ACTIONS(1519),
    [anon_sym_string] = ACTIONS(1519),
    [anon_sym_symbol] = ACTIONS(1519),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [100] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3263),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4361),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4180),
    [sym_constructor_type] = STATE(4180),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4180),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_type_arguments] = STATE(690),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5050),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4180),
    [sym_union_type] = STATE(4180),
    [sym_intersection_type] = STATE(4180),
    [sym_function_type] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1521),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1527),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1389),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1553),
    [sym_this] = ACTIONS(1555),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1559),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1561),
    [anon_sym_number] = ACTIONS(1561),
    [anon_sym_boolean] = ACTIONS(1561),
    [anon_sym_string] = ACTIONS(1561),
    [anon_sym_symbol] = ACTIONS(1561),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [101] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2268),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(1565),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_COLON] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_RBRACK] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [102] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5480),
    [sym_pattern] = STATE(4305),
    [sym_rest_pattern] = STATE(3978),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4030),
    [sym_constructor_type] = STATE(4030),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4030),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5002),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4030),
    [sym_union_type] = STATE(4030),
    [sym_intersection_type] = STATE(4030),
    [sym_function_type] = STATE(4030),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_COMMA] = ACTIONS(1584),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(1584),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(1603),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1619),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1625),
    [anon_sym_number] = ACTIONS(1625),
    [anon_sym_boolean] = ACTIONS(1625),
    [anon_sym_string] = ACTIONS(1625),
    [anon_sym_symbol] = ACTIONS(1625),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [103] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2415),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(1629),
    [anon_sym_EQ] = ACTIONS(1227),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
    [anon_sym_extends] = ACTIONS(1227),
    [sym__automatic_semicolon] = ACTIONS(1231),
  },
  [104] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2244),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(1641),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
    [anon_sym_extends] = ACTIONS(1227),
    [sym__automatic_semicolon] = ACTIONS(1231),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1231),
  },
  [105] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2510),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [sym__automatic_semicolon] = ACTIONS(1231),
  },
  [106] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2445),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1661),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1663),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
    [anon_sym_extends] = ACTIONS(1227),
    [sym__automatic_semicolon] = ACTIONS(1231),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1231),
  },
  [107] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2543),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_STAR] = ACTIONS(1669),
    [anon_sym_EQ] = ACTIONS(1227),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1673),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
    [anon_sym_extends] = ACTIONS(1227),
  },
  [108] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(1681),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
    [anon_sym_implements] = ACTIONS(1227),
    [anon_sym_extends] = ACTIONS(1227),
  },
  [109] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2706),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(1231),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_extends] = ACTIONS(1227),
  },
  [110] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2820),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
    [anon_sym_extends] = ACTIONS(1227),
    [sym__automatic_semicolon] = ACTIONS(1231),
  },
  [111] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2468),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1709),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
    [anon_sym_extends] = ACTIONS(1227),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1231),
  },
  [112] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2497),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1721),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_COLON] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
    [anon_sym_extends] = ACTIONS(1227),
  },
  [113] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2980),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(1733),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1735),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(1231),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
    [anon_sym_extends] = ACTIONS(1227),
  },
  [114] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2769),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
    [anon_sym_implements] = ACTIONS(1227),
  },
  [115] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2880),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1749),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_RBRACK] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
    [anon_sym_extends] = ACTIONS(1227),
  },
  [116] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(3046),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_STAR] = ACTIONS(1757),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
    [sym__automatic_semicolon] = ACTIONS(1231),
  },
  [117] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2765),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(1765),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1231),
  },
  [118] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3325),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(1773),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_RBRACK] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [119] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3117),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_COLON] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_QMARK_DOT] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_QMARK_QMARK] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [120] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1789),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [121] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1811),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1813),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [122] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1815),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1817),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1597),
  },
  [123] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [124] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1821),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [125] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1825),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1827),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [126] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1829),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1831),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1597),
  },
  [127] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1833),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1835),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [128] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1839),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1841),
    [sym_identifier] = ACTIONS(1843),
    [anon_sym_export] = ACTIONS(1843),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_default] = ACTIONS(1843),
    [anon_sym_EQ] = ACTIONS(1847),
    [anon_sym_as] = ACTIONS(1845),
    [anon_sym_namespace] = ACTIONS(1843),
    [anon_sym_LBRACE] = ACTIONS(1841),
    [anon_sym_COMMA] = ACTIONS(1849),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_type] = ACTIONS(1843),
    [anon_sym_typeof] = ACTIONS(1843),
    [anon_sym_import] = ACTIONS(1843),
    [anon_sym_var] = ACTIONS(1843),
    [anon_sym_let] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(1843),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_else] = ACTIONS(1843),
    [anon_sym_if] = ACTIONS(1843),
    [anon_sym_switch] = ACTIONS(1843),
    [anon_sym_for] = ACTIONS(1843),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_await] = ACTIONS(1843),
    [anon_sym_in] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1843),
    [anon_sym_do] = ACTIONS(1843),
    [anon_sym_try] = ACTIONS(1843),
    [anon_sym_with] = ACTIONS(1843),
    [anon_sym_break] = ACTIONS(1843),
    [anon_sym_continue] = ACTIONS(1843),
    [anon_sym_debugger] = ACTIONS(1843),
    [anon_sym_return] = ACTIONS(1843),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_SEMI] = ACTIONS(1841),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_yield] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_GT] = ACTIONS(1845),
    [anon_sym_SLASH] = ACTIONS(1843),
    [anon_sym_DOT] = ACTIONS(1845),
    [anon_sym_class] = ACTIONS(1843),
    [anon_sym_async] = ACTIONS(1843),
    [anon_sym_function] = ACTIONS(1843),
    [anon_sym_QMARK_DOT] = ACTIONS(1849),
    [anon_sym_new] = ACTIONS(1843),
    [anon_sym_QMARK] = ACTIONS(1845),
    [anon_sym_AMP_AMP] = ACTIONS(1849),
    [anon_sym_PIPE_PIPE] = ACTIONS(1849),
    [anon_sym_GT_GT] = ACTIONS(1845),
    [anon_sym_GT_GT_GT] = ACTIONS(1849),
    [anon_sym_LT_LT] = ACTIONS(1849),
    [anon_sym_AMP] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1849),
    [anon_sym_PIPE] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_PERCENT] = ACTIONS(1849),
    [anon_sym_STAR_STAR] = ACTIONS(1849),
    [anon_sym_LT_EQ] = ACTIONS(1849),
    [anon_sym_EQ_EQ] = ACTIONS(1845),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1849),
    [anon_sym_BANG_EQ] = ACTIONS(1845),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1849),
    [anon_sym_GT_EQ] = ACTIONS(1849),
    [anon_sym_QMARK_QMARK] = ACTIONS(1849),
    [anon_sym_instanceof] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1841),
    [anon_sym_void] = ACTIONS(1843),
    [anon_sym_delete] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_DQUOTE] = ACTIONS(1841),
    [anon_sym_SQUOTE] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1841),
    [sym_number] = ACTIONS(1841),
    [sym_this] = ACTIONS(1843),
    [sym_super] = ACTIONS(1843),
    [sym_true] = ACTIONS(1843),
    [sym_false] = ACTIONS(1843),
    [sym_null] = ACTIONS(1843),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(1841),
    [anon_sym_declare] = ACTIONS(1843),
    [anon_sym_static] = ACTIONS(1843),
    [anon_sym_readonly] = ACTIONS(1843),
    [anon_sym_abstract] = ACTIONS(1843),
    [anon_sym_get] = ACTIONS(1843),
    [anon_sym_set] = ACTIONS(1843),
    [anon_sym_public] = ACTIONS(1843),
    [anon_sym_private] = ACTIONS(1843),
    [anon_sym_protected] = ACTIONS(1843),
    [anon_sym_module] = ACTIONS(1843),
    [anon_sym_any] = ACTIONS(1843),
    [anon_sym_number] = ACTIONS(1843),
    [anon_sym_boolean] = ACTIONS(1843),
    [anon_sym_string] = ACTIONS(1843),
    [anon_sym_symbol] = ACTIONS(1843),
    [anon_sym_interface] = ACTIONS(1843),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(1851),
  },
  [130] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1853),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1855),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [131] = {
    [sym_statement_block] = STATE(154),
    [ts_builtin_sym_end] = ACTIONS(1857),
    [sym_identifier] = ACTIONS(1859),
    [anon_sym_export] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_default] = ACTIONS(1859),
    [anon_sym_as] = ACTIONS(1859),
    [anon_sym_namespace] = ACTIONS(1859),
    [anon_sym_LBRACE] = ACTIONS(1861),
    [anon_sym_COMMA] = ACTIONS(1857),
    [anon_sym_RBRACE] = ACTIONS(1857),
    [anon_sym_type] = ACTIONS(1859),
    [anon_sym_typeof] = ACTIONS(1859),
    [anon_sym_import] = ACTIONS(1859),
    [anon_sym_var] = ACTIONS(1859),
    [anon_sym_let] = ACTIONS(1859),
    [anon_sym_const] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(1859),
    [anon_sym_else] = ACTIONS(1859),
    [anon_sym_if] = ACTIONS(1859),
    [anon_sym_switch] = ACTIONS(1859),
    [anon_sym_for] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_in] = ACTIONS(1859),
    [anon_sym_while] = ACTIONS(1859),
    [anon_sym_do] = ACTIONS(1859),
    [anon_sym_try] = ACTIONS(1859),
    [anon_sym_with] = ACTIONS(1859),
    [anon_sym_break] = ACTIONS(1859),
    [anon_sym_continue] = ACTIONS(1859),
    [anon_sym_debugger] = ACTIONS(1859),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_throw] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_case] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1859),
    [anon_sym_DOT] = ACTIONS(1859),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_async] = ACTIONS(1859),
    [anon_sym_function] = ACTIONS(1859),
    [anon_sym_QMARK_DOT] = ACTIONS(1857),
    [anon_sym_new] = ACTIONS(1859),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_AMP_AMP] = ACTIONS(1857),
    [anon_sym_PIPE_PIPE] = ACTIONS(1857),
    [anon_sym_GT_GT] = ACTIONS(1859),
    [anon_sym_GT_GT_GT] = ACTIONS(1857),
    [anon_sym_LT_LT] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_LT_EQ] = ACTIONS(1857),
    [anon_sym_EQ_EQ] = ACTIONS(1859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1857),
    [anon_sym_BANG_EQ] = ACTIONS(1859),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1857),
    [anon_sym_GT_EQ] = ACTIONS(1857),
    [anon_sym_QMARK_QMARK] = ACTIONS(1857),
    [anon_sym_instanceof] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_void] = ACTIONS(1859),
    [anon_sym_delete] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_DQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1857),
    [sym_number] = ACTIONS(1857),
    [sym_this] = ACTIONS(1859),
    [sym_super] = ACTIONS(1859),
    [sym_true] = ACTIONS(1859),
    [sym_false] = ACTIONS(1859),
    [sym_null] = ACTIONS(1859),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(1857),
    [anon_sym_declare] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1859),
    [anon_sym_readonly] = ACTIONS(1859),
    [anon_sym_abstract] = ACTIONS(1859),
    [anon_sym_get] = ACTIONS(1859),
    [anon_sym_set] = ACTIONS(1859),
    [anon_sym_public] = ACTIONS(1859),
    [anon_sym_private] = ACTIONS(1859),
    [anon_sym_protected] = ACTIONS(1859),
    [anon_sym_module] = ACTIONS(1859),
    [anon_sym_any] = ACTIONS(1859),
    [anon_sym_number] = ACTIONS(1859),
    [anon_sym_boolean] = ACTIONS(1859),
    [anon_sym_string] = ACTIONS(1859),
    [anon_sym_symbol] = ACTIONS(1859),
    [anon_sym_interface] = ACTIONS(1859),
    [anon_sym_enum] = ACTIONS(1859),
    [sym__automatic_semicolon] = ACTIONS(1857),
  },
  [132] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1863),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1865),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_implements] = ACTIONS(1580),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [133] = {
    [sym_statement_block] = STATE(154),
    [ts_builtin_sym_end] = ACTIONS(1857),
    [sym_identifier] = ACTIONS(1859),
    [anon_sym_export] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_default] = ACTIONS(1859),
    [anon_sym_as] = ACTIONS(1859),
    [anon_sym_namespace] = ACTIONS(1859),
    [anon_sym_LBRACE] = ACTIONS(1861),
    [anon_sym_COMMA] = ACTIONS(1857),
    [anon_sym_RBRACE] = ACTIONS(1857),
    [anon_sym_type] = ACTIONS(1859),
    [anon_sym_typeof] = ACTIONS(1859),
    [anon_sym_import] = ACTIONS(1859),
    [anon_sym_var] = ACTIONS(1859),
    [anon_sym_let] = ACTIONS(1859),
    [anon_sym_const] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(1859),
    [anon_sym_else] = ACTIONS(1859),
    [anon_sym_if] = ACTIONS(1859),
    [anon_sym_switch] = ACTIONS(1859),
    [anon_sym_for] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_in] = ACTIONS(1859),
    [anon_sym_while] = ACTIONS(1859),
    [anon_sym_do] = ACTIONS(1859),
    [anon_sym_try] = ACTIONS(1859),
    [anon_sym_with] = ACTIONS(1859),
    [anon_sym_break] = ACTIONS(1859),
    [anon_sym_continue] = ACTIONS(1859),
    [anon_sym_debugger] = ACTIONS(1859),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_throw] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_case] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1859),
    [anon_sym_DOT] = ACTIONS(1867),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_async] = ACTIONS(1859),
    [anon_sym_function] = ACTIONS(1859),
    [anon_sym_QMARK_DOT] = ACTIONS(1857),
    [anon_sym_new] = ACTIONS(1859),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_AMP_AMP] = ACTIONS(1857),
    [anon_sym_PIPE_PIPE] = ACTIONS(1857),
    [anon_sym_GT_GT] = ACTIONS(1859),
    [anon_sym_GT_GT_GT] = ACTIONS(1857),
    [anon_sym_LT_LT] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_PERCENT] = ACTIONS(1857),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_LT_EQ] = ACTIONS(1857),
    [anon_sym_EQ_EQ] = ACTIONS(1859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1857),
    [anon_sym_BANG_EQ] = ACTIONS(1859),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1857),
    [anon_sym_GT_EQ] = ACTIONS(1857),
    [anon_sym_QMARK_QMARK] = ACTIONS(1857),
    [anon_sym_instanceof] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_void] = ACTIONS(1859),
    [anon_sym_delete] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_DQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1857),
    [sym_number] = ACTIONS(1857),
    [sym_this] = ACTIONS(1859),
    [sym_super] = ACTIONS(1859),
    [sym_true] = ACTIONS(1859),
    [sym_false] = ACTIONS(1859),
    [sym_null] = ACTIONS(1859),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(1857),
    [anon_sym_declare] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1859),
    [anon_sym_readonly] = ACTIONS(1859),
    [anon_sym_abstract] = ACTIONS(1859),
    [anon_sym_get] = ACTIONS(1859),
    [anon_sym_set] = ACTIONS(1859),
    [anon_sym_public] = ACTIONS(1859),
    [anon_sym_private] = ACTIONS(1859),
    [anon_sym_protected] = ACTIONS(1859),
    [anon_sym_module] = ACTIONS(1859),
    [anon_sym_any] = ACTIONS(1859),
    [anon_sym_number] = ACTIONS(1859),
    [anon_sym_boolean] = ACTIONS(1859),
    [anon_sym_string] = ACTIONS(1859),
    [anon_sym_symbol] = ACTIONS(1859),
    [anon_sym_interface] = ACTIONS(1859),
    [anon_sym_enum] = ACTIONS(1859),
    [sym__automatic_semicolon] = ACTIONS(1857),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(1869),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_export] = ACTIONS(1871),
    [anon_sym_STAR] = ACTIONS(1871),
    [anon_sym_default] = ACTIONS(1871),
    [anon_sym_as] = ACTIONS(1871),
    [anon_sym_namespace] = ACTIONS(1871),
    [anon_sym_LBRACE] = ACTIONS(1869),
    [anon_sym_COMMA] = ACTIONS(1869),
    [anon_sym_RBRACE] = ACTIONS(1869),
    [anon_sym_type] = ACTIONS(1871),
    [anon_sym_typeof] = ACTIONS(1871),
    [anon_sym_import] = ACTIONS(1871),
    [anon_sym_var] = ACTIONS(1871),
    [anon_sym_let] = ACTIONS(1871),
    [anon_sym_const] = ACTIONS(1871),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_else] = ACTIONS(1871),
    [anon_sym_if] = ACTIONS(1871),
    [anon_sym_switch] = ACTIONS(1871),
    [anon_sym_for] = ACTIONS(1871),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_await] = ACTIONS(1871),
    [anon_sym_in] = ACTIONS(1871),
    [anon_sym_while] = ACTIONS(1871),
    [anon_sym_do] = ACTIONS(1871),
    [anon_sym_try] = ACTIONS(1871),
    [anon_sym_with] = ACTIONS(1871),
    [anon_sym_break] = ACTIONS(1871),
    [anon_sym_continue] = ACTIONS(1871),
    [anon_sym_debugger] = ACTIONS(1871),
    [anon_sym_return] = ACTIONS(1871),
    [anon_sym_throw] = ACTIONS(1871),
    [anon_sym_SEMI] = ACTIONS(1869),
    [anon_sym_case] = ACTIONS(1871),
    [anon_sym_yield] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(1869),
    [anon_sym_LT] = ACTIONS(1871),
    [anon_sym_GT] = ACTIONS(1871),
    [anon_sym_SLASH] = ACTIONS(1871),
    [anon_sym_DOT] = ACTIONS(1871),
    [anon_sym_class] = ACTIONS(1871),
    [anon_sym_async] = ACTIONS(1871),
    [anon_sym_function] = ACTIONS(1871),
    [anon_sym_QMARK_DOT] = ACTIONS(1869),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_QMARK] = ACTIONS(1871),
    [anon_sym_AMP_AMP] = ACTIONS(1869),
    [anon_sym_PIPE_PIPE] = ACTIONS(1869),
    [anon_sym_GT_GT] = ACTIONS(1871),
    [anon_sym_GT_GT_GT] = ACTIONS(1869),
    [anon_sym_LT_LT] = ACTIONS(1869),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_CARET] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1871),
    [anon_sym_PLUS] = ACTIONS(1871),
    [anon_sym_DASH] = ACTIONS(1871),
    [anon_sym_PERCENT] = ACTIONS(1869),
    [anon_sym_STAR_STAR] = ACTIONS(1869),
    [anon_sym_LT_EQ] = ACTIONS(1869),
    [anon_sym_EQ_EQ] = ACTIONS(1871),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1869),
    [anon_sym_BANG_EQ] = ACTIONS(1871),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1869),
    [anon_sym_GT_EQ] = ACTIONS(1869),
    [anon_sym_QMARK_QMARK] = ACTIONS(1869),
    [anon_sym_instanceof] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1869),
    [anon_sym_void] = ACTIONS(1871),
    [anon_sym_delete] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1869),
    [anon_sym_DASH_DASH] = ACTIONS(1869),
    [anon_sym_DQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1869),
    [sym_number] = ACTIONS(1869),
    [sym_this] = ACTIONS(1871),
    [sym_super] = ACTIONS(1871),
    [sym_true] = ACTIONS(1871),
    [sym_false] = ACTIONS(1871),
    [sym_null] = ACTIONS(1871),
    [sym_undefined] = ACTIONS(1871),
    [anon_sym_AT] = ACTIONS(1869),
    [anon_sym_declare] = ACTIONS(1871),
    [anon_sym_static] = ACTIONS(1871),
    [anon_sym_readonly] = ACTIONS(1871),
    [anon_sym_abstract] = ACTIONS(1871),
    [anon_sym_get] = ACTIONS(1871),
    [anon_sym_set] = ACTIONS(1871),
    [anon_sym_public] = ACTIONS(1871),
    [anon_sym_private] = ACTIONS(1871),
    [anon_sym_protected] = ACTIONS(1871),
    [anon_sym_module] = ACTIONS(1871),
    [anon_sym_any] = ACTIONS(1871),
    [anon_sym_number] = ACTIONS(1871),
    [anon_sym_boolean] = ACTIONS(1871),
    [anon_sym_string] = ACTIONS(1871),
    [anon_sym_symbol] = ACTIONS(1871),
    [anon_sym_interface] = ACTIONS(1871),
    [anon_sym_enum] = ACTIONS(1871),
    [sym__automatic_semicolon] = ACTIONS(1869),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(1873),
    [sym_identifier] = ACTIONS(1875),
    [anon_sym_export] = ACTIONS(1875),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_default] = ACTIONS(1875),
    [anon_sym_as] = ACTIONS(1877),
    [anon_sym_namespace] = ACTIONS(1875),
    [anon_sym_LBRACE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(1879),
    [anon_sym_RBRACE] = ACTIONS(1873),
    [anon_sym_type] = ACTIONS(1875),
    [anon_sym_typeof] = ACTIONS(1875),
    [anon_sym_import] = ACTIONS(1875),
    [anon_sym_var] = ACTIONS(1875),
    [anon_sym_let] = ACTIONS(1875),
    [anon_sym_const] = ACTIONS(1875),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_else] = ACTIONS(1875),
    [anon_sym_if] = ACTIONS(1875),
    [anon_sym_switch] = ACTIONS(1875),
    [anon_sym_for] = ACTIONS(1875),
    [anon_sym_LPAREN] = ACTIONS(1873),
    [anon_sym_await] = ACTIONS(1875),
    [anon_sym_in] = ACTIONS(1877),
    [anon_sym_while] = ACTIONS(1875),
    [anon_sym_do] = ACTIONS(1875),
    [anon_sym_try] = ACTIONS(1875),
    [anon_sym_with] = ACTIONS(1875),
    [anon_sym_break] = ACTIONS(1875),
    [anon_sym_continue] = ACTIONS(1875),
    [anon_sym_debugger] = ACTIONS(1875),
    [anon_sym_return] = ACTIONS(1875),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_SEMI] = ACTIONS(1873),
    [anon_sym_case] = ACTIONS(1875),
    [anon_sym_yield] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1873),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_GT] = ACTIONS(1877),
    [anon_sym_SLASH] = ACTIONS(1875),
    [anon_sym_DOT] = ACTIONS(1877),
    [anon_sym_class] = ACTIONS(1875),
    [anon_sym_async] = ACTIONS(1875),
    [anon_sym_function] = ACTIONS(1875),
    [anon_sym_QMARK_DOT] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_QMARK] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1879),
    [anon_sym_PIPE_PIPE] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1877),
    [anon_sym_GT_GT_GT] = ACTIONS(1879),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_PIPE] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1875),
    [anon_sym_DASH] = ACTIONS(1875),
    [anon_sym_PERCENT] = ACTIONS(1879),
    [anon_sym_STAR_STAR] = ACTIONS(1879),
    [anon_sym_LT_EQ] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1879),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_QMARK_QMARK] = ACTIONS(1879),
    [anon_sym_instanceof] = ACTIONS(1877),
    [anon_sym_TILDE] = ACTIONS(1873),
    [anon_sym_void] = ACTIONS(1875),
    [anon_sym_delete] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1873),
    [anon_sym_DASH_DASH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1873),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1873),
    [sym_number] = ACTIONS(1873),
    [sym_this] = ACTIONS(1875),
    [sym_super] = ACTIONS(1875),
    [sym_true] = ACTIONS(1875),
    [sym_false] = ACTIONS(1875),
    [sym_null] = ACTIONS(1875),
    [sym_undefined] = ACTIONS(1875),
    [anon_sym_AT] = ACTIONS(1873),
    [anon_sym_declare] = ACTIONS(1875),
    [anon_sym_static] = ACTIONS(1875),
    [anon_sym_readonly] = ACTIONS(1875),
    [anon_sym_abstract] = ACTIONS(1875),
    [anon_sym_get] = ACTIONS(1875),
    [anon_sym_set] = ACTIONS(1875),
    [anon_sym_public] = ACTIONS(1875),
    [anon_sym_private] = ACTIONS(1875),
    [anon_sym_protected] = ACTIONS(1875),
    [anon_sym_module] = ACTIONS(1875),
    [anon_sym_any] = ACTIONS(1875),
    [anon_sym_number] = ACTIONS(1875),
    [anon_sym_boolean] = ACTIONS(1875),
    [anon_sym_string] = ACTIONS(1875),
    [anon_sym_symbol] = ACTIONS(1875),
    [anon_sym_interface] = ACTIONS(1875),
    [anon_sym_enum] = ACTIONS(1875),
    [sym__automatic_semicolon] = ACTIONS(1881),
  },
  [136] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5261),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4055),
    [sym_constructor_type] = STATE(4055),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4055),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5162),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4055),
    [sym_union_type] = STATE(4055),
    [sym_intersection_type] = STATE(4055),
    [sym_function_type] = STATE(4055),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1883),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1887),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(1191),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1897),
    [anon_sym_export] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1897),
    [anon_sym_default] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(1897),
    [anon_sym_namespace] = ACTIONS(1897),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_COMMA] = ACTIONS(1895),
    [anon_sym_RBRACE] = ACTIONS(1895),
    [anon_sym_type] = ACTIONS(1897),
    [anon_sym_typeof] = ACTIONS(1897),
    [anon_sym_import] = ACTIONS(1897),
    [anon_sym_var] = ACTIONS(1897),
    [anon_sym_let] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_BANG] = ACTIONS(1897),
    [anon_sym_else] = ACTIONS(1897),
    [anon_sym_if] = ACTIONS(1897),
    [anon_sym_switch] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1897),
    [anon_sym_LPAREN] = ACTIONS(1895),
    [anon_sym_await] = ACTIONS(1897),
    [anon_sym_in] = ACTIONS(1897),
    [anon_sym_while] = ACTIONS(1897),
    [anon_sym_do] = ACTIONS(1897),
    [anon_sym_try] = ACTIONS(1897),
    [anon_sym_with] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_continue] = ACTIONS(1897),
    [anon_sym_debugger] = ACTIONS(1897),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1895),
    [anon_sym_case] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1895),
    [anon_sym_LT] = ACTIONS(1897),
    [anon_sym_GT] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(1897),
    [anon_sym_DOT] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_async] = ACTIONS(1897),
    [anon_sym_function] = ACTIONS(1897),
    [anon_sym_QMARK_DOT] = ACTIONS(1895),
    [anon_sym_new] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1897),
    [anon_sym_AMP_AMP] = ACTIONS(1895),
    [anon_sym_PIPE_PIPE] = ACTIONS(1895),
    [anon_sym_GT_GT] = ACTIONS(1897),
    [anon_sym_GT_GT_GT] = ACTIONS(1895),
    [anon_sym_LT_LT] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_CARET] = ACTIONS(1895),
    [anon_sym_PIPE] = ACTIONS(1897),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_PERCENT] = ACTIONS(1895),
    [anon_sym_STAR_STAR] = ACTIONS(1895),
    [anon_sym_LT_EQ] = ACTIONS(1895),
    [anon_sym_EQ_EQ] = ACTIONS(1897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1895),
    [anon_sym_BANG_EQ] = ACTIONS(1897),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1895),
    [anon_sym_GT_EQ] = ACTIONS(1895),
    [anon_sym_QMARK_QMARK] = ACTIONS(1895),
    [anon_sym_instanceof] = ACTIONS(1897),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_void] = ACTIONS(1897),
    [anon_sym_delete] = ACTIONS(1897),
    [anon_sym_PLUS_PLUS] = ACTIONS(1895),
    [anon_sym_DASH_DASH] = ACTIONS(1895),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1895),
    [sym_number] = ACTIONS(1895),
    [sym_this] = ACTIONS(1897),
    [sym_super] = ACTIONS(1897),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [sym_null] = ACTIONS(1897),
    [sym_undefined] = ACTIONS(1897),
    [anon_sym_AT] = ACTIONS(1895),
    [anon_sym_declare] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_readonly] = ACTIONS(1897),
    [anon_sym_abstract] = ACTIONS(1897),
    [anon_sym_get] = ACTIONS(1897),
    [anon_sym_set] = ACTIONS(1897),
    [anon_sym_public] = ACTIONS(1897),
    [anon_sym_private] = ACTIONS(1897),
    [anon_sym_protected] = ACTIONS(1897),
    [anon_sym_module] = ACTIONS(1897),
    [anon_sym_any] = ACTIONS(1897),
    [anon_sym_number] = ACTIONS(1897),
    [anon_sym_boolean] = ACTIONS(1897),
    [anon_sym_string] = ACTIONS(1897),
    [anon_sym_symbol] = ACTIONS(1897),
    [anon_sym_interface] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [sym__automatic_semicolon] = ACTIONS(1895),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(1899),
    [sym_identifier] = ACTIONS(1901),
    [anon_sym_export] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_as] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_COMMA] = ACTIONS(1899),
    [anon_sym_RBRACE] = ACTIONS(1899),
    [anon_sym_type] = ACTIONS(1901),
    [anon_sym_typeof] = ACTIONS(1901),
    [anon_sym_import] = ACTIONS(1901),
    [anon_sym_var] = ACTIONS(1901),
    [anon_sym_let] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_BANG] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_LPAREN] = ACTIONS(1899),
    [anon_sym_await] = ACTIONS(1901),
    [anon_sym_in] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_with] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_debugger] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_yield] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1899),
    [anon_sym_LT] = ACTIONS(1901),
    [anon_sym_GT] = ACTIONS(1901),
    [anon_sym_SLASH] = ACTIONS(1901),
    [anon_sym_DOT] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_async] = ACTIONS(1901),
    [anon_sym_function] = ACTIONS(1901),
    [anon_sym_QMARK_DOT] = ACTIONS(1899),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_QMARK] = ACTIONS(1901),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_PIPE_PIPE] = ACTIONS(1899),
    [anon_sym_GT_GT] = ACTIONS(1901),
    [anon_sym_GT_GT_GT] = ACTIONS(1899),
    [anon_sym_LT_LT] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PERCENT] = ACTIONS(1899),
    [anon_sym_STAR_STAR] = ACTIONS(1899),
    [anon_sym_LT_EQ] = ACTIONS(1899),
    [anon_sym_EQ_EQ] = ACTIONS(1901),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1899),
    [anon_sym_BANG_EQ] = ACTIONS(1901),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1899),
    [anon_sym_GT_EQ] = ACTIONS(1899),
    [anon_sym_QMARK_QMARK] = ACTIONS(1899),
    [anon_sym_instanceof] = ACTIONS(1901),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_void] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1899),
    [sym_number] = ACTIONS(1899),
    [sym_this] = ACTIONS(1901),
    [sym_super] = ACTIONS(1901),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [sym_null] = ACTIONS(1901),
    [sym_undefined] = ACTIONS(1901),
    [anon_sym_AT] = ACTIONS(1899),
    [anon_sym_declare] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_readonly] = ACTIONS(1901),
    [anon_sym_abstract] = ACTIONS(1901),
    [anon_sym_get] = ACTIONS(1901),
    [anon_sym_set] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_module] = ACTIONS(1901),
    [anon_sym_any] = ACTIONS(1901),
    [anon_sym_number] = ACTIONS(1901),
    [anon_sym_boolean] = ACTIONS(1901),
    [anon_sym_string] = ACTIONS(1901),
    [anon_sym_symbol] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [sym__automatic_semicolon] = ACTIONS(1899),
  },
  [139] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1903),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1905),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(1907),
    [sym_identifier] = ACTIONS(1909),
    [anon_sym_export] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_as] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1907),
    [anon_sym_COMMA] = ACTIONS(1907),
    [anon_sym_RBRACE] = ACTIONS(1907),
    [anon_sym_type] = ACTIONS(1909),
    [anon_sym_typeof] = ACTIONS(1909),
    [anon_sym_import] = ACTIONS(1909),
    [anon_sym_var] = ACTIONS(1909),
    [anon_sym_let] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_LPAREN] = ACTIONS(1907),
    [anon_sym_await] = ACTIONS(1909),
    [anon_sym_in] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_with] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_debugger] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_yield] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(1909),
    [anon_sym_GT] = ACTIONS(1909),
    [anon_sym_SLASH] = ACTIONS(1909),
    [anon_sym_DOT] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_async] = ACTIONS(1909),
    [anon_sym_function] = ACTIONS(1909),
    [anon_sym_QMARK_DOT] = ACTIONS(1907),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_QMARK] = ACTIONS(1909),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_PIPE_PIPE] = ACTIONS(1907),
    [anon_sym_GT_GT] = ACTIONS(1909),
    [anon_sym_GT_GT_GT] = ACTIONS(1907),
    [anon_sym_LT_LT] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1907),
    [anon_sym_PIPE] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PERCENT] = ACTIONS(1907),
    [anon_sym_STAR_STAR] = ACTIONS(1907),
    [anon_sym_LT_EQ] = ACTIONS(1907),
    [anon_sym_EQ_EQ] = ACTIONS(1909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1909),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1907),
    [anon_sym_GT_EQ] = ACTIONS(1907),
    [anon_sym_QMARK_QMARK] = ACTIONS(1907),
    [anon_sym_instanceof] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1907),
    [sym_number] = ACTIONS(1907),
    [sym_this] = ACTIONS(1909),
    [sym_super] = ACTIONS(1909),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [sym_null] = ACTIONS(1909),
    [sym_undefined] = ACTIONS(1909),
    [anon_sym_AT] = ACTIONS(1907),
    [anon_sym_declare] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_readonly] = ACTIONS(1909),
    [anon_sym_abstract] = ACTIONS(1909),
    [anon_sym_get] = ACTIONS(1909),
    [anon_sym_set] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_module] = ACTIONS(1909),
    [anon_sym_any] = ACTIONS(1909),
    [anon_sym_number] = ACTIONS(1909),
    [anon_sym_boolean] = ACTIONS(1909),
    [anon_sym_string] = ACTIONS(1909),
    [anon_sym_symbol] = ACTIONS(1909),
    [anon_sym_interface] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [sym__automatic_semicolon] = ACTIONS(1907),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(1911),
    [sym_identifier] = ACTIONS(1913),
    [anon_sym_export] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1915),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_as] = ACTIONS(1915),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_type] = ACTIONS(1913),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_import] = ACTIONS(1913),
    [anon_sym_var] = ACTIONS(1913),
    [anon_sym_let] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [anon_sym_await] = ACTIONS(1913),
    [anon_sym_in] = ACTIONS(1915),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_with] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_debugger] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_yield] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1911),
    [anon_sym_LT] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_SLASH] = ACTIONS(1913),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_async] = ACTIONS(1913),
    [anon_sym_function] = ACTIONS(1913),
    [anon_sym_QMARK_DOT] = ACTIONS(1917),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_QMARK] = ACTIONS(1915),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_GT_GT] = ACTIONS(1915),
    [anon_sym_GT_GT_GT] = ACTIONS(1917),
    [anon_sym_LT_LT] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PERCENT] = ACTIONS(1917),
    [anon_sym_STAR_STAR] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1917),
    [anon_sym_EQ_EQ] = ACTIONS(1915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1915),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1917),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_QMARK_QMARK] = ACTIONS(1917),
    [anon_sym_instanceof] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_void] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1911),
    [sym_number] = ACTIONS(1911),
    [sym_this] = ACTIONS(1913),
    [sym_super] = ACTIONS(1913),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [sym_undefined] = ACTIONS(1913),
    [anon_sym_AT] = ACTIONS(1911),
    [anon_sym_declare] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_readonly] = ACTIONS(1913),
    [anon_sym_abstract] = ACTIONS(1913),
    [anon_sym_get] = ACTIONS(1913),
    [anon_sym_set] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_module] = ACTIONS(1913),
    [anon_sym_any] = ACTIONS(1913),
    [anon_sym_number] = ACTIONS(1913),
    [anon_sym_boolean] = ACTIONS(1913),
    [anon_sym_string] = ACTIONS(1913),
    [anon_sym_symbol] = ACTIONS(1913),
    [anon_sym_interface] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [sym__automatic_semicolon] = ACTIONS(1919),
  },
  [142] = {
    [ts_builtin_sym_end] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1923),
    [anon_sym_export] = ACTIONS(1923),
    [anon_sym_STAR] = ACTIONS(1923),
    [anon_sym_default] = ACTIONS(1923),
    [anon_sym_as] = ACTIONS(1923),
    [anon_sym_namespace] = ACTIONS(1923),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(1921),
    [anon_sym_type] = ACTIONS(1923),
    [anon_sym_typeof] = ACTIONS(1923),
    [anon_sym_import] = ACTIONS(1923),
    [anon_sym_var] = ACTIONS(1923),
    [anon_sym_let] = ACTIONS(1923),
    [anon_sym_const] = ACTIONS(1923),
    [anon_sym_BANG] = ACTIONS(1923),
    [anon_sym_else] = ACTIONS(1923),
    [anon_sym_if] = ACTIONS(1923),
    [anon_sym_switch] = ACTIONS(1923),
    [anon_sym_for] = ACTIONS(1923),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_in] = ACTIONS(1923),
    [anon_sym_while] = ACTIONS(1923),
    [anon_sym_do] = ACTIONS(1923),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_with] = ACTIONS(1923),
    [anon_sym_break] = ACTIONS(1923),
    [anon_sym_continue] = ACTIONS(1923),
    [anon_sym_debugger] = ACTIONS(1923),
    [anon_sym_return] = ACTIONS(1923),
    [anon_sym_throw] = ACTIONS(1923),
    [anon_sym_SEMI] = ACTIONS(1921),
    [anon_sym_case] = ACTIONS(1923),
    [anon_sym_yield] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1921),
    [anon_sym_LT] = ACTIONS(1923),
    [anon_sym_GT] = ACTIONS(1923),
    [anon_sym_SLASH] = ACTIONS(1923),
    [anon_sym_DOT] = ACTIONS(1923),
    [anon_sym_class] = ACTIONS(1923),
    [anon_sym_async] = ACTIONS(1923),
    [anon_sym_function] = ACTIONS(1923),
    [anon_sym_QMARK_DOT] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_QMARK] = ACTIONS(1923),
    [anon_sym_AMP_AMP] = ACTIONS(1921),
    [anon_sym_PIPE_PIPE] = ACTIONS(1921),
    [anon_sym_GT_GT] = ACTIONS(1923),
    [anon_sym_GT_GT_GT] = ACTIONS(1921),
    [anon_sym_LT_LT] = ACTIONS(1921),
    [anon_sym_AMP] = ACTIONS(1923),
    [anon_sym_CARET] = ACTIONS(1921),
    [anon_sym_PIPE] = ACTIONS(1923),
    [anon_sym_PLUS] = ACTIONS(1923),
    [anon_sym_DASH] = ACTIONS(1923),
    [anon_sym_PERCENT] = ACTIONS(1921),
    [anon_sym_STAR_STAR] = ACTIONS(1921),
    [anon_sym_LT_EQ] = ACTIONS(1921),
    [anon_sym_EQ_EQ] = ACTIONS(1923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1921),
    [anon_sym_BANG_EQ] = ACTIONS(1923),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1921),
    [anon_sym_GT_EQ] = ACTIONS(1921),
    [anon_sym_QMARK_QMARK] = ACTIONS(1921),
    [anon_sym_instanceof] = ACTIONS(1923),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_void] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(1923),
    [anon_sym_PLUS_PLUS] = ACTIONS(1921),
    [anon_sym_DASH_DASH] = ACTIONS(1921),
    [anon_sym_DQUOTE] = ACTIONS(1921),
    [anon_sym_SQUOTE] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1921),
    [sym_number] = ACTIONS(1921),
    [sym_this] = ACTIONS(1923),
    [sym_super] = ACTIONS(1923),
    [sym_true] = ACTIONS(1923),
    [sym_false] = ACTIONS(1923),
    [sym_null] = ACTIONS(1923),
    [sym_undefined] = ACTIONS(1923),
    [anon_sym_AT] = ACTIONS(1921),
    [anon_sym_declare] = ACTIONS(1923),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_readonly] = ACTIONS(1923),
    [anon_sym_abstract] = ACTIONS(1923),
    [anon_sym_get] = ACTIONS(1923),
    [anon_sym_set] = ACTIONS(1923),
    [anon_sym_public] = ACTIONS(1923),
    [anon_sym_private] = ACTIONS(1923),
    [anon_sym_protected] = ACTIONS(1923),
    [anon_sym_module] = ACTIONS(1923),
    [anon_sym_any] = ACTIONS(1923),
    [anon_sym_number] = ACTIONS(1923),
    [anon_sym_boolean] = ACTIONS(1923),
    [anon_sym_string] = ACTIONS(1923),
    [anon_sym_symbol] = ACTIONS(1923),
    [anon_sym_interface] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1923),
    [sym__automatic_semicolon] = ACTIONS(1921),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(1841),
    [sym_identifier] = ACTIONS(1843),
    [anon_sym_export] = ACTIONS(1843),
    [anon_sym_STAR] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1843),
    [anon_sym_as] = ACTIONS(1843),
    [anon_sym_namespace] = ACTIONS(1843),
    [anon_sym_LBRACE] = ACTIONS(1841),
    [anon_sym_COMMA] = ACTIONS(1841),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_type] = ACTIONS(1843),
    [anon_sym_typeof] = ACTIONS(1843),
    [anon_sym_import] = ACTIONS(1843),
    [anon_sym_var] = ACTIONS(1843),
    [anon_sym_let] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(1843),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_else] = ACTIONS(1843),
    [anon_sym_if] = ACTIONS(1843),
    [anon_sym_switch] = ACTIONS(1843),
    [anon_sym_for] = ACTIONS(1843),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_await] = ACTIONS(1843),
    [anon_sym_in] = ACTIONS(1843),
    [anon_sym_while] = ACTIONS(1843),
    [anon_sym_do] = ACTIONS(1843),
    [anon_sym_try] = ACTIONS(1843),
    [anon_sym_with] = ACTIONS(1843),
    [anon_sym_break] = ACTIONS(1843),
    [anon_sym_continue] = ACTIONS(1843),
    [anon_sym_debugger] = ACTIONS(1843),
    [anon_sym_return] = ACTIONS(1843),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_SEMI] = ACTIONS(1841),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_yield] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_GT] = ACTIONS(1843),
    [anon_sym_SLASH] = ACTIONS(1843),
    [anon_sym_DOT] = ACTIONS(1843),
    [anon_sym_class] = ACTIONS(1843),
    [anon_sym_async] = ACTIONS(1843),
    [anon_sym_function] = ACTIONS(1843),
    [anon_sym_QMARK_DOT] = ACTIONS(1841),
    [anon_sym_new] = ACTIONS(1843),
    [anon_sym_QMARK] = ACTIONS(1843),
    [anon_sym_AMP_AMP] = ACTIONS(1841),
    [anon_sym_PIPE_PIPE] = ACTIONS(1841),
    [anon_sym_GT_GT] = ACTIONS(1843),
    [anon_sym_GT_GT_GT] = ACTIONS(1841),
    [anon_sym_LT_LT] = ACTIONS(1841),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_CARET] = ACTIONS(1841),
    [anon_sym_PIPE] = ACTIONS(1843),
    [anon_sym_PLUS] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_PERCENT] = ACTIONS(1841),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_LT_EQ] = ACTIONS(1841),
    [anon_sym_EQ_EQ] = ACTIONS(1843),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1841),
    [anon_sym_BANG_EQ] = ACTIONS(1843),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1841),
    [anon_sym_GT_EQ] = ACTIONS(1841),
    [anon_sym_QMARK_QMARK] = ACTIONS(1841),
    [anon_sym_instanceof] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1841),
    [anon_sym_void] = ACTIONS(1843),
    [anon_sym_delete] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_DQUOTE] = ACTIONS(1841),
    [anon_sym_SQUOTE] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1841),
    [sym_number] = ACTIONS(1841),
    [sym_this] = ACTIONS(1843),
    [sym_super] = ACTIONS(1843),
    [sym_true] = ACTIONS(1843),
    [sym_false] = ACTIONS(1843),
    [sym_null] = ACTIONS(1843),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(1841),
    [anon_sym_declare] = ACTIONS(1843),
    [anon_sym_static] = ACTIONS(1843),
    [anon_sym_readonly] = ACTIONS(1843),
    [anon_sym_abstract] = ACTIONS(1843),
    [anon_sym_get] = ACTIONS(1843),
    [anon_sym_set] = ACTIONS(1843),
    [anon_sym_public] = ACTIONS(1843),
    [anon_sym_private] = ACTIONS(1843),
    [anon_sym_protected] = ACTIONS(1843),
    [anon_sym_module] = ACTIONS(1843),
    [anon_sym_any] = ACTIONS(1843),
    [anon_sym_number] = ACTIONS(1843),
    [anon_sym_boolean] = ACTIONS(1843),
    [anon_sym_string] = ACTIONS(1843),
    [anon_sym_symbol] = ACTIONS(1843),
    [anon_sym_interface] = ACTIONS(1843),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(1925),
  },
  [144] = {
    [ts_builtin_sym_end] = ACTIONS(1927),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_export] = ACTIONS(1929),
    [anon_sym_STAR] = ACTIONS(1931),
    [anon_sym_default] = ACTIONS(1929),
    [anon_sym_as] = ACTIONS(1931),
    [anon_sym_namespace] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_COMMA] = ACTIONS(1933),
    [anon_sym_RBRACE] = ACTIONS(1927),
    [anon_sym_type] = ACTIONS(1929),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_import] = ACTIONS(1929),
    [anon_sym_var] = ACTIONS(1929),
    [anon_sym_let] = ACTIONS(1929),
    [anon_sym_const] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1929),
    [anon_sym_else] = ACTIONS(1929),
    [anon_sym_if] = ACTIONS(1929),
    [anon_sym_switch] = ACTIONS(1929),
    [anon_sym_for] = ACTIONS(1929),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_await] = ACTIONS(1929),
    [anon_sym_in] = ACTIONS(1931),
    [anon_sym_while] = ACTIONS(1929),
    [anon_sym_do] = ACTIONS(1929),
    [anon_sym_try] = ACTIONS(1929),
    [anon_sym_with] = ACTIONS(1929),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_continue] = ACTIONS(1929),
    [anon_sym_debugger] = ACTIONS(1929),
    [anon_sym_return] = ACTIONS(1929),
    [anon_sym_throw] = ACTIONS(1929),
    [anon_sym_SEMI] = ACTIONS(1927),
    [anon_sym_case] = ACTIONS(1929),
    [anon_sym_yield] = ACTIONS(1929),
    [anon_sym_LBRACK] = ACTIONS(1927),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1931),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_DOT] = ACTIONS(1931),
    [anon_sym_class] = ACTIONS(1929),
    [anon_sym_async] = ACTIONS(1929),
    [anon_sym_function] = ACTIONS(1929),
    [anon_sym_QMARK_DOT] = ACTIONS(1933),
    [anon_sym_new] = ACTIONS(1929),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_AMP_AMP] = ACTIONS(1933),
    [anon_sym_PIPE_PIPE] = ACTIONS(1933),
    [anon_sym_GT_GT] = ACTIONS(1931),
    [anon_sym_GT_GT_GT] = ACTIONS(1933),
    [anon_sym_LT_LT] = ACTIONS(1933),
    [anon_sym_AMP] = ACTIONS(1931),
    [anon_sym_CARET] = ACTIONS(1933),
    [anon_sym_PIPE] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1929),
    [anon_sym_DASH] = ACTIONS(1929),
    [anon_sym_PERCENT] = ACTIONS(1933),
    [anon_sym_STAR_STAR] = ACTIONS(1933),
    [anon_sym_LT_EQ] = ACTIONS(1933),
    [anon_sym_EQ_EQ] = ACTIONS(1931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1933),
    [anon_sym_BANG_EQ] = ACTIONS(1931),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1933),
    [anon_sym_GT_EQ] = ACTIONS(1933),
    [anon_sym_QMARK_QMARK] = ACTIONS(1933),
    [anon_sym_instanceof] = ACTIONS(1931),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_void] = ACTIONS(1929),
    [anon_sym_delete] = ACTIONS(1929),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_DQUOTE] = ACTIONS(1927),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1927),
    [sym_number] = ACTIONS(1927),
    [sym_this] = ACTIONS(1929),
    [sym_super] = ACTIONS(1929),
    [sym_true] = ACTIONS(1929),
    [sym_false] = ACTIONS(1929),
    [sym_null] = ACTIONS(1929),
    [sym_undefined] = ACTIONS(1929),
    [anon_sym_AT] = ACTIONS(1927),
    [anon_sym_declare] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1929),
    [anon_sym_readonly] = ACTIONS(1929),
    [anon_sym_abstract] = ACTIONS(1929),
    [anon_sym_get] = ACTIONS(1929),
    [anon_sym_set] = ACTIONS(1929),
    [anon_sym_public] = ACTIONS(1929),
    [anon_sym_private] = ACTIONS(1929),
    [anon_sym_protected] = ACTIONS(1929),
    [anon_sym_module] = ACTIONS(1929),
    [anon_sym_any] = ACTIONS(1929),
    [anon_sym_number] = ACTIONS(1929),
    [anon_sym_boolean] = ACTIONS(1929),
    [anon_sym_string] = ACTIONS(1929),
    [anon_sym_symbol] = ACTIONS(1929),
    [anon_sym_interface] = ACTIONS(1929),
    [anon_sym_enum] = ACTIONS(1929),
    [sym__automatic_semicolon] = ACTIONS(1935),
  },
  [145] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1937),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1939),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [146] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1941),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1943),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [147] = {
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_export] = ACTIONS(1947),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_as] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_COMMA] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_type] = ACTIONS(1947),
    [anon_sym_typeof] = ACTIONS(1947),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(1947),
    [anon_sym_let] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_await] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_with] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_debugger] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1947),
    [anon_sym_GT] = ACTIONS(1947),
    [anon_sym_SLASH] = ACTIONS(1947),
    [anon_sym_DOT] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_async] = ACTIONS(1947),
    [anon_sym_function] = ACTIONS(1947),
    [anon_sym_QMARK_DOT] = ACTIONS(1945),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_AMP_AMP] = ACTIONS(1945),
    [anon_sym_PIPE_PIPE] = ACTIONS(1945),
    [anon_sym_GT_GT] = ACTIONS(1947),
    [anon_sym_GT_GT_GT] = ACTIONS(1945),
    [anon_sym_LT_LT] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_PERCENT] = ACTIONS(1945),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_LT_EQ] = ACTIONS(1945),
    [anon_sym_EQ_EQ] = ACTIONS(1947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1945),
    [anon_sym_BANG_EQ] = ACTIONS(1947),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(1945),
    [anon_sym_QMARK_QMARK] = ACTIONS(1945),
    [anon_sym_instanceof] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_void] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1945),
    [sym_number] = ACTIONS(1945),
    [sym_this] = ACTIONS(1947),
    [sym_super] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_null] = ACTIONS(1947),
    [sym_undefined] = ACTIONS(1947),
    [anon_sym_AT] = ACTIONS(1945),
    [anon_sym_declare] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1947),
    [anon_sym_abstract] = ACTIONS(1947),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_module] = ACTIONS(1947),
    [anon_sym_any] = ACTIONS(1947),
    [anon_sym_number] = ACTIONS(1947),
    [anon_sym_boolean] = ACTIONS(1947),
    [anon_sym_string] = ACTIONS(1947),
    [anon_sym_symbol] = ACTIONS(1947),
    [anon_sym_interface] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [sym__automatic_semicolon] = ACTIONS(1949),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_export] = ACTIONS(1947),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_as] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_COMMA] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_type] = ACTIONS(1947),
    [anon_sym_typeof] = ACTIONS(1947),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(1947),
    [anon_sym_let] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_await] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_with] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_debugger] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1947),
    [anon_sym_GT] = ACTIONS(1947),
    [anon_sym_SLASH] = ACTIONS(1947),
    [anon_sym_DOT] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_async] = ACTIONS(1947),
    [anon_sym_function] = ACTIONS(1947),
    [anon_sym_QMARK_DOT] = ACTIONS(1945),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_AMP_AMP] = ACTIONS(1945),
    [anon_sym_PIPE_PIPE] = ACTIONS(1945),
    [anon_sym_GT_GT] = ACTIONS(1947),
    [anon_sym_GT_GT_GT] = ACTIONS(1945),
    [anon_sym_LT_LT] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_PERCENT] = ACTIONS(1945),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_LT_EQ] = ACTIONS(1945),
    [anon_sym_EQ_EQ] = ACTIONS(1947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1945),
    [anon_sym_BANG_EQ] = ACTIONS(1947),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(1945),
    [anon_sym_QMARK_QMARK] = ACTIONS(1945),
    [anon_sym_instanceof] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_void] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1945),
    [sym_number] = ACTIONS(1945),
    [sym_this] = ACTIONS(1947),
    [sym_super] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_null] = ACTIONS(1947),
    [sym_undefined] = ACTIONS(1947),
    [anon_sym_AT] = ACTIONS(1945),
    [anon_sym_declare] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1947),
    [anon_sym_abstract] = ACTIONS(1947),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_module] = ACTIONS(1947),
    [anon_sym_any] = ACTIONS(1947),
    [anon_sym_number] = ACTIONS(1947),
    [anon_sym_boolean] = ACTIONS(1947),
    [anon_sym_string] = ACTIONS(1947),
    [anon_sym_symbol] = ACTIONS(1947),
    [anon_sym_interface] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [sym__automatic_semicolon] = ACTIONS(1945),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(1951),
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_export] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_default] = ACTIONS(1953),
    [anon_sym_as] = ACTIONS(1955),
    [anon_sym_namespace] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1951),
    [anon_sym_type] = ACTIONS(1953),
    [anon_sym_typeof] = ACTIONS(1953),
    [anon_sym_import] = ACTIONS(1953),
    [anon_sym_var] = ACTIONS(1953),
    [anon_sym_let] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_BANG] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_switch] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1951),
    [anon_sym_await] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1955),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_try] = ACTIONS(1953),
    [anon_sym_with] = ACTIONS(1953),
    [anon_sym_break] = ACTIONS(1953),
    [anon_sym_continue] = ACTIONS(1953),
    [anon_sym_debugger] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_throw] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1953),
    [anon_sym_yield] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(1955),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_DOT] = ACTIONS(1955),
    [anon_sym_class] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_function] = ACTIONS(1953),
    [anon_sym_QMARK_DOT] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_QMARK] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1957),
    [anon_sym_PIPE_PIPE] = ACTIONS(1957),
    [anon_sym_GT_GT] = ACTIONS(1955),
    [anon_sym_GT_GT_GT] = ACTIONS(1957),
    [anon_sym_LT_LT] = ACTIONS(1957),
    [anon_sym_AMP] = ACTIONS(1955),
    [anon_sym_CARET] = ACTIONS(1957),
    [anon_sym_PIPE] = ACTIONS(1955),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PERCENT] = ACTIONS(1957),
    [anon_sym_STAR_STAR] = ACTIONS(1957),
    [anon_sym_LT_EQ] = ACTIONS(1957),
    [anon_sym_EQ_EQ] = ACTIONS(1955),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1957),
    [anon_sym_BANG_EQ] = ACTIONS(1955),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1957),
    [anon_sym_GT_EQ] = ACTIONS(1957),
    [anon_sym_QMARK_QMARK] = ACTIONS(1957),
    [anon_sym_instanceof] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_void] = ACTIONS(1953),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_DQUOTE] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1951),
    [sym_number] = ACTIONS(1951),
    [sym_this] = ACTIONS(1953),
    [sym_super] = ACTIONS(1953),
    [sym_true] = ACTIONS(1953),
    [sym_false] = ACTIONS(1953),
    [sym_null] = ACTIONS(1953),
    [sym_undefined] = ACTIONS(1953),
    [anon_sym_AT] = ACTIONS(1951),
    [anon_sym_declare] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_readonly] = ACTIONS(1953),
    [anon_sym_abstract] = ACTIONS(1953),
    [anon_sym_get] = ACTIONS(1953),
    [anon_sym_set] = ACTIONS(1953),
    [anon_sym_public] = ACTIONS(1953),
    [anon_sym_private] = ACTIONS(1953),
    [anon_sym_protected] = ACTIONS(1953),
    [anon_sym_module] = ACTIONS(1953),
    [anon_sym_any] = ACTIONS(1953),
    [anon_sym_number] = ACTIONS(1953),
    [anon_sym_boolean] = ACTIONS(1953),
    [anon_sym_string] = ACTIONS(1953),
    [anon_sym_symbol] = ACTIONS(1953),
    [anon_sym_interface] = ACTIONS(1953),
    [anon_sym_enum] = ACTIONS(1953),
    [sym__automatic_semicolon] = ACTIONS(1959),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(1961),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_export] = ACTIONS(1963),
    [anon_sym_STAR] = ACTIONS(1963),
    [anon_sym_default] = ACTIONS(1963),
    [anon_sym_as] = ACTIONS(1963),
    [anon_sym_namespace] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1961),
    [anon_sym_COMMA] = ACTIONS(1961),
    [anon_sym_RBRACE] = ACTIONS(1961),
    [anon_sym_type] = ACTIONS(1963),
    [anon_sym_typeof] = ACTIONS(1963),
    [anon_sym_import] = ACTIONS(1963),
    [anon_sym_var] = ACTIONS(1963),
    [anon_sym_let] = ACTIONS(1963),
    [anon_sym_const] = ACTIONS(1963),
    [anon_sym_BANG] = ACTIONS(1963),
    [anon_sym_else] = ACTIONS(1963),
    [anon_sym_if] = ACTIONS(1963),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_for] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_await] = ACTIONS(1963),
    [anon_sym_in] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(1963),
    [anon_sym_do] = ACTIONS(1963),
    [anon_sym_try] = ACTIONS(1963),
    [anon_sym_with] = ACTIONS(1963),
    [anon_sym_break] = ACTIONS(1963),
    [anon_sym_continue] = ACTIONS(1963),
    [anon_sym_debugger] = ACTIONS(1963),
    [anon_sym_return] = ACTIONS(1963),
    [anon_sym_throw] = ACTIONS(1963),
    [anon_sym_SEMI] = ACTIONS(1961),
    [anon_sym_case] = ACTIONS(1963),
    [anon_sym_yield] = ACTIONS(1963),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_LT] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(1963),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_DOT] = ACTIONS(1963),
    [anon_sym_class] = ACTIONS(1963),
    [anon_sym_async] = ACTIONS(1963),
    [anon_sym_function] = ACTIONS(1963),
    [anon_sym_QMARK_DOT] = ACTIONS(1961),
    [anon_sym_new] = ACTIONS(1963),
    [anon_sym_QMARK] = ACTIONS(1963),
    [anon_sym_AMP_AMP] = ACTIONS(1961),
    [anon_sym_PIPE_PIPE] = ACTIONS(1961),
    [anon_sym_GT_GT] = ACTIONS(1963),
    [anon_sym_GT_GT_GT] = ACTIONS(1961),
    [anon_sym_LT_LT] = ACTIONS(1961),
    [anon_sym_AMP] = ACTIONS(1963),
    [anon_sym_CARET] = ACTIONS(1961),
    [anon_sym_PIPE] = ACTIONS(1963),
    [anon_sym_PLUS] = ACTIONS(1963),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_PERCENT] = ACTIONS(1961),
    [anon_sym_STAR_STAR] = ACTIONS(1961),
    [anon_sym_LT_EQ] = ACTIONS(1961),
    [anon_sym_EQ_EQ] = ACTIONS(1963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1961),
    [anon_sym_BANG_EQ] = ACTIONS(1963),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1961),
    [anon_sym_GT_EQ] = ACTIONS(1961),
    [anon_sym_QMARK_QMARK] = ACTIONS(1961),
    [anon_sym_instanceof] = ACTIONS(1963),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_void] = ACTIONS(1963),
    [anon_sym_delete] = ACTIONS(1963),
    [anon_sym_PLUS_PLUS] = ACTIONS(1961),
    [anon_sym_DASH_DASH] = ACTIONS(1961),
    [anon_sym_DQUOTE] = ACTIONS(1961),
    [anon_sym_SQUOTE] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1961),
    [sym_number] = ACTIONS(1961),
    [sym_this] = ACTIONS(1963),
    [sym_super] = ACTIONS(1963),
    [sym_true] = ACTIONS(1963),
    [sym_false] = ACTIONS(1963),
    [sym_null] = ACTIONS(1963),
    [sym_undefined] = ACTIONS(1963),
    [anon_sym_AT] = ACTIONS(1961),
    [anon_sym_declare] = ACTIONS(1963),
    [anon_sym_static] = ACTIONS(1963),
    [anon_sym_readonly] = ACTIONS(1963),
    [anon_sym_abstract] = ACTIONS(1963),
    [anon_sym_get] = ACTIONS(1963),
    [anon_sym_set] = ACTIONS(1963),
    [anon_sym_public] = ACTIONS(1963),
    [anon_sym_private] = ACTIONS(1963),
    [anon_sym_protected] = ACTIONS(1963),
    [anon_sym_module] = ACTIONS(1963),
    [anon_sym_any] = ACTIONS(1963),
    [anon_sym_number] = ACTIONS(1963),
    [anon_sym_boolean] = ACTIONS(1963),
    [anon_sym_string] = ACTIONS(1963),
    [anon_sym_symbol] = ACTIONS(1963),
    [anon_sym_interface] = ACTIONS(1963),
    [anon_sym_enum] = ACTIONS(1963),
    [sym__automatic_semicolon] = ACTIONS(1961),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(1965),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_export] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_default] = ACTIONS(1967),
    [anon_sym_as] = ACTIONS(1969),
    [anon_sym_namespace] = ACTIONS(1967),
    [anon_sym_LBRACE] = ACTIONS(1965),
    [anon_sym_COMMA] = ACTIONS(1971),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_type] = ACTIONS(1967),
    [anon_sym_typeof] = ACTIONS(1967),
    [anon_sym_import] = ACTIONS(1967),
    [anon_sym_var] = ACTIONS(1967),
    [anon_sym_let] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_else] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1965),
    [anon_sym_await] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(1969),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_try] = ACTIONS(1967),
    [anon_sym_with] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_debugger] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_throw] = ACTIONS(1967),
    [anon_sym_SEMI] = ACTIONS(1965),
    [anon_sym_case] = ACTIONS(1967),
    [anon_sym_yield] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(1967),
    [anon_sym_GT] = ACTIONS(1969),
    [anon_sym_SLASH] = ACTIONS(1967),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_class] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(1967),
    [anon_sym_function] = ACTIONS(1967),
    [anon_sym_QMARK_DOT] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1967),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1971),
    [anon_sym_PIPE_PIPE] = ACTIONS(1971),
    [anon_sym_GT_GT] = ACTIONS(1969),
    [anon_sym_GT_GT_GT] = ACTIONS(1971),
    [anon_sym_LT_LT] = ACTIONS(1971),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_CARET] = ACTIONS(1971),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_PLUS] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1967),
    [anon_sym_PERCENT] = ACTIONS(1971),
    [anon_sym_STAR_STAR] = ACTIONS(1971),
    [anon_sym_LT_EQ] = ACTIONS(1971),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1971),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1971),
    [anon_sym_GT_EQ] = ACTIONS(1971),
    [anon_sym_QMARK_QMARK] = ACTIONS(1971),
    [anon_sym_instanceof] = ACTIONS(1969),
    [anon_sym_TILDE] = ACTIONS(1965),
    [anon_sym_void] = ACTIONS(1967),
    [anon_sym_delete] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1965),
    [sym_number] = ACTIONS(1965),
    [sym_this] = ACTIONS(1967),
    [sym_super] = ACTIONS(1967),
    [sym_true] = ACTIONS(1967),
    [sym_false] = ACTIONS(1967),
    [sym_null] = ACTIONS(1967),
    [sym_undefined] = ACTIONS(1967),
    [anon_sym_AT] = ACTIONS(1965),
    [anon_sym_declare] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_readonly] = ACTIONS(1967),
    [anon_sym_abstract] = ACTIONS(1967),
    [anon_sym_get] = ACTIONS(1967),
    [anon_sym_set] = ACTIONS(1967),
    [anon_sym_public] = ACTIONS(1967),
    [anon_sym_private] = ACTIONS(1967),
    [anon_sym_protected] = ACTIONS(1967),
    [anon_sym_module] = ACTIONS(1967),
    [anon_sym_any] = ACTIONS(1967),
    [anon_sym_number] = ACTIONS(1967),
    [anon_sym_boolean] = ACTIONS(1967),
    [anon_sym_string] = ACTIONS(1967),
    [anon_sym_symbol] = ACTIONS(1967),
    [anon_sym_interface] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [sym__automatic_semicolon] = ACTIONS(1973),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(1975),
    [sym_identifier] = ACTIONS(1977),
    [anon_sym_export] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1977),
    [anon_sym_as] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1975),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1975),
    [anon_sym_type] = ACTIONS(1977),
    [anon_sym_typeof] = ACTIONS(1977),
    [anon_sym_import] = ACTIONS(1977),
    [anon_sym_var] = ACTIONS(1977),
    [anon_sym_let] = ACTIONS(1977),
    [anon_sym_const] = ACTIONS(1977),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_else] = ACTIONS(1977),
    [anon_sym_if] = ACTIONS(1977),
    [anon_sym_switch] = ACTIONS(1977),
    [anon_sym_for] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(1975),
    [anon_sym_await] = ACTIONS(1977),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1977),
    [anon_sym_do] = ACTIONS(1977),
    [anon_sym_try] = ACTIONS(1977),
    [anon_sym_with] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1977),
    [anon_sym_continue] = ACTIONS(1977),
    [anon_sym_debugger] = ACTIONS(1977),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_throw] = ACTIONS(1977),
    [anon_sym_SEMI] = ACTIONS(1975),
    [anon_sym_case] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1977),
    [anon_sym_async] = ACTIONS(1977),
    [anon_sym_function] = ACTIONS(1977),
    [anon_sym_QMARK_DOT] = ACTIONS(1981),
    [anon_sym_new] = ACTIONS(1977),
    [anon_sym_QMARK] = ACTIONS(1979),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_GT_GT_GT] = ACTIONS(1981),
    [anon_sym_LT_LT] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1977),
    [anon_sym_PERCENT] = ACTIONS(1981),
    [anon_sym_STAR_STAR] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1981),
    [anon_sym_EQ_EQ] = ACTIONS(1979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1979),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1981),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_QMARK_QMARK] = ACTIONS(1981),
    [anon_sym_instanceof] = ACTIONS(1979),
    [anon_sym_TILDE] = ACTIONS(1975),
    [anon_sym_void] = ACTIONS(1977),
    [anon_sym_delete] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1975),
    [anon_sym_DQUOTE] = ACTIONS(1975),
    [anon_sym_SQUOTE] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1975),
    [sym_this] = ACTIONS(1977),
    [sym_super] = ACTIONS(1977),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_AT] = ACTIONS(1975),
    [anon_sym_declare] = ACTIONS(1977),
    [anon_sym_static] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1977),
    [anon_sym_abstract] = ACTIONS(1977),
    [anon_sym_get] = ACTIONS(1977),
    [anon_sym_set] = ACTIONS(1977),
    [anon_sym_public] = ACTIONS(1977),
    [anon_sym_private] = ACTIONS(1977),
    [anon_sym_protected] = ACTIONS(1977),
    [anon_sym_module] = ACTIONS(1977),
    [anon_sym_any] = ACTIONS(1977),
    [anon_sym_number] = ACTIONS(1977),
    [anon_sym_boolean] = ACTIONS(1977),
    [anon_sym_string] = ACTIONS(1977),
    [anon_sym_symbol] = ACTIONS(1977),
    [anon_sym_interface] = ACTIONS(1977),
    [anon_sym_enum] = ACTIONS(1977),
    [sym__automatic_semicolon] = ACTIONS(1983),
  },
  [153] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4007),
    [sym_constructor_type] = STATE(4007),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4007),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4007),
    [sym_union_type] = STATE(4007),
    [sym_intersection_type] = STATE(4007),
    [sym_function_type] = STATE(4007),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1584),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1993),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1999),
    [anon_sym_export] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1999),
    [anon_sym_namespace] = ACTIONS(1999),
    [anon_sym_LBRACE] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(1997),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_type] = ACTIONS(1999),
    [anon_sym_typeof] = ACTIONS(1999),
    [anon_sym_import] = ACTIONS(1999),
    [anon_sym_var] = ACTIONS(1999),
    [anon_sym_let] = ACTIONS(1999),
    [anon_sym_const] = ACTIONS(1999),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_else] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_switch] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_await] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1999),
    [anon_sym_do] = ACTIONS(1999),
    [anon_sym_try] = ACTIONS(1999),
    [anon_sym_with] = ACTIONS(1999),
    [anon_sym_break] = ACTIONS(1999),
    [anon_sym_continue] = ACTIONS(1999),
    [anon_sym_debugger] = ACTIONS(1999),
    [anon_sym_return] = ACTIONS(1999),
    [anon_sym_throw] = ACTIONS(1999),
    [anon_sym_SEMI] = ACTIONS(1997),
    [anon_sym_case] = ACTIONS(1999),
    [anon_sym_yield] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(1999),
    [anon_sym_class] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_function] = ACTIONS(1999),
    [anon_sym_QMARK_DOT] = ACTIONS(1997),
    [anon_sym_new] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1997),
    [anon_sym_PIPE_PIPE] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(1997),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_STAR_STAR] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1997),
    [anon_sym_QMARK_QMARK] = ACTIONS(1997),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1997),
    [anon_sym_void] = ACTIONS(1999),
    [anon_sym_delete] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1997),
    [anon_sym_DQUOTE] = ACTIONS(1997),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1997),
    [sym_number] = ACTIONS(1997),
    [sym_this] = ACTIONS(1999),
    [sym_super] = ACTIONS(1999),
    [sym_true] = ACTIONS(1999),
    [sym_false] = ACTIONS(1999),
    [sym_null] = ACTIONS(1999),
    [sym_undefined] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1997),
    [anon_sym_declare] = ACTIONS(1999),
    [anon_sym_static] = ACTIONS(1999),
    [anon_sym_readonly] = ACTIONS(1999),
    [anon_sym_abstract] = ACTIONS(1999),
    [anon_sym_get] = ACTIONS(1999),
    [anon_sym_set] = ACTIONS(1999),
    [anon_sym_public] = ACTIONS(1999),
    [anon_sym_private] = ACTIONS(1999),
    [anon_sym_protected] = ACTIONS(1999),
    [anon_sym_module] = ACTIONS(1999),
    [anon_sym_any] = ACTIONS(1999),
    [anon_sym_number] = ACTIONS(1999),
    [anon_sym_boolean] = ACTIONS(1999),
    [anon_sym_string] = ACTIONS(1999),
    [anon_sym_symbol] = ACTIONS(1999),
    [anon_sym_interface] = ACTIONS(1999),
    [anon_sym_enum] = ACTIONS(1999),
    [sym__automatic_semicolon] = ACTIONS(1997),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2003),
    [anon_sym_export] = ACTIONS(2003),
    [anon_sym_STAR] = ACTIONS(2005),
    [anon_sym_default] = ACTIONS(2003),
    [anon_sym_as] = ACTIONS(2005),
    [anon_sym_namespace] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_type] = ACTIONS(2003),
    [anon_sym_typeof] = ACTIONS(2003),
    [anon_sym_import] = ACTIONS(2003),
    [anon_sym_var] = ACTIONS(2003),
    [anon_sym_let] = ACTIONS(2003),
    [anon_sym_const] = ACTIONS(2003),
    [anon_sym_BANG] = ACTIONS(2003),
    [anon_sym_else] = ACTIONS(2003),
    [anon_sym_if] = ACTIONS(2003),
    [anon_sym_switch] = ACTIONS(2003),
    [anon_sym_for] = ACTIONS(2003),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_await] = ACTIONS(2003),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_while] = ACTIONS(2003),
    [anon_sym_do] = ACTIONS(2003),
    [anon_sym_try] = ACTIONS(2003),
    [anon_sym_with] = ACTIONS(2003),
    [anon_sym_break] = ACTIONS(2003),
    [anon_sym_continue] = ACTIONS(2003),
    [anon_sym_debugger] = ACTIONS(2003),
    [anon_sym_return] = ACTIONS(2003),
    [anon_sym_throw] = ACTIONS(2003),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_case] = ACTIONS(2003),
    [anon_sym_yield] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2001),
    [anon_sym_LT] = ACTIONS(2003),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_DOT] = ACTIONS(2005),
    [anon_sym_class] = ACTIONS(2003),
    [anon_sym_async] = ACTIONS(2003),
    [anon_sym_function] = ACTIONS(2003),
    [anon_sym_QMARK_DOT] = ACTIONS(2007),
    [anon_sym_new] = ACTIONS(2003),
    [anon_sym_QMARK] = ACTIONS(2005),
    [anon_sym_AMP_AMP] = ACTIONS(2007),
    [anon_sym_PIPE_PIPE] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2005),
    [anon_sym_GT_GT_GT] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_CARET] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_PLUS] = ACTIONS(2003),
    [anon_sym_DASH] = ACTIONS(2003),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_EQ_EQ] = ACTIONS(2005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2007),
    [anon_sym_BANG_EQ] = ACTIONS(2005),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2007),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_QMARK_QMARK] = ACTIONS(2007),
    [anon_sym_instanceof] = ACTIONS(2005),
    [anon_sym_TILDE] = ACTIONS(2001),
    [anon_sym_void] = ACTIONS(2003),
    [anon_sym_delete] = ACTIONS(2003),
    [anon_sym_PLUS_PLUS] = ACTIONS(2001),
    [anon_sym_DASH_DASH] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2001),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_super] = ACTIONS(2003),
    [sym_true] = ACTIONS(2003),
    [sym_false] = ACTIONS(2003),
    [sym_null] = ACTIONS(2003),
    [sym_undefined] = ACTIONS(2003),
    [anon_sym_AT] = ACTIONS(2001),
    [anon_sym_declare] = ACTIONS(2003),
    [anon_sym_static] = ACTIONS(2003),
    [anon_sym_readonly] = ACTIONS(2003),
    [anon_sym_abstract] = ACTIONS(2003),
    [anon_sym_get] = ACTIONS(2003),
    [anon_sym_set] = ACTIONS(2003),
    [anon_sym_public] = ACTIONS(2003),
    [anon_sym_private] = ACTIONS(2003),
    [anon_sym_protected] = ACTIONS(2003),
    [anon_sym_module] = ACTIONS(2003),
    [anon_sym_any] = ACTIONS(2003),
    [anon_sym_number] = ACTIONS(2003),
    [anon_sym_boolean] = ACTIONS(2003),
    [anon_sym_string] = ACTIONS(2003),
    [anon_sym_symbol] = ACTIONS(2003),
    [anon_sym_interface] = ACTIONS(2003),
    [anon_sym_enum] = ACTIONS(2003),
    [sym__automatic_semicolon] = ACTIONS(2009),
  },
  [156] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(2013),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(2016),
    [sym_identifier] = ACTIONS(2018),
    [anon_sym_export] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(2020),
    [anon_sym_default] = ACTIONS(2018),
    [anon_sym_as] = ACTIONS(2020),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_LBRACE] = ACTIONS(2016),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_RBRACE] = ACTIONS(2016),
    [anon_sym_type] = ACTIONS(2018),
    [anon_sym_typeof] = ACTIONS(2018),
    [anon_sym_import] = ACTIONS(2018),
    [anon_sym_var] = ACTIONS(2018),
    [anon_sym_let] = ACTIONS(2018),
    [anon_sym_const] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(2018),
    [anon_sym_else] = ACTIONS(2018),
    [anon_sym_if] = ACTIONS(2018),
    [anon_sym_switch] = ACTIONS(2018),
    [anon_sym_for] = ACTIONS(2018),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [anon_sym_await] = ACTIONS(2018),
    [anon_sym_in] = ACTIONS(2020),
    [anon_sym_while] = ACTIONS(2018),
    [anon_sym_do] = ACTIONS(2018),
    [anon_sym_try] = ACTIONS(2018),
    [anon_sym_with] = ACTIONS(2018),
    [anon_sym_break] = ACTIONS(2018),
    [anon_sym_continue] = ACTIONS(2018),
    [anon_sym_debugger] = ACTIONS(2018),
    [anon_sym_return] = ACTIONS(2018),
    [anon_sym_throw] = ACTIONS(2018),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_case] = ACTIONS(2018),
    [anon_sym_yield] = ACTIONS(2018),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2020),
    [anon_sym_SLASH] = ACTIONS(2018),
    [anon_sym_DOT] = ACTIONS(2020),
    [anon_sym_class] = ACTIONS(2018),
    [anon_sym_async] = ACTIONS(2018),
    [anon_sym_function] = ACTIONS(2018),
    [anon_sym_QMARK_DOT] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_QMARK] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2022),
    [anon_sym_PIPE_PIPE] = ACTIONS(2022),
    [anon_sym_GT_GT] = ACTIONS(2020),
    [anon_sym_GT_GT_GT] = ACTIONS(2022),
    [anon_sym_LT_LT] = ACTIONS(2022),
    [anon_sym_AMP] = ACTIONS(2020),
    [anon_sym_CARET] = ACTIONS(2022),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2018),
    [anon_sym_PERCENT] = ACTIONS(2022),
    [anon_sym_STAR_STAR] = ACTIONS(2022),
    [anon_sym_LT_EQ] = ACTIONS(2022),
    [anon_sym_EQ_EQ] = ACTIONS(2020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2022),
    [anon_sym_BANG_EQ] = ACTIONS(2020),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2022),
    [anon_sym_GT_EQ] = ACTIONS(2022),
    [anon_sym_QMARK_QMARK] = ACTIONS(2022),
    [anon_sym_instanceof] = ACTIONS(2020),
    [anon_sym_TILDE] = ACTIONS(2016),
    [anon_sym_void] = ACTIONS(2018),
    [anon_sym_delete] = ACTIONS(2018),
    [anon_sym_PLUS_PLUS] = ACTIONS(2016),
    [anon_sym_DASH_DASH] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(2016),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2016),
    [sym_number] = ACTIONS(2016),
    [sym_this] = ACTIONS(2018),
    [sym_super] = ACTIONS(2018),
    [sym_true] = ACTIONS(2018),
    [sym_false] = ACTIONS(2018),
    [sym_null] = ACTIONS(2018),
    [sym_undefined] = ACTIONS(2018),
    [anon_sym_AT] = ACTIONS(2016),
    [anon_sym_declare] = ACTIONS(2018),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_readonly] = ACTIONS(2018),
    [anon_sym_abstract] = ACTIONS(2018),
    [anon_sym_get] = ACTIONS(2018),
    [anon_sym_set] = ACTIONS(2018),
    [anon_sym_public] = ACTIONS(2018),
    [anon_sym_private] = ACTIONS(2018),
    [anon_sym_protected] = ACTIONS(2018),
    [anon_sym_module] = ACTIONS(2018),
    [anon_sym_any] = ACTIONS(2018),
    [anon_sym_number] = ACTIONS(2018),
    [anon_sym_boolean] = ACTIONS(2018),
    [anon_sym_string] = ACTIONS(2018),
    [anon_sym_symbol] = ACTIONS(2018),
    [anon_sym_interface] = ACTIONS(2018),
    [anon_sym_enum] = ACTIONS(2018),
    [sym__automatic_semicolon] = ACTIONS(2022),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(2024),
    [sym_identifier] = ACTIONS(2026),
    [anon_sym_export] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(2026),
    [anon_sym_as] = ACTIONS(2028),
    [anon_sym_namespace] = ACTIONS(2026),
    [anon_sym_LBRACE] = ACTIONS(2024),
    [anon_sym_COMMA] = ACTIONS(2030),
    [anon_sym_RBRACE] = ACTIONS(2024),
    [anon_sym_type] = ACTIONS(2026),
    [anon_sym_typeof] = ACTIONS(2026),
    [anon_sym_import] = ACTIONS(2026),
    [anon_sym_var] = ACTIONS(2026),
    [anon_sym_let] = ACTIONS(2026),
    [anon_sym_const] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_else] = ACTIONS(2026),
    [anon_sym_if] = ACTIONS(2026),
    [anon_sym_switch] = ACTIONS(2026),
    [anon_sym_for] = ACTIONS(2026),
    [anon_sym_LPAREN] = ACTIONS(2024),
    [anon_sym_await] = ACTIONS(2026),
    [anon_sym_in] = ACTIONS(2028),
    [anon_sym_while] = ACTIONS(2026),
    [anon_sym_do] = ACTIONS(2026),
    [anon_sym_try] = ACTIONS(2026),
    [anon_sym_with] = ACTIONS(2026),
    [anon_sym_break] = ACTIONS(2026),
    [anon_sym_continue] = ACTIONS(2026),
    [anon_sym_debugger] = ACTIONS(2026),
    [anon_sym_return] = ACTIONS(2026),
    [anon_sym_throw] = ACTIONS(2026),
    [anon_sym_SEMI] = ACTIONS(2024),
    [anon_sym_case] = ACTIONS(2026),
    [anon_sym_yield] = ACTIONS(2026),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2026),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_SLASH] = ACTIONS(2026),
    [anon_sym_DOT] = ACTIONS(2028),
    [anon_sym_class] = ACTIONS(2026),
    [anon_sym_async] = ACTIONS(2026),
    [anon_sym_function] = ACTIONS(2026),
    [anon_sym_QMARK_DOT] = ACTIONS(2030),
    [anon_sym_new] = ACTIONS(2026),
    [anon_sym_QMARK] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_PIPE_PIPE] = ACTIONS(2030),
    [anon_sym_GT_GT] = ACTIONS(2028),
    [anon_sym_GT_GT_GT] = ACTIONS(2030),
    [anon_sym_LT_LT] = ACTIONS(2030),
    [anon_sym_AMP] = ACTIONS(2028),
    [anon_sym_CARET] = ACTIONS(2030),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_PERCENT] = ACTIONS(2030),
    [anon_sym_STAR_STAR] = ACTIONS(2030),
    [anon_sym_LT_EQ] = ACTIONS(2030),
    [anon_sym_EQ_EQ] = ACTIONS(2028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2030),
    [anon_sym_BANG_EQ] = ACTIONS(2028),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2030),
    [anon_sym_GT_EQ] = ACTIONS(2030),
    [anon_sym_QMARK_QMARK] = ACTIONS(2030),
    [anon_sym_instanceof] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2024),
    [anon_sym_void] = ACTIONS(2026),
    [anon_sym_delete] = ACTIONS(2026),
    [anon_sym_PLUS_PLUS] = ACTIONS(2024),
    [anon_sym_DASH_DASH] = ACTIONS(2024),
    [anon_sym_DQUOTE] = ACTIONS(2024),
    [anon_sym_SQUOTE] = ACTIONS(2024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2024),
    [sym_number] = ACTIONS(2024),
    [sym_this] = ACTIONS(2026),
    [sym_super] = ACTIONS(2026),
    [sym_true] = ACTIONS(2026),
    [sym_false] = ACTIONS(2026),
    [sym_null] = ACTIONS(2026),
    [sym_undefined] = ACTIONS(2026),
    [anon_sym_AT] = ACTIONS(2024),
    [anon_sym_declare] = ACTIONS(2026),
    [anon_sym_static] = ACTIONS(2026),
    [anon_sym_readonly] = ACTIONS(2026),
    [anon_sym_abstract] = ACTIONS(2026),
    [anon_sym_get] = ACTIONS(2026),
    [anon_sym_set] = ACTIONS(2026),
    [anon_sym_public] = ACTIONS(2026),
    [anon_sym_private] = ACTIONS(2026),
    [anon_sym_protected] = ACTIONS(2026),
    [anon_sym_module] = ACTIONS(2026),
    [anon_sym_any] = ACTIONS(2026),
    [anon_sym_number] = ACTIONS(2026),
    [anon_sym_boolean] = ACTIONS(2026),
    [anon_sym_string] = ACTIONS(2026),
    [anon_sym_symbol] = ACTIONS(2026),
    [anon_sym_interface] = ACTIONS(2026),
    [anon_sym_enum] = ACTIONS(2026),
    [sym__automatic_semicolon] = ACTIONS(2032),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(2034),
    [sym_identifier] = ACTIONS(2036),
    [anon_sym_export] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_default] = ACTIONS(2036),
    [anon_sym_as] = ACTIONS(2038),
    [anon_sym_namespace] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_COMMA] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(2034),
    [anon_sym_type] = ACTIONS(2036),
    [anon_sym_typeof] = ACTIONS(2036),
    [anon_sym_import] = ACTIONS(2036),
    [anon_sym_var] = ACTIONS(2036),
    [anon_sym_let] = ACTIONS(2036),
    [anon_sym_const] = ACTIONS(2036),
    [anon_sym_BANG] = ACTIONS(2036),
    [anon_sym_else] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2036),
    [anon_sym_switch] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(2036),
    [anon_sym_LPAREN] = ACTIONS(2034),
    [anon_sym_await] = ACTIONS(2036),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_while] = ACTIONS(2036),
    [anon_sym_do] = ACTIONS(2036),
    [anon_sym_try] = ACTIONS(2036),
    [anon_sym_with] = ACTIONS(2036),
    [anon_sym_break] = ACTIONS(2036),
    [anon_sym_continue] = ACTIONS(2036),
    [anon_sym_debugger] = ACTIONS(2036),
    [anon_sym_return] = ACTIONS(2036),
    [anon_sym_throw] = ACTIONS(2036),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_case] = ACTIONS(2036),
    [anon_sym_yield] = ACTIONS(2036),
    [anon_sym_LBRACK] = ACTIONS(2034),
    [anon_sym_LT] = ACTIONS(2036),
    [anon_sym_GT] = ACTIONS(2038),
    [anon_sym_SLASH] = ACTIONS(2036),
    [anon_sym_DOT] = ACTIONS(2038),
    [anon_sym_class] = ACTIONS(2036),
    [anon_sym_async] = ACTIONS(2036),
    [anon_sym_function] = ACTIONS(2036),
    [anon_sym_QMARK_DOT] = ACTIONS(2040),
    [anon_sym_new] = ACTIONS(2036),
    [anon_sym_QMARK] = ACTIONS(2038),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_PIPE_PIPE] = ACTIONS(2040),
    [anon_sym_GT_GT] = ACTIONS(2038),
    [anon_sym_GT_GT_GT] = ACTIONS(2040),
    [anon_sym_LT_LT] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_CARET] = ACTIONS(2040),
    [anon_sym_PIPE] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2036),
    [anon_sym_PERCENT] = ACTIONS(2040),
    [anon_sym_STAR_STAR] = ACTIONS(2040),
    [anon_sym_LT_EQ] = ACTIONS(2040),
    [anon_sym_EQ_EQ] = ACTIONS(2038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2040),
    [anon_sym_BANG_EQ] = ACTIONS(2038),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2040),
    [anon_sym_GT_EQ] = ACTIONS(2040),
    [anon_sym_QMARK_QMARK] = ACTIONS(2040),
    [anon_sym_instanceof] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2034),
    [anon_sym_void] = ACTIONS(2036),
    [anon_sym_delete] = ACTIONS(2036),
    [anon_sym_PLUS_PLUS] = ACTIONS(2034),
    [anon_sym_DASH_DASH] = ACTIONS(2034),
    [anon_sym_DQUOTE] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(2034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2034),
    [sym_number] = ACTIONS(2034),
    [sym_this] = ACTIONS(2036),
    [sym_super] = ACTIONS(2036),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [sym_null] = ACTIONS(2036),
    [sym_undefined] = ACTIONS(2036),
    [anon_sym_AT] = ACTIONS(2034),
    [anon_sym_declare] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2036),
    [anon_sym_readonly] = ACTIONS(2036),
    [anon_sym_abstract] = ACTIONS(2036),
    [anon_sym_get] = ACTIONS(2036),
    [anon_sym_set] = ACTIONS(2036),
    [anon_sym_public] = ACTIONS(2036),
    [anon_sym_private] = ACTIONS(2036),
    [anon_sym_protected] = ACTIONS(2036),
    [anon_sym_module] = ACTIONS(2036),
    [anon_sym_any] = ACTIONS(2036),
    [anon_sym_number] = ACTIONS(2036),
    [anon_sym_boolean] = ACTIONS(2036),
    [anon_sym_string] = ACTIONS(2036),
    [anon_sym_symbol] = ACTIONS(2036),
    [anon_sym_interface] = ACTIONS(2036),
    [anon_sym_enum] = ACTIONS(2036),
    [sym__automatic_semicolon] = ACTIONS(2042),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(2044),
    [sym_identifier] = ACTIONS(2046),
    [anon_sym_export] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2046),
    [anon_sym_as] = ACTIONS(2048),
    [anon_sym_namespace] = ACTIONS(2046),
    [anon_sym_LBRACE] = ACTIONS(2044),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2044),
    [anon_sym_type] = ACTIONS(2046),
    [anon_sym_typeof] = ACTIONS(2046),
    [anon_sym_import] = ACTIONS(2046),
    [anon_sym_var] = ACTIONS(2046),
    [anon_sym_let] = ACTIONS(2046),
    [anon_sym_const] = ACTIONS(2046),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_else] = ACTIONS(2046),
    [anon_sym_if] = ACTIONS(2046),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_for] = ACTIONS(2046),
    [anon_sym_LPAREN] = ACTIONS(2044),
    [anon_sym_await] = ACTIONS(2046),
    [anon_sym_in] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2046),
    [anon_sym_do] = ACTIONS(2046),
    [anon_sym_try] = ACTIONS(2046),
    [anon_sym_with] = ACTIONS(2046),
    [anon_sym_break] = ACTIONS(2046),
    [anon_sym_continue] = ACTIONS(2046),
    [anon_sym_debugger] = ACTIONS(2046),
    [anon_sym_return] = ACTIONS(2046),
    [anon_sym_throw] = ACTIONS(2046),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym_case] = ACTIONS(2046),
    [anon_sym_yield] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(2044),
    [anon_sym_LT] = ACTIONS(2046),
    [anon_sym_GT] = ACTIONS(2048),
    [anon_sym_SLASH] = ACTIONS(2046),
    [anon_sym_DOT] = ACTIONS(2048),
    [anon_sym_class] = ACTIONS(2046),
    [anon_sym_async] = ACTIONS(2046),
    [anon_sym_function] = ACTIONS(2046),
    [anon_sym_QMARK_DOT] = ACTIONS(2050),
    [anon_sym_new] = ACTIONS(2046),
    [anon_sym_QMARK] = ACTIONS(2048),
    [anon_sym_AMP_AMP] = ACTIONS(2050),
    [anon_sym_PIPE_PIPE] = ACTIONS(2050),
    [anon_sym_GT_GT] = ACTIONS(2048),
    [anon_sym_GT_GT_GT] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2048),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2046),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2048),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_QMARK_QMARK] = ACTIONS(2050),
    [anon_sym_instanceof] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2044),
    [anon_sym_void] = ACTIONS(2046),
    [anon_sym_delete] = ACTIONS(2046),
    [anon_sym_PLUS_PLUS] = ACTIONS(2044),
    [anon_sym_DASH_DASH] = ACTIONS(2044),
    [anon_sym_DQUOTE] = ACTIONS(2044),
    [anon_sym_SQUOTE] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2044),
    [sym_number] = ACTIONS(2044),
    [sym_this] = ACTIONS(2046),
    [sym_super] = ACTIONS(2046),
    [sym_true] = ACTIONS(2046),
    [sym_false] = ACTIONS(2046),
    [sym_null] = ACTIONS(2046),
    [sym_undefined] = ACTIONS(2046),
    [anon_sym_AT] = ACTIONS(2044),
    [anon_sym_declare] = ACTIONS(2046),
    [anon_sym_static] = ACTIONS(2046),
    [anon_sym_readonly] = ACTIONS(2046),
    [anon_sym_abstract] = ACTIONS(2046),
    [anon_sym_get] = ACTIONS(2046),
    [anon_sym_set] = ACTIONS(2046),
    [anon_sym_public] = ACTIONS(2046),
    [anon_sym_private] = ACTIONS(2046),
    [anon_sym_protected] = ACTIONS(2046),
    [anon_sym_module] = ACTIONS(2046),
    [anon_sym_any] = ACTIONS(2046),
    [anon_sym_number] = ACTIONS(2046),
    [anon_sym_boolean] = ACTIONS(2046),
    [anon_sym_string] = ACTIONS(2046),
    [anon_sym_symbol] = ACTIONS(2046),
    [anon_sym_interface] = ACTIONS(2046),
    [anon_sym_enum] = ACTIONS(2046),
    [sym__automatic_semicolon] = ACTIONS(2052),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2056),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_as] = ACTIONS(2058),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_COMMA] = ACTIONS(2060),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_type] = ACTIONS(2056),
    [anon_sym_typeof] = ACTIONS(2056),
    [anon_sym_import] = ACTIONS(2056),
    [anon_sym_var] = ACTIONS(2056),
    [anon_sym_let] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_BANG] = ACTIONS(2056),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_LPAREN] = ACTIONS(2054),
    [anon_sym_await] = ACTIONS(2056),
    [anon_sym_in] = ACTIONS(2058),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_with] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_debugger] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_yield] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2056),
    [anon_sym_GT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2056),
    [anon_sym_DOT] = ACTIONS(2058),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_async] = ACTIONS(2056),
    [anon_sym_function] = ACTIONS(2056),
    [anon_sym_QMARK_DOT] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_QMARK] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2060),
    [anon_sym_PIPE_PIPE] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_GT_GT_GT] = ACTIONS(2060),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_AMP] = ACTIONS(2058),
    [anon_sym_CARET] = ACTIONS(2060),
    [anon_sym_PIPE] = ACTIONS(2058),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_PERCENT] = ACTIONS(2060),
    [anon_sym_STAR_STAR] = ACTIONS(2060),
    [anon_sym_LT_EQ] = ACTIONS(2060),
    [anon_sym_EQ_EQ] = ACTIONS(2058),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2060),
    [anon_sym_BANG_EQ] = ACTIONS(2058),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2060),
    [anon_sym_GT_EQ] = ACTIONS(2060),
    [anon_sym_QMARK_QMARK] = ACTIONS(2060),
    [anon_sym_instanceof] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_void] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2054),
    [sym_number] = ACTIONS(2054),
    [sym_this] = ACTIONS(2056),
    [sym_super] = ACTIONS(2056),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [sym_null] = ACTIONS(2056),
    [sym_undefined] = ACTIONS(2056),
    [anon_sym_AT] = ACTIONS(2054),
    [anon_sym_declare] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_readonly] = ACTIONS(2056),
    [anon_sym_abstract] = ACTIONS(2056),
    [anon_sym_get] = ACTIONS(2056),
    [anon_sym_set] = ACTIONS(2056),
    [anon_sym_public] = ACTIONS(2056),
    [anon_sym_private] = ACTIONS(2056),
    [anon_sym_protected] = ACTIONS(2056),
    [anon_sym_module] = ACTIONS(2056),
    [anon_sym_any] = ACTIONS(2056),
    [anon_sym_number] = ACTIONS(2056),
    [anon_sym_boolean] = ACTIONS(2056),
    [anon_sym_string] = ACTIONS(2056),
    [anon_sym_symbol] = ACTIONS(2056),
    [anon_sym_interface] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [sym__automatic_semicolon] = ACTIONS(2062),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(2064),
    [sym_identifier] = ACTIONS(2066),
    [anon_sym_export] = ACTIONS(2066),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_default] = ACTIONS(2066),
    [anon_sym_as] = ACTIONS(2066),
    [anon_sym_namespace] = ACTIONS(2066),
    [anon_sym_LBRACE] = ACTIONS(2064),
    [anon_sym_COMMA] = ACTIONS(2064),
    [anon_sym_RBRACE] = ACTIONS(2064),
    [anon_sym_type] = ACTIONS(2066),
    [anon_sym_typeof] = ACTIONS(2066),
    [anon_sym_import] = ACTIONS(2066),
    [anon_sym_var] = ACTIONS(2066),
    [anon_sym_let] = ACTIONS(2066),
    [anon_sym_const] = ACTIONS(2066),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_else] = ACTIONS(2066),
    [anon_sym_if] = ACTIONS(2066),
    [anon_sym_switch] = ACTIONS(2066),
    [anon_sym_for] = ACTIONS(2066),
    [anon_sym_LPAREN] = ACTIONS(2064),
    [anon_sym_await] = ACTIONS(2066),
    [anon_sym_in] = ACTIONS(2066),
    [anon_sym_while] = ACTIONS(2066),
    [anon_sym_do] = ACTIONS(2066),
    [anon_sym_try] = ACTIONS(2066),
    [anon_sym_with] = ACTIONS(2066),
    [anon_sym_break] = ACTIONS(2066),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_debugger] = ACTIONS(2066),
    [anon_sym_return] = ACTIONS(2066),
    [anon_sym_throw] = ACTIONS(2066),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_case] = ACTIONS(2066),
    [anon_sym_yield] = ACTIONS(2066),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_DOT] = ACTIONS(2066),
    [anon_sym_class] = ACTIONS(2066),
    [anon_sym_async] = ACTIONS(2066),
    [anon_sym_function] = ACTIONS(2066),
    [anon_sym_QMARK_DOT] = ACTIONS(2064),
    [anon_sym_new] = ACTIONS(2066),
    [anon_sym_QMARK] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2066),
    [anon_sym_GT_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(2066),
    [anon_sym_CARET] = ACTIONS(2064),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(2066),
    [anon_sym_DASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2064),
    [anon_sym_STAR_STAR] = ACTIONS(2064),
    [anon_sym_LT_EQ] = ACTIONS(2064),
    [anon_sym_EQ_EQ] = ACTIONS(2066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2064),
    [anon_sym_BANG_EQ] = ACTIONS(2066),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2064),
    [anon_sym_GT_EQ] = ACTIONS(2064),
    [anon_sym_QMARK_QMARK] = ACTIONS(2064),
    [anon_sym_instanceof] = ACTIONS(2066),
    [anon_sym_TILDE] = ACTIONS(2064),
    [anon_sym_void] = ACTIONS(2066),
    [anon_sym_delete] = ACTIONS(2066),
    [anon_sym_PLUS_PLUS] = ACTIONS(2064),
    [anon_sym_DASH_DASH] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(2064),
    [anon_sym_SQUOTE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2064),
    [sym_number] = ACTIONS(2064),
    [sym_this] = ACTIONS(2066),
    [sym_super] = ACTIONS(2066),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_undefined] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(2064),
    [anon_sym_declare] = ACTIONS(2066),
    [anon_sym_static] = ACTIONS(2066),
    [anon_sym_readonly] = ACTIONS(2066),
    [anon_sym_abstract] = ACTIONS(2066),
    [anon_sym_get] = ACTIONS(2066),
    [anon_sym_set] = ACTIONS(2066),
    [anon_sym_public] = ACTIONS(2066),
    [anon_sym_private] = ACTIONS(2066),
    [anon_sym_protected] = ACTIONS(2066),
    [anon_sym_module] = ACTIONS(2066),
    [anon_sym_any] = ACTIONS(2066),
    [anon_sym_number] = ACTIONS(2066),
    [anon_sym_boolean] = ACTIONS(2066),
    [anon_sym_string] = ACTIONS(2066),
    [anon_sym_symbol] = ACTIONS(2066),
    [anon_sym_interface] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2066),
    [sym__automatic_semicolon] = ACTIONS(2064),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(2068),
    [sym_identifier] = ACTIONS(2070),
    [anon_sym_export] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(2072),
    [anon_sym_default] = ACTIONS(2070),
    [anon_sym_as] = ACTIONS(2072),
    [anon_sym_namespace] = ACTIONS(2070),
    [anon_sym_LBRACE] = ACTIONS(2068),
    [anon_sym_COMMA] = ACTIONS(2074),
    [anon_sym_RBRACE] = ACTIONS(2068),
    [anon_sym_type] = ACTIONS(2070),
    [anon_sym_typeof] = ACTIONS(2070),
    [anon_sym_import] = ACTIONS(2070),
    [anon_sym_var] = ACTIONS(2070),
    [anon_sym_let] = ACTIONS(2070),
    [anon_sym_const] = ACTIONS(2070),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_else] = ACTIONS(2070),
    [anon_sym_if] = ACTIONS(2070),
    [anon_sym_switch] = ACTIONS(2070),
    [anon_sym_for] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(2068),
    [anon_sym_await] = ACTIONS(2070),
    [anon_sym_in] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2070),
    [anon_sym_do] = ACTIONS(2070),
    [anon_sym_try] = ACTIONS(2070),
    [anon_sym_with] = ACTIONS(2070),
    [anon_sym_break] = ACTIONS(2070),
    [anon_sym_continue] = ACTIONS(2070),
    [anon_sym_debugger] = ACTIONS(2070),
    [anon_sym_return] = ACTIONS(2070),
    [anon_sym_throw] = ACTIONS(2070),
    [anon_sym_SEMI] = ACTIONS(2068),
    [anon_sym_case] = ACTIONS(2070),
    [anon_sym_yield] = ACTIONS(2070),
    [anon_sym_LBRACK] = ACTIONS(2068),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_SLASH] = ACTIONS(2070),
    [anon_sym_DOT] = ACTIONS(2072),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_async] = ACTIONS(2070),
    [anon_sym_function] = ACTIONS(2070),
    [anon_sym_QMARK_DOT] = ACTIONS(2074),
    [anon_sym_new] = ACTIONS(2070),
    [anon_sym_QMARK] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_GT_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2072),
    [anon_sym_CARET] = ACTIONS(2074),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_PLUS] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2070),
    [anon_sym_PERCENT] = ACTIONS(2074),
    [anon_sym_STAR_STAR] = ACTIONS(2074),
    [anon_sym_LT_EQ] = ACTIONS(2074),
    [anon_sym_EQ_EQ] = ACTIONS(2072),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2074),
    [anon_sym_BANG_EQ] = ACTIONS(2072),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2074),
    [anon_sym_GT_EQ] = ACTIONS(2074),
    [anon_sym_QMARK_QMARK] = ACTIONS(2074),
    [anon_sym_instanceof] = ACTIONS(2072),
    [anon_sym_TILDE] = ACTIONS(2068),
    [anon_sym_void] = ACTIONS(2070),
    [anon_sym_delete] = ACTIONS(2070),
    [anon_sym_PLUS_PLUS] = ACTIONS(2068),
    [anon_sym_DASH_DASH] = ACTIONS(2068),
    [anon_sym_DQUOTE] = ACTIONS(2068),
    [anon_sym_SQUOTE] = ACTIONS(2068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2068),
    [sym_number] = ACTIONS(2068),
    [sym_this] = ACTIONS(2070),
    [sym_super] = ACTIONS(2070),
    [sym_true] = ACTIONS(2070),
    [sym_false] = ACTIONS(2070),
    [sym_null] = ACTIONS(2070),
    [sym_undefined] = ACTIONS(2070),
    [anon_sym_AT] = ACTIONS(2068),
    [anon_sym_declare] = ACTIONS(2070),
    [anon_sym_static] = ACTIONS(2070),
    [anon_sym_readonly] = ACTIONS(2070),
    [anon_sym_abstract] = ACTIONS(2070),
    [anon_sym_get] = ACTIONS(2070),
    [anon_sym_set] = ACTIONS(2070),
    [anon_sym_public] = ACTIONS(2070),
    [anon_sym_private] = ACTIONS(2070),
    [anon_sym_protected] = ACTIONS(2070),
    [anon_sym_module] = ACTIONS(2070),
    [anon_sym_any] = ACTIONS(2070),
    [anon_sym_number] = ACTIONS(2070),
    [anon_sym_boolean] = ACTIONS(2070),
    [anon_sym_string] = ACTIONS(2070),
    [anon_sym_symbol] = ACTIONS(2070),
    [anon_sym_interface] = ACTIONS(2070),
    [anon_sym_enum] = ACTIONS(2070),
    [sym__automatic_semicolon] = ACTIONS(2076),
  },
  [164] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(2078),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(2080),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_implements] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [165] = {
    [sym_nested_identifier] = STATE(5331),
    [sym_string] = STATE(3780),
    [sym_formal_parameters] = STATE(5465),
    [sym_nested_type_identifier] = STATE(3717),
    [sym__type] = STATE(3820),
    [sym_constructor_type] = STATE(3820),
    [sym__primary_type] = STATE(3784),
    [sym_infer_type] = STATE(3820),
    [sym_conditional_type] = STATE(3782),
    [sym_generic_type] = STATE(3782),
    [sym_type_query] = STATE(3782),
    [sym_index_type_query] = STATE(3782),
    [sym_lookup_type] = STATE(3782),
    [sym_literal_type] = STATE(3782),
    [sym__number] = STATE(3780),
    [sym_existential_type] = STATE(3782),
    [sym_flow_maybe_type] = STATE(3782),
    [sym_parenthesized_type] = STATE(3782),
    [sym_predefined_type] = STATE(3782),
    [sym_object_type] = STATE(3782),
    [sym_type_parameters] = STATE(5034),
    [sym_array_type] = STATE(3782),
    [sym_tuple_type] = STATE(3782),
    [sym_readonly_type] = STATE(3820),
    [sym_union_type] = STATE(3820),
    [sym_intersection_type] = STATE(3820),
    [sym_function_type] = STATE(3820),
    [sym_identifier] = ACTIONS(2082),
    [anon_sym_STAR] = ACTIONS(2084),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(2086),
    [anon_sym_COMMA] = ACTIONS(1584),
    [anon_sym_RBRACE] = ACTIONS(1584),
    [anon_sym_typeof] = ACTIONS(2088),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2090),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(2092),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(2094),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(2098),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2102),
    [anon_sym_DASH] = ACTIONS(2102),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(2104),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2110),
    [sym_this] = ACTIONS(2112),
    [sym_true] = ACTIONS(2114),
    [sym_false] = ACTIONS(2114),
    [anon_sym_readonly] = ACTIONS(2116),
    [anon_sym_any] = ACTIONS(2104),
    [anon_sym_number] = ACTIONS(2104),
    [anon_sym_boolean] = ACTIONS(2104),
    [anon_sym_string] = ACTIONS(2104),
    [anon_sym_symbol] = ACTIONS(2104),
    [anon_sym_infer] = ACTIONS(723),
    [anon_sym_keyof] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [166] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2551),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym__formal_parameter] = STATE(4828),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5494),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(3534),
    [sym_identifier] = ACTIONS(2118),
    [anon_sym_export] = ACTIONS(643),
    [anon_sym_namespace] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(2124),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(643),
    [anon_sym_set] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(677),
    [anon_sym_private] = ACTIONS(677),
    [anon_sym_protected] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_any] = ACTIONS(643),
    [anon_sym_number] = ACTIONS(643),
    [anon_sym_boolean] = ACTIONS(643),
    [anon_sym_string] = ACTIONS(643),
    [anon_sym_symbol] = ACTIONS(643),
  },
  [167] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2482),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym__formal_parameter] = STATE(4828),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5378),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(3534),
    [sym_identifier] = ACTIONS(2118),
    [anon_sym_export] = ACTIONS(643),
    [anon_sym_namespace] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(2124),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(643),
    [anon_sym_set] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(677),
    [anon_sym_private] = ACTIONS(677),
    [anon_sym_protected] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_any] = ACTIONS(643),
    [anon_sym_number] = ACTIONS(643),
    [anon_sym_boolean] = ACTIONS(643),
    [anon_sym_string] = ACTIONS(643),
    [anon_sym_symbol] = ACTIONS(643),
  },
  [168] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(2130),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [169] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2522),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym__formal_parameter] = STATE(4828),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5550),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(3534),
    [sym_identifier] = ACTIONS(2118),
    [anon_sym_export] = ACTIONS(643),
    [anon_sym_namespace] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(2124),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(643),
    [anon_sym_set] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(677),
    [anon_sym_private] = ACTIONS(677),
    [anon_sym_protected] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_any] = ACTIONS(643),
    [anon_sym_number] = ACTIONS(643),
    [anon_sym_boolean] = ACTIONS(643),
    [anon_sym_string] = ACTIONS(643),
    [anon_sym_symbol] = ACTIONS(643),
  },
  [170] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(2135),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [171] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2514),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym__formal_parameter] = STATE(4828),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5410),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(3534),
    [sym_identifier] = ACTIONS(2118),
    [anon_sym_export] = ACTIONS(643),
    [anon_sym_namespace] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(2124),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(643),
    [anon_sym_set] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(677),
    [anon_sym_private] = ACTIONS(677),
    [anon_sym_protected] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_any] = ACTIONS(643),
    [anon_sym_number] = ACTIONS(643),
    [anon_sym_boolean] = ACTIONS(643),
    [anon_sym_string] = ACTIONS(643),
    [anon_sym_symbol] = ACTIONS(643),
  },
  [172] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(2137),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(2139),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [173] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5305),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4237),
    [sym_constructor_type] = STATE(4237),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4237),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5167),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4237),
    [sym_union_type] = STATE(4237),
    [sym_intersection_type] = STATE(4237),
    [sym_function_type] = STATE(4237),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(2141),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(2143),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [174] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [175] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [176] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2809),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4738),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4735),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2153),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [177] = {
    [sym_import] = STATE(2275),
    [sym_expression_statement] = STATE(218),
    [sym_variable_declaration] = STATE(218),
    [sym_lexical_declaration] = STATE(218),
    [sym_empty_statement] = STATE(218),
    [sym_parenthesized_expression] = STATE(1927),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(4854),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(4854),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1927),
    [sym_subscript_expression] = STATE(1927),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(4854),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1927),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2155),
    [anon_sym_export] = ACTIONS(2157),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_type] = ACTIONS(2157),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2165),
    [anon_sym_const] = ACTIONS(2165),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2169),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2157),
    [anon_sym_static] = ACTIONS(2157),
    [anon_sym_readonly] = ACTIONS(2157),
    [anon_sym_get] = ACTIONS(2157),
    [anon_sym_set] = ACTIONS(2157),
    [anon_sym_public] = ACTIONS(2157),
    [anon_sym_private] = ACTIONS(2157),
    [anon_sym_protected] = ACTIONS(2157),
    [anon_sym_module] = ACTIONS(2157),
    [anon_sym_any] = ACTIONS(2157),
    [anon_sym_number] = ACTIONS(2157),
    [anon_sym_boolean] = ACTIONS(2157),
    [anon_sym_string] = ACTIONS(2157),
    [anon_sym_symbol] = ACTIONS(2157),
  },
  [178] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2171),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [179] = {
    [sym_import] = STATE(2275),
    [sym_expression_statement] = STATE(223),
    [sym_variable_declaration] = STATE(223),
    [sym_lexical_declaration] = STATE(223),
    [sym_empty_statement] = STATE(223),
    [sym_parenthesized_expression] = STATE(1927),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(4854),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(4854),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1927),
    [sym_subscript_expression] = STATE(1927),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(4854),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1927),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2155),
    [anon_sym_export] = ACTIONS(2157),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_type] = ACTIONS(2157),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2165),
    [anon_sym_const] = ACTIONS(2165),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2169),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2157),
    [anon_sym_static] = ACTIONS(2157),
    [anon_sym_readonly] = ACTIONS(2157),
    [anon_sym_get] = ACTIONS(2157),
    [anon_sym_set] = ACTIONS(2157),
    [anon_sym_public] = ACTIONS(2157),
    [anon_sym_private] = ACTIONS(2157),
    [anon_sym_protected] = ACTIONS(2157),
    [anon_sym_module] = ACTIONS(2157),
    [anon_sym_any] = ACTIONS(2157),
    [anon_sym_number] = ACTIONS(2157),
    [anon_sym_boolean] = ACTIONS(2157),
    [anon_sym_string] = ACTIONS(2157),
    [anon_sym_symbol] = ACTIONS(2157),
  },
  [180] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2777),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4745),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4744),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2173),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [181] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [182] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2718),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4738),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4735),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2153),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [183] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2177),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [184] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2721),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4730),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4736),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2179),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [185] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4865),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4911),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [186] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2718),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4738),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4735),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [187] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2718),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4738),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4735),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2185),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [188] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3212),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4826),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4826),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4826),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_mapped_type_clause] = STATE(5240),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_namespace] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(2195),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_RBRACK] = ACTIONS(2199),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
  },
  [189] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2296),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(2203),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_RBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_QMARK] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [190] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2296),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_RBRACE] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(2203),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
    [anon_sym_extends] = ACTIONS(2205),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2203),
    [sym__automatic_semicolon] = ACTIONS(2203),
  },
  [191] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3150),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4826),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4826),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4826),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2207),
    [anon_sym_export] = ACTIONS(2209),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(2195),
    [anon_sym_type] = ACTIONS(2209),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_RBRACK] = ACTIONS(2199),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2209),
    [anon_sym_static] = ACTIONS(2209),
    [anon_sym_readonly] = ACTIONS(2209),
    [anon_sym_get] = ACTIONS(2209),
    [anon_sym_set] = ACTIONS(2209),
    [anon_sym_public] = ACTIONS(2209),
    [anon_sym_private] = ACTIONS(2209),
    [anon_sym_protected] = ACTIONS(2209),
    [anon_sym_module] = ACTIONS(2209),
    [anon_sym_any] = ACTIONS(2209),
    [anon_sym_number] = ACTIONS(2209),
    [anon_sym_boolean] = ACTIONS(2209),
    [anon_sym_string] = ACTIONS(2209),
    [anon_sym_symbol] = ACTIONS(2209),
  },
  [192] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2841),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4227),
    [sym_assignment_pattern] = STATE(4967),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4227),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4227),
    [sym_spread_element] = STATE(4883),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(4886),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_namespace] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(2215),
    [anon_sym_type] = ACTIONS(531),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(531),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [anon_sym_public] = ACTIONS(531),
    [anon_sym_private] = ACTIONS(531),
    [anon_sym_protected] = ACTIONS(531),
    [anon_sym_module] = ACTIONS(531),
    [anon_sym_any] = ACTIONS(531),
    [anon_sym_number] = ACTIONS(531),
    [anon_sym_boolean] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_symbol] = ACTIONS(531),
  },
  [193] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2184),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [194] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2650),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_spread_element] = STATE(4884),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4895),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2218),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(2220),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [195] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2762),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_spread_element] = STATE(4900),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4896),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2218),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [196] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2799),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [197] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2841),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_spread_element] = STATE(4883),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_RBRACK] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [198] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2492),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [199] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3113),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [200] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2878),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_spread_element] = STATE(4825),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4827),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2218),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(2228),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [201] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2556),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [202] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2549),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [203] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2944),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [204] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2622),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [205] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [206] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2239),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [207] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2793),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [208] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [209] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2814),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [210] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2829),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_spread_element] = STATE(4719),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4722),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2218),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(2232),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [211] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2748),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_spread_element] = STATE(4787),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [aux_sym_array_repeat1] = STATE(4786),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2218),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [212] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(3049),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [213] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2421),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [214] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3316),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [215] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2548),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [216] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2775),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [217] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2948),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
    [anon_sym_extends] = ACTIONS(2205),
  },
  [218] = {
    [sym_import] = STATE(2275),
    [sym_expression_statement] = STATE(290),
    [sym_empty_statement] = STATE(290),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [219] = {
    [sym_export_clause] = STATE(4675),
    [sym_declaration] = STATE(1100),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [220] = {
    [sym_export_clause] = STATE(4675),
    [sym_declaration] = STATE(1100),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [221] = {
    [sym_export_clause] = STATE(4675),
    [sym_declaration] = STATE(1100),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4799),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [222] = {
    [sym_export_clause] = STATE(4675),
    [sym_declaration] = STATE(1100),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [223] = {
    [sym_import] = STATE(2275),
    [sym_expression_statement] = STATE(287),
    [sym_empty_statement] = STATE(287),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5023),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [224] = {
    [sym_export_clause] = STATE(4675),
    [sym_declaration] = STATE(1100),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4747),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [225] = {
    [sym_export_clause] = STATE(4675),
    [sym_declaration] = STATE(1100),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [226] = {
    [sym_export_clause] = STATE(4675),
    [sym_declaration] = STATE(1100),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [227] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2549),
    [sym_primary_expression] = STATE(2362),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2297),
    [anon_sym_export] = ACTIONS(2299),
    [anon_sym_namespace] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2299),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2303),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2299),
    [anon_sym_static] = ACTIONS(2299),
    [anon_sym_readonly] = ACTIONS(2299),
    [anon_sym_get] = ACTIONS(2299),
    [anon_sym_set] = ACTIONS(2299),
    [anon_sym_public] = ACTIONS(2299),
    [anon_sym_private] = ACTIONS(2299),
    [anon_sym_protected] = ACTIONS(2299),
    [anon_sym_module] = ACTIONS(2299),
    [anon_sym_any] = ACTIONS(2299),
    [anon_sym_number] = ACTIONS(2299),
    [anon_sym_boolean] = ACTIONS(2299),
    [anon_sym_string] = ACTIONS(2299),
    [anon_sym_symbol] = ACTIONS(2299),
  },
  [228] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2321),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_export] = ACTIONS(2307),
    [anon_sym_namespace] = ACTIONS(2309),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(2307),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2311),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2307),
    [anon_sym_static] = ACTIONS(2307),
    [anon_sym_readonly] = ACTIONS(2307),
    [anon_sym_get] = ACTIONS(2307),
    [anon_sym_set] = ACTIONS(2307),
    [anon_sym_public] = ACTIONS(2307),
    [anon_sym_private] = ACTIONS(2307),
    [anon_sym_protected] = ACTIONS(2307),
    [anon_sym_module] = ACTIONS(2307),
    [anon_sym_any] = ACTIONS(2307),
    [anon_sym_number] = ACTIONS(2307),
    [anon_sym_boolean] = ACTIONS(2307),
    [anon_sym_string] = ACTIONS(2307),
    [anon_sym_symbol] = ACTIONS(2307),
  },
  [229] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(3368),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_export] = ACTIONS(2307),
    [anon_sym_namespace] = ACTIONS(2309),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(2307),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2311),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2307),
    [anon_sym_static] = ACTIONS(2307),
    [anon_sym_readonly] = ACTIONS(2307),
    [anon_sym_get] = ACTIONS(2307),
    [anon_sym_set] = ACTIONS(2307),
    [anon_sym_public] = ACTIONS(2307),
    [anon_sym_private] = ACTIONS(2307),
    [anon_sym_protected] = ACTIONS(2307),
    [anon_sym_module] = ACTIONS(2307),
    [anon_sym_any] = ACTIONS(2307),
    [anon_sym_number] = ACTIONS(2307),
    [anon_sym_boolean] = ACTIONS(2307),
    [anon_sym_string] = ACTIONS(2307),
    [anon_sym_symbol] = ACTIONS(2307),
  },
  [230] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2175),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5073),
    [sym_generic_type] = STATE(2060),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2317),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2319),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
  },
  [231] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2296),
    [sym_primary_expression] = STATE(3234),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2323),
    [anon_sym_namespace] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2323),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2327),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2323),
    [anon_sym_static] = ACTIONS(2323),
    [anon_sym_readonly] = ACTIONS(2323),
    [anon_sym_get] = ACTIONS(2323),
    [anon_sym_set] = ACTIONS(2323),
    [anon_sym_public] = ACTIONS(2323),
    [anon_sym_private] = ACTIONS(2323),
    [anon_sym_protected] = ACTIONS(2323),
    [anon_sym_module] = ACTIONS(2323),
    [anon_sym_any] = ACTIONS(2323),
    [anon_sym_number] = ACTIONS(2323),
    [anon_sym_boolean] = ACTIONS(2323),
    [anon_sym_string] = ACTIONS(2323),
    [anon_sym_symbol] = ACTIONS(2323),
  },
  [232] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4167),
    [sym_generic_type] = STATE(4597),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [233] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2296),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2323),
    [anon_sym_namespace] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2323),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2327),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2323),
    [anon_sym_static] = ACTIONS(2323),
    [anon_sym_readonly] = ACTIONS(2323),
    [anon_sym_get] = ACTIONS(2323),
    [anon_sym_set] = ACTIONS(2323),
    [anon_sym_public] = ACTIONS(2323),
    [anon_sym_private] = ACTIONS(2323),
    [anon_sym_protected] = ACTIONS(2323),
    [anon_sym_module] = ACTIONS(2323),
    [anon_sym_any] = ACTIONS(2323),
    [anon_sym_number] = ACTIONS(2323),
    [anon_sym_boolean] = ACTIONS(2323),
    [anon_sym_string] = ACTIONS(2323),
    [anon_sym_symbol] = ACTIONS(2323),
  },
  [234] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2548),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2331),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [235] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3113),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_namespace] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_static] = ACTIONS(2335),
    [anon_sym_readonly] = ACTIONS(2335),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_symbol] = ACTIONS(2335),
  },
  [236] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2799),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2341),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [237] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2556),
    [sym_primary_expression] = STATE(3230),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [238] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2948),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2345),
    [anon_sym_export] = ACTIONS(2347),
    [anon_sym_namespace] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2351),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2347),
    [anon_sym_static] = ACTIONS(2347),
    [anon_sym_readonly] = ACTIONS(2347),
    [anon_sym_get] = ACTIONS(2347),
    [anon_sym_set] = ACTIONS(2347),
    [anon_sym_public] = ACTIONS(2347),
    [anon_sym_private] = ACTIONS(2347),
    [anon_sym_protected] = ACTIONS(2347),
    [anon_sym_module] = ACTIONS(2347),
    [anon_sym_any] = ACTIONS(2347),
    [anon_sym_number] = ACTIONS(2347),
    [anon_sym_boolean] = ACTIONS(2347),
    [anon_sym_string] = ACTIONS(2347),
    [anon_sym_symbol] = ACTIONS(2347),
  },
  [239] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4515),
    [sym_generic_type] = STATE(4912),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [240] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2793),
    [sym_primary_expression] = STATE(3221),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(2355),
    [anon_sym_export] = ACTIONS(2357),
    [anon_sym_namespace] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(2357),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(2361),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2357),
    [anon_sym_static] = ACTIONS(2357),
    [anon_sym_readonly] = ACTIONS(2357),
    [anon_sym_get] = ACTIONS(2357),
    [anon_sym_set] = ACTIONS(2357),
    [anon_sym_public] = ACTIONS(2357),
    [anon_sym_private] = ACTIONS(2357),
    [anon_sym_protected] = ACTIONS(2357),
    [anon_sym_module] = ACTIONS(2357),
    [anon_sym_any] = ACTIONS(2357),
    [anon_sym_number] = ACTIONS(2357),
    [anon_sym_boolean] = ACTIONS(2357),
    [anon_sym_string] = ACTIONS(2357),
    [anon_sym_symbol] = ACTIONS(2357),
  },
  [241] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2239),
    [sym_primary_expression] = STATE(2722),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(2363),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [242] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2814),
    [sym_primary_expression] = STATE(2362),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2365),
    [anon_sym_export] = ACTIONS(2367),
    [anon_sym_namespace] = ACTIONS(2369),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2367),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2371),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2367),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_readonly] = ACTIONS(2367),
    [anon_sym_get] = ACTIONS(2367),
    [anon_sym_set] = ACTIONS(2367),
    [anon_sym_public] = ACTIONS(2367),
    [anon_sym_private] = ACTIONS(2367),
    [anon_sym_protected] = ACTIONS(2367),
    [anon_sym_module] = ACTIONS(2367),
    [anon_sym_any] = ACTIONS(2367),
    [anon_sym_number] = ACTIONS(2367),
    [anon_sym_boolean] = ACTIONS(2367),
    [anon_sym_string] = ACTIONS(2367),
    [anon_sym_symbol] = ACTIONS(2367),
  },
  [243] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1917),
    [sym_expression] = STATE(3362),
    [sym_primary_expression] = STATE(3242),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1917),
    [sym_subscript_expression] = STATE(1917),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1917),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4975),
    [sym_generic_type] = STATE(3154),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_export] = ACTIONS(2375),
    [anon_sym_namespace] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(2375),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(2379),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2375),
    [anon_sym_static] = ACTIONS(2375),
    [anon_sym_readonly] = ACTIONS(2375),
    [anon_sym_get] = ACTIONS(2375),
    [anon_sym_set] = ACTIONS(2375),
    [anon_sym_public] = ACTIONS(2375),
    [anon_sym_private] = ACTIONS(2375),
    [anon_sym_protected] = ACTIONS(2375),
    [anon_sym_module] = ACTIONS(2375),
    [anon_sym_any] = ACTIONS(2375),
    [anon_sym_number] = ACTIONS(2375),
    [anon_sym_boolean] = ACTIONS(2375),
    [anon_sym_string] = ACTIONS(2375),
    [anon_sym_symbol] = ACTIONS(2375),
  },
  [244] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2175),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5073),
    [sym_generic_type] = STATE(2060),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2383),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_namespace] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_static] = ACTIONS(2335),
    [anon_sym_readonly] = ACTIONS(2335),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_symbol] = ACTIONS(2335),
  },
  [245] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2175),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5073),
    [sym_generic_type] = STATE(2060),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_export] = ACTIONS(2307),
    [anon_sym_namespace] = ACTIONS(2309),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(2307),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2311),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2307),
    [anon_sym_static] = ACTIONS(2307),
    [anon_sym_readonly] = ACTIONS(2307),
    [anon_sym_get] = ACTIONS(2307),
    [anon_sym_set] = ACTIONS(2307),
    [anon_sym_public] = ACTIONS(2307),
    [anon_sym_private] = ACTIONS(2307),
    [anon_sym_protected] = ACTIONS(2307),
    [anon_sym_module] = ACTIONS(2307),
    [anon_sym_any] = ACTIONS(2307),
    [anon_sym_number] = ACTIONS(2307),
    [anon_sym_boolean] = ACTIONS(2307),
    [anon_sym_string] = ACTIONS(2307),
    [anon_sym_symbol] = ACTIONS(2307),
  },
  [246] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2944),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2387),
    [anon_sym_export] = ACTIONS(2389),
    [anon_sym_namespace] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2389),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2393),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2389),
    [anon_sym_readonly] = ACTIONS(2389),
    [anon_sym_get] = ACTIONS(2389),
    [anon_sym_set] = ACTIONS(2389),
    [anon_sym_public] = ACTIONS(2389),
    [anon_sym_private] = ACTIONS(2389),
    [anon_sym_protected] = ACTIONS(2389),
    [anon_sym_module] = ACTIONS(2389),
    [anon_sym_any] = ACTIONS(2389),
    [anon_sym_number] = ACTIONS(2389),
    [anon_sym_boolean] = ACTIONS(2389),
    [anon_sym_string] = ACTIONS(2389),
    [anon_sym_symbol] = ACTIONS(2389),
  },
  [247] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2184),
    [sym_primary_expression] = STATE(2362),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2395),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [248] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2791),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5118),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(2397),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [sym__automatic_semicolon] = ACTIONS(2397),
  },
  [249] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1993),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4709),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4709),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1993),
    [sym_subscript_expression] = STATE(1993),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4709),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1993),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2399),
    [anon_sym_export] = ACTIONS(2401),
    [anon_sym_namespace] = ACTIONS(2403),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_type] = ACTIONS(2401),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_var] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_const] = ACTIONS(2407),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2401),
    [anon_sym_static] = ACTIONS(2401),
    [anon_sym_readonly] = ACTIONS(2401),
    [anon_sym_get] = ACTIONS(2401),
    [anon_sym_set] = ACTIONS(2401),
    [anon_sym_public] = ACTIONS(2401),
    [anon_sym_private] = ACTIONS(2401),
    [anon_sym_protected] = ACTIONS(2401),
    [anon_sym_module] = ACTIONS(2401),
    [anon_sym_any] = ACTIONS(2401),
    [anon_sym_number] = ACTIONS(2401),
    [anon_sym_boolean] = ACTIONS(2401),
    [anon_sym_string] = ACTIONS(2401),
    [anon_sym_symbol] = ACTIONS(2401),
  },
  [250] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2296),
    [sym_primary_expression] = STATE(2321),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2323),
    [anon_sym_namespace] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2323),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2327),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2323),
    [anon_sym_static] = ACTIONS(2323),
    [anon_sym_readonly] = ACTIONS(2323),
    [anon_sym_get] = ACTIONS(2323),
    [anon_sym_set] = ACTIONS(2323),
    [anon_sym_public] = ACTIONS(2323),
    [anon_sym_private] = ACTIONS(2323),
    [anon_sym_protected] = ACTIONS(2323),
    [anon_sym_module] = ACTIONS(2323),
    [anon_sym_any] = ACTIONS(2323),
    [anon_sym_number] = ACTIONS(2323),
    [anon_sym_boolean] = ACTIONS(2323),
    [anon_sym_string] = ACTIONS(2323),
    [anon_sym_symbol] = ACTIONS(2323),
  },
  [251] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(3049),
    [sym_primary_expression] = STATE(2362),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2413),
    [anon_sym_export] = ACTIONS(2415),
    [anon_sym_namespace] = ACTIONS(2417),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2415),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2419),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2415),
    [anon_sym_static] = ACTIONS(2415),
    [anon_sym_readonly] = ACTIONS(2415),
    [anon_sym_get] = ACTIONS(2415),
    [anon_sym_set] = ACTIONS(2415),
    [anon_sym_public] = ACTIONS(2415),
    [anon_sym_private] = ACTIONS(2415),
    [anon_sym_protected] = ACTIONS(2415),
    [anon_sym_module] = ACTIONS(2415),
    [anon_sym_any] = ACTIONS(2415),
    [anon_sym_number] = ACTIONS(2415),
    [anon_sym_boolean] = ACTIONS(2415),
    [anon_sym_string] = ACTIONS(2415),
    [anon_sym_symbol] = ACTIONS(2415),
  },
  [252] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2315),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5144),
    [sym_generic_type] = STATE(2326),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2421),
    [anon_sym_export] = ACTIONS(2423),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(2423),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2423),
    [anon_sym_static] = ACTIONS(2423),
    [anon_sym_readonly] = ACTIONS(2423),
    [anon_sym_get] = ACTIONS(2423),
    [anon_sym_set] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2423),
    [anon_sym_private] = ACTIONS(2423),
    [anon_sym_protected] = ACTIONS(2423),
    [anon_sym_module] = ACTIONS(2423),
    [anon_sym_any] = ACTIONS(2423),
    [anon_sym_number] = ACTIONS(2423),
    [anon_sym_boolean] = ACTIONS(2423),
    [anon_sym_string] = ACTIONS(2423),
    [anon_sym_symbol] = ACTIONS(2423),
  },
  [253] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3316),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2431),
    [anon_sym_export] = ACTIONS(2433),
    [anon_sym_namespace] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2433),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2437),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_readonly] = ACTIONS(2433),
    [anon_sym_get] = ACTIONS(2433),
    [anon_sym_set] = ACTIONS(2433),
    [anon_sym_public] = ACTIONS(2433),
    [anon_sym_private] = ACTIONS(2433),
    [anon_sym_protected] = ACTIONS(2433),
    [anon_sym_module] = ACTIONS(2433),
    [anon_sym_any] = ACTIONS(2433),
    [anon_sym_number] = ACTIONS(2433),
    [anon_sym_boolean] = ACTIONS(2433),
    [anon_sym_string] = ACTIONS(2433),
    [anon_sym_symbol] = ACTIONS(2433),
  },
  [254] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2421),
    [sym_primary_expression] = STATE(2362),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2439),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [255] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2321),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2441),
    [anon_sym_export] = ACTIONS(2443),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(2443),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2447),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2443),
    [anon_sym_readonly] = ACTIONS(2443),
    [anon_sym_get] = ACTIONS(2443),
    [anon_sym_set] = ACTIONS(2443),
    [anon_sym_public] = ACTIONS(2443),
    [anon_sym_private] = ACTIONS(2443),
    [anon_sym_protected] = ACTIONS(2443),
    [anon_sym_module] = ACTIONS(2443),
    [anon_sym_any] = ACTIONS(2443),
    [anon_sym_number] = ACTIONS(2443),
    [anon_sym_boolean] = ACTIONS(2443),
    [anon_sym_string] = ACTIONS(2443),
    [anon_sym_symbol] = ACTIONS(2443),
  },
  [256] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2315),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5144),
    [sym_generic_type] = STATE(2326),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2449),
    [anon_sym_export] = ACTIONS(2451),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2451),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2451),
    [anon_sym_static] = ACTIONS(2451),
    [anon_sym_readonly] = ACTIONS(2451),
    [anon_sym_get] = ACTIONS(2451),
    [anon_sym_set] = ACTIONS(2451),
    [anon_sym_public] = ACTIONS(2451),
    [anon_sym_private] = ACTIONS(2451),
    [anon_sym_protected] = ACTIONS(2451),
    [anon_sym_module] = ACTIONS(2451),
    [anon_sym_any] = ACTIONS(2451),
    [anon_sym_number] = ACTIONS(2451),
    [anon_sym_boolean] = ACTIONS(2451),
    [anon_sym_string] = ACTIONS(2451),
    [anon_sym_symbol] = ACTIONS(2451),
  },
  [257] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2722),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_export] = ACTIONS(2459),
    [anon_sym_namespace] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(2459),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(2463),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2459),
    [anon_sym_static] = ACTIONS(2459),
    [anon_sym_readonly] = ACTIONS(2459),
    [anon_sym_get] = ACTIONS(2459),
    [anon_sym_set] = ACTIONS(2459),
    [anon_sym_public] = ACTIONS(2459),
    [anon_sym_private] = ACTIONS(2459),
    [anon_sym_protected] = ACTIONS(2459),
    [anon_sym_module] = ACTIONS(2459),
    [anon_sym_any] = ACTIONS(2459),
    [anon_sym_number] = ACTIONS(2459),
    [anon_sym_boolean] = ACTIONS(2459),
    [anon_sym_string] = ACTIONS(2459),
    [anon_sym_symbol] = ACTIONS(2459),
  },
  [258] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1462),
    [sym_expression] = STATE(3359),
    [sym_primary_expression] = STATE(2962),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1462),
    [sym_subscript_expression] = STATE(1462),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1462),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5016),
    [sym_generic_type] = STATE(3901),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_export] = ACTIONS(2467),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(2467),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(2471),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2467),
    [anon_sym_static] = ACTIONS(2467),
    [anon_sym_readonly] = ACTIONS(2467),
    [anon_sym_get] = ACTIONS(2467),
    [anon_sym_set] = ACTIONS(2467),
    [anon_sym_public] = ACTIONS(2467),
    [anon_sym_private] = ACTIONS(2467),
    [anon_sym_protected] = ACTIONS(2467),
    [anon_sym_module] = ACTIONS(2467),
    [anon_sym_any] = ACTIONS(2467),
    [anon_sym_number] = ACTIONS(2467),
    [anon_sym_boolean] = ACTIONS(2467),
    [anon_sym_string] = ACTIONS(2467),
    [anon_sym_symbol] = ACTIONS(2467),
  },
  [259] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2315),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5144),
    [sym_generic_type] = STATE(2326),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_export] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2479),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2477),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2481),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_readonly] = ACTIONS(2477),
    [anon_sym_get] = ACTIONS(2477),
    [anon_sym_set] = ACTIONS(2477),
    [anon_sym_public] = ACTIONS(2477),
    [anon_sym_private] = ACTIONS(2477),
    [anon_sym_protected] = ACTIONS(2477),
    [anon_sym_module] = ACTIONS(2477),
    [anon_sym_any] = ACTIONS(2477),
    [anon_sym_number] = ACTIONS(2477),
    [anon_sym_boolean] = ACTIONS(2477),
    [anon_sym_string] = ACTIONS(2477),
    [anon_sym_symbol] = ACTIONS(2477),
  },
  [260] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2492),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_export] = ACTIONS(2485),
    [anon_sym_namespace] = ACTIONS(2487),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2485),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2489),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2485),
    [anon_sym_static] = ACTIONS(2485),
    [anon_sym_readonly] = ACTIONS(2485),
    [anon_sym_get] = ACTIONS(2485),
    [anon_sym_set] = ACTIONS(2485),
    [anon_sym_public] = ACTIONS(2485),
    [anon_sym_private] = ACTIONS(2485),
    [anon_sym_protected] = ACTIONS(2485),
    [anon_sym_module] = ACTIONS(2485),
    [anon_sym_any] = ACTIONS(2485),
    [anon_sym_number] = ACTIONS(2485),
    [anon_sym_boolean] = ACTIONS(2485),
    [anon_sym_string] = ACTIONS(2485),
    [anon_sym_symbol] = ACTIONS(2485),
  },
  [261] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2321),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_namespace] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_static] = ACTIONS(2335),
    [anon_sym_readonly] = ACTIONS(2335),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_symbol] = ACTIONS(2335),
  },
  [262] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2775),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2491),
    [anon_sym_export] = ACTIONS(2493),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2493),
    [anon_sym_static] = ACTIONS(2493),
    [anon_sym_readonly] = ACTIONS(2493),
    [anon_sym_get] = ACTIONS(2493),
    [anon_sym_set] = ACTIONS(2493),
    [anon_sym_public] = ACTIONS(2493),
    [anon_sym_private] = ACTIONS(2493),
    [anon_sym_protected] = ACTIONS(2493),
    [anon_sym_module] = ACTIONS(2493),
    [anon_sym_any] = ACTIONS(2493),
    [anon_sym_number] = ACTIONS(2493),
    [anon_sym_boolean] = ACTIONS(2493),
    [anon_sym_string] = ACTIONS(2493),
    [anon_sym_symbol] = ACTIONS(2493),
  },
  [263] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2890),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4927),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4927),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4927),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_pattern] = STATE(5140),
    [sym_rest_pattern] = STATE(3978),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2499),
    [anon_sym_export] = ACTIONS(685),
    [anon_sym_namespace] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(685),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(699),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(685),
    [anon_sym_static] = ACTIONS(685),
    [anon_sym_readonly] = ACTIONS(685),
    [anon_sym_get] = ACTIONS(685),
    [anon_sym_set] = ACTIONS(685),
    [anon_sym_public] = ACTIONS(685),
    [anon_sym_private] = ACTIONS(685),
    [anon_sym_protected] = ACTIONS(685),
    [anon_sym_module] = ACTIONS(685),
    [anon_sym_any] = ACTIONS(685),
    [anon_sym_number] = ACTIONS(685),
    [anon_sym_boolean] = ACTIONS(685),
    [anon_sym_string] = ACTIONS(685),
    [anon_sym_symbol] = ACTIONS(685),
  },
  [264] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2622),
    [sym_primary_expression] = STATE(3221),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [265] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2740),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_nested_identifier] = STATE(5350),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_nested_type_identifier] = STATE(4429),
    [sym_generic_type] = STATE(4753),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(2503),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [266] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2175),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5073),
    [sym_generic_type] = STATE(2060),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2443),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(2443),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2447),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2443),
    [anon_sym_readonly] = ACTIONS(2443),
    [anon_sym_get] = ACTIONS(2443),
    [anon_sym_set] = ACTIONS(2443),
    [anon_sym_public] = ACTIONS(2443),
    [anon_sym_private] = ACTIONS(2443),
    [anon_sym_protected] = ACTIONS(2443),
    [anon_sym_module] = ACTIONS(2443),
    [anon_sym_any] = ACTIONS(2443),
    [anon_sym_number] = ACTIONS(2443),
    [anon_sym_boolean] = ACTIONS(2443),
    [anon_sym_string] = ACTIONS(2443),
    [anon_sym_symbol] = ACTIONS(2443),
  },
  [267] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2296),
    [sym_primary_expression] = STATE(3368),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2323),
    [anon_sym_namespace] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2323),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2327),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2323),
    [anon_sym_static] = ACTIONS(2323),
    [anon_sym_readonly] = ACTIONS(2323),
    [anon_sym_get] = ACTIONS(2323),
    [anon_sym_set] = ACTIONS(2323),
    [anon_sym_public] = ACTIONS(2323),
    [anon_sym_private] = ACTIONS(2323),
    [anon_sym_protected] = ACTIONS(2323),
    [anon_sym_module] = ACTIONS(2323),
    [anon_sym_any] = ACTIONS(2323),
    [anon_sym_number] = ACTIONS(2323),
    [anon_sym_boolean] = ACTIONS(2323),
    [anon_sym_string] = ACTIONS(2323),
    [anon_sym_symbol] = ACTIONS(2323),
  },
  [268] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2536),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_nested_identifier] = STATE(5350),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_nested_type_identifier] = STATE(4131),
    [sym_generic_type] = STATE(4691),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [269] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2365),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5137),
    [sym_generic_type] = STATE(3789),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2509),
    [anon_sym_export] = ACTIONS(2423),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(2423),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2423),
    [anon_sym_static] = ACTIONS(2423),
    [anon_sym_readonly] = ACTIONS(2423),
    [anon_sym_get] = ACTIONS(2423),
    [anon_sym_set] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2423),
    [anon_sym_private] = ACTIONS(2423),
    [anon_sym_protected] = ACTIONS(2423),
    [anon_sym_module] = ACTIONS(2423),
    [anon_sym_any] = ACTIONS(2423),
    [anon_sym_number] = ACTIONS(2423),
    [anon_sym_boolean] = ACTIONS(2423),
    [anon_sym_string] = ACTIONS(2423),
    [anon_sym_symbol] = ACTIONS(2423),
  },
  [270] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1462),
    [sym_expression] = STATE(3359),
    [sym_primary_expression] = STATE(2727),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1462),
    [sym_subscript_expression] = STATE(1462),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1462),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4977),
    [sym_generic_type] = STATE(2731),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(2511),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(2517),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_readonly] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2513),
    [anon_sym_set] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
  },
  [271] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2175),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5073),
    [sym_generic_type] = STATE(2060),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2519),
    [anon_sym_export] = ACTIONS(2521),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(2521),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2525),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2521),
    [anon_sym_static] = ACTIONS(2521),
    [anon_sym_readonly] = ACTIONS(2521),
    [anon_sym_get] = ACTIONS(2521),
    [anon_sym_set] = ACTIONS(2521),
    [anon_sym_public] = ACTIONS(2521),
    [anon_sym_private] = ACTIONS(2521),
    [anon_sym_protected] = ACTIONS(2521),
    [anon_sym_module] = ACTIONS(2521),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
  },
  [272] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1462),
    [sym_expression] = STATE(3359),
    [sym_primary_expression] = STATE(2727),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1462),
    [sym_subscript_expression] = STATE(1462),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1462),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4977),
    [sym_generic_type] = STATE(2731),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(2527),
    [anon_sym_export] = ACTIONS(2467),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(2467),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(2471),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2467),
    [anon_sym_static] = ACTIONS(2467),
    [anon_sym_readonly] = ACTIONS(2467),
    [anon_sym_get] = ACTIONS(2467),
    [anon_sym_set] = ACTIONS(2467),
    [anon_sym_public] = ACTIONS(2467),
    [anon_sym_private] = ACTIONS(2467),
    [anon_sym_protected] = ACTIONS(2467),
    [anon_sym_module] = ACTIONS(2467),
    [anon_sym_any] = ACTIONS(2467),
    [anon_sym_number] = ACTIONS(2467),
    [anon_sym_boolean] = ACTIONS(2467),
    [anon_sym_string] = ACTIONS(2467),
    [anon_sym_symbol] = ACTIONS(2467),
  },
  [273] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_namespace] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_static] = ACTIONS(2335),
    [anon_sym_readonly] = ACTIONS(2335),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_symbol] = ACTIONS(2335),
  },
  [274] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2175),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5073),
    [sym_generic_type] = STATE(2060),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2529),
    [anon_sym_export] = ACTIONS(2531),
    [anon_sym_namespace] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2531),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2531),
    [anon_sym_static] = ACTIONS(2531),
    [anon_sym_readonly] = ACTIONS(2531),
    [anon_sym_get] = ACTIONS(2531),
    [anon_sym_set] = ACTIONS(2531),
    [anon_sym_public] = ACTIONS(2531),
    [anon_sym_private] = ACTIONS(2531),
    [anon_sym_protected] = ACTIONS(2531),
    [anon_sym_module] = ACTIONS(2531),
    [anon_sym_any] = ACTIONS(2531),
    [anon_sym_number] = ACTIONS(2531),
    [anon_sym_boolean] = ACTIONS(2531),
    [anon_sym_string] = ACTIONS(2531),
    [anon_sym_symbol] = ACTIONS(2531),
  },
  [275] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2321),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2537),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2317),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2319),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
  },
  [276] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1367),
    [sym_expression] = STATE(2978),
    [sym_primary_expression] = STATE(2365),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5484),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1367),
    [sym_subscript_expression] = STATE(1367),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1367),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5137),
    [sym_generic_type] = STATE(3789),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2539),
    [anon_sym_export] = ACTIONS(2541),
    [anon_sym_namespace] = ACTIONS(2543),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2545),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2547),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2541),
    [anon_sym_readonly] = ACTIONS(2541),
    [anon_sym_get] = ACTIONS(2541),
    [anon_sym_set] = ACTIONS(2541),
    [anon_sym_public] = ACTIONS(2541),
    [anon_sym_private] = ACTIONS(2541),
    [anon_sym_protected] = ACTIONS(2541),
    [anon_sym_module] = ACTIONS(2541),
    [anon_sym_any] = ACTIONS(2541),
    [anon_sym_number] = ACTIONS(2541),
    [anon_sym_boolean] = ACTIONS(2541),
    [anon_sym_string] = ACTIONS(2541),
    [anon_sym_symbol] = ACTIONS(2541),
  },
  [277] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2549),
    [anon_sym_export] = ACTIONS(2521),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(2521),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2525),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2521),
    [anon_sym_static] = ACTIONS(2521),
    [anon_sym_readonly] = ACTIONS(2521),
    [anon_sym_get] = ACTIONS(2521),
    [anon_sym_set] = ACTIONS(2521),
    [anon_sym_public] = ACTIONS(2521),
    [anon_sym_private] = ACTIONS(2521),
    [anon_sym_protected] = ACTIONS(2521),
    [anon_sym_module] = ACTIONS(2521),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
  },
  [278] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(3368),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_namespace] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_static] = ACTIONS(2335),
    [anon_sym_readonly] = ACTIONS(2335),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_symbol] = ACTIONS(2335),
  },
  [279] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(2158),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [280] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2365),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5137),
    [sym_generic_type] = STATE(3789),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_export] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2479),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2477),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2481),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_readonly] = ACTIONS(2477),
    [anon_sym_get] = ACTIONS(2477),
    [anon_sym_set] = ACTIONS(2477),
    [anon_sym_public] = ACTIONS(2477),
    [anon_sym_private] = ACTIONS(2477),
    [anon_sym_protected] = ACTIONS(2477),
    [anon_sym_module] = ACTIONS(2477),
    [anon_sym_any] = ACTIONS(2477),
    [anon_sym_number] = ACTIONS(2477),
    [anon_sym_boolean] = ACTIONS(2477),
    [anon_sym_string] = ACTIONS(2477),
    [anon_sym_symbol] = ACTIONS(2477),
  },
  [281] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2365),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5137),
    [sym_generic_type] = STATE(3789),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2555),
    [anon_sym_export] = ACTIONS(2451),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2451),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2451),
    [anon_sym_static] = ACTIONS(2451),
    [anon_sym_readonly] = ACTIONS(2451),
    [anon_sym_get] = ACTIONS(2451),
    [anon_sym_set] = ACTIONS(2451),
    [anon_sym_public] = ACTIONS(2451),
    [anon_sym_private] = ACTIONS(2451),
    [anon_sym_protected] = ACTIONS(2451),
    [anon_sym_module] = ACTIONS(2451),
    [anon_sym_any] = ACTIONS(2451),
    [anon_sym_number] = ACTIONS(2451),
    [anon_sym_boolean] = ACTIONS(2451),
    [anon_sym_string] = ACTIONS(2451),
    [anon_sym_symbol] = ACTIONS(2451),
  },
  [282] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2321),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(4940),
    [sym_generic_type] = STATE(3694),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2549),
    [anon_sym_export] = ACTIONS(2521),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(2521),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2525),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2521),
    [anon_sym_static] = ACTIONS(2521),
    [anon_sym_readonly] = ACTIONS(2521),
    [anon_sym_get] = ACTIONS(2521),
    [anon_sym_set] = ACTIONS(2521),
    [anon_sym_public] = ACTIONS(2521),
    [anon_sym_private] = ACTIONS(2521),
    [anon_sym_protected] = ACTIONS(2521),
    [anon_sym_module] = ACTIONS(2521),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
  },
  [283] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2175),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_nested_identifier] = STATE(5311),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_nested_type_identifier] = STATE(5073),
    [sym_generic_type] = STATE(2060),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_export] = ACTIONS(2559),
    [anon_sym_namespace] = ACTIONS(2561),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2559),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2563),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2559),
    [anon_sym_static] = ACTIONS(2559),
    [anon_sym_readonly] = ACTIONS(2559),
    [anon_sym_get] = ACTIONS(2559),
    [anon_sym_set] = ACTIONS(2559),
    [anon_sym_public] = ACTIONS(2559),
    [anon_sym_private] = ACTIONS(2559),
    [anon_sym_protected] = ACTIONS(2559),
    [anon_sym_module] = ACTIONS(2559),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
  },
  [284] = {
    [sym_declaration] = STATE(1145),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2567),
    [anon_sym_global] = ACTIONS(2569),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [285] = {
    [sym_declaration] = STATE(1145),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2567),
    [anon_sym_global] = ACTIONS(2569),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [286] = {
    [sym_declaration] = STATE(1145),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4799),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2567),
    [anon_sym_global] = ACTIONS(2569),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [287] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(3022),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5445),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(2571),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [288] = {
    [sym_declaration] = STATE(1145),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2567),
    [anon_sym_global] = ACTIONS(2569),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [289] = {
    [sym_declaration] = STATE(1145),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2567),
    [anon_sym_global] = ACTIONS(2569),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [290] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(3043),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5581),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(2573),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [291] = {
    [sym_declaration] = STATE(1145),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4747),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2567),
    [anon_sym_global] = ACTIONS(2569),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [292] = {
    [sym_declaration] = STATE(1145),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2567),
    [anon_sym_global] = ACTIONS(2569),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [293] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2212),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2575),
    [anon_sym_export] = ACTIONS(2577),
    [anon_sym_namespace] = ACTIONS(2579),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2577),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2583),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2577),
    [anon_sym_static] = ACTIONS(2577),
    [anon_sym_readonly] = ACTIONS(2577),
    [anon_sym_get] = ACTIONS(2577),
    [anon_sym_set] = ACTIONS(2577),
    [anon_sym_public] = ACTIONS(2577),
    [anon_sym_private] = ACTIONS(2577),
    [anon_sym_protected] = ACTIONS(2577),
    [anon_sym_module] = ACTIONS(2577),
    [anon_sym_any] = ACTIONS(2577),
    [anon_sym_number] = ACTIONS(2577),
    [anon_sym_boolean] = ACTIONS(2577),
    [anon_sym_string] = ACTIONS(2577),
    [anon_sym_symbol] = ACTIONS(2577),
  },
  [294] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3284),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2662),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [295] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2904),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5443),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [296] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2587),
    [anon_sym_export] = ACTIONS(2521),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(2521),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2525),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2521),
    [anon_sym_static] = ACTIONS(2521),
    [anon_sym_readonly] = ACTIONS(2521),
    [anon_sym_get] = ACTIONS(2521),
    [anon_sym_set] = ACTIONS(2521),
    [anon_sym_public] = ACTIONS(2521),
    [anon_sym_private] = ACTIONS(2521),
    [anon_sym_protected] = ACTIONS(2521),
    [anon_sym_module] = ACTIONS(2521),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
  },
  [297] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2394),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2508),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [298] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2593),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_namespace] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_static] = ACTIONS(2335),
    [anon_sym_readonly] = ACTIONS(2335),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_symbol] = ACTIONS(2335),
  },
  [299] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2595),
    [anon_sym_export] = ACTIONS(2597),
    [anon_sym_namespace] = ACTIONS(2599),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2597),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2601),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2597),
    [anon_sym_static] = ACTIONS(2597),
    [anon_sym_readonly] = ACTIONS(2597),
    [anon_sym_get] = ACTIONS(2597),
    [anon_sym_set] = ACTIONS(2597),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2597),
    [anon_sym_any] = ACTIONS(2597),
    [anon_sym_number] = ACTIONS(2597),
    [anon_sym_boolean] = ACTIONS(2597),
    [anon_sym_string] = ACTIONS(2597),
    [anon_sym_symbol] = ACTIONS(2597),
  },
  [300] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3279),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [301] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(3055),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5442),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [302] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(3033),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5427),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [303] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2593),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_namespace] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_static] = ACTIONS(2335),
    [anon_sym_readonly] = ACTIONS(2335),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_symbol] = ACTIONS(2335),
  },
  [304] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2408),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2494),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [305] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2571),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5316),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [306] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2390),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2895),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [307] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2693),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2281),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [308] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2607),
    [anon_sym_export] = ACTIONS(2443),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(2443),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2447),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2443),
    [anon_sym_readonly] = ACTIONS(2443),
    [anon_sym_get] = ACTIONS(2443),
    [anon_sym_set] = ACTIONS(2443),
    [anon_sym_public] = ACTIONS(2443),
    [anon_sym_private] = ACTIONS(2443),
    [anon_sym_protected] = ACTIONS(2443),
    [anon_sym_module] = ACTIONS(2443),
    [anon_sym_any] = ACTIONS(2443),
    [anon_sym_number] = ACTIONS(2443),
    [anon_sym_boolean] = ACTIONS(2443),
    [anon_sym_string] = ACTIONS(2443),
    [anon_sym_symbol] = ACTIONS(2443),
  },
  [309] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2408),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2935),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [310] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2212),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2609),
    [anon_sym_export] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2479),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2477),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2481),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_readonly] = ACTIONS(2477),
    [anon_sym_get] = ACTIONS(2477),
    [anon_sym_set] = ACTIONS(2477),
    [anon_sym_public] = ACTIONS(2477),
    [anon_sym_private] = ACTIONS(2477),
    [anon_sym_protected] = ACTIONS(2477),
    [anon_sym_module] = ACTIONS(2477),
    [anon_sym_any] = ACTIONS(2477),
    [anon_sym_number] = ACTIONS(2477),
    [anon_sym_boolean] = ACTIONS(2477),
    [anon_sym_string] = ACTIONS(2477),
    [anon_sym_symbol] = ACTIONS(2477),
  },
  [311] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2345),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2080),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [312] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2953),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [313] = {
    [sym_export_clause] = STATE(4675),
    [sym_declaration] = STATE(1100),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2613),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [314] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2408),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2692),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [315] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3224),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2619),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [316] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3302),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2688),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [317] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2617),
    [anon_sym_export] = ACTIONS(2307),
    [anon_sym_namespace] = ACTIONS(2309),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(2307),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2311),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2307),
    [anon_sym_static] = ACTIONS(2307),
    [anon_sym_readonly] = ACTIONS(2307),
    [anon_sym_get] = ACTIONS(2307),
    [anon_sym_set] = ACTIONS(2307),
    [anon_sym_public] = ACTIONS(2307),
    [anon_sym_private] = ACTIONS(2307),
    [anon_sym_protected] = ACTIONS(2307),
    [anon_sym_module] = ACTIONS(2307),
    [anon_sym_any] = ACTIONS(2307),
    [anon_sym_number] = ACTIONS(2307),
    [anon_sym_boolean] = ACTIONS(2307),
    [anon_sym_string] = ACTIONS(2307),
    [anon_sym_symbol] = ACTIONS(2307),
  },
  [318] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2670),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2236),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [319] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1462),
    [sym_expression] = STATE(3359),
    [sym_primary_expression] = STATE(2425),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1462),
    [sym_subscript_expression] = STATE(1462),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1462),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(2619),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(2517),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_readonly] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2513),
    [anon_sym_set] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
  },
  [320] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [321] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2715),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2307),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [322] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2932),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_function_signature] = STATE(1124),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2623),
    [anon_sym_function] = ACTIONS(2625),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [323] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2408),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2378),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [324] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2111),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [325] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2506),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [326] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2938),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_function_signature] = STATE(4407),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2631),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [327] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2408),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2147),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [328] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3277),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [329] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2916),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5258),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [330] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3275),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [331] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3323),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2796),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [332] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3231),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2615),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [333] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3273),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [334] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1917),
    [sym_expression] = STATE(3362),
    [sym_primary_expression] = STATE(2761),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1917),
    [sym_subscript_expression] = STATE(1917),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1917),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(2633),
    [anon_sym_export] = ACTIONS(2375),
    [anon_sym_namespace] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(2375),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_DOT] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(2379),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2375),
    [anon_sym_static] = ACTIONS(2375),
    [anon_sym_readonly] = ACTIONS(2375),
    [anon_sym_get] = ACTIONS(2375),
    [anon_sym_set] = ACTIONS(2375),
    [anon_sym_public] = ACTIONS(2375),
    [anon_sym_private] = ACTIONS(2375),
    [anon_sym_protected] = ACTIONS(2375),
    [anon_sym_module] = ACTIONS(2375),
    [anon_sym_any] = ACTIONS(2375),
    [anon_sym_number] = ACTIONS(2375),
    [anon_sym_boolean] = ACTIONS(2375),
    [anon_sym_string] = ACTIONS(2375),
    [anon_sym_symbol] = ACTIONS(2375),
  },
  [335] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2617),
    [anon_sym_export] = ACTIONS(2307),
    [anon_sym_namespace] = ACTIONS(2309),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(2307),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2311),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2307),
    [anon_sym_static] = ACTIONS(2307),
    [anon_sym_readonly] = ACTIONS(2307),
    [anon_sym_get] = ACTIONS(2307),
    [anon_sym_set] = ACTIONS(2307),
    [anon_sym_public] = ACTIONS(2307),
    [anon_sym_private] = ACTIONS(2307),
    [anon_sym_protected] = ACTIONS(2307),
    [anon_sym_module] = ACTIONS(2307),
    [anon_sym_any] = ACTIONS(2307),
    [anon_sym_number] = ACTIONS(2307),
    [anon_sym_boolean] = ACTIONS(2307),
    [anon_sym_string] = ACTIONS(2307),
    [anon_sym_symbol] = ACTIONS(2307),
  },
  [336] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2345),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2917),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [337] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_export] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2639),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2643),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_readonly] = ACTIONS(2639),
    [anon_sym_get] = ACTIONS(2639),
    [anon_sym_set] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_module] = ACTIONS(2639),
    [anon_sym_any] = ACTIONS(2639),
    [anon_sym_number] = ACTIONS(2639),
    [anon_sym_boolean] = ACTIONS(2639),
    [anon_sym_string] = ACTIONS(2639),
    [anon_sym_symbol] = ACTIONS(2639),
  },
  [338] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2910),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5365),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [339] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3271),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [340] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2507),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [341] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4521),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5131),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_export] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2639),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2643),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_readonly] = ACTIONS(2639),
    [anon_sym_get] = ACTIONS(2639),
    [anon_sym_set] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_module] = ACTIONS(2639),
    [anon_sym_any] = ACTIONS(2639),
    [anon_sym_number] = ACTIONS(2639),
    [anon_sym_boolean] = ACTIONS(2639),
    [anon_sym_string] = ACTIONS(2639),
    [anon_sym_symbol] = ACTIONS(2639),
  },
  [342] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1462),
    [sym_expression] = STATE(3359),
    [sym_primary_expression] = STATE(2425),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1462),
    [sym_subscript_expression] = STATE(1462),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1462),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(2619),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(2517),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_readonly] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2513),
    [anon_sym_set] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
  },
  [343] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2509),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [344] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2286),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [345] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2394),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2897),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [346] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2645),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2317),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2319),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
  },
  [347] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2645),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2317),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2319),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
  },
  [348] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2345),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2386),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [349] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2616),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [350] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2118),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [351] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2617),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [352] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2595),
    [anon_sym_export] = ACTIONS(2597),
    [anon_sym_namespace] = ACTIONS(2599),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2597),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2601),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2597),
    [anon_sym_static] = ACTIONS(2597),
    [anon_sym_readonly] = ACTIONS(2597),
    [anon_sym_get] = ACTIONS(2597),
    [anon_sym_set] = ACTIONS(2597),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2597),
    [anon_sym_any] = ACTIONS(2597),
    [anon_sym_number] = ACTIONS(2597),
    [anon_sym_boolean] = ACTIONS(2597),
    [anon_sym_string] = ACTIONS(2597),
    [anon_sym_symbol] = ACTIONS(2597),
  },
  [353] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2957),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5462),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [354] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2664),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2221),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [355] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2821),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [356] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2824),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [357] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3223),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2719),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [358] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3212),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_mapped_type_clause] = STATE(5483),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2647),
    [anon_sym_export] = ACTIONS(2649),
    [anon_sym_namespace] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2649),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2653),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_readonly] = ACTIONS(2649),
    [anon_sym_get] = ACTIONS(2649),
    [anon_sym_set] = ACTIONS(2649),
    [anon_sym_public] = ACTIONS(2649),
    [anon_sym_private] = ACTIONS(2649),
    [anon_sym_protected] = ACTIONS(2649),
    [anon_sym_module] = ACTIONS(2649),
    [anon_sym_any] = ACTIONS(2649),
    [anon_sym_number] = ACTIONS(2649),
    [anon_sym_boolean] = ACTIONS(2649),
    [anon_sym_string] = ACTIONS(2649),
    [anon_sym_symbol] = ACTIONS(2649),
  },
  [359] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2908),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5578),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [360] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2212),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2423),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(2423),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2423),
    [anon_sym_static] = ACTIONS(2423),
    [anon_sym_readonly] = ACTIONS(2423),
    [anon_sym_get] = ACTIONS(2423),
    [anon_sym_set] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2423),
    [anon_sym_private] = ACTIONS(2423),
    [anon_sym_protected] = ACTIONS(2423),
    [anon_sym_module] = ACTIONS(2423),
    [anon_sym_any] = ACTIONS(2423),
    [anon_sym_number] = ACTIONS(2423),
    [anon_sym_boolean] = ACTIONS(2423),
    [anon_sym_string] = ACTIONS(2423),
    [anon_sym_symbol] = ACTIONS(2423),
  },
  [361] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1917),
    [sym_expression] = STATE(3362),
    [sym_primary_expression] = STATE(2761),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1917),
    [sym_subscript_expression] = STATE(1917),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1917),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(2657),
    [anon_sym_export] = ACTIONS(2659),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(2659),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_DOT] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(2663),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2659),
    [anon_sym_readonly] = ACTIONS(2659),
    [anon_sym_get] = ACTIONS(2659),
    [anon_sym_set] = ACTIONS(2659),
    [anon_sym_public] = ACTIONS(2659),
    [anon_sym_private] = ACTIONS(2659),
    [anon_sym_protected] = ACTIONS(2659),
    [anon_sym_module] = ACTIONS(2659),
    [anon_sym_any] = ACTIONS(2659),
    [anon_sym_number] = ACTIONS(2659),
    [anon_sym_boolean] = ACTIONS(2659),
    [anon_sym_string] = ACTIONS(2659),
    [anon_sym_symbol] = ACTIONS(2659),
  },
  [362] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2977),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [363] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2624),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [364] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2625),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [365] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2634),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [366] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2626),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [367] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2665),
    [anon_sym_export] = ACTIONS(2531),
    [anon_sym_namespace] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2531),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2531),
    [anon_sym_static] = ACTIONS(2531),
    [anon_sym_readonly] = ACTIONS(2531),
    [anon_sym_get] = ACTIONS(2531),
    [anon_sym_set] = ACTIONS(2531),
    [anon_sym_public] = ACTIONS(2531),
    [anon_sym_private] = ACTIONS(2531),
    [anon_sym_protected] = ACTIONS(2531),
    [anon_sym_module] = ACTIONS(2531),
    [anon_sym_any] = ACTIONS(2531),
    [anon_sym_number] = ACTIONS(2531),
    [anon_sym_boolean] = ACTIONS(2531),
    [anon_sym_string] = ACTIONS(2531),
    [anon_sym_symbol] = ACTIONS(2531),
  },
  [368] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2627),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [369] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2744),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5037),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [370] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3272),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [371] = {
    [sym_export_clause] = STATE(4675),
    [sym_declaration] = STATE(1100),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2613),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2279),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [372] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2808),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [373] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_export] = ACTIONS(2559),
    [anon_sym_namespace] = ACTIONS(2561),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2559),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2563),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2559),
    [anon_sym_static] = ACTIONS(2559),
    [anon_sym_readonly] = ACTIONS(2559),
    [anon_sym_get] = ACTIONS(2559),
    [anon_sym_set] = ACTIONS(2559),
    [anon_sym_public] = ACTIONS(2559),
    [anon_sym_private] = ACTIONS(2559),
    [anon_sym_protected] = ACTIONS(2559),
    [anon_sym_module] = ACTIONS(2559),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
  },
  [374] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2936),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5548),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [375] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2866),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [376] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3036),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [377] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2404),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2892),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [378] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3269),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [379] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4352),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5214),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_export] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2639),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2643),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_readonly] = ACTIONS(2639),
    [anon_sym_get] = ACTIONS(2639),
    [anon_sym_set] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_module] = ACTIONS(2639),
    [anon_sym_any] = ACTIONS(2639),
    [anon_sym_number] = ACTIONS(2639),
    [anon_sym_boolean] = ACTIONS(2639),
    [anon_sym_string] = ACTIONS(2639),
    [anon_sym_symbol] = ACTIONS(2639),
  },
  [380] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2512),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [381] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2861),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [382] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1462),
    [sym_expression] = STATE(3359),
    [sym_primary_expression] = STATE(2425),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1462),
    [sym_subscript_expression] = STATE(1462),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1462),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(2671),
    [anon_sym_export] = ACTIONS(2467),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(2467),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(2471),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2467),
    [anon_sym_static] = ACTIONS(2467),
    [anon_sym_readonly] = ACTIONS(2467),
    [anon_sym_get] = ACTIONS(2467),
    [anon_sym_set] = ACTIONS(2467),
    [anon_sym_public] = ACTIONS(2467),
    [anon_sym_private] = ACTIONS(2467),
    [anon_sym_protected] = ACTIONS(2467),
    [anon_sym_module] = ACTIONS(2467),
    [anon_sym_any] = ACTIONS(2467),
    [anon_sym_number] = ACTIONS(2467),
    [anon_sym_boolean] = ACTIONS(2467),
    [anon_sym_string] = ACTIONS(2467),
    [anon_sym_symbol] = ACTIONS(2467),
  },
  [383] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2504),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [384] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2345),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2655),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [385] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_export] = ACTIONS(2675),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2675),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2679),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2675),
    [anon_sym_static] = ACTIONS(2675),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_get] = ACTIONS(2675),
    [anon_sym_set] = ACTIONS(2675),
    [anon_sym_public] = ACTIONS(2675),
    [anon_sym_private] = ACTIONS(2675),
    [anon_sym_protected] = ACTIONS(2675),
    [anon_sym_module] = ACTIONS(2675),
    [anon_sym_any] = ACTIONS(2675),
    [anon_sym_number] = ACTIONS(2675),
    [anon_sym_boolean] = ACTIONS(2675),
    [anon_sym_string] = ACTIONS(2675),
    [anon_sym_symbol] = ACTIONS(2675),
  },
  [386] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2750),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [387] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [388] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2884),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5248),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [389] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1462),
    [sym_expression] = STATE(3359),
    [sym_primary_expression] = STATE(2425),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1462),
    [sym_subscript_expression] = STATE(1462),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1462),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(2671),
    [anon_sym_export] = ACTIONS(2467),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(2467),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(2471),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2467),
    [anon_sym_static] = ACTIONS(2467),
    [anon_sym_readonly] = ACTIONS(2467),
    [anon_sym_get] = ACTIONS(2467),
    [anon_sym_set] = ACTIONS(2467),
    [anon_sym_public] = ACTIONS(2467),
    [anon_sym_private] = ACTIONS(2467),
    [anon_sym_protected] = ACTIONS(2467),
    [anon_sym_module] = ACTIONS(2467),
    [anon_sym_any] = ACTIONS(2467),
    [anon_sym_number] = ACTIONS(2467),
    [anon_sym_boolean] = ACTIONS(2467),
    [anon_sym_string] = ACTIONS(2467),
    [anon_sym_symbol] = ACTIONS(2467),
  },
  [390] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3276),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [391] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2743),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [392] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [393] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2212),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_export] = ACTIONS(2683),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2683),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_get] = ACTIONS(2683),
    [anon_sym_set] = ACTIONS(2683),
    [anon_sym_public] = ACTIONS(2683),
    [anon_sym_private] = ACTIONS(2683),
    [anon_sym_protected] = ACTIONS(2683),
    [anon_sym_module] = ACTIONS(2683),
    [anon_sym_any] = ACTIONS(2683),
    [anon_sym_number] = ACTIONS(2683),
    [anon_sym_boolean] = ACTIONS(2683),
    [anon_sym_string] = ACTIONS(2683),
    [anon_sym_symbol] = ACTIONS(2683),
  },
  [394] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_export] = ACTIONS(2559),
    [anon_sym_namespace] = ACTIONS(2561),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2559),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2563),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2559),
    [anon_sym_static] = ACTIONS(2559),
    [anon_sym_readonly] = ACTIONS(2559),
    [anon_sym_get] = ACTIONS(2559),
    [anon_sym_set] = ACTIONS(2559),
    [anon_sym_public] = ACTIONS(2559),
    [anon_sym_private] = ACTIONS(2559),
    [anon_sym_protected] = ACTIONS(2559),
    [anon_sym_module] = ACTIONS(2559),
    [anon_sym_any] = ACTIONS(2559),
    [anon_sym_number] = ACTIONS(2559),
    [anon_sym_boolean] = ACTIONS(2559),
    [anon_sym_string] = ACTIONS(2559),
    [anon_sym_symbol] = ACTIONS(2559),
  },
  [395] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2381),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2449),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [396] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [397] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2381),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2896),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [398] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2417),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(4685),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [399] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3284),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2612),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [400] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2742),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [401] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3223),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [402] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2741),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [403] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2345),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2562),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [404] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4357),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(4969),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_export] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2639),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2643),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_readonly] = ACTIONS(2639),
    [anon_sym_get] = ACTIONS(2639),
    [anon_sym_set] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_module] = ACTIONS(2639),
    [anon_sym_any] = ACTIONS(2639),
    [anon_sym_number] = ACTIONS(2639),
    [anon_sym_boolean] = ACTIONS(2639),
    [anon_sym_string] = ACTIONS(2639),
    [anon_sym_symbol] = ACTIONS(2639),
  },
  [405] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2989),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5334),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [406] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2485),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [407] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2665),
    [anon_sym_export] = ACTIONS(2531),
    [anon_sym_namespace] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2531),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2531),
    [anon_sym_static] = ACTIONS(2531),
    [anon_sym_readonly] = ACTIONS(2531),
    [anon_sym_get] = ACTIONS(2531),
    [anon_sym_set] = ACTIONS(2531),
    [anon_sym_public] = ACTIONS(2531),
    [anon_sym_private] = ACTIONS(2531),
    [anon_sym_protected] = ACTIONS(2531),
    [anon_sym_module] = ACTIONS(2531),
    [anon_sym_any] = ACTIONS(2531),
    [anon_sym_number] = ACTIONS(2531),
    [anon_sym_boolean] = ACTIONS(2531),
    [anon_sym_string] = ACTIONS(2531),
    [anon_sym_symbol] = ACTIONS(2531),
  },
  [408] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2381),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2067),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [409] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2390),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2446),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [410] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2404),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2444),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [411] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2212),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2609),
    [anon_sym_export] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2479),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2477),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2481),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_readonly] = ACTIONS(2477),
    [anon_sym_get] = ACTIONS(2477),
    [anon_sym_set] = ACTIONS(2477),
    [anon_sym_public] = ACTIONS(2477),
    [anon_sym_private] = ACTIONS(2477),
    [anon_sym_protected] = ACTIONS(2477),
    [anon_sym_module] = ACTIONS(2477),
    [anon_sym_any] = ACTIONS(2477),
    [anon_sym_number] = ACTIONS(2477),
    [anon_sym_boolean] = ACTIONS(2477),
    [anon_sym_string] = ACTIONS(2477),
    [anon_sym_symbol] = ACTIONS(2477),
  },
  [412] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3288),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [413] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2212),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_export] = ACTIONS(2683),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2683),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_get] = ACTIONS(2683),
    [anon_sym_set] = ACTIONS(2683),
    [anon_sym_public] = ACTIONS(2683),
    [anon_sym_private] = ACTIONS(2683),
    [anon_sym_protected] = ACTIONS(2683),
    [anon_sym_module] = ACTIONS(2683),
    [anon_sym_any] = ACTIONS(2683),
    [anon_sym_number] = ACTIONS(2683),
    [anon_sym_boolean] = ACTIONS(2683),
    [anon_sym_string] = ACTIONS(2683),
    [anon_sym_symbol] = ACTIONS(2683),
  },
  [414] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2212),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2575),
    [anon_sym_export] = ACTIONS(2577),
    [anon_sym_namespace] = ACTIONS(2579),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2577),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2583),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2577),
    [anon_sym_static] = ACTIONS(2577),
    [anon_sym_readonly] = ACTIONS(2577),
    [anon_sym_get] = ACTIONS(2577),
    [anon_sym_set] = ACTIONS(2577),
    [anon_sym_public] = ACTIONS(2577),
    [anon_sym_private] = ACTIONS(2577),
    [anon_sym_protected] = ACTIONS(2577),
    [anon_sym_module] = ACTIONS(2577),
    [anon_sym_any] = ACTIONS(2577),
    [anon_sym_number] = ACTIONS(2577),
    [anon_sym_boolean] = ACTIONS(2577),
    [anon_sym_string] = ACTIONS(2577),
    [anon_sym_symbol] = ACTIONS(2577),
  },
  [415] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2790),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_sequence_expression] = STATE(5120),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [416] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2920),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5496),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [417] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2664),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2292),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [418] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(3001),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5449),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [419] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2483),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [420] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2481),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [421] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2156),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [422] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2607),
    [anon_sym_export] = ACTIONS(2443),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(2443),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2447),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2443),
    [anon_sym_readonly] = ACTIONS(2443),
    [anon_sym_get] = ACTIONS(2443),
    [anon_sym_set] = ACTIONS(2443),
    [anon_sym_public] = ACTIONS(2443),
    [anon_sym_private] = ACTIONS(2443),
    [anon_sym_protected] = ACTIONS(2443),
    [anon_sym_module] = ACTIONS(2443),
    [anon_sym_any] = ACTIONS(2443),
    [anon_sym_number] = ACTIONS(2443),
    [anon_sym_boolean] = ACTIONS(2443),
    [anon_sym_string] = ACTIONS(2443),
    [anon_sym_symbol] = ACTIONS(2443),
  },
  [423] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [424] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(3050),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5424),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [425] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2451),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [426] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [427] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2212),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2691),
    [anon_sym_export] = ACTIONS(2451),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2451),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2451),
    [anon_sym_static] = ACTIONS(2451),
    [anon_sym_readonly] = ACTIONS(2451),
    [anon_sym_get] = ACTIONS(2451),
    [anon_sym_set] = ACTIONS(2451),
    [anon_sym_public] = ACTIONS(2451),
    [anon_sym_private] = ACTIONS(2451),
    [anon_sym_protected] = ACTIONS(2451),
    [anon_sym_module] = ACTIONS(2451),
    [anon_sym_any] = ACTIONS(2451),
    [anon_sym_number] = ACTIONS(2451),
    [anon_sym_boolean] = ACTIONS(2451),
    [anon_sym_string] = ACTIONS(2451),
    [anon_sym_symbol] = ACTIONS(2451),
  },
  [428] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2477),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [429] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3231),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2712),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [430] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2693),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2225),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [431] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2670),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2316),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [432] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2825),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [433] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3224),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2716),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [434] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [435] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2166),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [436] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2717),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2308),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [437] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2404),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2059),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [438] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2177),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [439] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1917),
    [sym_expression] = STATE(3362),
    [sym_primary_expression] = STATE(2761),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1917),
    [sym_subscript_expression] = STATE(1917),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1917),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(2633),
    [anon_sym_export] = ACTIONS(2375),
    [anon_sym_namespace] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(2375),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_DOT] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(2379),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2375),
    [anon_sym_static] = ACTIONS(2375),
    [anon_sym_readonly] = ACTIONS(2375),
    [anon_sym_get] = ACTIONS(2375),
    [anon_sym_set] = ACTIONS(2375),
    [anon_sym_public] = ACTIONS(2375),
    [anon_sym_private] = ACTIONS(2375),
    [anon_sym_protected] = ACTIONS(2375),
    [anon_sym_module] = ACTIONS(2375),
    [anon_sym_any] = ACTIONS(2375),
    [anon_sym_number] = ACTIONS(2375),
    [anon_sym_boolean] = ACTIONS(2375),
    [anon_sym_string] = ACTIONS(2375),
    [anon_sym_symbol] = ACTIONS(2375),
  },
  [440] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1917),
    [sym_expression] = STATE(3362),
    [sym_primary_expression] = STATE(2761),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1917),
    [sym_subscript_expression] = STATE(1917),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1917),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(2657),
    [anon_sym_export] = ACTIONS(2659),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(2659),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_DOT] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(2663),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2659),
    [anon_sym_readonly] = ACTIONS(2659),
    [anon_sym_get] = ACTIONS(2659),
    [anon_sym_set] = ACTIONS(2659),
    [anon_sym_public] = ACTIONS(2659),
    [anon_sym_private] = ACTIONS(2659),
    [anon_sym_protected] = ACTIONS(2659),
    [anon_sym_module] = ACTIONS(2659),
    [anon_sym_any] = ACTIONS(2659),
    [anon_sym_number] = ACTIONS(2659),
    [anon_sym_boolean] = ACTIONS(2659),
    [anon_sym_string] = ACTIONS(2659),
    [anon_sym_symbol] = ACTIONS(2659),
  },
  [441] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2587),
    [anon_sym_export] = ACTIONS(2521),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(2521),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2525),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2521),
    [anon_sym_static] = ACTIONS(2521),
    [anon_sym_readonly] = ACTIONS(2521),
    [anon_sym_get] = ACTIONS(2521),
    [anon_sym_set] = ACTIONS(2521),
    [anon_sym_public] = ACTIONS(2521),
    [anon_sym_private] = ACTIONS(2521),
    [anon_sym_protected] = ACTIONS(2521),
    [anon_sym_module] = ACTIONS(2521),
    [anon_sym_any] = ACTIONS(2521),
    [anon_sym_number] = ACTIONS(2521),
    [anon_sym_boolean] = ACTIONS(2521),
    [anon_sym_string] = ACTIONS(2521),
    [anon_sym_symbol] = ACTIONS(2521),
  },
  [442] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2178),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [443] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2381),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2691),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [444] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2973),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [445] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2975),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [446] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2212),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2691),
    [anon_sym_export] = ACTIONS(2451),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(2451),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2451),
    [anon_sym_static] = ACTIONS(2451),
    [anon_sym_readonly] = ACTIONS(2451),
    [anon_sym_get] = ACTIONS(2451),
    [anon_sym_set] = ACTIONS(2451),
    [anon_sym_public] = ACTIONS(2451),
    [anon_sym_private] = ACTIONS(2451),
    [anon_sym_protected] = ACTIONS(2451),
    [anon_sym_module] = ACTIONS(2451),
    [anon_sym_any] = ACTIONS(2451),
    [anon_sym_number] = ACTIONS(2451),
    [anon_sym_boolean] = ACTIONS(2451),
    [anon_sym_string] = ACTIONS(2451),
    [anon_sym_symbol] = ACTIONS(2451),
  },
  [447] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2381),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2528),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [448] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2390),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2521),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [449] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2990),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [450] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2390),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2690),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [451] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2404),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2503),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [452] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2883),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [453] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2404),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2689),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [454] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2151),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2885),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [455] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2886),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [456] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3212),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_mapped_type_clause] = STATE(5240),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2693),
    [anon_sym_export] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2695),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2699),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_readonly] = ACTIONS(2695),
    [anon_sym_get] = ACTIONS(2695),
    [anon_sym_set] = ACTIONS(2695),
    [anon_sym_public] = ACTIONS(2695),
    [anon_sym_private] = ACTIONS(2695),
    [anon_sym_protected] = ACTIONS(2695),
    [anon_sym_module] = ACTIONS(2695),
    [anon_sym_any] = ACTIONS(2695),
    [anon_sym_number] = ACTIONS(2695),
    [anon_sym_boolean] = ACTIONS(2695),
    [anon_sym_string] = ACTIONS(2695),
    [anon_sym_symbol] = ACTIONS(2695),
  },
  [457] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2887),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [458] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2395),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [459] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [460] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2212),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1337),
    [sym_subscript_expression] = STATE(1337),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2423),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(2423),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2423),
    [anon_sym_static] = ACTIONS(2423),
    [anon_sym_readonly] = ACTIONS(2423),
    [anon_sym_get] = ACTIONS(2423),
    [anon_sym_set] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2423),
    [anon_sym_private] = ACTIONS(2423),
    [anon_sym_protected] = ACTIONS(2423),
    [anon_sym_module] = ACTIONS(2423),
    [anon_sym_any] = ACTIONS(2423),
    [anon_sym_number] = ACTIONS(2423),
    [anon_sym_boolean] = ACTIONS(2423),
    [anon_sym_string] = ACTIONS(2423),
    [anon_sym_symbol] = ACTIONS(2423),
  },
  [461] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2889),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [462] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_export] = ACTIONS(2675),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2675),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2679),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2675),
    [anon_sym_static] = ACTIONS(2675),
    [anon_sym_readonly] = ACTIONS(2675),
    [anon_sym_get] = ACTIONS(2675),
    [anon_sym_set] = ACTIONS(2675),
    [anon_sym_public] = ACTIONS(2675),
    [anon_sym_private] = ACTIONS(2675),
    [anon_sym_protected] = ACTIONS(2675),
    [anon_sym_module] = ACTIONS(2675),
    [anon_sym_any] = ACTIONS(2675),
    [anon_sym_number] = ACTIONS(2675),
    [anon_sym_boolean] = ACTIONS(2675),
    [anon_sym_string] = ACTIONS(2675),
    [anon_sym_symbol] = ACTIONS(2675),
  },
  [463] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3292),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [464] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2394),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2412),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [465] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4406),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5072),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_export] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2639),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2643),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_readonly] = ACTIONS(2639),
    [anon_sym_get] = ACTIONS(2639),
    [anon_sym_set] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_module] = ACTIONS(2639),
    [anon_sym_any] = ACTIONS(2639),
    [anon_sym_number] = ACTIONS(2639),
    [anon_sym_boolean] = ACTIONS(2639),
    [anon_sym_string] = ACTIONS(2639),
    [anon_sym_symbol] = ACTIONS(2639),
  },
  [466] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3290),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [467] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4272),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(4950),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_export] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2639),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2643),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_readonly] = ACTIONS(2639),
    [anon_sym_get] = ACTIONS(2639),
    [anon_sym_set] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_module] = ACTIONS(2639),
    [anon_sym_any] = ACTIONS(2639),
    [anon_sym_number] = ACTIONS(2639),
    [anon_sym_boolean] = ACTIONS(2639),
    [anon_sym_string] = ACTIONS(2639),
    [anon_sym_symbol] = ACTIONS(2639),
  },
  [468] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2390),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2064),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [469] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2197),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2874),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [470] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3323),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2578),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [471] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2394),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2056),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [472] = {
    [sym_import] = STATE(2275),
    [sym_statement_block] = STATE(2394),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2637),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [473] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2342),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [474] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2128),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2343),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [475] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2124),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3291),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [476] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2717),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [477] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2610),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_sequence_expression] = STATE(5282),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [478] = {
    [sym_import] = STATE(3278),
    [sym_statement_block] = STATE(3302),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2591),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [479] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2715),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2229),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [480] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3006),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [481] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3352),
    [sym_primary_expression] = STATE(2013),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_export] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(2639),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(2643),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_readonly] = ACTIONS(2639),
    [anon_sym_get] = ACTIONS(2639),
    [anon_sym_set] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_module] = ACTIONS(2639),
    [anon_sym_any] = ACTIONS(2639),
    [anon_sym_number] = ACTIONS(2639),
    [anon_sym_boolean] = ACTIONS(2639),
    [anon_sym_string] = ACTIONS(2639),
    [anon_sym_symbol] = ACTIONS(2639),
  },
  [482] = {
    [sym_import] = STATE(2192),
    [sym_statement_block] = STATE(2121),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2341),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [483] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2709),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2219),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [484] = {
    [sym_import] = STATE(2831),
    [sym_statement_block] = STATE(2709),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2306),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [485] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2544),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [486] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3114),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [487] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2220),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [488] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2322),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [489] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3118),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [490] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2456),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(2701),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [491] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2489),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [492] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2240),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(2701),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [493] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2476),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [494] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3078),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [495] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2564),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [496] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2563),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [497] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2548),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [498] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2223),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [499] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2537),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [500] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2563),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [501] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2535),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [502] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2534),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [503] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2533),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [504] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2532),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [505] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2531),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [506] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2529),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [507] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [508] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [509] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2524),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [510] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2523),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [511] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2519),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [512] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2515),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [513] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2513),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [514] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2799),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [515] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2800),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [516] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2708),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [517] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3274),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [518] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2971),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [519] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2943),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [520] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2944),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [521] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3113),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [522] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3115),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [523] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2228),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [524] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2998),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2705),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [525] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3004),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [526] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3116),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [527] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3138),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [528] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2943),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [529] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2269),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [530] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2230),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [531] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3171),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [532] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2249),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [533] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3008),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [534] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2293),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [535] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3009),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [536] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2628),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [537] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3011),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [538] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3012),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [539] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2250),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [540] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3018),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [541] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3019),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [542] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3020),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [543] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3024),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [544] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3026),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [545] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3268),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [546] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3027),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [547] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2623),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [548] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3029),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [549] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3030),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [550] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2622),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [551] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(3032),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [552] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2906),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [553] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2269),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2707),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [554] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2747),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [555] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2251),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [556] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2222),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [557] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3131),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [558] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2224),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [559] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2291),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [560] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2231),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [561] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2235),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [562] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2735),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [563] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3282),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [564] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2270),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [565] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2538),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [566] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2554),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [567] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2556),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [568] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2800),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [569] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3057),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [570] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2290),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [571] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2471),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [572] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2289),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [573] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2288),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [574] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2585),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [575] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2554),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [576] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2287),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [577] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2454),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [578] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2284),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [579] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2749),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [580] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2282),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [581] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2687),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [582] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2470),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [583] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2280),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [584] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2469),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [585] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [586] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2467),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [587] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2473),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [588] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2466),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [589] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2465),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [590] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2464),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [591] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2462),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [592] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2460),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [593] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2801),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [594] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2373),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [595] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(3049),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [596] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(3048),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [597] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(3047),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [598] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2447),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [599] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2489),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(2709),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [600] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2456),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [601] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2459),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [602] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2439),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [603] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2458),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [604] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(3045),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [605] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2437),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [606] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2457),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [607] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [608] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2581),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [609] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2436),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [610] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2643),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [611] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2435),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [612] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2434),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [613] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2269),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2711),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [614] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3194),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [615] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2756),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [616] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2685),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [617] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2422),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [618] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3106),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [619] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2405),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [620] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2863),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [621] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2495),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [622] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2493),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [623] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2492),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [624] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2418),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [625] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2979),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [626] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2391),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [627] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2766),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [628] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2877),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [629] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2991),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [630] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2876),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [631] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2875),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [632] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2871),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [633] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2767),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [634] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2329),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [635] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2771),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [636] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2773),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [637] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2317),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [638] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3304),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [639] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2867),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [640] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2779),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [641] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2864),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [642] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2575),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [643] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2862),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [644] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2859),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [645] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2493),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [646] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2633),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [647] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2857),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [648] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2856),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [649] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2855),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [650] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2852),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [651] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2577),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [652] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2844),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [653] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2580),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [654] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2586),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [655] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2804),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [656] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2589),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [657] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2590),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [658] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2592),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [659] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2593),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [660] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2594),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [661] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2542),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [662] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2998),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [663] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2999),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [664] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2598),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [665] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2813),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [666] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2599),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [667] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [668] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2921),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [669] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2296),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [670] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2269),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [671] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2601),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [672] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2772),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [673] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2602),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [674] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2283),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [675] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2490),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [676] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2881),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [677] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3211),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [678] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2265),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [679] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1962),
    [sym_expression] = STATE(2858),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5423),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5423),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5425),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1962),
    [sym_subscript_expression] = STATE(1962),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5423),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1962),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(616),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_readonly] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
  },
  [680] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2948),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [681] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2267),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [682] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2269),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2713),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [683] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2815),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [684] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2297),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [685] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2499),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [686] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2239),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [687] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2240),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [688] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2760),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [689] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2242),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [690] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2847),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [691] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2811),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [692] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2414),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [693] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2376),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [694] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2539),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [695] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2501),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [696] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2763),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [697] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3150),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [698] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2150),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [699] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2209),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [700] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2210),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [701] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [702] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2696),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [703] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2501),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2715),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [704] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2684),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [705] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2421),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [706] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2419),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [707] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2681),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [708] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [709] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [710] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2500),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(2715),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [711] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2679),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [712] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2214),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [713] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2148),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [714] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2939),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [715] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2677),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [716] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2937),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [717] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2676),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [718] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2675),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [719] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2377),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [720] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2237),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [721] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2673),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [722] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2661),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [723] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2928),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [724] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2775),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [725] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2772),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [726] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2095),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [727] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1913),
    [sym_expression] = STATE(2770),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5233),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5233),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5289),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1913),
    [sym_subscript_expression] = STATE(1913),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3664),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5233),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1913),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(630),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1271),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1279),
    [anon_sym_yield] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1745),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_protected] = ACTIONS(1271),
    [anon_sym_module] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
  },
  [728] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3329),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [729] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2246),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [730] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2245),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [731] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2918),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [732] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2827),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [733] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2210),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [734] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3245),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [735] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2140),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [736] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2502),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [737] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2881),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [738] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2516),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [739] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2092),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [740] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2517),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [741] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2091),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [742] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2090),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [743] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2518),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [744] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2915),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [745] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2911),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [746] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2089),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [747] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2088),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [748] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2087),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [749] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2086),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [750] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2079),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [751] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2520),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [752] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2905),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [753] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3215),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [754] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2890),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [755] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2902),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [756] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2078),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [757] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2530),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [758] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2077),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [759] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2901),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [760] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2900),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [761] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2076),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [762] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2899),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [763] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2898),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [764] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2621),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [765] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2134),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [766] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2894),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [767] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2138),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [768] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2122),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [769] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3212),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [770] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2115),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [771] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2075),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [772] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2587),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [773] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2473),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4526),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4526),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4526),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2717),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [774] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2778),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [775] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2074),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [776] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2112),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [777] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1945),
    [sym_expression] = STATE(2550),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5344),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5344),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5497),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1945),
    [sym_subscript_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5344),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1945),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(608),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(941),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_typeof] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_delete] = ACTIONS(965),
    [anon_sym_PLUS_PLUS] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_readonly] = ACTIONS(941),
    [anon_sym_get] = ACTIONS(941),
    [anon_sym_set] = ACTIONS(941),
    [anon_sym_public] = ACTIONS(941),
    [anon_sym_private] = ACTIONS(941),
    [anon_sym_protected] = ACTIONS(941),
    [anon_sym_module] = ACTIONS(941),
    [anon_sym_any] = ACTIONS(941),
    [anon_sym_number] = ACTIONS(941),
    [anon_sym_boolean] = ACTIONS(941),
    [anon_sym_string] = ACTIONS(941),
    [anon_sym_symbol] = ACTIONS(941),
  },
  [778] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2785),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [779] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2793),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [780] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3241),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [781] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2707),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [782] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2560),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [783] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2110),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [784] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2184),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [785] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(3048),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(2709),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [786] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2816),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(2709),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [787] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3010),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [788] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2216),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [789] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2785),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(2719),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [790] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3326),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [791] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_expression] = STATE(2238),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5393),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5393),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5396),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3661),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5393),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1405),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(729),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1337),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_TILDE] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1361),
    [anon_sym_delete] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_get] = ACTIONS(1337),
    [anon_sym_set] = ACTIONS(1337),
    [anon_sym_public] = ACTIONS(1337),
    [anon_sym_private] = ACTIONS(1337),
    [anon_sym_protected] = ACTIONS(1337),
    [anon_sym_module] = ACTIONS(1337),
    [anon_sym_any] = ACTIONS(1337),
    [anon_sym_number] = ACTIONS(1337),
    [anon_sym_boolean] = ACTIONS(1337),
    [anon_sym_string] = ACTIONS(1337),
    [anon_sym_symbol] = ACTIONS(1337),
  },
  [792] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2636),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [793] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2107),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [794] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2814),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [795] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2638),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [796] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [797] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2816),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [798] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2642),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [799] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2645),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [800] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2646),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [801] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3270),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [802] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2647),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [803] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2817),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [804] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2649),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [805] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2912),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [806] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2651),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [807] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2269),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5484),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5484),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5484),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2721),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [808] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2656),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [809] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2053),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [810] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1349),
    [sym_expression] = STATE(2207),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5287),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5287),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5487),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3669),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5287),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1195),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1195),
    [anon_sym_readonly] = ACTIONS(1195),
    [anon_sym_get] = ACTIONS(1195),
    [anon_sym_set] = ACTIONS(1195),
    [anon_sym_public] = ACTIONS(1195),
    [anon_sym_private] = ACTIONS(1195),
    [anon_sym_protected] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1195),
    [anon_sym_any] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_boolean] = ACTIONS(1195),
    [anon_sym_string] = ACTIONS(1195),
    [anon_sym_symbol] = ACTIONS(1195),
  },
  [811] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2686),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [812] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2054),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [813] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1926),
    [sym_expression] = STATE(2970),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5543),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5543),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5551),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1926),
    [sym_subscript_expression] = STATE(1926),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5543),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1926),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(714),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_typeof] = ACTIONS(1459),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_void] = ACTIONS(1459),
    [anon_sym_delete] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_readonly] = ACTIONS(1435),
    [anon_sym_get] = ACTIONS(1435),
    [anon_sym_set] = ACTIONS(1435),
    [anon_sym_public] = ACTIONS(1435),
    [anon_sym_private] = ACTIONS(1435),
    [anon_sym_protected] = ACTIONS(1435),
    [anon_sym_module] = ACTIONS(1435),
    [anon_sym_any] = ACTIONS(1435),
    [anon_sym_number] = ACTIONS(1435),
    [anon_sym_boolean] = ACTIONS(1435),
    [anon_sym_string] = ACTIONS(1435),
    [anon_sym_symbol] = ACTIONS(1435),
  },
  [814] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2055),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [815] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2623),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(2719),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [816] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2694),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [817] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2952),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [818] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(2695),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5298),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5298),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5296),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3667),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5298),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1900),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(818),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(925),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_void] = ACTIONS(925),
    [anon_sym_delete] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_any] = ACTIONS(891),
    [anon_sym_number] = ACTIONS(891),
    [anon_sym_boolean] = ACTIONS(891),
    [anon_sym_string] = ACTIONS(891),
    [anon_sym_symbol] = ACTIONS(891),
  },
  [819] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2888),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [820] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2954),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [821] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2057),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [822] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3119),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [823] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3087),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [824] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1938),
    [sym_expression] = STATE(2840),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5387),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5387),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5464),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3668),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5387),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1938),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(690),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
  },
  [825] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3086),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [826] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2500),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [827] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1370),
    [sym_expression] = STATE(2473),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(4723),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(4723),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5320),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1370),
    [sym_subscript_expression] = STATE(1370),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3670),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(4723),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(681),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_typeof] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(549),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [828] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3085),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [829] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_expression] = STATE(2940),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5359),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5359),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5558),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5359),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1972),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1027),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1019),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_delete] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [830] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3082),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [831] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2452),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [832] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3081),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [833] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3080),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [834] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2491),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [835] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3076),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [836] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3074),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [837] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_expression] = STATE(2568),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5370),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5370),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5232),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1902),
    [sym_subscript_expression] = STATE(1902),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5370),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1902),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(513),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(849),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_get] = ACTIONS(849),
    [anon_sym_set] = ACTIONS(849),
    [anon_sym_public] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_protected] = ACTIONS(849),
    [anon_sym_module] = ACTIONS(849),
    [anon_sym_any] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_boolean] = ACTIONS(849),
    [anon_sym_string] = ACTIONS(849),
    [anon_sym_symbol] = ACTIONS(849),
  },
  [838] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3071),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [839] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2419),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(2709),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [840] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3319),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [841] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3317),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [842] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3316),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [843] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2134),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(2709),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [844] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3070),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [845] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3069),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [846] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3068),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [847] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_expression] = STATE(2071),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5259),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5259),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5217),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(1332),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3677),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5259),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(698),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1037),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1037),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_readonly] = ACTIONS(1037),
    [anon_sym_get] = ACTIONS(1037),
    [anon_sym_set] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1037),
    [anon_sym_private] = ACTIONS(1037),
    [anon_sym_protected] = ACTIONS(1037),
    [anon_sym_module] = ACTIONS(1037),
    [anon_sym_any] = ACTIONS(1037),
    [anon_sym_number] = ACTIONS(1037),
    [anon_sym_boolean] = ACTIONS(1037),
    [anon_sym_string] = ACTIONS(1037),
    [anon_sym_symbol] = ACTIONS(1037),
  },
  [848] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2424),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [849] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3067),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [850] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2379),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [851] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2384),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [852] = {
    [sym_import] = STATE(2831),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_expression] = STATE(2382),
    [sym_primary_expression] = STATE(2834),
    [sym_yield_expression] = STATE(2839),
    [sym_object] = STATE(2831),
    [sym_object_pattern] = STATE(5489),
    [sym_array] = STATE(2831),
    [sym_array_pattern] = STATE(5489),
    [sym_class] = STATE(2831),
    [sym_function] = STATE(2831),
    [sym_generator_function] = STATE(2831),
    [sym_arrow_function] = STATE(2831),
    [sym__call_signature] = STATE(5488),
    [sym_call_expression] = STATE(2831),
    [sym_new_expression] = STATE(2839),
    [sym_await_expression] = STATE(2839),
    [sym_member_expression] = STATE(1433),
    [sym_subscript_expression] = STATE(1433),
    [sym_assignment_expression] = STATE(2839),
    [sym__augmented_assignment_lhs] = STATE(3675),
    [sym_augmented_assignment_expression] = STATE(2839),
    [sym__destructuring_pattern] = STATE(5489),
    [sym_ternary_expression] = STATE(2839),
    [sym_binary_expression] = STATE(2839),
    [sym_unary_expression] = STATE(2839),
    [sym_update_expression] = STATE(2839),
    [sym_string] = STATE(2831),
    [sym_template_string] = STATE(2831),
    [sym_regex] = STATE(2831),
    [sym_meta_property] = STATE(2831),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(2839),
    [sym_as_expression] = STATE(2839),
    [sym_internal_module] = STATE(2839),
    [sym_type_arguments] = STATE(851),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4557),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1077),
    [anon_sym_readonly] = ACTIONS(1077),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
    [anon_sym_public] = ACTIONS(1077),
    [anon_sym_private] = ACTIONS(1077),
    [anon_sym_protected] = ACTIONS(1077),
    [anon_sym_module] = ACTIONS(1077),
    [anon_sym_any] = ACTIONS(1077),
    [anon_sym_number] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1077),
    [anon_sym_string] = ACTIONS(1077),
    [anon_sym_symbol] = ACTIONS(1077),
  },
  [853] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2385),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [854] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2387),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [855] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2398),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [856] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2498),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5323),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5323),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5384),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5323),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(673),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_symbol] = ACTIONS(1241),
  },
  [857] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3115),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [858] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3243),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [859] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2549),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [860] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3062),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [861] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2431),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [862] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2565),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [863] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3244),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [864] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2567),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [865] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2982),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [866] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2570),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [867] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3038),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [868] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2614),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [869] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2584),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [870] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2410),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [871] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2588),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [872] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3266),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [873] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2409),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [874] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2406),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [875] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3317),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(2703),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [876] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2402),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [877] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3003),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [878] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2595),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [879] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3007),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [880] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2596),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [881] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2603),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [882] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2461),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5499),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5499),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5502),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3676),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5499),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(694),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
  },
  [883] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_expression] = STATE(3174),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5319),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5319),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5299),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3665),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5319),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(823),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1513),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1513),
    [anon_sym_delete] = ACTIONS(1513),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
  },
  [884] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3013),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [885] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3260),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [886] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2605),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [887] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2606),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [888] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2608),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [889] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3014),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [890] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3259),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [891] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3257),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [892] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3256),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [893] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3254),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [894] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3252),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [895] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3250),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [896] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2609),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [897] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3249),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [898] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3015),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [899] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2399),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [900] = {
    [sym_import] = STATE(3278),
    [sym_parenthesized_expression] = STATE(1909),
    [sym_expression] = STATE(2611),
    [sym_primary_expression] = STATE(3299),
    [sym_yield_expression] = STATE(3307),
    [sym_object] = STATE(3278),
    [sym_object_pattern] = STATE(5439),
    [sym_array] = STATE(3278),
    [sym_array_pattern] = STATE(5439),
    [sym_class] = STATE(3278),
    [sym_function] = STATE(3278),
    [sym_generator_function] = STATE(3278),
    [sym_arrow_function] = STATE(3278),
    [sym__call_signature] = STATE(5441),
    [sym_call_expression] = STATE(3278),
    [sym_new_expression] = STATE(3307),
    [sym_await_expression] = STATE(3307),
    [sym_member_expression] = STATE(1909),
    [sym_subscript_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(3307),
    [sym__augmented_assignment_lhs] = STATE(3663),
    [sym_augmented_assignment_expression] = STATE(3307),
    [sym__destructuring_pattern] = STATE(5439),
    [sym_ternary_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym_update_expression] = STATE(3307),
    [sym_string] = STATE(3278),
    [sym_template_string] = STATE(3278),
    [sym_regex] = STATE(3278),
    [sym_meta_property] = STATE(3278),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1909),
    [sym_type_assertion] = STATE(3307),
    [sym_as_expression] = STATE(3307),
    [sym_internal_module] = STATE(3307),
    [sym_type_arguments] = STATE(864),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4610),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1377),
    [anon_sym_namespace] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_await] = ACTIONS(1391),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1399),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1403),
    [anon_sym_new] = ACTIONS(1715),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1717),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_get] = ACTIONS(1377),
    [anon_sym_set] = ACTIONS(1377),
    [anon_sym_public] = ACTIONS(1377),
    [anon_sym_private] = ACTIONS(1377),
    [anon_sym_protected] = ACTIONS(1377),
    [anon_sym_module] = ACTIONS(1377),
    [anon_sym_any] = ACTIONS(1377),
    [anon_sym_number] = ACTIONS(1377),
    [anon_sym_boolean] = ACTIONS(1377),
    [anon_sym_string] = ACTIONS(1377),
    [anon_sym_symbol] = ACTIONS(1377),
  },
  [901] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3021),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [902] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(2882),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [903] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1947),
    [sym_expression] = STATE(3025),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5308),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5308),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5307),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1947),
    [sym_subscript_expression] = STATE(1947),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3671),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5308),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1947),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(819),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(793),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_PLUS_PLUS] = ACTIONS(795),
    [anon_sym_DASH_DASH] = ACTIONS(795),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_readonly] = ACTIONS(767),
    [anon_sym_get] = ACTIONS(767),
    [anon_sym_set] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_module] = ACTIONS(767),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
  },
  [904] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3248),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [905] = {
    [sym_import] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1922),
    [sym_expression] = STATE(2400),
    [sym_primary_expression] = STATE(2277),
    [sym_yield_expression] = STATE(2278),
    [sym_object] = STATE(2275),
    [sym_object_pattern] = STATE(5358),
    [sym_array] = STATE(2275),
    [sym_array_pattern] = STATE(5358),
    [sym_class] = STATE(2275),
    [sym_function] = STATE(2275),
    [sym_generator_function] = STATE(2275),
    [sym_arrow_function] = STATE(2275),
    [sym__call_signature] = STATE(5353),
    [sym_call_expression] = STATE(2275),
    [sym_new_expression] = STATE(2278),
    [sym_await_expression] = STATE(2278),
    [sym_member_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(2278),
    [sym__augmented_assignment_lhs] = STATE(3662),
    [sym_augmented_assignment_expression] = STATE(2278),
    [sym__destructuring_pattern] = STATE(5358),
    [sym_ternary_expression] = STATE(2278),
    [sym_binary_expression] = STATE(2278),
    [sym_unary_expression] = STATE(2278),
    [sym_update_expression] = STATE(2278),
    [sym_string] = STATE(2275),
    [sym_template_string] = STATE(2275),
    [sym_regex] = STATE(2275),
    [sym_meta_property] = STATE(2275),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1922),
    [sym_type_assertion] = STATE(2278),
    [sym_as_expression] = STATE(2278),
    [sym_internal_module] = STATE(2278),
    [sym_type_arguments] = STATE(693),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4550),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_typeof] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1313),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1327),
    [anon_sym_delete] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
  },
  [906] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3247),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [907] = {
    [sym_import] = STATE(2192),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_expression] = STATE(3246),
    [sym_primary_expression] = STATE(2204),
    [sym_yield_expression] = STATE(2203),
    [sym_object] = STATE(2192),
    [sym_object_pattern] = STATE(5286),
    [sym_array] = STATE(2192),
    [sym_array_pattern] = STATE(5286),
    [sym_class] = STATE(2192),
    [sym_function] = STATE(2192),
    [sym_generator_function] = STATE(2192),
    [sym_arrow_function] = STATE(2192),
    [sym__call_signature] = STATE(5260),
    [sym_call_expression] = STATE(2192),
    [sym_new_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_member_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(1973),
    [sym_assignment_expression] = STATE(2203),
    [sym__augmented_assignment_lhs] = STATE(3666),
    [sym_augmented_assignment_expression] = STATE(2203),
    [sym__destructuring_pattern] = STATE(5286),
    [sym_ternary_expression] = STATE(2203),
    [sym_binary_expression] = STATE(2203),
    [sym_unary_expression] = STATE(2203),
    [sym_update_expression] = STATE(2203),
    [sym_string] = STATE(2192),
    [sym_template_string] = STATE(2192),
    [sym_regex] = STATE(2192),
    [sym_meta_property] = STATE(2192),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(4474),
    [sym_non_null_expression] = STATE(1973),
    [sym_type_assertion] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_internal_module] = STATE(2203),
    [sym_type_arguments] = STATE(858),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_export_statement_repeat1] = STATE(4670),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(819),
    [anon_sym_yield] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(563),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(587),
    [sym_number] = ACTIONS(1487),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_undefined] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
  },
  [908] = {
    [sym_declaration] = STATE(1145),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1821),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2567),
    [anon_sym_global] = ACTIONS(2569),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [909] = {
    [sym_declaration] = STATE(1145),
    [sym_variable_declaration] = STATE(1094),
    [sym_lexical_declaration] = STATE(1094),
    [sym_class_declaration] = STATE(1094),
    [sym_function_declaration] = STATE(1094),
    [sym_generator_function_declaration] = STATE(1094),
    [sym_decorator] = STATE(3633),
    [sym_function_signature] = STATE(1094),
    [sym_ambient_declaration] = STATE(1094),
    [sym_abstract_class_declaration] = STATE(1094),
    [sym_module] = STATE(1094),
    [sym_internal_module] = STATE(1101),
    [sym_import_alias] = STATE(1094),
    [sym_interface_declaration] = STATE(1094),
    [sym_enum_declaration] = STATE(1094),
    [sym_type_alias_declaration] = STATE(1094),
    [aux_sym_export_statement_repeat1] = STATE(4303),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1821),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(2275),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2567),
    [anon_sym_global] = ACTIONS(2569),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2283),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [910] = {
    [sym__call_signature] = STATE(5272),
    [sym_string] = STATE(4097),
    [sym_formal_parameters] = STATE(4474),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_object_repeat1] = STATE(4747),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_export] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_type] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2732),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2727),
    [anon_sym_function] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_readonly] = ACTIONS(2727),
    [anon_sym_get] = ACTIONS(2747),
    [anon_sym_set] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2727),
    [anon_sym_private] = ACTIONS(2727),
    [anon_sym_protected] = ACTIONS(2727),
    [anon_sym_module] = ACTIONS(2727),
    [anon_sym_any] = ACTIONS(2727),
    [anon_sym_number] = ACTIONS(2727),
    [anon_sym_boolean] = ACTIONS(2727),
    [anon_sym_string] = ACTIONS(2727),
    [anon_sym_symbol] = ACTIONS(2727),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [911] = {
    [sym__call_signature] = STATE(5272),
    [sym_string] = STATE(4097),
    [sym_formal_parameters] = STATE(4474),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_export] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_type] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2732),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2727),
    [anon_sym_function] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_readonly] = ACTIONS(2727),
    [anon_sym_get] = ACTIONS(2747),
    [anon_sym_set] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2727),
    [anon_sym_private] = ACTIONS(2727),
    [anon_sym_protected] = ACTIONS(2727),
    [anon_sym_module] = ACTIONS(2727),
    [anon_sym_any] = ACTIONS(2727),
    [anon_sym_number] = ACTIONS(2727),
    [anon_sym_boolean] = ACTIONS(2727),
    [anon_sym_string] = ACTIONS(2727),
    [anon_sym_symbol] = ACTIONS(2727),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [912] = {
    [sym__call_signature] = STATE(5272),
    [sym_string] = STATE(4097),
    [sym_formal_parameters] = STATE(4474),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_export] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_type] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2732),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2727),
    [anon_sym_function] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_readonly] = ACTIONS(2727),
    [anon_sym_get] = ACTIONS(2747),
    [anon_sym_set] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2727),
    [anon_sym_private] = ACTIONS(2727),
    [anon_sym_protected] = ACTIONS(2727),
    [anon_sym_module] = ACTIONS(2727),
    [anon_sym_any] = ACTIONS(2727),
    [anon_sym_number] = ACTIONS(2727),
    [anon_sym_boolean] = ACTIONS(2727),
    [anon_sym_string] = ACTIONS(2727),
    [anon_sym_symbol] = ACTIONS(2727),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [913] = {
    [sym__call_signature] = STATE(5272),
    [sym_string] = STATE(4097),
    [sym_formal_parameters] = STATE(4474),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_export] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_type] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2732),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2727),
    [anon_sym_function] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_readonly] = ACTIONS(2727),
    [anon_sym_get] = ACTIONS(2747),
    [anon_sym_set] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2727),
    [anon_sym_private] = ACTIONS(2727),
    [anon_sym_protected] = ACTIONS(2727),
    [anon_sym_module] = ACTIONS(2727),
    [anon_sym_any] = ACTIONS(2727),
    [anon_sym_number] = ACTIONS(2727),
    [anon_sym_boolean] = ACTIONS(2727),
    [anon_sym_string] = ACTIONS(2727),
    [anon_sym_symbol] = ACTIONS(2727),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [914] = {
    [sym__call_signature] = STATE(5272),
    [sym_string] = STATE(4097),
    [sym_formal_parameters] = STATE(4474),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_export] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2732),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2727),
    [anon_sym_function] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_readonly] = ACTIONS(2727),
    [anon_sym_get] = ACTIONS(2747),
    [anon_sym_set] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2727),
    [anon_sym_private] = ACTIONS(2727),
    [anon_sym_protected] = ACTIONS(2727),
    [anon_sym_module] = ACTIONS(2727),
    [anon_sym_any] = ACTIONS(2727),
    [anon_sym_number] = ACTIONS(2727),
    [anon_sym_boolean] = ACTIONS(2727),
    [anon_sym_string] = ACTIONS(2727),
    [anon_sym_symbol] = ACTIONS(2727),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [915] = {
    [sym__call_signature] = STATE(5272),
    [sym_string] = STATE(4097),
    [sym_formal_parameters] = STATE(4474),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_export] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_type] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2732),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2727),
    [anon_sym_function] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_readonly] = ACTIONS(2727),
    [anon_sym_get] = ACTIONS(2747),
    [anon_sym_set] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2727),
    [anon_sym_private] = ACTIONS(2727),
    [anon_sym_protected] = ACTIONS(2727),
    [anon_sym_module] = ACTIONS(2727),
    [anon_sym_any] = ACTIONS(2727),
    [anon_sym_number] = ACTIONS(2727),
    [anon_sym_boolean] = ACTIONS(2727),
    [anon_sym_string] = ACTIONS(2727),
    [anon_sym_symbol] = ACTIONS(2727),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [916] = {
    [sym__call_signature] = STATE(5272),
    [sym_string] = STATE(4097),
    [sym_formal_parameters] = STATE(4474),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [sym_type_parameters] = STATE(5025),
    [aux_sym_object_repeat1] = STATE(4799),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_export] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_type] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2732),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2727),
    [anon_sym_function] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_readonly] = ACTIONS(2727),
    [anon_sym_get] = ACTIONS(2747),
    [anon_sym_set] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2727),
    [anon_sym_private] = ACTIONS(2727),
    [anon_sym_protected] = ACTIONS(2727),
    [anon_sym_module] = ACTIONS(2727),
    [anon_sym_any] = ACTIONS(2727),
    [anon_sym_number] = ACTIONS(2727),
    [anon_sym_boolean] = ACTIONS(2727),
    [anon_sym_string] = ACTIONS(2727),
    [anon_sym_symbol] = ACTIONS(2727),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [917] = {
    [ts_builtin_sym_end] = ACTIONS(2749),
    [sym_identifier] = ACTIONS(2751),
    [anon_sym_export] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_EQ] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_COMMA] = ACTIONS(2749),
    [anon_sym_RBRACE] = ACTIONS(2749),
    [anon_sym_type] = ACTIONS(2751),
    [anon_sym_typeof] = ACTIONS(2751),
    [anon_sym_import] = ACTIONS(2751),
    [anon_sym_var] = ACTIONS(2751),
    [anon_sym_let] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_LPAREN] = ACTIONS(2749),
    [anon_sym_RPAREN] = ACTIONS(2749),
    [anon_sym_await] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_with] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_debugger] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym_COLON] = ACTIONS(2749),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_yield] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2749),
    [anon_sym_RBRACK] = ACTIONS(2749),
    [anon_sym_LT] = ACTIONS(2749),
    [anon_sym_GT] = ACTIONS(2749),
    [anon_sym_SLASH] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_async] = ACTIONS(2751),
    [anon_sym_function] = ACTIONS(2751),
    [anon_sym_EQ_GT] = ACTIONS(2749),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_QMARK] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_PIPE] = ACTIONS(2749),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_void] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2749),
    [sym_number] = ACTIONS(2749),
    [sym_this] = ACTIONS(2751),
    [sym_super] = ACTIONS(2751),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [sym_null] = ACTIONS(2751),
    [sym_undefined] = ACTIONS(2751),
    [anon_sym_AT] = ACTIONS(2749),
    [anon_sym_declare] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_readonly] = ACTIONS(2751),
    [anon_sym_abstract] = ACTIONS(2751),
    [anon_sym_get] = ACTIONS(2751),
    [anon_sym_set] = ACTIONS(2751),
    [anon_sym_public] = ACTIONS(2751),
    [anon_sym_private] = ACTIONS(2751),
    [anon_sym_protected] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(2751),
    [anon_sym_any] = ACTIONS(2751),
    [anon_sym_number] = ACTIONS(2751),
    [anon_sym_boolean] = ACTIONS(2751),
    [anon_sym_string] = ACTIONS(2751),
    [anon_sym_symbol] = ACTIONS(2751),
    [anon_sym_interface] = ACTIONS(2751),
    [anon_sym_extends] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
  },
  [918] = {
    [ts_builtin_sym_end] = ACTIONS(2753),
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_export] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_type] = ACTIONS(2755),
    [anon_sym_typeof] = ACTIONS(2755),
    [anon_sym_import] = ACTIONS(2755),
    [anon_sym_var] = ACTIONS(2755),
    [anon_sym_let] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_LPAREN] = ACTIONS(2753),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_await] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_with] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_debugger] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_COLON] = ACTIONS(2753),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_yield] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_RBRACK] = ACTIONS(2753),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_async] = ACTIONS(2755),
    [anon_sym_function] = ACTIONS(2755),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_void] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2753),
    [sym_number] = ACTIONS(2753),
    [sym_this] = ACTIONS(2755),
    [sym_super] = ACTIONS(2755),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [sym_null] = ACTIONS(2755),
    [sym_undefined] = ACTIONS(2755),
    [anon_sym_AT] = ACTIONS(2753),
    [anon_sym_declare] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_readonly] = ACTIONS(2755),
    [anon_sym_abstract] = ACTIONS(2755),
    [anon_sym_get] = ACTIONS(2755),
    [anon_sym_set] = ACTIONS(2755),
    [anon_sym_public] = ACTIONS(2755),
    [anon_sym_private] = ACTIONS(2755),
    [anon_sym_protected] = ACTIONS(2755),
    [anon_sym_module] = ACTIONS(2755),
    [anon_sym_any] = ACTIONS(2755),
    [anon_sym_number] = ACTIONS(2755),
    [anon_sym_boolean] = ACTIONS(2755),
    [anon_sym_string] = ACTIONS(2755),
    [anon_sym_symbol] = ACTIONS(2755),
    [anon_sym_interface] = ACTIONS(2755),
    [anon_sym_extends] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
  },
  [919] = {
    [ts_builtin_sym_end] = ACTIONS(1961),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_export] = ACTIONS(1963),
    [anon_sym_default] = ACTIONS(1963),
    [anon_sym_EQ] = ACTIONS(1963),
    [anon_sym_namespace] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1961),
    [anon_sym_COMMA] = ACTIONS(1961),
    [anon_sym_RBRACE] = ACTIONS(1961),
    [anon_sym_type] = ACTIONS(1963),
    [anon_sym_typeof] = ACTIONS(1963),
    [anon_sym_import] = ACTIONS(1963),
    [anon_sym_var] = ACTIONS(1963),
    [anon_sym_let] = ACTIONS(1963),
    [anon_sym_const] = ACTIONS(1963),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_else] = ACTIONS(1963),
    [anon_sym_if] = ACTIONS(1963),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_for] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_RPAREN] = ACTIONS(1961),
    [anon_sym_await] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(1963),
    [anon_sym_do] = ACTIONS(1963),
    [anon_sym_try] = ACTIONS(1963),
    [anon_sym_with] = ACTIONS(1963),
    [anon_sym_break] = ACTIONS(1963),
    [anon_sym_continue] = ACTIONS(1963),
    [anon_sym_debugger] = ACTIONS(1963),
    [anon_sym_return] = ACTIONS(1963),
    [anon_sym_throw] = ACTIONS(1963),
    [anon_sym_SEMI] = ACTIONS(1961),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_case] = ACTIONS(1963),
    [anon_sym_yield] = ACTIONS(1963),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_RBRACK] = ACTIONS(1961),
    [anon_sym_LT] = ACTIONS(1961),
    [anon_sym_GT] = ACTIONS(1961),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_class] = ACTIONS(1963),
    [anon_sym_async] = ACTIONS(1963),
    [anon_sym_function] = ACTIONS(1963),
    [anon_sym_EQ_GT] = ACTIONS(1961),
    [anon_sym_new] = ACTIONS(1963),
    [anon_sym_QMARK] = ACTIONS(1961),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym_PIPE] = ACTIONS(1961),
    [anon_sym_PLUS] = ACTIONS(1963),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_void] = ACTIONS(1963),
    [anon_sym_delete] = ACTIONS(1963),
    [anon_sym_PLUS_PLUS] = ACTIONS(1961),
    [anon_sym_DASH_DASH] = ACTIONS(1961),
    [anon_sym_DQUOTE] = ACTIONS(1961),
    [anon_sym_SQUOTE] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1961),
    [sym_number] = ACTIONS(1961),
    [sym_this] = ACTIONS(1963),
    [sym_super] = ACTIONS(1963),
    [sym_true] = ACTIONS(1963),
    [sym_false] = ACTIONS(1963),
    [sym_null] = ACTIONS(1963),
    [sym_undefined] = ACTIONS(1963),
    [anon_sym_AT] = ACTIONS(1961),
    [anon_sym_declare] = ACTIONS(1963),
    [anon_sym_static] = ACTIONS(1963),
    [anon_sym_readonly] = ACTIONS(1963),
    [anon_sym_abstract] = ACTIONS(1963),
    [anon_sym_get] = ACTIONS(1963),
    [anon_sym_set] = ACTIONS(1963),
    [anon_sym_public] = ACTIONS(1963),
    [anon_sym_private] = ACTIONS(1963),
    [anon_sym_protected] = ACTIONS(1963),
    [anon_sym_module] = ACTIONS(1963),
    [anon_sym_any] = ACTIONS(1963),
    [anon_sym_number] = ACTIONS(1963),
    [anon_sym_boolean] = ACTIONS(1963),
    [anon_sym_string] = ACTIONS(1963),
    [anon_sym_symbol] = ACTIONS(1963),
    [anon_sym_interface] = ACTIONS(1963),
    [anon_sym_extends] = ACTIONS(1963),
    [anon_sym_enum] = ACTIONS(1963),
  },
  [920] = {
    [ts_builtin_sym_end] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1897),
    [anon_sym_export] = ACTIONS(1897),
    [anon_sym_default] = ACTIONS(1897),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_namespace] = ACTIONS(1897),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_COMMA] = ACTIONS(1895),
    [anon_sym_RBRACE] = ACTIONS(1895),
    [anon_sym_type] = ACTIONS(1897),
    [anon_sym_typeof] = ACTIONS(1897),
    [anon_sym_import] = ACTIONS(1897),
    [anon_sym_var] = ACTIONS(1897),
    [anon_sym_let] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_BANG] = ACTIONS(1895),
    [anon_sym_else] = ACTIONS(1897),
    [anon_sym_if] = ACTIONS(1897),
    [anon_sym_switch] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1897),
    [anon_sym_LPAREN] = ACTIONS(1895),
    [anon_sym_RPAREN] = ACTIONS(1895),
    [anon_sym_await] = ACTIONS(1897),
    [anon_sym_while] = ACTIONS(1897),
    [anon_sym_do] = ACTIONS(1897),
    [anon_sym_try] = ACTIONS(1897),
    [anon_sym_with] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_continue] = ACTIONS(1897),
    [anon_sym_debugger] = ACTIONS(1897),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1895),
    [anon_sym_COLON] = ACTIONS(1895),
    [anon_sym_case] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1895),
    [anon_sym_RBRACK] = ACTIONS(1895),
    [anon_sym_LT] = ACTIONS(1895),
    [anon_sym_GT] = ACTIONS(1895),
    [anon_sym_SLASH] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_async] = ACTIONS(1897),
    [anon_sym_function] = ACTIONS(1897),
    [anon_sym_EQ_GT] = ACTIONS(1895),
    [anon_sym_new] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1895),
    [anon_sym_PIPE] = ACTIONS(1895),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_void] = ACTIONS(1897),
    [anon_sym_delete] = ACTIONS(1897),
    [anon_sym_PLUS_PLUS] = ACTIONS(1895),
    [anon_sym_DASH_DASH] = ACTIONS(1895),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1895),
    [sym_number] = ACTIONS(1895),
    [sym_this] = ACTIONS(1897),
    [sym_super] = ACTIONS(1897),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [sym_null] = ACTIONS(1897),
    [sym_undefined] = ACTIONS(1897),
    [anon_sym_AT] = ACTIONS(1895),
    [anon_sym_declare] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_readonly] = ACTIONS(1897),
    [anon_sym_abstract] = ACTIONS(1897),
    [anon_sym_get] = ACTIONS(1897),
    [anon_sym_set] = ACTIONS(1897),
    [anon_sym_public] = ACTIONS(1897),
    [anon_sym_private] = ACTIONS(1897),
    [anon_sym_protected] = ACTIONS(1897),
    [anon_sym_module] = ACTIONS(1897),
    [anon_sym_any] = ACTIONS(1897),
    [anon_sym_number] = ACTIONS(1897),
    [anon_sym_boolean] = ACTIONS(1897),
    [anon_sym_string] = ACTIONS(1897),
    [anon_sym_symbol] = ACTIONS(1897),
    [anon_sym_interface] = ACTIONS(1897),
    [anon_sym_extends] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
  },
  [921] = {
    [ts_builtin_sym_end] = ACTIONS(2757),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_export] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2759),
    [anon_sym_EQ] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_COMMA] = ACTIONS(2757),
    [anon_sym_RBRACE] = ACTIONS(2757),
    [anon_sym_type] = ACTIONS(2759),
    [anon_sym_typeof] = ACTIONS(2759),
    [anon_sym_import] = ACTIONS(2759),
    [anon_sym_var] = ACTIONS(2759),
    [anon_sym_let] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_switch] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_LPAREN] = ACTIONS(2757),
    [anon_sym_RPAREN] = ACTIONS(2757),
    [anon_sym_await] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [anon_sym_with] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_debugger] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_throw] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym_COLON] = ACTIONS(2757),
    [anon_sym_case] = ACTIONS(2759),
    [anon_sym_yield] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2757),
    [anon_sym_RBRACK] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(2757),
    [anon_sym_GT] = ACTIONS(2757),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_async] = ACTIONS(2759),
    [anon_sym_function] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2757),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2757),
    [anon_sym_PIPE] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_void] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2757),
    [sym_number] = ACTIONS(2757),
    [sym_this] = ACTIONS(2759),
    [sym_super] = ACTIONS(2759),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [sym_null] = ACTIONS(2759),
    [sym_undefined] = ACTIONS(2759),
    [anon_sym_AT] = ACTIONS(2757),
    [anon_sym_declare] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_readonly] = ACTIONS(2759),
    [anon_sym_abstract] = ACTIONS(2759),
    [anon_sym_get] = ACTIONS(2759),
    [anon_sym_set] = ACTIONS(2759),
    [anon_sym_public] = ACTIONS(2759),
    [anon_sym_private] = ACTIONS(2759),
    [anon_sym_protected] = ACTIONS(2759),
    [anon_sym_module] = ACTIONS(2759),
    [anon_sym_any] = ACTIONS(2759),
    [anon_sym_number] = ACTIONS(2759),
    [anon_sym_boolean] = ACTIONS(2759),
    [anon_sym_string] = ACTIONS(2759),
    [anon_sym_symbol] = ACTIONS(2759),
    [anon_sym_interface] = ACTIONS(2759),
    [anon_sym_extends] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
  },
  [922] = {
    [ts_builtin_sym_end] = ACTIONS(2761),
    [sym_identifier] = ACTIONS(2763),
    [anon_sym_export] = ACTIONS(2763),
    [anon_sym_default] = ACTIONS(2763),
    [anon_sym_EQ] = ACTIONS(2763),
    [anon_sym_namespace] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2761),
    [anon_sym_RBRACE] = ACTIONS(2761),
    [anon_sym_type] = ACTIONS(2763),
    [anon_sym_typeof] = ACTIONS(2763),
    [anon_sym_import] = ACTIONS(2763),
    [anon_sym_var] = ACTIONS(2763),
    [anon_sym_let] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_else] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_switch] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_LPAREN] = ACTIONS(2761),
    [anon_sym_RPAREN] = ACTIONS(2761),
    [anon_sym_await] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_do] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [anon_sym_with] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_debugger] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_throw] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym_COLON] = ACTIONS(2761),
    [anon_sym_case] = ACTIONS(2763),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2761),
    [anon_sym_RBRACK] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_async] = ACTIONS(2763),
    [anon_sym_function] = ACTIONS(2763),
    [anon_sym_EQ_GT] = ACTIONS(2761),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_QMARK] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_void] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2761),
    [sym_number] = ACTIONS(2761),
    [sym_this] = ACTIONS(2763),
    [sym_super] = ACTIONS(2763),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [sym_null] = ACTIONS(2763),
    [sym_undefined] = ACTIONS(2763),
    [anon_sym_AT] = ACTIONS(2761),
    [anon_sym_declare] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_readonly] = ACTIONS(2763),
    [anon_sym_abstract] = ACTIONS(2763),
    [anon_sym_get] = ACTIONS(2763),
    [anon_sym_set] = ACTIONS(2763),
    [anon_sym_public] = ACTIONS(2763),
    [anon_sym_private] = ACTIONS(2763),
    [anon_sym_protected] = ACTIONS(2763),
    [anon_sym_module] = ACTIONS(2763),
    [anon_sym_any] = ACTIONS(2763),
    [anon_sym_number] = ACTIONS(2763),
    [anon_sym_boolean] = ACTIONS(2763),
    [anon_sym_string] = ACTIONS(2763),
    [anon_sym_symbol] = ACTIONS(2763),
    [anon_sym_interface] = ACTIONS(2763),
    [anon_sym_extends] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
  },
  [923] = {
    [ts_builtin_sym_end] = ACTIONS(2765),
    [sym_identifier] = ACTIONS(2767),
    [anon_sym_export] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_EQ] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_COMMA] = ACTIONS(2765),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_type] = ACTIONS(2767),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_import] = ACTIONS(2767),
    [anon_sym_var] = ACTIONS(2767),
    [anon_sym_let] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_LPAREN] = ACTIONS(2765),
    [anon_sym_RPAREN] = ACTIONS(2765),
    [anon_sym_await] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_with] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_debugger] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym_COLON] = ACTIONS(2765),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_yield] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2765),
    [anon_sym_RBRACK] = ACTIONS(2765),
    [anon_sym_LT] = ACTIONS(2765),
    [anon_sym_GT] = ACTIONS(2765),
    [anon_sym_SLASH] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_async] = ACTIONS(2767),
    [anon_sym_function] = ACTIONS(2767),
    [anon_sym_EQ_GT] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_QMARK] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2765),
    [anon_sym_PIPE] = ACTIONS(2765),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_void] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2765),
    [sym_number] = ACTIONS(2765),
    [sym_this] = ACTIONS(2767),
    [sym_super] = ACTIONS(2767),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [sym_null] = ACTIONS(2767),
    [sym_undefined] = ACTIONS(2767),
    [anon_sym_AT] = ACTIONS(2765),
    [anon_sym_declare] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_readonly] = ACTIONS(2767),
    [anon_sym_abstract] = ACTIONS(2767),
    [anon_sym_get] = ACTIONS(2767),
    [anon_sym_set] = ACTIONS(2767),
    [anon_sym_public] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(2767),
    [anon_sym_protected] = ACTIONS(2767),
    [anon_sym_module] = ACTIONS(2767),
    [anon_sym_any] = ACTIONS(2767),
    [anon_sym_number] = ACTIONS(2767),
    [anon_sym_boolean] = ACTIONS(2767),
    [anon_sym_string] = ACTIONS(2767),
    [anon_sym_symbol] = ACTIONS(2767),
    [anon_sym_interface] = ACTIONS(2767),
    [anon_sym_extends] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
  },
  [924] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2773),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [925] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [926] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4747),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [927] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4747),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2769),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2769),
    [anon_sym_set] = ACTIONS(2769),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [928] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2769),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2769),
    [anon_sym_set] = ACTIONS(2769),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [929] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [930] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2769),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2769),
    [anon_sym_set] = ACTIONS(2769),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [931] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2773),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [932] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4747),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2773),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [933] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [934] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2769),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2769),
    [anon_sym_set] = ACTIONS(2769),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [935] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2769),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2769),
    [anon_sym_set] = ACTIONS(2769),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [936] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2769),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2769),
    [anon_sym_set] = ACTIONS(2769),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [937] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4799),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2773),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [938] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [939] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [940] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2773),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [941] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2773),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [942] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2773),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [943] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4799),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [944] = {
    [sym_string] = STATE(4097),
    [sym__property_name] = STATE(4097),
    [sym_computed_property_name] = STATE(4097),
    [aux_sym_object_repeat1] = STATE(4799),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2769),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2769),
    [anon_sym_set] = ACTIONS(2769),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [945] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__formal_parameter] = STATE(4828),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(5480),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4649),
    [sym_constructor_type] = STATE(4649),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4649),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5002),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4649),
    [sym_union_type] = STATE(4649),
    [sym_intersection_type] = STATE(4649),
    [sym_function_type] = STATE(4649),
    [aux_sym_export_statement_repeat1] = STATE(3555),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2783),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(2785),
    [anon_sym_private] = ACTIONS(2785),
    [anon_sym_protected] = ACTIONS(2785),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1625),
    [anon_sym_number] = ACTIONS(1625),
    [anon_sym_boolean] = ACTIONS(1625),
    [anon_sym_string] = ACTIONS(1625),
    [anon_sym_symbol] = ACTIONS(1625),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [946] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__formal_parameter] = STATE(4828),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(5480),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4537),
    [sym_constructor_type] = STATE(4537),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4537),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5002),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4537),
    [sym_union_type] = STATE(4537),
    [sym_intersection_type] = STATE(4537),
    [sym_function_type] = STATE(4537),
    [aux_sym_export_statement_repeat1] = STATE(3555),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2783),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(2785),
    [anon_sym_private] = ACTIONS(2785),
    [anon_sym_protected] = ACTIONS(2785),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1625),
    [anon_sym_number] = ACTIONS(1625),
    [anon_sym_boolean] = ACTIONS(1625),
    [anon_sym_string] = ACTIONS(1625),
    [anon_sym_symbol] = ACTIONS(1625),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [947] = {
    [sym_object_pattern] = STATE(3978),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_COMMA] = ACTIONS(2195),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_RBRACK] = ACTIONS(2793),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2795),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2797),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(2799),
    [anon_sym_number] = ACTIONS(2799),
    [anon_sym_boolean] = ACTIONS(2799),
    [anon_sym_string] = ACTIONS(2799),
    [anon_sym_symbol] = ACTIONS(2799),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [948] = {
    [sym_object_pattern] = STATE(3978),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_COMMA] = ACTIONS(2195),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_RBRACK] = ACTIONS(2801),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2795),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2797),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(2799),
    [anon_sym_number] = ACTIONS(2799),
    [anon_sym_boolean] = ACTIONS(2799),
    [anon_sym_string] = ACTIONS(2799),
    [anon_sym_symbol] = ACTIONS(2799),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [949] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__formal_parameter] = STATE(4828),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(5480),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4622),
    [sym_constructor_type] = STATE(4622),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4622),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5002),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4622),
    [sym_union_type] = STATE(4622),
    [sym_intersection_type] = STATE(4622),
    [sym_function_type] = STATE(4622),
    [aux_sym_export_statement_repeat1] = STATE(3555),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2783),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(2785),
    [anon_sym_private] = ACTIONS(2785),
    [anon_sym_protected] = ACTIONS(2785),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1625),
    [anon_sym_number] = ACTIONS(1625),
    [anon_sym_boolean] = ACTIONS(1625),
    [anon_sym_string] = ACTIONS(1625),
    [anon_sym_symbol] = ACTIONS(1625),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [950] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__formal_parameter] = STATE(4828),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(5480),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4672),
    [sym_constructor_type] = STATE(4672),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4672),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5002),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4672),
    [sym_union_type] = STATE(4672),
    [sym_intersection_type] = STATE(4672),
    [sym_function_type] = STATE(4672),
    [aux_sym_export_statement_repeat1] = STATE(3555),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2783),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(2785),
    [anon_sym_private] = ACTIONS(2785),
    [anon_sym_protected] = ACTIONS(2785),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1625),
    [anon_sym_number] = ACTIONS(1625),
    [anon_sym_boolean] = ACTIONS(1625),
    [anon_sym_string] = ACTIONS(1625),
    [anon_sym_symbol] = ACTIONS(1625),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [951] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__formal_parameter] = STATE(4828),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(5480),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4582),
    [sym_constructor_type] = STATE(4582),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4582),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5002),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4582),
    [sym_union_type] = STATE(4582),
    [sym_intersection_type] = STATE(4582),
    [sym_function_type] = STATE(4582),
    [aux_sym_export_statement_repeat1] = STATE(3555),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2783),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(2785),
    [anon_sym_private] = ACTIONS(2785),
    [anon_sym_protected] = ACTIONS(2785),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1625),
    [anon_sym_number] = ACTIONS(1625),
    [anon_sym_boolean] = ACTIONS(1625),
    [anon_sym_string] = ACTIONS(1625),
    [anon_sym_symbol] = ACTIONS(1625),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [952] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__formal_parameter] = STATE(4828),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(5480),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4653),
    [sym_constructor_type] = STATE(4653),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4653),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5002),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4653),
    [sym_union_type] = STATE(4653),
    [sym_intersection_type] = STATE(4653),
    [sym_function_type] = STATE(4653),
    [aux_sym_export_statement_repeat1] = STATE(3555),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2783),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(2785),
    [anon_sym_private] = ACTIONS(2785),
    [anon_sym_protected] = ACTIONS(2785),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1625),
    [anon_sym_number] = ACTIONS(1625),
    [anon_sym_boolean] = ACTIONS(1625),
    [anon_sym_string] = ACTIONS(1625),
    [anon_sym_symbol] = ACTIONS(1625),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [953] = {
    [sym_object_pattern] = STATE(3978),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_COMMA] = ACTIONS(2195),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_RBRACK] = ACTIONS(2803),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2795),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2797),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(2799),
    [anon_sym_number] = ACTIONS(2799),
    [anon_sym_boolean] = ACTIONS(2799),
    [anon_sym_string] = ACTIONS(2799),
    [anon_sym_symbol] = ACTIONS(2799),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [954] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__formal_parameter] = STATE(4828),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_decorator] = STATE(3633),
    [sym_formal_parameters] = STATE(5480),
    [sym_pattern] = STATE(3990),
    [sym_rest_pattern] = STATE(3978),
    [sym_nested_type_identifier] = STATE(3658),
    [sym_accessibility_modifier] = STATE(3606),
    [sym_required_parameter] = STATE(4828),
    [sym_optional_parameter] = STATE(4828),
    [sym__parameter_name] = STATE(3990),
    [sym__type] = STATE(4529),
    [sym_constructor_type] = STATE(4529),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4529),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5002),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4529),
    [sym_union_type] = STATE(4529),
    [sym_intersection_type] = STATE(4529),
    [sym_function_type] = STATE(4529),
    [aux_sym_export_statement_repeat1] = STATE(3555),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(2781),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2783),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(2785),
    [anon_sym_private] = ACTIONS(2785),
    [anon_sym_protected] = ACTIONS(2785),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1625),
    [anon_sym_number] = ACTIONS(1625),
    [anon_sym_boolean] = ACTIONS(1625),
    [anon_sym_string] = ACTIONS(1625),
    [anon_sym_symbol] = ACTIONS(1625),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [955] = {
    [sym_object_pattern] = STATE(3978),
    [sym_assignment_pattern] = STATE(4761),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_pattern] = STATE(4707),
    [sym_rest_pattern] = STATE(4512),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4776),
    [sym_optional_tuple_parameter] = STATE(4776),
    [sym_optional_type] = STATE(4776),
    [sym_rest_type] = STATE(4776),
    [sym__tuple_type_member] = STATE(4776),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [aux_sym_array_pattern_repeat1] = STATE(4734),
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_COMMA] = ACTIONS(2195),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_RBRACK] = ACTIONS(2805),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2795),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(2797),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(2799),
    [anon_sym_number] = ACTIONS(2799),
    [anon_sym_boolean] = ACTIONS(2799),
    [anon_sym_string] = ACTIONS(2799),
    [anon_sym_symbol] = ACTIONS(2799),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [956] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_pattern] = STATE(4305),
    [sym_rest_pattern] = STATE(3978),
    [sym_identifier] = ACTIONS(2807),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(1584),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_RPAREN] = ACTIONS(1584),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(2814),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_this] = ACTIONS(2817),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(1573),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1573),
    [anon_sym_number] = ACTIONS(1573),
    [anon_sym_boolean] = ACTIONS(1573),
    [anon_sym_string] = ACTIONS(1573),
    [anon_sym_symbol] = ACTIONS(1573),
  },
  [957] = {
    [sym__call_signature] = STATE(5265),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_export] = ACTIONS(2821),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1789),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2821),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_readonly] = ACTIONS(2821),
    [anon_sym_get] = ACTIONS(2821),
    [anon_sym_set] = ACTIONS(2821),
    [anon_sym_public] = ACTIONS(2821),
    [anon_sym_private] = ACTIONS(2821),
    [anon_sym_protected] = ACTIONS(2821),
    [anon_sym_module] = ACTIONS(2821),
    [anon_sym_any] = ACTIONS(2821),
    [anon_sym_number] = ACTIONS(2821),
    [anon_sym_boolean] = ACTIONS(2821),
    [anon_sym_string] = ACTIONS(2821),
    [anon_sym_symbol] = ACTIONS(2821),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [958] = {
    [sym__call_signature] = STATE(5474),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1813),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_readonly] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [959] = {
    [sym__call_signature] = STATE(5474),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1811),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1813),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_readonly] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [960] = {
    [sym__call_signature] = STATE(5265),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_export] = ACTIONS(2821),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2821),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_readonly] = ACTIONS(2821),
    [anon_sym_get] = ACTIONS(2821),
    [anon_sym_set] = ACTIONS(2821),
    [anon_sym_public] = ACTIONS(2821),
    [anon_sym_private] = ACTIONS(2821),
    [anon_sym_protected] = ACTIONS(2821),
    [anon_sym_module] = ACTIONS(2821),
    [anon_sym_any] = ACTIONS(2821),
    [anon_sym_number] = ACTIONS(2821),
    [anon_sym_boolean] = ACTIONS(2821),
    [anon_sym_string] = ACTIONS(2821),
    [anon_sym_symbol] = ACTIONS(2821),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [961] = {
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2839),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_readonly] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [962] = {
    [aux_sym_object_repeat1] = STATE(4799),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2839),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_readonly] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [963] = {
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2839),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_readonly] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [964] = {
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2839),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_readonly] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [965] = {
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2839),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_readonly] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [966] = {
    [sym__call_signature] = STATE(5389),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_export] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1829),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2843),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2843),
    [anon_sym_function] = ACTIONS(2845),
    [anon_sym_EQ_GT] = ACTIONS(1817),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_readonly] = ACTIONS(2843),
    [anon_sym_get] = ACTIONS(2843),
    [anon_sym_set] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_module] = ACTIONS(2843),
    [anon_sym_any] = ACTIONS(2843),
    [anon_sym_number] = ACTIONS(2843),
    [anon_sym_boolean] = ACTIONS(2843),
    [anon_sym_string] = ACTIONS(2843),
    [anon_sym_symbol] = ACTIONS(2843),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1597),
  },
  [967] = {
    [aux_sym_object_repeat1] = STATE(4747),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2839),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_readonly] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [968] = {
    [sym__call_signature] = STATE(5474),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1813),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_readonly] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [969] = {
    [sym__call_signature] = STATE(5389),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_export] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2843),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2843),
    [anon_sym_function] = ACTIONS(2845),
    [anon_sym_EQ_GT] = ACTIONS(1817),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_readonly] = ACTIONS(2843),
    [anon_sym_get] = ACTIONS(2843),
    [anon_sym_set] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_module] = ACTIONS(2843),
    [anon_sym_any] = ACTIONS(2843),
    [anon_sym_number] = ACTIONS(2843),
    [anon_sym_boolean] = ACTIONS(2843),
    [anon_sym_string] = ACTIONS(2843),
    [anon_sym_symbol] = ACTIONS(2843),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1597),
  },
  [970] = {
    [sym__call_signature] = STATE(5389),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_export] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1815),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2843),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2843),
    [anon_sym_function] = ACTIONS(2845),
    [anon_sym_EQ_GT] = ACTIONS(1817),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_readonly] = ACTIONS(2843),
    [anon_sym_get] = ACTIONS(2843),
    [anon_sym_set] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_module] = ACTIONS(2843),
    [anon_sym_any] = ACTIONS(2843),
    [anon_sym_number] = ACTIONS(2843),
    [anon_sym_boolean] = ACTIONS(2843),
    [anon_sym_string] = ACTIONS(2843),
    [anon_sym_symbol] = ACTIONS(2843),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1597),
  },
  [971] = {
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(2839),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_readonly] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [972] = {
    [sym__call_signature] = STATE(5265),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_export] = ACTIONS(2821),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2821),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2821),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_readonly] = ACTIONS(2821),
    [anon_sym_get] = ACTIONS(2821),
    [anon_sym_set] = ACTIONS(2821),
    [anon_sym_public] = ACTIONS(2821),
    [anon_sym_private] = ACTIONS(2821),
    [anon_sym_protected] = ACTIONS(2821),
    [anon_sym_module] = ACTIONS(2821),
    [anon_sym_any] = ACTIONS(2821),
    [anon_sym_number] = ACTIONS(2821),
    [anon_sym_boolean] = ACTIONS(2821),
    [anon_sym_string] = ACTIONS(2821),
    [anon_sym_symbol] = ACTIONS(2821),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [973] = {
    [sym__call_signature] = STATE(5265),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_export] = ACTIONS(2821),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1821),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2821),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2821),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_readonly] = ACTIONS(2821),
    [anon_sym_get] = ACTIONS(2821),
    [anon_sym_set] = ACTIONS(2821),
    [anon_sym_public] = ACTIONS(2821),
    [anon_sym_private] = ACTIONS(2821),
    [anon_sym_protected] = ACTIONS(2821),
    [anon_sym_module] = ACTIONS(2821),
    [anon_sym_any] = ACTIONS(2821),
    [anon_sym_number] = ACTIONS(2821),
    [anon_sym_boolean] = ACTIONS(2821),
    [anon_sym_string] = ACTIONS(2821),
    [anon_sym_symbol] = ACTIONS(2821),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [974] = {
    [sym__call_signature] = STATE(5474),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1833),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1813),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_readonly] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [975] = {
    [sym__call_signature] = STATE(5229),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_export] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2849),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2849),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_readonly] = ACTIONS(2849),
    [anon_sym_get] = ACTIONS(2849),
    [anon_sym_set] = ACTIONS(2849),
    [anon_sym_public] = ACTIONS(2849),
    [anon_sym_private] = ACTIONS(2849),
    [anon_sym_protected] = ACTIONS(2849),
    [anon_sym_module] = ACTIONS(2849),
    [anon_sym_any] = ACTIONS(2849),
    [anon_sym_number] = ACTIONS(2849),
    [anon_sym_boolean] = ACTIONS(2849),
    [anon_sym_string] = ACTIONS(2849),
    [anon_sym_symbol] = ACTIONS(2849),
  },
  [976] = {
    [sym__call_signature] = STATE(5520),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_export] = ACTIONS(2853),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2845),
    [anon_sym_EQ_GT] = ACTIONS(1831),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2853),
    [anon_sym_static] = ACTIONS(2853),
    [anon_sym_readonly] = ACTIONS(2853),
    [anon_sym_get] = ACTIONS(2853),
    [anon_sym_set] = ACTIONS(2853),
    [anon_sym_public] = ACTIONS(2853),
    [anon_sym_private] = ACTIONS(2853),
    [anon_sym_protected] = ACTIONS(2853),
    [anon_sym_module] = ACTIONS(2853),
    [anon_sym_any] = ACTIONS(2853),
    [anon_sym_number] = ACTIONS(2853),
    [anon_sym_boolean] = ACTIONS(2853),
    [anon_sym_string] = ACTIONS(2853),
    [anon_sym_symbol] = ACTIONS(2853),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1597),
  },
  [977] = {
    [sym__call_signature] = STATE(5520),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_export] = ACTIONS(2853),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1829),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2845),
    [anon_sym_EQ_GT] = ACTIONS(1831),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2853),
    [anon_sym_static] = ACTIONS(2853),
    [anon_sym_readonly] = ACTIONS(2853),
    [anon_sym_get] = ACTIONS(2853),
    [anon_sym_set] = ACTIONS(2853),
    [anon_sym_public] = ACTIONS(2853),
    [anon_sym_private] = ACTIONS(2853),
    [anon_sym_protected] = ACTIONS(2853),
    [anon_sym_module] = ACTIONS(2853),
    [anon_sym_any] = ACTIONS(2853),
    [anon_sym_number] = ACTIONS(2853),
    [anon_sym_boolean] = ACTIONS(2853),
    [anon_sym_string] = ACTIONS(2853),
    [anon_sym_symbol] = ACTIONS(2853),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1597),
  },
  [978] = {
    [sym__call_signature] = STATE(5229),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_export] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2849),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2849),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_readonly] = ACTIONS(2849),
    [anon_sym_get] = ACTIONS(2849),
    [anon_sym_set] = ACTIONS(2849),
    [anon_sym_public] = ACTIONS(2849),
    [anon_sym_private] = ACTIONS(2849),
    [anon_sym_protected] = ACTIONS(2849),
    [anon_sym_module] = ACTIONS(2849),
    [anon_sym_any] = ACTIONS(2849),
    [anon_sym_number] = ACTIONS(2849),
    [anon_sym_boolean] = ACTIONS(2849),
    [anon_sym_string] = ACTIONS(2849),
    [anon_sym_symbol] = ACTIONS(2849),
  },
  [979] = {
    [sym__call_signature] = STATE(5236),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_export] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2078),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1865),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2857),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_readonly] = ACTIONS(2857),
    [anon_sym_get] = ACTIONS(2857),
    [anon_sym_set] = ACTIONS(2857),
    [anon_sym_public] = ACTIONS(2857),
    [anon_sym_private] = ACTIONS(2857),
    [anon_sym_protected] = ACTIONS(2857),
    [anon_sym_module] = ACTIONS(2857),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_implements] = ACTIONS(1580),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [980] = {
    [sym__call_signature] = STATE(5272),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_export] = ACTIONS(2861),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1821),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2861),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2861),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2861),
    [anon_sym_get] = ACTIONS(2861),
    [anon_sym_set] = ACTIONS(2861),
    [anon_sym_public] = ACTIONS(2861),
    [anon_sym_private] = ACTIONS(2861),
    [anon_sym_protected] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(2861),
    [anon_sym_any] = ACTIONS(2861),
    [anon_sym_number] = ACTIONS(2861),
    [anon_sym_boolean] = ACTIONS(2861),
    [anon_sym_string] = ACTIONS(2861),
    [anon_sym_symbol] = ACTIONS(2861),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [981] = {
    [sym__call_signature] = STATE(5435),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_export] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1937),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_EQ_GT] = ACTIONS(1939),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2865),
    [anon_sym_static] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2865),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_public] = ACTIONS(2865),
    [anon_sym_private] = ACTIONS(2865),
    [anon_sym_protected] = ACTIONS(2865),
    [anon_sym_module] = ACTIONS(2865),
    [anon_sym_any] = ACTIONS(2865),
    [anon_sym_number] = ACTIONS(2865),
    [anon_sym_boolean] = ACTIONS(2865),
    [anon_sym_string] = ACTIONS(2865),
    [anon_sym_symbol] = ACTIONS(2865),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1597),
  },
  [982] = {
    [sym__call_signature] = STATE(5435),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_export] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_EQ_GT] = ACTIONS(1939),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2865),
    [anon_sym_static] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2865),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_public] = ACTIONS(2865),
    [anon_sym_private] = ACTIONS(2865),
    [anon_sym_protected] = ACTIONS(2865),
    [anon_sym_module] = ACTIONS(2865),
    [anon_sym_any] = ACTIONS(2865),
    [anon_sym_number] = ACTIONS(2865),
    [anon_sym_boolean] = ACTIONS(2865),
    [anon_sym_string] = ACTIONS(2865),
    [anon_sym_symbol] = ACTIONS(2865),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1597),
  },
  [983] = {
    [sym__call_signature] = STATE(5456),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1825),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2871),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2871),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1827),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2871),
    [anon_sym_static] = ACTIONS(2871),
    [anon_sym_readonly] = ACTIONS(2871),
    [anon_sym_get] = ACTIONS(2871),
    [anon_sym_set] = ACTIONS(2871),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_any] = ACTIONS(2871),
    [anon_sym_number] = ACTIONS(2871),
    [anon_sym_boolean] = ACTIONS(2871),
    [anon_sym_string] = ACTIONS(2871),
    [anon_sym_symbol] = ACTIONS(2871),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [984] = {
    [sym__call_signature] = STATE(5272),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_export] = ACTIONS(2861),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1821),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2861),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2861),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2861),
    [anon_sym_get] = ACTIONS(2861),
    [anon_sym_set] = ACTIONS(2861),
    [anon_sym_public] = ACTIONS(2861),
    [anon_sym_private] = ACTIONS(2861),
    [anon_sym_protected] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(2861),
    [anon_sym_any] = ACTIONS(2861),
    [anon_sym_number] = ACTIONS(2861),
    [anon_sym_boolean] = ACTIONS(2861),
    [anon_sym_string] = ACTIONS(2861),
    [anon_sym_symbol] = ACTIONS(2861),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [985] = {
    [sym__call_signature] = STATE(5390),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1833),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1835),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2875),
    [anon_sym_static] = ACTIONS(2875),
    [anon_sym_readonly] = ACTIONS(2875),
    [anon_sym_get] = ACTIONS(2875),
    [anon_sym_set] = ACTIONS(2875),
    [anon_sym_public] = ACTIONS(2875),
    [anon_sym_private] = ACTIONS(2875),
    [anon_sym_protected] = ACTIONS(2875),
    [anon_sym_module] = ACTIONS(2875),
    [anon_sym_any] = ACTIONS(2875),
    [anon_sym_number] = ACTIONS(2875),
    [anon_sym_boolean] = ACTIONS(2875),
    [anon_sym_string] = ACTIONS(2875),
    [anon_sym_symbol] = ACTIONS(2875),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [986] = {
    [sym__call_signature] = STATE(5456),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2871),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2871),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1827),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2871),
    [anon_sym_static] = ACTIONS(2871),
    [anon_sym_readonly] = ACTIONS(2871),
    [anon_sym_get] = ACTIONS(2871),
    [anon_sym_set] = ACTIONS(2871),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_any] = ACTIONS(2871),
    [anon_sym_number] = ACTIONS(2871),
    [anon_sym_boolean] = ACTIONS(2871),
    [anon_sym_string] = ACTIONS(2871),
    [anon_sym_symbol] = ACTIONS(2871),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [987] = {
    [sym__call_signature] = STATE(5272),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_export] = ACTIONS(2861),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2861),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2861),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2861),
    [anon_sym_get] = ACTIONS(2861),
    [anon_sym_set] = ACTIONS(2861),
    [anon_sym_public] = ACTIONS(2861),
    [anon_sym_private] = ACTIONS(2861),
    [anon_sym_protected] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(2861),
    [anon_sym_any] = ACTIONS(2861),
    [anon_sym_number] = ACTIONS(2861),
    [anon_sym_boolean] = ACTIONS(2861),
    [anon_sym_string] = ACTIONS(2861),
    [anon_sym_symbol] = ACTIONS(2861),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [988] = {
    [sym__call_signature] = STATE(5265),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_export] = ACTIONS(2821),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1903),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2821),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2821),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_readonly] = ACTIONS(2821),
    [anon_sym_get] = ACTIONS(2821),
    [anon_sym_set] = ACTIONS(2821),
    [anon_sym_public] = ACTIONS(2821),
    [anon_sym_private] = ACTIONS(2821),
    [anon_sym_protected] = ACTIONS(2821),
    [anon_sym_module] = ACTIONS(2821),
    [anon_sym_any] = ACTIONS(2821),
    [anon_sym_number] = ACTIONS(2821),
    [anon_sym_boolean] = ACTIONS(2821),
    [anon_sym_string] = ACTIONS(2821),
    [anon_sym_symbol] = ACTIONS(2821),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [989] = {
    [sym__call_signature] = STATE(5236),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_export] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1865),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2857),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_readonly] = ACTIONS(2857),
    [anon_sym_get] = ACTIONS(2857),
    [anon_sym_set] = ACTIONS(2857),
    [anon_sym_public] = ACTIONS(2857),
    [anon_sym_private] = ACTIONS(2857),
    [anon_sym_protected] = ACTIONS(2857),
    [anon_sym_module] = ACTIONS(2857),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_implements] = ACTIONS(1580),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [990] = {
    [sym__call_signature] = STATE(5265),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_export] = ACTIONS(2821),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1853),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2821),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2821),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_readonly] = ACTIONS(2821),
    [anon_sym_get] = ACTIONS(2821),
    [anon_sym_set] = ACTIONS(2821),
    [anon_sym_public] = ACTIONS(2821),
    [anon_sym_private] = ACTIONS(2821),
    [anon_sym_protected] = ACTIONS(2821),
    [anon_sym_module] = ACTIONS(2821),
    [anon_sym_any] = ACTIONS(2821),
    [anon_sym_number] = ACTIONS(2821),
    [anon_sym_boolean] = ACTIONS(2821),
    [anon_sym_string] = ACTIONS(2821),
    [anon_sym_symbol] = ACTIONS(2821),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [991] = {
    [sym__call_signature] = STATE(5390),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1835),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2875),
    [anon_sym_static] = ACTIONS(2875),
    [anon_sym_readonly] = ACTIONS(2875),
    [anon_sym_get] = ACTIONS(2875),
    [anon_sym_set] = ACTIONS(2875),
    [anon_sym_public] = ACTIONS(2875),
    [anon_sym_private] = ACTIONS(2875),
    [anon_sym_protected] = ACTIONS(2875),
    [anon_sym_module] = ACTIONS(2875),
    [anon_sym_any] = ACTIONS(2875),
    [anon_sym_number] = ACTIONS(2875),
    [anon_sym_boolean] = ACTIONS(2875),
    [anon_sym_string] = ACTIONS(2875),
    [anon_sym_symbol] = ACTIONS(2875),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [992] = {
    [sym__call_signature] = STATE(5272),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_export] = ACTIONS(2861),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1821),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2861),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2861),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2861),
    [anon_sym_get] = ACTIONS(2861),
    [anon_sym_set] = ACTIONS(2861),
    [anon_sym_public] = ACTIONS(2861),
    [anon_sym_private] = ACTIONS(2861),
    [anon_sym_protected] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(2861),
    [anon_sym_any] = ACTIONS(2861),
    [anon_sym_number] = ACTIONS(2861),
    [anon_sym_boolean] = ACTIONS(2861),
    [anon_sym_string] = ACTIONS(2861),
    [anon_sym_symbol] = ACTIONS(2861),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [993] = {
    [sym__call_signature] = STATE(5236),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_export] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1863),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1865),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2857),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_readonly] = ACTIONS(2857),
    [anon_sym_get] = ACTIONS(2857),
    [anon_sym_set] = ACTIONS(2857),
    [anon_sym_public] = ACTIONS(2857),
    [anon_sym_private] = ACTIONS(2857),
    [anon_sym_protected] = ACTIONS(2857),
    [anon_sym_module] = ACTIONS(2857),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_implements] = ACTIONS(1580),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [994] = {
    [sym__call_signature] = STATE(5272),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_export] = ACTIONS(2861),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1821),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2861),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(2879),
    [anon_sym_of] = ACTIONS(2882),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2861),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2861),
    [anon_sym_get] = ACTIONS(2861),
    [anon_sym_set] = ACTIONS(2861),
    [anon_sym_public] = ACTIONS(2861),
    [anon_sym_private] = ACTIONS(2861),
    [anon_sym_protected] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(2861),
    [anon_sym_any] = ACTIONS(2861),
    [anon_sym_number] = ACTIONS(2861),
    [anon_sym_boolean] = ACTIONS(2861),
    [anon_sym_string] = ACTIONS(2861),
    [anon_sym_symbol] = ACTIONS(2861),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [995] = {
    [sym__call_signature] = STATE(5435),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_export] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2141),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_EQ_GT] = ACTIONS(1939),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2865),
    [anon_sym_static] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2865),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_public] = ACTIONS(2865),
    [anon_sym_private] = ACTIONS(2865),
    [anon_sym_protected] = ACTIONS(2865),
    [anon_sym_module] = ACTIONS(2865),
    [anon_sym_any] = ACTIONS(2865),
    [anon_sym_number] = ACTIONS(2865),
    [anon_sym_boolean] = ACTIONS(2865),
    [anon_sym_string] = ACTIONS(2865),
    [anon_sym_symbol] = ACTIONS(2865),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1597),
  },
  [996] = {
    [sym__call_signature] = STATE(5304),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2884),
    [anon_sym_export] = ACTIONS(2886),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2886),
    [anon_sym_type] = ACTIONS(2886),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2886),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1855),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2886),
    [anon_sym_static] = ACTIONS(2886),
    [anon_sym_readonly] = ACTIONS(2886),
    [anon_sym_get] = ACTIONS(2886),
    [anon_sym_set] = ACTIONS(2886),
    [anon_sym_public] = ACTIONS(2886),
    [anon_sym_private] = ACTIONS(2886),
    [anon_sym_protected] = ACTIONS(2886),
    [anon_sym_module] = ACTIONS(2886),
    [anon_sym_any] = ACTIONS(2886),
    [anon_sym_number] = ACTIONS(2886),
    [anon_sym_boolean] = ACTIONS(2886),
    [anon_sym_string] = ACTIONS(2886),
    [anon_sym_symbol] = ACTIONS(2886),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [997] = {
    [sym__call_signature] = STATE(5274),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2888),
    [anon_sym_export] = ACTIONS(2890),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2890),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2890),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2890),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2080),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2890),
    [anon_sym_static] = ACTIONS(2890),
    [anon_sym_readonly] = ACTIONS(2890),
    [anon_sym_get] = ACTIONS(2890),
    [anon_sym_set] = ACTIONS(2890),
    [anon_sym_public] = ACTIONS(2890),
    [anon_sym_private] = ACTIONS(2890),
    [anon_sym_protected] = ACTIONS(2890),
    [anon_sym_module] = ACTIONS(2890),
    [anon_sym_any] = ACTIONS(2890),
    [anon_sym_number] = ACTIONS(2890),
    [anon_sym_boolean] = ACTIONS(2890),
    [anon_sym_string] = ACTIONS(2890),
    [anon_sym_symbol] = ACTIONS(2890),
    [anon_sym_implements] = ACTIONS(1580),
  },
  [998] = {
    [sym__call_signature] = STATE(5304),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2884),
    [anon_sym_export] = ACTIONS(2886),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1853),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2886),
    [anon_sym_type] = ACTIONS(2886),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2886),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1855),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2886),
    [anon_sym_static] = ACTIONS(2886),
    [anon_sym_readonly] = ACTIONS(2886),
    [anon_sym_get] = ACTIONS(2886),
    [anon_sym_set] = ACTIONS(2886),
    [anon_sym_public] = ACTIONS(2886),
    [anon_sym_private] = ACTIONS(2886),
    [anon_sym_protected] = ACTIONS(2886),
    [anon_sym_module] = ACTIONS(2886),
    [anon_sym_any] = ACTIONS(2886),
    [anon_sym_number] = ACTIONS(2886),
    [anon_sym_boolean] = ACTIONS(2886),
    [anon_sym_string] = ACTIONS(2886),
    [anon_sym_symbol] = ACTIONS(2886),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [999] = {
    [sym__call_signature] = STATE(5229),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_export] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2849),
    [anon_sym_COMMA] = ACTIONS(1584),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1584),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2814),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2849),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_readonly] = ACTIONS(2849),
    [anon_sym_get] = ACTIONS(2849),
    [anon_sym_set] = ACTIONS(2849),
    [anon_sym_public] = ACTIONS(2849),
    [anon_sym_private] = ACTIONS(2849),
    [anon_sym_protected] = ACTIONS(2849),
    [anon_sym_module] = ACTIONS(2849),
    [anon_sym_any] = ACTIONS(2849),
    [anon_sym_number] = ACTIONS(2849),
    [anon_sym_boolean] = ACTIONS(2849),
    [anon_sym_string] = ACTIONS(2849),
    [anon_sym_symbol] = ACTIONS(2849),
  },
  [1000] = {
    [sym__call_signature] = STATE(5474),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1941),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1813),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_readonly] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1001] = {
    [sym__call_signature] = STATE(5514),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2892),
    [anon_sym_export] = ACTIONS(2894),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2894),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2894),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2894),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1839),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2894),
    [anon_sym_static] = ACTIONS(2894),
    [anon_sym_readonly] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2894),
    [anon_sym_set] = ACTIONS(2894),
    [anon_sym_public] = ACTIONS(2894),
    [anon_sym_private] = ACTIONS(2894),
    [anon_sym_protected] = ACTIONS(2894),
    [anon_sym_module] = ACTIONS(2894),
    [anon_sym_any] = ACTIONS(2894),
    [anon_sym_number] = ACTIONS(2894),
    [anon_sym_boolean] = ACTIONS(2894),
    [anon_sym_string] = ACTIONS(2894),
    [anon_sym_symbol] = ACTIONS(2894),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1002] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5311),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5480),
    [sym_pattern] = STATE(4305),
    [sym_rest_pattern] = STATE(3978),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4030),
    [sym_constructor_type] = STATE(4030),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4030),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5002),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4030),
    [sym_union_type] = STATE(4030),
    [sym_intersection_type] = STATE(4030),
    [sym_function_type] = STATE(4030),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_COMMA] = ACTIONS(2896),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(2896),
    [anon_sym_COLON] = ACTIONS(2896),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1619),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1625),
    [anon_sym_number] = ACTIONS(1625),
    [anon_sym_boolean] = ACTIONS(1625),
    [anon_sym_string] = ACTIONS(1625),
    [anon_sym_symbol] = ACTIONS(1625),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [1003] = {
    [ts_builtin_sym_end] = ACTIONS(1841),
    [sym_identifier] = ACTIONS(1843),
    [anon_sym_export] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1843),
    [anon_sym_namespace] = ACTIONS(1843),
    [anon_sym_LBRACE] = ACTIONS(1841),
    [anon_sym_COMMA] = ACTIONS(1841),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_type] = ACTIONS(1843),
    [anon_sym_typeof] = ACTIONS(1843),
    [anon_sym_import] = ACTIONS(1843),
    [anon_sym_var] = ACTIONS(1843),
    [anon_sym_let] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(1843),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_else] = ACTIONS(1843),
    [anon_sym_if] = ACTIONS(1843),
    [anon_sym_switch] = ACTIONS(1843),
    [anon_sym_for] = ACTIONS(1843),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_await] = ACTIONS(1843),
    [anon_sym_while] = ACTIONS(1843),
    [anon_sym_do] = ACTIONS(1843),
    [anon_sym_try] = ACTIONS(1843),
    [anon_sym_with] = ACTIONS(1843),
    [anon_sym_break] = ACTIONS(1843),
    [anon_sym_continue] = ACTIONS(1843),
    [anon_sym_debugger] = ACTIONS(1843),
    [anon_sym_return] = ACTIONS(1843),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_SEMI] = ACTIONS(1841),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_catch] = ACTIONS(1843),
    [anon_sym_finally] = ACTIONS(1843),
    [anon_sym_yield] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_LT] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1843),
    [anon_sym_class] = ACTIONS(1843),
    [anon_sym_async] = ACTIONS(1843),
    [anon_sym_function] = ACTIONS(1843),
    [anon_sym_new] = ACTIONS(1843),
    [anon_sym_PLUS] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1841),
    [anon_sym_void] = ACTIONS(1843),
    [anon_sym_delete] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_DQUOTE] = ACTIONS(1841),
    [anon_sym_SQUOTE] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1841),
    [sym_number] = ACTIONS(1841),
    [sym_this] = ACTIONS(1843),
    [sym_super] = ACTIONS(1843),
    [sym_true] = ACTIONS(1843),
    [sym_false] = ACTIONS(1843),
    [sym_null] = ACTIONS(1843),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(1841),
    [anon_sym_declare] = ACTIONS(1843),
    [anon_sym_static] = ACTIONS(1843),
    [anon_sym_readonly] = ACTIONS(1843),
    [anon_sym_abstract] = ACTIONS(1843),
    [anon_sym_get] = ACTIONS(1843),
    [anon_sym_set] = ACTIONS(1843),
    [anon_sym_public] = ACTIONS(1843),
    [anon_sym_private] = ACTIONS(1843),
    [anon_sym_protected] = ACTIONS(1843),
    [anon_sym_module] = ACTIONS(1843),
    [anon_sym_any] = ACTIONS(1843),
    [anon_sym_number] = ACTIONS(1843),
    [anon_sym_boolean] = ACTIONS(1843),
    [anon_sym_string] = ACTIONS(1843),
    [anon_sym_symbol] = ACTIONS(1843),
    [anon_sym_interface] = ACTIONS(1843),
    [anon_sym_enum] = ACTIONS(1843),
    [sym__automatic_semicolon] = ACTIONS(1851),
  },
  [1004] = {
    [sym__call_signature] = STATE(5368),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2141),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_EQ_GT] = ACTIONS(2143),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2900),
    [anon_sym_set] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1597),
  },
  [1005] = {
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_export] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_COMMA] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_type] = ACTIONS(1947),
    [anon_sym_typeof] = ACTIONS(1947),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(1947),
    [anon_sym_let] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_await] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_with] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_debugger] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_catch] = ACTIONS(1947),
    [anon_sym_finally] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_SLASH] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_async] = ACTIONS(1947),
    [anon_sym_function] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_void] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1945),
    [sym_number] = ACTIONS(1945),
    [sym_this] = ACTIONS(1947),
    [sym_super] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_null] = ACTIONS(1947),
    [sym_undefined] = ACTIONS(1947),
    [anon_sym_AT] = ACTIONS(1945),
    [anon_sym_declare] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1947),
    [anon_sym_abstract] = ACTIONS(1947),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_module] = ACTIONS(1947),
    [anon_sym_any] = ACTIONS(1947),
    [anon_sym_number] = ACTIONS(1947),
    [anon_sym_boolean] = ACTIONS(1947),
    [anon_sym_string] = ACTIONS(1947),
    [anon_sym_symbol] = ACTIONS(1947),
    [anon_sym_interface] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [sym__automatic_semicolon] = ACTIONS(2902),
  },
  [1006] = {
    [sym__call_signature] = STATE(5368),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_EQ_GT] = ACTIONS(2143),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2900),
    [anon_sym_set] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1597),
  },
  [1007] = {
    [sym_catch_clause] = STATE(1035),
    [sym_finally_clause] = STATE(1065),
    [ts_builtin_sym_end] = ACTIONS(2904),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_export] = ACTIONS(2906),
    [anon_sym_default] = ACTIONS(2906),
    [anon_sym_namespace] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(2904),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_type] = ACTIONS(2906),
    [anon_sym_typeof] = ACTIONS(2906),
    [anon_sym_import] = ACTIONS(2906),
    [anon_sym_var] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_const] = ACTIONS(2906),
    [anon_sym_BANG] = ACTIONS(2904),
    [anon_sym_else] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_switch] = ACTIONS(2906),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_LPAREN] = ACTIONS(2904),
    [anon_sym_await] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_with] = ACTIONS(2906),
    [anon_sym_break] = ACTIONS(2906),
    [anon_sym_continue] = ACTIONS(2906),
    [anon_sym_debugger] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_throw] = ACTIONS(2906),
    [anon_sym_SEMI] = ACTIONS(2904),
    [anon_sym_case] = ACTIONS(2906),
    [anon_sym_catch] = ACTIONS(2908),
    [anon_sym_finally] = ACTIONS(2910),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_SLASH] = ACTIONS(2906),
    [anon_sym_class] = ACTIONS(2906),
    [anon_sym_async] = ACTIONS(2906),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2904),
    [anon_sym_void] = ACTIONS(2906),
    [anon_sym_delete] = ACTIONS(2906),
    [anon_sym_PLUS_PLUS] = ACTIONS(2904),
    [anon_sym_DASH_DASH] = ACTIONS(2904),
    [anon_sym_DQUOTE] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2904),
    [sym_number] = ACTIONS(2904),
    [sym_this] = ACTIONS(2906),
    [sym_super] = ACTIONS(2906),
    [sym_true] = ACTIONS(2906),
    [sym_false] = ACTIONS(2906),
    [sym_null] = ACTIONS(2906),
    [sym_undefined] = ACTIONS(2906),
    [anon_sym_AT] = ACTIONS(2904),
    [anon_sym_declare] = ACTIONS(2906),
    [anon_sym_static] = ACTIONS(2906),
    [anon_sym_readonly] = ACTIONS(2906),
    [anon_sym_abstract] = ACTIONS(2906),
    [anon_sym_get] = ACTIONS(2906),
    [anon_sym_set] = ACTIONS(2906),
    [anon_sym_public] = ACTIONS(2906),
    [anon_sym_private] = ACTIONS(2906),
    [anon_sym_protected] = ACTIONS(2906),
    [anon_sym_module] = ACTIONS(2906),
    [anon_sym_any] = ACTIONS(2906),
    [anon_sym_number] = ACTIONS(2906),
    [anon_sym_boolean] = ACTIONS(2906),
    [anon_sym_string] = ACTIONS(2906),
    [anon_sym_symbol] = ACTIONS(2906),
    [anon_sym_interface] = ACTIONS(2906),
    [anon_sym_enum] = ACTIONS(2906),
  },
  [1008] = {
    [sym__call_signature] = STATE(5274),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2888),
    [anon_sym_export] = ACTIONS(2890),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2078),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2890),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2890),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2890),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2080),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2890),
    [anon_sym_static] = ACTIONS(2890),
    [anon_sym_readonly] = ACTIONS(2890),
    [anon_sym_get] = ACTIONS(2890),
    [anon_sym_set] = ACTIONS(2890),
    [anon_sym_public] = ACTIONS(2890),
    [anon_sym_private] = ACTIONS(2890),
    [anon_sym_protected] = ACTIONS(2890),
    [anon_sym_module] = ACTIONS(2890),
    [anon_sym_any] = ACTIONS(2890),
    [anon_sym_number] = ACTIONS(2890),
    [anon_sym_boolean] = ACTIONS(2890),
    [anon_sym_string] = ACTIONS(2890),
    [anon_sym_symbol] = ACTIONS(2890),
    [anon_sym_implements] = ACTIONS(1580),
  },
  [1009] = {
    [sym__call_signature] = STATE(5514),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2892),
    [anon_sym_export] = ACTIONS(2894),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2894),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2894),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2894),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1839),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2894),
    [anon_sym_static] = ACTIONS(2894),
    [anon_sym_readonly] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2894),
    [anon_sym_set] = ACTIONS(2894),
    [anon_sym_public] = ACTIONS(2894),
    [anon_sym_private] = ACTIONS(2894),
    [anon_sym_protected] = ACTIONS(2894),
    [anon_sym_module] = ACTIONS(2894),
    [anon_sym_any] = ACTIONS(2894),
    [anon_sym_number] = ACTIONS(2894),
    [anon_sym_boolean] = ACTIONS(2894),
    [anon_sym_string] = ACTIONS(2894),
    [anon_sym_symbol] = ACTIONS(2894),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1010] = {
    [sym__call_signature] = STATE(5306),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2914),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2896),
    [anon_sym_type] = ACTIONS(2914),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2914),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2139),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2914),
    [anon_sym_static] = ACTIONS(2914),
    [anon_sym_readonly] = ACTIONS(2914),
    [anon_sym_get] = ACTIONS(2914),
    [anon_sym_set] = ACTIONS(2914),
    [anon_sym_public] = ACTIONS(2914),
    [anon_sym_private] = ACTIONS(2914),
    [anon_sym_protected] = ACTIONS(2914),
    [anon_sym_module] = ACTIONS(2914),
    [anon_sym_any] = ACTIONS(2914),
    [anon_sym_number] = ACTIONS(2914),
    [anon_sym_boolean] = ACTIONS(2914),
    [anon_sym_string] = ACTIONS(2914),
    [anon_sym_symbol] = ACTIONS(2914),
  },
  [1011] = {
    [sym__call_signature] = STATE(5474),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2137),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1813),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_readonly] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1012] = {
    [sym__call_signature] = STATE(5534),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_export] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1903),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_type] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2923),
    [anon_sym_function] = ACTIONS(2925),
    [anon_sym_EQ_GT] = ACTIONS(1905),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_readonly] = ACTIONS(2923),
    [anon_sym_get] = ACTIONS(2923),
    [anon_sym_set] = ACTIONS(2923),
    [anon_sym_public] = ACTIONS(2923),
    [anon_sym_private] = ACTIONS(2923),
    [anon_sym_protected] = ACTIONS(2923),
    [anon_sym_module] = ACTIONS(2923),
    [anon_sym_any] = ACTIONS(2923),
    [anon_sym_number] = ACTIONS(2923),
    [anon_sym_boolean] = ACTIONS(2923),
    [anon_sym_string] = ACTIONS(2923),
    [anon_sym_symbol] = ACTIONS(2923),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1013] = {
    [sym__call_signature] = STATE(5566),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2927),
    [anon_sym_export] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1941),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_type] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2929),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1943),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_readonly] = ACTIONS(2929),
    [anon_sym_get] = ACTIONS(2929),
    [anon_sym_set] = ACTIONS(2929),
    [anon_sym_public] = ACTIONS(2929),
    [anon_sym_private] = ACTIONS(2929),
    [anon_sym_protected] = ACTIONS(2929),
    [anon_sym_module] = ACTIONS(2929),
    [anon_sym_any] = ACTIONS(2929),
    [anon_sym_number] = ACTIONS(2929),
    [anon_sym_boolean] = ACTIONS(2929),
    [anon_sym_string] = ACTIONS(2929),
    [anon_sym_symbol] = ACTIONS(2929),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1014] = {
    [sym__call_signature] = STATE(5229),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_export] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2849),
    [anon_sym_COMMA] = ACTIONS(1584),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2849),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_readonly] = ACTIONS(2849),
    [anon_sym_get] = ACTIONS(2849),
    [anon_sym_set] = ACTIONS(2849),
    [anon_sym_public] = ACTIONS(2849),
    [anon_sym_private] = ACTIONS(2849),
    [anon_sym_protected] = ACTIONS(2849),
    [anon_sym_module] = ACTIONS(2849),
    [anon_sym_any] = ACTIONS(2849),
    [anon_sym_number] = ACTIONS(2849),
    [anon_sym_boolean] = ACTIONS(2849),
    [anon_sym_string] = ACTIONS(2849),
    [anon_sym_symbol] = ACTIONS(2849),
  },
  [1015] = {
    [sym__call_signature] = STATE(5534),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_export] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1903),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_type] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2923),
    [anon_sym_function] = ACTIONS(2931),
    [anon_sym_EQ_GT] = ACTIONS(1905),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_readonly] = ACTIONS(2923),
    [anon_sym_get] = ACTIONS(2923),
    [anon_sym_set] = ACTIONS(2923),
    [anon_sym_public] = ACTIONS(2923),
    [anon_sym_private] = ACTIONS(2923),
    [anon_sym_protected] = ACTIONS(2923),
    [anon_sym_module] = ACTIONS(2923),
    [anon_sym_any] = ACTIONS(2923),
    [anon_sym_number] = ACTIONS(2923),
    [anon_sym_boolean] = ACTIONS(2923),
    [anon_sym_string] = ACTIONS(2923),
    [anon_sym_symbol] = ACTIONS(2923),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1016] = {
    [sym__call_signature] = STATE(5306),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2914),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2896),
    [anon_sym_type] = ACTIONS(2914),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2914),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2139),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2914),
    [anon_sym_static] = ACTIONS(2914),
    [anon_sym_readonly] = ACTIONS(2914),
    [anon_sym_get] = ACTIONS(2914),
    [anon_sym_set] = ACTIONS(2914),
    [anon_sym_public] = ACTIONS(2914),
    [anon_sym_private] = ACTIONS(2914),
    [anon_sym_protected] = ACTIONS(2914),
    [anon_sym_module] = ACTIONS(2914),
    [anon_sym_any] = ACTIONS(2914),
    [anon_sym_number] = ACTIONS(2914),
    [anon_sym_boolean] = ACTIONS(2914),
    [anon_sym_string] = ACTIONS(2914),
    [anon_sym_symbol] = ACTIONS(2914),
  },
  [1017] = {
    [sym__call_signature] = STATE(5306),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2914),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2137),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2914),
    [anon_sym_type] = ACTIONS(2914),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(2933),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2914),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2139),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2914),
    [anon_sym_static] = ACTIONS(2914),
    [anon_sym_readonly] = ACTIONS(2914),
    [anon_sym_get] = ACTIONS(2914),
    [anon_sym_set] = ACTIONS(2914),
    [anon_sym_public] = ACTIONS(2914),
    [anon_sym_private] = ACTIONS(2914),
    [anon_sym_protected] = ACTIONS(2914),
    [anon_sym_module] = ACTIONS(2914),
    [anon_sym_any] = ACTIONS(2914),
    [anon_sym_number] = ACTIONS(2914),
    [anon_sym_boolean] = ACTIONS(2914),
    [anon_sym_string] = ACTIONS(2914),
    [anon_sym_symbol] = ACTIONS(2914),
  },
  [1018] = {
    [ts_builtin_sym_end] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1923),
    [anon_sym_export] = ACTIONS(1923),
    [anon_sym_default] = ACTIONS(1923),
    [anon_sym_namespace] = ACTIONS(1923),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(1921),
    [anon_sym_type] = ACTIONS(1923),
    [anon_sym_typeof] = ACTIONS(1923),
    [anon_sym_import] = ACTIONS(1923),
    [anon_sym_var] = ACTIONS(1923),
    [anon_sym_let] = ACTIONS(1923),
    [anon_sym_const] = ACTIONS(1923),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(1923),
    [anon_sym_if] = ACTIONS(1923),
    [anon_sym_switch] = ACTIONS(1923),
    [anon_sym_for] = ACTIONS(1923),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_while] = ACTIONS(1923),
    [anon_sym_do] = ACTIONS(1923),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_with] = ACTIONS(1923),
    [anon_sym_break] = ACTIONS(1923),
    [anon_sym_continue] = ACTIONS(1923),
    [anon_sym_debugger] = ACTIONS(1923),
    [anon_sym_return] = ACTIONS(1923),
    [anon_sym_throw] = ACTIONS(1923),
    [anon_sym_SEMI] = ACTIONS(1921),
    [anon_sym_case] = ACTIONS(1923),
    [anon_sym_catch] = ACTIONS(1923),
    [anon_sym_finally] = ACTIONS(1923),
    [anon_sym_yield] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1921),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_SLASH] = ACTIONS(1923),
    [anon_sym_class] = ACTIONS(1923),
    [anon_sym_async] = ACTIONS(1923),
    [anon_sym_function] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_PLUS] = ACTIONS(1923),
    [anon_sym_DASH] = ACTIONS(1923),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_void] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(1923),
    [anon_sym_PLUS_PLUS] = ACTIONS(1921),
    [anon_sym_DASH_DASH] = ACTIONS(1921),
    [anon_sym_DQUOTE] = ACTIONS(1921),
    [anon_sym_SQUOTE] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1921),
    [sym_number] = ACTIONS(1921),
    [sym_this] = ACTIONS(1923),
    [sym_super] = ACTIONS(1923),
    [sym_true] = ACTIONS(1923),
    [sym_false] = ACTIONS(1923),
    [sym_null] = ACTIONS(1923),
    [sym_undefined] = ACTIONS(1923),
    [anon_sym_AT] = ACTIONS(1921),
    [anon_sym_declare] = ACTIONS(1923),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_readonly] = ACTIONS(1923),
    [anon_sym_abstract] = ACTIONS(1923),
    [anon_sym_get] = ACTIONS(1923),
    [anon_sym_set] = ACTIONS(1923),
    [anon_sym_public] = ACTIONS(1923),
    [anon_sym_private] = ACTIONS(1923),
    [anon_sym_protected] = ACTIONS(1923),
    [anon_sym_module] = ACTIONS(1923),
    [anon_sym_any] = ACTIONS(1923),
    [anon_sym_number] = ACTIONS(1923),
    [anon_sym_boolean] = ACTIONS(1923),
    [anon_sym_string] = ACTIONS(1923),
    [anon_sym_symbol] = ACTIONS(1923),
    [anon_sym_interface] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1923),
  },
  [1019] = {
    [sym__call_signature] = STATE(5418),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_export] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2013),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_get] = ACTIONS(2937),
    [anon_sym_set] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_module] = ACTIONS(2937),
    [anon_sym_any] = ACTIONS(2937),
    [anon_sym_number] = ACTIONS(2937),
    [anon_sym_boolean] = ACTIONS(2937),
    [anon_sym_string] = ACTIONS(2937),
    [anon_sym_symbol] = ACTIONS(2937),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1020] = {
    [ts_builtin_sym_end] = ACTIONS(1907),
    [sym_identifier] = ACTIONS(1909),
    [anon_sym_export] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1907),
    [anon_sym_COMMA] = ACTIONS(1907),
    [anon_sym_RBRACE] = ACTIONS(1907),
    [anon_sym_type] = ACTIONS(1909),
    [anon_sym_typeof] = ACTIONS(1909),
    [anon_sym_import] = ACTIONS(1909),
    [anon_sym_var] = ACTIONS(1909),
    [anon_sym_let] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_LPAREN] = ACTIONS(1907),
    [anon_sym_await] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_with] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_debugger] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_yield] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_SLASH] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_async] = ACTIONS(1909),
    [anon_sym_function] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1907),
    [sym_number] = ACTIONS(1907),
    [sym_this] = ACTIONS(1909),
    [sym_super] = ACTIONS(1909),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [sym_null] = ACTIONS(1909),
    [sym_undefined] = ACTIONS(1909),
    [anon_sym_AT] = ACTIONS(1907),
    [anon_sym_declare] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_readonly] = ACTIONS(1909),
    [anon_sym_abstract] = ACTIONS(1909),
    [anon_sym_get] = ACTIONS(1909),
    [anon_sym_set] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_module] = ACTIONS(1909),
    [anon_sym_any] = ACTIONS(1909),
    [anon_sym_number] = ACTIONS(1909),
    [anon_sym_boolean] = ACTIONS(1909),
    [anon_sym_string] = ACTIONS(1909),
    [anon_sym_symbol] = ACTIONS(1909),
    [anon_sym_interface] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1907),
    [sym__automatic_semicolon] = ACTIONS(1907),
  },
  [1021] = {
    [sym__call_signature] = STATE(5418),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_export] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2013),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_get] = ACTIONS(2937),
    [anon_sym_set] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_module] = ACTIONS(2937),
    [anon_sym_any] = ACTIONS(2937),
    [anon_sym_number] = ACTIONS(2937),
    [anon_sym_boolean] = ACTIONS(2937),
    [anon_sym_string] = ACTIONS(2937),
    [anon_sym_symbol] = ACTIONS(2937),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1022] = {
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_export] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_COMMA] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_type] = ACTIONS(1947),
    [anon_sym_typeof] = ACTIONS(1947),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(1947),
    [anon_sym_let] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_await] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_with] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_debugger] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_SLASH] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_async] = ACTIONS(1947),
    [anon_sym_function] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_void] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1945),
    [sym_number] = ACTIONS(1945),
    [sym_this] = ACTIONS(1947),
    [sym_super] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_null] = ACTIONS(1947),
    [sym_undefined] = ACTIONS(1947),
    [anon_sym_AT] = ACTIONS(1945),
    [anon_sym_declare] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1947),
    [anon_sym_abstract] = ACTIONS(1947),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_module] = ACTIONS(1947),
    [anon_sym_any] = ACTIONS(1947),
    [anon_sym_number] = ACTIONS(1947),
    [anon_sym_boolean] = ACTIONS(1947),
    [anon_sym_string] = ACTIONS(1947),
    [anon_sym_symbol] = ACTIONS(1947),
    [anon_sym_interface] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1945),
    [sym__automatic_semicolon] = ACTIONS(1945),
  },
  [1023] = {
    [sym__call_signature] = STATE(5534),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_export] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_type] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2923),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1905),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_readonly] = ACTIONS(2923),
    [anon_sym_get] = ACTIONS(2923),
    [anon_sym_set] = ACTIONS(2923),
    [anon_sym_public] = ACTIONS(2923),
    [anon_sym_private] = ACTIONS(2923),
    [anon_sym_protected] = ACTIONS(2923),
    [anon_sym_module] = ACTIONS(2923),
    [anon_sym_any] = ACTIONS(2923),
    [anon_sym_number] = ACTIONS(2923),
    [anon_sym_boolean] = ACTIONS(2923),
    [anon_sym_string] = ACTIONS(2923),
    [anon_sym_symbol] = ACTIONS(2923),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1024] = {
    [sym__call_signature] = STATE(5534),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_export] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1903),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_type] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2923),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(1905),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_readonly] = ACTIONS(2923),
    [anon_sym_get] = ACTIONS(2923),
    [anon_sym_set] = ACTIONS(2923),
    [anon_sym_public] = ACTIONS(2923),
    [anon_sym_private] = ACTIONS(2923),
    [anon_sym_protected] = ACTIONS(2923),
    [anon_sym_module] = ACTIONS(2923),
    [anon_sym_any] = ACTIONS(2923),
    [anon_sym_number] = ACTIONS(2923),
    [anon_sym_boolean] = ACTIONS(2923),
    [anon_sym_string] = ACTIONS(2923),
    [anon_sym_symbol] = ACTIONS(2923),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1025] = {
    [ts_builtin_sym_end] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1923),
    [anon_sym_export] = ACTIONS(1923),
    [anon_sym_default] = ACTIONS(1923),
    [anon_sym_namespace] = ACTIONS(1923),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(1921),
    [anon_sym_type] = ACTIONS(1923),
    [anon_sym_typeof] = ACTIONS(1923),
    [anon_sym_import] = ACTIONS(1923),
    [anon_sym_var] = ACTIONS(1923),
    [anon_sym_let] = ACTIONS(1923),
    [anon_sym_const] = ACTIONS(1923),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(1923),
    [anon_sym_if] = ACTIONS(1923),
    [anon_sym_switch] = ACTIONS(1923),
    [anon_sym_for] = ACTIONS(1923),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_while] = ACTIONS(1923),
    [anon_sym_do] = ACTIONS(1923),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_with] = ACTIONS(1923),
    [anon_sym_break] = ACTIONS(1923),
    [anon_sym_continue] = ACTIONS(1923),
    [anon_sym_debugger] = ACTIONS(1923),
    [anon_sym_return] = ACTIONS(1923),
    [anon_sym_throw] = ACTIONS(1923),
    [anon_sym_SEMI] = ACTIONS(1921),
    [anon_sym_case] = ACTIONS(1923),
    [anon_sym_yield] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1921),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_SLASH] = ACTIONS(1923),
    [anon_sym_class] = ACTIONS(1923),
    [anon_sym_async] = ACTIONS(1923),
    [anon_sym_function] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_PLUS] = ACTIONS(1923),
    [anon_sym_DASH] = ACTIONS(1923),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_void] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(1923),
    [anon_sym_PLUS_PLUS] = ACTIONS(1921),
    [anon_sym_DASH_DASH] = ACTIONS(1921),
    [anon_sym_DQUOTE] = ACTIONS(1921),
    [anon_sym_SQUOTE] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1921),
    [sym_number] = ACTIONS(1921),
    [sym_this] = ACTIONS(1923),
    [sym_super] = ACTIONS(1923),
    [sym_true] = ACTIONS(1923),
    [sym_false] = ACTIONS(1923),
    [sym_null] = ACTIONS(1923),
    [sym_undefined] = ACTIONS(1923),
    [anon_sym_AT] = ACTIONS(1921),
    [anon_sym_declare] = ACTIONS(1923),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_readonly] = ACTIONS(1923),
    [anon_sym_abstract] = ACTIONS(1923),
    [anon_sym_get] = ACTIONS(1923),
    [anon_sym_set] = ACTIONS(1923),
    [anon_sym_public] = ACTIONS(1923),
    [anon_sym_private] = ACTIONS(1923),
    [anon_sym_protected] = ACTIONS(1923),
    [anon_sym_module] = ACTIONS(1923),
    [anon_sym_any] = ACTIONS(1923),
    [anon_sym_number] = ACTIONS(1923),
    [anon_sym_boolean] = ACTIONS(1923),
    [anon_sym_string] = ACTIONS(1923),
    [anon_sym_symbol] = ACTIONS(1923),
    [anon_sym_interface] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1923),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1921),
    [sym__automatic_semicolon] = ACTIONS(1921),
  },
  [1026] = {
    [sym__call_signature] = STATE(5566),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2927),
    [anon_sym_export] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_type] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2929),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1943),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_readonly] = ACTIONS(2929),
    [anon_sym_get] = ACTIONS(2929),
    [anon_sym_set] = ACTIONS(2929),
    [anon_sym_public] = ACTIONS(2929),
    [anon_sym_private] = ACTIONS(2929),
    [anon_sym_protected] = ACTIONS(2929),
    [anon_sym_module] = ACTIONS(2929),
    [anon_sym_any] = ACTIONS(2929),
    [anon_sym_number] = ACTIONS(2929),
    [anon_sym_boolean] = ACTIONS(2929),
    [anon_sym_string] = ACTIONS(2929),
    [anon_sym_symbol] = ACTIONS(2929),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1027] = {
    [sym__call_signature] = STATE(5229),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_export] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2849),
    [anon_sym_COMMA] = ACTIONS(1584),
    [anon_sym_RBRACE] = ACTIONS(1584),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2849),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_readonly] = ACTIONS(2849),
    [anon_sym_get] = ACTIONS(2849),
    [anon_sym_set] = ACTIONS(2849),
    [anon_sym_public] = ACTIONS(2849),
    [anon_sym_private] = ACTIONS(2849),
    [anon_sym_protected] = ACTIONS(2849),
    [anon_sym_module] = ACTIONS(2849),
    [anon_sym_any] = ACTIONS(2849),
    [anon_sym_number] = ACTIONS(2849),
    [anon_sym_boolean] = ACTIONS(2849),
    [anon_sym_string] = ACTIONS(2849),
    [anon_sym_symbol] = ACTIONS(2849),
  },
  [1028] = {
    [ts_builtin_sym_end] = ACTIONS(1869),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_export] = ACTIONS(1871),
    [anon_sym_default] = ACTIONS(1871),
    [anon_sym_namespace] = ACTIONS(1871),
    [anon_sym_LBRACE] = ACTIONS(1869),
    [anon_sym_COMMA] = ACTIONS(1869),
    [anon_sym_RBRACE] = ACTIONS(1869),
    [anon_sym_type] = ACTIONS(1871),
    [anon_sym_typeof] = ACTIONS(1871),
    [anon_sym_import] = ACTIONS(1871),
    [anon_sym_var] = ACTIONS(1871),
    [anon_sym_let] = ACTIONS(1871),
    [anon_sym_const] = ACTIONS(1871),
    [anon_sym_BANG] = ACTIONS(1869),
    [anon_sym_else] = ACTIONS(1871),
    [anon_sym_if] = ACTIONS(1871),
    [anon_sym_switch] = ACTIONS(1871),
    [anon_sym_for] = ACTIONS(1871),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_await] = ACTIONS(1871),
    [anon_sym_while] = ACTIONS(1871),
    [anon_sym_do] = ACTIONS(1871),
    [anon_sym_try] = ACTIONS(1871),
    [anon_sym_with] = ACTIONS(1871),
    [anon_sym_break] = ACTIONS(1871),
    [anon_sym_continue] = ACTIONS(1871),
    [anon_sym_debugger] = ACTIONS(1871),
    [anon_sym_return] = ACTIONS(1871),
    [anon_sym_throw] = ACTIONS(1871),
    [anon_sym_SEMI] = ACTIONS(1869),
    [anon_sym_case] = ACTIONS(1871),
    [anon_sym_yield] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(1869),
    [anon_sym_LT] = ACTIONS(1869),
    [anon_sym_SLASH] = ACTIONS(1871),
    [anon_sym_class] = ACTIONS(1871),
    [anon_sym_async] = ACTIONS(1871),
    [anon_sym_function] = ACTIONS(1871),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_PLUS] = ACTIONS(1871),
    [anon_sym_DASH] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1869),
    [anon_sym_void] = ACTIONS(1871),
    [anon_sym_delete] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1869),
    [anon_sym_DASH_DASH] = ACTIONS(1869),
    [anon_sym_DQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1869),
    [sym_number] = ACTIONS(1869),
    [sym_this] = ACTIONS(1871),
    [sym_super] = ACTIONS(1871),
    [sym_true] = ACTIONS(1871),
    [sym_false] = ACTIONS(1871),
    [sym_null] = ACTIONS(1871),
    [sym_undefined] = ACTIONS(1871),
    [anon_sym_AT] = ACTIONS(1869),
    [anon_sym_declare] = ACTIONS(1871),
    [anon_sym_static] = ACTIONS(1871),
    [anon_sym_readonly] = ACTIONS(1871),
    [anon_sym_abstract] = ACTIONS(1871),
    [anon_sym_get] = ACTIONS(1871),
    [anon_sym_set] = ACTIONS(1871),
    [anon_sym_public] = ACTIONS(1871),
    [anon_sym_private] = ACTIONS(1871),
    [anon_sym_protected] = ACTIONS(1871),
    [anon_sym_module] = ACTIONS(1871),
    [anon_sym_any] = ACTIONS(1871),
    [anon_sym_number] = ACTIONS(1871),
    [anon_sym_boolean] = ACTIONS(1871),
    [anon_sym_string] = ACTIONS(1871),
    [anon_sym_symbol] = ACTIONS(1871),
    [anon_sym_interface] = ACTIONS(1871),
    [anon_sym_enum] = ACTIONS(1871),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(1869),
  },
  [1029] = {
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_export] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_COMMA] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_type] = ACTIONS(1947),
    [anon_sym_typeof] = ACTIONS(1947),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(1947),
    [anon_sym_let] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_await] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_with] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_debugger] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_catch] = ACTIONS(1947),
    [anon_sym_finally] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_SLASH] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_async] = ACTIONS(1947),
    [anon_sym_function] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_void] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1945),
    [sym_number] = ACTIONS(1945),
    [sym_this] = ACTIONS(1947),
    [sym_super] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_null] = ACTIONS(1947),
    [sym_undefined] = ACTIONS(1947),
    [anon_sym_AT] = ACTIONS(1945),
    [anon_sym_declare] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1947),
    [anon_sym_abstract] = ACTIONS(1947),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_module] = ACTIONS(1947),
    [anon_sym_any] = ACTIONS(1947),
    [anon_sym_number] = ACTIONS(1947),
    [anon_sym_boolean] = ACTIONS(1947),
    [anon_sym_string] = ACTIONS(1947),
    [anon_sym_symbol] = ACTIONS(1947),
    [anon_sym_interface] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
  },
  [1030] = {
    [sym__call_signature] = STATE(5306),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2914),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2137),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2914),
    [anon_sym_type] = ACTIONS(2914),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2914),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2139),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2914),
    [anon_sym_static] = ACTIONS(2914),
    [anon_sym_readonly] = ACTIONS(2914),
    [anon_sym_get] = ACTIONS(2914),
    [anon_sym_set] = ACTIONS(2914),
    [anon_sym_public] = ACTIONS(2914),
    [anon_sym_private] = ACTIONS(2914),
    [anon_sym_protected] = ACTIONS(2914),
    [anon_sym_module] = ACTIONS(2914),
    [anon_sym_any] = ACTIONS(2914),
    [anon_sym_number] = ACTIONS(2914),
    [anon_sym_boolean] = ACTIONS(2914),
    [anon_sym_string] = ACTIONS(2914),
    [anon_sym_symbol] = ACTIONS(2914),
  },
  [1031] = {
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_export] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_COMMA] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_type] = ACTIONS(1947),
    [anon_sym_typeof] = ACTIONS(1947),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(1947),
    [anon_sym_let] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_await] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_with] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_debugger] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_SLASH] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_async] = ACTIONS(1947),
    [anon_sym_function] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_void] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1945),
    [sym_number] = ACTIONS(1945),
    [sym_this] = ACTIONS(1947),
    [sym_super] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_null] = ACTIONS(1947),
    [sym_undefined] = ACTIONS(1947),
    [anon_sym_AT] = ACTIONS(1945),
    [anon_sym_declare] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1947),
    [anon_sym_abstract] = ACTIONS(1947),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_module] = ACTIONS(1947),
    [anon_sym_any] = ACTIONS(1947),
    [anon_sym_number] = ACTIONS(1947),
    [anon_sym_boolean] = ACTIONS(1947),
    [anon_sym_string] = ACTIONS(1947),
    [anon_sym_symbol] = ACTIONS(1947),
    [anon_sym_interface] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1945),
    [sym__automatic_semicolon] = ACTIONS(2939),
  },
  [1032] = {
    [ts_builtin_sym_end] = ACTIONS(1841),
    [sym_identifier] = ACTIONS(1843),
    [anon_sym_export] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1843),
    [anon_sym_namespace] = ACTIONS(1843),
    [anon_sym_LBRACE] = ACTIONS(1841),
    [anon_sym_COMMA] = ACTIONS(1841),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_type] = ACTIONS(1843),
    [anon_sym_typeof] = ACTIONS(1843),
    [anon_sym_import] = ACTIONS(1843),
    [anon_sym_var] = ACTIONS(1843),
    [anon_sym_let] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(1843),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_else] = ACTIONS(1843),
    [anon_sym_if] = ACTIONS(1843),
    [anon_sym_switch] = ACTIONS(1843),
    [anon_sym_for] = ACTIONS(1843),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_await] = ACTIONS(1843),
    [anon_sym_while] = ACTIONS(1843),
    [anon_sym_do] = ACTIONS(1843),
    [anon_sym_try] = ACTIONS(1843),
    [anon_sym_with] = ACTIONS(1843),
    [anon_sym_break] = ACTIONS(1843),
    [anon_sym_continue] = ACTIONS(1843),
    [anon_sym_debugger] = ACTIONS(1843),
    [anon_sym_return] = ACTIONS(1843),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_SEMI] = ACTIONS(1841),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_yield] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_LT] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1843),
    [anon_sym_class] = ACTIONS(1843),
    [anon_sym_async] = ACTIONS(1843),
    [anon_sym_function] = ACTIONS(1843),
    [anon_sym_new] = ACTIONS(1843),
    [anon_sym_PLUS] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1841),
    [anon_sym_void] = ACTIONS(1843),
    [anon_sym_delete] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_DQUOTE] = ACTIONS(1841),
    [anon_sym_SQUOTE] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1841),
    [sym_number] = ACTIONS(1841),
    [sym_this] = ACTIONS(1843),
    [sym_super] = ACTIONS(1843),
    [sym_true] = ACTIONS(1843),
    [sym_false] = ACTIONS(1843),
    [sym_null] = ACTIONS(1843),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(1841),
    [anon_sym_declare] = ACTIONS(1843),
    [anon_sym_static] = ACTIONS(1843),
    [anon_sym_readonly] = ACTIONS(1843),
    [anon_sym_abstract] = ACTIONS(1843),
    [anon_sym_get] = ACTIONS(1843),
    [anon_sym_set] = ACTIONS(1843),
    [anon_sym_public] = ACTIONS(1843),
    [anon_sym_private] = ACTIONS(1843),
    [anon_sym_protected] = ACTIONS(1843),
    [anon_sym_module] = ACTIONS(1843),
    [anon_sym_any] = ACTIONS(1843),
    [anon_sym_number] = ACTIONS(1843),
    [anon_sym_boolean] = ACTIONS(1843),
    [anon_sym_string] = ACTIONS(1843),
    [anon_sym_symbol] = ACTIONS(1843),
    [anon_sym_interface] = ACTIONS(1843),
    [anon_sym_enum] = ACTIONS(1843),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1841),
    [sym__automatic_semicolon] = ACTIONS(2941),
  },
  [1033] = {
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(1584),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_RPAREN] = ACTIONS(1584),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2814),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_this] = ACTIONS(2837),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_readonly] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
  },
  [1034] = {
    [sym__call_signature] = STATE(5418),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_export] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2013),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_get] = ACTIONS(2937),
    [anon_sym_set] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_module] = ACTIONS(2937),
    [anon_sym_any] = ACTIONS(2937),
    [anon_sym_number] = ACTIONS(2937),
    [anon_sym_boolean] = ACTIONS(2937),
    [anon_sym_string] = ACTIONS(2937),
    [anon_sym_symbol] = ACTIONS(2937),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1035] = {
    [sym_finally_clause] = STATE(1091),
    [ts_builtin_sym_end] = ACTIONS(2943),
    [sym_identifier] = ACTIONS(2945),
    [anon_sym_export] = ACTIONS(2945),
    [anon_sym_default] = ACTIONS(2945),
    [anon_sym_namespace] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2943),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_type] = ACTIONS(2945),
    [anon_sym_typeof] = ACTIONS(2945),
    [anon_sym_import] = ACTIONS(2945),
    [anon_sym_var] = ACTIONS(2945),
    [anon_sym_let] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2943),
    [anon_sym_else] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_switch] = ACTIONS(2945),
    [anon_sym_for] = ACTIONS(2945),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_await] = ACTIONS(2945),
    [anon_sym_while] = ACTIONS(2945),
    [anon_sym_do] = ACTIONS(2945),
    [anon_sym_try] = ACTIONS(2945),
    [anon_sym_with] = ACTIONS(2945),
    [anon_sym_break] = ACTIONS(2945),
    [anon_sym_continue] = ACTIONS(2945),
    [anon_sym_debugger] = ACTIONS(2945),
    [anon_sym_return] = ACTIONS(2945),
    [anon_sym_throw] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_case] = ACTIONS(2945),
    [anon_sym_finally] = ACTIONS(2910),
    [anon_sym_yield] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2943),
    [anon_sym_SLASH] = ACTIONS(2945),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2945),
    [anon_sym_new] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_TILDE] = ACTIONS(2943),
    [anon_sym_void] = ACTIONS(2945),
    [anon_sym_delete] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2943),
    [sym_number] = ACTIONS(2943),
    [sym_this] = ACTIONS(2945),
    [sym_super] = ACTIONS(2945),
    [sym_true] = ACTIONS(2945),
    [sym_false] = ACTIONS(2945),
    [sym_null] = ACTIONS(2945),
    [sym_undefined] = ACTIONS(2945),
    [anon_sym_AT] = ACTIONS(2943),
    [anon_sym_declare] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_readonly] = ACTIONS(2945),
    [anon_sym_abstract] = ACTIONS(2945),
    [anon_sym_get] = ACTIONS(2945),
    [anon_sym_set] = ACTIONS(2945),
    [anon_sym_public] = ACTIONS(2945),
    [anon_sym_private] = ACTIONS(2945),
    [anon_sym_protected] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(2945),
    [anon_sym_any] = ACTIONS(2945),
    [anon_sym_number] = ACTIONS(2945),
    [anon_sym_boolean] = ACTIONS(2945),
    [anon_sym_string] = ACTIONS(2945),
    [anon_sym_symbol] = ACTIONS(2945),
    [anon_sym_interface] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
  },
  [1036] = {
    [sym__call_signature] = STATE(5290),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_export] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2949),
    [anon_sym_type] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2949),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2135),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_readonly] = ACTIONS(2949),
    [anon_sym_get] = ACTIONS(2949),
    [anon_sym_set] = ACTIONS(2949),
    [anon_sym_public] = ACTIONS(2949),
    [anon_sym_private] = ACTIONS(2949),
    [anon_sym_protected] = ACTIONS(2949),
    [anon_sym_module] = ACTIONS(2949),
    [anon_sym_any] = ACTIONS(2949),
    [anon_sym_number] = ACTIONS(2949),
    [anon_sym_boolean] = ACTIONS(2949),
    [anon_sym_string] = ACTIONS(2949),
    [anon_sym_symbol] = ACTIONS(2949),
  },
  [1037] = {
    [sym__call_signature] = STATE(5306),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2914),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2914),
    [anon_sym_type] = ACTIONS(2914),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2914),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2139),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2914),
    [anon_sym_static] = ACTIONS(2914),
    [anon_sym_readonly] = ACTIONS(2914),
    [anon_sym_get] = ACTIONS(2914),
    [anon_sym_set] = ACTIONS(2914),
    [anon_sym_public] = ACTIONS(2914),
    [anon_sym_private] = ACTIONS(2914),
    [anon_sym_protected] = ACTIONS(2914),
    [anon_sym_module] = ACTIONS(2914),
    [anon_sym_any] = ACTIONS(2914),
    [anon_sym_number] = ACTIONS(2914),
    [anon_sym_boolean] = ACTIONS(2914),
    [anon_sym_string] = ACTIONS(2914),
    [anon_sym_symbol] = ACTIONS(2914),
  },
  [1038] = {
    [sym__call_signature] = STATE(5329),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_export] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2953),
    [anon_sym_type] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2130),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2953),
    [anon_sym_readonly] = ACTIONS(2953),
    [anon_sym_get] = ACTIONS(2953),
    [anon_sym_set] = ACTIONS(2953),
    [anon_sym_public] = ACTIONS(2953),
    [anon_sym_private] = ACTIONS(2953),
    [anon_sym_protected] = ACTIONS(2953),
    [anon_sym_module] = ACTIONS(2953),
    [anon_sym_any] = ACTIONS(2953),
    [anon_sym_number] = ACTIONS(2953),
    [anon_sym_boolean] = ACTIONS(2953),
    [anon_sym_string] = ACTIONS(2953),
    [anon_sym_symbol] = ACTIONS(2953),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1039] = {
    [sym__call_signature] = STATE(5290),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_export] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2949),
    [anon_sym_type] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(2879),
    [anon_sym_of] = ACTIONS(2882),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2949),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2135),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_readonly] = ACTIONS(2949),
    [anon_sym_get] = ACTIONS(2949),
    [anon_sym_set] = ACTIONS(2949),
    [anon_sym_public] = ACTIONS(2949),
    [anon_sym_private] = ACTIONS(2949),
    [anon_sym_protected] = ACTIONS(2949),
    [anon_sym_module] = ACTIONS(2949),
    [anon_sym_any] = ACTIONS(2949),
    [anon_sym_number] = ACTIONS(2949),
    [anon_sym_boolean] = ACTIONS(2949),
    [anon_sym_string] = ACTIONS(2949),
    [anon_sym_symbol] = ACTIONS(2949),
  },
  [1040] = {
    [sym_statement_block] = STATE(1139),
    [ts_builtin_sym_end] = ACTIONS(1857),
    [sym_identifier] = ACTIONS(1859),
    [anon_sym_export] = ACTIONS(1859),
    [anon_sym_default] = ACTIONS(1859),
    [anon_sym_namespace] = ACTIONS(1859),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_RBRACE] = ACTIONS(1857),
    [anon_sym_type] = ACTIONS(1859),
    [anon_sym_typeof] = ACTIONS(1859),
    [anon_sym_import] = ACTIONS(1859),
    [anon_sym_var] = ACTIONS(1859),
    [anon_sym_let] = ACTIONS(1859),
    [anon_sym_const] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_else] = ACTIONS(1859),
    [anon_sym_if] = ACTIONS(1859),
    [anon_sym_switch] = ACTIONS(1859),
    [anon_sym_for] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_while] = ACTIONS(1859),
    [anon_sym_do] = ACTIONS(1859),
    [anon_sym_try] = ACTIONS(1859),
    [anon_sym_with] = ACTIONS(1859),
    [anon_sym_break] = ACTIONS(1859),
    [anon_sym_continue] = ACTIONS(1859),
    [anon_sym_debugger] = ACTIONS(1859),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_throw] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_case] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_SLASH] = ACTIONS(1859),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_async] = ACTIONS(1859),
    [anon_sym_function] = ACTIONS(1859),
    [anon_sym_new] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_void] = ACTIONS(1859),
    [anon_sym_delete] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_DQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1857),
    [sym_number] = ACTIONS(1857),
    [sym_this] = ACTIONS(1859),
    [sym_super] = ACTIONS(1859),
    [sym_true] = ACTIONS(1859),
    [sym_false] = ACTIONS(1859),
    [sym_null] = ACTIONS(1859),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(1857),
    [anon_sym_declare] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1859),
    [anon_sym_readonly] = ACTIONS(1859),
    [anon_sym_abstract] = ACTIONS(1859),
    [anon_sym_get] = ACTIONS(1859),
    [anon_sym_set] = ACTIONS(1859),
    [anon_sym_public] = ACTIONS(1859),
    [anon_sym_private] = ACTIONS(1859),
    [anon_sym_protected] = ACTIONS(1859),
    [anon_sym_module] = ACTIONS(1859),
    [anon_sym_any] = ACTIONS(1859),
    [anon_sym_number] = ACTIONS(1859),
    [anon_sym_boolean] = ACTIONS(1859),
    [anon_sym_string] = ACTIONS(1859),
    [anon_sym_symbol] = ACTIONS(1859),
    [anon_sym_interface] = ACTIONS(1859),
    [anon_sym_enum] = ACTIONS(1859),
  },
  [1041] = {
    [sym__call_signature] = STATE(5329),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_export] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2128),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2953),
    [anon_sym_type] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2130),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2953),
    [anon_sym_readonly] = ACTIONS(2953),
    [anon_sym_get] = ACTIONS(2953),
    [anon_sym_set] = ACTIONS(2953),
    [anon_sym_public] = ACTIONS(2953),
    [anon_sym_private] = ACTIONS(2953),
    [anon_sym_protected] = ACTIONS(2953),
    [anon_sym_module] = ACTIONS(2953),
    [anon_sym_any] = ACTIONS(2953),
    [anon_sym_number] = ACTIONS(2953),
    [anon_sym_boolean] = ACTIONS(2953),
    [anon_sym_string] = ACTIONS(2953),
    [anon_sym_symbol] = ACTIONS(2953),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1042] = {
    [sym__call_signature] = STATE(5306),
    [sym_formal_parameters] = STATE(4474),
    [sym_type_parameters] = STATE(5025),
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2914),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2137),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(2914),
    [anon_sym_type] = ACTIONS(2914),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(2914),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2139),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(2914),
    [anon_sym_static] = ACTIONS(2914),
    [anon_sym_readonly] = ACTIONS(2914),
    [anon_sym_get] = ACTIONS(2914),
    [anon_sym_set] = ACTIONS(2914),
    [anon_sym_public] = ACTIONS(2914),
    [anon_sym_private] = ACTIONS(2914),
    [anon_sym_protected] = ACTIONS(2914),
    [anon_sym_module] = ACTIONS(2914),
    [anon_sym_any] = ACTIONS(2914),
    [anon_sym_number] = ACTIONS(2914),
    [anon_sym_boolean] = ACTIONS(2914),
    [anon_sym_string] = ACTIONS(2914),
    [anon_sym_symbol] = ACTIONS(2914),
  },
  [1043] = {
    [ts_builtin_sym_end] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_type] = ACTIONS(2056),
    [anon_sym_typeof] = ACTIONS(2056),
    [anon_sym_import] = ACTIONS(2056),
    [anon_sym_var] = ACTIONS(2056),
    [anon_sym_let] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_LPAREN] = ACTIONS(2054),
    [anon_sym_await] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_with] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_debugger] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_yield] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2054),
    [anon_sym_SLASH] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_async] = ACTIONS(2056),
    [anon_sym_function] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_void] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2054),
    [sym_number] = ACTIONS(2054),
    [sym_this] = ACTIONS(2056),
    [sym_super] = ACTIONS(2056),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [sym_null] = ACTIONS(2056),
    [sym_undefined] = ACTIONS(2056),
    [anon_sym_AT] = ACTIONS(2054),
    [anon_sym_declare] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_readonly] = ACTIONS(2056),
    [anon_sym_abstract] = ACTIONS(2056),
    [anon_sym_get] = ACTIONS(2056),
    [anon_sym_set] = ACTIONS(2056),
    [anon_sym_public] = ACTIONS(2056),
    [anon_sym_private] = ACTIONS(2056),
    [anon_sym_protected] = ACTIONS(2056),
    [anon_sym_module] = ACTIONS(2056),
    [anon_sym_any] = ACTIONS(2056),
    [anon_sym_number] = ACTIONS(2056),
    [anon_sym_boolean] = ACTIONS(2056),
    [anon_sym_string] = ACTIONS(2056),
    [anon_sym_symbol] = ACTIONS(2056),
    [anon_sym_interface] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [sym__automatic_semicolon] = ACTIONS(2062),
  },
  [1044] = {
    [ts_builtin_sym_end] = ACTIONS(2959),
    [sym_identifier] = ACTIONS(2961),
    [anon_sym_export] = ACTIONS(2961),
    [anon_sym_default] = ACTIONS(2961),
    [anon_sym_namespace] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_type] = ACTIONS(2961),
    [anon_sym_typeof] = ACTIONS(2961),
    [anon_sym_import] = ACTIONS(2961),
    [anon_sym_var] = ACTIONS(2961),
    [anon_sym_let] = ACTIONS(2961),
    [anon_sym_const] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2959),
    [anon_sym_else] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_switch] = ACTIONS(2961),
    [anon_sym_for] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_await] = ACTIONS(2961),
    [anon_sym_while] = ACTIONS(2961),
    [anon_sym_do] = ACTIONS(2961),
    [anon_sym_try] = ACTIONS(2961),
    [anon_sym_with] = ACTIONS(2961),
    [anon_sym_break] = ACTIONS(2961),
    [anon_sym_continue] = ACTIONS(2961),
    [anon_sym_debugger] = ACTIONS(2961),
    [anon_sym_return] = ACTIONS(2961),
    [anon_sym_throw] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_case] = ACTIONS(2961),
    [anon_sym_yield] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_LT] = ACTIONS(2959),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_class] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(2961),
    [anon_sym_function] = ACTIONS(2961),
    [anon_sym_new] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_void] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2959),
    [sym_number] = ACTIONS(2959),
    [sym_this] = ACTIONS(2961),
    [sym_super] = ACTIONS(2961),
    [sym_true] = ACTIONS(2961),
    [sym_false] = ACTIONS(2961),
    [sym_null] = ACTIONS(2961),
    [sym_undefined] = ACTIONS(2961),
    [anon_sym_AT] = ACTIONS(2959),
    [anon_sym_declare] = ACTIONS(2961),
    [anon_sym_static] = ACTIONS(2961),
    [anon_sym_readonly] = ACTIONS(2961),
    [anon_sym_abstract] = ACTIONS(2961),
    [anon_sym_get] = ACTIONS(2961),
    [anon_sym_set] = ACTIONS(2961),
    [anon_sym_public] = ACTIONS(2961),
    [anon_sym_private] = ACTIONS(2961),
    [anon_sym_protected] = ACTIONS(2961),
    [anon_sym_module] = ACTIONS(2961),
    [anon_sym_any] = ACTIONS(2961),
    [anon_sym_number] = ACTIONS(2961),
    [anon_sym_boolean] = ACTIONS(2961),
    [anon_sym_string] = ACTIONS(2961),
    [anon_sym_symbol] = ACTIONS(2961),
    [anon_sym_interface] = ACTIONS(2961),
    [anon_sym_enum] = ACTIONS(2961),
  },
  [1045] = {
    [ts_builtin_sym_end] = ACTIONS(2963),
    [sym_identifier] = ACTIONS(2965),
    [anon_sym_export] = ACTIONS(2965),
    [anon_sym_default] = ACTIONS(2965),
    [anon_sym_namespace] = ACTIONS(2965),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_type] = ACTIONS(2965),
    [anon_sym_typeof] = ACTIONS(2965),
    [anon_sym_import] = ACTIONS(2965),
    [anon_sym_var] = ACTIONS(2965),
    [anon_sym_let] = ACTIONS(2965),
    [anon_sym_const] = ACTIONS(2965),
    [anon_sym_BANG] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2965),
    [anon_sym_if] = ACTIONS(2965),
    [anon_sym_switch] = ACTIONS(2965),
    [anon_sym_for] = ACTIONS(2965),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_await] = ACTIONS(2965),
    [anon_sym_while] = ACTIONS(2965),
    [anon_sym_do] = ACTIONS(2965),
    [anon_sym_try] = ACTIONS(2965),
    [anon_sym_with] = ACTIONS(2965),
    [anon_sym_break] = ACTIONS(2965),
    [anon_sym_continue] = ACTIONS(2965),
    [anon_sym_debugger] = ACTIONS(2965),
    [anon_sym_return] = ACTIONS(2965),
    [anon_sym_throw] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_case] = ACTIONS(2965),
    [anon_sym_yield] = ACTIONS(2965),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_LT] = ACTIONS(2963),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_class] = ACTIONS(2965),
    [anon_sym_async] = ACTIONS(2965),
    [anon_sym_function] = ACTIONS(2965),
    [anon_sym_new] = ACTIONS(2965),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_TILDE] = ACTIONS(2963),
    [anon_sym_void] = ACTIONS(2965),
    [anon_sym_delete] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2963),
    [anon_sym_DASH_DASH] = ACTIONS(2963),
    [anon_sym_DQUOTE] = ACTIONS(2963),
    [anon_sym_SQUOTE] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2963),
    [sym_number] = ACTIONS(2963),
    [sym_this] = ACTIONS(2965),
    [sym_super] = ACTIONS(2965),
    [sym_true] = ACTIONS(2965),
    [sym_false] = ACTIONS(2965),
    [sym_null] = ACTIONS(2965),
    [sym_undefined] = ACTIONS(2965),
    [anon_sym_AT] = ACTIONS(2963),
    [anon_sym_declare] = ACTIONS(2965),
    [anon_sym_static] = ACTIONS(2965),
    [anon_sym_readonly] = ACTIONS(2965),
    [anon_sym_abstract] = ACTIONS(2965),
    [anon_sym_get] = ACTIONS(2965),
    [anon_sym_set] = ACTIONS(2965),
    [anon_sym_public] = ACTIONS(2965),
    [anon_sym_private] = ACTIONS(2965),
    [anon_sym_protected] = ACTIONS(2965),
    [anon_sym_module] = ACTIONS(2965),
    [anon_sym_any] = ACTIONS(2965),
    [anon_sym_number] = ACTIONS(2965),
    [anon_sym_boolean] = ACTIONS(2965),
    [anon_sym_string] = ACTIONS(2965),
    [anon_sym_symbol] = ACTIONS(2965),
    [anon_sym_interface] = ACTIONS(2965),
    [anon_sym_enum] = ACTIONS(2965),
  },
  [1046] = {
    [ts_builtin_sym_end] = ACTIONS(1873),
    [sym_identifier] = ACTIONS(1875),
    [anon_sym_export] = ACTIONS(1875),
    [anon_sym_default] = ACTIONS(1875),
    [anon_sym_namespace] = ACTIONS(1875),
    [anon_sym_LBRACE] = ACTIONS(1873),
    [anon_sym_RBRACE] = ACTIONS(1873),
    [anon_sym_type] = ACTIONS(1875),
    [anon_sym_typeof] = ACTIONS(1875),
    [anon_sym_import] = ACTIONS(1875),
    [anon_sym_var] = ACTIONS(1875),
    [anon_sym_let] = ACTIONS(1875),
    [anon_sym_const] = ACTIONS(1875),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_else] = ACTIONS(1875),
    [anon_sym_if] = ACTIONS(1875),
    [anon_sym_switch] = ACTIONS(1875),
    [anon_sym_for] = ACTIONS(1875),
    [anon_sym_LPAREN] = ACTIONS(1873),
    [anon_sym_await] = ACTIONS(1875),
    [anon_sym_while] = ACTIONS(1875),
    [anon_sym_do] = ACTIONS(1875),
    [anon_sym_try] = ACTIONS(1875),
    [anon_sym_with] = ACTIONS(1875),
    [anon_sym_break] = ACTIONS(1875),
    [anon_sym_continue] = ACTIONS(1875),
    [anon_sym_debugger] = ACTIONS(1875),
    [anon_sym_return] = ACTIONS(1875),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_SEMI] = ACTIONS(1873),
    [anon_sym_case] = ACTIONS(1875),
    [anon_sym_yield] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1873),
    [anon_sym_LT] = ACTIONS(1873),
    [anon_sym_SLASH] = ACTIONS(1875),
    [anon_sym_class] = ACTIONS(1875),
    [anon_sym_async] = ACTIONS(1875),
    [anon_sym_function] = ACTIONS(1875),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_PLUS] = ACTIONS(1875),
    [anon_sym_DASH] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1873),
    [anon_sym_void] = ACTIONS(1875),
    [anon_sym_delete] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1873),
    [anon_sym_DASH_DASH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1873),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1873),
    [sym_number] = ACTIONS(1873),
    [sym_this] = ACTIONS(1875),
    [sym_super] = ACTIONS(1875),
    [sym_true] = ACTIONS(1875),
    [sym_false] = ACTIONS(1875),
    [sym_null] = ACTIONS(1875),
    [sym_undefined] = ACTIONS(1875),
    [anon_sym_AT] = ACTIONS(1873),
    [anon_sym_declare] = ACTIONS(1875),
    [anon_sym_static] = ACTIONS(1875),
    [anon_sym_readonly] = ACTIONS(1875),
    [anon_sym_abstract] = ACTIONS(1875),
    [anon_sym_get] = ACTIONS(1875),
    [anon_sym_set] = ACTIONS(1875),
    [anon_sym_public] = ACTIONS(1875),
    [anon_sym_private] = ACTIONS(1875),
    [anon_sym_protected] = ACTIONS(1875),
    [anon_sym_module] = ACTIONS(1875),
    [anon_sym_any] = ACTIONS(1875),
    [anon_sym_number] = ACTIONS(1875),
    [anon_sym_boolean] = ACTIONS(1875),
    [anon_sym_string] = ACTIONS(1875),
    [anon_sym_symbol] = ACTIONS(1875),
    [anon_sym_interface] = ACTIONS(1875),
    [anon_sym_enum] = ACTIONS(1875),
    [sym__automatic_semicolon] = ACTIONS(1881),
  },
  [1047] = {
    [ts_builtin_sym_end] = ACTIONS(2044),
    [sym_identifier] = ACTIONS(2046),
    [anon_sym_export] = ACTIONS(2046),
    [anon_sym_default] = ACTIONS(2046),
    [anon_sym_namespace] = ACTIONS(2046),
    [anon_sym_LBRACE] = ACTIONS(2044),
    [anon_sym_RBRACE] = ACTIONS(2044),
    [anon_sym_type] = ACTIONS(2046),
    [anon_sym_typeof] = ACTIONS(2046),
    [anon_sym_import] = ACTIONS(2046),
    [anon_sym_var] = ACTIONS(2046),
    [anon_sym_let] = ACTIONS(2046),
    [anon_sym_const] = ACTIONS(2046),
    [anon_sym_BANG] = ACTIONS(2044),
    [anon_sym_else] = ACTIONS(2046),
    [anon_sym_if] = ACTIONS(2046),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_for] = ACTIONS(2046),
    [anon_sym_LPAREN] = ACTIONS(2044),
    [anon_sym_await] = ACTIONS(2046),
    [anon_sym_while] = ACTIONS(2046),
    [anon_sym_do] = ACTIONS(2046),
    [anon_sym_try] = ACTIONS(2046),
    [anon_sym_with] = ACTIONS(2046),
    [anon_sym_break] = ACTIONS(2046),
    [anon_sym_continue] = ACTIONS(2046),
    [anon_sym_debugger] = ACTIONS(2046),
    [anon_sym_return] = ACTIONS(2046),
    [anon_sym_throw] = ACTIONS(2046),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym_case] = ACTIONS(2046),
    [anon_sym_yield] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(2044),
    [anon_sym_LT] = ACTIONS(2044),
    [anon_sym_SLASH] = ACTIONS(2046),
    [anon_sym_class] = ACTIONS(2046),
    [anon_sym_async] = ACTIONS(2046),
    [anon_sym_function] = ACTIONS(2046),
    [anon_sym_new] = ACTIONS(2046),
    [anon_sym_PLUS] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2044),
    [anon_sym_void] = ACTIONS(2046),
    [anon_sym_delete] = ACTIONS(2046),
    [anon_sym_PLUS_PLUS] = ACTIONS(2044),
    [anon_sym_DASH_DASH] = ACTIONS(2044),
    [anon_sym_DQUOTE] = ACTIONS(2044),
    [anon_sym_SQUOTE] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2044),
    [sym_number] = ACTIONS(2044),
    [sym_this] = ACTIONS(2046),
    [sym_super] = ACTIONS(2046),
    [sym_true] = ACTIONS(2046),
    [sym_false] = ACTIONS(2046),
    [sym_null] = ACTIONS(2046),
    [sym_undefined] = ACTIONS(2046),
    [anon_sym_AT] = ACTIONS(2044),
    [anon_sym_declare] = ACTIONS(2046),
    [anon_sym_static] = ACTIONS(2046),
    [anon_sym_readonly] = ACTIONS(2046),
    [anon_sym_abstract] = ACTIONS(2046),
    [anon_sym_get] = ACTIONS(2046),
    [anon_sym_set] = ACTIONS(2046),
    [anon_sym_public] = ACTIONS(2046),
    [anon_sym_private] = ACTIONS(2046),
    [anon_sym_protected] = ACTIONS(2046),
    [anon_sym_module] = ACTIONS(2046),
    [anon_sym_any] = ACTIONS(2046),
    [anon_sym_number] = ACTIONS(2046),
    [anon_sym_boolean] = ACTIONS(2046),
    [anon_sym_string] = ACTIONS(2046),
    [anon_sym_symbol] = ACTIONS(2046),
    [anon_sym_interface] = ACTIONS(2046),
    [anon_sym_enum] = ACTIONS(2046),
    [sym__automatic_semicolon] = ACTIONS(2052),
  },
  [1048] = {
    [ts_builtin_sym_end] = ACTIONS(1927),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_export] = ACTIONS(1929),
    [anon_sym_default] = ACTIONS(1929),
    [anon_sym_namespace] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(1927),
    [anon_sym_type] = ACTIONS(1929),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_import] = ACTIONS(1929),
    [anon_sym_var] = ACTIONS(1929),
    [anon_sym_let] = ACTIONS(1929),
    [anon_sym_const] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_else] = ACTIONS(1929),
    [anon_sym_if] = ACTIONS(1929),
    [anon_sym_switch] = ACTIONS(1929),
    [anon_sym_for] = ACTIONS(1929),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_await] = ACTIONS(1929),
    [anon_sym_while] = ACTIONS(1929),
    [anon_sym_do] = ACTIONS(1929),
    [anon_sym_try] = ACTIONS(1929),
    [anon_sym_with] = ACTIONS(1929),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_continue] = ACTIONS(1929),
    [anon_sym_debugger] = ACTIONS(1929),
    [anon_sym_return] = ACTIONS(1929),
    [anon_sym_throw] = ACTIONS(1929),
    [anon_sym_SEMI] = ACTIONS(1927),
    [anon_sym_case] = ACTIONS(1929),
    [anon_sym_yield] = ACTIONS(1929),
    [anon_sym_LBRACK] = ACTIONS(1927),
    [anon_sym_LT] = ACTIONS(1927),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_class] = ACTIONS(1929),
    [anon_sym_async] = ACTIONS(1929),
    [anon_sym_function] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1929),
    [anon_sym_PLUS] = ACTIONS(1929),
    [anon_sym_DASH] = ACTIONS(1929),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_void] = ACTIONS(1929),
    [anon_sym_delete] = ACTIONS(1929),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_DQUOTE] = ACTIONS(1927),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1927),
    [sym_number] = ACTIONS(1927),
    [sym_this] = ACTIONS(1929),
    [sym_super] = ACTIONS(1929),
    [sym_true] = ACTIONS(1929),
    [sym_false] = ACTIONS(1929),
    [sym_null] = ACTIONS(1929),
    [sym_undefined] = ACTIONS(1929),
    [anon_sym_AT] = ACTIONS(1927),
    [anon_sym_declare] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1929),
    [anon_sym_readonly] = ACTIONS(1929),
    [anon_sym_abstract] = ACTIONS(1929),
    [anon_sym_get] = ACTIONS(1929),
    [anon_sym_set] = ACTIONS(1929),
    [anon_sym_public] = ACTIONS(1929),
    [anon_sym_private] = ACTIONS(1929),
    [anon_sym_protected] = ACTIONS(1929),
    [anon_sym_module] = ACTIONS(1929),
    [anon_sym_any] = ACTIONS(1929),
    [anon_sym_number] = ACTIONS(1929),
    [anon_sym_boolean] = ACTIONS(1929),
    [anon_sym_string] = ACTIONS(1929),
    [anon_sym_symbol] = ACTIONS(1929),
    [anon_sym_interface] = ACTIONS(1929),
    [anon_sym_enum] = ACTIONS(1929),
    [sym__automatic_semicolon] = ACTIONS(1935),
  },
  [1049] = {
    [ts_builtin_sym_end] = ACTIONS(2068),
    [sym_identifier] = ACTIONS(2070),
    [anon_sym_export] = ACTIONS(2070),
    [anon_sym_default] = ACTIONS(2070),
    [anon_sym_namespace] = ACTIONS(2070),
    [anon_sym_LBRACE] = ACTIONS(2068),
    [anon_sym_RBRACE] = ACTIONS(2068),
    [anon_sym_type] = ACTIONS(2070),
    [anon_sym_typeof] = ACTIONS(2070),
    [anon_sym_import] = ACTIONS(2070),
    [anon_sym_var] = ACTIONS(2070),
    [anon_sym_let] = ACTIONS(2070),
    [anon_sym_const] = ACTIONS(2070),
    [anon_sym_BANG] = ACTIONS(2068),
    [anon_sym_else] = ACTIONS(2070),
    [anon_sym_if] = ACTIONS(2070),
    [anon_sym_switch] = ACTIONS(2070),
    [anon_sym_for] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(2068),
    [anon_sym_await] = ACTIONS(2070),
    [anon_sym_while] = ACTIONS(2070),
    [anon_sym_do] = ACTIONS(2070),
    [anon_sym_try] = ACTIONS(2070),
    [anon_sym_with] = ACTIONS(2070),
    [anon_sym_break] = ACTIONS(2070),
    [anon_sym_continue] = ACTIONS(2070),
    [anon_sym_debugger] = ACTIONS(2070),
    [anon_sym_return] = ACTIONS(2070),
    [anon_sym_throw] = ACTIONS(2070),
    [anon_sym_SEMI] = ACTIONS(2068),
    [anon_sym_case] = ACTIONS(2070),
    [anon_sym_yield] = ACTIONS(2070),
    [anon_sym_LBRACK] = ACTIONS(2068),
    [anon_sym_LT] = ACTIONS(2068),
    [anon_sym_SLASH] = ACTIONS(2070),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_async] = ACTIONS(2070),
    [anon_sym_function] = ACTIONS(2070),
    [anon_sym_new] = ACTIONS(2070),
    [anon_sym_PLUS] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2070),
    [anon_sym_TILDE] = ACTIONS(2068),
    [anon_sym_void] = ACTIONS(2070),
    [anon_sym_delete] = ACTIONS(2070),
    [anon_sym_PLUS_PLUS] = ACTIONS(2068),
    [anon_sym_DASH_DASH] = ACTIONS(2068),
    [anon_sym_DQUOTE] = ACTIONS(2068),
    [anon_sym_SQUOTE] = ACTIONS(2068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2068),
    [sym_number] = ACTIONS(2068),
    [sym_this] = ACTIONS(2070),
    [sym_super] = ACTIONS(2070),
    [sym_true] = ACTIONS(2070),
    [sym_false] = ACTIONS(2070),
    [sym_null] = ACTIONS(2070),
    [sym_undefined] = ACTIONS(2070),
    [anon_sym_AT] = ACTIONS(2068),
    [anon_sym_declare] = ACTIONS(2070),
    [anon_sym_static] = ACTIONS(2070),
    [anon_sym_readonly] = ACTIONS(2070),
    [anon_sym_abstract] = ACTIONS(2070),
    [anon_sym_get] = ACTIONS(2070),
    [anon_sym_set] = ACTIONS(2070),
    [anon_sym_public] = ACTIONS(2070),
    [anon_sym_private] = ACTIONS(2070),
    [anon_sym_protected] = ACTIONS(2070),
    [anon_sym_module] = ACTIONS(2070),
    [anon_sym_any] = ACTIONS(2070),
    [anon_sym_number] = ACTIONS(2070),
    [anon_sym_boolean] = ACTIONS(2070),
    [anon_sym_string] = ACTIONS(2070),
    [anon_sym_symbol] = ACTIONS(2070),
    [anon_sym_interface] = ACTIONS(2070),
    [anon_sym_enum] = ACTIONS(2070),
    [sym__automatic_semicolon] = ACTIONS(2076),
  },
  [1050] = {
    [ts_builtin_sym_end] = ACTIONS(2064),
    [sym_identifier] = ACTIONS(2066),
    [anon_sym_export] = ACTIONS(2066),
    [anon_sym_default] = ACTIONS(2066),
    [anon_sym_namespace] = ACTIONS(2066),
    [anon_sym_LBRACE] = ACTIONS(2064),
    [anon_sym_RBRACE] = ACTIONS(2064),
    [anon_sym_type] = ACTIONS(2066),
    [anon_sym_typeof] = ACTIONS(2066),
    [anon_sym_import] = ACTIONS(2066),
    [anon_sym_var] = ACTIONS(2066),
    [anon_sym_let] = ACTIONS(2066),
    [anon_sym_const] = ACTIONS(2066),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_else] = ACTIONS(2066),
    [anon_sym_if] = ACTIONS(2066),
    [anon_sym_switch] = ACTIONS(2066),
    [anon_sym_for] = ACTIONS(2066),
    [anon_sym_LPAREN] = ACTIONS(2064),
    [anon_sym_await] = ACTIONS(2066),
    [anon_sym_while] = ACTIONS(2066),
    [anon_sym_do] = ACTIONS(2066),
    [anon_sym_try] = ACTIONS(2066),
    [anon_sym_with] = ACTIONS(2066),
    [anon_sym_break] = ACTIONS(2066),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_debugger] = ACTIONS(2066),
    [anon_sym_return] = ACTIONS(2066),
    [anon_sym_throw] = ACTIONS(2066),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_case] = ACTIONS(2066),
    [anon_sym_yield] = ACTIONS(2066),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_DOT] = ACTIONS(2066),
    [anon_sym_class] = ACTIONS(2066),
    [anon_sym_async] = ACTIONS(2066),
    [anon_sym_function] = ACTIONS(2066),
    [anon_sym_new] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(2066),
    [anon_sym_DASH] = ACTIONS(2066),
    [anon_sym_TILDE] = ACTIONS(2064),
    [anon_sym_void] = ACTIONS(2066),
    [anon_sym_delete] = ACTIONS(2066),
    [anon_sym_PLUS_PLUS] = ACTIONS(2064),
    [anon_sym_DASH_DASH] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(2064),
    [anon_sym_SQUOTE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2064),
    [sym_number] = ACTIONS(2064),
    [sym_this] = ACTIONS(2066),
    [sym_super] = ACTIONS(2066),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_undefined] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(2064),
    [anon_sym_declare] = ACTIONS(2066),
    [anon_sym_static] = ACTIONS(2066),
    [anon_sym_readonly] = ACTIONS(2066),
    [anon_sym_abstract] = ACTIONS(2066),
    [anon_sym_get] = ACTIONS(2066),
    [anon_sym_set] = ACTIONS(2066),
    [anon_sym_public] = ACTIONS(2066),
    [anon_sym_private] = ACTIONS(2066),
    [anon_sym_protected] = ACTIONS(2066),
    [anon_sym_module] = ACTIONS(2066),
    [anon_sym_any] = ACTIONS(2066),
    [anon_sym_number] = ACTIONS(2066),
    [anon_sym_boolean] = ACTIONS(2066),
    [anon_sym_string] = ACTIONS(2066),
    [anon_sym_symbol] = ACTIONS(2066),
    [anon_sym_interface] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2066),
  },
  [1051] = {
    [ts_builtin_sym_end] = ACTIONS(1951),
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_export] = ACTIONS(1953),
    [anon_sym_default] = ACTIONS(1953),
    [anon_sym_namespace] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1951),
    [anon_sym_RBRACE] = ACTIONS(1951),
    [anon_sym_type] = ACTIONS(1953),
    [anon_sym_typeof] = ACTIONS(1953),
    [anon_sym_import] = ACTIONS(1953),
    [anon_sym_var] = ACTIONS(1953),
    [anon_sym_let] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_switch] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1951),
    [anon_sym_await] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_try] = ACTIONS(1953),
    [anon_sym_with] = ACTIONS(1953),
    [anon_sym_break] = ACTIONS(1953),
    [anon_sym_continue] = ACTIONS(1953),
    [anon_sym_debugger] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_throw] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1953),
    [anon_sym_yield] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_LT] = ACTIONS(1951),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_class] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_function] = ACTIONS(1953),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_void] = ACTIONS(1953),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_DQUOTE] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1951),
    [sym_number] = ACTIONS(1951),
    [sym_this] = ACTIONS(1953),
    [sym_super] = ACTIONS(1953),
    [sym_true] = ACTIONS(1953),
    [sym_false] = ACTIONS(1953),
    [sym_null] = ACTIONS(1953),
    [sym_undefined] = ACTIONS(1953),
    [anon_sym_AT] = ACTIONS(1951),
    [anon_sym_declare] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_readonly] = ACTIONS(1953),
    [anon_sym_abstract] = ACTIONS(1953),
    [anon_sym_get] = ACTIONS(1953),
    [anon_sym_set] = ACTIONS(1953),
    [anon_sym_public] = ACTIONS(1953),
    [anon_sym_private] = ACTIONS(1953),
    [anon_sym_protected] = ACTIONS(1953),
    [anon_sym_module] = ACTIONS(1953),
    [anon_sym_any] = ACTIONS(1953),
    [anon_sym_number] = ACTIONS(1953),
    [anon_sym_boolean] = ACTIONS(1953),
    [anon_sym_string] = ACTIONS(1953),
    [anon_sym_symbol] = ACTIONS(1953),
    [anon_sym_interface] = ACTIONS(1953),
    [anon_sym_enum] = ACTIONS(1953),
    [sym__automatic_semicolon] = ACTIONS(1959),
  },
  [1052] = {
    [ts_builtin_sym_end] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2003),
    [anon_sym_export] = ACTIONS(2003),
    [anon_sym_default] = ACTIONS(2003),
    [anon_sym_namespace] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_type] = ACTIONS(2003),
    [anon_sym_typeof] = ACTIONS(2003),
    [anon_sym_import] = ACTIONS(2003),
    [anon_sym_var] = ACTIONS(2003),
    [anon_sym_let] = ACTIONS(2003),
    [anon_sym_const] = ACTIONS(2003),
    [anon_sym_BANG] = ACTIONS(2001),
    [anon_sym_else] = ACTIONS(2003),
    [anon_sym_if] = ACTIONS(2003),
    [anon_sym_switch] = ACTIONS(2003),
    [anon_sym_for] = ACTIONS(2003),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_await] = ACTIONS(2003),
    [anon_sym_while] = ACTIONS(2003),
    [anon_sym_do] = ACTIONS(2003),
    [anon_sym_try] = ACTIONS(2003),
    [anon_sym_with] = ACTIONS(2003),
    [anon_sym_break] = ACTIONS(2003),
    [anon_sym_continue] = ACTIONS(2003),
    [anon_sym_debugger] = ACTIONS(2003),
    [anon_sym_return] = ACTIONS(2003),
    [anon_sym_throw] = ACTIONS(2003),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_case] = ACTIONS(2003),
    [anon_sym_yield] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2001),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_class] = ACTIONS(2003),
    [anon_sym_async] = ACTIONS(2003),
    [anon_sym_function] = ACTIONS(2003),
    [anon_sym_new] = ACTIONS(2003),
    [anon_sym_PLUS] = ACTIONS(2003),
    [anon_sym_DASH] = ACTIONS(2003),
    [anon_sym_TILDE] = ACTIONS(2001),
    [anon_sym_void] = ACTIONS(2003),
    [anon_sym_delete] = ACTIONS(2003),
    [anon_sym_PLUS_PLUS] = ACTIONS(2001),
    [anon_sym_DASH_DASH] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2001),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_super] = ACTIONS(2003),
    [sym_true] = ACTIONS(2003),
    [sym_false] = ACTIONS(2003),
    [sym_null] = ACTIONS(2003),
    [sym_undefined] = ACTIONS(2003),
    [anon_sym_AT] = ACTIONS(2001),
    [anon_sym_declare] = ACTIONS(2003),
    [anon_sym_static] = ACTIONS(2003),
    [anon_sym_readonly] = ACTIONS(2003),
    [anon_sym_abstract] = ACTIONS(2003),
    [anon_sym_get] = ACTIONS(2003),
    [anon_sym_set] = ACTIONS(2003),
    [anon_sym_public] = ACTIONS(2003),
    [anon_sym_private] = ACTIONS(2003),
    [anon_sym_protected] = ACTIONS(2003),
    [anon_sym_module] = ACTIONS(2003),
    [anon_sym_any] = ACTIONS(2003),
    [anon_sym_number] = ACTIONS(2003),
    [anon_sym_boolean] = ACTIONS(2003),
    [anon_sym_string] = ACTIONS(2003),
    [anon_sym_symbol] = ACTIONS(2003),
    [anon_sym_interface] = ACTIONS(2003),
    [anon_sym_enum] = ACTIONS(2003),
    [sym__automatic_semicolon] = ACTIONS(2009),
  },
  [1053] = {
    [ts_builtin_sym_end] = ACTIONS(2024),
    [sym_identifier] = ACTIONS(2026),
    [anon_sym_export] = ACTIONS(2026),
    [anon_sym_default] = ACTIONS(2026),
    [anon_sym_namespace] = ACTIONS(2026),
    [anon_sym_LBRACE] = ACTIONS(2024),
    [anon_sym_RBRACE] = ACTIONS(2024),
    [anon_sym_type] = ACTIONS(2026),
    [anon_sym_typeof] = ACTIONS(2026),
    [anon_sym_import] = ACTIONS(2026),
    [anon_sym_var] = ACTIONS(2026),
    [anon_sym_let] = ACTIONS(2026),
    [anon_sym_const] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(2024),
    [anon_sym_else] = ACTIONS(2026),
    [anon_sym_if] = ACTIONS(2026),
    [anon_sym_switch] = ACTIONS(2026),
    [anon_sym_for] = ACTIONS(2026),
    [anon_sym_LPAREN] = ACTIONS(2024),
    [anon_sym_await] = ACTIONS(2026),
    [anon_sym_while] = ACTIONS(2026),
    [anon_sym_do] = ACTIONS(2026),
    [anon_sym_try] = ACTIONS(2026),
    [anon_sym_with] = ACTIONS(2026),
    [anon_sym_break] = ACTIONS(2026),
    [anon_sym_continue] = ACTIONS(2026),
    [anon_sym_debugger] = ACTIONS(2026),
    [anon_sym_return] = ACTIONS(2026),
    [anon_sym_throw] = ACTIONS(2026),
    [anon_sym_SEMI] = ACTIONS(2024),
    [anon_sym_case] = ACTIONS(2026),
    [anon_sym_yield] = ACTIONS(2026),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2026),
    [anon_sym_class] = ACTIONS(2026),
    [anon_sym_async] = ACTIONS(2026),
    [anon_sym_function] = ACTIONS(2026),
    [anon_sym_new] = ACTIONS(2026),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_TILDE] = ACTIONS(2024),
    [anon_sym_void] = ACTIONS(2026),
    [anon_sym_delete] = ACTIONS(2026),
    [anon_sym_PLUS_PLUS] = ACTIONS(2024),
    [anon_sym_DASH_DASH] = ACTIONS(2024),
    [anon_sym_DQUOTE] = ACTIONS(2024),
    [anon_sym_SQUOTE] = ACTIONS(2024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2024),
    [sym_number] = ACTIONS(2024),
    [sym_this] = ACTIONS(2026),
    [sym_super] = ACTIONS(2026),
    [sym_true] = ACTIONS(2026),
    [sym_false] = ACTIONS(2026),
    [sym_null] = ACTIONS(2026),
    [sym_undefined] = ACTIONS(2026),
    [anon_sym_AT] = ACTIONS(2024),
    [anon_sym_declare] = ACTIONS(2026),
    [anon_sym_static] = ACTIONS(2026),
    [anon_sym_readonly] = ACTIONS(2026),
    [anon_sym_abstract] = ACTIONS(2026),
    [anon_sym_get] = ACTIONS(2026),
    [anon_sym_set] = ACTIONS(2026),
    [anon_sym_public] = ACTIONS(2026),
    [anon_sym_private] = ACTIONS(2026),
    [anon_sym_protected] = ACTIONS(2026),
    [anon_sym_module] = ACTIONS(2026),
    [anon_sym_any] = ACTIONS(2026),
    [anon_sym_number] = ACTIONS(2026),
    [anon_sym_boolean] = ACTIONS(2026),
    [anon_sym_string] = ACTIONS(2026),
    [anon_sym_symbol] = ACTIONS(2026),
    [anon_sym_interface] = ACTIONS(2026),
    [anon_sym_enum] = ACTIONS(2026),
    [sym__automatic_semicolon] = ACTIONS(2032),
  },
  [1054] = {
    [ts_builtin_sym_end] = ACTIONS(1911),
    [sym_identifier] = ACTIONS(1913),
    [anon_sym_export] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_type] = ACTIONS(1913),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_import] = ACTIONS(1913),
    [anon_sym_var] = ACTIONS(1913),
    [anon_sym_let] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [anon_sym_await] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_with] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_debugger] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_yield] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1911),
    [anon_sym_LT] = ACTIONS(1911),
    [anon_sym_SLASH] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_async] = ACTIONS(1913),
    [anon_sym_function] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_void] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1911),
    [sym_number] = ACTIONS(1911),
    [sym_this] = ACTIONS(1913),
    [sym_super] = ACTIONS(1913),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [sym_undefined] = ACTIONS(1913),
    [anon_sym_AT] = ACTIONS(1911),
    [anon_sym_declare] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_readonly] = ACTIONS(1913),
    [anon_sym_abstract] = ACTIONS(1913),
    [anon_sym_get] = ACTIONS(1913),
    [anon_sym_set] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_module] = ACTIONS(1913),
    [anon_sym_any] = ACTIONS(1913),
    [anon_sym_number] = ACTIONS(1913),
    [anon_sym_boolean] = ACTIONS(1913),
    [anon_sym_string] = ACTIONS(1913),
    [anon_sym_symbol] = ACTIONS(1913),
    [anon_sym_interface] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [sym__automatic_semicolon] = ACTIONS(1919),
  },
  [1055] = {
    [ts_builtin_sym_end] = ACTIONS(2034),
    [sym_identifier] = ACTIONS(2036),
    [anon_sym_export] = ACTIONS(2036),
    [anon_sym_default] = ACTIONS(2036),
    [anon_sym_namespace] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_RBRACE] = ACTIONS(2034),
    [anon_sym_type] = ACTIONS(2036),
    [anon_sym_typeof] = ACTIONS(2036),
    [anon_sym_import] = ACTIONS(2036),
    [anon_sym_var] = ACTIONS(2036),
    [anon_sym_let] = ACTIONS(2036),
    [anon_sym_const] = ACTIONS(2036),
    [anon_sym_BANG] = ACTIONS(2034),
    [anon_sym_else] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2036),
    [anon_sym_switch] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(2036),
    [anon_sym_LPAREN] = ACTIONS(2034),
    [anon_sym_await] = ACTIONS(2036),
    [anon_sym_while] = ACTIONS(2036),
    [anon_sym_do] = ACTIONS(2036),
    [anon_sym_try] = ACTIONS(2036),
    [anon_sym_with] = ACTIONS(2036),
    [anon_sym_break] = ACTIONS(2036),
    [anon_sym_continue] = ACTIONS(2036),
    [anon_sym_debugger] = ACTIONS(2036),
    [anon_sym_return] = ACTIONS(2036),
    [anon_sym_throw] = ACTIONS(2036),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_case] = ACTIONS(2036),
    [anon_sym_yield] = ACTIONS(2036),
    [anon_sym_LBRACK] = ACTIONS(2034),
    [anon_sym_LT] = ACTIONS(2034),
    [anon_sym_SLASH] = ACTIONS(2036),
    [anon_sym_class] = ACTIONS(2036),
    [anon_sym_async] = ACTIONS(2036),
    [anon_sym_function] = ACTIONS(2036),
    [anon_sym_new] = ACTIONS(2036),
    [anon_sym_PLUS] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2036),
    [anon_sym_TILDE] = ACTIONS(2034),
    [anon_sym_void] = ACTIONS(2036),
    [anon_sym_delete] = ACTIONS(2036),
    [anon_sym_PLUS_PLUS] = ACTIONS(2034),
    [anon_sym_DASH_DASH] = ACTIONS(2034),
    [anon_sym_DQUOTE] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(2034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2034),
    [sym_number] = ACTIONS(2034),
    [sym_this] = ACTIONS(2036),
    [sym_super] = ACTIONS(2036),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [sym_null] = ACTIONS(2036),
    [sym_undefined] = ACTIONS(2036),
    [anon_sym_AT] = ACTIONS(2034),
    [anon_sym_declare] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2036),
    [anon_sym_readonly] = ACTIONS(2036),
    [anon_sym_abstract] = ACTIONS(2036),
    [anon_sym_get] = ACTIONS(2036),
    [anon_sym_set] = ACTIONS(2036),
    [anon_sym_public] = ACTIONS(2036),
    [anon_sym_private] = ACTIONS(2036),
    [anon_sym_protected] = ACTIONS(2036),
    [anon_sym_module] = ACTIONS(2036),
    [anon_sym_any] = ACTIONS(2036),
    [anon_sym_number] = ACTIONS(2036),
    [anon_sym_boolean] = ACTIONS(2036),
    [anon_sym_string] = ACTIONS(2036),
    [anon_sym_symbol] = ACTIONS(2036),
    [anon_sym_interface] = ACTIONS(2036),
    [anon_sym_enum] = ACTIONS(2036),
    [sym__automatic_semicolon] = ACTIONS(2042),
  },
  [1056] = {
    [ts_builtin_sym_end] = ACTIONS(2967),
    [sym_identifier] = ACTIONS(2969),
    [anon_sym_export] = ACTIONS(2969),
    [anon_sym_default] = ACTIONS(2969),
    [anon_sym_namespace] = ACTIONS(2969),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_type] = ACTIONS(2969),
    [anon_sym_typeof] = ACTIONS(2969),
    [anon_sym_import] = ACTIONS(2969),
    [anon_sym_var] = ACTIONS(2969),
    [anon_sym_let] = ACTIONS(2969),
    [anon_sym_const] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2969),
    [anon_sym_switch] = ACTIONS(2969),
    [anon_sym_for] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_await] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2969),
    [anon_sym_try] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [anon_sym_break] = ACTIONS(2969),
    [anon_sym_continue] = ACTIONS(2969),
    [anon_sym_debugger] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2969),
    [anon_sym_throw] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_case] = ACTIONS(2969),
    [anon_sym_finally] = ACTIONS(2969),
    [anon_sym_yield] = ACTIONS(2969),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_class] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(2969),
    [anon_sym_function] = ACTIONS(2969),
    [anon_sym_new] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2969),
    [anon_sym_DASH] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2967),
    [anon_sym_void] = ACTIONS(2969),
    [anon_sym_delete] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2967),
    [sym_number] = ACTIONS(2967),
    [sym_this] = ACTIONS(2969),
    [sym_super] = ACTIONS(2969),
    [sym_true] = ACTIONS(2969),
    [sym_false] = ACTIONS(2969),
    [sym_null] = ACTIONS(2969),
    [sym_undefined] = ACTIONS(2969),
    [anon_sym_AT] = ACTIONS(2967),
    [anon_sym_declare] = ACTIONS(2969),
    [anon_sym_static] = ACTIONS(2969),
    [anon_sym_readonly] = ACTIONS(2969),
    [anon_sym_abstract] = ACTIONS(2969),
    [anon_sym_get] = ACTIONS(2969),
    [anon_sym_set] = ACTIONS(2969),
    [anon_sym_public] = ACTIONS(2969),
    [anon_sym_private] = ACTIONS(2969),
    [anon_sym_protected] = ACTIONS(2969),
    [anon_sym_module] = ACTIONS(2969),
    [anon_sym_any] = ACTIONS(2969),
    [anon_sym_number] = ACTIONS(2969),
    [anon_sym_boolean] = ACTIONS(2969),
    [anon_sym_string] = ACTIONS(2969),
    [anon_sym_symbol] = ACTIONS(2969),
    [anon_sym_interface] = ACTIONS(2969),
    [anon_sym_enum] = ACTIONS(2969),
  },
  [1057] = {
    [ts_builtin_sym_end] = ACTIONS(1965),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_export] = ACTIONS(1967),
    [anon_sym_default] = ACTIONS(1967),
    [anon_sym_namespace] = ACTIONS(1967),
    [anon_sym_LBRACE] = ACTIONS(1965),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_type] = ACTIONS(1967),
    [anon_sym_typeof] = ACTIONS(1967),
    [anon_sym_import] = ACTIONS(1967),
    [anon_sym_var] = ACTIONS(1967),
    [anon_sym_let] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_else] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1965),
    [anon_sym_await] = ACTIONS(1967),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_try] = ACTIONS(1967),
    [anon_sym_with] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_debugger] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_throw] = ACTIONS(1967),
    [anon_sym_SEMI] = ACTIONS(1965),
    [anon_sym_case] = ACTIONS(1967),
    [anon_sym_yield] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(1965),
    [anon_sym_SLASH] = ACTIONS(1967),
    [anon_sym_class] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(1967),
    [anon_sym_function] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1965),
    [anon_sym_void] = ACTIONS(1967),
    [anon_sym_delete] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1965),
    [sym_number] = ACTIONS(1965),
    [sym_this] = ACTIONS(1967),
    [sym_super] = ACTIONS(1967),
    [sym_true] = ACTIONS(1967),
    [sym_false] = ACTIONS(1967),
    [sym_null] = ACTIONS(1967),
    [sym_undefined] = ACTIONS(1967),
    [anon_sym_AT] = ACTIONS(1965),
    [anon_sym_declare] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_readonly] = ACTIONS(1967),
    [anon_sym_abstract] = ACTIONS(1967),
    [anon_sym_get] = ACTIONS(1967),
    [anon_sym_set] = ACTIONS(1967),
    [anon_sym_public] = ACTIONS(1967),
    [anon_sym_private] = ACTIONS(1967),
    [anon_sym_protected] = ACTIONS(1967),
    [anon_sym_module] = ACTIONS(1967),
    [anon_sym_any] = ACTIONS(1967),
    [anon_sym_number] = ACTIONS(1967),
    [anon_sym_boolean] = ACTIONS(1967),
    [anon_sym_string] = ACTIONS(1967),
    [anon_sym_symbol] = ACTIONS(1967),
    [anon_sym_interface] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [sym__automatic_semicolon] = ACTIONS(1973),
  },
  [1058] = {
    [sym_statement_block] = STATE(1139),
    [ts_builtin_sym_end] = ACTIONS(1857),
    [sym_identifier] = ACTIONS(1859),
    [anon_sym_export] = ACTIONS(1859),
    [anon_sym_default] = ACTIONS(1859),
    [anon_sym_namespace] = ACTIONS(1859),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_RBRACE] = ACTIONS(1857),
    [anon_sym_type] = ACTIONS(1859),
    [anon_sym_typeof] = ACTIONS(1859),
    [anon_sym_import] = ACTIONS(1859),
    [anon_sym_var] = ACTIONS(1859),
    [anon_sym_let] = ACTIONS(1859),
    [anon_sym_const] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_else] = ACTIONS(1859),
    [anon_sym_if] = ACTIONS(1859),
    [anon_sym_switch] = ACTIONS(1859),
    [anon_sym_for] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_while] = ACTIONS(1859),
    [anon_sym_do] = ACTIONS(1859),
    [anon_sym_try] = ACTIONS(1859),
    [anon_sym_with] = ACTIONS(1859),
    [anon_sym_break] = ACTIONS(1859),
    [anon_sym_continue] = ACTIONS(1859),
    [anon_sym_debugger] = ACTIONS(1859),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_throw] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_case] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_SLASH] = ACTIONS(1859),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_async] = ACTIONS(1859),
    [anon_sym_function] = ACTIONS(1859),
    [anon_sym_new] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_void] = ACTIONS(1859),
    [anon_sym_delete] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_DQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1857),
    [sym_number] = ACTIONS(1857),
    [sym_this] = ACTIONS(1859),
    [sym_super] = ACTIONS(1859),
    [sym_true] = ACTIONS(1859),
    [sym_false] = ACTIONS(1859),
    [sym_null] = ACTIONS(1859),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(1857),
    [anon_sym_declare] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1859),
    [anon_sym_readonly] = ACTIONS(1859),
    [anon_sym_abstract] = ACTIONS(1859),
    [anon_sym_get] = ACTIONS(1859),
    [anon_sym_set] = ACTIONS(1859),
    [anon_sym_public] = ACTIONS(1859),
    [anon_sym_private] = ACTIONS(1859),
    [anon_sym_protected] = ACTIONS(1859),
    [anon_sym_module] = ACTIONS(1859),
    [anon_sym_any] = ACTIONS(1859),
    [anon_sym_number] = ACTIONS(1859),
    [anon_sym_boolean] = ACTIONS(1859),
    [anon_sym_string] = ACTIONS(1859),
    [anon_sym_symbol] = ACTIONS(1859),
    [anon_sym_interface] = ACTIONS(1859),
    [anon_sym_enum] = ACTIONS(1859),
  },
  [1059] = {
    [ts_builtin_sym_end] = ACTIONS(1975),
    [sym_identifier] = ACTIONS(1977),
    [anon_sym_export] = ACTIONS(1977),
    [anon_sym_default] = ACTIONS(1977),
    [anon_sym_namespace] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1975),
    [anon_sym_RBRACE] = ACTIONS(1975),
    [anon_sym_type] = ACTIONS(1977),
    [anon_sym_typeof] = ACTIONS(1977),
    [anon_sym_import] = ACTIONS(1977),
    [anon_sym_var] = ACTIONS(1977),
    [anon_sym_let] = ACTIONS(1977),
    [anon_sym_const] = ACTIONS(1977),
    [anon_sym_BANG] = ACTIONS(1975),
    [anon_sym_else] = ACTIONS(1977),
    [anon_sym_if] = ACTIONS(1977),
    [anon_sym_switch] = ACTIONS(1977),
    [anon_sym_for] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(1975),
    [anon_sym_await] = ACTIONS(1977),
    [anon_sym_while] = ACTIONS(1977),
    [anon_sym_do] = ACTIONS(1977),
    [anon_sym_try] = ACTIONS(1977),
    [anon_sym_with] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1977),
    [anon_sym_continue] = ACTIONS(1977),
    [anon_sym_debugger] = ACTIONS(1977),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_throw] = ACTIONS(1977),
    [anon_sym_SEMI] = ACTIONS(1975),
    [anon_sym_case] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_SLASH] = ACTIONS(1977),
    [anon_sym_class] = ACTIONS(1977),
    [anon_sym_async] = ACTIONS(1977),
    [anon_sym_function] = ACTIONS(1977),
    [anon_sym_new] = ACTIONS(1977),
    [anon_sym_PLUS] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1975),
    [anon_sym_void] = ACTIONS(1977),
    [anon_sym_delete] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1975),
    [anon_sym_DQUOTE] = ACTIONS(1975),
    [anon_sym_SQUOTE] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1975),
    [sym_this] = ACTIONS(1977),
    [sym_super] = ACTIONS(1977),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_AT] = ACTIONS(1975),
    [anon_sym_declare] = ACTIONS(1977),
    [anon_sym_static] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1977),
    [anon_sym_abstract] = ACTIONS(1977),
    [anon_sym_get] = ACTIONS(1977),
    [anon_sym_set] = ACTIONS(1977),
    [anon_sym_public] = ACTIONS(1977),
    [anon_sym_private] = ACTIONS(1977),
    [anon_sym_protected] = ACTIONS(1977),
    [anon_sym_module] = ACTIONS(1977),
    [anon_sym_any] = ACTIONS(1977),
    [anon_sym_number] = ACTIONS(1977),
    [anon_sym_boolean] = ACTIONS(1977),
    [anon_sym_string] = ACTIONS(1977),
    [anon_sym_symbol] = ACTIONS(1977),
    [anon_sym_interface] = ACTIONS(1977),
    [anon_sym_enum] = ACTIONS(1977),
    [sym__automatic_semicolon] = ACTIONS(1983),
  },
  [1060] = {
    [ts_builtin_sym_end] = ACTIONS(2971),
    [sym_identifier] = ACTIONS(2973),
    [anon_sym_export] = ACTIONS(2973),
    [anon_sym_default] = ACTIONS(2973),
    [anon_sym_namespace] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2971),
    [anon_sym_RBRACE] = ACTIONS(2971),
    [anon_sym_type] = ACTIONS(2973),
    [anon_sym_typeof] = ACTIONS(2973),
    [anon_sym_import] = ACTIONS(2973),
    [anon_sym_var] = ACTIONS(2973),
    [anon_sym_let] = ACTIONS(2973),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2971),
    [anon_sym_else] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_switch] = ACTIONS(2973),
    [anon_sym_for] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_await] = ACTIONS(2973),
    [anon_sym_while] = ACTIONS(2973),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_try] = ACTIONS(2973),
    [anon_sym_with] = ACTIONS(2973),
    [anon_sym_break] = ACTIONS(2973),
    [anon_sym_continue] = ACTIONS(2973),
    [anon_sym_debugger] = ACTIONS(2973),
    [anon_sym_return] = ACTIONS(2973),
    [anon_sym_throw] = ACTIONS(2973),
    [anon_sym_SEMI] = ACTIONS(2971),
    [anon_sym_case] = ACTIONS(2973),
    [anon_sym_finally] = ACTIONS(2973),
    [anon_sym_yield] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_class] = ACTIONS(2973),
    [anon_sym_async] = ACTIONS(2973),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_new] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2971),
    [anon_sym_void] = ACTIONS(2973),
    [anon_sym_delete] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2971),
    [anon_sym_DASH_DASH] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2971),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2971),
    [sym_number] = ACTIONS(2971),
    [sym_this] = ACTIONS(2973),
    [sym_super] = ACTIONS(2973),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_null] = ACTIONS(2973),
    [sym_undefined] = ACTIONS(2973),
    [anon_sym_AT] = ACTIONS(2971),
    [anon_sym_declare] = ACTIONS(2973),
    [anon_sym_static] = ACTIONS(2973),
    [anon_sym_readonly] = ACTIONS(2973),
    [anon_sym_abstract] = ACTIONS(2973),
    [anon_sym_get] = ACTIONS(2973),
    [anon_sym_set] = ACTIONS(2973),
    [anon_sym_public] = ACTIONS(2973),
    [anon_sym_private] = ACTIONS(2973),
    [anon_sym_protected] = ACTIONS(2973),
    [anon_sym_module] = ACTIONS(2973),
    [anon_sym_any] = ACTIONS(2973),
    [anon_sym_number] = ACTIONS(2973),
    [anon_sym_boolean] = ACTIONS(2973),
    [anon_sym_string] = ACTIONS(2973),
    [anon_sym_symbol] = ACTIONS(2973),
    [anon_sym_interface] = ACTIONS(2973),
    [anon_sym_enum] = ACTIONS(2973),
  },
  [1061] = {
    [sym_else_clause] = STATE(1080),
    [ts_builtin_sym_end] = ACTIONS(2975),
    [sym_identifier] = ACTIONS(2977),
    [anon_sym_export] = ACTIONS(2977),
    [anon_sym_default] = ACTIONS(2977),
    [anon_sym_namespace] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2975),
    [anon_sym_RBRACE] = ACTIONS(2975),
    [anon_sym_type] = ACTIONS(2977),
    [anon_sym_typeof] = ACTIONS(2977),
    [anon_sym_import] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2975),
    [anon_sym_else] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_await] = ACTIONS(2977),
    [anon_sym_while] = ACTIONS(2977),
    [anon_sym_do] = ACTIONS(2977),
    [anon_sym_try] = ACTIONS(2977),
    [anon_sym_with] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_debugger] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_throw] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2975),
    [anon_sym_case] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_class] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_function] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2975),
    [anon_sym_void] = ACTIONS(2977),
    [anon_sym_delete] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [anon_sym_DQUOTE] = ACTIONS(2975),
    [anon_sym_SQUOTE] = ACTIONS(2975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2975),
    [sym_number] = ACTIONS(2975),
    [sym_this] = ACTIONS(2977),
    [sym_super] = ACTIONS(2977),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_null] = ACTIONS(2977),
    [sym_undefined] = ACTIONS(2977),
    [anon_sym_AT] = ACTIONS(2975),
    [anon_sym_declare] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_get] = ACTIONS(2977),
    [anon_sym_set] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_module] = ACTIONS(2977),
    [anon_sym_any] = ACTIONS(2977),
    [anon_sym_number] = ACTIONS(2977),
    [anon_sym_boolean] = ACTIONS(2977),
    [anon_sym_string] = ACTIONS(2977),
    [anon_sym_symbol] = ACTIONS(2977),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
  },
  [1062] = {
    [ts_builtin_sym_end] = ACTIONS(2981),
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_default] = ACTIONS(2983),
    [anon_sym_namespace] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_type] = ACTIONS(2983),
    [anon_sym_typeof] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_var] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_switch] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_await] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_with] = ACTIONS(2983),
    [anon_sym_break] = ACTIONS(2983),
    [anon_sym_continue] = ACTIONS(2983),
    [anon_sym_debugger] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_throw] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_case] = ACTIONS(2983),
    [anon_sym_yield] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2981),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2983),
    [anon_sym_class] = ACTIONS(2983),
    [anon_sym_async] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_new] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(2983),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_void] = ACTIONS(2983),
    [anon_sym_delete] = ACTIONS(2983),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2981),
    [sym_number] = ACTIONS(2981),
    [sym_this] = ACTIONS(2983),
    [sym_super] = ACTIONS(2983),
    [sym_true] = ACTIONS(2983),
    [sym_false] = ACTIONS(2983),
    [sym_null] = ACTIONS(2983),
    [sym_undefined] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2981),
    [anon_sym_declare] = ACTIONS(2983),
    [anon_sym_static] = ACTIONS(2983),
    [anon_sym_readonly] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_get] = ACTIONS(2983),
    [anon_sym_set] = ACTIONS(2983),
    [anon_sym_public] = ACTIONS(2983),
    [anon_sym_private] = ACTIONS(2983),
    [anon_sym_protected] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_any] = ACTIONS(2983),
    [anon_sym_number] = ACTIONS(2983),
    [anon_sym_boolean] = ACTIONS(2983),
    [anon_sym_string] = ACTIONS(2983),
    [anon_sym_symbol] = ACTIONS(2983),
    [anon_sym_interface] = ACTIONS(2983),
    [anon_sym_enum] = ACTIONS(2983),
  },
  [1063] = {
    [ts_builtin_sym_end] = ACTIONS(2985),
    [sym_identifier] = ACTIONS(2987),
    [anon_sym_export] = ACTIONS(2987),
    [anon_sym_default] = ACTIONS(2987),
    [anon_sym_namespace] = ACTIONS(2987),
    [anon_sym_LBRACE] = ACTIONS(2985),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_type] = ACTIONS(2987),
    [anon_sym_typeof] = ACTIONS(2987),
    [anon_sym_import] = ACTIONS(2987),
    [anon_sym_var] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_const] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_else] = ACTIONS(2987),
    [anon_sym_if] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_for] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2987),
    [anon_sym_while] = ACTIONS(2987),
    [anon_sym_do] = ACTIONS(2987),
    [anon_sym_try] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [anon_sym_break] = ACTIONS(2987),
    [anon_sym_continue] = ACTIONS(2987),
    [anon_sym_debugger] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2987),
    [anon_sym_throw] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_case] = ACTIONS(2987),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2987),
    [anon_sym_class] = ACTIONS(2987),
    [anon_sym_async] = ACTIONS(2987),
    [anon_sym_function] = ACTIONS(2987),
    [anon_sym_new] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2985),
    [anon_sym_void] = ACTIONS(2987),
    [anon_sym_delete] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [sym_number] = ACTIONS(2985),
    [sym_this] = ACTIONS(2987),
    [sym_super] = ACTIONS(2987),
    [sym_true] = ACTIONS(2987),
    [sym_false] = ACTIONS(2987),
    [sym_null] = ACTIONS(2987),
    [sym_undefined] = ACTIONS(2987),
    [anon_sym_AT] = ACTIONS(2985),
    [anon_sym_declare] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(2987),
    [anon_sym_abstract] = ACTIONS(2987),
    [anon_sym_get] = ACTIONS(2987),
    [anon_sym_set] = ACTIONS(2987),
    [anon_sym_public] = ACTIONS(2987),
    [anon_sym_private] = ACTIONS(2987),
    [anon_sym_protected] = ACTIONS(2987),
    [anon_sym_module] = ACTIONS(2987),
    [anon_sym_any] = ACTIONS(2987),
    [anon_sym_number] = ACTIONS(2987),
    [anon_sym_boolean] = ACTIONS(2987),
    [anon_sym_string] = ACTIONS(2987),
    [anon_sym_symbol] = ACTIONS(2987),
    [anon_sym_interface] = ACTIONS(2987),
    [anon_sym_enum] = ACTIONS(2987),
  },
  [1064] = {
    [ts_builtin_sym_end] = ACTIONS(2989),
    [sym_identifier] = ACTIONS(2991),
    [anon_sym_export] = ACTIONS(2991),
    [anon_sym_default] = ACTIONS(2991),
    [anon_sym_namespace] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2989),
    [anon_sym_type] = ACTIONS(2991),
    [anon_sym_typeof] = ACTIONS(2991),
    [anon_sym_import] = ACTIONS(2991),
    [anon_sym_var] = ACTIONS(2991),
    [anon_sym_let] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2991),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_else] = ACTIONS(2991),
    [anon_sym_if] = ACTIONS(2991),
    [anon_sym_switch] = ACTIONS(2991),
    [anon_sym_for] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2989),
    [anon_sym_await] = ACTIONS(2991),
    [anon_sym_while] = ACTIONS(2991),
    [anon_sym_do] = ACTIONS(2991),
    [anon_sym_try] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2991),
    [anon_sym_break] = ACTIONS(2991),
    [anon_sym_continue] = ACTIONS(2991),
    [anon_sym_debugger] = ACTIONS(2991),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_throw] = ACTIONS(2991),
    [anon_sym_SEMI] = ACTIONS(2989),
    [anon_sym_case] = ACTIONS(2991),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2991),
    [anon_sym_class] = ACTIONS(2991),
    [anon_sym_async] = ACTIONS(2991),
    [anon_sym_function] = ACTIONS(2991),
    [anon_sym_new] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2991),
    [anon_sym_DASH] = ACTIONS(2991),
    [anon_sym_TILDE] = ACTIONS(2989),
    [anon_sym_void] = ACTIONS(2991),
    [anon_sym_delete] = ACTIONS(2991),
    [anon_sym_PLUS_PLUS] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2989),
    [anon_sym_SQUOTE] = ACTIONS(2989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2989),
    [sym_number] = ACTIONS(2989),
    [sym_this] = ACTIONS(2991),
    [sym_super] = ACTIONS(2991),
    [sym_true] = ACTIONS(2991),
    [sym_false] = ACTIONS(2991),
    [sym_null] = ACTIONS(2991),
    [sym_undefined] = ACTIONS(2991),
    [anon_sym_AT] = ACTIONS(2989),
    [anon_sym_declare] = ACTIONS(2991),
    [anon_sym_static] = ACTIONS(2991),
    [anon_sym_readonly] = ACTIONS(2991),
    [anon_sym_abstract] = ACTIONS(2991),
    [anon_sym_get] = ACTIONS(2991),
    [anon_sym_set] = ACTIONS(2991),
    [anon_sym_public] = ACTIONS(2991),
    [anon_sym_private] = ACTIONS(2991),
    [anon_sym_protected] = ACTIONS(2991),
    [anon_sym_module] = ACTIONS(2991),
    [anon_sym_any] = ACTIONS(2991),
    [anon_sym_number] = ACTIONS(2991),
    [anon_sym_boolean] = ACTIONS(2991),
    [anon_sym_string] = ACTIONS(2991),
    [anon_sym_symbol] = ACTIONS(2991),
    [anon_sym_interface] = ACTIONS(2991),
    [anon_sym_enum] = ACTIONS(2991),
  },
  [1065] = {
    [ts_builtin_sym_end] = ACTIONS(2993),
    [sym_identifier] = ACTIONS(2995),
    [anon_sym_export] = ACTIONS(2995),
    [anon_sym_default] = ACTIONS(2995),
    [anon_sym_namespace] = ACTIONS(2995),
    [anon_sym_LBRACE] = ACTIONS(2993),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_type] = ACTIONS(2995),
    [anon_sym_typeof] = ACTIONS(2995),
    [anon_sym_import] = ACTIONS(2995),
    [anon_sym_var] = ACTIONS(2995),
    [anon_sym_let] = ACTIONS(2995),
    [anon_sym_const] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_else] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2995),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_for] = ACTIONS(2995),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_await] = ACTIONS(2995),
    [anon_sym_while] = ACTIONS(2995),
    [anon_sym_do] = ACTIONS(2995),
    [anon_sym_try] = ACTIONS(2995),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_break] = ACTIONS(2995),
    [anon_sym_continue] = ACTIONS(2995),
    [anon_sym_debugger] = ACTIONS(2995),
    [anon_sym_return] = ACTIONS(2995),
    [anon_sym_throw] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_yield] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_class] = ACTIONS(2995),
    [anon_sym_async] = ACTIONS(2995),
    [anon_sym_function] = ACTIONS(2995),
    [anon_sym_new] = ACTIONS(2995),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_TILDE] = ACTIONS(2993),
    [anon_sym_void] = ACTIONS(2995),
    [anon_sym_delete] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [sym_number] = ACTIONS(2993),
    [sym_this] = ACTIONS(2995),
    [sym_super] = ACTIONS(2995),
    [sym_true] = ACTIONS(2995),
    [sym_false] = ACTIONS(2995),
    [sym_null] = ACTIONS(2995),
    [sym_undefined] = ACTIONS(2995),
    [anon_sym_AT] = ACTIONS(2993),
    [anon_sym_declare] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(2995),
    [anon_sym_readonly] = ACTIONS(2995),
    [anon_sym_abstract] = ACTIONS(2995),
    [anon_sym_get] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(2995),
    [anon_sym_public] = ACTIONS(2995),
    [anon_sym_private] = ACTIONS(2995),
    [anon_sym_protected] = ACTIONS(2995),
    [anon_sym_module] = ACTIONS(2995),
    [anon_sym_any] = ACTIONS(2995),
    [anon_sym_number] = ACTIONS(2995),
    [anon_sym_boolean] = ACTIONS(2995),
    [anon_sym_string] = ACTIONS(2995),
    [anon_sym_symbol] = ACTIONS(2995),
    [anon_sym_interface] = ACTIONS(2995),
    [anon_sym_enum] = ACTIONS(2995),
  },
  [1066] = {
    [ts_builtin_sym_end] = ACTIONS(2997),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_export] = ACTIONS(2999),
    [anon_sym_default] = ACTIONS(2999),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(2997),
    [anon_sym_RBRACE] = ACTIONS(2997),
    [anon_sym_type] = ACTIONS(2999),
    [anon_sym_typeof] = ACTIONS(2999),
    [anon_sym_import] = ACTIONS(2999),
    [anon_sym_var] = ACTIONS(2999),
    [anon_sym_let] = ACTIONS(2999),
    [anon_sym_const] = ACTIONS(2999),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_else] = ACTIONS(2999),
    [anon_sym_if] = ACTIONS(2999),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_for] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(2997),
    [anon_sym_await] = ACTIONS(2999),
    [anon_sym_while] = ACTIONS(2999),
    [anon_sym_do] = ACTIONS(2999),
    [anon_sym_try] = ACTIONS(2999),
    [anon_sym_with] = ACTIONS(2999),
    [anon_sym_break] = ACTIONS(2999),
    [anon_sym_continue] = ACTIONS(2999),
    [anon_sym_debugger] = ACTIONS(2999),
    [anon_sym_return] = ACTIONS(2999),
    [anon_sym_throw] = ACTIONS(2999),
    [anon_sym_SEMI] = ACTIONS(2997),
    [anon_sym_case] = ACTIONS(2999),
    [anon_sym_yield] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2997),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(2999),
    [anon_sym_async] = ACTIONS(2999),
    [anon_sym_function] = ACTIONS(2999),
    [anon_sym_new] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(2999),
    [anon_sym_DASH] = ACTIONS(2999),
    [anon_sym_TILDE] = ACTIONS(2997),
    [anon_sym_void] = ACTIONS(2999),
    [anon_sym_delete] = ACTIONS(2999),
    [anon_sym_PLUS_PLUS] = ACTIONS(2997),
    [anon_sym_DASH_DASH] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2997),
    [anon_sym_SQUOTE] = ACTIONS(2997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2997),
    [sym_number] = ACTIONS(2997),
    [sym_this] = ACTIONS(2999),
    [sym_super] = ACTIONS(2999),
    [sym_true] = ACTIONS(2999),
    [sym_false] = ACTIONS(2999),
    [sym_null] = ACTIONS(2999),
    [sym_undefined] = ACTIONS(2999),
    [anon_sym_AT] = ACTIONS(2997),
    [anon_sym_declare] = ACTIONS(2999),
    [anon_sym_static] = ACTIONS(2999),
    [anon_sym_readonly] = ACTIONS(2999),
    [anon_sym_abstract] = ACTIONS(2999),
    [anon_sym_get] = ACTIONS(2999),
    [anon_sym_set] = ACTIONS(2999),
    [anon_sym_public] = ACTIONS(2999),
    [anon_sym_private] = ACTIONS(2999),
    [anon_sym_protected] = ACTIONS(2999),
    [anon_sym_module] = ACTIONS(2999),
    [anon_sym_any] = ACTIONS(2999),
    [anon_sym_number] = ACTIONS(2999),
    [anon_sym_boolean] = ACTIONS(2999),
    [anon_sym_string] = ACTIONS(2999),
    [anon_sym_symbol] = ACTIONS(2999),
    [anon_sym_interface] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(2999),
  },
  [1067] = {
    [ts_builtin_sym_end] = ACTIONS(1899),
    [sym_identifier] = ACTIONS(1901),
    [anon_sym_export] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_RBRACE] = ACTIONS(1899),
    [anon_sym_type] = ACTIONS(1901),
    [anon_sym_typeof] = ACTIONS(1901),
    [anon_sym_import] = ACTIONS(1901),
    [anon_sym_var] = ACTIONS(1901),
    [anon_sym_let] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_else] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_LPAREN] = ACTIONS(1899),
    [anon_sym_await] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_with] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_debugger] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_yield] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1899),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_SLASH] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_async] = ACTIONS(1901),
    [anon_sym_function] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_void] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1899),
    [sym_number] = ACTIONS(1899),
    [sym_this] = ACTIONS(1901),
    [sym_super] = ACTIONS(1901),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [sym_null] = ACTIONS(1901),
    [sym_undefined] = ACTIONS(1901),
    [anon_sym_AT] = ACTIONS(1899),
    [anon_sym_declare] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_readonly] = ACTIONS(1901),
    [anon_sym_abstract] = ACTIONS(1901),
    [anon_sym_get] = ACTIONS(1901),
    [anon_sym_set] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_module] = ACTIONS(1901),
    [anon_sym_any] = ACTIONS(1901),
    [anon_sym_number] = ACTIONS(1901),
    [anon_sym_boolean] = ACTIONS(1901),
    [anon_sym_string] = ACTIONS(1901),
    [anon_sym_symbol] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
  },
  [1068] = {
    [ts_builtin_sym_end] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_export] = ACTIONS(3003),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_namespace] = ACTIONS(3003),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_RBRACE] = ACTIONS(3001),
    [anon_sym_type] = ACTIONS(3003),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_import] = ACTIONS(3003),
    [anon_sym_var] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_const] = ACTIONS(3003),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_switch] = ACTIONS(3003),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym_await] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_with] = ACTIONS(3003),
    [anon_sym_break] = ACTIONS(3003),
    [anon_sym_continue] = ACTIONS(3003),
    [anon_sym_debugger] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_throw] = ACTIONS(3003),
    [anon_sym_SEMI] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3003),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3001),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_async] = ACTIONS(3003),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3001),
    [anon_sym_void] = ACTIONS(3003),
    [anon_sym_delete] = ACTIONS(3003),
    [anon_sym_PLUS_PLUS] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3001),
    [sym_number] = ACTIONS(3001),
    [sym_this] = ACTIONS(3003),
    [sym_super] = ACTIONS(3003),
    [sym_true] = ACTIONS(3003),
    [sym_false] = ACTIONS(3003),
    [sym_null] = ACTIONS(3003),
    [sym_undefined] = ACTIONS(3003),
    [anon_sym_AT] = ACTIONS(3001),
    [anon_sym_declare] = ACTIONS(3003),
    [anon_sym_static] = ACTIONS(3003),
    [anon_sym_readonly] = ACTIONS(3003),
    [anon_sym_abstract] = ACTIONS(3003),
    [anon_sym_get] = ACTIONS(3003),
    [anon_sym_set] = ACTIONS(3003),
    [anon_sym_public] = ACTIONS(3003),
    [anon_sym_private] = ACTIONS(3003),
    [anon_sym_protected] = ACTIONS(3003),
    [anon_sym_module] = ACTIONS(3003),
    [anon_sym_any] = ACTIONS(3003),
    [anon_sym_number] = ACTIONS(3003),
    [anon_sym_boolean] = ACTIONS(3003),
    [anon_sym_string] = ACTIONS(3003),
    [anon_sym_symbol] = ACTIONS(3003),
    [anon_sym_interface] = ACTIONS(3003),
    [anon_sym_enum] = ACTIONS(3003),
  },
  [1069] = {
    [ts_builtin_sym_end] = ACTIONS(1869),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_export] = ACTIONS(1871),
    [anon_sym_default] = ACTIONS(1871),
    [anon_sym_namespace] = ACTIONS(1871),
    [anon_sym_LBRACE] = ACTIONS(1869),
    [anon_sym_RBRACE] = ACTIONS(1869),
    [anon_sym_type] = ACTIONS(1871),
    [anon_sym_typeof] = ACTIONS(1871),
    [anon_sym_import] = ACTIONS(1871),
    [anon_sym_var] = ACTIONS(1871),
    [anon_sym_let] = ACTIONS(1871),
    [anon_sym_const] = ACTIONS(1871),
    [anon_sym_BANG] = ACTIONS(1869),
    [anon_sym_else] = ACTIONS(1871),
    [anon_sym_if] = ACTIONS(1871),
    [anon_sym_switch] = ACTIONS(1871),
    [anon_sym_for] = ACTIONS(1871),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_await] = ACTIONS(1871),
    [anon_sym_while] = ACTIONS(1871),
    [anon_sym_do] = ACTIONS(1871),
    [anon_sym_try] = ACTIONS(1871),
    [anon_sym_with] = ACTIONS(1871),
    [anon_sym_break] = ACTIONS(1871),
    [anon_sym_continue] = ACTIONS(1871),
    [anon_sym_debugger] = ACTIONS(1871),
    [anon_sym_return] = ACTIONS(1871),
    [anon_sym_throw] = ACTIONS(1871),
    [anon_sym_SEMI] = ACTIONS(1869),
    [anon_sym_case] = ACTIONS(1871),
    [anon_sym_yield] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(1869),
    [anon_sym_LT] = ACTIONS(1869),
    [anon_sym_SLASH] = ACTIONS(1871),
    [anon_sym_class] = ACTIONS(1871),
    [anon_sym_async] = ACTIONS(1871),
    [anon_sym_function] = ACTIONS(1871),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_PLUS] = ACTIONS(1871),
    [anon_sym_DASH] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1869),
    [anon_sym_void] = ACTIONS(1871),
    [anon_sym_delete] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1869),
    [anon_sym_DASH_DASH] = ACTIONS(1869),
    [anon_sym_DQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1869),
    [sym_number] = ACTIONS(1869),
    [sym_this] = ACTIONS(1871),
    [sym_super] = ACTIONS(1871),
    [sym_true] = ACTIONS(1871),
    [sym_false] = ACTIONS(1871),
    [sym_null] = ACTIONS(1871),
    [sym_undefined] = ACTIONS(1871),
    [anon_sym_AT] = ACTIONS(1869),
    [anon_sym_declare] = ACTIONS(1871),
    [anon_sym_static] = ACTIONS(1871),
    [anon_sym_readonly] = ACTIONS(1871),
    [anon_sym_abstract] = ACTIONS(1871),
    [anon_sym_get] = ACTIONS(1871),
    [anon_sym_set] = ACTIONS(1871),
    [anon_sym_public] = ACTIONS(1871),
    [anon_sym_private] = ACTIONS(1871),
    [anon_sym_protected] = ACTIONS(1871),
    [anon_sym_module] = ACTIONS(1871),
    [anon_sym_any] = ACTIONS(1871),
    [anon_sym_number] = ACTIONS(1871),
    [anon_sym_boolean] = ACTIONS(1871),
    [anon_sym_string] = ACTIONS(1871),
    [anon_sym_symbol] = ACTIONS(1871),
    [anon_sym_interface] = ACTIONS(1871),
    [anon_sym_enum] = ACTIONS(1871),
  },
  [1070] = {
    [ts_builtin_sym_end] = ACTIONS(3005),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_export] = ACTIONS(3007),
    [anon_sym_default] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3005),
    [anon_sym_RBRACE] = ACTIONS(3005),
    [anon_sym_type] = ACTIONS(3007),
    [anon_sym_typeof] = ACTIONS(3007),
    [anon_sym_import] = ACTIONS(3007),
    [anon_sym_var] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_const] = ACTIONS(3007),
    [anon_sym_BANG] = ACTIONS(3005),
    [anon_sym_else] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_switch] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_await] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_with] = ACTIONS(3007),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_continue] = ACTIONS(3007),
    [anon_sym_debugger] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_throw] = ACTIONS(3007),
    [anon_sym_SEMI] = ACTIONS(3005),
    [anon_sym_case] = ACTIONS(3007),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_SLASH] = ACTIONS(3007),
    [anon_sym_class] = ACTIONS(3007),
    [anon_sym_async] = ACTIONS(3007),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3005),
    [anon_sym_void] = ACTIONS(3007),
    [anon_sym_delete] = ACTIONS(3007),
    [anon_sym_PLUS_PLUS] = ACTIONS(3005),
    [anon_sym_DASH_DASH] = ACTIONS(3005),
    [anon_sym_DQUOTE] = ACTIONS(3005),
    [anon_sym_SQUOTE] = ACTIONS(3005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3005),
    [sym_number] = ACTIONS(3005),
    [sym_this] = ACTIONS(3007),
    [sym_super] = ACTIONS(3007),
    [sym_true] = ACTIONS(3007),
    [sym_false] = ACTIONS(3007),
    [sym_null] = ACTIONS(3007),
    [sym_undefined] = ACTIONS(3007),
    [anon_sym_AT] = ACTIONS(3005),
    [anon_sym_declare] = ACTIONS(3007),
    [anon_sym_static] = ACTIONS(3007),
    [anon_sym_readonly] = ACTIONS(3007),
    [anon_sym_abstract] = ACTIONS(3007),
    [anon_sym_get] = ACTIONS(3007),
    [anon_sym_set] = ACTIONS(3007),
    [anon_sym_public] = ACTIONS(3007),
    [anon_sym_private] = ACTIONS(3007),
    [anon_sym_protected] = ACTIONS(3007),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_any] = ACTIONS(3007),
    [anon_sym_number] = ACTIONS(3007),
    [anon_sym_boolean] = ACTIONS(3007),
    [anon_sym_string] = ACTIONS(3007),
    [anon_sym_symbol] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3007),
    [anon_sym_enum] = ACTIONS(3007),
  },
  [1071] = {
    [ts_builtin_sym_end] = ACTIONS(3009),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_export] = ACTIONS(3011),
    [anon_sym_default] = ACTIONS(3011),
    [anon_sym_namespace] = ACTIONS(3011),
    [anon_sym_LBRACE] = ACTIONS(3009),
    [anon_sym_RBRACE] = ACTIONS(3009),
    [anon_sym_type] = ACTIONS(3011),
    [anon_sym_typeof] = ACTIONS(3011),
    [anon_sym_import] = ACTIONS(3011),
    [anon_sym_var] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_const] = ACTIONS(3011),
    [anon_sym_BANG] = ACTIONS(3009),
    [anon_sym_else] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_switch] = ACTIONS(3011),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_await] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_with] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3011),
    [anon_sym_continue] = ACTIONS(3011),
    [anon_sym_debugger] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_throw] = ACTIONS(3011),
    [anon_sym_SEMI] = ACTIONS(3009),
    [anon_sym_case] = ACTIONS(3011),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_SLASH] = ACTIONS(3011),
    [anon_sym_class] = ACTIONS(3011),
    [anon_sym_async] = ACTIONS(3011),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3009),
    [anon_sym_void] = ACTIONS(3011),
    [anon_sym_delete] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3009),
    [anon_sym_DASH_DASH] = ACTIONS(3009),
    [anon_sym_DQUOTE] = ACTIONS(3009),
    [anon_sym_SQUOTE] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3009),
    [sym_number] = ACTIONS(3009),
    [sym_this] = ACTIONS(3011),
    [sym_super] = ACTIONS(3011),
    [sym_true] = ACTIONS(3011),
    [sym_false] = ACTIONS(3011),
    [sym_null] = ACTIONS(3011),
    [sym_undefined] = ACTIONS(3011),
    [anon_sym_AT] = ACTIONS(3009),
    [anon_sym_declare] = ACTIONS(3011),
    [anon_sym_static] = ACTIONS(3011),
    [anon_sym_readonly] = ACTIONS(3011),
    [anon_sym_abstract] = ACTIONS(3011),
    [anon_sym_get] = ACTIONS(3011),
    [anon_sym_set] = ACTIONS(3011),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_module] = ACTIONS(3011),
    [anon_sym_any] = ACTIONS(3011),
    [anon_sym_number] = ACTIONS(3011),
    [anon_sym_boolean] = ACTIONS(3011),
    [anon_sym_string] = ACTIONS(3011),
    [anon_sym_symbol] = ACTIONS(3011),
    [anon_sym_interface] = ACTIONS(3011),
    [anon_sym_enum] = ACTIONS(3011),
  },
  [1072] = {
    [ts_builtin_sym_end] = ACTIONS(3013),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_export] = ACTIONS(3015),
    [anon_sym_default] = ACTIONS(3015),
    [anon_sym_namespace] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_RBRACE] = ACTIONS(3013),
    [anon_sym_type] = ACTIONS(3015),
    [anon_sym_typeof] = ACTIONS(3015),
    [anon_sym_import] = ACTIONS(3015),
    [anon_sym_var] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_const] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3013),
    [anon_sym_else] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_switch] = ACTIONS(3015),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3013),
    [anon_sym_await] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_with] = ACTIONS(3015),
    [anon_sym_break] = ACTIONS(3015),
    [anon_sym_continue] = ACTIONS(3015),
    [anon_sym_debugger] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_throw] = ACTIONS(3015),
    [anon_sym_SEMI] = ACTIONS(3013),
    [anon_sym_case] = ACTIONS(3015),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_SLASH] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3015),
    [anon_sym_async] = ACTIONS(3015),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3013),
    [anon_sym_void] = ACTIONS(3015),
    [anon_sym_delete] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3013),
    [anon_sym_DASH_DASH] = ACTIONS(3013),
    [anon_sym_DQUOTE] = ACTIONS(3013),
    [anon_sym_SQUOTE] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3013),
    [sym_number] = ACTIONS(3013),
    [sym_this] = ACTIONS(3015),
    [sym_super] = ACTIONS(3015),
    [sym_true] = ACTIONS(3015),
    [sym_false] = ACTIONS(3015),
    [sym_null] = ACTIONS(3015),
    [sym_undefined] = ACTIONS(3015),
    [anon_sym_AT] = ACTIONS(3013),
    [anon_sym_declare] = ACTIONS(3015),
    [anon_sym_static] = ACTIONS(3015),
    [anon_sym_readonly] = ACTIONS(3015),
    [anon_sym_abstract] = ACTIONS(3015),
    [anon_sym_get] = ACTIONS(3015),
    [anon_sym_set] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3015),
    [anon_sym_private] = ACTIONS(3015),
    [anon_sym_protected] = ACTIONS(3015),
    [anon_sym_module] = ACTIONS(3015),
    [anon_sym_any] = ACTIONS(3015),
    [anon_sym_number] = ACTIONS(3015),
    [anon_sym_boolean] = ACTIONS(3015),
    [anon_sym_string] = ACTIONS(3015),
    [anon_sym_symbol] = ACTIONS(3015),
    [anon_sym_interface] = ACTIONS(3015),
    [anon_sym_enum] = ACTIONS(3015),
  },
  [1073] = {
    [ts_builtin_sym_end] = ACTIONS(3017),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_export] = ACTIONS(3019),
    [anon_sym_default] = ACTIONS(3019),
    [anon_sym_namespace] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3017),
    [anon_sym_RBRACE] = ACTIONS(3017),
    [anon_sym_type] = ACTIONS(3019),
    [anon_sym_typeof] = ACTIONS(3019),
    [anon_sym_import] = ACTIONS(3019),
    [anon_sym_var] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3017),
    [anon_sym_else] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_switch] = ACTIONS(3019),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_LPAREN] = ACTIONS(3017),
    [anon_sym_await] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_with] = ACTIONS(3019),
    [anon_sym_break] = ACTIONS(3019),
    [anon_sym_continue] = ACTIONS(3019),
    [anon_sym_debugger] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_throw] = ACTIONS(3019),
    [anon_sym_SEMI] = ACTIONS(3017),
    [anon_sym_case] = ACTIONS(3019),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_SLASH] = ACTIONS(3019),
    [anon_sym_class] = ACTIONS(3019),
    [anon_sym_async] = ACTIONS(3019),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_void] = ACTIONS(3019),
    [anon_sym_delete] = ACTIONS(3019),
    [anon_sym_PLUS_PLUS] = ACTIONS(3017),
    [anon_sym_DASH_DASH] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3017),
    [anon_sym_SQUOTE] = ACTIONS(3017),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3017),
    [sym_number] = ACTIONS(3017),
    [sym_this] = ACTIONS(3019),
    [sym_super] = ACTIONS(3019),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [sym_null] = ACTIONS(3019),
    [sym_undefined] = ACTIONS(3019),
    [anon_sym_AT] = ACTIONS(3017),
    [anon_sym_declare] = ACTIONS(3019),
    [anon_sym_static] = ACTIONS(3019),
    [anon_sym_readonly] = ACTIONS(3019),
    [anon_sym_abstract] = ACTIONS(3019),
    [anon_sym_get] = ACTIONS(3019),
    [anon_sym_set] = ACTIONS(3019),
    [anon_sym_public] = ACTIONS(3019),
    [anon_sym_private] = ACTIONS(3019),
    [anon_sym_protected] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3019),
    [anon_sym_any] = ACTIONS(3019),
    [anon_sym_number] = ACTIONS(3019),
    [anon_sym_boolean] = ACTIONS(3019),
    [anon_sym_string] = ACTIONS(3019),
    [anon_sym_symbol] = ACTIONS(3019),
    [anon_sym_interface] = ACTIONS(3019),
    [anon_sym_enum] = ACTIONS(3019),
  },
  [1074] = {
    [ts_builtin_sym_end] = ACTIONS(3021),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_export] = ACTIONS(3023),
    [anon_sym_default] = ACTIONS(3023),
    [anon_sym_namespace] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3021),
    [anon_sym_RBRACE] = ACTIONS(3021),
    [anon_sym_type] = ACTIONS(3023),
    [anon_sym_typeof] = ACTIONS(3023),
    [anon_sym_import] = ACTIONS(3023),
    [anon_sym_var] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_const] = ACTIONS(3023),
    [anon_sym_BANG] = ACTIONS(3021),
    [anon_sym_else] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_switch] = ACTIONS(3023),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(3021),
    [anon_sym_await] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_with] = ACTIONS(3023),
    [anon_sym_break] = ACTIONS(3023),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_debugger] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_throw] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3021),
    [anon_sym_case] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_SLASH] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3023),
    [anon_sym_async] = ACTIONS(3023),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3021),
    [anon_sym_void] = ACTIONS(3023),
    [anon_sym_delete] = ACTIONS(3023),
    [anon_sym_PLUS_PLUS] = ACTIONS(3021),
    [anon_sym_DASH_DASH] = ACTIONS(3021),
    [anon_sym_DQUOTE] = ACTIONS(3021),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3021),
    [sym_number] = ACTIONS(3021),
    [sym_this] = ACTIONS(3023),
    [sym_super] = ACTIONS(3023),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [sym_null] = ACTIONS(3023),
    [sym_undefined] = ACTIONS(3023),
    [anon_sym_AT] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3023),
    [anon_sym_readonly] = ACTIONS(3023),
    [anon_sym_abstract] = ACTIONS(3023),
    [anon_sym_get] = ACTIONS(3023),
    [anon_sym_set] = ACTIONS(3023),
    [anon_sym_public] = ACTIONS(3023),
    [anon_sym_private] = ACTIONS(3023),
    [anon_sym_protected] = ACTIONS(3023),
    [anon_sym_module] = ACTIONS(3023),
    [anon_sym_any] = ACTIONS(3023),
    [anon_sym_number] = ACTIONS(3023),
    [anon_sym_boolean] = ACTIONS(3023),
    [anon_sym_string] = ACTIONS(3023),
    [anon_sym_symbol] = ACTIONS(3023),
    [anon_sym_interface] = ACTIONS(3023),
    [anon_sym_enum] = ACTIONS(3023),
  },
  [1075] = {
    [ts_builtin_sym_end] = ACTIONS(3025),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_export] = ACTIONS(3027),
    [anon_sym_default] = ACTIONS(3027),
    [anon_sym_namespace] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3025),
    [anon_sym_RBRACE] = ACTIONS(3025),
    [anon_sym_type] = ACTIONS(3027),
    [anon_sym_typeof] = ACTIONS(3027),
    [anon_sym_import] = ACTIONS(3027),
    [anon_sym_var] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_const] = ACTIONS(3027),
    [anon_sym_BANG] = ACTIONS(3025),
    [anon_sym_else] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_switch] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_LPAREN] = ACTIONS(3025),
    [anon_sym_await] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_with] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_debugger] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_throw] = ACTIONS(3027),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_case] = ACTIONS(3027),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_SLASH] = ACTIONS(3027),
    [anon_sym_class] = ACTIONS(3027),
    [anon_sym_async] = ACTIONS(3027),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3025),
    [anon_sym_void] = ACTIONS(3027),
    [anon_sym_delete] = ACTIONS(3027),
    [anon_sym_PLUS_PLUS] = ACTIONS(3025),
    [anon_sym_DASH_DASH] = ACTIONS(3025),
    [anon_sym_DQUOTE] = ACTIONS(3025),
    [anon_sym_SQUOTE] = ACTIONS(3025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3025),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3027),
    [sym_super] = ACTIONS(3027),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [sym_null] = ACTIONS(3027),
    [sym_undefined] = ACTIONS(3027),
    [anon_sym_AT] = ACTIONS(3025),
    [anon_sym_declare] = ACTIONS(3027),
    [anon_sym_static] = ACTIONS(3027),
    [anon_sym_readonly] = ACTIONS(3027),
    [anon_sym_abstract] = ACTIONS(3027),
    [anon_sym_get] = ACTIONS(3027),
    [anon_sym_set] = ACTIONS(3027),
    [anon_sym_public] = ACTIONS(3027),
    [anon_sym_private] = ACTIONS(3027),
    [anon_sym_protected] = ACTIONS(3027),
    [anon_sym_module] = ACTIONS(3027),
    [anon_sym_any] = ACTIONS(3027),
    [anon_sym_number] = ACTIONS(3027),
    [anon_sym_boolean] = ACTIONS(3027),
    [anon_sym_string] = ACTIONS(3027),
    [anon_sym_symbol] = ACTIONS(3027),
    [anon_sym_interface] = ACTIONS(3027),
    [anon_sym_enum] = ACTIONS(3027),
  },
  [1076] = {
    [ts_builtin_sym_end] = ACTIONS(3029),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_export] = ACTIONS(3031),
    [anon_sym_default] = ACTIONS(3031),
    [anon_sym_namespace] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_RBRACE] = ACTIONS(3029),
    [anon_sym_type] = ACTIONS(3031),
    [anon_sym_typeof] = ACTIONS(3031),
    [anon_sym_import] = ACTIONS(3031),
    [anon_sym_var] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_const] = ACTIONS(3031),
    [anon_sym_BANG] = ACTIONS(3029),
    [anon_sym_else] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_switch] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(3029),
    [anon_sym_await] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_with] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_debugger] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_throw] = ACTIONS(3031),
    [anon_sym_SEMI] = ACTIONS(3029),
    [anon_sym_case] = ACTIONS(3031),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_SLASH] = ACTIONS(3031),
    [anon_sym_class] = ACTIONS(3031),
    [anon_sym_async] = ACTIONS(3031),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3029),
    [anon_sym_void] = ACTIONS(3031),
    [anon_sym_delete] = ACTIONS(3031),
    [anon_sym_PLUS_PLUS] = ACTIONS(3029),
    [anon_sym_DASH_DASH] = ACTIONS(3029),
    [anon_sym_DQUOTE] = ACTIONS(3029),
    [anon_sym_SQUOTE] = ACTIONS(3029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3029),
    [sym_number] = ACTIONS(3029),
    [sym_this] = ACTIONS(3031),
    [sym_super] = ACTIONS(3031),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [sym_null] = ACTIONS(3031),
    [sym_undefined] = ACTIONS(3031),
    [anon_sym_AT] = ACTIONS(3029),
    [anon_sym_declare] = ACTIONS(3031),
    [anon_sym_static] = ACTIONS(3031),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_abstract] = ACTIONS(3031),
    [anon_sym_get] = ACTIONS(3031),
    [anon_sym_set] = ACTIONS(3031),
    [anon_sym_public] = ACTIONS(3031),
    [anon_sym_private] = ACTIONS(3031),
    [anon_sym_protected] = ACTIONS(3031),
    [anon_sym_module] = ACTIONS(3031),
    [anon_sym_any] = ACTIONS(3031),
    [anon_sym_number] = ACTIONS(3031),
    [anon_sym_boolean] = ACTIONS(3031),
    [anon_sym_string] = ACTIONS(3031),
    [anon_sym_symbol] = ACTIONS(3031),
    [anon_sym_interface] = ACTIONS(3031),
    [anon_sym_enum] = ACTIONS(3031),
  },
  [1077] = {
    [ts_builtin_sym_end] = ACTIONS(3033),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_export] = ACTIONS(3035),
    [anon_sym_default] = ACTIONS(3035),
    [anon_sym_namespace] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3033),
    [anon_sym_RBRACE] = ACTIONS(3033),
    [anon_sym_type] = ACTIONS(3035),
    [anon_sym_typeof] = ACTIONS(3035),
    [anon_sym_import] = ACTIONS(3035),
    [anon_sym_var] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_BANG] = ACTIONS(3033),
    [anon_sym_else] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_switch] = ACTIONS(3035),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_LPAREN] = ACTIONS(3033),
    [anon_sym_await] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_with] = ACTIONS(3035),
    [anon_sym_break] = ACTIONS(3035),
    [anon_sym_continue] = ACTIONS(3035),
    [anon_sym_debugger] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_throw] = ACTIONS(3035),
    [anon_sym_SEMI] = ACTIONS(3033),
    [anon_sym_case] = ACTIONS(3035),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_SLASH] = ACTIONS(3035),
    [anon_sym_class] = ACTIONS(3035),
    [anon_sym_async] = ACTIONS(3035),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3033),
    [anon_sym_void] = ACTIONS(3035),
    [anon_sym_delete] = ACTIONS(3035),
    [anon_sym_PLUS_PLUS] = ACTIONS(3033),
    [anon_sym_DASH_DASH] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3033),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [sym_number] = ACTIONS(3033),
    [sym_this] = ACTIONS(3035),
    [sym_super] = ACTIONS(3035),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [sym_null] = ACTIONS(3035),
    [sym_undefined] = ACTIONS(3035),
    [anon_sym_AT] = ACTIONS(3033),
    [anon_sym_declare] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3035),
    [anon_sym_readonly] = ACTIONS(3035),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_get] = ACTIONS(3035),
    [anon_sym_set] = ACTIONS(3035),
    [anon_sym_public] = ACTIONS(3035),
    [anon_sym_private] = ACTIONS(3035),
    [anon_sym_protected] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(3035),
    [anon_sym_any] = ACTIONS(3035),
    [anon_sym_number] = ACTIONS(3035),
    [anon_sym_boolean] = ACTIONS(3035),
    [anon_sym_string] = ACTIONS(3035),
    [anon_sym_symbol] = ACTIONS(3035),
    [anon_sym_interface] = ACTIONS(3035),
    [anon_sym_enum] = ACTIONS(3035),
  },
  [1078] = {
    [ts_builtin_sym_end] = ACTIONS(3037),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_export] = ACTIONS(3039),
    [anon_sym_default] = ACTIONS(3039),
    [anon_sym_namespace] = ACTIONS(3039),
    [anon_sym_LBRACE] = ACTIONS(3037),
    [anon_sym_RBRACE] = ACTIONS(3037),
    [anon_sym_type] = ACTIONS(3039),
    [anon_sym_typeof] = ACTIONS(3039),
    [anon_sym_import] = ACTIONS(3039),
    [anon_sym_var] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_BANG] = ACTIONS(3037),
    [anon_sym_else] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_switch] = ACTIONS(3039),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3037),
    [anon_sym_await] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_with] = ACTIONS(3039),
    [anon_sym_break] = ACTIONS(3039),
    [anon_sym_continue] = ACTIONS(3039),
    [anon_sym_debugger] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_throw] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3037),
    [anon_sym_case] = ACTIONS(3039),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_SLASH] = ACTIONS(3039),
    [anon_sym_class] = ACTIONS(3039),
    [anon_sym_async] = ACTIONS(3039),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_void] = ACTIONS(3039),
    [anon_sym_delete] = ACTIONS(3039),
    [anon_sym_PLUS_PLUS] = ACTIONS(3037),
    [anon_sym_DASH_DASH] = ACTIONS(3037),
    [anon_sym_DQUOTE] = ACTIONS(3037),
    [anon_sym_SQUOTE] = ACTIONS(3037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3037),
    [sym_number] = ACTIONS(3037),
    [sym_this] = ACTIONS(3039),
    [sym_super] = ACTIONS(3039),
    [sym_true] = ACTIONS(3039),
    [sym_false] = ACTIONS(3039),
    [sym_null] = ACTIONS(3039),
    [sym_undefined] = ACTIONS(3039),
    [anon_sym_AT] = ACTIONS(3037),
    [anon_sym_declare] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3039),
    [anon_sym_readonly] = ACTIONS(3039),
    [anon_sym_abstract] = ACTIONS(3039),
    [anon_sym_get] = ACTIONS(3039),
    [anon_sym_set] = ACTIONS(3039),
    [anon_sym_public] = ACTIONS(3039),
    [anon_sym_private] = ACTIONS(3039),
    [anon_sym_protected] = ACTIONS(3039),
    [anon_sym_module] = ACTIONS(3039),
    [anon_sym_any] = ACTIONS(3039),
    [anon_sym_number] = ACTIONS(3039),
    [anon_sym_boolean] = ACTIONS(3039),
    [anon_sym_string] = ACTIONS(3039),
    [anon_sym_symbol] = ACTIONS(3039),
    [anon_sym_interface] = ACTIONS(3039),
    [anon_sym_enum] = ACTIONS(3039),
  },
  [1079] = {
    [ts_builtin_sym_end] = ACTIONS(3041),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_export] = ACTIONS(3043),
    [anon_sym_default] = ACTIONS(3043),
    [anon_sym_namespace] = ACTIONS(3043),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_RBRACE] = ACTIONS(3041),
    [anon_sym_type] = ACTIONS(3043),
    [anon_sym_typeof] = ACTIONS(3043),
    [anon_sym_import] = ACTIONS(3043),
    [anon_sym_var] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_const] = ACTIONS(3043),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_else] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_switch] = ACTIONS(3043),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_await] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_with] = ACTIONS(3043),
    [anon_sym_break] = ACTIONS(3043),
    [anon_sym_continue] = ACTIONS(3043),
    [anon_sym_debugger] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_throw] = ACTIONS(3043),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym_case] = ACTIONS(3043),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_SLASH] = ACTIONS(3043),
    [anon_sym_class] = ACTIONS(3043),
    [anon_sym_async] = ACTIONS(3043),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_void] = ACTIONS(3043),
    [anon_sym_delete] = ACTIONS(3043),
    [anon_sym_PLUS_PLUS] = ACTIONS(3041),
    [anon_sym_DASH_DASH] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3041),
    [sym_number] = ACTIONS(3041),
    [sym_this] = ACTIONS(3043),
    [sym_super] = ACTIONS(3043),
    [sym_true] = ACTIONS(3043),
    [sym_false] = ACTIONS(3043),
    [sym_null] = ACTIONS(3043),
    [sym_undefined] = ACTIONS(3043),
    [anon_sym_AT] = ACTIONS(3041),
    [anon_sym_declare] = ACTIONS(3043),
    [anon_sym_static] = ACTIONS(3043),
    [anon_sym_readonly] = ACTIONS(3043),
    [anon_sym_abstract] = ACTIONS(3043),
    [anon_sym_get] = ACTIONS(3043),
    [anon_sym_set] = ACTIONS(3043),
    [anon_sym_public] = ACTIONS(3043),
    [anon_sym_private] = ACTIONS(3043),
    [anon_sym_protected] = ACTIONS(3043),
    [anon_sym_module] = ACTIONS(3043),
    [anon_sym_any] = ACTIONS(3043),
    [anon_sym_number] = ACTIONS(3043),
    [anon_sym_boolean] = ACTIONS(3043),
    [anon_sym_string] = ACTIONS(3043),
    [anon_sym_symbol] = ACTIONS(3043),
    [anon_sym_interface] = ACTIONS(3043),
    [anon_sym_enum] = ACTIONS(3043),
  },
  [1080] = {
    [ts_builtin_sym_end] = ACTIONS(3045),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_export] = ACTIONS(3047),
    [anon_sym_default] = ACTIONS(3047),
    [anon_sym_namespace] = ACTIONS(3047),
    [anon_sym_LBRACE] = ACTIONS(3045),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_type] = ACTIONS(3047),
    [anon_sym_typeof] = ACTIONS(3047),
    [anon_sym_import] = ACTIONS(3047),
    [anon_sym_var] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_const] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_switch] = ACTIONS(3047),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_await] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_with] = ACTIONS(3047),
    [anon_sym_break] = ACTIONS(3047),
    [anon_sym_continue] = ACTIONS(3047),
    [anon_sym_debugger] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_throw] = ACTIONS(3047),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_case] = ACTIONS(3047),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3047),
    [anon_sym_class] = ACTIONS(3047),
    [anon_sym_async] = ACTIONS(3047),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_void] = ACTIONS(3047),
    [anon_sym_delete] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3045),
    [sym_number] = ACTIONS(3045),
    [sym_this] = ACTIONS(3047),
    [sym_super] = ACTIONS(3047),
    [sym_true] = ACTIONS(3047),
    [sym_false] = ACTIONS(3047),
    [sym_null] = ACTIONS(3047),
    [sym_undefined] = ACTIONS(3047),
    [anon_sym_AT] = ACTIONS(3045),
    [anon_sym_declare] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3047),
    [anon_sym_readonly] = ACTIONS(3047),
    [anon_sym_abstract] = ACTIONS(3047),
    [anon_sym_get] = ACTIONS(3047),
    [anon_sym_set] = ACTIONS(3047),
    [anon_sym_public] = ACTIONS(3047),
    [anon_sym_private] = ACTIONS(3047),
    [anon_sym_protected] = ACTIONS(3047),
    [anon_sym_module] = ACTIONS(3047),
    [anon_sym_any] = ACTIONS(3047),
    [anon_sym_number] = ACTIONS(3047),
    [anon_sym_boolean] = ACTIONS(3047),
    [anon_sym_string] = ACTIONS(3047),
    [anon_sym_symbol] = ACTIONS(3047),
    [anon_sym_interface] = ACTIONS(3047),
    [anon_sym_enum] = ACTIONS(3047),
  },
  [1081] = {
    [ts_builtin_sym_end] = ACTIONS(3049),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_default] = ACTIONS(3051),
    [anon_sym_namespace] = ACTIONS(3051),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_RBRACE] = ACTIONS(3049),
    [anon_sym_type] = ACTIONS(3051),
    [anon_sym_typeof] = ACTIONS(3051),
    [anon_sym_import] = ACTIONS(3051),
    [anon_sym_var] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_const] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_switch] = ACTIONS(3051),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_await] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_with] = ACTIONS(3051),
    [anon_sym_break] = ACTIONS(3051),
    [anon_sym_continue] = ACTIONS(3051),
    [anon_sym_debugger] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_throw] = ACTIONS(3051),
    [anon_sym_SEMI] = ACTIONS(3049),
    [anon_sym_case] = ACTIONS(3051),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3051),
    [anon_sym_class] = ACTIONS(3051),
    [anon_sym_async] = ACTIONS(3051),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_void] = ACTIONS(3051),
    [anon_sym_delete] = ACTIONS(3051),
    [anon_sym_PLUS_PLUS] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3049),
    [sym_number] = ACTIONS(3049),
    [sym_this] = ACTIONS(3051),
    [sym_super] = ACTIONS(3051),
    [sym_true] = ACTIONS(3051),
    [sym_false] = ACTIONS(3051),
    [sym_null] = ACTIONS(3051),
    [sym_undefined] = ACTIONS(3051),
    [anon_sym_AT] = ACTIONS(3049),
    [anon_sym_declare] = ACTIONS(3051),
    [anon_sym_static] = ACTIONS(3051),
    [anon_sym_readonly] = ACTIONS(3051),
    [anon_sym_abstract] = ACTIONS(3051),
    [anon_sym_get] = ACTIONS(3051),
    [anon_sym_set] = ACTIONS(3051),
    [anon_sym_public] = ACTIONS(3051),
    [anon_sym_private] = ACTIONS(3051),
    [anon_sym_protected] = ACTIONS(3051),
    [anon_sym_module] = ACTIONS(3051),
    [anon_sym_any] = ACTIONS(3051),
    [anon_sym_number] = ACTIONS(3051),
    [anon_sym_boolean] = ACTIONS(3051),
    [anon_sym_string] = ACTIONS(3051),
    [anon_sym_symbol] = ACTIONS(3051),
    [anon_sym_interface] = ACTIONS(3051),
    [anon_sym_enum] = ACTIONS(3051),
  },
  [1082] = {
    [ts_builtin_sym_end] = ACTIONS(3053),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3055),
    [anon_sym_default] = ACTIONS(3055),
    [anon_sym_namespace] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3053),
    [anon_sym_RBRACE] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3055),
    [anon_sym_typeof] = ACTIONS(3055),
    [anon_sym_import] = ACTIONS(3055),
    [anon_sym_var] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_else] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_switch] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_await] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_with] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_debugger] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_throw] = ACTIONS(3055),
    [anon_sym_SEMI] = ACTIONS(3053),
    [anon_sym_case] = ACTIONS(3055),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_SLASH] = ACTIONS(3055),
    [anon_sym_class] = ACTIONS(3055),
    [anon_sym_async] = ACTIONS(3055),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(3055),
    [anon_sym_delete] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3053),
    [anon_sym_DASH_DASH] = ACTIONS(3053),
    [anon_sym_DQUOTE] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3053),
    [sym_number] = ACTIONS(3053),
    [sym_this] = ACTIONS(3055),
    [sym_super] = ACTIONS(3055),
    [sym_true] = ACTIONS(3055),
    [sym_false] = ACTIONS(3055),
    [sym_null] = ACTIONS(3055),
    [sym_undefined] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3053),
    [anon_sym_declare] = ACTIONS(3055),
    [anon_sym_static] = ACTIONS(3055),
    [anon_sym_readonly] = ACTIONS(3055),
    [anon_sym_abstract] = ACTIONS(3055),
    [anon_sym_get] = ACTIONS(3055),
    [anon_sym_set] = ACTIONS(3055),
    [anon_sym_public] = ACTIONS(3055),
    [anon_sym_private] = ACTIONS(3055),
    [anon_sym_protected] = ACTIONS(3055),
    [anon_sym_module] = ACTIONS(3055),
    [anon_sym_any] = ACTIONS(3055),
    [anon_sym_number] = ACTIONS(3055),
    [anon_sym_boolean] = ACTIONS(3055),
    [anon_sym_string] = ACTIONS(3055),
    [anon_sym_symbol] = ACTIONS(3055),
    [anon_sym_interface] = ACTIONS(3055),
    [anon_sym_enum] = ACTIONS(3055),
  },
  [1083] = {
    [ts_builtin_sym_end] = ACTIONS(3057),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_export] = ACTIONS(3059),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_namespace] = ACTIONS(3059),
    [anon_sym_LBRACE] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3057),
    [anon_sym_type] = ACTIONS(3059),
    [anon_sym_typeof] = ACTIONS(3059),
    [anon_sym_import] = ACTIONS(3059),
    [anon_sym_var] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_const] = ACTIONS(3059),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_else] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_switch] = ACTIONS(3059),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3057),
    [anon_sym_await] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_with] = ACTIONS(3059),
    [anon_sym_break] = ACTIONS(3059),
    [anon_sym_continue] = ACTIONS(3059),
    [anon_sym_debugger] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_throw] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3057),
    [anon_sym_case] = ACTIONS(3059),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_SLASH] = ACTIONS(3059),
    [anon_sym_class] = ACTIONS(3059),
    [anon_sym_async] = ACTIONS(3059),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3057),
    [anon_sym_void] = ACTIONS(3059),
    [anon_sym_delete] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3057),
    [anon_sym_DASH_DASH] = ACTIONS(3057),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3057),
    [sym_number] = ACTIONS(3057),
    [sym_this] = ACTIONS(3059),
    [sym_super] = ACTIONS(3059),
    [sym_true] = ACTIONS(3059),
    [sym_false] = ACTIONS(3059),
    [sym_null] = ACTIONS(3059),
    [sym_undefined] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3059),
    [anon_sym_static] = ACTIONS(3059),
    [anon_sym_readonly] = ACTIONS(3059),
    [anon_sym_abstract] = ACTIONS(3059),
    [anon_sym_get] = ACTIONS(3059),
    [anon_sym_set] = ACTIONS(3059),
    [anon_sym_public] = ACTIONS(3059),
    [anon_sym_private] = ACTIONS(3059),
    [anon_sym_protected] = ACTIONS(3059),
    [anon_sym_module] = ACTIONS(3059),
    [anon_sym_any] = ACTIONS(3059),
    [anon_sym_number] = ACTIONS(3059),
    [anon_sym_boolean] = ACTIONS(3059),
    [anon_sym_string] = ACTIONS(3059),
    [anon_sym_symbol] = ACTIONS(3059),
    [anon_sym_interface] = ACTIONS(3059),
    [anon_sym_enum] = ACTIONS(3059),
  },
  [1084] = {
    [ts_builtin_sym_end] = ACTIONS(3061),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_export] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_RBRACE] = ACTIONS(3061),
    [anon_sym_type] = ACTIONS(3063),
    [anon_sym_typeof] = ACTIONS(3063),
    [anon_sym_import] = ACTIONS(3063),
    [anon_sym_var] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_else] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_await] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_with] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_debugger] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_SLASH] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_async] = ACTIONS(3063),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_void] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3061),
    [sym_number] = ACTIONS(3061),
    [sym_this] = ACTIONS(3063),
    [sym_super] = ACTIONS(3063),
    [sym_true] = ACTIONS(3063),
    [sym_false] = ACTIONS(3063),
    [sym_null] = ACTIONS(3063),
    [sym_undefined] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3061),
    [anon_sym_declare] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_readonly] = ACTIONS(3063),
    [anon_sym_abstract] = ACTIONS(3063),
    [anon_sym_get] = ACTIONS(3063),
    [anon_sym_set] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_module] = ACTIONS(3063),
    [anon_sym_any] = ACTIONS(3063),
    [anon_sym_number] = ACTIONS(3063),
    [anon_sym_boolean] = ACTIONS(3063),
    [anon_sym_string] = ACTIONS(3063),
    [anon_sym_symbol] = ACTIONS(3063),
    [anon_sym_interface] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
  },
  [1085] = {
    [ts_builtin_sym_end] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3067),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_namespace] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_type] = ACTIONS(3067),
    [anon_sym_typeof] = ACTIONS(3067),
    [anon_sym_import] = ACTIONS(3067),
    [anon_sym_var] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_else] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_await] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_break] = ACTIONS(3067),
    [anon_sym_continue] = ACTIONS(3067),
    [anon_sym_debugger] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_throw] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_case] = ACTIONS(3067),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_async] = ACTIONS(3067),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_void] = ACTIONS(3067),
    [anon_sym_delete] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3065),
    [sym_number] = ACTIONS(3065),
    [sym_this] = ACTIONS(3067),
    [sym_super] = ACTIONS(3067),
    [sym_true] = ACTIONS(3067),
    [sym_false] = ACTIONS(3067),
    [sym_null] = ACTIONS(3067),
    [sym_undefined] = ACTIONS(3067),
    [anon_sym_AT] = ACTIONS(3065),
    [anon_sym_declare] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_readonly] = ACTIONS(3067),
    [anon_sym_abstract] = ACTIONS(3067),
    [anon_sym_get] = ACTIONS(3067),
    [anon_sym_set] = ACTIONS(3067),
    [anon_sym_public] = ACTIONS(3067),
    [anon_sym_private] = ACTIONS(3067),
    [anon_sym_protected] = ACTIONS(3067),
    [anon_sym_module] = ACTIONS(3067),
    [anon_sym_any] = ACTIONS(3067),
    [anon_sym_number] = ACTIONS(3067),
    [anon_sym_boolean] = ACTIONS(3067),
    [anon_sym_string] = ACTIONS(3067),
    [anon_sym_symbol] = ACTIONS(3067),
    [anon_sym_interface] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
  },
  [1086] = {
    [ts_builtin_sym_end] = ACTIONS(3069),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_type] = ACTIONS(3071),
    [anon_sym_typeof] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_var] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_switch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3069),
    [anon_sym_await] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_with] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3071),
    [anon_sym_debugger] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_throw] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym_case] = ACTIONS(3071),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_async] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_void] = ACTIONS(3071),
    [anon_sym_delete] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3069),
    [sym_number] = ACTIONS(3069),
    [sym_this] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_true] = ACTIONS(3071),
    [sym_false] = ACTIONS(3071),
    [sym_null] = ACTIONS(3071),
    [sym_undefined] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3069),
    [anon_sym_declare] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_readonly] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_get] = ACTIONS(3071),
    [anon_sym_set] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_any] = ACTIONS(3071),
    [anon_sym_number] = ACTIONS(3071),
    [anon_sym_boolean] = ACTIONS(3071),
    [anon_sym_string] = ACTIONS(3071),
    [anon_sym_symbol] = ACTIONS(3071),
    [anon_sym_interface] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
  },
  [1087] = {
    [ts_builtin_sym_end] = ACTIONS(3073),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_type] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3075),
    [anon_sym_import] = ACTIONS(3075),
    [anon_sym_var] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_else] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_await] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_debugger] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_case] = ACTIONS(3075),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_SLASH] = ACTIONS(3075),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_async] = ACTIONS(3075),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3075),
    [anon_sym_delete] = ACTIONS(3075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3073),
    [sym_number] = ACTIONS(3073),
    [sym_this] = ACTIONS(3075),
    [sym_super] = ACTIONS(3075),
    [sym_true] = ACTIONS(3075),
    [sym_false] = ACTIONS(3075),
    [sym_null] = ACTIONS(3075),
    [sym_undefined] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3073),
    [anon_sym_declare] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_readonly] = ACTIONS(3075),
    [anon_sym_abstract] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(3075),
    [anon_sym_set] = ACTIONS(3075),
    [anon_sym_public] = ACTIONS(3075),
    [anon_sym_private] = ACTIONS(3075),
    [anon_sym_protected] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_any] = ACTIONS(3075),
    [anon_sym_number] = ACTIONS(3075),
    [anon_sym_boolean] = ACTIONS(3075),
    [anon_sym_string] = ACTIONS(3075),
    [anon_sym_symbol] = ACTIONS(3075),
    [anon_sym_interface] = ACTIONS(3075),
    [anon_sym_enum] = ACTIONS(3075),
  },
  [1088] = {
    [ts_builtin_sym_end] = ACTIONS(3077),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_export] = ACTIONS(3079),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_namespace] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_type] = ACTIONS(3079),
    [anon_sym_typeof] = ACTIONS(3079),
    [anon_sym_import] = ACTIONS(3079),
    [anon_sym_var] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_else] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_switch] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3077),
    [anon_sym_await] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_with] = ACTIONS(3079),
    [anon_sym_break] = ACTIONS(3079),
    [anon_sym_continue] = ACTIONS(3079),
    [anon_sym_debugger] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_throw] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym_case] = ACTIONS(3079),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_SLASH] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_async] = ACTIONS(3079),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_void] = ACTIONS(3079),
    [anon_sym_delete] = ACTIONS(3079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3077),
    [sym_number] = ACTIONS(3077),
    [sym_this] = ACTIONS(3079),
    [sym_super] = ACTIONS(3079),
    [sym_true] = ACTIONS(3079),
    [sym_false] = ACTIONS(3079),
    [sym_null] = ACTIONS(3079),
    [sym_undefined] = ACTIONS(3079),
    [anon_sym_AT] = ACTIONS(3077),
    [anon_sym_declare] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_readonly] = ACTIONS(3079),
    [anon_sym_abstract] = ACTIONS(3079),
    [anon_sym_get] = ACTIONS(3079),
    [anon_sym_set] = ACTIONS(3079),
    [anon_sym_public] = ACTIONS(3079),
    [anon_sym_private] = ACTIONS(3079),
    [anon_sym_protected] = ACTIONS(3079),
    [anon_sym_module] = ACTIONS(3079),
    [anon_sym_any] = ACTIONS(3079),
    [anon_sym_number] = ACTIONS(3079),
    [anon_sym_boolean] = ACTIONS(3079),
    [anon_sym_string] = ACTIONS(3079),
    [anon_sym_symbol] = ACTIONS(3079),
    [anon_sym_interface] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
  },
  [1089] = {
    [ts_builtin_sym_end] = ACTIONS(3081),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_export] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_namespace] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3081),
    [anon_sym_RBRACE] = ACTIONS(3081),
    [anon_sym_type] = ACTIONS(3083),
    [anon_sym_typeof] = ACTIONS(3083),
    [anon_sym_import] = ACTIONS(3083),
    [anon_sym_var] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_else] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_LPAREN] = ACTIONS(3081),
    [anon_sym_await] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_with] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_debugger] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_case] = ACTIONS(3083),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_SLASH] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_async] = ACTIONS(3083),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_void] = ACTIONS(3083),
    [anon_sym_delete] = ACTIONS(3083),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3081),
    [sym_number] = ACTIONS(3081),
    [sym_this] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_true] = ACTIONS(3083),
    [sym_false] = ACTIONS(3083),
    [sym_null] = ACTIONS(3083),
    [sym_undefined] = ACTIONS(3083),
    [anon_sym_AT] = ACTIONS(3081),
    [anon_sym_declare] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_readonly] = ACTIONS(3083),
    [anon_sym_abstract] = ACTIONS(3083),
    [anon_sym_get] = ACTIONS(3083),
    [anon_sym_set] = ACTIONS(3083),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_module] = ACTIONS(3083),
    [anon_sym_any] = ACTIONS(3083),
    [anon_sym_number] = ACTIONS(3083),
    [anon_sym_boolean] = ACTIONS(3083),
    [anon_sym_string] = ACTIONS(3083),
    [anon_sym_symbol] = ACTIONS(3083),
    [anon_sym_interface] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
  },
  [1090] = {
    [ts_builtin_sym_end] = ACTIONS(3085),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_export] = ACTIONS(3087),
    [anon_sym_default] = ACTIONS(3087),
    [anon_sym_namespace] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_type] = ACTIONS(3087),
    [anon_sym_typeof] = ACTIONS(3087),
    [anon_sym_import] = ACTIONS(3087),
    [anon_sym_var] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_const] = ACTIONS(3087),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_else] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_switch] = ACTIONS(3087),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3085),
    [anon_sym_await] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_with] = ACTIONS(3087),
    [anon_sym_break] = ACTIONS(3087),
    [anon_sym_continue] = ACTIONS(3087),
    [anon_sym_debugger] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_throw] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_case] = ACTIONS(3087),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_SLASH] = ACTIONS(3087),
    [anon_sym_class] = ACTIONS(3087),
    [anon_sym_async] = ACTIONS(3087),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_void] = ACTIONS(3087),
    [anon_sym_delete] = ACTIONS(3087),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3085),
    [sym_number] = ACTIONS(3085),
    [sym_this] = ACTIONS(3087),
    [sym_super] = ACTIONS(3087),
    [sym_true] = ACTIONS(3087),
    [sym_false] = ACTIONS(3087),
    [sym_null] = ACTIONS(3087),
    [sym_undefined] = ACTIONS(3087),
    [anon_sym_AT] = ACTIONS(3085),
    [anon_sym_declare] = ACTIONS(3087),
    [anon_sym_static] = ACTIONS(3087),
    [anon_sym_readonly] = ACTIONS(3087),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_get] = ACTIONS(3087),
    [anon_sym_set] = ACTIONS(3087),
    [anon_sym_public] = ACTIONS(3087),
    [anon_sym_private] = ACTIONS(3087),
    [anon_sym_protected] = ACTIONS(3087),
    [anon_sym_module] = ACTIONS(3087),
    [anon_sym_any] = ACTIONS(3087),
    [anon_sym_number] = ACTIONS(3087),
    [anon_sym_boolean] = ACTIONS(3087),
    [anon_sym_string] = ACTIONS(3087),
    [anon_sym_symbol] = ACTIONS(3087),
    [anon_sym_interface] = ACTIONS(3087),
    [anon_sym_enum] = ACTIONS(3087),
  },
  [1091] = {
    [ts_builtin_sym_end] = ACTIONS(3089),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_export] = ACTIONS(3091),
    [anon_sym_default] = ACTIONS(3091),
    [anon_sym_namespace] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_RBRACE] = ACTIONS(3089),
    [anon_sym_type] = ACTIONS(3091),
    [anon_sym_typeof] = ACTIONS(3091),
    [anon_sym_import] = ACTIONS(3091),
    [anon_sym_var] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_else] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_switch] = ACTIONS(3091),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_LPAREN] = ACTIONS(3089),
    [anon_sym_await] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_with] = ACTIONS(3091),
    [anon_sym_break] = ACTIONS(3091),
    [anon_sym_continue] = ACTIONS(3091),
    [anon_sym_debugger] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_throw] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym_case] = ACTIONS(3091),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_SLASH] = ACTIONS(3091),
    [anon_sym_class] = ACTIONS(3091),
    [anon_sym_async] = ACTIONS(3091),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_delete] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3089),
    [sym_number] = ACTIONS(3089),
    [sym_this] = ACTIONS(3091),
    [sym_super] = ACTIONS(3091),
    [sym_true] = ACTIONS(3091),
    [sym_false] = ACTIONS(3091),
    [sym_null] = ACTIONS(3091),
    [sym_undefined] = ACTIONS(3091),
    [anon_sym_AT] = ACTIONS(3089),
    [anon_sym_declare] = ACTIONS(3091),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_readonly] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3091),
    [anon_sym_get] = ACTIONS(3091),
    [anon_sym_set] = ACTIONS(3091),
    [anon_sym_public] = ACTIONS(3091),
    [anon_sym_private] = ACTIONS(3091),
    [anon_sym_protected] = ACTIONS(3091),
    [anon_sym_module] = ACTIONS(3091),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_interface] = ACTIONS(3091),
    [anon_sym_enum] = ACTIONS(3091),
  },
  [1092] = {
    [ts_builtin_sym_end] = ACTIONS(3093),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_export] = ACTIONS(3095),
    [anon_sym_default] = ACTIONS(3095),
    [anon_sym_namespace] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3093),
    [anon_sym_RBRACE] = ACTIONS(3093),
    [anon_sym_type] = ACTIONS(3095),
    [anon_sym_typeof] = ACTIONS(3095),
    [anon_sym_import] = ACTIONS(3095),
    [anon_sym_var] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_const] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_else] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_switch] = ACTIONS(3095),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3093),
    [anon_sym_await] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_with] = ACTIONS(3095),
    [anon_sym_break] = ACTIONS(3095),
    [anon_sym_continue] = ACTIONS(3095),
    [anon_sym_debugger] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_throw] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_case] = ACTIONS(3095),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_class] = ACTIONS(3095),
    [anon_sym_async] = ACTIONS(3095),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_void] = ACTIONS(3095),
    [anon_sym_delete] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3093),
    [sym_this] = ACTIONS(3095),
    [sym_super] = ACTIONS(3095),
    [sym_true] = ACTIONS(3095),
    [sym_false] = ACTIONS(3095),
    [sym_null] = ACTIONS(3095),
    [sym_undefined] = ACTIONS(3095),
    [anon_sym_AT] = ACTIONS(3093),
    [anon_sym_declare] = ACTIONS(3095),
    [anon_sym_static] = ACTIONS(3095),
    [anon_sym_readonly] = ACTIONS(3095),
    [anon_sym_abstract] = ACTIONS(3095),
    [anon_sym_get] = ACTIONS(3095),
    [anon_sym_set] = ACTIONS(3095),
    [anon_sym_public] = ACTIONS(3095),
    [anon_sym_private] = ACTIONS(3095),
    [anon_sym_protected] = ACTIONS(3095),
    [anon_sym_module] = ACTIONS(3095),
    [anon_sym_any] = ACTIONS(3095),
    [anon_sym_number] = ACTIONS(3095),
    [anon_sym_boolean] = ACTIONS(3095),
    [anon_sym_string] = ACTIONS(3095),
    [anon_sym_symbol] = ACTIONS(3095),
    [anon_sym_interface] = ACTIONS(3095),
    [anon_sym_enum] = ACTIONS(3095),
  },
  [1093] = {
    [ts_builtin_sym_end] = ACTIONS(3097),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_default] = ACTIONS(3099),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_LBRACE] = ACTIONS(3097),
    [anon_sym_RBRACE] = ACTIONS(3097),
    [anon_sym_type] = ACTIONS(3099),
    [anon_sym_typeof] = ACTIONS(3099),
    [anon_sym_import] = ACTIONS(3099),
    [anon_sym_var] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_const] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_switch] = ACTIONS(3099),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3097),
    [anon_sym_await] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_with] = ACTIONS(3099),
    [anon_sym_break] = ACTIONS(3099),
    [anon_sym_continue] = ACTIONS(3099),
    [anon_sym_debugger] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_throw] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_case] = ACTIONS(3099),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_SLASH] = ACTIONS(3099),
    [anon_sym_class] = ACTIONS(3099),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_void] = ACTIONS(3099),
    [anon_sym_delete] = ACTIONS(3099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3097),
    [anon_sym_DASH_DASH] = ACTIONS(3097),
    [anon_sym_DQUOTE] = ACTIONS(3097),
    [anon_sym_SQUOTE] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3097),
    [sym_number] = ACTIONS(3097),
    [sym_this] = ACTIONS(3099),
    [sym_super] = ACTIONS(3099),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_AT] = ACTIONS(3097),
    [anon_sym_declare] = ACTIONS(3099),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3099),
    [anon_sym_abstract] = ACTIONS(3099),
    [anon_sym_get] = ACTIONS(3099),
    [anon_sym_set] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_module] = ACTIONS(3099),
    [anon_sym_any] = ACTIONS(3099),
    [anon_sym_number] = ACTIONS(3099),
    [anon_sym_boolean] = ACTIONS(3099),
    [anon_sym_string] = ACTIONS(3099),
    [anon_sym_symbol] = ACTIONS(3099),
    [anon_sym_interface] = ACTIONS(3099),
    [anon_sym_enum] = ACTIONS(3099),
  },
  [1094] = {
    [ts_builtin_sym_end] = ACTIONS(2016),
    [sym_identifier] = ACTIONS(2018),
    [anon_sym_export] = ACTIONS(2018),
    [anon_sym_default] = ACTIONS(2018),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_LBRACE] = ACTIONS(2016),
    [anon_sym_RBRACE] = ACTIONS(2016),
    [anon_sym_type] = ACTIONS(2018),
    [anon_sym_typeof] = ACTIONS(2018),
    [anon_sym_import] = ACTIONS(2018),
    [anon_sym_var] = ACTIONS(2018),
    [anon_sym_let] = ACTIONS(2018),
    [anon_sym_const] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_else] = ACTIONS(2018),
    [anon_sym_if] = ACTIONS(2018),
    [anon_sym_switch] = ACTIONS(2018),
    [anon_sym_for] = ACTIONS(2018),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [anon_sym_await] = ACTIONS(2018),
    [anon_sym_while] = ACTIONS(2018),
    [anon_sym_do] = ACTIONS(2018),
    [anon_sym_try] = ACTIONS(2018),
    [anon_sym_with] = ACTIONS(2018),
    [anon_sym_break] = ACTIONS(2018),
    [anon_sym_continue] = ACTIONS(2018),
    [anon_sym_debugger] = ACTIONS(2018),
    [anon_sym_return] = ACTIONS(2018),
    [anon_sym_throw] = ACTIONS(2018),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_case] = ACTIONS(2018),
    [anon_sym_yield] = ACTIONS(2018),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(2016),
    [anon_sym_SLASH] = ACTIONS(2018),
    [anon_sym_class] = ACTIONS(2018),
    [anon_sym_async] = ACTIONS(2018),
    [anon_sym_function] = ACTIONS(2018),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2016),
    [anon_sym_void] = ACTIONS(2018),
    [anon_sym_delete] = ACTIONS(2018),
    [anon_sym_PLUS_PLUS] = ACTIONS(2016),
    [anon_sym_DASH_DASH] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(2016),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2016),
    [sym_number] = ACTIONS(2016),
    [sym_this] = ACTIONS(2018),
    [sym_super] = ACTIONS(2018),
    [sym_true] = ACTIONS(2018),
    [sym_false] = ACTIONS(2018),
    [sym_null] = ACTIONS(2018),
    [sym_undefined] = ACTIONS(2018),
    [anon_sym_AT] = ACTIONS(2016),
    [anon_sym_declare] = ACTIONS(2018),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_readonly] = ACTIONS(2018),
    [anon_sym_abstract] = ACTIONS(2018),
    [anon_sym_get] = ACTIONS(2018),
    [anon_sym_set] = ACTIONS(2018),
    [anon_sym_public] = ACTIONS(2018),
    [anon_sym_private] = ACTIONS(2018),
    [anon_sym_protected] = ACTIONS(2018),
    [anon_sym_module] = ACTIONS(2018),
    [anon_sym_any] = ACTIONS(2018),
    [anon_sym_number] = ACTIONS(2018),
    [anon_sym_boolean] = ACTIONS(2018),
    [anon_sym_string] = ACTIONS(2018),
    [anon_sym_symbol] = ACTIONS(2018),
    [anon_sym_interface] = ACTIONS(2018),
    [anon_sym_enum] = ACTIONS(2018),
  },
  [1095] = {
    [ts_builtin_sym_end] = ACTIONS(3101),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_default] = ACTIONS(3103),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_LBRACE] = ACTIONS(3101),
    [anon_sym_RBRACE] = ACTIONS(3101),
    [anon_sym_type] = ACTIONS(3103),
    [anon_sym_typeof] = ACTIONS(3103),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_var] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_const] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_else] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_switch] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [anon_sym_await] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_with] = ACTIONS(3103),
    [anon_sym_break] = ACTIONS(3103),
    [anon_sym_continue] = ACTIONS(3103),
    [anon_sym_debugger] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_throw] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3101),
    [anon_sym_case] = ACTIONS(3103),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_SLASH] = ACTIONS(3103),
    [anon_sym_class] = ACTIONS(3103),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_void] = ACTIONS(3103),
    [anon_sym_delete] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3101),
    [anon_sym_DQUOTE] = ACTIONS(3101),
    [anon_sym_SQUOTE] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3101),
    [sym_number] = ACTIONS(3101),
    [sym_this] = ACTIONS(3103),
    [sym_super] = ACTIONS(3103),
    [sym_true] = ACTIONS(3103),
    [sym_false] = ACTIONS(3103),
    [sym_null] = ACTIONS(3103),
    [sym_undefined] = ACTIONS(3103),
    [anon_sym_AT] = ACTIONS(3101),
    [anon_sym_declare] = ACTIONS(3103),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_abstract] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3103),
    [anon_sym_number] = ACTIONS(3103),
    [anon_sym_boolean] = ACTIONS(3103),
    [anon_sym_string] = ACTIONS(3103),
    [anon_sym_symbol] = ACTIONS(3103),
    [anon_sym_interface] = ACTIONS(3103),
    [anon_sym_enum] = ACTIONS(3103),
  },
  [1096] = {
    [ts_builtin_sym_end] = ACTIONS(3105),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_export] = ACTIONS(3107),
    [anon_sym_default] = ACTIONS(3107),
    [anon_sym_namespace] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3105),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_type] = ACTIONS(3107),
    [anon_sym_typeof] = ACTIONS(3107),
    [anon_sym_import] = ACTIONS(3107),
    [anon_sym_var] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_const] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3105),
    [anon_sym_else] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_switch] = ACTIONS(3107),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_await] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_with] = ACTIONS(3107),
    [anon_sym_break] = ACTIONS(3107),
    [anon_sym_continue] = ACTIONS(3107),
    [anon_sym_debugger] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_throw] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_case] = ACTIONS(3107),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_SLASH] = ACTIONS(3107),
    [anon_sym_class] = ACTIONS(3107),
    [anon_sym_async] = ACTIONS(3107),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_void] = ACTIONS(3107),
    [anon_sym_delete] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3105),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [anon_sym_SQUOTE] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3105),
    [sym_number] = ACTIONS(3105),
    [sym_this] = ACTIONS(3107),
    [sym_super] = ACTIONS(3107),
    [sym_true] = ACTIONS(3107),
    [sym_false] = ACTIONS(3107),
    [sym_null] = ACTIONS(3107),
    [sym_undefined] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3105),
    [anon_sym_declare] = ACTIONS(3107),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_abstract] = ACTIONS(3107),
    [anon_sym_get] = ACTIONS(3107),
    [anon_sym_set] = ACTIONS(3107),
    [anon_sym_public] = ACTIONS(3107),
    [anon_sym_private] = ACTIONS(3107),
    [anon_sym_protected] = ACTIONS(3107),
    [anon_sym_module] = ACTIONS(3107),
    [anon_sym_any] = ACTIONS(3107),
    [anon_sym_number] = ACTIONS(3107),
    [anon_sym_boolean] = ACTIONS(3107),
    [anon_sym_string] = ACTIONS(3107),
    [anon_sym_symbol] = ACTIONS(3107),
    [anon_sym_interface] = ACTIONS(3107),
    [anon_sym_enum] = ACTIONS(3107),
  },
  [1097] = {
    [ts_builtin_sym_end] = ACTIONS(3109),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_export] = ACTIONS(3111),
    [anon_sym_default] = ACTIONS(3111),
    [anon_sym_namespace] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [anon_sym_RBRACE] = ACTIONS(3109),
    [anon_sym_type] = ACTIONS(3111),
    [anon_sym_typeof] = ACTIONS(3111),
    [anon_sym_import] = ACTIONS(3111),
    [anon_sym_var] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_BANG] = ACTIONS(3109),
    [anon_sym_else] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_switch] = ACTIONS(3111),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3109),
    [anon_sym_await] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_with] = ACTIONS(3111),
    [anon_sym_break] = ACTIONS(3111),
    [anon_sym_continue] = ACTIONS(3111),
    [anon_sym_debugger] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_throw] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3109),
    [anon_sym_case] = ACTIONS(3111),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_SLASH] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_async] = ACTIONS(3111),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3109),
    [anon_sym_void] = ACTIONS(3111),
    [anon_sym_delete] = ACTIONS(3111),
    [anon_sym_PLUS_PLUS] = ACTIONS(3109),
    [anon_sym_DASH_DASH] = ACTIONS(3109),
    [anon_sym_DQUOTE] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(3109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3109),
    [sym_number] = ACTIONS(3109),
    [sym_this] = ACTIONS(3111),
    [sym_super] = ACTIONS(3111),
    [sym_true] = ACTIONS(3111),
    [sym_false] = ACTIONS(3111),
    [sym_null] = ACTIONS(3111),
    [sym_undefined] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(3109),
    [anon_sym_declare] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_readonly] = ACTIONS(3111),
    [anon_sym_abstract] = ACTIONS(3111),
    [anon_sym_get] = ACTIONS(3111),
    [anon_sym_set] = ACTIONS(3111),
    [anon_sym_public] = ACTIONS(3111),
    [anon_sym_private] = ACTIONS(3111),
    [anon_sym_protected] = ACTIONS(3111),
    [anon_sym_module] = ACTIONS(3111),
    [anon_sym_any] = ACTIONS(3111),
    [anon_sym_number] = ACTIONS(3111),
    [anon_sym_boolean] = ACTIONS(3111),
    [anon_sym_string] = ACTIONS(3111),
    [anon_sym_symbol] = ACTIONS(3111),
    [anon_sym_interface] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
  },
  [1098] = {
    [ts_builtin_sym_end] = ACTIONS(3113),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_export] = ACTIONS(3115),
    [anon_sym_default] = ACTIONS(3115),
    [anon_sym_namespace] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_RBRACE] = ACTIONS(3113),
    [anon_sym_type] = ACTIONS(3115),
    [anon_sym_typeof] = ACTIONS(3115),
    [anon_sym_import] = ACTIONS(3115),
    [anon_sym_var] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_const] = ACTIONS(3115),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_else] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_switch] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(3113),
    [anon_sym_await] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_with] = ACTIONS(3115),
    [anon_sym_break] = ACTIONS(3115),
    [anon_sym_continue] = ACTIONS(3115),
    [anon_sym_debugger] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_throw] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym_case] = ACTIONS(3115),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_class] = ACTIONS(3115),
    [anon_sym_async] = ACTIONS(3115),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_void] = ACTIONS(3115),
    [anon_sym_delete] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_DQUOTE] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3113),
    [sym_number] = ACTIONS(3113),
    [sym_this] = ACTIONS(3115),
    [sym_super] = ACTIONS(3115),
    [sym_true] = ACTIONS(3115),
    [sym_false] = ACTIONS(3115),
    [sym_null] = ACTIONS(3115),
    [sym_undefined] = ACTIONS(3115),
    [anon_sym_AT] = ACTIONS(3113),
    [anon_sym_declare] = ACTIONS(3115),
    [anon_sym_static] = ACTIONS(3115),
    [anon_sym_readonly] = ACTIONS(3115),
    [anon_sym_abstract] = ACTIONS(3115),
    [anon_sym_get] = ACTIONS(3115),
    [anon_sym_set] = ACTIONS(3115),
    [anon_sym_public] = ACTIONS(3115),
    [anon_sym_private] = ACTIONS(3115),
    [anon_sym_protected] = ACTIONS(3115),
    [anon_sym_module] = ACTIONS(3115),
    [anon_sym_any] = ACTIONS(3115),
    [anon_sym_number] = ACTIONS(3115),
    [anon_sym_boolean] = ACTIONS(3115),
    [anon_sym_string] = ACTIONS(3115),
    [anon_sym_symbol] = ACTIONS(3115),
    [anon_sym_interface] = ACTIONS(3115),
    [anon_sym_enum] = ACTIONS(3115),
  },
  [1099] = {
    [ts_builtin_sym_end] = ACTIONS(3117),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_export] = ACTIONS(3119),
    [anon_sym_default] = ACTIONS(3119),
    [anon_sym_namespace] = ACTIONS(3119),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_type] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_import] = ACTIONS(3119),
    [anon_sym_var] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_const] = ACTIONS(3119),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_else] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_switch] = ACTIONS(3119),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_await] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_with] = ACTIONS(3119),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_continue] = ACTIONS(3119),
    [anon_sym_debugger] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_throw] = ACTIONS(3119),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_case] = ACTIONS(3119),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_SLASH] = ACTIONS(3119),
    [anon_sym_class] = ACTIONS(3119),
    [anon_sym_async] = ACTIONS(3119),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3117),
    [anon_sym_void] = ACTIONS(3119),
    [anon_sym_delete] = ACTIONS(3119),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [anon_sym_DQUOTE] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [sym_number] = ACTIONS(3117),
    [sym_this] = ACTIONS(3119),
    [sym_super] = ACTIONS(3119),
    [sym_true] = ACTIONS(3119),
    [sym_false] = ACTIONS(3119),
    [sym_null] = ACTIONS(3119),
    [sym_undefined] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3117),
    [anon_sym_declare] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(3119),
    [anon_sym_abstract] = ACTIONS(3119),
    [anon_sym_get] = ACTIONS(3119),
    [anon_sym_set] = ACTIONS(3119),
    [anon_sym_public] = ACTIONS(3119),
    [anon_sym_private] = ACTIONS(3119),
    [anon_sym_protected] = ACTIONS(3119),
    [anon_sym_module] = ACTIONS(3119),
    [anon_sym_any] = ACTIONS(3119),
    [anon_sym_number] = ACTIONS(3119),
    [anon_sym_boolean] = ACTIONS(3119),
    [anon_sym_string] = ACTIONS(3119),
    [anon_sym_symbol] = ACTIONS(3119),
    [anon_sym_interface] = ACTIONS(3119),
    [anon_sym_enum] = ACTIONS(3119),
  },
  [1100] = {
    [ts_builtin_sym_end] = ACTIONS(3121),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_export] = ACTIONS(3123),
    [anon_sym_default] = ACTIONS(3123),
    [anon_sym_namespace] = ACTIONS(3123),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_type] = ACTIONS(3123),
    [anon_sym_typeof] = ACTIONS(3123),
    [anon_sym_import] = ACTIONS(3123),
    [anon_sym_var] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_const] = ACTIONS(3123),
    [anon_sym_BANG] = ACTIONS(3121),
    [anon_sym_else] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_switch] = ACTIONS(3123),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_await] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_with] = ACTIONS(3123),
    [anon_sym_break] = ACTIONS(3123),
    [anon_sym_continue] = ACTIONS(3123),
    [anon_sym_debugger] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_throw] = ACTIONS(3123),
    [anon_sym_SEMI] = ACTIONS(3121),
    [anon_sym_case] = ACTIONS(3123),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_SLASH] = ACTIONS(3123),
    [anon_sym_class] = ACTIONS(3123),
    [anon_sym_async] = ACTIONS(3123),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_void] = ACTIONS(3123),
    [anon_sym_delete] = ACTIONS(3123),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_SQUOTE] = ACTIONS(3121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [sym_number] = ACTIONS(3121),
    [sym_this] = ACTIONS(3123),
    [sym_super] = ACTIONS(3123),
    [sym_true] = ACTIONS(3123),
    [sym_false] = ACTIONS(3123),
    [sym_null] = ACTIONS(3123),
    [sym_undefined] = ACTIONS(3123),
    [anon_sym_AT] = ACTIONS(3121),
    [anon_sym_declare] = ACTIONS(3123),
    [anon_sym_static] = ACTIONS(3123),
    [anon_sym_readonly] = ACTIONS(3123),
    [anon_sym_abstract] = ACTIONS(3123),
    [anon_sym_get] = ACTIONS(3123),
    [anon_sym_set] = ACTIONS(3123),
    [anon_sym_public] = ACTIONS(3123),
    [anon_sym_private] = ACTIONS(3123),
    [anon_sym_protected] = ACTIONS(3123),
    [anon_sym_module] = ACTIONS(3123),
    [anon_sym_any] = ACTIONS(3123),
    [anon_sym_number] = ACTIONS(3123),
    [anon_sym_boolean] = ACTIONS(3123),
    [anon_sym_string] = ACTIONS(3123),
    [anon_sym_symbol] = ACTIONS(3123),
    [anon_sym_interface] = ACTIONS(3123),
    [anon_sym_enum] = ACTIONS(3123),
  },
  [1101] = {
    [ts_builtin_sym_end] = ACTIONS(2016),
    [sym_identifier] = ACTIONS(2018),
    [anon_sym_export] = ACTIONS(2018),
    [anon_sym_default] = ACTIONS(2018),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_LBRACE] = ACTIONS(2016),
    [anon_sym_RBRACE] = ACTIONS(2016),
    [anon_sym_type] = ACTIONS(2018),
    [anon_sym_typeof] = ACTIONS(2018),
    [anon_sym_import] = ACTIONS(2018),
    [anon_sym_var] = ACTIONS(2018),
    [anon_sym_let] = ACTIONS(2018),
    [anon_sym_const] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_else] = ACTIONS(2018),
    [anon_sym_if] = ACTIONS(2018),
    [anon_sym_switch] = ACTIONS(2018),
    [anon_sym_for] = ACTIONS(2018),
    [anon_sym_LPAREN] = ACTIONS(2016),
    [anon_sym_await] = ACTIONS(2018),
    [anon_sym_while] = ACTIONS(2018),
    [anon_sym_do] = ACTIONS(2018),
    [anon_sym_try] = ACTIONS(2018),
    [anon_sym_with] = ACTIONS(2018),
    [anon_sym_break] = ACTIONS(2018),
    [anon_sym_continue] = ACTIONS(2018),
    [anon_sym_debugger] = ACTIONS(2018),
    [anon_sym_return] = ACTIONS(2018),
    [anon_sym_throw] = ACTIONS(2018),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_case] = ACTIONS(2018),
    [anon_sym_yield] = ACTIONS(2018),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(2016),
    [anon_sym_SLASH] = ACTIONS(2018),
    [anon_sym_class] = ACTIONS(2018),
    [anon_sym_async] = ACTIONS(2018),
    [anon_sym_function] = ACTIONS(2018),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2016),
    [anon_sym_void] = ACTIONS(2018),
    [anon_sym_delete] = ACTIONS(2018),
    [anon_sym_PLUS_PLUS] = ACTIONS(2016),
    [anon_sym_DASH_DASH] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(2016),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2016),
    [sym_number] = ACTIONS(2016),
    [sym_this] = ACTIONS(2018),
    [sym_super] = ACTIONS(2018),
    [sym_true] = ACTIONS(2018),
    [sym_false] = ACTIONS(2018),
    [sym_null] = ACTIONS(2018),
    [sym_undefined] = ACTIONS(2018),
    [anon_sym_AT] = ACTIONS(2016),
    [anon_sym_declare] = ACTIONS(2018),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_readonly] = ACTIONS(2018),
    [anon_sym_abstract] = ACTIONS(2018),
    [anon_sym_get] = ACTIONS(2018),
    [anon_sym_set] = ACTIONS(2018),
    [anon_sym_public] = ACTIONS(2018),
    [anon_sym_private] = ACTIONS(2018),
    [anon_sym_protected] = ACTIONS(2018),
    [anon_sym_module] = ACTIONS(2018),
    [anon_sym_any] = ACTIONS(2018),
    [anon_sym_number] = ACTIONS(2018),
    [anon_sym_boolean] = ACTIONS(2018),
    [anon_sym_string] = ACTIONS(2018),
    [anon_sym_symbol] = ACTIONS(2018),
    [anon_sym_interface] = ACTIONS(2018),
    [anon_sym_enum] = ACTIONS(2018),
  },
  [1102] = {
    [ts_builtin_sym_end] = ACTIONS(3125),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_export] = ACTIONS(3127),
    [anon_sym_default] = ACTIONS(3127),
    [anon_sym_namespace] = ACTIONS(3127),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_RBRACE] = ACTIONS(3125),
    [anon_sym_type] = ACTIONS(3127),
    [anon_sym_typeof] = ACTIONS(3127),
    [anon_sym_import] = ACTIONS(3127),
    [anon_sym_var] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_const] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3125),
    [anon_sym_else] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_switch] = ACTIONS(3127),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_LPAREN] = ACTIONS(3125),
    [anon_sym_await] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_with] = ACTIONS(3127),
    [anon_sym_break] = ACTIONS(3127),
    [anon_sym_continue] = ACTIONS(3127),
    [anon_sym_debugger] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_throw] = ACTIONS(3127),
    [anon_sym_SEMI] = ACTIONS(3125),
    [anon_sym_case] = ACTIONS(3127),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_class] = ACTIONS(3127),
    [anon_sym_async] = ACTIONS(3127),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3125),
    [anon_sym_void] = ACTIONS(3127),
    [anon_sym_delete] = ACTIONS(3127),
    [anon_sym_PLUS_PLUS] = ACTIONS(3125),
    [anon_sym_DASH_DASH] = ACTIONS(3125),
    [anon_sym_DQUOTE] = ACTIONS(3125),
    [anon_sym_SQUOTE] = ACTIONS(3125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3125),
    [sym_number] = ACTIONS(3125),
    [sym_this] = ACTIONS(3127),
    [sym_super] = ACTIONS(3127),
    [sym_true] = ACTIONS(3127),
    [sym_false] = ACTIONS(3127),
    [sym_null] = ACTIONS(3127),
    [sym_undefined] = ACTIONS(3127),
    [anon_sym_AT] = ACTIONS(3125),
    [anon_sym_declare] = ACTIONS(3127),
    [anon_sym_static] = ACTIONS(3127),
    [anon_sym_readonly] = ACTIONS(3127),
    [anon_sym_abstract] = ACTIONS(3127),
    [anon_sym_get] = ACTIONS(3127),
    [anon_sym_set] = ACTIONS(3127),
    [anon_sym_public] = ACTIONS(3127),
    [anon_sym_private] = ACTIONS(3127),
    [anon_sym_protected] = ACTIONS(3127),
    [anon_sym_module] = ACTIONS(3127),
    [anon_sym_any] = ACTIONS(3127),
    [anon_sym_number] = ACTIONS(3127),
    [anon_sym_boolean] = ACTIONS(3127),
    [anon_sym_string] = ACTIONS(3127),
    [anon_sym_symbol] = ACTIONS(3127),
    [anon_sym_interface] = ACTIONS(3127),
    [anon_sym_enum] = ACTIONS(3127),
  },
  [1103] = {
    [ts_builtin_sym_end] = ACTIONS(3129),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_export] = ACTIONS(3131),
    [anon_sym_default] = ACTIONS(3131),
    [anon_sym_namespace] = ACTIONS(3131),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_type] = ACTIONS(3131),
    [anon_sym_typeof] = ACTIONS(3131),
    [anon_sym_import] = ACTIONS(3131),
    [anon_sym_var] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_const] = ACTIONS(3131),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_else] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_switch] = ACTIONS(3131),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_await] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_with] = ACTIONS(3131),
    [anon_sym_break] = ACTIONS(3131),
    [anon_sym_continue] = ACTIONS(3131),
    [anon_sym_debugger] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_throw] = ACTIONS(3131),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_case] = ACTIONS(3131),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_class] = ACTIONS(3131),
    [anon_sym_async] = ACTIONS(3131),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3129),
    [anon_sym_void] = ACTIONS(3131),
    [anon_sym_delete] = ACTIONS(3131),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_DQUOTE] = ACTIONS(3129),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3129),
    [sym_number] = ACTIONS(3129),
    [sym_this] = ACTIONS(3131),
    [sym_super] = ACTIONS(3131),
    [sym_true] = ACTIONS(3131),
    [sym_false] = ACTIONS(3131),
    [sym_null] = ACTIONS(3131),
    [sym_undefined] = ACTIONS(3131),
    [anon_sym_AT] = ACTIONS(3129),
    [anon_sym_declare] = ACTIONS(3131),
    [anon_sym_static] = ACTIONS(3131),
    [anon_sym_readonly] = ACTIONS(3131),
    [anon_sym_abstract] = ACTIONS(3131),
    [anon_sym_get] = ACTIONS(3131),
    [anon_sym_set] = ACTIONS(3131),
    [anon_sym_public] = ACTIONS(3131),
    [anon_sym_private] = ACTIONS(3131),
    [anon_sym_protected] = ACTIONS(3131),
    [anon_sym_module] = ACTIONS(3131),
    [anon_sym_any] = ACTIONS(3131),
    [anon_sym_number] = ACTIONS(3131),
    [anon_sym_boolean] = ACTIONS(3131),
    [anon_sym_string] = ACTIONS(3131),
    [anon_sym_symbol] = ACTIONS(3131),
    [anon_sym_interface] = ACTIONS(3131),
    [anon_sym_enum] = ACTIONS(3131),
  },
  [1104] = {
    [ts_builtin_sym_end] = ACTIONS(3133),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_export] = ACTIONS(3135),
    [anon_sym_default] = ACTIONS(3135),
    [anon_sym_namespace] = ACTIONS(3135),
    [anon_sym_LBRACE] = ACTIONS(3133),
    [anon_sym_RBRACE] = ACTIONS(3133),
    [anon_sym_type] = ACTIONS(3135),
    [anon_sym_typeof] = ACTIONS(3135),
    [anon_sym_import] = ACTIONS(3135),
    [anon_sym_var] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_const] = ACTIONS(3135),
    [anon_sym_BANG] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_switch] = ACTIONS(3135),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3133),
    [anon_sym_await] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_with] = ACTIONS(3135),
    [anon_sym_break] = ACTIONS(3135),
    [anon_sym_continue] = ACTIONS(3135),
    [anon_sym_debugger] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_throw] = ACTIONS(3135),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym_case] = ACTIONS(3135),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_SLASH] = ACTIONS(3135),
    [anon_sym_class] = ACTIONS(3135),
    [anon_sym_async] = ACTIONS(3135),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_delete] = ACTIONS(3135),
    [anon_sym_PLUS_PLUS] = ACTIONS(3133),
    [anon_sym_DASH_DASH] = ACTIONS(3133),
    [anon_sym_DQUOTE] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3133),
    [sym_number] = ACTIONS(3133),
    [sym_this] = ACTIONS(3135),
    [sym_super] = ACTIONS(3135),
    [sym_true] = ACTIONS(3135),
    [sym_false] = ACTIONS(3135),
    [sym_null] = ACTIONS(3135),
    [sym_undefined] = ACTIONS(3135),
    [anon_sym_AT] = ACTIONS(3133),
    [anon_sym_declare] = ACTIONS(3135),
    [anon_sym_static] = ACTIONS(3135),
    [anon_sym_readonly] = ACTIONS(3135),
    [anon_sym_abstract] = ACTIONS(3135),
    [anon_sym_get] = ACTIONS(3135),
    [anon_sym_set] = ACTIONS(3135),
    [anon_sym_public] = ACTIONS(3135),
    [anon_sym_private] = ACTIONS(3135),
    [anon_sym_protected] = ACTIONS(3135),
    [anon_sym_module] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_interface] = ACTIONS(3135),
    [anon_sym_enum] = ACTIONS(3135),
  },
  [1105] = {
    [ts_builtin_sym_end] = ACTIONS(3137),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_export] = ACTIONS(3139),
    [anon_sym_default] = ACTIONS(3139),
    [anon_sym_namespace] = ACTIONS(3139),
    [anon_sym_LBRACE] = ACTIONS(3137),
    [anon_sym_RBRACE] = ACTIONS(3137),
    [anon_sym_type] = ACTIONS(3139),
    [anon_sym_typeof] = ACTIONS(3139),
    [anon_sym_import] = ACTIONS(3139),
    [anon_sym_var] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_const] = ACTIONS(3139),
    [anon_sym_BANG] = ACTIONS(3137),
    [anon_sym_else] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_switch] = ACTIONS(3139),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_LPAREN] = ACTIONS(3137),
    [anon_sym_await] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_with] = ACTIONS(3139),
    [anon_sym_break] = ACTIONS(3139),
    [anon_sym_continue] = ACTIONS(3139),
    [anon_sym_debugger] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_throw] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3137),
    [anon_sym_case] = ACTIONS(3139),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_SLASH] = ACTIONS(3139),
    [anon_sym_class] = ACTIONS(3139),
    [anon_sym_async] = ACTIONS(3139),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3137),
    [anon_sym_void] = ACTIONS(3139),
    [anon_sym_delete] = ACTIONS(3139),
    [anon_sym_PLUS_PLUS] = ACTIONS(3137),
    [anon_sym_DASH_DASH] = ACTIONS(3137),
    [anon_sym_DQUOTE] = ACTIONS(3137),
    [anon_sym_SQUOTE] = ACTIONS(3137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3137),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_super] = ACTIONS(3139),
    [sym_true] = ACTIONS(3139),
    [sym_false] = ACTIONS(3139),
    [sym_null] = ACTIONS(3139),
    [sym_undefined] = ACTIONS(3139),
    [anon_sym_AT] = ACTIONS(3137),
    [anon_sym_declare] = ACTIONS(3139),
    [anon_sym_static] = ACTIONS(3139),
    [anon_sym_readonly] = ACTIONS(3139),
    [anon_sym_abstract] = ACTIONS(3139),
    [anon_sym_get] = ACTIONS(3139),
    [anon_sym_set] = ACTIONS(3139),
    [anon_sym_public] = ACTIONS(3139),
    [anon_sym_private] = ACTIONS(3139),
    [anon_sym_protected] = ACTIONS(3139),
    [anon_sym_module] = ACTIONS(3139),
    [anon_sym_any] = ACTIONS(3139),
    [anon_sym_number] = ACTIONS(3139),
    [anon_sym_boolean] = ACTIONS(3139),
    [anon_sym_string] = ACTIONS(3139),
    [anon_sym_symbol] = ACTIONS(3139),
    [anon_sym_interface] = ACTIONS(3139),
    [anon_sym_enum] = ACTIONS(3139),
  },
  [1106] = {
    [ts_builtin_sym_end] = ACTIONS(3141),
    [sym_identifier] = ACTIONS(3143),
    [anon_sym_export] = ACTIONS(3143),
    [anon_sym_default] = ACTIONS(3143),
    [anon_sym_namespace] = ACTIONS(3143),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_RBRACE] = ACTIONS(3141),
    [anon_sym_type] = ACTIONS(3143),
    [anon_sym_typeof] = ACTIONS(3143),
    [anon_sym_import] = ACTIONS(3143),
    [anon_sym_var] = ACTIONS(3143),
    [anon_sym_let] = ACTIONS(3143),
    [anon_sym_const] = ACTIONS(3143),
    [anon_sym_BANG] = ACTIONS(3141),
    [anon_sym_else] = ACTIONS(3143),
    [anon_sym_if] = ACTIONS(3143),
    [anon_sym_switch] = ACTIONS(3143),
    [anon_sym_for] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(3141),
    [anon_sym_await] = ACTIONS(3143),
    [anon_sym_while] = ACTIONS(3143),
    [anon_sym_do] = ACTIONS(3143),
    [anon_sym_try] = ACTIONS(3143),
    [anon_sym_with] = ACTIONS(3143),
    [anon_sym_break] = ACTIONS(3143),
    [anon_sym_continue] = ACTIONS(3143),
    [anon_sym_debugger] = ACTIONS(3143),
    [anon_sym_return] = ACTIONS(3143),
    [anon_sym_throw] = ACTIONS(3143),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_case] = ACTIONS(3143),
    [anon_sym_yield] = ACTIONS(3143),
    [anon_sym_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_SLASH] = ACTIONS(3143),
    [anon_sym_class] = ACTIONS(3143),
    [anon_sym_async] = ACTIONS(3143),
    [anon_sym_function] = ACTIONS(3143),
    [anon_sym_new] = ACTIONS(3143),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_TILDE] = ACTIONS(3141),
    [anon_sym_void] = ACTIONS(3143),
    [anon_sym_delete] = ACTIONS(3143),
    [anon_sym_PLUS_PLUS] = ACTIONS(3141),
    [anon_sym_DASH_DASH] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(3141),
    [anon_sym_SQUOTE] = ACTIONS(3141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3141),
    [sym_number] = ACTIONS(3141),
    [sym_this] = ACTIONS(3143),
    [sym_super] = ACTIONS(3143),
    [sym_true] = ACTIONS(3143),
    [sym_false] = ACTIONS(3143),
    [sym_null] = ACTIONS(3143),
    [sym_undefined] = ACTIONS(3143),
    [anon_sym_AT] = ACTIONS(3141),
    [anon_sym_declare] = ACTIONS(3143),
    [anon_sym_static] = ACTIONS(3143),
    [anon_sym_readonly] = ACTIONS(3143),
    [anon_sym_abstract] = ACTIONS(3143),
    [anon_sym_get] = ACTIONS(3143),
    [anon_sym_set] = ACTIONS(3143),
    [anon_sym_public] = ACTIONS(3143),
    [anon_sym_private] = ACTIONS(3143),
    [anon_sym_protected] = ACTIONS(3143),
    [anon_sym_module] = ACTIONS(3143),
    [anon_sym_any] = ACTIONS(3143),
    [anon_sym_number] = ACTIONS(3143),
    [anon_sym_boolean] = ACTIONS(3143),
    [anon_sym_string] = ACTIONS(3143),
    [anon_sym_symbol] = ACTIONS(3143),
    [anon_sym_interface] = ACTIONS(3143),
    [anon_sym_enum] = ACTIONS(3143),
  },
  [1107] = {
    [ts_builtin_sym_end] = ACTIONS(3145),
    [sym_identifier] = ACTIONS(3147),
    [anon_sym_export] = ACTIONS(3147),
    [anon_sym_default] = ACTIONS(3147),
    [anon_sym_namespace] = ACTIONS(3147),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_RBRACE] = ACTIONS(3145),
    [anon_sym_type] = ACTIONS(3147),
    [anon_sym_typeof] = ACTIONS(3147),
    [anon_sym_import] = ACTIONS(3147),
    [anon_sym_var] = ACTIONS(3147),
    [anon_sym_let] = ACTIONS(3147),
    [anon_sym_const] = ACTIONS(3147),
    [anon_sym_BANG] = ACTIONS(3145),
    [anon_sym_else] = ACTIONS(3147),
    [anon_sym_if] = ACTIONS(3147),
    [anon_sym_switch] = ACTIONS(3147),
    [anon_sym_for] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_await] = ACTIONS(3147),
    [anon_sym_while] = ACTIONS(3147),
    [anon_sym_do] = ACTIONS(3147),
    [anon_sym_try] = ACTIONS(3147),
    [anon_sym_with] = ACTIONS(3147),
    [anon_sym_break] = ACTIONS(3147),
    [anon_sym_continue] = ACTIONS(3147),
    [anon_sym_debugger] = ACTIONS(3147),
    [anon_sym_return] = ACTIONS(3147),
    [anon_sym_throw] = ACTIONS(3147),
    [anon_sym_SEMI] = ACTIONS(3145),
    [anon_sym_case] = ACTIONS(3147),
    [anon_sym_yield] = ACTIONS(3147),
    [anon_sym_LBRACK] = ACTIONS(3145),
    [anon_sym_LT] = ACTIONS(3145),
    [anon_sym_SLASH] = ACTIONS(3147),
    [anon_sym_class] = ACTIONS(3147),
    [anon_sym_async] = ACTIONS(3147),
    [anon_sym_function] = ACTIONS(3147),
    [anon_sym_new] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_DASH] = ACTIONS(3147),
    [anon_sym_TILDE] = ACTIONS(3145),
    [anon_sym_void] = ACTIONS(3147),
    [anon_sym_delete] = ACTIONS(3147),
    [anon_sym_PLUS_PLUS] = ACTIONS(3145),
    [anon_sym_DASH_DASH] = ACTIONS(3145),
    [anon_sym_DQUOTE] = ACTIONS(3145),
    [anon_sym_SQUOTE] = ACTIONS(3145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3145),
    [sym_number] = ACTIONS(3145),
    [sym_this] = ACTIONS(3147),
    [sym_super] = ACTIONS(3147),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [sym_null] = ACTIONS(3147),
    [sym_undefined] = ACTIONS(3147),
    [anon_sym_AT] = ACTIONS(3145),
    [anon_sym_declare] = ACTIONS(3147),
    [anon_sym_static] = ACTIONS(3147),
    [anon_sym_readonly] = ACTIONS(3147),
    [anon_sym_abstract] = ACTIONS(3147),
    [anon_sym_get] = ACTIONS(3147),
    [anon_sym_set] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(3147),
    [anon_sym_private] = ACTIONS(3147),
    [anon_sym_protected] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3147),
    [anon_sym_number] = ACTIONS(3147),
    [anon_sym_boolean] = ACTIONS(3147),
    [anon_sym_string] = ACTIONS(3147),
    [anon_sym_symbol] = ACTIONS(3147),
    [anon_sym_interface] = ACTIONS(3147),
    [anon_sym_enum] = ACTIONS(3147),
  },
  [1108] = {
    [ts_builtin_sym_end] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_export] = ACTIONS(3151),
    [anon_sym_default] = ACTIONS(3151),
    [anon_sym_namespace] = ACTIONS(3151),
    [anon_sym_LBRACE] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(3149),
    [anon_sym_type] = ACTIONS(3151),
    [anon_sym_typeof] = ACTIONS(3151),
    [anon_sym_import] = ACTIONS(3151),
    [anon_sym_var] = ACTIONS(3151),
    [anon_sym_let] = ACTIONS(3151),
    [anon_sym_const] = ACTIONS(3151),
    [anon_sym_BANG] = ACTIONS(3149),
    [anon_sym_else] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_switch] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(3149),
    [anon_sym_await] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [anon_sym_do] = ACTIONS(3151),
    [anon_sym_try] = ACTIONS(3151),
    [anon_sym_with] = ACTIONS(3151),
    [anon_sym_break] = ACTIONS(3151),
    [anon_sym_continue] = ACTIONS(3151),
    [anon_sym_debugger] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_throw] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(3149),
    [anon_sym_case] = ACTIONS(3151),
    [anon_sym_yield] = ACTIONS(3151),
    [anon_sym_LBRACK] = ACTIONS(3149),
    [anon_sym_LT] = ACTIONS(3149),
    [anon_sym_SLASH] = ACTIONS(3151),
    [anon_sym_class] = ACTIONS(3151),
    [anon_sym_async] = ACTIONS(3151),
    [anon_sym_function] = ACTIONS(3151),
    [anon_sym_new] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(3151),
    [anon_sym_DASH] = ACTIONS(3151),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_void] = ACTIONS(3151),
    [anon_sym_delete] = ACTIONS(3151),
    [anon_sym_PLUS_PLUS] = ACTIONS(3149),
    [anon_sym_DASH_DASH] = ACTIONS(3149),
    [anon_sym_DQUOTE] = ACTIONS(3149),
    [anon_sym_SQUOTE] = ACTIONS(3149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3149),
    [sym_number] = ACTIONS(3149),
    [sym_this] = ACTIONS(3151),
    [sym_super] = ACTIONS(3151),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_null] = ACTIONS(3151),
    [sym_undefined] = ACTIONS(3151),
    [anon_sym_AT] = ACTIONS(3149),
    [anon_sym_declare] = ACTIONS(3151),
    [anon_sym_static] = ACTIONS(3151),
    [anon_sym_readonly] = ACTIONS(3151),
    [anon_sym_abstract] = ACTIONS(3151),
    [anon_sym_get] = ACTIONS(3151),
    [anon_sym_set] = ACTIONS(3151),
    [anon_sym_public] = ACTIONS(3151),
    [anon_sym_private] = ACTIONS(3151),
    [anon_sym_protected] = ACTIONS(3151),
    [anon_sym_module] = ACTIONS(3151),
    [anon_sym_any] = ACTIONS(3151),
    [anon_sym_number] = ACTIONS(3151),
    [anon_sym_boolean] = ACTIONS(3151),
    [anon_sym_string] = ACTIONS(3151),
    [anon_sym_symbol] = ACTIONS(3151),
    [anon_sym_interface] = ACTIONS(3151),
    [anon_sym_enum] = ACTIONS(3151),
  },
  [1109] = {
    [ts_builtin_sym_end] = ACTIONS(3153),
    [sym_identifier] = ACTIONS(3155),
    [anon_sym_export] = ACTIONS(3155),
    [anon_sym_default] = ACTIONS(3155),
    [anon_sym_namespace] = ACTIONS(3155),
    [anon_sym_LBRACE] = ACTIONS(3153),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_type] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3155),
    [anon_sym_import] = ACTIONS(3155),
    [anon_sym_var] = ACTIONS(3155),
    [anon_sym_let] = ACTIONS(3155),
    [anon_sym_const] = ACTIONS(3155),
    [anon_sym_BANG] = ACTIONS(3153),
    [anon_sym_else] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(3155),
    [anon_sym_switch] = ACTIONS(3155),
    [anon_sym_for] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3153),
    [anon_sym_await] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(3155),
    [anon_sym_do] = ACTIONS(3155),
    [anon_sym_try] = ACTIONS(3155),
    [anon_sym_with] = ACTIONS(3155),
    [anon_sym_break] = ACTIONS(3155),
    [anon_sym_continue] = ACTIONS(3155),
    [anon_sym_debugger] = ACTIONS(3155),
    [anon_sym_return] = ACTIONS(3155),
    [anon_sym_throw] = ACTIONS(3155),
    [anon_sym_SEMI] = ACTIONS(3153),
    [anon_sym_case] = ACTIONS(3155),
    [anon_sym_yield] = ACTIONS(3155),
    [anon_sym_LBRACK] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3153),
    [anon_sym_SLASH] = ACTIONS(3155),
    [anon_sym_class] = ACTIONS(3155),
    [anon_sym_async] = ACTIONS(3155),
    [anon_sym_function] = ACTIONS(3155),
    [anon_sym_new] = ACTIONS(3155),
    [anon_sym_PLUS] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3155),
    [anon_sym_TILDE] = ACTIONS(3153),
    [anon_sym_void] = ACTIONS(3155),
    [anon_sym_delete] = ACTIONS(3155),
    [anon_sym_PLUS_PLUS] = ACTIONS(3153),
    [anon_sym_DASH_DASH] = ACTIONS(3153),
    [anon_sym_DQUOTE] = ACTIONS(3153),
    [anon_sym_SQUOTE] = ACTIONS(3153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3153),
    [sym_number] = ACTIONS(3153),
    [sym_this] = ACTIONS(3155),
    [sym_super] = ACTIONS(3155),
    [sym_true] = ACTIONS(3155),
    [sym_false] = ACTIONS(3155),
    [sym_null] = ACTIONS(3155),
    [sym_undefined] = ACTIONS(3155),
    [anon_sym_AT] = ACTIONS(3153),
    [anon_sym_declare] = ACTIONS(3155),
    [anon_sym_static] = ACTIONS(3155),
    [anon_sym_readonly] = ACTIONS(3155),
    [anon_sym_abstract] = ACTIONS(3155),
    [anon_sym_get] = ACTIONS(3155),
    [anon_sym_set] = ACTIONS(3155),
    [anon_sym_public] = ACTIONS(3155),
    [anon_sym_private] = ACTIONS(3155),
    [anon_sym_protected] = ACTIONS(3155),
    [anon_sym_module] = ACTIONS(3155),
    [anon_sym_any] = ACTIONS(3155),
    [anon_sym_number] = ACTIONS(3155),
    [anon_sym_boolean] = ACTIONS(3155),
    [anon_sym_string] = ACTIONS(3155),
    [anon_sym_symbol] = ACTIONS(3155),
    [anon_sym_interface] = ACTIONS(3155),
    [anon_sym_enum] = ACTIONS(3155),
  },
  [1110] = {
    [ts_builtin_sym_end] = ACTIONS(3157),
    [sym_identifier] = ACTIONS(3159),
    [anon_sym_export] = ACTIONS(3159),
    [anon_sym_default] = ACTIONS(3159),
    [anon_sym_namespace] = ACTIONS(3159),
    [anon_sym_LBRACE] = ACTIONS(3157),
    [anon_sym_RBRACE] = ACTIONS(3157),
    [anon_sym_type] = ACTIONS(3159),
    [anon_sym_typeof] = ACTIONS(3159),
    [anon_sym_import] = ACTIONS(3159),
    [anon_sym_var] = ACTIONS(3159),
    [anon_sym_let] = ACTIONS(3159),
    [anon_sym_const] = ACTIONS(3159),
    [anon_sym_BANG] = ACTIONS(3157),
    [anon_sym_else] = ACTIONS(3159),
    [anon_sym_if] = ACTIONS(3159),
    [anon_sym_switch] = ACTIONS(3159),
    [anon_sym_for] = ACTIONS(3159),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [anon_sym_await] = ACTIONS(3159),
    [anon_sym_while] = ACTIONS(3159),
    [anon_sym_do] = ACTIONS(3159),
    [anon_sym_try] = ACTIONS(3159),
    [anon_sym_with] = ACTIONS(3159),
    [anon_sym_break] = ACTIONS(3159),
    [anon_sym_continue] = ACTIONS(3159),
    [anon_sym_debugger] = ACTIONS(3159),
    [anon_sym_return] = ACTIONS(3159),
    [anon_sym_throw] = ACTIONS(3159),
    [anon_sym_SEMI] = ACTIONS(3157),
    [anon_sym_case] = ACTIONS(3159),
    [anon_sym_yield] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [anon_sym_LT] = ACTIONS(3157),
    [anon_sym_SLASH] = ACTIONS(3159),
    [anon_sym_class] = ACTIONS(3159),
    [anon_sym_async] = ACTIONS(3159),
    [anon_sym_function] = ACTIONS(3159),
    [anon_sym_new] = ACTIONS(3159),
    [anon_sym_PLUS] = ACTIONS(3159),
    [anon_sym_DASH] = ACTIONS(3159),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_void] = ACTIONS(3159),
    [anon_sym_delete] = ACTIONS(3159),
    [anon_sym_PLUS_PLUS] = ACTIONS(3157),
    [anon_sym_DASH_DASH] = ACTIONS(3157),
    [anon_sym_DQUOTE] = ACTIONS(3157),
    [anon_sym_SQUOTE] = ACTIONS(3157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3157),
    [sym_number] = ACTIONS(3157),
    [sym_this] = ACTIONS(3159),
    [sym_super] = ACTIONS(3159),
    [sym_true] = ACTIONS(3159),
    [sym_false] = ACTIONS(3159),
    [sym_null] = ACTIONS(3159),
    [sym_undefined] = ACTIONS(3159),
    [anon_sym_AT] = ACTIONS(3157),
    [anon_sym_declare] = ACTIONS(3159),
    [anon_sym_static] = ACTIONS(3159),
    [anon_sym_readonly] = ACTIONS(3159),
    [anon_sym_abstract] = ACTIONS(3159),
    [anon_sym_get] = ACTIONS(3159),
    [anon_sym_set] = ACTIONS(3159),
    [anon_sym_public] = ACTIONS(3159),
    [anon_sym_private] = ACTIONS(3159),
    [anon_sym_protected] = ACTIONS(3159),
    [anon_sym_module] = ACTIONS(3159),
    [anon_sym_any] = ACTIONS(3159),
    [anon_sym_number] = ACTIONS(3159),
    [anon_sym_boolean] = ACTIONS(3159),
    [anon_sym_string] = ACTIONS(3159),
    [anon_sym_symbol] = ACTIONS(3159),
    [anon_sym_interface] = ACTIONS(3159),
    [anon_sym_enum] = ACTIONS(3159),
  },
  [1111] = {
    [ts_builtin_sym_end] = ACTIONS(3161),
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_export] = ACTIONS(3163),
    [anon_sym_default] = ACTIONS(3163),
    [anon_sym_namespace] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3161),
    [anon_sym_RBRACE] = ACTIONS(3161),
    [anon_sym_type] = ACTIONS(3163),
    [anon_sym_typeof] = ACTIONS(3163),
    [anon_sym_import] = ACTIONS(3163),
    [anon_sym_var] = ACTIONS(3163),
    [anon_sym_let] = ACTIONS(3163),
    [anon_sym_const] = ACTIONS(3163),
    [anon_sym_BANG] = ACTIONS(3161),
    [anon_sym_else] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3163),
    [anon_sym_switch] = ACTIONS(3163),
    [anon_sym_for] = ACTIONS(3163),
    [anon_sym_LPAREN] = ACTIONS(3161),
    [anon_sym_await] = ACTIONS(3163),
    [anon_sym_while] = ACTIONS(3163),
    [anon_sym_do] = ACTIONS(3163),
    [anon_sym_try] = ACTIONS(3163),
    [anon_sym_with] = ACTIONS(3163),
    [anon_sym_break] = ACTIONS(3163),
    [anon_sym_continue] = ACTIONS(3163),
    [anon_sym_debugger] = ACTIONS(3163),
    [anon_sym_return] = ACTIONS(3163),
    [anon_sym_throw] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3161),
    [anon_sym_case] = ACTIONS(3163),
    [anon_sym_yield] = ACTIONS(3163),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(3161),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_class] = ACTIONS(3163),
    [anon_sym_async] = ACTIONS(3163),
    [anon_sym_function] = ACTIONS(3163),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_TILDE] = ACTIONS(3161),
    [anon_sym_void] = ACTIONS(3163),
    [anon_sym_delete] = ACTIONS(3163),
    [anon_sym_PLUS_PLUS] = ACTIONS(3161),
    [anon_sym_DASH_DASH] = ACTIONS(3161),
    [anon_sym_DQUOTE] = ACTIONS(3161),
    [anon_sym_SQUOTE] = ACTIONS(3161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3161),
    [sym_number] = ACTIONS(3161),
    [sym_this] = ACTIONS(3163),
    [sym_super] = ACTIONS(3163),
    [sym_true] = ACTIONS(3163),
    [sym_false] = ACTIONS(3163),
    [sym_null] = ACTIONS(3163),
    [sym_undefined] = ACTIONS(3163),
    [anon_sym_AT] = ACTIONS(3161),
    [anon_sym_declare] = ACTIONS(3163),
    [anon_sym_static] = ACTIONS(3163),
    [anon_sym_readonly] = ACTIONS(3163),
    [anon_sym_abstract] = ACTIONS(3163),
    [anon_sym_get] = ACTIONS(3163),
    [anon_sym_set] = ACTIONS(3163),
    [anon_sym_public] = ACTIONS(3163),
    [anon_sym_private] = ACTIONS(3163),
    [anon_sym_protected] = ACTIONS(3163),
    [anon_sym_module] = ACTIONS(3163),
    [anon_sym_any] = ACTIONS(3163),
    [anon_sym_number] = ACTIONS(3163),
    [anon_sym_boolean] = ACTIONS(3163),
    [anon_sym_string] = ACTIONS(3163),
    [anon_sym_symbol] = ACTIONS(3163),
    [anon_sym_interface] = ACTIONS(3163),
    [anon_sym_enum] = ACTIONS(3163),
  },
  [1112] = {
    [ts_builtin_sym_end] = ACTIONS(3165),
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_export] = ACTIONS(3167),
    [anon_sym_default] = ACTIONS(3167),
    [anon_sym_namespace] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_type] = ACTIONS(3167),
    [anon_sym_typeof] = ACTIONS(3167),
    [anon_sym_import] = ACTIONS(3167),
    [anon_sym_var] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_const] = ACTIONS(3167),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_else] = ACTIONS(3167),
    [anon_sym_if] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_for] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3165),
    [anon_sym_await] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [anon_sym_do] = ACTIONS(3167),
    [anon_sym_try] = ACTIONS(3167),
    [anon_sym_with] = ACTIONS(3167),
    [anon_sym_break] = ACTIONS(3167),
    [anon_sym_continue] = ACTIONS(3167),
    [anon_sym_debugger] = ACTIONS(3167),
    [anon_sym_return] = ACTIONS(3167),
    [anon_sym_throw] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_case] = ACTIONS(3167),
    [anon_sym_yield] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_class] = ACTIONS(3167),
    [anon_sym_async] = ACTIONS(3167),
    [anon_sym_function] = ACTIONS(3167),
    [anon_sym_new] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3165),
    [anon_sym_void] = ACTIONS(3167),
    [anon_sym_delete] = ACTIONS(3167),
    [anon_sym_PLUS_PLUS] = ACTIONS(3165),
    [anon_sym_DASH_DASH] = ACTIONS(3165),
    [anon_sym_DQUOTE] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3165),
    [sym_number] = ACTIONS(3165),
    [sym_this] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_undefined] = ACTIONS(3167),
    [anon_sym_AT] = ACTIONS(3165),
    [anon_sym_declare] = ACTIONS(3167),
    [anon_sym_static] = ACTIONS(3167),
    [anon_sym_readonly] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3167),
    [anon_sym_get] = ACTIONS(3167),
    [anon_sym_set] = ACTIONS(3167),
    [anon_sym_public] = ACTIONS(3167),
    [anon_sym_private] = ACTIONS(3167),
    [anon_sym_protected] = ACTIONS(3167),
    [anon_sym_module] = ACTIONS(3167),
    [anon_sym_any] = ACTIONS(3167),
    [anon_sym_number] = ACTIONS(3167),
    [anon_sym_boolean] = ACTIONS(3167),
    [anon_sym_string] = ACTIONS(3167),
    [anon_sym_symbol] = ACTIONS(3167),
    [anon_sym_interface] = ACTIONS(3167),
    [anon_sym_enum] = ACTIONS(3167),
  },
  [1113] = {
    [ts_builtin_sym_end] = ACTIONS(3169),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_export] = ACTIONS(3171),
    [anon_sym_default] = ACTIONS(3171),
    [anon_sym_namespace] = ACTIONS(3171),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_type] = ACTIONS(3171),
    [anon_sym_typeof] = ACTIONS(3171),
    [anon_sym_import] = ACTIONS(3171),
    [anon_sym_var] = ACTIONS(3171),
    [anon_sym_let] = ACTIONS(3171),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3169),
    [anon_sym_else] = ACTIONS(3171),
    [anon_sym_if] = ACTIONS(3171),
    [anon_sym_switch] = ACTIONS(3171),
    [anon_sym_for] = ACTIONS(3171),
    [anon_sym_LPAREN] = ACTIONS(3169),
    [anon_sym_await] = ACTIONS(3171),
    [anon_sym_while] = ACTIONS(3171),
    [anon_sym_do] = ACTIONS(3171),
    [anon_sym_try] = ACTIONS(3171),
    [anon_sym_with] = ACTIONS(3171),
    [anon_sym_break] = ACTIONS(3171),
    [anon_sym_continue] = ACTIONS(3171),
    [anon_sym_debugger] = ACTIONS(3171),
    [anon_sym_return] = ACTIONS(3171),
    [anon_sym_throw] = ACTIONS(3171),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_case] = ACTIONS(3171),
    [anon_sym_yield] = ACTIONS(3171),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3169),
    [anon_sym_SLASH] = ACTIONS(3171),
    [anon_sym_class] = ACTIONS(3171),
    [anon_sym_async] = ACTIONS(3171),
    [anon_sym_function] = ACTIONS(3171),
    [anon_sym_new] = ACTIONS(3171),
    [anon_sym_PLUS] = ACTIONS(3171),
    [anon_sym_DASH] = ACTIONS(3171),
    [anon_sym_TILDE] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_delete] = ACTIONS(3171),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [anon_sym_DQUOTE] = ACTIONS(3169),
    [anon_sym_SQUOTE] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [sym_number] = ACTIONS(3169),
    [sym_this] = ACTIONS(3171),
    [sym_super] = ACTIONS(3171),
    [sym_true] = ACTIONS(3171),
    [sym_false] = ACTIONS(3171),
    [sym_null] = ACTIONS(3171),
    [sym_undefined] = ACTIONS(3171),
    [anon_sym_AT] = ACTIONS(3169),
    [anon_sym_declare] = ACTIONS(3171),
    [anon_sym_static] = ACTIONS(3171),
    [anon_sym_readonly] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3171),
    [anon_sym_get] = ACTIONS(3171),
    [anon_sym_set] = ACTIONS(3171),
    [anon_sym_public] = ACTIONS(3171),
    [anon_sym_private] = ACTIONS(3171),
    [anon_sym_protected] = ACTIONS(3171),
    [anon_sym_module] = ACTIONS(3171),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_interface] = ACTIONS(3171),
    [anon_sym_enum] = ACTIONS(3171),
  },
  [1114] = {
    [ts_builtin_sym_end] = ACTIONS(3173),
    [sym_identifier] = ACTIONS(3175),
    [anon_sym_export] = ACTIONS(3175),
    [anon_sym_default] = ACTIONS(3175),
    [anon_sym_namespace] = ACTIONS(3175),
    [anon_sym_LBRACE] = ACTIONS(3173),
    [anon_sym_RBRACE] = ACTIONS(3173),
    [anon_sym_type] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3175),
    [anon_sym_import] = ACTIONS(3175),
    [anon_sym_var] = ACTIONS(3175),
    [anon_sym_let] = ACTIONS(3175),
    [anon_sym_const] = ACTIONS(3175),
    [anon_sym_BANG] = ACTIONS(3173),
    [anon_sym_else] = ACTIONS(3175),
    [anon_sym_if] = ACTIONS(3175),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_for] = ACTIONS(3175),
    [anon_sym_LPAREN] = ACTIONS(3173),
    [anon_sym_await] = ACTIONS(3175),
    [anon_sym_while] = ACTIONS(3175),
    [anon_sym_do] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(3175),
    [anon_sym_with] = ACTIONS(3175),
    [anon_sym_break] = ACTIONS(3175),
    [anon_sym_continue] = ACTIONS(3175),
    [anon_sym_debugger] = ACTIONS(3175),
    [anon_sym_return] = ACTIONS(3175),
    [anon_sym_throw] = ACTIONS(3175),
    [anon_sym_SEMI] = ACTIONS(3173),
    [anon_sym_case] = ACTIONS(3175),
    [anon_sym_yield] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(3173),
    [anon_sym_LT] = ACTIONS(3173),
    [anon_sym_SLASH] = ACTIONS(3175),
    [anon_sym_class] = ACTIONS(3175),
    [anon_sym_async] = ACTIONS(3175),
    [anon_sym_function] = ACTIONS(3175),
    [anon_sym_new] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(3175),
    [anon_sym_DASH] = ACTIONS(3175),
    [anon_sym_TILDE] = ACTIONS(3173),
    [anon_sym_void] = ACTIONS(3175),
    [anon_sym_delete] = ACTIONS(3175),
    [anon_sym_PLUS_PLUS] = ACTIONS(3173),
    [anon_sym_DASH_DASH] = ACTIONS(3173),
    [anon_sym_DQUOTE] = ACTIONS(3173),
    [anon_sym_SQUOTE] = ACTIONS(3173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3173),
    [sym_this] = ACTIONS(3175),
    [sym_super] = ACTIONS(3175),
    [sym_true] = ACTIONS(3175),
    [sym_false] = ACTIONS(3175),
    [sym_null] = ACTIONS(3175),
    [sym_undefined] = ACTIONS(3175),
    [anon_sym_AT] = ACTIONS(3173),
    [anon_sym_declare] = ACTIONS(3175),
    [anon_sym_static] = ACTIONS(3175),
    [anon_sym_readonly] = ACTIONS(3175),
    [anon_sym_abstract] = ACTIONS(3175),
    [anon_sym_get] = ACTIONS(3175),
    [anon_sym_set] = ACTIONS(3175),
    [anon_sym_public] = ACTIONS(3175),
    [anon_sym_private] = ACTIONS(3175),
    [anon_sym_protected] = ACTIONS(3175),
    [anon_sym_module] = ACTIONS(3175),
    [anon_sym_any] = ACTIONS(3175),
    [anon_sym_number] = ACTIONS(3175),
    [anon_sym_boolean] = ACTIONS(3175),
    [anon_sym_string] = ACTIONS(3175),
    [anon_sym_symbol] = ACTIONS(3175),
    [anon_sym_interface] = ACTIONS(3175),
    [anon_sym_enum] = ACTIONS(3175),
  },
  [1115] = {
    [ts_builtin_sym_end] = ACTIONS(3177),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_export] = ACTIONS(3179),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_namespace] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(3177),
    [anon_sym_RBRACE] = ACTIONS(3177),
    [anon_sym_type] = ACTIONS(3179),
    [anon_sym_typeof] = ACTIONS(3179),
    [anon_sym_import] = ACTIONS(3179),
    [anon_sym_var] = ACTIONS(3179),
    [anon_sym_let] = ACTIONS(3179),
    [anon_sym_const] = ACTIONS(3179),
    [anon_sym_BANG] = ACTIONS(3177),
    [anon_sym_else] = ACTIONS(3179),
    [anon_sym_if] = ACTIONS(3179),
    [anon_sym_switch] = ACTIONS(3179),
    [anon_sym_for] = ACTIONS(3179),
    [anon_sym_LPAREN] = ACTIONS(3177),
    [anon_sym_await] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3179),
    [anon_sym_do] = ACTIONS(3179),
    [anon_sym_try] = ACTIONS(3179),
    [anon_sym_with] = ACTIONS(3179),
    [anon_sym_break] = ACTIONS(3179),
    [anon_sym_continue] = ACTIONS(3179),
    [anon_sym_debugger] = ACTIONS(3179),
    [anon_sym_return] = ACTIONS(3179),
    [anon_sym_throw] = ACTIONS(3179),
    [anon_sym_SEMI] = ACTIONS(3177),
    [anon_sym_case] = ACTIONS(3179),
    [anon_sym_yield] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3177),
    [anon_sym_LT] = ACTIONS(3177),
    [anon_sym_SLASH] = ACTIONS(3179),
    [anon_sym_class] = ACTIONS(3179),
    [anon_sym_async] = ACTIONS(3179),
    [anon_sym_function] = ACTIONS(3179),
    [anon_sym_new] = ACTIONS(3179),
    [anon_sym_PLUS] = ACTIONS(3179),
    [anon_sym_DASH] = ACTIONS(3179),
    [anon_sym_TILDE] = ACTIONS(3177),
    [anon_sym_void] = ACTIONS(3179),
    [anon_sym_delete] = ACTIONS(3179),
    [anon_sym_PLUS_PLUS] = ACTIONS(3177),
    [anon_sym_DASH_DASH] = ACTIONS(3177),
    [anon_sym_DQUOTE] = ACTIONS(3177),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3177),
    [sym_number] = ACTIONS(3177),
    [sym_this] = ACTIONS(3179),
    [sym_super] = ACTIONS(3179),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_AT] = ACTIONS(3177),
    [anon_sym_declare] = ACTIONS(3179),
    [anon_sym_static] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3179),
    [anon_sym_abstract] = ACTIONS(3179),
    [anon_sym_get] = ACTIONS(3179),
    [anon_sym_set] = ACTIONS(3179),
    [anon_sym_public] = ACTIONS(3179),
    [anon_sym_private] = ACTIONS(3179),
    [anon_sym_protected] = ACTIONS(3179),
    [anon_sym_module] = ACTIONS(3179),
    [anon_sym_any] = ACTIONS(3179),
    [anon_sym_number] = ACTIONS(3179),
    [anon_sym_boolean] = ACTIONS(3179),
    [anon_sym_string] = ACTIONS(3179),
    [anon_sym_symbol] = ACTIONS(3179),
    [anon_sym_interface] = ACTIONS(3179),
    [anon_sym_enum] = ACTIONS(3179),
  },
  [1116] = {
    [ts_builtin_sym_end] = ACTIONS(3181),
    [sym_identifier] = ACTIONS(3183),
    [anon_sym_export] = ACTIONS(3183),
    [anon_sym_default] = ACTIONS(3183),
    [anon_sym_namespace] = ACTIONS(3183),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_RBRACE] = ACTIONS(3181),
    [anon_sym_type] = ACTIONS(3183),
    [anon_sym_typeof] = ACTIONS(3183),
    [anon_sym_import] = ACTIONS(3183),
    [anon_sym_var] = ACTIONS(3183),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [anon_sym_BANG] = ACTIONS(3181),
    [anon_sym_else] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(3183),
    [anon_sym_switch] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3181),
    [anon_sym_await] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_with] = ACTIONS(3183),
    [anon_sym_break] = ACTIONS(3183),
    [anon_sym_continue] = ACTIONS(3183),
    [anon_sym_debugger] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_throw] = ACTIONS(3183),
    [anon_sym_SEMI] = ACTIONS(3181),
    [anon_sym_case] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3183),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(3181),
    [anon_sym_SLASH] = ACTIONS(3183),
    [anon_sym_class] = ACTIONS(3183),
    [anon_sym_async] = ACTIONS(3183),
    [anon_sym_function] = ACTIONS(3183),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3181),
    [anon_sym_void] = ACTIONS(3183),
    [anon_sym_delete] = ACTIONS(3183),
    [anon_sym_PLUS_PLUS] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(3181),
    [anon_sym_DQUOTE] = ACTIONS(3181),
    [anon_sym_SQUOTE] = ACTIONS(3181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3181),
    [sym_number] = ACTIONS(3181),
    [sym_this] = ACTIONS(3183),
    [sym_super] = ACTIONS(3183),
    [sym_true] = ACTIONS(3183),
    [sym_false] = ACTIONS(3183),
    [sym_null] = ACTIONS(3183),
    [sym_undefined] = ACTIONS(3183),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_declare] = ACTIONS(3183),
    [anon_sym_static] = ACTIONS(3183),
    [anon_sym_readonly] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_get] = ACTIONS(3183),
    [anon_sym_set] = ACTIONS(3183),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_module] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3183),
    [anon_sym_number] = ACTIONS(3183),
    [anon_sym_boolean] = ACTIONS(3183),
    [anon_sym_string] = ACTIONS(3183),
    [anon_sym_symbol] = ACTIONS(3183),
    [anon_sym_interface] = ACTIONS(3183),
    [anon_sym_enum] = ACTIONS(3183),
  },
  [1117] = {
    [ts_builtin_sym_end] = ACTIONS(3185),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_export] = ACTIONS(3187),
    [anon_sym_default] = ACTIONS(3187),
    [anon_sym_namespace] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3185),
    [anon_sym_RBRACE] = ACTIONS(3185),
    [anon_sym_type] = ACTIONS(3187),
    [anon_sym_typeof] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3187),
    [anon_sym_var] = ACTIONS(3187),
    [anon_sym_let] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_BANG] = ACTIONS(3185),
    [anon_sym_else] = ACTIONS(3187),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_switch] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3185),
    [anon_sym_await] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [anon_sym_do] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [anon_sym_with] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_continue] = ACTIONS(3187),
    [anon_sym_debugger] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_throw] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3185),
    [anon_sym_case] = ACTIONS(3187),
    [anon_sym_yield] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(3185),
    [anon_sym_LT] = ACTIONS(3185),
    [anon_sym_SLASH] = ACTIONS(3187),
    [anon_sym_class] = ACTIONS(3187),
    [anon_sym_async] = ACTIONS(3187),
    [anon_sym_function] = ACTIONS(3187),
    [anon_sym_new] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3185),
    [anon_sym_void] = ACTIONS(3187),
    [anon_sym_delete] = ACTIONS(3187),
    [anon_sym_PLUS_PLUS] = ACTIONS(3185),
    [anon_sym_DASH_DASH] = ACTIONS(3185),
    [anon_sym_DQUOTE] = ACTIONS(3185),
    [anon_sym_SQUOTE] = ACTIONS(3185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3185),
    [sym_number] = ACTIONS(3185),
    [sym_this] = ACTIONS(3187),
    [sym_super] = ACTIONS(3187),
    [sym_true] = ACTIONS(3187),
    [sym_false] = ACTIONS(3187),
    [sym_null] = ACTIONS(3187),
    [sym_undefined] = ACTIONS(3187),
    [anon_sym_AT] = ACTIONS(3185),
    [anon_sym_declare] = ACTIONS(3187),
    [anon_sym_static] = ACTIONS(3187),
    [anon_sym_readonly] = ACTIONS(3187),
    [anon_sym_abstract] = ACTIONS(3187),
    [anon_sym_get] = ACTIONS(3187),
    [anon_sym_set] = ACTIONS(3187),
    [anon_sym_public] = ACTIONS(3187),
    [anon_sym_private] = ACTIONS(3187),
    [anon_sym_protected] = ACTIONS(3187),
    [anon_sym_module] = ACTIONS(3187),
    [anon_sym_any] = ACTIONS(3187),
    [anon_sym_number] = ACTIONS(3187),
    [anon_sym_boolean] = ACTIONS(3187),
    [anon_sym_string] = ACTIONS(3187),
    [anon_sym_symbol] = ACTIONS(3187),
    [anon_sym_interface] = ACTIONS(3187),
    [anon_sym_enum] = ACTIONS(3187),
  },
  [1118] = {
    [ts_builtin_sym_end] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3191),
    [anon_sym_export] = ACTIONS(3191),
    [anon_sym_default] = ACTIONS(3191),
    [anon_sym_namespace] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_RBRACE] = ACTIONS(3189),
    [anon_sym_type] = ACTIONS(3191),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_import] = ACTIONS(3191),
    [anon_sym_var] = ACTIONS(3191),
    [anon_sym_let] = ACTIONS(3191),
    [anon_sym_const] = ACTIONS(3191),
    [anon_sym_BANG] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3191),
    [anon_sym_if] = ACTIONS(3191),
    [anon_sym_switch] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3191),
    [anon_sym_while] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_try] = ACTIONS(3191),
    [anon_sym_with] = ACTIONS(3191),
    [anon_sym_break] = ACTIONS(3191),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_debugger] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3191),
    [anon_sym_throw] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_case] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3191),
    [anon_sym_LBRACK] = ACTIONS(3189),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_SLASH] = ACTIONS(3191),
    [anon_sym_class] = ACTIONS(3191),
    [anon_sym_async] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3189),
    [anon_sym_void] = ACTIONS(3191),
    [anon_sym_delete] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3189),
    [anon_sym_DASH_DASH] = ACTIONS(3189),
    [anon_sym_DQUOTE] = ACTIONS(3189),
    [anon_sym_SQUOTE] = ACTIONS(3189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3189),
    [sym_number] = ACTIONS(3189),
    [sym_this] = ACTIONS(3191),
    [sym_super] = ACTIONS(3191),
    [sym_true] = ACTIONS(3191),
    [sym_false] = ACTIONS(3191),
    [sym_null] = ACTIONS(3191),
    [sym_undefined] = ACTIONS(3191),
    [anon_sym_AT] = ACTIONS(3189),
    [anon_sym_declare] = ACTIONS(3191),
    [anon_sym_static] = ACTIONS(3191),
    [anon_sym_readonly] = ACTIONS(3191),
    [anon_sym_abstract] = ACTIONS(3191),
    [anon_sym_get] = ACTIONS(3191),
    [anon_sym_set] = ACTIONS(3191),
    [anon_sym_public] = ACTIONS(3191),
    [anon_sym_private] = ACTIONS(3191),
    [anon_sym_protected] = ACTIONS(3191),
    [anon_sym_module] = ACTIONS(3191),
    [anon_sym_any] = ACTIONS(3191),
    [anon_sym_number] = ACTIONS(3191),
    [anon_sym_boolean] = ACTIONS(3191),
    [anon_sym_string] = ACTIONS(3191),
    [anon_sym_symbol] = ACTIONS(3191),
    [anon_sym_interface] = ACTIONS(3191),
    [anon_sym_enum] = ACTIONS(3191),
  },
  [1119] = {
    [ts_builtin_sym_end] = ACTIONS(3193),
    [sym_identifier] = ACTIONS(3195),
    [anon_sym_export] = ACTIONS(3195),
    [anon_sym_default] = ACTIONS(3195),
    [anon_sym_namespace] = ACTIONS(3195),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_RBRACE] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3195),
    [anon_sym_typeof] = ACTIONS(3195),
    [anon_sym_import] = ACTIONS(3195),
    [anon_sym_var] = ACTIONS(3195),
    [anon_sym_let] = ACTIONS(3195),
    [anon_sym_const] = ACTIONS(3195),
    [anon_sym_BANG] = ACTIONS(3193),
    [anon_sym_else] = ACTIONS(3195),
    [anon_sym_if] = ACTIONS(3195),
    [anon_sym_switch] = ACTIONS(3195),
    [anon_sym_for] = ACTIONS(3195),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_await] = ACTIONS(3195),
    [anon_sym_while] = ACTIONS(3195),
    [anon_sym_do] = ACTIONS(3195),
    [anon_sym_try] = ACTIONS(3195),
    [anon_sym_with] = ACTIONS(3195),
    [anon_sym_break] = ACTIONS(3195),
    [anon_sym_continue] = ACTIONS(3195),
    [anon_sym_debugger] = ACTIONS(3195),
    [anon_sym_return] = ACTIONS(3195),
    [anon_sym_throw] = ACTIONS(3195),
    [anon_sym_SEMI] = ACTIONS(3193),
    [anon_sym_case] = ACTIONS(3195),
    [anon_sym_yield] = ACTIONS(3195),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LT] = ACTIONS(3193),
    [anon_sym_SLASH] = ACTIONS(3195),
    [anon_sym_class] = ACTIONS(3195),
    [anon_sym_async] = ACTIONS(3195),
    [anon_sym_function] = ACTIONS(3195),
    [anon_sym_new] = ACTIONS(3195),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3193),
    [anon_sym_void] = ACTIONS(3195),
    [anon_sym_delete] = ACTIONS(3195),
    [anon_sym_PLUS_PLUS] = ACTIONS(3193),
    [anon_sym_DASH_DASH] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3193),
    [sym_number] = ACTIONS(3193),
    [sym_this] = ACTIONS(3195),
    [sym_super] = ACTIONS(3195),
    [sym_true] = ACTIONS(3195),
    [sym_false] = ACTIONS(3195),
    [sym_null] = ACTIONS(3195),
    [sym_undefined] = ACTIONS(3195),
    [anon_sym_AT] = ACTIONS(3193),
    [anon_sym_declare] = ACTIONS(3195),
    [anon_sym_static] = ACTIONS(3195),
    [anon_sym_readonly] = ACTIONS(3195),
    [anon_sym_abstract] = ACTIONS(3195),
    [anon_sym_get] = ACTIONS(3195),
    [anon_sym_set] = ACTIONS(3195),
    [anon_sym_public] = ACTIONS(3195),
    [anon_sym_private] = ACTIONS(3195),
    [anon_sym_protected] = ACTIONS(3195),
    [anon_sym_module] = ACTIONS(3195),
    [anon_sym_any] = ACTIONS(3195),
    [anon_sym_number] = ACTIONS(3195),
    [anon_sym_boolean] = ACTIONS(3195),
    [anon_sym_string] = ACTIONS(3195),
    [anon_sym_symbol] = ACTIONS(3195),
    [anon_sym_interface] = ACTIONS(3195),
    [anon_sym_enum] = ACTIONS(3195),
  },
  [1120] = {
    [ts_builtin_sym_end] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [anon_sym_export] = ACTIONS(3199),
    [anon_sym_default] = ACTIONS(3199),
    [anon_sym_namespace] = ACTIONS(3199),
    [anon_sym_LBRACE] = ACTIONS(3197),
    [anon_sym_RBRACE] = ACTIONS(3197),
    [anon_sym_type] = ACTIONS(3199),
    [anon_sym_typeof] = ACTIONS(3199),
    [anon_sym_import] = ACTIONS(3199),
    [anon_sym_var] = ACTIONS(3199),
    [anon_sym_let] = ACTIONS(3199),
    [anon_sym_const] = ACTIONS(3199),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_else] = ACTIONS(3199),
    [anon_sym_if] = ACTIONS(3199),
    [anon_sym_switch] = ACTIONS(3199),
    [anon_sym_for] = ACTIONS(3199),
    [anon_sym_LPAREN] = ACTIONS(3197),
    [anon_sym_await] = ACTIONS(3199),
    [anon_sym_while] = ACTIONS(3199),
    [anon_sym_do] = ACTIONS(3199),
    [anon_sym_try] = ACTIONS(3199),
    [anon_sym_with] = ACTIONS(3199),
    [anon_sym_break] = ACTIONS(3199),
    [anon_sym_continue] = ACTIONS(3199),
    [anon_sym_debugger] = ACTIONS(3199),
    [anon_sym_return] = ACTIONS(3199),
    [anon_sym_throw] = ACTIONS(3199),
    [anon_sym_SEMI] = ACTIONS(3197),
    [anon_sym_case] = ACTIONS(3199),
    [anon_sym_yield] = ACTIONS(3199),
    [anon_sym_LBRACK] = ACTIONS(3197),
    [anon_sym_LT] = ACTIONS(3197),
    [anon_sym_SLASH] = ACTIONS(3199),
    [anon_sym_class] = ACTIONS(3199),
    [anon_sym_async] = ACTIONS(3199),
    [anon_sym_function] = ACTIONS(3199),
    [anon_sym_new] = ACTIONS(3199),
    [anon_sym_PLUS] = ACTIONS(3199),
    [anon_sym_DASH] = ACTIONS(3199),
    [anon_sym_TILDE] = ACTIONS(3197),
    [anon_sym_void] = ACTIONS(3199),
    [anon_sym_delete] = ACTIONS(3199),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_DQUOTE] = ACTIONS(3197),
    [anon_sym_SQUOTE] = ACTIONS(3197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3197),
    [sym_number] = ACTIONS(3197),
    [sym_this] = ACTIONS(3199),
    [sym_super] = ACTIONS(3199),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [sym_null] = ACTIONS(3199),
    [sym_undefined] = ACTIONS(3199),
    [anon_sym_AT] = ACTIONS(3197),
    [anon_sym_declare] = ACTIONS(3199),
    [anon_sym_static] = ACTIONS(3199),
    [anon_sym_readonly] = ACTIONS(3199),
    [anon_sym_abstract] = ACTIONS(3199),
    [anon_sym_get] = ACTIONS(3199),
    [anon_sym_set] = ACTIONS(3199),
    [anon_sym_public] = ACTIONS(3199),
    [anon_sym_private] = ACTIONS(3199),
    [anon_sym_protected] = ACTIONS(3199),
    [anon_sym_module] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3199),
    [anon_sym_number] = ACTIONS(3199),
    [anon_sym_boolean] = ACTIONS(3199),
    [anon_sym_string] = ACTIONS(3199),
    [anon_sym_symbol] = ACTIONS(3199),
    [anon_sym_interface] = ACTIONS(3199),
    [anon_sym_enum] = ACTIONS(3199),
  },
  [1121] = {
    [ts_builtin_sym_end] = ACTIONS(3201),
    [sym_identifier] = ACTIONS(3203),
    [anon_sym_export] = ACTIONS(3203),
    [anon_sym_default] = ACTIONS(3203),
    [anon_sym_namespace] = ACTIONS(3203),
    [anon_sym_LBRACE] = ACTIONS(3201),
    [anon_sym_RBRACE] = ACTIONS(3201),
    [anon_sym_type] = ACTIONS(3203),
    [anon_sym_typeof] = ACTIONS(3203),
    [anon_sym_import] = ACTIONS(3203),
    [anon_sym_var] = ACTIONS(3203),
    [anon_sym_let] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_BANG] = ACTIONS(3201),
    [anon_sym_else] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_switch] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_await] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_do] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [anon_sym_with] = ACTIONS(3203),
    [anon_sym_break] = ACTIONS(3203),
    [anon_sym_continue] = ACTIONS(3203),
    [anon_sym_debugger] = ACTIONS(3203),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_throw] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3201),
    [anon_sym_case] = ACTIONS(3203),
    [anon_sym_yield] = ACTIONS(3203),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_LT] = ACTIONS(3201),
    [anon_sym_SLASH] = ACTIONS(3203),
    [anon_sym_class] = ACTIONS(3203),
    [anon_sym_async] = ACTIONS(3203),
    [anon_sym_function] = ACTIONS(3203),
    [anon_sym_new] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_TILDE] = ACTIONS(3201),
    [anon_sym_void] = ACTIONS(3203),
    [anon_sym_delete] = ACTIONS(3203),
    [anon_sym_PLUS_PLUS] = ACTIONS(3201),
    [anon_sym_DASH_DASH] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3201),
    [anon_sym_SQUOTE] = ACTIONS(3201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3201),
    [sym_number] = ACTIONS(3201),
    [sym_this] = ACTIONS(3203),
    [sym_super] = ACTIONS(3203),
    [sym_true] = ACTIONS(3203),
    [sym_false] = ACTIONS(3203),
    [sym_null] = ACTIONS(3203),
    [sym_undefined] = ACTIONS(3203),
    [anon_sym_AT] = ACTIONS(3201),
    [anon_sym_declare] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3203),
    [anon_sym_readonly] = ACTIONS(3203),
    [anon_sym_abstract] = ACTIONS(3203),
    [anon_sym_get] = ACTIONS(3203),
    [anon_sym_set] = ACTIONS(3203),
    [anon_sym_public] = ACTIONS(3203),
    [anon_sym_private] = ACTIONS(3203),
    [anon_sym_protected] = ACTIONS(3203),
    [anon_sym_module] = ACTIONS(3203),
    [anon_sym_any] = ACTIONS(3203),
    [anon_sym_number] = ACTIONS(3203),
    [anon_sym_boolean] = ACTIONS(3203),
    [anon_sym_string] = ACTIONS(3203),
    [anon_sym_symbol] = ACTIONS(3203),
    [anon_sym_interface] = ACTIONS(3203),
    [anon_sym_enum] = ACTIONS(3203),
  },
  [1122] = {
    [ts_builtin_sym_end] = ACTIONS(3205),
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3207),
    [anon_sym_default] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3205),
    [anon_sym_RBRACE] = ACTIONS(3205),
    [anon_sym_type] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym_import] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3205),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3205),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_with] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_debugger] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3205),
    [anon_sym_case] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3205),
    [anon_sym_LT] = ACTIONS(3205),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_class] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_function] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_TILDE] = ACTIONS(3205),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_delete] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3205),
    [anon_sym_DASH_DASH] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(3205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3205),
    [sym_number] = ACTIONS(3205),
    [sym_this] = ACTIONS(3207),
    [sym_super] = ACTIONS(3207),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [sym_null] = ACTIONS(3207),
    [sym_undefined] = ACTIONS(3207),
    [anon_sym_AT] = ACTIONS(3205),
    [anon_sym_declare] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_get] = ACTIONS(3207),
    [anon_sym_set] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_interface] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(3207),
  },
  [1123] = {
    [ts_builtin_sym_end] = ACTIONS(3209),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_export] = ACTIONS(3211),
    [anon_sym_default] = ACTIONS(3211),
    [anon_sym_namespace] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_type] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym_import] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3209),
    [anon_sym_else] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_with] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_debugger] = ACTIONS(3211),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_case] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3209),
    [anon_sym_SLASH] = ACTIONS(3211),
    [anon_sym_class] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_function] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_TILDE] = ACTIONS(3209),
    [anon_sym_void] = ACTIONS(3211),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [anon_sym_DQUOTE] = ACTIONS(3209),
    [anon_sym_SQUOTE] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [sym_number] = ACTIONS(3209),
    [sym_this] = ACTIONS(3211),
    [sym_super] = ACTIONS(3211),
    [sym_true] = ACTIONS(3211),
    [sym_false] = ACTIONS(3211),
    [sym_null] = ACTIONS(3211),
    [sym_undefined] = ACTIONS(3211),
    [anon_sym_AT] = ACTIONS(3209),
    [anon_sym_declare] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_get] = ACTIONS(3211),
    [anon_sym_set] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_module] = ACTIONS(3211),
    [anon_sym_any] = ACTIONS(3211),
    [anon_sym_number] = ACTIONS(3211),
    [anon_sym_boolean] = ACTIONS(3211),
    [anon_sym_string] = ACTIONS(3211),
    [anon_sym_symbol] = ACTIONS(3211),
    [anon_sym_interface] = ACTIONS(3211),
    [anon_sym_enum] = ACTIONS(3211),
  },
  [1124] = {
    [ts_builtin_sym_end] = ACTIONS(3213),
    [sym_identifier] = ACTIONS(3215),
    [anon_sym_export] = ACTIONS(3215),
    [anon_sym_default] = ACTIONS(3215),
    [anon_sym_namespace] = ACTIONS(3215),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_type] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3215),
    [anon_sym_import] = ACTIONS(3215),
    [anon_sym_var] = ACTIONS(3215),
    [anon_sym_let] = ACTIONS(3215),
    [anon_sym_const] = ACTIONS(3215),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_else] = ACTIONS(3215),
    [anon_sym_if] = ACTIONS(3215),
    [anon_sym_switch] = ACTIONS(3215),
    [anon_sym_for] = ACTIONS(3215),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_await] = ACTIONS(3215),
    [anon_sym_while] = ACTIONS(3215),
    [anon_sym_do] = ACTIONS(3215),
    [anon_sym_try] = ACTIONS(3215),
    [anon_sym_with] = ACTIONS(3215),
    [anon_sym_break] = ACTIONS(3215),
    [anon_sym_continue] = ACTIONS(3215),
    [anon_sym_debugger] = ACTIONS(3215),
    [anon_sym_return] = ACTIONS(3215),
    [anon_sym_throw] = ACTIONS(3215),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_case] = ACTIONS(3215),
    [anon_sym_yield] = ACTIONS(3215),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LT] = ACTIONS(3213),
    [anon_sym_SLASH] = ACTIONS(3215),
    [anon_sym_class] = ACTIONS(3215),
    [anon_sym_async] = ACTIONS(3215),
    [anon_sym_function] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3215),
    [anon_sym_PLUS] = ACTIONS(3215),
    [anon_sym_DASH] = ACTIONS(3215),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_void] = ACTIONS(3215),
    [anon_sym_delete] = ACTIONS(3215),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3213),
    [sym_number] = ACTIONS(3213),
    [sym_this] = ACTIONS(3215),
    [sym_super] = ACTIONS(3215),
    [sym_true] = ACTIONS(3215),
    [sym_false] = ACTIONS(3215),
    [sym_null] = ACTIONS(3215),
    [sym_undefined] = ACTIONS(3215),
    [anon_sym_AT] = ACTIONS(3213),
    [anon_sym_declare] = ACTIONS(3215),
    [anon_sym_static] = ACTIONS(3215),
    [anon_sym_readonly] = ACTIONS(3215),
    [anon_sym_abstract] = ACTIONS(3215),
    [anon_sym_get] = ACTIONS(3215),
    [anon_sym_set] = ACTIONS(3215),
    [anon_sym_public] = ACTIONS(3215),
    [anon_sym_private] = ACTIONS(3215),
    [anon_sym_protected] = ACTIONS(3215),
    [anon_sym_module] = ACTIONS(3215),
    [anon_sym_any] = ACTIONS(3215),
    [anon_sym_number] = ACTIONS(3215),
    [anon_sym_boolean] = ACTIONS(3215),
    [anon_sym_string] = ACTIONS(3215),
    [anon_sym_symbol] = ACTIONS(3215),
    [anon_sym_interface] = ACTIONS(3215),
    [anon_sym_enum] = ACTIONS(3215),
  },
  [1125] = {
    [ts_builtin_sym_end] = ACTIONS(3217),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_export] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_RBRACE] = ACTIONS(3217),
    [anon_sym_type] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym_import] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_with] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_debugger] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_case] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LT] = ACTIONS(3217),
    [anon_sym_SLASH] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_function] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_void] = ACTIONS(3219),
    [anon_sym_delete] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3217),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3217),
    [sym_number] = ACTIONS(3217),
    [sym_this] = ACTIONS(3219),
    [sym_super] = ACTIONS(3219),
    [sym_true] = ACTIONS(3219),
    [sym_false] = ACTIONS(3219),
    [sym_null] = ACTIONS(3219),
    [sym_undefined] = ACTIONS(3219),
    [anon_sym_AT] = ACTIONS(3217),
    [anon_sym_declare] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3219),
    [anon_sym_set] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_module] = ACTIONS(3219),
    [anon_sym_any] = ACTIONS(3219),
    [anon_sym_number] = ACTIONS(3219),
    [anon_sym_boolean] = ACTIONS(3219),
    [anon_sym_string] = ACTIONS(3219),
    [anon_sym_symbol] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
  },
  [1126] = {
    [ts_builtin_sym_end] = ACTIONS(3221),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_export] = ACTIONS(3223),
    [anon_sym_default] = ACTIONS(3223),
    [anon_sym_namespace] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_RBRACE] = ACTIONS(3221),
    [anon_sym_type] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym_import] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_else] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_with] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_debugger] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_case] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(3221),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_function] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_void] = ACTIONS(3223),
    [anon_sym_delete] = ACTIONS(3223),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3221),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3221),
    [sym_number] = ACTIONS(3221),
    [sym_this] = ACTIONS(3223),
    [sym_super] = ACTIONS(3223),
    [sym_true] = ACTIONS(3223),
    [sym_false] = ACTIONS(3223),
    [sym_null] = ACTIONS(3223),
    [sym_undefined] = ACTIONS(3223),
    [anon_sym_AT] = ACTIONS(3221),
    [anon_sym_declare] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_get] = ACTIONS(3223),
    [anon_sym_set] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_module] = ACTIONS(3223),
    [anon_sym_any] = ACTIONS(3223),
    [anon_sym_number] = ACTIONS(3223),
    [anon_sym_boolean] = ACTIONS(3223),
    [anon_sym_string] = ACTIONS(3223),
    [anon_sym_symbol] = ACTIONS(3223),
    [anon_sym_interface] = ACTIONS(3223),
    [anon_sym_enum] = ACTIONS(3223),
  },
  [1127] = {
    [ts_builtin_sym_end] = ACTIONS(1907),
    [sym_identifier] = ACTIONS(1909),
    [anon_sym_export] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1907),
    [anon_sym_RBRACE] = ACTIONS(1907),
    [anon_sym_type] = ACTIONS(1909),
    [anon_sym_typeof] = ACTIONS(1909),
    [anon_sym_import] = ACTIONS(1909),
    [anon_sym_var] = ACTIONS(1909),
    [anon_sym_let] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_LPAREN] = ACTIONS(1907),
    [anon_sym_await] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_with] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_debugger] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_yield] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_SLASH] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_async] = ACTIONS(1909),
    [anon_sym_function] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1907),
    [sym_number] = ACTIONS(1907),
    [sym_this] = ACTIONS(1909),
    [sym_super] = ACTIONS(1909),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [sym_null] = ACTIONS(1909),
    [sym_undefined] = ACTIONS(1909),
    [anon_sym_AT] = ACTIONS(1907),
    [anon_sym_declare] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_readonly] = ACTIONS(1909),
    [anon_sym_abstract] = ACTIONS(1909),
    [anon_sym_get] = ACTIONS(1909),
    [anon_sym_set] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_module] = ACTIONS(1909),
    [anon_sym_any] = ACTIONS(1909),
    [anon_sym_number] = ACTIONS(1909),
    [anon_sym_boolean] = ACTIONS(1909),
    [anon_sym_string] = ACTIONS(1909),
    [anon_sym_symbol] = ACTIONS(1909),
    [anon_sym_interface] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
  },
  [1128] = {
    [ts_builtin_sym_end] = ACTIONS(3225),
    [sym_identifier] = ACTIONS(3227),
    [anon_sym_export] = ACTIONS(3227),
    [anon_sym_default] = ACTIONS(3227),
    [anon_sym_namespace] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_RBRACE] = ACTIONS(3225),
    [anon_sym_type] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym_import] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_with] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_debugger] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_case] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LT] = ACTIONS(3225),
    [anon_sym_SLASH] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_function] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_void] = ACTIONS(3227),
    [anon_sym_delete] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3225),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3225),
    [sym_number] = ACTIONS(3225),
    [sym_this] = ACTIONS(3227),
    [sym_super] = ACTIONS(3227),
    [sym_true] = ACTIONS(3227),
    [sym_false] = ACTIONS(3227),
    [sym_null] = ACTIONS(3227),
    [sym_undefined] = ACTIONS(3227),
    [anon_sym_AT] = ACTIONS(3225),
    [anon_sym_declare] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_get] = ACTIONS(3227),
    [anon_sym_set] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_module] = ACTIONS(3227),
    [anon_sym_any] = ACTIONS(3227),
    [anon_sym_number] = ACTIONS(3227),
    [anon_sym_boolean] = ACTIONS(3227),
    [anon_sym_string] = ACTIONS(3227),
    [anon_sym_symbol] = ACTIONS(3227),
    [anon_sym_interface] = ACTIONS(3227),
    [anon_sym_enum] = ACTIONS(3227),
  },
  [1129] = {
    [ts_builtin_sym_end] = ACTIONS(3229),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_export] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3229),
    [anon_sym_RBRACE] = ACTIONS(3229),
    [anon_sym_type] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym_import] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3229),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_with] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_debugger] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_case] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(3229),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_function] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3229),
    [anon_sym_void] = ACTIONS(3231),
    [anon_sym_delete] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3229),
    [anon_sym_DASH_DASH] = ACTIONS(3229),
    [anon_sym_DQUOTE] = ACTIONS(3229),
    [anon_sym_SQUOTE] = ACTIONS(3229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3229),
    [sym_number] = ACTIONS(3229),
    [sym_this] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_true] = ACTIONS(3231),
    [sym_false] = ACTIONS(3231),
    [sym_null] = ACTIONS(3231),
    [sym_undefined] = ACTIONS(3231),
    [anon_sym_AT] = ACTIONS(3229),
    [anon_sym_declare] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_get] = ACTIONS(3231),
    [anon_sym_set] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_module] = ACTIONS(3231),
    [anon_sym_any] = ACTIONS(3231),
    [anon_sym_number] = ACTIONS(3231),
    [anon_sym_boolean] = ACTIONS(3231),
    [anon_sym_string] = ACTIONS(3231),
    [anon_sym_symbol] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
  },
  [1130] = {
    [ts_builtin_sym_end] = ACTIONS(3233),
    [sym_identifier] = ACTIONS(3235),
    [anon_sym_export] = ACTIONS(3235),
    [anon_sym_default] = ACTIONS(3235),
    [anon_sym_namespace] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_RBRACE] = ACTIONS(3233),
    [anon_sym_type] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym_import] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_with] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_debugger] = ACTIONS(3235),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_case] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(3233),
    [anon_sym_SLASH] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_function] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_void] = ACTIONS(3235),
    [anon_sym_delete] = ACTIONS(3235),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3233),
    [sym_number] = ACTIONS(3233),
    [sym_this] = ACTIONS(3235),
    [sym_super] = ACTIONS(3235),
    [sym_true] = ACTIONS(3235),
    [sym_false] = ACTIONS(3235),
    [sym_null] = ACTIONS(3235),
    [sym_undefined] = ACTIONS(3235),
    [anon_sym_AT] = ACTIONS(3233),
    [anon_sym_declare] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_get] = ACTIONS(3235),
    [anon_sym_set] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_module] = ACTIONS(3235),
    [anon_sym_any] = ACTIONS(3235),
    [anon_sym_number] = ACTIONS(3235),
    [anon_sym_boolean] = ACTIONS(3235),
    [anon_sym_string] = ACTIONS(3235),
    [anon_sym_symbol] = ACTIONS(3235),
    [anon_sym_interface] = ACTIONS(3235),
    [anon_sym_enum] = ACTIONS(3235),
  },
  [1131] = {
    [sym_object_pattern] = STATE(3978),
    [sym_array_pattern] = STATE(3978),
    [sym_nested_identifier] = STATE(5331),
    [sym__destructuring_pattern] = STATE(3978),
    [sym_string] = STATE(3780),
    [sym_formal_parameters] = STATE(5465),
    [sym_pattern] = STATE(5140),
    [sym_rest_pattern] = STATE(3978),
    [sym_nested_type_identifier] = STATE(3717),
    [sym__type] = STATE(3857),
    [sym_constructor_type] = STATE(3857),
    [sym__primary_type] = STATE(3784),
    [sym_infer_type] = STATE(3857),
    [sym_conditional_type] = STATE(3782),
    [sym_generic_type] = STATE(3782),
    [sym_type_query] = STATE(3782),
    [sym_index_type_query] = STATE(3782),
    [sym_lookup_type] = STATE(3782),
    [sym_literal_type] = STATE(3782),
    [sym__number] = STATE(3780),
    [sym_existential_type] = STATE(3782),
    [sym_flow_maybe_type] = STATE(3782),
    [sym_parenthesized_type] = STATE(3782),
    [sym_predefined_type] = STATE(3782),
    [sym_object_type] = STATE(3782),
    [sym_type_parameters] = STATE(5034),
    [sym_array_type] = STATE(3782),
    [sym_tuple_type] = STATE(3782),
    [sym_readonly_type] = STATE(3857),
    [sym_union_type] = STATE(3857),
    [sym_intersection_type] = STATE(3857),
    [sym_function_type] = STATE(3857),
    [sym_identifier] = ACTIONS(3237),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(3239),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(2094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_void] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2110),
    [sym_this] = ACTIONS(2112),
    [sym_true] = ACTIONS(2114),
    [sym_false] = ACTIONS(2114),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_readonly] = ACTIONS(3245),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(3247),
    [anon_sym_number] = ACTIONS(3247),
    [anon_sym_boolean] = ACTIONS(3247),
    [anon_sym_string] = ACTIONS(3247),
    [anon_sym_symbol] = ACTIONS(3247),
    [anon_sym_infer] = ACTIONS(723),
    [anon_sym_keyof] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [1132] = {
    [ts_builtin_sym_end] = ACTIONS(3249),
    [sym_identifier] = ACTIONS(3251),
    [anon_sym_export] = ACTIONS(3251),
    [anon_sym_default] = ACTIONS(3251),
    [anon_sym_namespace] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_type] = ACTIONS(3251),
    [anon_sym_typeof] = ACTIONS(3251),
    [anon_sym_import] = ACTIONS(3251),
    [anon_sym_var] = ACTIONS(3251),
    [anon_sym_let] = ACTIONS(3251),
    [anon_sym_const] = ACTIONS(3251),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(3251),
    [anon_sym_switch] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_await] = ACTIONS(3251),
    [anon_sym_while] = ACTIONS(3251),
    [anon_sym_do] = ACTIONS(3251),
    [anon_sym_try] = ACTIONS(3251),
    [anon_sym_with] = ACTIONS(3251),
    [anon_sym_break] = ACTIONS(3251),
    [anon_sym_continue] = ACTIONS(3251),
    [anon_sym_debugger] = ACTIONS(3251),
    [anon_sym_return] = ACTIONS(3251),
    [anon_sym_throw] = ACTIONS(3251),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_case] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LT] = ACTIONS(3249),
    [anon_sym_SLASH] = ACTIONS(3251),
    [anon_sym_class] = ACTIONS(3251),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3251),
    [anon_sym_PLUS] = ACTIONS(3251),
    [anon_sym_DASH] = ACTIONS(3251),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_void] = ACTIONS(3251),
    [anon_sym_delete] = ACTIONS(3251),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3249),
    [sym_number] = ACTIONS(3249),
    [sym_this] = ACTIONS(3251),
    [sym_super] = ACTIONS(3251),
    [sym_true] = ACTIONS(3251),
    [sym_false] = ACTIONS(3251),
    [sym_null] = ACTIONS(3251),
    [sym_undefined] = ACTIONS(3251),
    [anon_sym_AT] = ACTIONS(3249),
    [anon_sym_declare] = ACTIONS(3251),
    [anon_sym_static] = ACTIONS(3251),
    [anon_sym_readonly] = ACTIONS(3251),
    [anon_sym_abstract] = ACTIONS(3251),
    [anon_sym_get] = ACTIONS(3251),
    [anon_sym_set] = ACTIONS(3251),
    [anon_sym_public] = ACTIONS(3251),
    [anon_sym_private] = ACTIONS(3251),
    [anon_sym_protected] = ACTIONS(3251),
    [anon_sym_module] = ACTIONS(3251),
    [anon_sym_any] = ACTIONS(3251),
    [anon_sym_number] = ACTIONS(3251),
    [anon_sym_boolean] = ACTIONS(3251),
    [anon_sym_string] = ACTIONS(3251),
    [anon_sym_symbol] = ACTIONS(3251),
    [anon_sym_interface] = ACTIONS(3251),
    [anon_sym_enum] = ACTIONS(3251),
  },
  [1133] = {
    [ts_builtin_sym_end] = ACTIONS(3253),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_RBRACE] = ACTIONS(3253),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3253),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3253),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3253),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3253),
    [anon_sym_LT] = ACTIONS(3253),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3253),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3253),
    [anon_sym_DASH_DASH] = ACTIONS(3253),
    [anon_sym_DQUOTE] = ACTIONS(3253),
    [anon_sym_SQUOTE] = ACTIONS(3253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3253),
    [sym_number] = ACTIONS(3253),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3253),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
  },
  [1134] = {
    [ts_builtin_sym_end] = ACTIONS(3257),
    [sym_identifier] = ACTIONS(3259),
    [anon_sym_export] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3259),
    [anon_sym_namespace] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_RBRACE] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3259),
    [anon_sym_typeof] = ACTIONS(3259),
    [anon_sym_import] = ACTIONS(3259),
    [anon_sym_var] = ACTIONS(3259),
    [anon_sym_let] = ACTIONS(3259),
    [anon_sym_const] = ACTIONS(3259),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_else] = ACTIONS(3259),
    [anon_sym_if] = ACTIONS(3259),
    [anon_sym_switch] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_await] = ACTIONS(3259),
    [anon_sym_while] = ACTIONS(3259),
    [anon_sym_do] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3259),
    [anon_sym_with] = ACTIONS(3259),
    [anon_sym_break] = ACTIONS(3259),
    [anon_sym_continue] = ACTIONS(3259),
    [anon_sym_debugger] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_throw] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(3257),
    [anon_sym_case] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3259),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LT] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3259),
    [anon_sym_class] = ACTIONS(3259),
    [anon_sym_async] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3257),
    [anon_sym_void] = ACTIONS(3259),
    [anon_sym_delete] = ACTIONS(3259),
    [anon_sym_PLUS_PLUS] = ACTIONS(3257),
    [anon_sym_DASH_DASH] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_SQUOTE] = ACTIONS(3257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3257),
    [sym_number] = ACTIONS(3257),
    [sym_this] = ACTIONS(3259),
    [sym_super] = ACTIONS(3259),
    [sym_true] = ACTIONS(3259),
    [sym_false] = ACTIONS(3259),
    [sym_null] = ACTIONS(3259),
    [sym_undefined] = ACTIONS(3259),
    [anon_sym_AT] = ACTIONS(3257),
    [anon_sym_declare] = ACTIONS(3259),
    [anon_sym_static] = ACTIONS(3259),
    [anon_sym_readonly] = ACTIONS(3259),
    [anon_sym_abstract] = ACTIONS(3259),
    [anon_sym_get] = ACTIONS(3259),
    [anon_sym_set] = ACTIONS(3259),
    [anon_sym_public] = ACTIONS(3259),
    [anon_sym_private] = ACTIONS(3259),
    [anon_sym_protected] = ACTIONS(3259),
    [anon_sym_module] = ACTIONS(3259),
    [anon_sym_any] = ACTIONS(3259),
    [anon_sym_number] = ACTIONS(3259),
    [anon_sym_boolean] = ACTIONS(3259),
    [anon_sym_string] = ACTIONS(3259),
    [anon_sym_symbol] = ACTIONS(3259),
    [anon_sym_interface] = ACTIONS(3259),
    [anon_sym_enum] = ACTIONS(3259),
  },
  [1135] = {
    [ts_builtin_sym_end] = ACTIONS(3261),
    [sym_identifier] = ACTIONS(3263),
    [anon_sym_export] = ACTIONS(3263),
    [anon_sym_default] = ACTIONS(3263),
    [anon_sym_namespace] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_type] = ACTIONS(3263),
    [anon_sym_typeof] = ACTIONS(3263),
    [anon_sym_import] = ACTIONS(3263),
    [anon_sym_var] = ACTIONS(3263),
    [anon_sym_let] = ACTIONS(3263),
    [anon_sym_const] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3261),
    [anon_sym_else] = ACTIONS(3263),
    [anon_sym_if] = ACTIONS(3263),
    [anon_sym_switch] = ACTIONS(3263),
    [anon_sym_for] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_await] = ACTIONS(3263),
    [anon_sym_while] = ACTIONS(3263),
    [anon_sym_do] = ACTIONS(3263),
    [anon_sym_try] = ACTIONS(3263),
    [anon_sym_with] = ACTIONS(3263),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_continue] = ACTIONS(3263),
    [anon_sym_debugger] = ACTIONS(3263),
    [anon_sym_return] = ACTIONS(3263),
    [anon_sym_throw] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_case] = ACTIONS(3263),
    [anon_sym_yield] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(3261),
    [anon_sym_SLASH] = ACTIONS(3263),
    [anon_sym_class] = ACTIONS(3263),
    [anon_sym_async] = ACTIONS(3263),
    [anon_sym_function] = ACTIONS(3263),
    [anon_sym_new] = ACTIONS(3263),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3261),
    [anon_sym_void] = ACTIONS(3263),
    [anon_sym_delete] = ACTIONS(3263),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_SQUOTE] = ACTIONS(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [sym_number] = ACTIONS(3261),
    [sym_this] = ACTIONS(3263),
    [sym_super] = ACTIONS(3263),
    [sym_true] = ACTIONS(3263),
    [sym_false] = ACTIONS(3263),
    [sym_null] = ACTIONS(3263),
    [sym_undefined] = ACTIONS(3263),
    [anon_sym_AT] = ACTIONS(3261),
    [anon_sym_declare] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(3263),
    [anon_sym_readonly] = ACTIONS(3263),
    [anon_sym_abstract] = ACTIONS(3263),
    [anon_sym_get] = ACTIONS(3263),
    [anon_sym_set] = ACTIONS(3263),
    [anon_sym_public] = ACTIONS(3263),
    [anon_sym_private] = ACTIONS(3263),
    [anon_sym_protected] = ACTIONS(3263),
    [anon_sym_module] = ACTIONS(3263),
    [anon_sym_any] = ACTIONS(3263),
    [anon_sym_number] = ACTIONS(3263),
    [anon_sym_boolean] = ACTIONS(3263),
    [anon_sym_string] = ACTIONS(3263),
    [anon_sym_symbol] = ACTIONS(3263),
    [anon_sym_interface] = ACTIONS(3263),
    [anon_sym_enum] = ACTIONS(3263),
  },
  [1136] = {
    [ts_builtin_sym_end] = ACTIONS(3265),
    [sym_identifier] = ACTIONS(3267),
    [anon_sym_export] = ACTIONS(3267),
    [anon_sym_default] = ACTIONS(3267),
    [anon_sym_namespace] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_RBRACE] = ACTIONS(3265),
    [anon_sym_type] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym_import] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_else] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_LPAREN] = ACTIONS(3265),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_with] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_debugger] = ACTIONS(3267),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3265),
    [anon_sym_case] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3265),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3267),
    [anon_sym_class] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_function] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_TILDE] = ACTIONS(3265),
    [anon_sym_void] = ACTIONS(3267),
    [anon_sym_delete] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3265),
    [anon_sym_DASH_DASH] = ACTIONS(3265),
    [anon_sym_DQUOTE] = ACTIONS(3265),
    [anon_sym_SQUOTE] = ACTIONS(3265),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3265),
    [sym_number] = ACTIONS(3265),
    [sym_this] = ACTIONS(3267),
    [sym_super] = ACTIONS(3267),
    [sym_true] = ACTIONS(3267),
    [sym_false] = ACTIONS(3267),
    [sym_null] = ACTIONS(3267),
    [sym_undefined] = ACTIONS(3267),
    [anon_sym_AT] = ACTIONS(3265),
    [anon_sym_declare] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_get] = ACTIONS(3267),
    [anon_sym_set] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_module] = ACTIONS(3267),
    [anon_sym_any] = ACTIONS(3267),
    [anon_sym_number] = ACTIONS(3267),
    [anon_sym_boolean] = ACTIONS(3267),
    [anon_sym_string] = ACTIONS(3267),
    [anon_sym_symbol] = ACTIONS(3267),
    [anon_sym_interface] = ACTIONS(3267),
    [anon_sym_enum] = ACTIONS(3267),
  },
  [1137] = {
    [ts_builtin_sym_end] = ACTIONS(3269),
    [sym_identifier] = ACTIONS(3271),
    [anon_sym_export] = ACTIONS(3271),
    [anon_sym_default] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_type] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym_import] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_with] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_debugger] = ACTIONS(3271),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_case] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3269),
    [anon_sym_SLASH] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_function] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_delete] = ACTIONS(3271),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [anon_sym_DQUOTE] = ACTIONS(3269),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym_number] = ACTIONS(3269),
    [sym_this] = ACTIONS(3271),
    [sym_super] = ACTIONS(3271),
    [sym_true] = ACTIONS(3271),
    [sym_false] = ACTIONS(3271),
    [sym_null] = ACTIONS(3271),
    [sym_undefined] = ACTIONS(3271),
    [anon_sym_AT] = ACTIONS(3269),
    [anon_sym_declare] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_get] = ACTIONS(3271),
    [anon_sym_set] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_module] = ACTIONS(3271),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
  },
  [1138] = {
    [ts_builtin_sym_end] = ACTIONS(3273),
    [sym_identifier] = ACTIONS(3275),
    [anon_sym_export] = ACTIONS(3275),
    [anon_sym_default] = ACTIONS(3275),
    [anon_sym_namespace] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_type] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym_import] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_else] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_with] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_debugger] = ACTIONS(3275),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_case] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LT] = ACTIONS(3273),
    [anon_sym_SLASH] = ACTIONS(3275),
    [anon_sym_class] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_function] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_void] = ACTIONS(3275),
    [anon_sym_delete] = ACTIONS(3275),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3273),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3273),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_super] = ACTIONS(3275),
    [sym_true] = ACTIONS(3275),
    [sym_false] = ACTIONS(3275),
    [sym_null] = ACTIONS(3275),
    [sym_undefined] = ACTIONS(3275),
    [anon_sym_AT] = ACTIONS(3273),
    [anon_sym_declare] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_get] = ACTIONS(3275),
    [anon_sym_set] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_module] = ACTIONS(3275),
    [anon_sym_any] = ACTIONS(3275),
    [anon_sym_number] = ACTIONS(3275),
    [anon_sym_boolean] = ACTIONS(3275),
    [anon_sym_string] = ACTIONS(3275),
    [anon_sym_symbol] = ACTIONS(3275),
    [anon_sym_interface] = ACTIONS(3275),
    [anon_sym_enum] = ACTIONS(3275),
  },
  [1139] = {
    [ts_builtin_sym_end] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1999),
    [anon_sym_export] = ACTIONS(1999),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_namespace] = ACTIONS(1999),
    [anon_sym_LBRACE] = ACTIONS(1997),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_type] = ACTIONS(1999),
    [anon_sym_typeof] = ACTIONS(1999),
    [anon_sym_import] = ACTIONS(1999),
    [anon_sym_var] = ACTIONS(1999),
    [anon_sym_let] = ACTIONS(1999),
    [anon_sym_const] = ACTIONS(1999),
    [anon_sym_BANG] = ACTIONS(1997),
    [anon_sym_else] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_switch] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_await] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1999),
    [anon_sym_do] = ACTIONS(1999),
    [anon_sym_try] = ACTIONS(1999),
    [anon_sym_with] = ACTIONS(1999),
    [anon_sym_break] = ACTIONS(1999),
    [anon_sym_continue] = ACTIONS(1999),
    [anon_sym_debugger] = ACTIONS(1999),
    [anon_sym_return] = ACTIONS(1999),
    [anon_sym_throw] = ACTIONS(1999),
    [anon_sym_SEMI] = ACTIONS(1997),
    [anon_sym_case] = ACTIONS(1999),
    [anon_sym_yield] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(1999),
    [anon_sym_class] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_function] = ACTIONS(1999),
    [anon_sym_new] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1997),
    [anon_sym_void] = ACTIONS(1999),
    [anon_sym_delete] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1997),
    [anon_sym_DQUOTE] = ACTIONS(1997),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1997),
    [sym_number] = ACTIONS(1997),
    [sym_this] = ACTIONS(1999),
    [sym_super] = ACTIONS(1999),
    [sym_true] = ACTIONS(1999),
    [sym_false] = ACTIONS(1999),
    [sym_null] = ACTIONS(1999),
    [sym_undefined] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1997),
    [anon_sym_declare] = ACTIONS(1999),
    [anon_sym_static] = ACTIONS(1999),
    [anon_sym_readonly] = ACTIONS(1999),
    [anon_sym_abstract] = ACTIONS(1999),
    [anon_sym_get] = ACTIONS(1999),
    [anon_sym_set] = ACTIONS(1999),
    [anon_sym_public] = ACTIONS(1999),
    [anon_sym_private] = ACTIONS(1999),
    [anon_sym_protected] = ACTIONS(1999),
    [anon_sym_module] = ACTIONS(1999),
    [anon_sym_any] = ACTIONS(1999),
    [anon_sym_number] = ACTIONS(1999),
    [anon_sym_boolean] = ACTIONS(1999),
    [anon_sym_string] = ACTIONS(1999),
    [anon_sym_symbol] = ACTIONS(1999),
    [anon_sym_interface] = ACTIONS(1999),
    [anon_sym_enum] = ACTIONS(1999),
  },
  [1140] = {
    [ts_builtin_sym_end] = ACTIONS(3277),
    [sym_identifier] = ACTIONS(3279),
    [anon_sym_export] = ACTIONS(3279),
    [anon_sym_default] = ACTIONS(3279),
    [anon_sym_namespace] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_type] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym_import] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_else] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_with] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_debugger] = ACTIONS(3279),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_case] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(3277),
    [anon_sym_SLASH] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_function] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_void] = ACTIONS(3279),
    [anon_sym_delete] = ACTIONS(3279),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3277),
    [sym_number] = ACTIONS(3277),
    [sym_this] = ACTIONS(3279),
    [sym_super] = ACTIONS(3279),
    [sym_true] = ACTIONS(3279),
    [sym_false] = ACTIONS(3279),
    [sym_null] = ACTIONS(3279),
    [sym_undefined] = ACTIONS(3279),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_get] = ACTIONS(3279),
    [anon_sym_set] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_module] = ACTIONS(3279),
    [anon_sym_any] = ACTIONS(3279),
    [anon_sym_number] = ACTIONS(3279),
    [anon_sym_boolean] = ACTIONS(3279),
    [anon_sym_string] = ACTIONS(3279),
    [anon_sym_symbol] = ACTIONS(3279),
    [anon_sym_interface] = ACTIONS(3279),
    [anon_sym_enum] = ACTIONS(3279),
  },
  [1141] = {
    [ts_builtin_sym_end] = ACTIONS(3281),
    [sym_identifier] = ACTIONS(3283),
    [anon_sym_export] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_type] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym_import] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_with] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_debugger] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_case] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LT] = ACTIONS(3281),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_class] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_void] = ACTIONS(3283),
    [anon_sym_delete] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3281),
    [sym_number] = ACTIONS(3281),
    [sym_this] = ACTIONS(3283),
    [sym_super] = ACTIONS(3283),
    [sym_true] = ACTIONS(3283),
    [sym_false] = ACTIONS(3283),
    [sym_null] = ACTIONS(3283),
    [sym_undefined] = ACTIONS(3283),
    [anon_sym_AT] = ACTIONS(3281),
    [anon_sym_declare] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_get] = ACTIONS(3283),
    [anon_sym_set] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(3283),
    [anon_sym_any] = ACTIONS(3283),
    [anon_sym_number] = ACTIONS(3283),
    [anon_sym_boolean] = ACTIONS(3283),
    [anon_sym_string] = ACTIONS(3283),
    [anon_sym_symbol] = ACTIONS(3283),
    [anon_sym_interface] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
  },
  [1142] = {
    [ts_builtin_sym_end] = ACTIONS(3285),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_export] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3287),
    [anon_sym_namespace] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym_import] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_debugger] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_case] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3287),
    [anon_sym_delete] = ACTIONS(3287),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_this] = ACTIONS(3287),
    [sym_super] = ACTIONS(3287),
    [sym_true] = ACTIONS(3287),
    [sym_false] = ACTIONS(3287),
    [sym_null] = ACTIONS(3287),
    [sym_undefined] = ACTIONS(3287),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_get] = ACTIONS(3287),
    [anon_sym_set] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_module] = ACTIONS(3287),
    [anon_sym_any] = ACTIONS(3287),
    [anon_sym_number] = ACTIONS(3287),
    [anon_sym_boolean] = ACTIONS(3287),
    [anon_sym_string] = ACTIONS(3287),
    [anon_sym_symbol] = ACTIONS(3287),
    [anon_sym_interface] = ACTIONS(3287),
    [anon_sym_enum] = ACTIONS(3287),
  },
  [1143] = {
    [ts_builtin_sym_end] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3291),
    [anon_sym_export] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_type] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym_import] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_else] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_with] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_debugger] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_case] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3289),
    [anon_sym_SLASH] = ACTIONS(3291),
    [anon_sym_class] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_function] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_void] = ACTIONS(3291),
    [anon_sym_delete] = ACTIONS(3291),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3289),
    [sym_number] = ACTIONS(3289),
    [sym_this] = ACTIONS(3291),
    [sym_super] = ACTIONS(3291),
    [sym_true] = ACTIONS(3291),
    [sym_false] = ACTIONS(3291),
    [sym_null] = ACTIONS(3291),
    [sym_undefined] = ACTIONS(3291),
    [anon_sym_AT] = ACTIONS(3289),
    [anon_sym_declare] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_get] = ACTIONS(3291),
    [anon_sym_set] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_module] = ACTIONS(3291),
    [anon_sym_any] = ACTIONS(3291),
    [anon_sym_number] = ACTIONS(3291),
    [anon_sym_boolean] = ACTIONS(3291),
    [anon_sym_string] = ACTIONS(3291),
    [anon_sym_symbol] = ACTIONS(3291),
    [anon_sym_interface] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
  },
  [1144] = {
    [ts_builtin_sym_end] = ACTIONS(3293),
    [sym_identifier] = ACTIONS(3295),
    [anon_sym_export] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_namespace] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_type] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_with] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_debugger] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_case] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3295),
    [anon_sym_class] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_function] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_delete] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3293),
    [sym_number] = ACTIONS(3293),
    [sym_this] = ACTIONS(3295),
    [sym_super] = ACTIONS(3295),
    [sym_true] = ACTIONS(3295),
    [sym_false] = ACTIONS(3295),
    [sym_null] = ACTIONS(3295),
    [sym_undefined] = ACTIONS(3295),
    [anon_sym_AT] = ACTIONS(3293),
    [anon_sym_declare] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_get] = ACTIONS(3295),
    [anon_sym_set] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_module] = ACTIONS(3295),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_interface] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
  },
  [1145] = {
    [ts_builtin_sym_end] = ACTIONS(3297),
    [sym_identifier] = ACTIONS(3299),
    [anon_sym_export] = ACTIONS(3299),
    [anon_sym_default] = ACTIONS(3299),
    [anon_sym_namespace] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_type] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym_import] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_else] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_with] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_debugger] = ACTIONS(3299),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_case] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_function] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_void] = ACTIONS(3299),
    [anon_sym_delete] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3297),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3297),
    [sym_number] = ACTIONS(3297),
    [sym_this] = ACTIONS(3299),
    [sym_super] = ACTIONS(3299),
    [sym_true] = ACTIONS(3299),
    [sym_false] = ACTIONS(3299),
    [sym_null] = ACTIONS(3299),
    [sym_undefined] = ACTIONS(3299),
    [anon_sym_AT] = ACTIONS(3297),
    [anon_sym_declare] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_get] = ACTIONS(3299),
    [anon_sym_set] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_module] = ACTIONS(3299),
    [anon_sym_any] = ACTIONS(3299),
    [anon_sym_number] = ACTIONS(3299),
    [anon_sym_boolean] = ACTIONS(3299),
    [anon_sym_string] = ACTIONS(3299),
    [anon_sym_symbol] = ACTIONS(3299),
    [anon_sym_interface] = ACTIONS(3299),
    [anon_sym_enum] = ACTIONS(3299),
  },
  [1146] = {
    [sym_identifier] = ACTIONS(3301),
    [anon_sym_export] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_type] = ACTIONS(3301),
    [anon_sym_typeof] = ACTIONS(3301),
    [anon_sym_import] = ACTIONS(3301),
    [anon_sym_var] = ACTIONS(3301),
    [anon_sym_let] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_with] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_debugger] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_LT] = ACTIONS(3303),
    [anon_sym_SLASH] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_async] = ACTIONS(3301),
    [anon_sym_function] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_void] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3303),
    [sym_number] = ACTIONS(3303),
    [sym_this] = ACTIONS(3301),
    [sym_super] = ACTIONS(3301),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [sym_null] = ACTIONS(3301),
    [sym_undefined] = ACTIONS(3301),
    [anon_sym_AT] = ACTIONS(3303),
    [anon_sym_declare] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_readonly] = ACTIONS(3301),
    [anon_sym_abstract] = ACTIONS(3301),
    [anon_sym_get] = ACTIONS(3301),
    [anon_sym_set] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_module] = ACTIONS(3301),
    [anon_sym_any] = ACTIONS(3301),
    [anon_sym_number] = ACTIONS(3301),
    [anon_sym_boolean] = ACTIONS(3301),
    [anon_sym_string] = ACTIONS(3301),
    [anon_sym_symbol] = ACTIONS(3301),
    [anon_sym_interface] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
  },
  [1147] = {
    [sym_identifier] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(3305),
    [anon_sym_namespace] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3307),
    [anon_sym_type] = ACTIONS(3305),
    [anon_sym_typeof] = ACTIONS(3305),
    [anon_sym_import] = ACTIONS(3305),
    [anon_sym_var] = ACTIONS(3305),
    [anon_sym_let] = ACTIONS(3305),
    [anon_sym_const] = ACTIONS(3305),
    [anon_sym_BANG] = ACTIONS(3307),
    [anon_sym_if] = ACTIONS(3305),
    [anon_sym_switch] = ACTIONS(3305),
    [anon_sym_for] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3305),
    [anon_sym_while] = ACTIONS(3305),
    [anon_sym_do] = ACTIONS(3305),
    [anon_sym_try] = ACTIONS(3305),
    [anon_sym_with] = ACTIONS(3305),
    [anon_sym_break] = ACTIONS(3305),
    [anon_sym_continue] = ACTIONS(3305),
    [anon_sym_debugger] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3305),
    [anon_sym_throw] = ACTIONS(3305),
    [anon_sym_SEMI] = ACTIONS(3307),
    [anon_sym_yield] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3307),
    [anon_sym_SLASH] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3305),
    [anon_sym_async] = ACTIONS(3305),
    [anon_sym_function] = ACTIONS(3305),
    [anon_sym_new] = ACTIONS(3305),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3307),
    [anon_sym_void] = ACTIONS(3305),
    [anon_sym_delete] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3307),
    [anon_sym_DASH_DASH] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [anon_sym_SQUOTE] = ACTIONS(3307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3307),
    [sym_number] = ACTIONS(3307),
    [sym_this] = ACTIONS(3305),
    [sym_super] = ACTIONS(3305),
    [sym_true] = ACTIONS(3305),
    [sym_false] = ACTIONS(3305),
    [sym_null] = ACTIONS(3305),
    [sym_undefined] = ACTIONS(3305),
    [anon_sym_AT] = ACTIONS(3307),
    [anon_sym_declare] = ACTIONS(3305),
    [anon_sym_static] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_abstract] = ACTIONS(3305),
    [anon_sym_get] = ACTIONS(3305),
    [anon_sym_set] = ACTIONS(3305),
    [anon_sym_public] = ACTIONS(3305),
    [anon_sym_private] = ACTIONS(3305),
    [anon_sym_protected] = ACTIONS(3305),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_any] = ACTIONS(3305),
    [anon_sym_number] = ACTIONS(3305),
    [anon_sym_boolean] = ACTIONS(3305),
    [anon_sym_string] = ACTIONS(3305),
    [anon_sym_symbol] = ACTIONS(3305),
    [anon_sym_interface] = ACTIONS(3305),
    [anon_sym_enum] = ACTIONS(3305),
  },
  [1148] = {
    [sym_identifier] = ACTIONS(3309),
    [anon_sym_export] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_type] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym_import] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_with] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_debugger] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_SLASH] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_function] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_void] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3311),
    [sym_number] = ACTIONS(3311),
    [sym_this] = ACTIONS(3309),
    [sym_super] = ACTIONS(3309),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [sym_null] = ACTIONS(3309),
    [sym_undefined] = ACTIONS(3309),
    [anon_sym_AT] = ACTIONS(3311),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_readonly] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_get] = ACTIONS(3309),
    [anon_sym_set] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_module] = ACTIONS(3309),
    [anon_sym_any] = ACTIONS(3309),
    [anon_sym_number] = ACTIONS(3309),
    [anon_sym_boolean] = ACTIONS(3309),
    [anon_sym_string] = ACTIONS(3309),
    [anon_sym_symbol] = ACTIONS(3309),
    [anon_sym_interface] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
  },
  [1149] = {
    [sym_identifier] = ACTIONS(3313),
    [anon_sym_export] = ACTIONS(3313),
    [anon_sym_namespace] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_type] = ACTIONS(3313),
    [anon_sym_typeof] = ACTIONS(3313),
    [anon_sym_import] = ACTIONS(3313),
    [anon_sym_var] = ACTIONS(3313),
    [anon_sym_let] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3313),
    [anon_sym_BANG] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3313),
    [anon_sym_switch] = ACTIONS(3313),
    [anon_sym_for] = ACTIONS(3313),
    [anon_sym_LPAREN] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3313),
    [anon_sym_while] = ACTIONS(3313),
    [anon_sym_do] = ACTIONS(3313),
    [anon_sym_try] = ACTIONS(3313),
    [anon_sym_with] = ACTIONS(3313),
    [anon_sym_break] = ACTIONS(3313),
    [anon_sym_continue] = ACTIONS(3313),
    [anon_sym_debugger] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3313),
    [anon_sym_throw] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3313),
    [anon_sym_LBRACK] = ACTIONS(3315),
    [anon_sym_LT] = ACTIONS(3315),
    [anon_sym_SLASH] = ACTIONS(3313),
    [anon_sym_class] = ACTIONS(3313),
    [anon_sym_async] = ACTIONS(3313),
    [anon_sym_function] = ACTIONS(3313),
    [anon_sym_new] = ACTIONS(3313),
    [anon_sym_PLUS] = ACTIONS(3313),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_TILDE] = ACTIONS(3315),
    [anon_sym_void] = ACTIONS(3313),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_PLUS_PLUS] = ACTIONS(3315),
    [anon_sym_DASH_DASH] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3315),
    [sym_number] = ACTIONS(3315),
    [sym_this] = ACTIONS(3313),
    [sym_super] = ACTIONS(3313),
    [sym_true] = ACTIONS(3313),
    [sym_false] = ACTIONS(3313),
    [sym_null] = ACTIONS(3313),
    [sym_undefined] = ACTIONS(3313),
    [anon_sym_AT] = ACTIONS(3315),
    [anon_sym_declare] = ACTIONS(3313),
    [anon_sym_static] = ACTIONS(3313),
    [anon_sym_readonly] = ACTIONS(3313),
    [anon_sym_abstract] = ACTIONS(3313),
    [anon_sym_get] = ACTIONS(3313),
    [anon_sym_set] = ACTIONS(3313),
    [anon_sym_public] = ACTIONS(3313),
    [anon_sym_private] = ACTIONS(3313),
    [anon_sym_protected] = ACTIONS(3313),
    [anon_sym_module] = ACTIONS(3313),
    [anon_sym_any] = ACTIONS(3313),
    [anon_sym_number] = ACTIONS(3313),
    [anon_sym_boolean] = ACTIONS(3313),
    [anon_sym_string] = ACTIONS(3313),
    [anon_sym_symbol] = ACTIONS(3313),
    [anon_sym_interface] = ACTIONS(3313),
    [anon_sym_enum] = ACTIONS(3313),
  },
  [1150] = {
    [sym_identifier] = ACTIONS(3317),
    [anon_sym_export] = ACTIONS(3317),
    [anon_sym_namespace] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_type] = ACTIONS(3317),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_import] = ACTIONS(3317),
    [anon_sym_var] = ACTIONS(3317),
    [anon_sym_let] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3317),
    [anon_sym_switch] = ACTIONS(3317),
    [anon_sym_for] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3317),
    [anon_sym_while] = ACTIONS(3317),
    [anon_sym_do] = ACTIONS(3317),
    [anon_sym_try] = ACTIONS(3317),
    [anon_sym_with] = ACTIONS(3317),
    [anon_sym_break] = ACTIONS(3317),
    [anon_sym_continue] = ACTIONS(3317),
    [anon_sym_debugger] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_throw] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3319),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_class] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_function] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3319),
    [anon_sym_void] = ACTIONS(3317),
    [anon_sym_delete] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym_number] = ACTIONS(3319),
    [sym_this] = ACTIONS(3317),
    [sym_super] = ACTIONS(3317),
    [sym_true] = ACTIONS(3317),
    [sym_false] = ACTIONS(3317),
    [sym_null] = ACTIONS(3317),
    [sym_undefined] = ACTIONS(3317),
    [anon_sym_AT] = ACTIONS(3319),
    [anon_sym_declare] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_get] = ACTIONS(3317),
    [anon_sym_set] = ACTIONS(3317),
    [anon_sym_public] = ACTIONS(3317),
    [anon_sym_private] = ACTIONS(3317),
    [anon_sym_protected] = ACTIONS(3317),
    [anon_sym_module] = ACTIONS(3317),
    [anon_sym_any] = ACTIONS(3317),
    [anon_sym_number] = ACTIONS(3317),
    [anon_sym_boolean] = ACTIONS(3317),
    [anon_sym_string] = ACTIONS(3317),
    [anon_sym_symbol] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3317),
    [anon_sym_enum] = ACTIONS(3317),
  },
  [1151] = {
    [sym_nested_identifier] = STATE(1040),
    [sym_string] = STATE(1058),
    [sym__module] = STATE(1143),
    [aux_sym_object_repeat1] = STATE(4747),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1152] = {
    [sym_nested_identifier] = STATE(133),
    [sym_string] = STATE(131),
    [sym__module] = STATE(138),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1153] = {
    [sym_nested_identifier] = STATE(1040),
    [sym_string] = STATE(1058),
    [sym__module] = STATE(1143),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1154] = {
    [sym_nested_identifier] = STATE(1040),
    [sym_string] = STATE(1058),
    [sym__module] = STATE(1143),
    [aux_sym_object_repeat1] = STATE(4799),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1155] = {
    [sym_nested_identifier] = STATE(1040),
    [sym_string] = STATE(1058),
    [sym__module] = STATE(1143),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1156] = {
    [sym_nested_identifier] = STATE(1040),
    [sym_string] = STATE(1058),
    [sym__module] = STATE(1143),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1157] = {
    [sym_nested_identifier] = STATE(1040),
    [sym_string] = STATE(1058),
    [sym__module] = STATE(1143),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1158] = {
    [sym_nested_identifier] = STATE(133),
    [sym_string] = STATE(131),
    [sym__module] = STATE(138),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1159] = {
    [sym_nested_identifier] = STATE(133),
    [sym_string] = STATE(131),
    [sym__module] = STATE(138),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1160] = {
    [sym_nested_identifier] = STATE(133),
    [sym_string] = STATE(131),
    [sym__module] = STATE(138),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1161] = {
    [sym_nested_identifier] = STATE(2033),
    [sym_string] = STATE(2032),
    [sym__module] = STATE(2206),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1811),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1813),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1162] = {
    [sym_nested_identifier] = STATE(133),
    [sym_string] = STATE(131),
    [sym__module] = STATE(138),
    [aux_sym_object_repeat1] = STATE(4799),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1163] = {
    [sym_nested_identifier] = STATE(133),
    [sym_string] = STATE(131),
    [sym__module] = STATE(138),
    [aux_sym_object_repeat1] = STATE(4747),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1164] = {
    [sym_nested_identifier] = STATE(2033),
    [sym_string] = STATE(2032),
    [sym__module] = STATE(2206),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1165] = {
    [sym_nested_identifier] = STATE(133),
    [sym_string] = STATE(131),
    [sym__module] = STATE(138),
    [aux_sym_object_repeat1] = STATE(4831),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1166] = {
    [sym_nested_identifier] = STATE(1040),
    [sym_string] = STATE(1058),
    [sym__module] = STATE(1143),
    [aux_sym_object_repeat1] = STATE(4772),
    [aux_sym_object_pattern_repeat1] = STATE(4771),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1823),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1167] = {
    [sym_nested_identifier] = STATE(2033),
    [sym_string] = STATE(2032),
    [sym__module] = STATE(2206),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1813),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1168] = {
    [sym_nested_identifier] = STATE(2040),
    [sym_string] = STATE(2039),
    [sym__module] = STATE(2093),
    [sym_identifier] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1789),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1169] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_rest_pattern] = STATE(4946),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4913),
    [sym_optional_tuple_parameter] = STATE(4913),
    [sym_optional_type] = STATE(4913),
    [sym_rest_type] = STATE(4913),
    [sym__tuple_type_member] = STATE(4913),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3337),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [1170] = {
    [sym_nested_identifier] = STATE(2488),
    [sym_string] = STATE(2487),
    [sym__module] = STATE(2653),
    [sym_identifier] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1829),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1817),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1597),
  },
  [1171] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_rest_pattern] = STATE(4946),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4809),
    [sym_optional_tuple_parameter] = STATE(4809),
    [sym_optional_type] = STATE(4809),
    [sym_rest_type] = STATE(4809),
    [sym__tuple_type_member] = STATE(4809),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(3341),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3337),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [1172] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_rest_pattern] = STATE(4946),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4866),
    [sym_optional_tuple_parameter] = STATE(4866),
    [sym_optional_type] = STATE(4866),
    [sym_rest_type] = STATE(4866),
    [sym__tuple_type_member] = STATE(4866),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(3343),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3337),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [1173] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_rest_pattern] = STATE(4946),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4746),
    [sym_optional_tuple_parameter] = STATE(4746),
    [sym_optional_type] = STATE(4746),
    [sym_rest_type] = STATE(4746),
    [sym__tuple_type_member] = STATE(4746),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(3345),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3337),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [1174] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_rest_pattern] = STATE(4946),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4808),
    [sym_optional_tuple_parameter] = STATE(4808),
    [sym_optional_type] = STATE(4808),
    [sym_rest_type] = STATE(4808),
    [sym__tuple_type_member] = STATE(4808),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(3347),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3337),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [1175] = {
    [sym_nested_identifier] = STATE(2033),
    [sym_string] = STATE(2032),
    [sym__module] = STATE(2206),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1813),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(1580),
  },
  [1176] = {
    [sym_nested_identifier] = STATE(2488),
    [sym_string] = STATE(2487),
    [sym__module] = STATE(2653),
    [sym_identifier] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1815),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1817),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1597),
  },
  [1177] = {
    [sym_nested_identifier] = STATE(2033),
    [sym_string] = STATE(2032),
    [sym__module] = STATE(2206),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1817),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(1580),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1597),
  },
  [1178] = {
    [sym_nested_identifier] = STATE(2033),
    [sym_string] = STATE(2032),
    [sym__module] = STATE(2206),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_DOT] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_QMARK_DOT] = ACTIONS(1597),
    [anon_sym_PLUS_EQ] = ACTIONS(1601),
    [anon_sym_DASH_EQ] = ACTIONS(1601),
    [anon_sym_STAR_EQ] = ACTIONS(1601),
    [anon_sym_SLASH_EQ] = ACTIONS(1601),
    [anon_sym_PERCENT_EQ] = ACTIONS(1601),
    [anon_sym_CARET_EQ] = ACTIONS(1601),
    [anon_sym_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1601),
    [anon_sym_LT_LT_EQ] = ACTIONS(1601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1597),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [1179] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_rest_pattern] = STATE(4946),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4776),
    [sym_optional_tuple_parameter] = STATE(4776),
    [sym_optional_type] = STATE(4776),
    [sym_rest_type] = STATE(4776),
    [sym__tuple_type_member] = STATE(4776),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(3349),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3337),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
  [1180] = {
    [sym_nested_identifier] = STATE(5311),
    [sym_string] = STATE(3704),
    [sym_formal_parameters] = STATE(5376),
    [sym_rest_pattern] = STATE(4946),
    [sym_nested_type_identifier] = STATE(3658),
    [sym__type] = STATE(4242),
    [sym_tuple_parameter] = STATE(4742),
    [sym_optional_tuple_parameter] = STATE(4742),
    [sym_optional_type] = STATE(4742),
    [sym_rest_type] = STATE(4742),
    [sym__tuple_type_member] = STATE(4742),
    [sym_constructor_type] = STATE(4242),
    [sym__primary_type] = STATE(3726),
    [sym_infer_type] = STATE(4242),
    [sym_conditional_type] = STATE(3699),
    [sym_generic_type] = STATE(3699),
    [sym_type_query] = STATE(3699),
    [sym_index_type_query] = STATE(3699),
    [sym_lookup_type] = STATE(3699),
    [sym_literal_type] = STATE(3699),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3699),
    [sym_flow_maybe_type] = STATE(3699),
    [sym_parenthesized_type] = STATE(3699),
    [sym_predefined_type] = STATE(3699),
    [sym_object_type] = STATE(3699),
    [sym_type_parameters] = STATE(5179),
    [sym_array_type] = STATE(3699),
    [sym_tuple_type] = STATE(3699),
    [sym_readonly_type] = STATE(4242),
    [sym_union_type] = STATE(4242),
    [sym_intersection_type] = STATE(4242),
    [sym_function_type] = STATE(4242),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(3351),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3337),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1807),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [anon_sym_readonly] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_infer] = ACTIONS(601),
    [anon_sym_keyof] = ACTIONS(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(605),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(1829), 1,
      anon_sym_EQ,
    ACTIONS(1831), 1,
      anon_sym_EQ_GT,
    ACTIONS(3339), 1,
      sym_identifier,
    STATE(2487), 1,
      sym_string,
    STATE(2488), 1,
      sym_nested_identifier,
    STATE(2653), 1,
      sym__module,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [89] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1797), 1,
      anon_sym_EQ_GT,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(3331), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_string,
    STATE(2040), 1,
      sym_nested_identifier,
    STATE(2093), 1,
      sym__module,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [178] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(1819), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [267] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1813), 1,
      anon_sym_EQ_GT,
    ACTIONS(1833), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [356] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3333), 1,
      sym_identifier,
    ACTIONS(3337), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(4946), 1,
      sym_rest_pattern,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    STATE(5026), 5,
      sym_tuple_parameter,
      sym_optional_tuple_parameter,
      sym_optional_type,
      sym_rest_type,
      sym__tuple_type_member,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4242), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [489] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1831), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [578] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [667] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [755] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1825), 1,
      anon_sym_EQ,
    ACTIONS(1827), 1,
      anon_sym_EQ_GT,
    ACTIONS(3331), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_string,
    STATE(2040), 1,
      sym_nested_identifier,
    STATE(2093), 1,
      sym__module,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3353), 40,
      anon_sym_export,
      anon_sym_EQ,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_implements,
      anon_sym_extends,
  [913] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(3331), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_string,
    STATE(2040), 1,
      sym_nested_identifier,
    STATE(2093), 1,
      sym__module,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1001] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(1939), 1,
      anon_sym_EQ_GT,
    ACTIONS(2141), 1,
      anon_sym_EQ,
    ACTIONS(3357), 1,
      sym_identifier,
    STATE(3039), 1,
      sym_string,
    STATE(3040), 1,
      sym_nested_identifier,
    STATE(3185), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [1089] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1797), 1,
      anon_sym_EQ_GT,
    ACTIONS(1853), 1,
      anon_sym_EQ,
    ACTIONS(3331), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_string,
    STATE(2040), 1,
      sym_nested_identifier,
    STATE(2093), 1,
      sym__module,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [1177] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1797), 1,
      anon_sym_EQ_GT,
    ACTIONS(1903), 1,
      anon_sym_EQ,
    ACTIONS(3331), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_string,
    STATE(2040), 1,
      sym_nested_identifier,
    STATE(2093), 1,
      sym__module,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [1265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3359), 40,
      anon_sym_export,
      anon_sym_EQ,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_implements,
      anon_sym_extends,
  [1335] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1833), 1,
      anon_sym_EQ,
    ACTIONS(1835), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [1423] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(1937), 1,
      anon_sym_EQ,
    ACTIONS(1939), 1,
      anon_sym_EQ_GT,
    ACTIONS(3357), 1,
      sym_identifier,
    STATE(3039), 1,
      sym_string,
    STATE(3040), 1,
      sym_nested_identifier,
    STATE(3185), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [1511] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1835), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [1599] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1865), 1,
      anon_sym_EQ_GT,
    ACTIONS(2078), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
      anon_sym_extends,
  [1687] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1939), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [1775] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2667), 1,
      anon_sym_COLON,
    ACTIONS(3323), 1,
      sym_identifier,
    ACTIONS(3325), 1,
      anon_sym_DQUOTE,
    ACTIONS(3327), 1,
      anon_sym_SQUOTE,
    STATE(131), 1,
      sym_string,
    STATE(133), 1,
      sym_nested_identifier,
    STATE(138), 1,
      sym__module,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1865] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2667), 1,
      anon_sym_COLON,
    ACTIONS(3321), 1,
      sym_identifier,
    STATE(1040), 1,
      sym_nested_identifier,
    STATE(1058), 1,
      sym_string,
    STATE(1143), 1,
      sym__module,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1955] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2615), 1,
      anon_sym_COLON,
    ACTIONS(3321), 1,
      sym_identifier,
    STATE(1040), 1,
      sym_nested_identifier,
    STATE(1058), 1,
      sym_string,
    STATE(1143), 1,
      sym__module,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2045] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1827), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [2133] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1863), 1,
      anon_sym_EQ,
    ACTIONS(1865), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
      anon_sym_extends,
  [2221] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2615), 1,
      anon_sym_COLON,
    ACTIONS(3331), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_string,
    STATE(2040), 1,
      sym_nested_identifier,
    STATE(2093), 1,
      sym__module,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2311] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2879), 1,
      anon_sym_in,
    ACTIONS(2882), 1,
      anon_sym_of,
    ACTIONS(3331), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_string,
    STATE(2040), 1,
      sym_nested_identifier,
    STATE(2093), 1,
      sym__module,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2403] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1865), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 26,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
      anon_sym_extends,
  [2491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3365), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3363), 40,
      anon_sym_export,
      anon_sym_EQ,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_implements,
      anon_sym_extends,
  [2561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3319), 38,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [2630] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_export,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3375), 1,
      anon_sym_RBRACE,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3383), 1,
      anon_sym_async,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3391), 1,
      anon_sym_static,
    ACTIONS(3393), 1,
      anon_sym_readonly,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3395), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3397), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3367), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2767] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1839), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [2854] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3403), 1,
      anon_sym_export,
    ACTIONS(3405), 1,
      anon_sym_RBRACE,
    ACTIONS(3407), 1,
      anon_sym_async,
    ACTIONS(3409), 1,
      anon_sym_static,
    ACTIONS(3411), 1,
      anon_sym_readonly,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4918), 1,
      aux_sym_object_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3413), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3415), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4921), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3401), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3419), 38,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [3060] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3423), 1,
      anon_sym_export,
    ACTIONS(3425), 1,
      anon_sym_RBRACE,
    ACTIONS(3427), 1,
      anon_sym_async,
    ACTIONS(3429), 1,
      anon_sym_static,
    ACTIONS(3431), 1,
      anon_sym_readonly,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3433), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3435), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3421), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [3197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3439), 38,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [3266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3313), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3315), 38,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [3335] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1813), 1,
      anon_sym_EQ_GT,
    ACTIONS(1941), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [3422] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3443), 1,
      anon_sym_export,
    ACTIONS(3445), 1,
      anon_sym_RBRACE,
    ACTIONS(3447), 1,
      anon_sym_async,
    ACTIONS(3449), 1,
      anon_sym_static,
    ACTIONS(3451), 1,
      anon_sym_readonly,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4760), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3453), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3455), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4789), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3441), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [3559] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_export,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3383), 1,
      anon_sym_async,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3391), 1,
      anon_sym_static,
    ACTIONS(3393), 1,
      anon_sym_readonly,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3457), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3395), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3397), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3367), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [3696] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2080), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [3783] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3403), 1,
      anon_sym_export,
    ACTIONS(3407), 1,
      anon_sym_async,
    ACTIONS(3409), 1,
      anon_sym_static,
    ACTIONS(3411), 1,
      anon_sym_readonly,
    ACTIONS(3459), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4918), 1,
      aux_sym_object_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3413), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3415), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4921), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3401), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [3920] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1855), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [4007] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_export,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3383), 1,
      anon_sym_async,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3391), 1,
      anon_sym_static,
    ACTIONS(3393), 1,
      anon_sym_readonly,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3461), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3395), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3397), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3367), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4144] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(2143), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [4231] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3403), 1,
      anon_sym_export,
    ACTIONS(3407), 1,
      anon_sym_async,
    ACTIONS(3409), 1,
      anon_sym_static,
    ACTIONS(3411), 1,
      anon_sym_readonly,
    ACTIONS(3463), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4918), 1,
      aux_sym_object_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3413), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3415), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4921), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3401), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4368] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1837), 1,
      anon_sym_EQ,
    ACTIONS(1839), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [4455] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3467), 1,
      anon_sym_export,
    ACTIONS(3469), 1,
      anon_sym_RBRACE,
    ACTIONS(3471), 1,
      anon_sym_async,
    ACTIONS(3473), 1,
      anon_sym_static,
    ACTIONS(3475), 1,
      anon_sym_readonly,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4918), 1,
      aux_sym_object_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3477), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3479), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4921), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3465), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3483), 38,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [4661] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3487), 1,
      anon_sym_export,
    ACTIONS(3489), 1,
      anon_sym_RBRACE,
    ACTIONS(3491), 1,
      anon_sym_async,
    ACTIONS(3493), 1,
      anon_sym_static,
    ACTIONS(3495), 1,
      anon_sym_readonly,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3497), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3499), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3485), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4798] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3503), 1,
      anon_sym_export,
    ACTIONS(3505), 1,
      anon_sym_RBRACE,
    ACTIONS(3507), 1,
      anon_sym_async,
    ACTIONS(3509), 1,
      anon_sym_static,
    ACTIONS(3511), 1,
      anon_sym_readonly,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3513), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3515), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3501), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4935] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1813), 1,
      anon_sym_EQ_GT,
    ACTIONS(2137), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [5022] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3423), 1,
      anon_sym_export,
    ACTIONS(3427), 1,
      anon_sym_async,
    ACTIONS(3429), 1,
      anon_sym_static,
    ACTIONS(3431), 1,
      anon_sym_readonly,
    ACTIONS(3457), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3433), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3435), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3421), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5159] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3519), 1,
      anon_sym_export,
    ACTIONS(3521), 1,
      anon_sym_RBRACE,
    ACTIONS(3523), 1,
      anon_sym_async,
    ACTIONS(3525), 1,
      anon_sym_static,
    ACTIONS(3527), 1,
      anon_sym_readonly,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4819), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3529), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3531), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4919), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3517), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5296] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3443), 1,
      anon_sym_export,
    ACTIONS(3447), 1,
      anon_sym_async,
    ACTIONS(3449), 1,
      anon_sym_static,
    ACTIONS(3451), 1,
      anon_sym_readonly,
    ACTIONS(3533), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4760), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3453), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3455), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4789), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3441), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5433] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3403), 1,
      anon_sym_export,
    ACTIONS(3407), 1,
      anon_sym_async,
    ACTIONS(3409), 1,
      anon_sym_static,
    ACTIONS(3411), 1,
      anon_sym_readonly,
    ACTIONS(3535), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4918), 1,
      aux_sym_object_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3413), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3415), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4921), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3401), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5570] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2078), 1,
      anon_sym_EQ,
    ACTIONS(2080), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [5657] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1853), 1,
      anon_sym_EQ,
    ACTIONS(1855), 1,
      anon_sym_EQ_GT,
    ACTIONS(3331), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_string,
    STATE(2040), 1,
      sym_nested_identifier,
    STATE(2093), 1,
      sym__module,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [5744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3539), 38,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [5813] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3519), 1,
      anon_sym_export,
    ACTIONS(3523), 1,
      anon_sym_async,
    ACTIONS(3525), 1,
      anon_sym_static,
    ACTIONS(3527), 1,
      anon_sym_readonly,
    ACTIONS(3541), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4819), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3529), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3531), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4919), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3517), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5950] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1577), 1,
      anon_sym_EQ,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(2814), 1,
      anon_sym_QMARK,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1584), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1597), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6041] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1584), 1,
      anon_sym_RBRACK,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(2896), 1,
      anon_sym_COMMA,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    ACTIONS(2919), 1,
      anon_sym_COLON,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6134] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3423), 1,
      anon_sym_export,
    ACTIONS(3427), 1,
      anon_sym_async,
    ACTIONS(3429), 1,
      anon_sym_static,
    ACTIONS(3431), 1,
      anon_sym_readonly,
    ACTIONS(3543), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3433), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3435), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3421), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [6271] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3547), 1,
      anon_sym_export,
    ACTIONS(3549), 1,
      anon_sym_RBRACE,
    ACTIONS(3551), 1,
      anon_sym_async,
    ACTIONS(3553), 1,
      anon_sym_static,
    ACTIONS(3555), 1,
      anon_sym_readonly,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3557), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3559), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3545), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [6408] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3369), 1,
      anon_sym_export,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3383), 1,
      anon_sym_async,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3391), 1,
      anon_sym_static,
    ACTIONS(3393), 1,
      anon_sym_readonly,
    ACTIONS(3561), 1,
      anon_sym_COMMA,
    ACTIONS(3563), 1,
      anon_sym_RBRACE,
    ACTIONS(3565), 1,
      anon_sym_SEMI,
    ACTIONS(3567), 1,
      anon_sym_PIPE_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3395), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3397), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4094), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3367), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [6545] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3373), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3423), 1,
      anon_sym_export,
    ACTIONS(3427), 1,
      anon_sym_async,
    ACTIONS(3429), 1,
      anon_sym_static,
    ACTIONS(3431), 1,
      anon_sym_readonly,
    ACTIONS(3461), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3433), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3435), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3421), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [6682] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2141), 1,
      anon_sym_EQ,
    ACTIONS(2143), 1,
      anon_sym_EQ_GT,
    ACTIONS(3357), 1,
      sym_identifier,
    STATE(3039), 1,
      sym_string,
    STATE(3040), 1,
      sym_nested_identifier,
    STATE(3185), 1,
      sym__module,
    ACTIONS(1597), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6769] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2011), 1,
      anon_sym_EQ,
    ACTIONS(2013), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [6855] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1903), 1,
      anon_sym_EQ,
    ACTIONS(1905), 1,
      anon_sym_EQ_GT,
    ACTIONS(3331), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_string,
    STATE(2040), 1,
      sym_nested_identifier,
    STATE(2093), 1,
      sym__module,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6941] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(1819), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1584), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1597), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [7029] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2287), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      sym_identifier,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [7117] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1577), 1,
      anon_sym_EQ,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1584), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1597), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [7205] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1941), 1,
      anon_sym_EQ,
    ACTIONS(1943), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [7291] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      sym_identifier,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [7379] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2137), 1,
      anon_sym_EQ,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 1,
      anon_sym_COLON,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [7467] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2293), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      sym_identifier,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [7555] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(2896), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4030), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7681] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3579), 1,
      anon_sym_LT,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3585), 1,
      anon_sym_EQ_GT,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7761] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3589), 1,
      anon_sym_LT,
    ACTIONS(3592), 1,
      anon_sym_EQ_GT,
    STATE(2352), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7841] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3592), 1,
      anon_sym_EQ_GT,
    ACTIONS(3594), 1,
      anon_sym_LT,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7921] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1905), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [8007] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3585), 1,
      anon_sym_EQ_GT,
    ACTIONS(3597), 1,
      anon_sym_EQ,
    ACTIONS(3599), 1,
      anon_sym_LT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8087] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1584), 1,
      anon_sym_RBRACK,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(2896), 1,
      anon_sym_COMMA,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [8177] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2137), 1,
      anon_sym_EQ,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(2919), 1,
      anon_sym_COLON,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [8265] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2285), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      sym_identifier,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [8353] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(1943), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [8439] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2295), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      sym_identifier,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [8527] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2013), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [8613] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2013), 1,
      anon_sym_EQ_GT,
    ACTIONS(2128), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [8699] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2291), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      sym_identifier,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [8787] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3592), 1,
      anon_sym_EQ_GT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3602), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8871] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3585), 1,
      anon_sym_EQ_GT,
    ACTIONS(3597), 1,
      anon_sym_EQ,
    ACTIONS(3599), 1,
      anon_sym_LT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3577), 22,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [9027] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    ACTIONS(3569), 1,
      sym_identifier,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [9115] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3592), 1,
      anon_sym_EQ_GT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3602), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9195] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9280] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3610), 1,
      anon_sym_EQ,
    ACTIONS(3612), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9359] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2789), 1,
      anon_sym_LBRACE,
    ACTIONS(2791), 1,
      anon_sym_LBRACK,
    ACTIONS(3614), 1,
      sym_identifier,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    STATE(3986), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4516), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9484] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2295), 1,
      anon_sym_RBRACE,
    ACTIONS(3616), 1,
      anon_sym_EQ,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(3621), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 1,
      anon_sym_EQ,
    ACTIONS(1797), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9642] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3626), 1,
      sym_identifier,
    ACTIONS(3628), 1,
      anon_sym_LBRACE,
    ACTIONS(3630), 1,
      anon_sym_LBRACK,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    STATE(3986), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4516), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9767] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1811), 1,
      anon_sym_EQ,
    ACTIONS(1813), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9844] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2291), 1,
      anon_sym_RBRACE,
    ACTIONS(3616), 1,
      anon_sym_EQ,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3621), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_EQ_GT,
    ACTIONS(3597), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10002] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2293), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10087] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2291), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3419), 36,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [10239] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3585), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10312] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(2896), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4007), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10437] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1813), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 20,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10510] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1811), 1,
      anon_sym_EQ,
    ACTIONS(1813), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 20,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3313), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3315), 36,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [10650] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2128), 1,
      anon_sym_EQ,
    ACTIONS(2130), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [10735] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(3642), 1,
      anon_sym_extends,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10820] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3612), 1,
      anon_sym_EQ_GT,
    ACTIONS(3644), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10903] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2285), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10988] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2295), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11073] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(3616), 1,
      anon_sym_EQ,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(3621), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11158] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 1,
      anon_sym_EQ,
    ACTIONS(1797), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11235] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3610), 1,
      anon_sym_EQ,
    ACTIONS(3642), 1,
      anon_sym_COMMA,
    ACTIONS(3646), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3592), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3483), 36,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [11460] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2285), 1,
      anon_sym_RBRACE,
    ACTIONS(3616), 1,
      anon_sym_EQ,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(3621), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11545] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3612), 1,
      anon_sym_EQ_GT,
    ACTIONS(3648), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3319), 36,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [11691] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2287), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3439), 36,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [11843] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(2135), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 12,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [11928] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(3655), 1,
      anon_sym_DOT,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(3607), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3651), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3642), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3577), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12015] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3585), 1,
      anon_sym_EQ_GT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12094] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(3616), 1,
      anon_sym_EQ,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(3621), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12179] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [12264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3539), 36,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [12331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 1,
      anon_sym_EQ_GT,
    ACTIONS(3602), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12404] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3592), 1,
      anon_sym_EQ_GT,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12483] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2260), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(2565), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2266), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12568] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2293), 1,
      anon_sym_RBRACE,
    ACTIONS(3616), 1,
      anon_sym_EQ,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(3621), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12653] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12726] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3612), 1,
      anon_sym_EQ_GT,
    ACTIONS(3644), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12805] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(2135), 1,
      anon_sym_EQ_GT,
    ACTIONS(2879), 1,
      anon_sym_in,
    ACTIONS(2882), 1,
      anon_sym_of,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [12894] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2130), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [12979] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    ACTIONS(2287), 1,
      anon_sym_RBRACE,
    ACTIONS(3616), 1,
      anon_sym_EQ,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(3621), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13064] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2137), 1,
      anon_sym_EQ,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(3329), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_string,
    STATE(2033), 1,
      sym_nested_identifier,
    STATE(2206), 1,
      sym__module,
    ACTIONS(1597), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [13149] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3585), 1,
      anon_sym_EQ_GT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3658), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 1,
      anon_sym_EQ_GT,
    ACTIONS(1819), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13299] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(3642), 1,
      anon_sym_extends,
    ACTIONS(3660), 1,
      anon_sym_EQ,
    ACTIONS(3663), 1,
      anon_sym_COLON,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    STATE(3684), 1,
      sym_type_arguments,
    STATE(5192), 1,
      sym_type_annotation,
    ACTIONS(3607), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3651), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3577), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13391] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(2683), 1,
      sym_template_string,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3005), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13517] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(2366), 1,
      sym_template_string,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2545), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1817), 1,
      anon_sym_EQ_GT,
    ACTIONS(1829), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13715] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(2896), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3820), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13839] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2160), 1,
      sym_template_string,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3340), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13965] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14035] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1817), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14107] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3585), 1,
      anon_sym_EQ_GT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14185] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3783), 1,
      sym_identifier,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3795), 1,
      sym_this,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3799), 1,
      anon_sym_asserts,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5085), 1,
      sym_type_predicate,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4704), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14311] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2160), 1,
      sym_template_string,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3213), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14437] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14507] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2160), 1,
      sym_template_string,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3417), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14633] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3592), 1,
      anon_sym_EQ_GT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3831), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3612), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14783] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(2683), 1,
      sym_template_string,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2657), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14909] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(1819), 1,
      anon_sym_EQ,
    ACTIONS(2203), 1,
      anon_sym_extends,
    ACTIONS(3632), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14987] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(1819), 1,
      anon_sym_EQ,
    ACTIONS(3632), 1,
      anon_sym_LBRACK,
    ACTIONS(3635), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3847), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2203), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1597), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15067] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2160), 1,
      sym_template_string,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3408), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15193] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2160), 1,
      sym_template_string,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2496), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15319] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1815), 1,
      anon_sym_EQ,
    ACTIONS(1817), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15391] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(3301), 1,
      sym_template_string,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3300), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15517] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2160), 1,
      sym_template_string,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3075), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15643] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15713] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3931), 1,
      sym_identifier,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3961), 1,
      sym_this,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3967), 1,
      anon_sym_asserts,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(4625), 1,
      sym_type_predicate,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4024), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15839] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1815), 1,
      anon_sym_EQ,
    ACTIONS(1817), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15915] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(2366), 1,
      sym_template_string,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3044), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16041] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2160), 1,
      sym_template_string,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3297), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16167] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3646), 1,
      anon_sym_EQ_GT,
    ACTIONS(4003), 1,
      anon_sym_LT,
    STATE(3933), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16245] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1813), 1,
      anon_sym_EQ_GT,
    ACTIONS(1819), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 1,
      anon_sym_EQ_GT,
    ACTIONS(3644), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16389] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3642), 1,
      anon_sym_COMMA,
    ACTIONS(3658), 1,
      anon_sym_EQ,
    ACTIONS(4006), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16473] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3646), 1,
      anon_sym_EQ_GT,
    ACTIONS(3648), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16551] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(2366), 1,
      sym_template_string,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3378), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16677] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4024), 1,
      sym_this,
    ACTIONS(4026), 1,
      anon_sym_asserts,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5085), 1,
      sym_type_predicate,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4423), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16803] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    ACTIONS(3642), 1,
      anon_sym_extends,
    ACTIONS(3831), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16887] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_EQ,
    ACTIONS(1831), 1,
      anon_sym_EQ_GT,
    ACTIONS(2203), 1,
      anon_sym_COMMA,
    ACTIONS(3632), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16965] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      sym_this,
    ACTIONS(4032), 1,
      anon_sym_asserts,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(4108), 1,
      sym_type_predicate,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3857), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3439), 34,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [17156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1813), 1,
      anon_sym_EQ_GT,
    ACTIONS(1833), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17227] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4034), 1,
      sym_identifier,
    ACTIONS(4036), 1,
      sym_this,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(2339), 1,
      sym_type_predicate,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2582), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17419] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2667), 1,
      anon_sym_COLON,
    ACTIONS(3569), 1,
      sym_identifier,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17494] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17634] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4038), 1,
      sym_identifier,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(4817), 1,
      sym_type_parameter,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4180), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17757] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4040), 1,
      sym_identifier,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4052), 1,
      sym_this,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3716), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4441), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17880] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4040), 1,
      sym_identifier,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4052), 1,
      sym_this,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3720), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4445), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18003] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    ACTIONS(4058), 1,
      sym_identifier,
    ACTIONS(4060), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2170), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3414), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18126] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18197] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3589), 1,
      anon_sym_LT,
    ACTIONS(4062), 1,
      anon_sym_EQ_GT,
    STATE(2352), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18274] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    ACTIONS(4058), 1,
      sym_identifier,
    ACTIONS(4060), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2131), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3411), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18397] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    ACTIONS(4064), 1,
      sym_identifier,
    ACTIONS(4066), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2170), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3198), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18520] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2615), 1,
      anon_sym_COLON,
    ACTIONS(3569), 1,
      sym_identifier,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18595] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    ACTIONS(4068), 1,
      anon_sym_RBRACK,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4566), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18718] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3783), 1,
      sym_identifier,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3795), 1,
      sym_this,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3716), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4320), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3483), 34,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [18906] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    ACTIONS(4064), 1,
      sym_identifier,
    ACTIONS(4066), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2131), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3201), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19029] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4070), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19152] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4072), 1,
      anon_sym_EQ,
    ACTIONS(4074), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19229] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4076), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19352] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4078), 1,
      sym_identifier,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4090), 1,
      sym_this,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3771), 1,
      sym_type_predicate,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4152), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19475] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4096), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19598] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    ACTIONS(4098), 1,
      anon_sym_RBRACK,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4536), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19721] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4100), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19844] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3783), 1,
      sym_identifier,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3795), 1,
      sym_this,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3720), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4264), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19967] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3592), 1,
      anon_sym_EQ_GT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4102), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20044] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    ACTIONS(4104), 1,
      sym_identifier,
    ACTIONS(4106), 1,
      sym_this,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(2354), 1,
      sym_type_predicate,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3016), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20167] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4108), 1,
      sym_identifier,
    ACTIONS(4110), 1,
      sym_this,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3720), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4004), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20290] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4072), 1,
      anon_sym_EQ,
    ACTIONS(4074), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20371] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    ACTIONS(4104), 1,
      sym_identifier,
    ACTIONS(4106), 1,
      sym_this,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(2339), 1,
      sym_type_predicate,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3028), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20494] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    ACTIONS(4112), 1,
      sym_identifier,
    ACTIONS(4114), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2170), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3195), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20617] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    ACTIONS(4116), 1,
      sym_identifier,
    ACTIONS(4118), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2170), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2486), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20740] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4120), 1,
      sym_identifier,
    ACTIONS(4122), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2131), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3364), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20863] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(4124), 1,
      anon_sym_EQ,
    ACTIONS(4126), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20946] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4006), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21023] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4128), 1,
      sym_identifier,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4140), 1,
      sym_this,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3720), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4492), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21146] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(4148), 1,
      anon_sym_export,
    ACTIONS(4153), 1,
      anon_sym_async,
    ACTIONS(4155), 1,
      anon_sym_static,
    ACTIONS(4157), 1,
      anon_sym_readonly,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4150), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4159), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4161), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(5130), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(5132), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4126), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4146), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [21269] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    ACTIONS(4163), 1,
      anon_sym_RBRACK,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4639), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3644), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21461] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4165), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21584] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4120), 1,
      sym_identifier,
    ACTIONS(4122), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2170), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3370), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21707] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3642), 1,
      anon_sym_COMMA,
    ACTIONS(4102), 1,
      anon_sym_EQ,
    ACTIONS(4167), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21790] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    ACTIONS(4169), 1,
      anon_sym_RBRACK,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4596), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21913] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4108), 1,
      sym_identifier,
    ACTIONS(4110), 1,
      sym_this,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3716), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3993), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22036] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4171), 1,
      anon_sym_EQ,
    ACTIONS(4173), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22117] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4062), 1,
      anon_sym_EQ_GT,
    ACTIONS(4175), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22194] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4177), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22317] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4024), 1,
      sym_this,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3720), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4048), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3419), 34,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [22505] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    ACTIONS(4112), 1,
      sym_identifier,
    ACTIONS(4114), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2131), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3191), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22628] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4179), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22751] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4128), 1,
      sym_identifier,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4140), 1,
      sym_this,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3716), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4469), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22874] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4181), 1,
      sym_identifier,
    ACTIONS(4183), 1,
      sym_this,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(3167), 1,
      sym_type_predicate,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3124), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22997] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2203), 1,
      anon_sym_extends,
    ACTIONS(3632), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23074] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4062), 1,
      anon_sym_EQ_GT,
    ACTIONS(4175), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23155] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4074), 1,
      anon_sym_EQ_GT,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23232] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    ACTIONS(4187), 1,
      sym_identifier,
    ACTIONS(4189), 1,
      sym_this,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(2354), 1,
      sym_type_predicate,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3346), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23355] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3646), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23426] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4024), 1,
      sym_this,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3716), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3963), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23549] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4191), 1,
      sym_identifier,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4203), 1,
      sym_this,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3720), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3965), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23672] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3642), 1,
      anon_sym_extends,
    ACTIONS(4209), 1,
      anon_sym_EQ,
    ACTIONS(4211), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23755] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_EQ,
    ACTIONS(1835), 1,
      anon_sym_EQ_GT,
    ACTIONS(2203), 1,
      anon_sym_COMMA,
    ACTIONS(3632), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23832] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4213), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23955] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3579), 1,
      anon_sym_LT,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(4173), 1,
      anon_sym_EQ_GT,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24032] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_EQ_GT,
    ACTIONS(4215), 1,
      anon_sym_LT,
    STATE(3200), 1,
      sym_type_arguments,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24109] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    ACTIONS(4218), 1,
      sym_identifier,
    ACTIONS(4220), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2170), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3103), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24301] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4222), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24424] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    ACTIONS(4224), 1,
      anon_sym_RBRACK,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4673), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24547] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4226), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24670] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4228), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24793] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    ACTIONS(4187), 1,
      sym_identifier,
    ACTIONS(4189), 1,
      sym_this,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(2339), 1,
      sym_type_predicate,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3337), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_EQ,
    ACTIONS(3646), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24987] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4191), 1,
      sym_identifier,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4203), 1,
      sym_this,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3716), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3979), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25110] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4230), 1,
      sym_identifier,
    ACTIONS(4232), 1,
      sym_this,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3716), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4178), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25233] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    ACTIONS(4218), 1,
      sym_identifier,
    ACTIONS(4220), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2131), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3105), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25356] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3931), 1,
      sym_identifier,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3961), 1,
      sym_this,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(3913), 1,
      sym_type_predicate,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3914), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25479] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(4062), 1,
      anon_sym_EQ_GT,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25556] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4181), 1,
      sym_identifier,
    ACTIONS(4183), 1,
      sym_this,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(3179), 1,
      sym_type_predicate,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3126), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25679] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    ACTIONS(4116), 1,
      sym_identifier,
    ACTIONS(4118), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2131), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2613), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25802] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4234), 1,
      sym_identifier,
    ACTIONS(4236), 1,
      sym_this,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3716), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4044), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25925] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4238), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26048] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4209), 1,
      anon_sym_EQ,
    ACTIONS(4211), 1,
      anon_sym_EQ_GT,
    ACTIONS(4242), 1,
      anon_sym_COMMA,
    STATE(3684), 1,
      sym_type_arguments,
    STATE(4640), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(4240), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3577), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26131] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      sym_this,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3771), 1,
      sym_type_predicate,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3799), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26254] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3931), 1,
      sym_identifier,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3961), 1,
      sym_this,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(3921), 1,
      sym_type_predicate,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3892), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26377] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1831), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 18,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3313), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3315), 34,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [26513] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3642), 1,
      anon_sym_extends,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4244), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26596] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4230), 1,
      sym_identifier,
    ACTIONS(4232), 1,
      sym_this,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3720), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4148), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26719] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4246), 1,
      sym_identifier,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4258), 1,
      sym_this,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3716), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4029), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26842] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3565), 1,
      anon_sym_SEMI,
    ACTIONS(3567), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4266), 1,
      anon_sym_export,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4272), 1,
      anon_sym_RBRACE,
    ACTIONS(4274), 1,
      anon_sym_async,
    ACTIONS(4276), 1,
      sym_number,
    ACTIONS(4278), 1,
      anon_sym_static,
    ACTIONS(4280), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4282), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4284), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3725), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4094), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4264), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26971] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4173), 1,
      anon_sym_EQ_GT,
    ACTIONS(4209), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27048] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(3642), 1,
      anon_sym_extends,
    ACTIONS(4286), 1,
      anon_sym_EQ,
    ACTIONS(4292), 1,
      anon_sym_COLON,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3607), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4288), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3577), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27135] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4294), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27258] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27450] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    ACTIONS(4298), 1,
      anon_sym_RBRACK,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4600), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27573] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4246), 1,
      sym_identifier,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4258), 1,
      sym_this,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3720), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4025), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27696] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4300), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27819] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4034), 1,
      sym_identifier,
    ACTIONS(4036), 1,
      sym_this,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(2354), 1,
      sym_type_predicate,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2557), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(1819), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28013] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      sym_this,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(3785), 1,
      sym_type_predicate,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3802), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28136] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4302), 1,
      sym_identifier,
    ACTIONS(4304), 1,
      sym_this,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(2823), 1,
      sym_type_predicate,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2929), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28259] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4240), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4244), 1,
      anon_sym_EQ_GT,
    ACTIONS(4306), 1,
      anon_sym_LBRACE,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(4310), 1,
      anon_sym_LT,
    ACTIONS(4313), 1,
      anon_sym_DOT,
    STATE(4689), 1,
      aux_sym_extends_clause_repeat1,
    STATE(4806), 1,
      sym_type_arguments,
    ACTIONS(3577), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28344] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    ACTIONS(4316), 1,
      sym_identifier,
    ACTIONS(4318), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2170), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3386), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28467] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    ACTIONS(4320), 1,
      anon_sym_RBRACK,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4546), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28590] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4322), 1,
      anon_sym_GT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28713] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4234), 1,
      sym_identifier,
    ACTIONS(4236), 1,
      sym_this,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3720), 1,
      sym_type_predicate,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4067), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28836] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    ACTIONS(4316), 1,
      sym_identifier,
    ACTIONS(4318), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2131), 1,
      sym_type_predicate,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3392), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28959] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4266), 1,
      anon_sym_export,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4274), 1,
      anon_sym_async,
    ACTIONS(4276), 1,
      sym_number,
    ACTIONS(4278), 1,
      anon_sym_static,
    ACTIONS(4280), 1,
      anon_sym_readonly,
    ACTIONS(4324), 1,
      anon_sym_COMMA,
    ACTIONS(4326), 1,
      anon_sym_RBRACE,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4282), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4284), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3725), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4264), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3539), 34,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [29153] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4302), 1,
      sym_identifier,
    ACTIONS(4304), 1,
      sym_this,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(2853), 1,
      sym_type_predicate,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2942), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29276] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    ACTIONS(4328), 1,
      sym_identifier,
    ACTIONS(4330), 1,
      sym_this,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(2823), 1,
      sym_type_predicate,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2786), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29399] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4266), 1,
      anon_sym_export,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4274), 1,
      anon_sym_async,
    ACTIONS(4276), 1,
      sym_number,
    ACTIONS(4278), 1,
      anon_sym_static,
    ACTIONS(4280), 1,
      anon_sym_readonly,
    ACTIONS(4324), 1,
      anon_sym_COMMA,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4282), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4284), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3725), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4264), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [29599] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    ACTIONS(4328), 1,
      sym_identifier,
    ACTIONS(4330), 1,
      sym_this,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(2853), 1,
      sym_type_predicate,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2783), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29722] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4171), 1,
      anon_sym_EQ,
    ACTIONS(4173), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [29799] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3579), 1,
      anon_sym_LT,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(4006), 1,
      anon_sym_EQ_GT,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [29876] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_EQ,
    ACTIONS(1831), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 18,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [29947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 1,
      anon_sym_EQ_GT,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30018] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3399), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4266), 1,
      anon_sym_export,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4274), 1,
      anon_sym_async,
    ACTIONS(4276), 1,
      sym_number,
    ACTIONS(4278), 1,
      anon_sym_static,
    ACTIONS(4280), 1,
      anon_sym_readonly,
    ACTIONS(4324), 1,
      anon_sym_COMMA,
    ACTIONS(4334), 1,
      anon_sym_RBRACE,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4282), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4284), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3725), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4264), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30147] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_STAR,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(3389), 1,
      sym_number,
    ACTIONS(4148), 1,
      anon_sym_export,
    ACTIONS(4153), 1,
      anon_sym_async,
    ACTIONS(4155), 1,
      anon_sym_static,
    ACTIONS(4157), 1,
      anon_sym_readonly,
    STATE(3616), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4150), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4159), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4161), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3703), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(5130), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(5132), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4118), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4146), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30270] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(3642), 1,
      anon_sym_extends,
    ACTIONS(3651), 1,
      anon_sym_RPAREN,
    ACTIONS(3660), 1,
      anon_sym_EQ,
    ACTIONS(4339), 1,
      anon_sym_QMARK,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3607), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4336), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3577), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30359] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3592), 1,
      anon_sym_EQ_GT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4124), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30436] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      sym_identifier,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4354), 1,
      sym_this,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(3785), 1,
      sym_type_predicate,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3948), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [30559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3319), 34,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [30624] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      sym_identifier,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4354), 1,
      sym_this,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3771), 1,
      sym_type_predicate,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3945), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [30747] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4078), 1,
      sym_identifier,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4090), 1,
      sym_this,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(3785), 1,
      sym_type_predicate,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4199), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [30870] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [30990] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2133), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31110] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3176), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31230] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4180), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31350] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4680), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31470] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4147), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31590] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1835), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31660] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4598), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31780] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2826), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31900] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2930), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32020] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4257), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32140] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4322), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32260] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4541), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32380] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4149), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32500] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4423), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32620] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2183), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32740] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2850), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32860] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3719), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32980] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4607), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [33100] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4583), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [33220] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2868), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [33340] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 1,
      anon_sym_EQ,
    ACTIONS(2143), 1,
      anon_sym_EQ_GT,
    ACTIONS(2203), 1,
      anon_sym_extends,
    ACTIONS(3632), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33416] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4647), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [33536] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2734), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5480), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4848), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [33656] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2951), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [33776] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2736), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [33896] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3181), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [34016] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2963), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [34136] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3763), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [34256] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3701), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [34376] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4074), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3573), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34446] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1939), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1580), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34516] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4168), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [34636] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3129), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [34756] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2958), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [34876] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4520), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [34996] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4656), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35116] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2475), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 1,
      anon_sym_EQ_GT,
    ACTIONS(1853), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [35306] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4698), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35426] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4623), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      anon_sym_EQ,
    ACTIONS(1835), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [35616] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4164), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35736] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4360), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_this,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3943), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4815), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35856] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [35924] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4650), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [36044] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4579), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [36164] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4668), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [36284] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36352] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4677), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [36472] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2561), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [36592] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4360), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_this,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3942), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [36712] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(4364), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36784] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4236), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [36904] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3721), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [37024] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4460), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [37144] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3375), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [37264] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3721), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [37384] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4360), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_this,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3937), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [37504] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4648), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [37624] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4569), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [37744] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3701), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [37864] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4360), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_this,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3926), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [37984] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4315), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [38104] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4360), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_this,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3931), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [38224] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4072), 1,
      anon_sym_EQ,
    ACTIONS(4074), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3573), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [38294] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4016), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [38414] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3371), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [38534] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4484), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [38654] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3719), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [38774] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2183), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [38894] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3125), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [39014] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2165), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [39134] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3168), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [39254] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3369), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [39374] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4159), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [39494] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1853), 1,
      anon_sym_EQ,
    ACTIONS(1855), 1,
      anon_sym_EQ_GT,
    ACTIONS(2203), 1,
      anon_sym_COMMA,
    ACTIONS(3632), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [39570] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2667), 1,
      anon_sym_COLON,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [39642] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4327), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [39762] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2133), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [39882] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3710), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [40002] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4636), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [40122] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3708), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4904), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [40242] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_COLON,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    ACTIONS(3831), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [40314] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3338), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [40434] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2558), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [40554] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3356), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [40674] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_new,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3761), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3775), 1,
      anon_sym_readonly,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4955), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5395), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2063), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [40794] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4171), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [40914] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2572), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [41034] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2338), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [41154] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2323), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [41274] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2337), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4764), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [41394] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3759), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3779), 1,
      anon_sym_keyof,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2062), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4851), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [41514] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4706), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [41634] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 1,
      anon_sym_EQ,
    ACTIONS(1865), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [41704] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4692), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [41824] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4661), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [41944] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4534), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42064] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [42134] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4081), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42254] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4608), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42374] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4292), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42494] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3994), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42614] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3196), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42734] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4606), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42854] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3721), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42974] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4602), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [43094] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2165), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [43214] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 1,
      anon_sym_EQ,
    ACTIONS(1939), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [43288] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4440), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [43408] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3721), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [43528] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4335), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [43648] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3701), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [43768] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4444), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [43888] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3579), 1,
      anon_sym_LT,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(4366), 1,
      anon_sym_EQ_GT,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [43964] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3415), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [44084] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3681), 1,
      anon_sym_new,
    ACTIONS(3683), 1,
      anon_sym_QMARK,
    ACTIONS(3685), 1,
      anon_sym_AMP,
    ACTIONS(3687), 1,
      anon_sym_PIPE,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3699), 1,
      anon_sym_readonly,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3703), 1,
      anon_sym_keyof,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(4945), 1,
      sym_type_parameters,
    STATE(5498), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2945), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [44204] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2183), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [44324] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3719), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [44444] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    ACTIONS(3831), 1,
      anon_sym_EQ,
    ACTIONS(4368), 1,
      anon_sym_in,
    ACTIONS(4371), 1,
      anon_sym_of,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [44518] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3708), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4908), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [44638] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2165), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [44758] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4293), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [44878] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3412), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [44998] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3710), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [45118] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2133), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [45238] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3708), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4907), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [45358] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4078), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [45478] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2879), 1,
      anon_sym_in,
    ACTIONS(4373), 1,
      anon_sym_of,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [45552] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4364), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [45672] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3710), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [45792] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3197), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [45912] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4240), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [46032] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3382), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [46152] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2183), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [46272] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3721), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [46392] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3418), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [46512] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2063), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [46632] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2165), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [46752] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2062), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4822), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [46872] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3821), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [46992] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3199), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [47112] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2133), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [47232] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3701), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [47352] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3286), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [47472] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4613), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [47592] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4552), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [47712] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3287), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [47832] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3991), 1,
      anon_sym_new,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(3999), 1,
      anon_sym_readonly,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(4941), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5332), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2063), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [47952] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(3993), 1,
      anon_sym_QMARK,
    ACTIONS(4001), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2062), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4845), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [48072] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4263), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [48192] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3719), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [48312] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2615), 1,
      anon_sym_COLON,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    ACTIONS(3831), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [48384] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(2615), 1,
      anon_sym_COLON,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [48456] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4192), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [48576] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 1,
      anon_sym_EQ,
    ACTIONS(1905), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 1,
      anon_sym_LBRACK,
    ACTIONS(2203), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [48652] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4655), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [48772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [48842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4062), 1,
      anon_sym_EQ_GT,
    ACTIONS(4175), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [48912] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4595), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [49032] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3708), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4800), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [49152] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4585), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [49272] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4426), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [49392] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3710), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [49512] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3708), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4899), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [49632] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2429), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [49752] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3710), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [49872] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3966), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [49992] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4018), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [50112] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3708), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4888), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [50232] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4360), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_this,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3910), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [50352] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3058), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [50472] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4592), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [50592] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4244), 1,
      anon_sym_EQ_GT,
    ACTIONS(4310), 1,
      anon_sym_LT,
    ACTIONS(4313), 1,
      anon_sym_DOT,
    ACTIONS(4375), 1,
      anon_sym_LBRACE,
    STATE(4806), 1,
      sym_type_arguments,
    ACTIONS(4377), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3577), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [50672] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3158), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [50792] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2337), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4795), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [50912] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2338), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [51032] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3357), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [51152] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4652), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [51272] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3373), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [51392] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3157), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [51512] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4203), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [51632] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3156), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5480), 1,
      sym_formal_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4829), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [51752] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4237), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [51872] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3589), 1,
      anon_sym_LT,
    ACTIONS(4167), 1,
      anon_sym_EQ_GT,
    STATE(2352), 1,
      sym_type_arguments,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [51948] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4395), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [52068] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [52188] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3098), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [52308] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4442), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [52428] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3857), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [52548] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3360), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [52668] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3719), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [52788] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_EQ,
    ACTIONS(2080), 1,
      anon_sym_EQ_GT,
    ACTIONS(2203), 1,
      anon_sym_extends,
    ACTIONS(3632), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [52864] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 1,
      anon_sym_DQUOTE,
    ACTIONS(1417), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3879), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_STAR,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(3887), 1,
      anon_sym_LPAREN,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3891), 1,
      anon_sym_new,
    ACTIONS(3893), 1,
      anon_sym_QMARK,
    ACTIONS(3895), 1,
      anon_sym_AMP,
    ACTIONS(3897), 1,
      anon_sym_PIPE,
    ACTIONS(3903), 1,
      sym_number,
    ACTIONS(3905), 1,
      sym_this,
    ACTIONS(3909), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_infer,
    ACTIONS(3913), 1,
      anon_sym_keyof,
    ACTIONS(3915), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2969), 1,
      sym_nested_type_identifier,
    STATE(3147), 1,
      sym__primary_type,
    STATE(4973), 1,
      sym_type_parameters,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(5560), 1,
      sym_formal_parameters,
    ACTIONS(3899), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3907), 2,
      sym_true,
      sym_false,
    STATE(3143), 2,
      sym_string,
      sym__number,
    ACTIONS(3901), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3127), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3144), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [52984] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3935), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [53104] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3100), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [53224] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2183), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [53344] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4129), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [53464] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4577), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [53584] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4591), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [53704] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4549), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [53824] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2165), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [53944] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3104), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [54064] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4068), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [54184] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3701), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [54304] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4260), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [54424] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2133), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [54544] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1825), 1,
      anon_sym_EQ,
    ACTIONS(1827), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [54614] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4551), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [54734] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2323), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [54854] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4539), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [54974] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2429), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [55094] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3701), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [55214] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3983), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [55334] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 1,
      anon_sym_EQ_GT,
    ACTIONS(1903), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [55404] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4040), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [55524] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3721), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [55644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [55714] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4584), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [55834] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3355), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [55954] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4308), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [56074] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3060), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [56194] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4036), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [56314] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2604), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [56434] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2474), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [56554] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3063), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [56674] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3991), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [56794] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3719), 1,
      anon_sym_new,
    ACTIONS(3721), 1,
      anon_sym_QMARK,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3737), 1,
      anon_sym_readonly,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3741), 1,
      anon_sym_keyof,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5035), 1,
      sym_type_parameters,
    STATE(5244), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2472), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [56914] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3721), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [57034] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3919), 1,
      anon_sym_new,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3923), 1,
      anon_sym_AMP,
    ACTIONS(3925), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5030), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5470), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2063), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [57154] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(3921), 1,
      anon_sym_QMARK,
    ACTIONS(3929), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2062), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4714), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [57274] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3803), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [57394] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3763), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [57514] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2337), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4841), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [57634] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3384), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [57754] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3701), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [57874] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4031), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [57994] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2338), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [58114] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2996), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [58234] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3701), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [58354] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3708), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4855), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [58474] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4026), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [58594] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3710), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [58714] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4058), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [58834] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4007), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [58954] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3774), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [59074] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(4379), 1,
      anon_sym_EQ,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [59156] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2995), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [59276] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_EQ,
    ACTIONS(1823), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [59346] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3719), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [59466] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3800), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [59586] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3783), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [59706] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4325), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [59826] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4041), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [59946] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3710), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [60066] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4621), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [60186] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3820), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [60306] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    ACTIONS(3831), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [60376] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3819), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [60496] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3792), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [60616] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3708), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4901), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [60736] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(4010), 1,
      anon_sym_new,
    ACTIONS(4012), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_AMP,
    ACTIONS(4016), 1,
      anon_sym_PIPE,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(5210), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_formal_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3344), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [60856] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3791), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4798), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [60976] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4127), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [61096] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4587), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [61216] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3385), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [61336] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4369), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [61456] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4360), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_this,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3911), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [61576] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4560), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [61696] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3791), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4737), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [61816] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3792), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [61936] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4169), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [62056] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(3819), 1,
      anon_sym_new,
    ACTIONS(3821), 1,
      anon_sym_QMARK,
    ACTIONS(3823), 1,
      anon_sym_AMP,
    ACTIONS(3825), 1,
      anon_sym_PIPE,
    ACTIONS(3827), 1,
      anon_sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5020), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5506), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3416), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [62176] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4628), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [62296] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2183), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [62416] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4174), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [62536] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4066), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [62656] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3719), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [62776] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2165), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [62896] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3390), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [63016] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4137), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [63136] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2133), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [63256] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3396), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [63376] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3379), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [63496] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4366), 1,
      anon_sym_EQ_GT,
    ACTIONS(4383), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [63576] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2734), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5480), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4852), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [63696] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2736), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [63816] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3853), 1,
      anon_sym_new,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_PIPE,
    ACTIONS(3861), 1,
      anon_sym_readonly,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5182), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5283), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2063), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [63936] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2648), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [64056] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2644), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [64176] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3932), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [64296] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2826), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [64416] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2784), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [64536] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3642), 1,
      anon_sym_COMMA,
    ACTIONS(4385), 1,
      anon_sym_EQ,
    ACTIONS(4387), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [64618] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4366), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [64694] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2850), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [64814] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4173), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [64884] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3710), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [65004] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(3855), 1,
      anon_sym_QMARK,
    ACTIONS(3863), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2062), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4838), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [65124] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 1,
      anon_sym_EQ,
    ACTIONS(1939), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1580), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [65194] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4360), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_this,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3899), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [65314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4171), 1,
      anon_sym_EQ,
    ACTIONS(4173), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [65384] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2868), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [65504] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2781), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [65624] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4030), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [65744] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4006), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [65864] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3710), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [65984] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4053), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [66104] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4360), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_this,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3893), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [66224] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(4167), 1,
      anon_sym_EQ_GT,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [66300] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3708), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4879), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [66420] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3624), 1,
      anon_sym_EQ_GT,
    ACTIONS(3831), 1,
      anon_sym_EQ,
    ACTIONS(4389), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [66492] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4562), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [66612] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4006), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [66682] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4651), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [66802] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4638), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [66922] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4554), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [67042] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4062), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [67112] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4664), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [67232] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3791), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4751), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [67352] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3792), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [67472] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2607), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [67592] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3936), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [67712] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3206), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [67832] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_DQUOTE,
    ACTIONS(1117), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_STAR,
    ACTIONS(3673), 1,
      anon_sym_LBRACE,
    ACTIONS(3677), 1,
      anon_sym_LPAREN,
    ACTIONS(3679), 1,
      anon_sym_LBRACK,
    ACTIONS(3693), 1,
      sym_number,
    ACTIONS(3695), 1,
      sym_this,
    ACTIONS(3701), 1,
      anon_sym_infer,
    ACTIONS(3705), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(3835), 1,
      anon_sym_new,
    ACTIONS(3837), 1,
      anon_sym_QMARK,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_PIPE,
    ACTIONS(3843), 1,
      anon_sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_keyof,
    STATE(2559), 1,
      sym_nested_type_identifier,
    STATE(2674), 1,
      sym__primary_type,
    STATE(5188), 1,
      sym_type_parameters,
    STATE(5402), 1,
      sym_formal_parameters,
    STATE(5570), 1,
      sym_nested_identifier,
    ACTIONS(3689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3697), 2,
      sym_true,
      sym_false,
    STATE(2660), 2,
      sym_string,
      sym__number,
    ACTIONS(3691), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2782), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2663), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [67952] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3933), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      anon_sym_LBRACE,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(3939), 1,
      anon_sym_LPAREN,
    ACTIONS(3941), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_new,
    ACTIONS(3945), 1,
      anon_sym_QMARK,
    ACTIONS(3947), 1,
      anon_sym_AMP,
    ACTIONS(3949), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_DQUOTE,
    ACTIONS(3957), 1,
      anon_sym_SQUOTE,
    ACTIONS(3959), 1,
      sym_number,
    ACTIONS(3965), 1,
      anon_sym_readonly,
    ACTIONS(3969), 1,
      anon_sym_infer,
    ACTIONS(3971), 1,
      anon_sym_keyof,
    ACTIONS(3973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4360), 1,
      sym_identifier,
    ACTIONS(4362), 1,
      sym_this,
    STATE(3811), 1,
      sym_nested_type_identifier,
    STATE(3906), 1,
      sym__primary_type,
    STATE(5007), 1,
      sym_type_parameters,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(5504), 1,
      sym_formal_parameters,
    ACTIONS(3951), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3963), 2,
      sym_true,
      sym_false,
    STATE(3918), 2,
      sym_string,
      sym__number,
    ACTIONS(3953), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3895), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3909), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [68072] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3950), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [68192] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4509), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [68312] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_AMP,
    ACTIONS(707), 1,
      anon_sym_PIPE,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(725), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2094), 1,
      anon_sym_new,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2116), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5034), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5465), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3902), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [68432] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_EQ,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(2203), 1,
      anon_sym_extends,
    ACTIONS(2814), 1,
      anon_sym_QMARK,
    ACTIONS(3632), 1,
      anon_sym_LBRACK,
    ACTIONS(3847), 1,
      anon_sym_RPAREN,
    ACTIONS(1584), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3635), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [68514] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4538), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [68634] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(4250), 1,
      anon_sym_new,
    ACTIONS(4252), 1,
      anon_sym_QMARK,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_readonly,
    ACTIONS(4262), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5129), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5415), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3721), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [68754] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4448), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [68874] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4594), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [68994] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2183), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [69114] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(569), 1,
      anon_sym_QMARK,
    ACTIONS(571), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(603), 1,
      anon_sym_keyof,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(1987), 1,
      anon_sym_new,
    ACTIONS(1995), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5179), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5376), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4013), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [69234] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3783), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [69354] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3920), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [69474] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1865), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [69544] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4540), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [69664] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1825), 1,
      anon_sym_EQ,
    ACTIONS(1827), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [69738] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3774), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [69858] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4548), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [69978] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2463), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [70098] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3783), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [70218] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4211), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [70338] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2063), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [70458] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1865), 1,
      anon_sym_EQ_GT,
    ACTIONS(2078), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [70528] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2062), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4757), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [70648] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3763), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [70768] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(4346), 1,
      anon_sym_new,
    ACTIONS(4348), 1,
      anon_sym_QMARK,
    ACTIONS(4350), 1,
      anon_sym_AMP,
    ACTIONS(4352), 1,
      anon_sym_PIPE,
    ACTIONS(4356), 1,
      anon_sym_readonly,
    ACTIONS(4358), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5180), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5438), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3944), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [70888] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4573), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [71008] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3585), 1,
      anon_sym_EQ_GT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4385), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [71084] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [71204] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3017), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [71324] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4556), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [71444] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4366), 1,
      anon_sym_EQ_GT,
    ACTIONS(4383), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [71520] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 1,
      anon_sym_EQ,
    ACTIONS(4006), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [71590] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4572), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [71710] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(4132), 1,
      anon_sym_new,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_AMP,
    ACTIONS(4138), 1,
      anon_sym_PIPE,
    ACTIONS(4142), 1,
      anon_sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5113), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5532), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4665), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [71830] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1939), 1,
      anon_sym_EQ_GT,
    ACTIONS(2141), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1580), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [71900] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(3787), 1,
      anon_sym_new,
    ACTIONS(3789), 1,
      anon_sym_QMARK,
    ACTIONS(3791), 1,
      anon_sym_AMP,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    ACTIONS(3797), 1,
      anon_sym_readonly,
    ACTIONS(3801), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5150), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5352), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4425), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [72020] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2062), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4777), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [72140] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3774), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [72260] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4565), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [72380] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2063), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [72500] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3261), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [72620] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3262), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [72740] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4055), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [72860] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4216), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [72980] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3209), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [73100] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3981), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [73220] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(4391), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [73302] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4699), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [73422] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4667), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [73542] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4209), 1,
      anon_sym_EQ,
    ACTIONS(4211), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(4377), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3577), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [73620] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2323), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [73740] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4701), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [73860] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(745), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_AMP,
    ACTIONS(749), 1,
      anon_sym_PIPE,
    ACTIONS(763), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_new,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1809), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5167), 1,
      sym_type_parameters,
    STATE(5305), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4141), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [73980] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4095), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [74100] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2133), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [74220] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3192), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [74340] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3023), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [74460] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(4044), 1,
      anon_sym_new,
    ACTIONS(4046), 1,
      anon_sym_QMARK,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4050), 1,
      anon_sym_PIPE,
    ACTIONS(4054), 1,
      anon_sym_readonly,
    ACTIONS(4056), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5096), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5574), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4703), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [74580] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3719), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [74700] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3976), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [74820] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(3805), 1,
      anon_sym_new,
    ACTIONS(3807), 1,
      anon_sym_QMARK,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(3811), 1,
      anon_sym_PIPE,
    ACTIONS(3813), 1,
      anon_sym_readonly,
    ACTIONS(3815), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5061), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5421), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2165), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [74940] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3745), 1,
      sym_identifier,
    ACTIONS(3747), 1,
      anon_sym_STAR,
    ACTIONS(3749), 1,
      anon_sym_LBRACE,
    ACTIONS(3753), 1,
      anon_sym_LPAREN,
    ACTIONS(3755), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      sym_number,
    ACTIONS(3771), 1,
      sym_this,
    ACTIONS(3777), 1,
      anon_sym_infer,
    ACTIONS(3781), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(3867), 1,
      anon_sym_new,
    ACTIONS(3869), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 1,
      anon_sym_AMP,
    ACTIONS(3873), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_readonly,
    ACTIONS(3877), 1,
      anon_sym_keyof,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2179), 1,
      sym__primary_type,
    STATE(5125), 1,
      sym_type_parameters,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(5322), 1,
      sym_formal_parameters,
    ACTIONS(3765), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3773), 2,
      sym_true,
      sym_false,
    STATE(2185), 2,
      sym_string,
      sym__number,
    ACTIONS(3767), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2597), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2181), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [75060] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_infer,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2090), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_LBRACK,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2110), 1,
      sym_number,
    ACTIONS(2112), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(4082), 1,
      anon_sym_new,
    ACTIONS(4084), 1,
      anon_sym_QMARK,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4088), 1,
      anon_sym_PIPE,
    ACTIONS(4092), 1,
      anon_sym_readonly,
    ACTIONS(4094), 1,
      anon_sym_keyof,
    STATE(3717), 1,
      sym_nested_type_identifier,
    STATE(3784), 1,
      sym__primary_type,
    STATE(5087), 1,
      sym_type_parameters,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(5379), 1,
      sym_formal_parameters,
    ACTIONS(2114), 2,
      sym_true,
      sym_false,
    ACTIONS(3243), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3780), 2,
      sym_string,
      sym__number,
    ACTIONS(2104), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4333), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3782), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [75180] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3721), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [75300] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3031), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [75420] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3707), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      anon_sym_STAR,
    ACTIONS(3711), 1,
      anon_sym_LBRACE,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 1,
      anon_sym_LBRACK,
    ACTIONS(3731), 1,
      sym_number,
    ACTIONS(3733), 1,
      sym_this,
    ACTIONS(3739), 1,
      anon_sym_infer,
    ACTIONS(3743), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(3977), 1,
      anon_sym_new,
    ACTIONS(3979), 1,
      anon_sym_QMARK,
    ACTIONS(3981), 1,
      anon_sym_AMP,
    ACTIONS(3983), 1,
      anon_sym_PIPE,
    ACTIONS(3985), 1,
      anon_sym_readonly,
    ACTIONS(3987), 1,
      anon_sym_keyof,
    STATE(2247), 1,
      sym_nested_type_identifier,
    STATE(2279), 1,
      sym__primary_type,
    STATE(4937), 1,
      sym_type_parameters,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(5493), 1,
      sym_formal_parameters,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3735), 2,
      sym_true,
      sym_false,
    STATE(2298), 2,
      sym_string,
      sym__number,
    ACTIONS(3729), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2429), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2263), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [75540] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(4195), 1,
      anon_sym_new,
    ACTIONS(4197), 1,
      anon_sym_QMARK,
    ACTIONS(4199), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_keyof,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5071), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5538), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3987), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [75660] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(661), 1,
      anon_sym_QMARK,
    ACTIONS(663), 1,
      anon_sym_AMP,
    ACTIONS(665), 1,
      anon_sym_PIPE,
    ACTIONS(681), 1,
      anon_sym_keyof,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1599), 1,
      anon_sym_new,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3571), 1,
      anon_sym_readonly,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5002), 1,
      sym_type_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(5480), 1,
      sym_formal_parameters,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(4605), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [75780] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3585), 1,
      anon_sym_EQ_GT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4379), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [75856] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3701), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [75976] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 1,
      anon_sym_EQ,
    ACTIONS(1865), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [76050] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3952), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [76170] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_STAR,
    ACTIONS(601), 1,
      anon_sym_infer,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_AMP,
    ACTIONS(1177), 1,
      anon_sym_PIPE,
    ACTIONS(1191), 1,
      anon_sym_keyof,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(1617), 1,
      sym_number,
    ACTIONS(1787), 1,
      sym_identifier,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1807), 1,
      sym_this,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(1885), 1,
      anon_sym_new,
    ACTIONS(1893), 1,
      anon_sym_readonly,
    ACTIONS(2777), 1,
      anon_sym_LT,
    STATE(3658), 1,
      sym_nested_type_identifier,
    STATE(3726), 1,
      sym__primary_type,
    STATE(5162), 1,
      sym_type_parameters,
    STATE(5261), 1,
      sym_formal_parameters,
    STATE(5311), 1,
      sym_nested_identifier,
    ACTIONS(1621), 2,
      sym_true,
      sym_false,
    ACTIONS(2779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3704), 2,
      sym_string,
      sym__number,
    ACTIONS(1611), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3719), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(3699), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [76290] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_EQ,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(2814), 1,
      anon_sym_QMARK,
    ACTIONS(1584), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [76363] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(1819), 1,
      anon_sym_EQ,
    ACTIONS(2203), 1,
      anon_sym_extends,
    ACTIONS(3635), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1597), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [76438] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(2135), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 1,
      anon_sym_LBRACK,
    ACTIONS(2203), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [76513] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3579), 1,
      anon_sym_LT,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(4393), 1,
      anon_sym_EQ_GT,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [76588] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3579), 1,
      anon_sym_LT,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(4387), 1,
      anon_sym_EQ_GT,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [76663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4102), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [76730] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4102), 1,
      anon_sym_EQ,
    ACTIONS(4167), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [76799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4171), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [76866] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 1,
      anon_sym_EQ,
    ACTIONS(2143), 1,
      anon_sym_EQ_GT,
    ACTIONS(1597), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [76935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(3660), 1,
      anon_sym_EQ,
    ACTIONS(4339), 1,
      anon_sym_QMARK,
    ACTIONS(4336), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4366), 1,
      anon_sym_EQ_GT,
    ACTIONS(4383), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77077] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77146] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 1,
      anon_sym_RBRACK,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(2896), 1,
      anon_sym_COMMA,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    ACTIONS(2919), 1,
      anon_sym_COLON,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77221] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_EQ,
    ACTIONS(1943), 1,
      anon_sym_EQ_GT,
    ACTIONS(2203), 1,
      anon_sym_COMMA,
    ACTIONS(3632), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77296] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4072), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3573), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77363] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4366), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3539), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77495] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1837), 1,
      anon_sym_EQ,
    ACTIONS(1839), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77568] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77635] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_EQ,
    ACTIONS(4211), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77704] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_EQ,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 1,
      anon_sym_LBRACK,
    ACTIONS(2203), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77779] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_EQ,
    ACTIONS(2080), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3573), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77915] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(2143), 1,
      anon_sym_EQ_GT,
    ACTIONS(1597), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [77984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1855), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3313), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3315), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78116] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4393), 1,
      anon_sym_EQ_GT,
    ACTIONS(4396), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4175), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3419), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78321] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_EQ,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(2203), 1,
      anon_sym_extends,
    ACTIONS(3632), 1,
      anon_sym_LBRACK,
    ACTIONS(3847), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3635), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78398] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4167), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4124), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78534] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_EQ,
    ACTIONS(4368), 1,
      anon_sym_in,
    ACTIONS(4371), 1,
      anon_sym_of,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1813), 1,
      anon_sym_EQ_GT,
    ACTIONS(1941), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78674] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4393), 1,
      anon_sym_EQ_GT,
    ACTIONS(4398), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78753] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4387), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78828] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1853), 1,
      anon_sym_EQ,
    ACTIONS(1855), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78897] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(3642), 1,
      anon_sym_COMMA,
    ACTIONS(4396), 1,
      anon_sym_EQ,
    ACTIONS(4400), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3604), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3577), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [78978] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1837), 1,
      anon_sym_EQ,
    ACTIONS(1839), 1,
      anon_sym_EQ_GT,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3483), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79110] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1813), 1,
      anon_sym_EQ_GT,
    ACTIONS(2137), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79179] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4336), 1,
      anon_sym_RBRACK,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_EQ,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4408), 1,
      anon_sym_in,
    ACTIONS(4410), 1,
      anon_sym_COLON,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4244), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79325] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3573), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3319), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79455] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4244), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1839), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1597), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3439), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4211), 1,
      anon_sym_EQ_GT,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79725] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4393), 1,
      anon_sym_EQ_GT,
    ACTIONS(4398), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4383), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79866] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4124), 1,
      anon_sym_EQ,
    ACTIONS(4126), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [79934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4396), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80000] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      sym_number,
    ACTIONS(4414), 1,
      anon_sym_export,
    ACTIONS(4418), 1,
      anon_sym_async,
    ACTIONS(4420), 1,
      anon_sym_static,
    ACTIONS(4422), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4416), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4424), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4426), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3725), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(5132), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4126), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4412), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80118] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(4428), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4126), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4393), 1,
      anon_sym_EQ_GT,
    ACTIONS(4398), 1,
      anon_sym_EQ,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80324] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(3599), 1,
      anon_sym_LT,
    ACTIONS(4400), 1,
      anon_sym_EQ_GT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80398] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4393), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80466] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 1,
      anon_sym_RBRACK,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(2896), 1,
      anon_sym_COMMA,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80538] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_EQ,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    ACTIONS(4408), 1,
      anon_sym_in,
    ACTIONS(4431), 1,
      anon_sym_COLON,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80610] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_EQ,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 1,
      anon_sym_COLON,
    ACTIONS(1597), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80680] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1597), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80748] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4336), 1,
      anon_sym_RBRACK,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_EQ,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80820] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      anon_sym_EQ,
    ACTIONS(2013), 1,
      anon_sym_EQ_GT,
    ACTIONS(3632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_EQ,
    ACTIONS(1943), 1,
      anon_sym_EQ_GT,
    ACTIONS(1597), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [80960] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      anon_sym_EQ,
    ACTIONS(2130), 1,
      anon_sym_EQ_GT,
    ACTIONS(2203), 1,
      anon_sym_COMMA,
    ACTIONS(3632), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3635), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1597), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4398), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81100] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 1,
      anon_sym_EQ_GT,
    ACTIONS(2128), 1,
      anon_sym_EQ,
    ACTIONS(1597), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81168] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4387), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4385), 1,
      anon_sym_EQ,
    ACTIONS(4387), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1597), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81372] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(4286), 1,
      anon_sym_EQ,
    ACTIONS(4428), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81442] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3579), 1,
      anon_sym_LT,
    ACTIONS(3582), 1,
      anon_sym_DOT,
    ACTIONS(4400), 1,
      anon_sym_EQ_GT,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81516] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1905), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81584] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(4336), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81654] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(1819), 1,
      anon_sym_EQ,
    ACTIONS(1584), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4385), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_EQ,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81856] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3640), 1,
      anon_sym_EQ_GT,
    ACTIONS(3660), 1,
      anon_sym_EQ,
    ACTIONS(4336), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81926] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      anon_sym_EQ,
    ACTIONS(2013), 1,
      anon_sym_EQ_GT,
    ACTIONS(1597), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [81994] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3381), 1,
      anon_sym_LBRACK,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      sym_number,
    ACTIONS(4414), 1,
      anon_sym_export,
    ACTIONS(4418), 1,
      anon_sym_async,
    ACTIONS(4420), 1,
      anon_sym_static,
    ACTIONS(4422), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4416), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4424), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4426), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3725), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(5132), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4118), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4412), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82112] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_EQ,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(1584), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82182] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_EQ,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    ACTIONS(4408), 1,
      anon_sym_in,
    ACTIONS(4410), 1,
      anon_sym_COLON,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82254] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_EQ,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(2919), 1,
      anon_sym_COLON,
    ACTIONS(1597), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82324] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 1,
      anon_sym_EQ,
    ACTIONS(1905), 1,
      anon_sym_EQ_GT,
    ACTIONS(1597), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82392] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      anon_sym_EQ,
    ACTIONS(2130), 1,
      anon_sym_EQ_GT,
    ACTIONS(1597), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82459] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_EQ,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82526] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(2135), 1,
      anon_sym_EQ_GT,
    ACTIONS(1597), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82593] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1597), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82660] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_EQ,
    ACTIONS(2139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1597), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4396), 1,
      anon_sym_EQ,
    ACTIONS(4400), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82794] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82861] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4400), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82928] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4368), 1,
      anon_sym_in,
    ACTIONS(4371), 1,
      anon_sym_of,
    ACTIONS(4391), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [82999] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(2135), 1,
      anon_sym_EQ_GT,
    ACTIONS(2879), 1,
      anon_sym_in,
    ACTIONS(4373), 1,
      anon_sym_of,
    ACTIONS(1597), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [83070] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4391), 1,
      anon_sym_EQ_GT,
    ACTIONS(3577), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [83137] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      anon_sym_EQ_GT,
    ACTIONS(2133), 1,
      anon_sym_EQ,
    ACTIONS(1597), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
    ACTIONS(1601), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [83204] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(4368), 1,
      anon_sym_in,
    ACTIONS(4371), 1,
      anon_sym_of,
    ACTIONS(3577), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3587), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3573), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [83272] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4446), 1,
      anon_sym_RBRACE,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [83387] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4477), 1,
      sym_identifier,
    ACTIONS(4479), 1,
      anon_sym_STAR,
    ACTIONS(4483), 1,
      anon_sym_LBRACE,
    STATE(5064), 1,
      sym_import_clause,
    ACTIONS(4487), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(5065), 2,
      sym_string,
      sym_import_require_clause,
    STATE(5414), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(4481), 15,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4485), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83462] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(4489), 1,
      anon_sym_RBRACE,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [83577] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(4492), 1,
      anon_sym_RBRACE,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [83692] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(4495), 1,
      anon_sym_RBRACE,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [83807] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(4498), 1,
      anon_sym_RBRACE,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [83922] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(4501), 1,
      anon_sym_RBRACE,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [84037] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(4504), 1,
      anon_sym_RBRACE,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [84152] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(4507), 1,
      anon_sym_RBRACE,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [84267] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(4510), 1,
      anon_sym_RBRACE,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [84382] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4517), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4519), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4249), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84488] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4535), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4537), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4173), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84594] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4539), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4541), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4143), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84700] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4543), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4545), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4233), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84806] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(4547), 1,
      anon_sym_COMMA,
    ACTIONS(4550), 1,
      anon_sym_RBRACE,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [84918] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4553), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4555), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4175), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85024] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3565), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3567), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4094), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85130] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(3379), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3399), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4124), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85236] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    ACTIONS(4557), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [85343] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4568), 1,
      anon_sym_LT,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4572), 1,
      anon_sym_QMARK_DOT,
    STATE(2034), 1,
      sym_type_arguments,
    STATE(2167), 1,
      sym_arguments,
    ACTIONS(4560), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4562), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [85412] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(4574), 1,
      anon_sym_EQ,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [85517] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_STAR,
    ACTIONS(4435), 1,
      anon_sym_default,
    ACTIONS(4437), 1,
      anon_sym_EQ,
    ACTIONS(4439), 1,
      anon_sym_as,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4399), 1,
      sym_declaration,
    STATE(4688), 1,
      sym_export_clause,
    ACTIONS(4576), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [85624] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4580), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85726] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4582), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1961), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [85882] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4584), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85984] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4586), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86086] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4588), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86188] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4590), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1895), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86344] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4592), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86446] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4594), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86548] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4596), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4598), 1,
      sym__automatic_semicolon,
    ACTIONS(1947), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1945), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [86706] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4600), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86808] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4602), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86910] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4604), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87012] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4606), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    STATE(2104), 1,
      sym_statement_block,
    ACTIONS(1859), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1857), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [87172] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    ACTIONS(4610), 1,
      anon_sym_DOT,
    STATE(2104), 1,
      sym_statement_block,
    ACTIONS(1859), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1857), 28,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [87232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    STATE(2117), 1,
      sym_arguments,
    ACTIONS(4612), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4614), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [87290] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4616), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    STATE(2070), 1,
      sym_type_arguments,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [87450] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4622), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87552] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4624), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2154), 1,
      sym_statement_block,
    ACTIONS(1859), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1857), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87712] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    ACTIONS(4628), 1,
      anon_sym_DOT,
    STATE(2154), 1,
      sym_statement_block,
    ACTIONS(1859), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1857), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87772] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4630), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87874] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4632), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87976] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    ACTIONS(4638), 1,
      anon_sym_DOT,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(4634), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4636), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [88036] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    STATE(2070), 1,
      sym_type_arguments,
    ACTIONS(4640), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4642), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [88094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(4644), 1,
      sym__automatic_semicolon,
    ACTIONS(1843), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1841), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [88152] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    ACTIONS(4648), 1,
      anon_sym_DOT,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(4646), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [88212] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4651), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4644), 1,
      sym__automatic_semicolon,
    ACTIONS(1843), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1841), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [88370] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4653), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88472] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4655), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4657), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4659), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [88627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4663), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [88680] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4675), 1,
      anon_sym_LT,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88757] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4675), 1,
      anon_sym_LT,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88828] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88921] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4708), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89020] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4716), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2765), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [89172] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4718), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4720), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4722), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [89324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4724), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4726), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [89377] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4732), 1,
      anon_sym_LBRACK,
    ACTIONS(4736), 1,
      anon_sym_extends,
    ACTIONS(4734), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4728), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4730), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [89436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4738), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4740), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [89489] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4742), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4746), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [89641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4750), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [89694] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4752), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4754), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4756), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [89846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4640), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4642), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [89899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4760), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [89952] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4762), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [90051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2040), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [90104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1917), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [90157] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4768), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [90220] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4774), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [90319] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4806), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [90418] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4808), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [90517] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4810), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 20,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [90590] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [90673] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4813), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [90772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1957), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [90825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2007), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [90878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1895), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [90931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2028), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2030), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [90984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2058), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2060), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [91037] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [91116] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [91201] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [91290] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4810), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [91367] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4810), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [91438] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [91531] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4716), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [91630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1899), 30,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4815), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4817), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [91736] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4762), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [91835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4819), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4821), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [91888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4823), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4825), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [91941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1945), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [91994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1969), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1971), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1933), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2050), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1877), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1879), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    ACTIONS(4827), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1997), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4835), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4837), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4839), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92420] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 11,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4746), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [92566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3361), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92619] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92704] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4841), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [92803] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4690), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4845), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3355), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [92988] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4690), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [93071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2066), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2064), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4849), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93177] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4813), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [93276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1923), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1921), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4853), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4752), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93435] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4675), 1,
      anon_sym_LT,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [93508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2761), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4861), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4865), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4869), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4718), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 1,
      anon_sym_DOT,
    ACTIONS(4873), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4875), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4880), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4882), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4884), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [93987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1907), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [94040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4890), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [94093] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4896), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [94164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4899), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4901), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [94217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4905), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [94270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3365), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [94323] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4808), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [94422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1981), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [94475] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4806), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [94574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1923), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1921), 30,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [94627] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [94686] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(4919), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [94745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [94798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4931), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [94851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [94908] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4841), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95007] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4774), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95106] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [95163] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4690), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4708), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [95279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4947), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4949), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [95332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4953), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [95385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1997), 30,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(1845), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [95493] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4708), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [95592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1961), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [95645] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4572), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4722), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4720), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2020), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [95708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4957), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [95761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [95814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4963), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4813), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [95867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4965), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4967), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [95920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2757), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [95973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4971), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4973), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4975), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96079] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4718), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [96178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4977), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4979), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4983), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4987), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4995), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4997), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4999), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5003), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1869), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96602] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4572), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4720), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4722), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5005), 1,
      sym__automatic_semicolon,
    ACTIONS(1843), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1841), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96716] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4742), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [96815] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4752), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [96914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4732), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4736), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [96969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2072), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2074), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2755), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2753), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5009), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97181] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4896), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5013), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2751), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2749), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5015), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5017), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1869), 30,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2203), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5023), 1,
      sym_regex_flags,
    ACTIONS(5019), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_extends,
    ACTIONS(5021), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [97572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5027), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      sym__automatic_semicolon,
    ACTIONS(1947), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1945), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5031), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5033), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4907), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1945), 30,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5035), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4841), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [97947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [98000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5043), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [98053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5045), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5047), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [98106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5049), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5051), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [98159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4481), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [98212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [98265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4572), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2020), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [98324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1907), 30,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1899), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [98430] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5057), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [98499] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5060), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [98598] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4768), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4778), 1,
      anon_sym_in,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4784), 1,
      anon_sym_QMARK,
    ACTIONS(4786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4794), 1,
      anon_sym_PIPE,
    ACTIONS(4798), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4802), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4788), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4796), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4770), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4780), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4800), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5062), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_extends,
  [98697] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5064), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [98768] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5064), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [98839] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(5067), 1,
      anon_sym_LT,
    ACTIONS(5069), 1,
      anon_sym_QMARK_DOT,
    STATE(2226), 1,
      sym_type_arguments,
    STATE(2350), 1,
      sym_arguments,
    ACTIONS(4560), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4562), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2066), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2064), 30,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98959] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5071), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99028] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5060), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99127] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4684), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4688), 1,
      anon_sym_in,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4698), 1,
      anon_sym_AMP,
    ACTIONS(4700), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_QMARK,
    ACTIONS(4714), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4696), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4665), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4682), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4704), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5062), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    ACTIONS(5074), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4827), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [99282] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4123), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99380] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4718), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [99478] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4716), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [99576] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4708), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [99674] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [99756] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4762), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [99854] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5119), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [99926] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4813), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [100024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    STATE(2371), 1,
      sym_arguments,
    ACTIONS(4612), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4614), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100080] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4160), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100178] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [100270] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4742), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [100368] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5119), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [100444] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4808), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [100542] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100640] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4752), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [100738] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4243), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100836] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4806), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [100934] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4841), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [101032] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4774), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [101130] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5119), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 20,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [101200] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5122), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 20,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [101270] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5122), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 20,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [101340] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4389), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101438] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5062), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [101536] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    ACTIONS(4648), 1,
      anon_sym_DOT,
    ACTIONS(5125), 1,
      anon_sym_is,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [101596] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5079), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5097), 1,
      anon_sym_QMARK,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5101), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5060), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
  [101694] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5127), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 22,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [101762] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5089), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 25,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [101824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 1,
      anon_sym_LT,
    STATE(2357), 1,
      sym_type_arguments,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101880] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4126), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101978] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5105), 1,
      anon_sym_AMP,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [102066] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5085), 1,
      anon_sym_in,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5091), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [102150] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 1,
      anon_sym_LT,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5111), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5109), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5077), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5103), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [102228] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4135), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102326] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_extends,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [102386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 1,
      anon_sym_LT,
    ACTIONS(5130), 1,
      anon_sym_DOT,
    STATE(2352), 1,
      sym_type_arguments,
    ACTIONS(4646), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102444] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 1,
      anon_sym_LT,
    ACTIONS(5133), 1,
      anon_sym_DOT,
    STATE(2352), 1,
      sym_type_arguments,
    ACTIONS(4634), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4636), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 1,
      anon_sym_LT,
    STATE(2357), 1,
      sym_type_arguments,
    ACTIONS(4640), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4642), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(5135), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(1845), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [102614] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_new,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_STAR,
    ACTIONS(4515), 1,
      anon_sym_export,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(4523), 1,
      anon_sym_async,
    ACTIONS(4525), 1,
      sym_number,
    ACTIONS(4527), 1,
      anon_sym_static,
    ACTIONS(4529), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4268), 1,
      sym__call_signature,
    STATE(4531), 1,
      aux_sym_export_statement_repeat1,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(4531), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4118), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(5138), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4907), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [102768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 1,
      sym_regex_flags,
    ACTIONS(5019), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_extends,
    ACTIONS(5021), 25,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [102822] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 1,
      anon_sym_LT,
    ACTIONS(5130), 1,
      anon_sym_DOT,
    ACTIONS(5143), 1,
      anon_sym_is,
    STATE(2352), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102882] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(2765), 1,
      anon_sym_extends,
    ACTIONS(4919), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [102942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3361), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103044] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5062), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5143), 1,
      anon_sym_is,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103194] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [103255] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5060), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103352] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [103421] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5176), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [103490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1969), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1971), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5027), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103592] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5181), 1,
      anon_sym_RBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5185), 1,
      anon_sym_async,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5189), 1,
      anon_sym_static,
    ACTIONS(5191), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4918), 1,
      aux_sym_object_repeat1,
    ACTIONS(5193), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5195), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4921), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5179), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1933), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2050), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103836] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(5069), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2020), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5197), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4736), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103997] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4808), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104094] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4813), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104191] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5176), 1,
      anon_sym_LT,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 18,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [104262] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4774), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104359] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [104440] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5231), 1,
      anon_sym_RBRACE,
    ACTIONS(5233), 1,
      anon_sym_async,
    ACTIONS(5235), 1,
      anon_sym_static,
    ACTIONS(5237), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4760), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5239), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5241), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4789), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5229), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104531] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4841), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104628] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 15,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [104705] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [104788] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [104875] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5176), 1,
      anon_sym_LT,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 15,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [104950] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [105041] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4708), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105138] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4716), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 1,
      anon_sym_is,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [105288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2203), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105339] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [105408] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5243), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [105475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5013), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105526] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5248), 1,
      anon_sym_RBRACE,
    ACTIONS(5250), 1,
      anon_sym_async,
    ACTIONS(5252), 1,
      anon_sym_static,
    ACTIONS(5254), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5256), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5258), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5246), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [105617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1877), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1879), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105668] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5262), 1,
      anon_sym_RBRACE,
    ACTIONS(5264), 1,
      anon_sym_async,
    ACTIONS(5266), 1,
      anon_sym_static,
    ACTIONS(5268), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4819), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5270), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5272), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4919), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5260), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [105759] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5276), 1,
      anon_sym_RBRACE,
    ACTIONS(5278), 1,
      anon_sym_async,
    ACTIONS(5280), 1,
      anon_sym_static,
    ACTIONS(5282), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5284), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5286), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5274), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [105850] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(5290), 1,
      anon_sym_DOT,
    ACTIONS(5293), 1,
      anon_sym_is,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [105909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4657), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4659), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5049), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5051), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106011] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4718), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106108] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4742), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106205] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4752), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2757), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4835), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4837), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4839), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106455] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4746), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [106510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4853), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106561] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5297), 1,
      anon_sym_RBRACE,
    ACTIONS(5299), 1,
      anon_sym_async,
    ACTIONS(5301), 1,
      anon_sym_static,
    ACTIONS(5303), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5305), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5307), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5295), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [106652] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(5069), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4720), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4722), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106709] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4841), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106806] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4806), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4971), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2040), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2765), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107056] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4572), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4720), 3,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4722), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(2020), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [107117] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4762), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [107214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4973), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4975), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [107322] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(4919), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [107379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4720), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4722), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1917), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107481] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5311), 1,
      anon_sym_RBRACE,
    ACTIONS(5313), 1,
      anon_sym_async,
    ACTIONS(5315), 1,
      anon_sym_static,
    ACTIONS(5317), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4918), 1,
      aux_sym_object_repeat1,
    ACTIONS(5319), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5321), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4921), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5309), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [107572] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4806), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [107669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [107724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3365), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4983), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107826] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_COMMA,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [107885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4724), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4726), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107936] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(2765), 1,
      anon_sym_COMMA,
    ACTIONS(4919), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [107995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [108050] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4736), 1,
      anon_sym_extends,
    ACTIONS(5197), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4728), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4730), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [108107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4738), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4740), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5045), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5047), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108260] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4752), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108357] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4742), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108454] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4718), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4899), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4901), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4963), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4813), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4890), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3355), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4965), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4967), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4481), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4977), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4979), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4746), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4750), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4987), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4884), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4754), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4756), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4640), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4642), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4760), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4995), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 1,
      anon_sym_DOT,
    ACTIONS(4873), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4875), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4869), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109420] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5325), 1,
      anon_sym_RBRACE,
    ACTIONS(5327), 1,
      anon_sym_async,
    ACTIONS(5329), 1,
      anon_sym_static,
    ACTIONS(5331), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4918), 1,
      aux_sym_object_repeat1,
    ACTIONS(5333), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5335), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4921), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5323), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [109511] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(5069), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4722), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4720), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2020), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [109572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4865), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2761), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109674] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(5069), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4720), 3,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4722), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2020), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [109735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4997), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4999), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4845), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5003), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109939] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5339), 1,
      anon_sym_RBRACE,
    ACTIONS(5341), 1,
      anon_sym_async,
    ACTIONS(5343), 1,
      anon_sym_static,
    ACTIONS(5345), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5337), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [110030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4849), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4957), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110132] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [110223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5043), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110325] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(5351), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [110386] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5355), 1,
      anon_sym_EQ,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4774), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [110485] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5035), 1,
      anon_sym_EQ,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4841), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [110584] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5383), 1,
      anon_sym_EQ,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4806), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [110683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4907), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4752), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110787] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4774), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [110884] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5387), 1,
      anon_sym_RBRACE,
    ACTIONS(5389), 1,
      anon_sym_async,
    ACTIONS(5391), 1,
      anon_sym_static,
    ACTIONS(5393), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5395), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5397), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5385), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [110975] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5205), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [111036] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4808), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [111135] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4963), 1,
      anon_sym_EQ,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4813), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [111234] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5401), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [111305] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5406), 1,
      anon_sym_RBRACE,
    ACTIONS(5408), 1,
      anon_sym_async,
    ACTIONS(5410), 1,
      anon_sym_static,
    ACTIONS(5412), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    STATE(4791), 1,
      aux_sym_object_repeat1,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5414), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5416), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4814), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5404), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [111396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4953), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111498] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4808), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [111595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4947), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4949), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4861), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4708), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111748] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4813), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [111845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2072), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2074), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1957), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111947] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4669), 6,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4667), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [112028] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 9,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [112105] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [112188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4931), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112239] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [112326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2007), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4718), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112428] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5418), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [112499] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5401), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [112574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4880), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4882), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5035), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4841), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112676] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5401), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [112745] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [112836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5015), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5017), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112887] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4945), 1,
      anon_sym_EQ,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4708), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [112986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    ACTIONS(4827), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [113039] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5421), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [113106] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5424), 1,
      anon_sym_EQ,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5060), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113205] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5426), 1,
      anon_sym_EQ,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5062), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113304] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5430), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113403] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4762), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113500] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5432), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [113569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2028), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2030), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [113620] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5432), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [113689] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 10,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [113770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [113821] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5435), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 21,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [113888] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(5438), 1,
      anon_sym_QMARK_DOT,
    STATE(2555), 1,
      sym_type_arguments,
    STATE(2703), 1,
      sym_arguments,
    ACTIONS(4560), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4562), 23,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [113953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_extends,
    ACTIONS(4933), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [114010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2058), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2060), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2755), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2753), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5009), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114163] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4939), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [114220] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5440), 1,
      anon_sym_EQ,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4716), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [114319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2751), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2749), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4663), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114421] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [114498] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 10,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [114581] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [114668] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5418), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [114743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4823), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4825), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114794] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [114863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4819), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4821), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(5005), 1,
      sym__automatic_semicolon,
    ACTIONS(1843), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1841), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1981), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5031), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5033), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115071] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4871), 1,
      anon_sym_EQ,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4718), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115170] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5060), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115267] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4857), 1,
      anon_sym_EQ,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4742), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115366] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5201), 1,
      anon_sym_as,
    ACTIONS(5203), 1,
      anon_sym_in,
    ACTIONS(5205), 1,
      anon_sym_LT,
    ACTIONS(5209), 1,
      anon_sym_QMARK,
    ACTIONS(5211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5217), 1,
      anon_sym_AMP,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5213), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5199), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5207), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5062), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5225), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115463] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5442), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [115532] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(4855), 1,
      anon_sym_EQ,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4752), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(1845), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115684] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4708), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115781] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(5357), 1,
      anon_sym_as,
    ACTIONS(5359), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    ACTIONS(5365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5381), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5445), 1,
      anon_sym_EQ,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5367), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5375), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5353), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5361), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4762), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5379), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4815), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4817), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115931] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4716), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [116028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4905), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116079] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5442), 1,
      anon_sym_LT,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(5117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 19,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [116148] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5355), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4774), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [116246] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5383), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4806), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [116344] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5399), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4808), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [116442] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5477), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [116512] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4762), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [116608] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4669), 6,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4667), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [116688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_AMP,
    ACTIONS(5508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [116740] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 9,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [116816] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [116898] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [116984] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5477), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [117058] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5424), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5060), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [117156] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 5,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [117246] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5440), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4716), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [117344] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5445), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4762), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [117442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5562), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [117496] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5564), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [117592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [117646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5562), 1,
      anon_sym_PIPE,
    ACTIONS(5572), 1,
      anon_sym_extends,
    ACTIONS(5568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [117702] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5062), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [117798] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4855), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4752), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [117896] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4857), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4742), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [117994] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4871), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4718), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5574), 1,
      sym_regex_flags,
    ACTIONS(5019), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_extends,
    ACTIONS(5021), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [118144] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4945), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4708), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118242] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(5576), 1,
      anon_sym_RPAREN,
    ACTIONS(5578), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(5561), 1,
      sym_type_annotation,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118344] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4963), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4813), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(5580), 1,
      sym__automatic_semicolon,
    ACTIONS(1843), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1841), 26,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [118496] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5035), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4841), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(4989), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [118650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(2682), 1,
      sym_statement_block,
    ACTIONS(1859), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1857), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [118704] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(5586), 1,
      anon_sym_DOT,
    STATE(2682), 1,
      sym_statement_block,
    ACTIONS(1859), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1857), 25,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [118760] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5588), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [118828] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5591), 1,
      anon_sym_COMMA,
    ACTIONS(5594), 1,
      anon_sym_RBRACE,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4808), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118928] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4806), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119024] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5596), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [119092] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5596), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [119160] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4841), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119256] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5062), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(4959), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [119408] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5060), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119504] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5629), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 20,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [119570] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5632), 1,
      anon_sym_COMMA,
    ACTIONS(5635), 1,
      anon_sym_RBRACE,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4808), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119670] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4774), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119766] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5635), 1,
      anon_sym_RBRACE,
    ACTIONS(5637), 1,
      anon_sym_COMMA,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4774), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119866] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4716), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119962] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4718), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [120058] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4841), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [120154] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4813), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [120250] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4708), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [120346] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4718), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [120442] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4708), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [120538] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4742), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [120634] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5060), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [120730] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(5290), 1,
      anon_sym_DOT,
    ACTIONS(5670), 1,
      anon_sym_is,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 25,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [120788] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4752), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [120884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(5646), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
      anon_sym_extends,
  [120944] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(5578), 1,
      anon_sym_COLON,
    ACTIONS(5672), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(5348), 1,
      sym_type_annotation,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [121046] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4774), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [121142] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [121232] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5674), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [121300] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5674), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [121374] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4806), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [121470] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [121556] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4742), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [121652] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(5578), 1,
      anon_sym_COLON,
    ACTIONS(5677), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(5567), 1,
      sym_type_annotation,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [121754] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4808), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [121850] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5679), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
      anon_sym_extends,
  [121920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 1,
      anon_sym_LT,
    ACTIONS(5130), 1,
      anon_sym_DOT,
    ACTIONS(5682), 1,
      anon_sym_is,
    STATE(2352), 1,
      sym_type_arguments,
    ACTIONS(4646), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [121978] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
      anon_sym_extends,
  [122058] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
      anon_sym_extends,
  [122134] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4752), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [122230] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
      anon_sym_extends,
  [122312] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [122394] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
      anon_sym_extends,
  [122480] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5679), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
      anon_sym_extends,
  [122554] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5679), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
      anon_sym_extends,
  [122622] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
      anon_sym_extends,
  [122712] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4716), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [122808] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5686), 1,
      anon_sym_LBRACE,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5714), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4682), 1,
      sym_type_arguments,
    STATE(4690), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [122910] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4762), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [123006] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5426), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5062), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [123104] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(5484), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [123164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_LT,
    STATE(2757), 1,
      sym_type_arguments,
    ACTIONS(4640), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4642), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [123218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(5716), 1,
      anon_sym_DOT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(4634), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4636), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [123274] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [123350] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_as,
    ACTIONS(5451), 1,
      anon_sym_in,
    ACTIONS(5453), 1,
      anon_sym_LT,
    ACTIONS(5457), 1,
      anon_sym_QMARK,
    ACTIONS(5459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5465), 1,
      anon_sym_AMP,
    ACTIONS(5467), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5475), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5469), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5060), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5447), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5455), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5463), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5473), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [123448] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [123528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5562), 1,
      anon_sym_PIPE,
    ACTIONS(5572), 1,
      anon_sym_extends,
    ACTIONS(4959), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [123584] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4242), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4641), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5714), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [123684] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(5290), 1,
      anon_sym_DOT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [123740] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5746), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
      anon_sym_extends,
  [123808] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5588), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [123876] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5749), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [123942] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(5578), 1,
      anon_sym_COLON,
    ACTIONS(5752), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(5516), 1,
      sym_type_annotation,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [124044] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(4919), 1,
      anon_sym_LBRACK,
    ACTIONS(4922), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5754), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2765), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1845), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [124104] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 1,
      anon_sym_LBRACK,
    ACTIONS(4916), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5758), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4726), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4907), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [124164] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5762), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [124232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    STATE(2724), 1,
      sym_arguments,
    ACTIONS(4612), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4614), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [124286] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5762), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [124354] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5562), 1,
      anon_sym_PIPE,
    ACTIONS(5572), 1,
      anon_sym_extends,
    ACTIONS(4884), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [124410] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5562), 1,
      anon_sym_PIPE,
    ACTIONS(5572), 1,
      anon_sym_extends,
    ACTIONS(5765), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [124466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_LT,
    STATE(2757), 1,
      sym_type_arguments,
    ACTIONS(4618), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [124520] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4808), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [124616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5769), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [124668] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4813), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [124764] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5746), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
      anon_sym_extends,
  [124832] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5062), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [124928] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5773), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [124994] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5644), 1,
      anon_sym_in,
    ACTIONS(5646), 1,
      anon_sym_LT,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    ACTIONS(5652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP,
    ACTIONS(5660), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5668), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5662), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5648), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5656), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5060), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5666), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [125090] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5526), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [125150] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5776), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 20,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
      anon_sym_extends,
  [125216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 1,
      anon_sym_COMMA,
    ACTIONS(4939), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [125272] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5355), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4774), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [125370] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(5578), 1,
      anon_sym_COLON,
    ACTIONS(5779), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(5383), 1,
      sym_type_annotation,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [125472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [125524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4907), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [125576] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    ACTIONS(4827), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [125628] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4762), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [125724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(1845), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [125776] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4716), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [125872] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5035), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4841), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [125970] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_COMMA,
    ACTIONS(4933), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [126026] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [126116] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(5453), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [126176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5562), 1,
      anon_sym_PIPE,
    ACTIONS(5572), 1,
      anon_sym_extends,
    ACTIONS(4989), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [126232] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5477), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [126300] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5383), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4806), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [126398] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5781), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [126464] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5784), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [126532] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5674), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [126602] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5399), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4808), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [126700] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5784), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [126774] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [126860] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4963), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4813), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [126958] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [127040] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [127116] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 9,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [127196] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5787), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [127266] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4669), 6,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4667), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [127346] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [127402] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5784), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [127472] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4808), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [127568] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4806), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [127664] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4774), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [127760] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(5605), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [127820] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 9,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [127896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_AMP,
    ACTIONS(5769), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [127948] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [128030] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [128116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5765), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [128172] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5787), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 11,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [128246] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5787), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [128314] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(5578), 1,
      anon_sym_COLON,
    ACTIONS(5790), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(5310), 1,
      sym_type_annotation,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [128416] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 5,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [128506] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4708), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [128604] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(4884), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [128660] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4716), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [128758] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4718), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [128856] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4841), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [128952] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4813), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [129048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 1,
      anon_sym_is,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [129100] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4742), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [129198] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4855), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4752), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [129296] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5445), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4762), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [129394] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5792), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [129462] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5792), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [129530] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4708), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [129626] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4718), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [129722] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4742), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [129818] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(5603), 1,
      anon_sym_in,
    ACTIONS(5605), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_QMARK,
    ACTIONS(5611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5617), 1,
      anon_sym_AMP,
    ACTIONS(5619), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5627), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5613), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5621), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5599), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5607), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4752), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5625), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [129914] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5426), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_in,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5526), 1,
      anon_sym_LT,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_AMP,
    ACTIONS(5544), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5552), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5062), 3,
      anon_sym_COMMA,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5528), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [130012] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(2765), 1,
      anon_sym_COMMA,
    ACTIONS(4919), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [130070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_COMMA,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [130128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(4919), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [130184] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [130240] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [130321] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4708), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [130416] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    ACTIONS(4648), 1,
      anon_sym_DOT,
    ACTIONS(5795), 1,
      anon_sym_is,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [130473] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4716), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [130568] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4708), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [130663] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 5,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [130752] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(1851), 1,
      sym__automatic_semicolon,
    ACTIONS(1841), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1845), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [130807] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5829), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [130904] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5831), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [130971] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5831), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [131044] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5834), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [131111] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5839), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_extends,
    ACTIONS(5765), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [131166] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [131251] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [131332] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [131407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [131458] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [131537] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5843), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4926), 1,
      aux_sym_array_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [131636] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5831), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [131705] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      sym_number,
    ACTIONS(5847), 1,
      anon_sym_async,
    ACTIONS(5849), 1,
      anon_sym_static,
    ACTIONS(5851), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    ACTIONS(4150), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5853), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5855), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3959), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(5130), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(5132), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5845), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [131788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1899), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [131837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5027), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [131886] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4813), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [131981] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4808), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [132076] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5839), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_extends,
    ACTIONS(4959), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [132131] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    ACTIONS(4648), 1,
      anon_sym_DOT,
    ACTIONS(5857), 1,
      anon_sym_is,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(4646), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2203), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5013), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132286] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4716), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [132383] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4708), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [132480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4708), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4947), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4949), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4953), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4931), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1981), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5035), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4841), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4905), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 1,
      sym__automatic_semicolon,
    ACTIONS(1947), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1945), 26,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [132972] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 4,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [133061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5861), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4736), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [133112] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5863), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [133179] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5863), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 11,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [133252] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [133337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4957), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [133386] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [133467] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 9,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [133542] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4669), 6,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [133621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1997), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [133670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [133719] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5863), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [133788] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(5866), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [133847] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4806), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [133942] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 5,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [134031] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4963), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4813), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [134128] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4718), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [134223] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4742), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [134318] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4752), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [134413] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4841), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [134508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4963), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4813), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [134557] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4774), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [134652] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(5803), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [134711] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5399), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4808), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [134808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4965), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4967), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [134857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [134910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5023), 1,
      sym_regex_flags,
    ACTIONS(5019), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(5021), 24,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [134961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4663), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [135010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [135063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4880), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4882), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [135112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4977), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4979), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [135161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_COMMA,
    ACTIONS(4933), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [135216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4987), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [135265] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5060), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [135360] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4762), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [135455] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5062), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [135550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4718), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [135599] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5896), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4781), 1,
      aux_sym_array_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [135698] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_extends,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [135755] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4718), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [135852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4861), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [135901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 1,
      anon_sym_COMMA,
    ACTIONS(4939), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [135956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [136005] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4742), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [136102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4752), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [136151] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5898), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4887), 1,
      aux_sym_array_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [136250] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(4855), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4752), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [136347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4853), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [136396] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5900), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4832), 1,
      aux_sym_array_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [136495] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5438), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4722), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4720), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2020), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 22,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [136554] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(2765), 1,
      anon_sym_extends,
    ACTIONS(4919), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [136611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4849), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [136660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4995), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [136709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4997), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4999), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [136758] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5438), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4720), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4722), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [136813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5003), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [136862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2765), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [136911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4845), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [136960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4720), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4722), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [137009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4724), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4726), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [137058] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4936), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4933), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5013), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [137113] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4736), 1,
      anon_sym_extends,
    ACTIONS(5861), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4728), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4730), 25,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [137168] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4762), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [137263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4738), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4740), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [137312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4746), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [137361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      sym__automatic_semicolon,
    ACTIONS(1843), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1841), 26,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [137412] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5902), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [137507] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5902), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [137604] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4752), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [137699] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4742), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [137794] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4718), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [137889] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5430), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [137986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5682), 1,
      anon_sym_is,
    ACTIONS(4618), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [138037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4750), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [138086] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5906), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [138181] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5908), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4724), 1,
      aux_sym_array_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [138280] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4716), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [138375] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4708), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [138470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4754), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4756), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [138519] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5912), 1,
      anon_sym_DOT,
    ACTIONS(5915), 1,
      anon_sym_is,
    STATE(3200), 1,
      sym_type_arguments,
    ACTIONS(4646), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [138576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4837), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4839), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [138625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(5917), 1,
      sym__automatic_semicolon,
    ACTIONS(1843), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1841), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [138678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4640), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4642), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [138727] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5834), 1,
      anon_sym_LT,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [138800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4760), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [138849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1869), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [138898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5015), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5017), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [138947] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5919), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACE_PIPE,
  [139012] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5922), 1,
      anon_sym_QMARK_DOT,
    STATE(3002), 1,
      sym_type_arguments,
    STATE(3305), 1,
      sym_arguments,
    ACTIONS(4560), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4562), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [139075] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5924), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4850), 1,
      aux_sym_array_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [139174] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5383), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4806), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [139271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1969), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1971), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [139320] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5424), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5060), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [139417] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5926), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 19,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [139482] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [139567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3365), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [139616] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5060), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [139711] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5062), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [139806] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [139887] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5929), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [139954] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [140029] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4746), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [140082] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5929), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [140149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      anon_sym_is,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [140200] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5932), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4920), 1,
      aux_sym_array_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [140299] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5426), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5062), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [140396] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [140475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4835), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [140524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5839), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [140577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5839), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_extends,
    ACTIONS(5568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [140632] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5839), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_extends,
    ACTIONS(4989), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [140687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5769), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [140738] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5934), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [140805] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5839), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_extends,
    ACTIONS(4884), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [140860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3355), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [140909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4657), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4659), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [140958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4865), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [141007] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5937), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [141104] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5939), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [141201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5031), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5033), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [141250] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5934), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [141317] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    ACTIONS(4648), 1,
      anon_sym_DOT,
    ACTIONS(5941), 1,
      anon_sym_is,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [141374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1923), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1921), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [141423] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5035), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4841), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [141520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4869), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [141569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2066), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2064), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [141618] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5943), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [141685] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5943), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [141752] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5946), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [141817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2761), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [141866] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4942), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4939), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4620), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [141921] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5834), 1,
      anon_sym_LT,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [141990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2040), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [142039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1917), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [142088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1895), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [142137] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4813), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [142232] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5949), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4887), 1,
      aux_sym_array_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [142331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4819), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4821), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [142380] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5355), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4774), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [142477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3361), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [142526] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4808), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [142621] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5951), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [142688] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4762), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [142783] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5951), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [142850] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5062), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [142945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2072), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2074), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [142994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1957), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [143043] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(5801), 1,
      anon_sym_in,
    ACTIONS(5803), 1,
      anon_sym_LT,
    ACTIONS(5807), 1,
      anon_sym_QMARK,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5815), 1,
      anon_sym_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5825), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5819), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5060), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(5797), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5805), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5813), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5823), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [143138] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4752), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [143233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 1,
      anon_sym_DOT,
    ACTIONS(4873), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4875), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [143284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4884), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [143333] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4742), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [143428] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4718), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [143523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4890), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [143572] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5954), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [143637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4899), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4901), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [143686] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5957), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4878), 1,
      aux_sym_array_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [143785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1907), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [143834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [143883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1877), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1879), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [143932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2050), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [143981] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5438), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2020), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 24,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2007), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2028), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2030), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2058), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2060), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4815), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4817), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144281] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5445), 1,
      anon_sym_LBRACE,
    ACTIONS(5516), 1,
      anon_sym_as,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5688), 1,
      anon_sym_in,
    ACTIONS(5690), 1,
      anon_sym_LT,
    ACTIONS(5694), 1,
      anon_sym_QMARK,
    ACTIONS(5696), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5702), 1,
      anon_sym_AMP,
    ACTIONS(5704), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5712), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4762), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5706), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5684), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5692), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5700), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5710), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [144378] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5959), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [144473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4823), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4825), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144522] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4746), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [144575] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4716), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [144670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1933), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2757), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144768] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_LT,
    STATE(4682), 1,
      sym_type_arguments,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACE_PIPE,
  [144827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4971), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4973), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4975), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [144974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4983), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [145023] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 5,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [145112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [145161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2755), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2753), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [145210] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5961), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [145277] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5961), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [145350] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [145435] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4806), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [145530] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [145605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4481), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [145654] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4841), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [145749] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 8,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [145828] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5866), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(5874), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5880), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5890), 1,
      anon_sym_as,
    ACTIONS(5892), 1,
      anon_sym_QMARK,
    ACTIONS(5894), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5884), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4774), 3,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(5868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5872), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5888), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [145923] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5961), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [145992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5043), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [146041] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4813), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [146136] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4808), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [146231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5009), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [146280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5045), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5047), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [146329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1945), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [146378] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4806), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [146473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1961), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [146522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2751), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2749), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [146571] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4841), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [146666] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5642), 1,
      anon_sym_as,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_LT,
    ACTIONS(5726), 1,
      anon_sym_QMARK,
    ACTIONS(5728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5734), 1,
      anon_sym_AMP,
    ACTIONS(5736), 1,
      anon_sym_PIPE,
    ACTIONS(5740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5744), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5730), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5738), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4774), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5718), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5732), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5742), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [146761] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(5722), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 22,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [146820] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5482), 1,
      anon_sym_in,
    ACTIONS(5484), 1,
      anon_sym_LT,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5496), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5492), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5486), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5906), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5504), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [146915] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5964), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(4928), 1,
      aux_sym_array_repeat1,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [147014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5049), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5051), 27,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [147063] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5060), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [147157] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5996), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 16,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [147223] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5999), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [147289] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4813), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [147383] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6002), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [147479] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4708), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [147573] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4718), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [147667] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4742), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [147761] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(6004), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 21,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [147819] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4752), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [147913] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6006), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [148007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5917), 1,
      sym__automatic_semicolon,
    ACTIONS(1843), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1841), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [148057] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4718), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [148151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5912), 1,
      anon_sym_DOT,
    STATE(3200), 1,
      sym_type_arguments,
    ACTIONS(4646), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [148205] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4716), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [148299] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4742), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [148393] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4752), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [148487] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [148581] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 4,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [148669] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6036), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [148735] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6036), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [148807] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [148891] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [148971] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(6039), 1,
      anon_sym_DOT,
    STATE(3200), 1,
      sym_type_arguments,
    ACTIONS(4634), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4636), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [149025] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6041), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [149121] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [149195] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6043), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [149289] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 1,
      anon_sym_LBRACK,
    ACTIONS(4726), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [149345] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6045), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [149441] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(4919), 1,
      anon_sym_LBRACK,
    ACTIONS(2765), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [149497] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6047), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [149593] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [149671] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6049), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [149765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(3202), 1,
      sym_type_arguments,
    ACTIONS(4640), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4642), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [149817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5005), 1,
      sym__automatic_semicolon,
    ACTIONS(1843), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1841), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [149867] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6036), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [149935] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6051), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [150031] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4813), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [150125] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4808), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [150219] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(6053), 1,
      anon_sym_in,
    ACTIONS(6056), 1,
      anon_sym_of,
    ACTIONS(4907), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [150273] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6058), 1,
      anon_sym_RBRACE,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [150369] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4762), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [150463] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2042), 1,
      sym__automatic_semicolon,
    ACTIONS(2034), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2038), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2040), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [150515] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1919), 1,
      sym__automatic_semicolon,
    ACTIONS(1911), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1915), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1917), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [150567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5915), 1,
      anon_sym_is,
    ACTIONS(4618), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [150617] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      sym__automatic_semicolon,
    ACTIONS(2068), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2072), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2074), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [150669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1959), 1,
      sym__automatic_semicolon,
    ACTIONS(1951), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1955), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1957), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [150721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 1,
      anon_sym_is,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [150771] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4806), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [150865] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_AMP,
    ACTIONS(6090), 1,
      anon_sym_PIPE,
    ACTIONS(6092), 1,
      anon_sym_extends,
    ACTIONS(4884), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 25,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [150919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_AMP,
    ACTIONS(5769), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [150969] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(2765), 1,
      anon_sym_extends,
    ACTIONS(4919), 1,
      anon_sym_LBRACK,
    ACTIONS(6094), 1,
      anon_sym_COLON,
    ACTIONS(4922), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5754), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1845), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [151029] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6096), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [151123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2020), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [151173] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_extends,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 1,
      anon_sym_LBRACK,
    ACTIONS(6056), 1,
      anon_sym_COLON,
    ACTIONS(4916), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5758), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4907), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [151233] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4841), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [151327] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6098), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [151423] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4774), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [151517] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6100), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [151611] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(6012), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [151669] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6102), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 18,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [151733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      sym__automatic_semicolon,
    ACTIONS(1873), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1877), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1879), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [151785] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_AMP,
    ACTIONS(6090), 1,
      anon_sym_PIPE,
    ACTIONS(6092), 1,
      anon_sym_extends,
    ACTIONS(4989), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 25,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [151839] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6105), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 16,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [151905] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6105), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 16,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [151971] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_AMP,
    ACTIONS(6090), 1,
      anon_sym_PIPE,
    ACTIONS(6092), 1,
      anon_sym_extends,
    ACTIONS(5568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 25,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [152025] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 1,
      sym__automatic_semicolon,
    ACTIONS(2001), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2005), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2007), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [152077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5023), 1,
      sym_regex_flags,
    ACTIONS(5019), 18,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
      anon_sym_extends,
    ACTIONS(5021), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [152127] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5996), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 16,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [152193] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 1,
      anon_sym_LBRACK,
    ACTIONS(4726), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [152249] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2032), 1,
      sym__automatic_semicolon,
    ACTIONS(2024), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2028), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2030), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [152301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_AMP,
    ACTIONS(6090), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [152353] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4774), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [152447] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4841), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [152541] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6108), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 18,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [152605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4939), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [152659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_extends,
    ACTIONS(4933), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [152713] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6111), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [152809] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_AMP,
    ACTIONS(6090), 1,
      anon_sym_PIPE,
    ACTIONS(6092), 1,
      anon_sym_extends,
    ACTIONS(5765), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 25,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [152863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 1,
      anon_sym_EQ,
    ACTIONS(4907), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [152913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6113), 1,
      anon_sym_EQ,
    ACTIONS(4827), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [152963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 1,
      anon_sym_EQ,
    ACTIONS(1845), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [153013] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5438), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4720), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4722), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
    ACTIONS(2020), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [153071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_AMP,
    ACTIONS(5508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 26,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [153121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2062), 1,
      sym__automatic_semicolon,
    ACTIONS(2054), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2058), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2060), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [153173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6119), 1,
      sym_regex_flags,
    ACTIONS(5019), 18,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_extends,
    ACTIONS(5021), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [153223] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_extends,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 1,
      anon_sym_LBRACK,
    ACTIONS(5758), 1,
      anon_sym_RPAREN,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(4916), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5138), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [153285] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(2765), 1,
      anon_sym_extends,
    ACTIONS(4919), 1,
      anon_sym_LBRACK,
    ACTIONS(5754), 1,
      anon_sym_RPAREN,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(4922), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5135), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [153347] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    ACTIONS(4648), 1,
      anon_sym_DOT,
    ACTIONS(6121), 1,
      anon_sym_is,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [153403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(3202), 1,
      sym_type_arguments,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [153455] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [153549] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5062), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [153643] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2052), 1,
      sym__automatic_semicolon,
    ACTIONS(2044), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2048), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2050), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [153695] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4752), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [153789] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(4919), 1,
      anon_sym_LBRACK,
    ACTIONS(2765), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [153845] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4742), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [153939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 1,
      sym__automatic_semicolon,
    ACTIONS(1927), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1931), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1933), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [153991] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4718), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [154085] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [154151] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5062), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [154245] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5060), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [154339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4907), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154389] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4806), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [154483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(1845), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    ACTIONS(4827), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154583] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(2765), 1,
      anon_sym_COMMA,
    ACTIONS(4919), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [154639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 1,
      sym__automatic_semicolon,
    ACTIONS(1975), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1979), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1981), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [154691] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4939), 1,
      anon_sym_LBRACK,
    ACTIONS(6123), 1,
      anon_sym_EQ,
    ACTIONS(6128), 1,
      anon_sym_RPAREN,
    ACTIONS(6132), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6125), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [154753] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_COMMA,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [154809] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6135), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [154905] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4841), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [154999] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6137), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [155093] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 1,
      anon_sym_EQ,
    ACTIONS(4919), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [155147] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    ACTIONS(6113), 1,
      anon_sym_in,
    ACTIONS(6139), 1,
      anon_sym_of,
    ACTIONS(4827), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [155201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 1,
      anon_sym_EQ,
    ACTIONS(4913), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [155255] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_AMP,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_extends,
    ACTIONS(5765), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [155309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_AMP,
    ACTIONS(5508), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [155359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 1,
      sym__automatic_semicolon,
    ACTIONS(1947), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1945), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [155409] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5635), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [155503] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5594), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [155597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 1,
      sym_regex_flags,
    ACTIONS(5019), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(5021), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [155647] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6149), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [155743] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    STATE(3280), 1,
      sym_arguments,
    ACTIONS(4612), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4614), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [155795] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4808), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [155889] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4762), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [155983] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_AMP,
    ACTIONS(6090), 1,
      anon_sym_PIPE,
    ACTIONS(6092), 1,
      anon_sym_extends,
    ACTIONS(4959), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 25,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [156037] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4813), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [156131] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5999), 1,
      anon_sym_LT,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 15,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [156199] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4716), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [156293] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 4,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [156381] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [156459] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6151), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 16,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [156525] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6151), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 12,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [156597] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 12,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [156671] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [156751] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [156835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_AMP,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_extends,
    ACTIONS(4884), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [156889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_AMP,
    ACTIONS(5769), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [156939] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [157023] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [157103] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 12,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [157177] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5999), 1,
      anon_sym_LT,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 12,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [157249] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6154), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [157345] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_AMP,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_extends,
    ACTIONS(5568), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [157399] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 7,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
  [157477] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 4,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_extends,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [157565] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6151), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 15,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_extends,
  [157633] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4808), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [157727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_AMP,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_extends,
    ACTIONS(4989), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [157781] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4806), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [157875] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(5970), 1,
      anon_sym_in,
    ACTIONS(5972), 1,
      anon_sym_LT,
    ACTIONS(5976), 1,
      anon_sym_QMARK,
    ACTIONS(5978), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5984), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_PIPE,
    ACTIONS(5990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5994), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4774), 2,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5980), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5988), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5966), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5974), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5982), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5992), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [157969] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_AMP,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [158021] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(5972), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 21,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_extends,
  [158079] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6156), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [158175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 1,
      anon_sym_is,
    ACTIONS(4618), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [158225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(6094), 1,
      anon_sym_of,
    ACTIONS(6116), 1,
      anon_sym_in,
    ACTIONS(1845), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [158279] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4708), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [158373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4644), 1,
      sym__automatic_semicolon,
    ACTIONS(1843), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1841), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [158423] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6004), 1,
      anon_sym_LT,
    ACTIONS(6062), 1,
      anon_sym_as,
    ACTIONS(6064), 1,
      anon_sym_in,
    ACTIONS(6068), 1,
      anon_sym_QMARK,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_AMP,
    ACTIONS(6078), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6086), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4716), 2,
      anon_sym_EQ_GT,
      anon_sym_extends,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6072), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6080), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6060), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6066), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6074), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6084), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [158517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6158), 1,
      anon_sym_LBRACE,
    STATE(3148), 1,
      sym_statement_block,
    ACTIONS(1859), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1857), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [158569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6158), 1,
      anon_sym_LBRACE,
    ACTIONS(6160), 1,
      anon_sym_DOT,
    STATE(3148), 1,
      sym_statement_block,
    ACTIONS(1859), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1857), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [158623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1973), 1,
      sym__automatic_semicolon,
    ACTIONS(1965), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1969), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1971), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [158675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 1,
      anon_sym_LT,
    ACTIONS(5130), 1,
      anon_sym_DOT,
    ACTIONS(6162), 1,
      anon_sym_is,
    STATE(2352), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [158731] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6164), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [158827] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_AMP,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_extends,
    ACTIONS(4959), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [158881] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6166), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [158945] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5060), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [159039] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5799), 1,
      anon_sym_as,
    ACTIONS(6010), 1,
      anon_sym_in,
    ACTIONS(6012), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_QMARK,
    ACTIONS(6018), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_PIPE,
    ACTIONS(6030), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6034), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5062), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6020), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6028), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6008), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6014), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6022), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6032), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [159133] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6169), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [159199] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6169), 1,
      anon_sym_LT,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4686), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [159265] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6172), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [159361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [159415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(4919), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [159469] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_extends,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [159525] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(2765), 1,
      anon_sym_extends,
    ACTIONS(4919), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [159581] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4772), 1,
      anon_sym_as,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5147), 1,
      anon_sym_in,
    ACTIONS(5149), 1,
      anon_sym_LT,
    ACTIONS(5153), 1,
      anon_sym_QMARK,
    ACTIONS(5155), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    ACTIONS(5167), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5171), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(6174), 1,
      anon_sym_RPAREN,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5165), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5145), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5151), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5169), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [159677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5795), 1,
      anon_sym_is,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [159727] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6180), 1,
      anon_sym_COLON,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [159820] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym_AMP,
    ACTIONS(6208), 1,
      anon_sym_PIPE,
    ACTIONS(6210), 1,
      anon_sym_extends,
    ACTIONS(5765), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [159873] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    ACTIONS(4648), 1,
      anon_sym_DOT,
    ACTIONS(6212), 1,
      anon_sym_is,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [159928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6214), 1,
      anon_sym_AMP,
    ACTIONS(6216), 1,
      anon_sym_PIPE,
    ACTIONS(6218), 1,
      anon_sym_extends,
    ACTIONS(5765), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [159981] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(6053), 1,
      anon_sym_QMARK,
    ACTIONS(5138), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4907), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [160034] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4762), 1,
      anon_sym_COLON,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [160127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6214), 1,
      anon_sym_AMP,
    ACTIONS(5508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [160176] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4495), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [160249] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4495), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [160324] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4495), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [160395] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4716), 1,
      anon_sym_COLON,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [160488] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4667), 3,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [160575] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6242), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 15,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [160640] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6242), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 11,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [160711] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 5,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [160794] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_LBRACK,
    ACTIONS(4620), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [160847] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 1,
      anon_sym_LBRACK,
    ACTIONS(5013), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [160900] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [160979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6214), 1,
      anon_sym_AMP,
    ACTIONS(6216), 1,
      anon_sym_PIPE,
    ACTIONS(6218), 1,
      anon_sym_extends,
    ACTIONS(4959), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [161032] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 11,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [161105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4957), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [161152] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6245), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [161245] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_LBRACK,
    ACTIONS(4620), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [161298] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [161375] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6242), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 14,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [161442] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4808), 1,
      anon_sym_COLON,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [161535] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    ACTIONS(6113), 1,
      anon_sym_QMARK,
    ACTIONS(5074), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4827), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [161588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6119), 1,
      sym_regex_flags,
    ACTIONS(5019), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(5021), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [161637] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4806), 1,
      anon_sym_COLON,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [161730] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4774), 1,
      anon_sym_COLON,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [161823] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(6182), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 20,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [161880] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6249), 1,
      anon_sym_RBRACE,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3308), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [161965] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [162038] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [162113] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(6240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [162184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4845), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [162231] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4510), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [162302] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4510), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [162377] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6265), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3088), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [162462] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(2765), 1,
      anon_sym_extends,
    ACTIONS(4919), 1,
      anon_sym_LBRACK,
    ACTIONS(5754), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4922), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [162519] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_extends,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(4913), 1,
      anon_sym_LBRACK,
    ACTIONS(5758), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4916), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [162576] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6214), 1,
      anon_sym_AMP,
    ACTIONS(6216), 1,
      anon_sym_PIPE,
    ACTIONS(6218), 1,
      anon_sym_extends,
    ACTIONS(5568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [162629] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6267), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3308), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [162714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6214), 1,
      anon_sym_AMP,
    ACTIONS(6216), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [162765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4746), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [162816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(5135), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1845), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [162869] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6214), 1,
      anon_sym_AMP,
    ACTIONS(6216), 1,
      anon_sym_PIPE,
    ACTIONS(6218), 1,
      anon_sym_extends,
    ACTIONS(4989), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [162922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6214), 1,
      anon_sym_AMP,
    ACTIONS(5769), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [162971] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6214), 1,
      anon_sym_AMP,
    ACTIONS(6216), 1,
      anon_sym_PIPE,
    ACTIONS(6218), 1,
      anon_sym_extends,
    ACTIONS(4884), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [163024] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6269), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [163117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6162), 1,
      anon_sym_is,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [163166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4819), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4821), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [163213] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6271), 1,
      anon_sym_LPAREN,
    ACTIONS(6274), 1,
      anon_sym_COLON,
    ACTIONS(6276), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [163266] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4504), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [163339] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4504), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [163414] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4504), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [163485] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6279), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 15,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [163550] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6282), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [163643] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6279), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 15,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [163708] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5062), 1,
      anon_sym_COLON,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [163801] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5060), 1,
      anon_sym_COLON,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [163894] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6284), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [163987] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6286), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 17,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [164050] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6289), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3308), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [164135] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6291), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3120), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [164220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2040), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [164267] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 1,
      anon_sym_LBRACK,
    ACTIONS(5013), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [164320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym_AMP,
    ACTIONS(6208), 1,
      anon_sym_PIPE,
    ACTIONS(6210), 1,
      anon_sym_extends,
    ACTIONS(4884), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [164373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym_AMP,
    ACTIONS(5769), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [164422] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym_AMP,
    ACTIONS(6208), 1,
      anon_sym_PIPE,
    ACTIONS(6210), 1,
      anon_sym_extends,
    ACTIONS(4989), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [164475] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym_AMP,
    ACTIONS(6208), 1,
      anon_sym_PIPE,
    ACTIONS(6210), 1,
      anon_sym_extends,
    ACTIONS(5568), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [164528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 1,
      anon_sym_EQ,
    ACTIONS(6132), 1,
      anon_sym_QMARK,
    ACTIONS(6125), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [164581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym_AMP,
    ACTIONS(6208), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [164632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2066), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2064), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [164679] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6293), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [164772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1933), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [164819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1917), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [164866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5027), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [164913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2072), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2074), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [164960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1957), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [165007] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4489), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [165080] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6295), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [165173] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4489), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [165248] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4489), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(6240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [165319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2007), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [165366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2203), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [165413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5013), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [165460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [165507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2028), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2030), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [165554] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6297), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3193), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [165639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4736), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [165688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1997), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [165735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2765), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [165782] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6305), 1,
      anon_sym_RBRACK,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [165875] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6331), 1,
      anon_sym_LPAREN,
    ACTIONS(6334), 1,
      anon_sym_COLON,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(5015), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5017), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [165928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2058), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2060), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [165975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4815), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4817), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4720), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4722), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4724), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4726), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4736), 1,
      anon_sym_extends,
    ACTIONS(6299), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4728), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4730), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [166169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4738), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4740), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym_AMP,
    ACTIONS(5508), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4746), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4754), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4756), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4640), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4642), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1869), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4823), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4825), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2761), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4865), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4869), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4884), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4890), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4899), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4901), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1969), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1971), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166829] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6339), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [166922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1907), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [166969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2757), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167016] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6341), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [167109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4971), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4973), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4975), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167203] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4510), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [167276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4983), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2755), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2753), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5009), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2751), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2749), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2050), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167558] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6343), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3308), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [167643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1899), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4657), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4659), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4835), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4837), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4839), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1961), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1945), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [167925] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 1,
      anon_sym_AMP,
    ACTIONS(6347), 1,
      anon_sym_PIPE,
    ACTIONS(6349), 1,
      anon_sym_extends,
    ACTIONS(4884), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [167978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 1,
      anon_sym_AMP,
    ACTIONS(5769), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [168027] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6351), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3308), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [168112] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6353), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [168205] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 1,
      anon_sym_AMP,
    ACTIONS(6347), 1,
      anon_sym_PIPE,
    ACTIONS(6349), 1,
      anon_sym_extends,
    ACTIONS(4989), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [168258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      anon_sym_AMP,
    ACTIONS(6357), 1,
      anon_sym_PIPE,
    ACTIONS(6359), 1,
      anon_sym_extends,
    ACTIONS(5568), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [168311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      anon_sym_AMP,
    ACTIONS(6357), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [168362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      anon_sym_AMP,
    ACTIONS(6357), 1,
      anon_sym_PIPE,
    ACTIONS(6359), 1,
      anon_sym_extends,
    ACTIONS(4989), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [168415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      anon_sym_AMP,
    ACTIONS(5769), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [168464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4750), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [168511] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      anon_sym_AMP,
    ACTIONS(6357), 1,
      anon_sym_PIPE,
    ACTIONS(6359), 1,
      anon_sym_extends,
    ACTIONS(4884), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [168564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4760), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [168611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3361), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [168658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1895), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [168705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1923), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1921), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [168752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 1,
      anon_sym_AMP,
    ACTIONS(6347), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [168803] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6361), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3184), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [168888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 1,
      anon_sym_DOT,
    ACTIONS(4873), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4875), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [168937] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 1,
      anon_sym_AMP,
    ACTIONS(6347), 1,
      anon_sym_PIPE,
    ACTIONS(6349), 1,
      anon_sym_extends,
    ACTIONS(5568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [168990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3355), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [169037] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6363), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [169130] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6365), 1,
      anon_sym_RBRACK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [169223] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 1,
      anon_sym_AMP,
    ACTIONS(6347), 1,
      anon_sym_PIPE,
    ACTIONS(6349), 1,
      anon_sym_extends,
    ACTIONS(4959), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [169276] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4746), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [169327] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6367), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [169420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3365), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [169467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 1,
      anon_sym_EQ,
    ACTIONS(4907), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [169516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6113), 1,
      anon_sym_EQ,
    ACTIONS(4827), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [169565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 1,
      anon_sym_EQ,
    ACTIONS(1845), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [169614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1877), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1879), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [169661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5922), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4722), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4720), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2020), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [169718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4853), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [169765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4752), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [169812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [169859] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4501), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [169932] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4501), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [170007] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4501), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(6240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [170078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4861), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [170125] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    ACTIONS(6139), 1,
      anon_sym_COLON,
    ACTIONS(5074), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4827), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [170178] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4572), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4722), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4720), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2020), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [170235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4718), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [170282] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 1,
      anon_sym_COMMA,
    ACTIONS(4939), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [170335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4880), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4882), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [170382] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4572), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4720), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4722), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(2020), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [170439] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4446), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [170510] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_COMMA,
    ACTIONS(4933), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [170563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4663), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [170610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 1,
      anon_sym_is,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [170659] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4446), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [170734] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4446), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [170807] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6369), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [170900] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5922), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4720), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4722), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [170953] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(6307), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4766), 20,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [171010] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4774), 1,
      anon_sym_RBRACK,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [171103] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6371), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [171196] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4806), 1,
      anon_sym_RBRACK,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [171289] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4808), 1,
      anon_sym_RBRACK,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [171382] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6373), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 14,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [171449] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 5,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [171526] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 11,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [171599] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4939), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [171652] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 4,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4667), 6,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [171731] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 1,
      anon_sym_EQ,
    ACTIONS(4919), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1845), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [171784] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 3,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4667), 5,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [171867] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 1,
      anon_sym_EQ,
    ACTIONS(4913), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4916), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4907), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [171920] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6373), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4669), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 11,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [171991] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6373), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 15,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [172056] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6376), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3308), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [172141] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4669), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4667), 3,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [172228] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4716), 1,
      anon_sym_RBRACK,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [172321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 1,
      anon_sym_AMP,
    ACTIONS(5508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [172370] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 1,
      anon_sym_AMP,
    ACTIONS(6347), 1,
      anon_sym_PIPE,
    ACTIONS(6349), 1,
      anon_sym_extends,
    ACTIONS(5765), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [172423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_extends,
    ACTIONS(4933), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [172476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4942), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [172527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4905), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [172574] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4762), 1,
      anon_sym_RBRACK,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [172667] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4936), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [172718] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6378), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [172811] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4841), 1,
      anon_sym_RBRACK,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [172904] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6380), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [172997] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4813), 1,
      anon_sym_RBRACK,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [173090] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4841), 1,
      anon_sym_COLON,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [173183] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4708), 1,
      anon_sym_RBRACK,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [173276] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6382), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [173369] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4718), 1,
      anon_sym_RBRACK,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [173462] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4813), 1,
      anon_sym_COLON,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [173555] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4742), 1,
      anon_sym_RBRACK,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [173648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [173695] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4752), 1,
      anon_sym_RBRACK,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [173788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4849), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [173835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [173882] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6384), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [173975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4931), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [174022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4708), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [174069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4947), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4949), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [174116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      anon_sym_AMP,
    ACTIONS(6357), 1,
      anon_sym_PIPE,
    ACTIONS(6359), 1,
      anon_sym_extends,
    ACTIONS(5765), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [174169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      anon_sym_AMP,
    ACTIONS(5508), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [174218] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4708), 1,
      anon_sym_COLON,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [174311] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6386), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3308), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [174396] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4718), 1,
      anon_sym_COLON,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [174489] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4742), 1,
      anon_sym_COLON,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [174582] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4752), 1,
      anon_sym_COLON,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [174675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4953), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [174722] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4498), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [174793] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4498), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [174868] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4498), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [174941] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      anon_sym_AMP,
    ACTIONS(6357), 1,
      anon_sym_PIPE,
    ACTIONS(6359), 1,
      anon_sym_extends,
    ACTIONS(4959), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [174994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_extends,
    ACTIONS(4933), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(4936), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [175047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5922), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2020), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175100] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      anon_sym_AMP,
    ACTIONS(6208), 1,
      anon_sym_PIPE,
    ACTIONS(6210), 1,
      anon_sym_extends,
    ACTIONS(4959), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [175153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4963), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4813), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4965), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4967), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175294] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6388), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [175387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4977), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4979), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4987), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175528] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6393), 1,
      anon_sym_STAR,
    ACTIONS(6396), 1,
      anon_sym_RBRACE,
    ACTIONS(6398), 1,
      anon_sym_LBRACK,
    ACTIONS(6401), 1,
      anon_sym_async,
    ACTIONS(6404), 1,
      anon_sym_DASH,
    ACTIONS(6407), 1,
      anon_sym_DQUOTE,
    ACTIONS(6410), 1,
      anon_sym_SQUOTE,
    ACTIONS(6413), 1,
      sym_number,
    ACTIONS(6416), 1,
      anon_sym_AT,
    ACTIONS(6419), 1,
      anon_sym_declare,
    ACTIONS(6422), 1,
      anon_sym_static,
    ACTIONS(6425), 1,
      anon_sym_readonly,
    ACTIONS(6428), 1,
      anon_sym_abstract,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6431), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3308), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(6434), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(6390), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [175613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1981), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4995), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4997), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4999), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5003), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5023), 1,
      sym_regex_flags,
    ACTIONS(5019), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
    ACTIONS(5021), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [175850] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_LT,
    ACTIONS(4648), 1,
      anon_sym_DOT,
    ACTIONS(6437), 1,
      anon_sym_is,
    STATE(2066), 1,
      sym_type_arguments,
    ACTIONS(4646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3642), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [175905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4481), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [175952] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6439), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 15,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [176017] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6439), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 15,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [176082] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6442), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3099), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [176167] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5062), 1,
      anon_sym_RBRACK,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [176260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5045), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5047), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [176307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5043), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [176354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [176401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5035), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4841), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [176448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5031), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5033), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [176495] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5060), 1,
      anon_sym_RBRACK,
    ACTIONS(5968), 1,
      anon_sym_as,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6307), 1,
      anon_sym_LT,
    ACTIONS(6311), 1,
      anon_sym_QMARK,
    ACTIONS(6313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6319), 1,
      anon_sym_AMP,
    ACTIONS(6321), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6329), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6301), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6309), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6317), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6327), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [176588] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6444), 1,
      anon_sym_LT,
    STATE(4590), 1,
      sym_type_arguments,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 17,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [176651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5049), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5051), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [176698] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6447), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3289), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [176783] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6449), 1,
      anon_sym_COLON,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [176876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5015), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5017), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [176923] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4492), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [176996] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4492), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [177071] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      anon_sym_DASH,
    ACTIONS(4521), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_STAR,
    ACTIONS(6251), 1,
      anon_sym_async,
    ACTIONS(6253), 1,
      sym_number,
    ACTIONS(6255), 1,
      anon_sym_declare,
    ACTIONS(6257), 1,
      anon_sym_static,
    ACTIONS(6259), 1,
      anon_sym_readonly,
    ACTIONS(6261), 1,
      anon_sym_abstract,
    ACTIONS(6451), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_method_definition,
    STATE(3610), 1,
      sym_accessibility_modifier,
    ACTIONS(6263), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3258), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3688), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4859), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4513), 10,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [177156] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4492), 1,
      anon_sym_RBRACE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(6240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [177227] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4504), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [177293] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [177359] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 1,
      anon_sym_AMP,
    ACTIONS(6455), 1,
      anon_sym_PIPE,
    ACTIONS(6457), 1,
      anon_sym_extends,
    ACTIONS(4989), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [177411] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_AMP,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6463), 1,
      anon_sym_extends,
    ACTIONS(5765), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [177463] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4495), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [177529] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_AMP,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6463), 1,
      anon_sym_extends,
    ACTIONS(4959), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [177581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_extends,
    ACTIONS(4933), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(4936), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [177633] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4446), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [177699] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 1,
      anon_sym_DOT,
    ACTIONS(4680), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4710), 1,
      anon_sym_BANG,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4553), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2375), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [177789] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 1,
      anon_sym_AMP,
    ACTIONS(6455), 1,
      anon_sym_PIPE,
    ACTIONS(6457), 1,
      anon_sym_extends,
    ACTIONS(5568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [177841] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4492), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [177907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 1,
      anon_sym_AMP,
    ACTIONS(6455), 1,
      anon_sym_PIPE,
    ACTIONS(6457), 1,
      anon_sym_extends,
    ACTIONS(4884), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [177959] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4547), 1,
      anon_sym_COMMA,
    ACTIONS(4550), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6465), 1,
      anon_sym_STAR,
    ACTIONS(6467), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(6469), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4116), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [178027] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4547), 1,
      anon_sym_COMMA,
    ACTIONS(4550), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6465), 1,
      anon_sym_STAR,
    ACTIONS(6471), 1,
      anon_sym_async,
    ACTIONS(6473), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(6475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3696), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [178097] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4547), 1,
      anon_sym_COMMA,
    ACTIONS(4550), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6465), 1,
      anon_sym_STAR,
    ACTIONS(6471), 1,
      anon_sym_async,
    ACTIONS(6473), 1,
      sym_number,
    ACTIONS(6477), 1,
      anon_sym_readonly,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(6475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3696), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [178169] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4501), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [178235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4746), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [178285] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4776), 1,
      anon_sym_BANG,
    ACTIONS(4782), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4590), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2198), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [178375] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4510), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [178441] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4746), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [178491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 1,
      anon_sym_AMP,
    ACTIONS(6455), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [178541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_AMP,
    ACTIONS(5508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [178589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 1,
      anon_sym_AMP,
    ACTIONS(5508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [178637] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_extends,
    ACTIONS(4936), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4933), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [178689] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(5087), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_DOT,
    ACTIONS(5095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4630), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2848), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [178779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 1,
      anon_sym_AMP,
    ACTIONS(5769), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [178827] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4498), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [178893] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5518), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_LBRACK,
    ACTIONS(5530), 1,
      anon_sym_DOT,
    ACTIONS(5532), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5601), 1,
      anon_sym_as,
    ACTIONS(6178), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_LT,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6194), 1,
      anon_sym_AMP,
    ACTIONS(6196), 1,
      anon_sym_PIPE,
    ACTIONS(6200), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6204), 1,
      anon_sym_QMARK_QMARK,
    STATE(4682), 1,
      sym_type_arguments,
    ACTIONS(4804), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(6198), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3322), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6176), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(6184), 3,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6192), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(6202), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [178983] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(5138), 1,
      anon_sym_RBRACK,
    ACTIONS(6056), 1,
      anon_sym_COMMA,
    ACTIONS(4907), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179035] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_AMP,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6463), 1,
      anon_sym_extends,
    ACTIONS(4884), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6437), 1,
      anon_sym_is,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 23,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [179135] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    ACTIONS(5074), 1,
      anon_sym_RBRACK,
    ACTIONS(6139), 1,
      anon_sym_COMMA,
    ACTIONS(4827), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4939), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(4942), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3573), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179239] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 1,
      anon_sym_DOT,
    ACTIONS(4572), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4720), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4722), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2020), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2022), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_AMP,
    ACTIONS(5769), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [179343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_AMP,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6463), 1,
      anon_sym_extends,
    ACTIONS(4989), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179395] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_AMP,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [179445] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(5135), 1,
      anon_sym_RBRACK,
    ACTIONS(6094), 1,
      anon_sym_COMMA,
    ACTIONS(1845), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179497] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 1,
      anon_sym_AMP,
    ACTIONS(6455), 1,
      anon_sym_PIPE,
    ACTIONS(6457), 1,
      anon_sym_extends,
    ACTIONS(5765), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179549] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4489), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [179615] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_AMP,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6463), 1,
      anon_sym_extends,
    ACTIONS(5568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179667] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4942), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4939), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6212), 1,
      anon_sym_is,
    ACTIONS(4618), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4620), 23,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [179767] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 1,
      anon_sym_AMP,
    ACTIONS(6455), 1,
      anon_sym_PIPE,
    ACTIONS(6457), 1,
      anon_sym_extends,
    ACTIONS(4959), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      anon_sym_AMP,
    ACTIONS(5508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 23,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [179866] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_EQ,
    ACTIONS(6053), 1,
      anon_sym_in,
    ACTIONS(6056), 1,
      anon_sym_of,
    ACTIONS(4907), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4911), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [179917] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(6485), 1,
      anon_sym_RBRACE,
    ACTIONS(6487), 1,
      sym_number,
    STATE(4708), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4710), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(5453), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(6481), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [179984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_AMP,
    ACTIONS(6491), 1,
      anon_sym_PIPE,
    ACTIONS(6493), 1,
      anon_sym_extends,
    ACTIONS(5765), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [180035] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6495), 1,
      anon_sym_STAR,
    ACTIONS(6497), 1,
      anon_sym_async,
    ACTIONS(6499), 1,
      sym_number,
    ACTIONS(6501), 1,
      anon_sym_abstract,
    ACTIONS(6503), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3680), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [180098] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      anon_sym_AMP,
    ACTIONS(6505), 1,
      anon_sym_PIPE,
    ACTIONS(6507), 1,
      anon_sym_extends,
    ACTIONS(5568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [180149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      anon_sym_AMP,
    ACTIONS(6505), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 23,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [180198] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      anon_sym_AMP,
    ACTIONS(6505), 1,
      anon_sym_PIPE,
    ACTIONS(6507), 1,
      anon_sym_extends,
    ACTIONS(4989), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [180249] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(6487), 1,
      sym_number,
    ACTIONS(6511), 1,
      anon_sym_RBRACE,
    STATE(4917), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4923), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(5453), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(6509), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [180316] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    ACTIONS(6113), 1,
      anon_sym_in,
    ACTIONS(6139), 1,
      anon_sym_of,
    ACTIONS(4827), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [180367] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_EQ,
    ACTIONS(6094), 1,
      anon_sym_of,
    ACTIONS(6116), 1,
      anon_sym_in,
    ACTIONS(1845), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1849), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [180418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      anon_sym_AMP,
    ACTIONS(5769), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 23,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [180465] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(4576), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [180530] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      anon_sym_AMP,
    ACTIONS(6505), 1,
      anon_sym_PIPE,
    ACTIONS(6507), 1,
      anon_sym_extends,
    ACTIONS(4884), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [180581] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    ACTIONS(4576), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [180648] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    ACTIONS(4576), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(6240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [180711] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6513), 1,
      sym_number,
    ACTIONS(6515), 1,
      anon_sym_static,
    ACTIONS(6517), 1,
      anon_sym_readonly,
    ACTIONS(6519), 1,
      anon_sym_abstract,
    STATE(3619), 1,
      sym_accessibility_modifier,
    ACTIONS(4533), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3856), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4513), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [180776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      anon_sym_AMP,
    ACTIONS(6505), 1,
      anon_sym_PIPE,
    ACTIONS(6507), 1,
      anon_sym_extends,
    ACTIONS(5765), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [180827] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6521), 1,
      anon_sym_RPAREN,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      sym_this,
    ACTIONS(6527), 1,
      anon_sym_readonly,
    STATE(3555), 1,
      aux_sym_export_statement_repeat1,
    STATE(3606), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3990), 2,
      sym_pattern,
      sym__parameter_name,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5194), 3,
      sym__formal_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [180900] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      sym_this,
    ACTIONS(6527), 1,
      anon_sym_readonly,
    ACTIONS(6529), 1,
      anon_sym_RPAREN,
    STATE(3555), 1,
      aux_sym_export_statement_repeat1,
    STATE(3606), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3990), 2,
      sym_pattern,
      sym__parameter_name,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5194), 3,
      sym__formal_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [180973] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      sym_this,
    ACTIONS(6527), 1,
      anon_sym_readonly,
    ACTIONS(6531), 1,
      anon_sym_RPAREN,
    STATE(3555), 1,
      aux_sym_export_statement_repeat1,
    STATE(3606), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3990), 2,
      sym_pattern,
      sym__parameter_name,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4754), 3,
      sym__formal_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181046] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      sym_this,
    ACTIONS(6527), 1,
      anon_sym_readonly,
    ACTIONS(6533), 1,
      anon_sym_RPAREN,
    STATE(3555), 1,
      aux_sym_export_statement_repeat1,
    STATE(3606), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3990), 2,
      sym_pattern,
      sym__parameter_name,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5194), 3,
      sym__formal_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181119] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      sym_this,
    ACTIONS(6527), 1,
      anon_sym_readonly,
    ACTIONS(6535), 1,
      anon_sym_RPAREN,
    STATE(3555), 1,
      aux_sym_export_statement_repeat1,
    STATE(3606), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3990), 2,
      sym_pattern,
      sym__parameter_name,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5194), 3,
      sym__formal_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181192] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      sym_this,
    ACTIONS(6527), 1,
      anon_sym_readonly,
    ACTIONS(6537), 1,
      anon_sym_RPAREN,
    STATE(3555), 1,
      aux_sym_export_statement_repeat1,
    STATE(3606), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3990), 2,
      sym_pattern,
      sym__parameter_name,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5194), 3,
      sym__formal_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181265] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6465), 1,
      anon_sym_STAR,
    ACTIONS(6471), 1,
      anon_sym_async,
    ACTIONS(6473), 1,
      sym_number,
    ACTIONS(4557), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(6475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3696), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181330] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6465), 1,
      anon_sym_STAR,
    ACTIONS(6471), 1,
      anon_sym_async,
    ACTIONS(6473), 1,
      sym_number,
    ACTIONS(6477), 1,
      anon_sym_readonly,
    ACTIONS(4557), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(6475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3696), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181397] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6465), 1,
      anon_sym_STAR,
    ACTIONS(6467), 1,
      sym_number,
    ACTIONS(4557), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(6469), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4116), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181460] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6539), 1,
      anon_sym_STAR,
    ACTIONS(6541), 1,
      anon_sym_async,
    ACTIONS(6543), 1,
      sym_number,
    ACTIONS(6545), 1,
      anon_sym_abstract,
    ACTIONS(6547), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3690), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181523] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      sym_this,
    ACTIONS(6527), 1,
      anon_sym_readonly,
    ACTIONS(6549), 1,
      anon_sym_RPAREN,
    STATE(3555), 1,
      aux_sym_export_statement_repeat1,
    STATE(3606), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3990), 2,
      sym_pattern,
      sym__parameter_name,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5194), 3,
      sym__formal_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181596] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      anon_sym_AMP,
    ACTIONS(6505), 1,
      anon_sym_PIPE,
    ACTIONS(6507), 1,
      anon_sym_extends,
    ACTIONS(4959), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [181647] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(651), 1,
      anon_sym_RPAREN,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      sym_this,
    ACTIONS(6527), 1,
      anon_sym_readonly,
    STATE(3555), 1,
      aux_sym_export_statement_repeat1,
    STATE(3606), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3990), 2,
      sym_pattern,
      sym__parameter_name,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4828), 3,
      sym__formal_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181720] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(4547), 1,
      anon_sym_COMMA,
    ACTIONS(4550), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6467), 1,
      sym_number,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4116), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_AMP,
    ACTIONS(6491), 1,
      anon_sym_PIPE,
    ACTIONS(6493), 1,
      anon_sym_extends,
    ACTIONS(4884), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [181834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_AMP,
    ACTIONS(5769), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5771), 23,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [181881] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      sym_this,
    ACTIONS(6527), 1,
      anon_sym_readonly,
    ACTIONS(6551), 1,
      anon_sym_RPAREN,
    STATE(3555), 1,
      aux_sym_export_statement_repeat1,
    STATE(3606), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3990), 2,
      sym_pattern,
      sym__parameter_name,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4858), 3,
      sym__formal_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [181954] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_AMP,
    ACTIONS(6491), 1,
      anon_sym_PIPE,
    ACTIONS(6493), 1,
      anon_sym_extends,
    ACTIONS(4989), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [182005] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_AMP,
    ACTIONS(6491), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 23,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [182054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_AMP,
    ACTIONS(6491), 1,
      anon_sym_PIPE,
    ACTIONS(6493), 1,
      anon_sym_extends,
    ACTIONS(5568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5570), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [182105] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_AMP,
    ACTIONS(6491), 1,
      anon_sym_PIPE,
    ACTIONS(6493), 1,
      anon_sym_extends,
    ACTIONS(4959), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [182156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_AMP,
    ACTIONS(5508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 23,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [182203] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2291), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182275] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182347] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4504), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182403] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4489), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182459] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2295), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182527] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2295), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182597] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4501), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182653] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6224), 1,
      anon_sym_LBRACK,
    ACTIONS(6465), 1,
      anon_sym_STAR,
    ACTIONS(6471), 1,
      anon_sym_async,
    ACTIONS(6473), 1,
      sym_number,
    ACTIONS(6475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3696), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182713] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6495), 1,
      anon_sym_STAR,
    ACTIONS(6497), 1,
      anon_sym_async,
    ACTIONS(6499), 1,
      sym_number,
    ACTIONS(6503), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3680), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182773] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6495), 1,
      anon_sym_STAR,
    ACTIONS(6555), 1,
      sym_number,
    ACTIONS(6557), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4172), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182831] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    ACTIONS(4576), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182889] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6559), 1,
      anon_sym_STAR,
    ACTIONS(6561), 1,
      anon_sym_async,
    ACTIONS(6563), 1,
      sym_number,
    ACTIONS(6565), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3706), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [182949] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6465), 1,
      anon_sym_STAR,
    ACTIONS(6471), 1,
      anon_sym_async,
    ACTIONS(6473), 1,
      sym_number,
    ACTIONS(6477), 1,
      anon_sym_readonly,
    ACTIONS(6475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3696), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183057] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6465), 1,
      anon_sym_STAR,
    ACTIONS(6467), 1,
      sym_number,
    ACTIONS(6469), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4116), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183115] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6559), 1,
      anon_sym_STAR,
    ACTIONS(6561), 1,
      anon_sym_async,
    ACTIONS(6563), 1,
      sym_number,
    ACTIONS(6567), 1,
      anon_sym_readonly,
    ACTIONS(6565), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3706), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183177] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6569), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183247] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6569), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183319] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6569), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183387] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4498), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183443] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6559), 1,
      anon_sym_STAR,
    ACTIONS(6571), 1,
      sym_number,
    ACTIONS(6573), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4226), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183501] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6495), 1,
      anon_sym_STAR,
    ACTIONS(6497), 1,
      anon_sym_async,
    ACTIONS(6499), 1,
      sym_number,
    ACTIONS(6575), 1,
      anon_sym_readonly,
    ACTIONS(6503), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3680), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183563] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2287), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183631] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2287), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183703] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6577), 1,
      anon_sym_STAR,
    ACTIONS(6579), 1,
      sym_number,
    ACTIONS(6581), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4224), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183761] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2287), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183831] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2293), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183899] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      sym_number,
    ACTIONS(6587), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4222), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [183957] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2293), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184029] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2293), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184099] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2285), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184167] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2285), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184239] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2291), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184307] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2285), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184377] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2291), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184447] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      sym_this,
    ACTIONS(6527), 1,
      anon_sym_readonly,
    STATE(3555), 1,
      aux_sym_export_statement_repeat1,
    STATE(3606), 1,
      sym_accessibility_modifier,
    STATE(3633), 1,
      sym_decorator,
    STATE(3990), 2,
      sym_pattern,
      sym__parameter_name,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5194), 3,
      sym__formal_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184517] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2295), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184589] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184659] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6589), 1,
      anon_sym_STAR,
    ACTIONS(6591), 1,
      anon_sym_async,
    ACTIONS(6593), 1,
      sym_number,
    ACTIONS(6595), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3687), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184719] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184791] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6597), 1,
      anon_sym_STAR,
    ACTIONS(6599), 1,
      sym_number,
    ACTIONS(6601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4112), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184849] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6589), 1,
      anon_sym_STAR,
    ACTIONS(6603), 1,
      sym_number,
    ACTIONS(6605), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184907] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6607), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [184975] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      sym_number,
    ACTIONS(6613), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4145), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185033] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4492), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185089] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185157] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6607), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185229] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6615), 1,
      anon_sym_STAR,
    ACTIONS(6617), 1,
      sym_number,
    ACTIONS(6619), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4119), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185287] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6607), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185357] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6621), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185427] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4510), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185483] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6621), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185555] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6621), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185623] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6539), 1,
      anon_sym_STAR,
    ACTIONS(6541), 1,
      anon_sym_async,
    ACTIONS(6543), 1,
      sym_number,
    ACTIONS(6623), 1,
      anon_sym_readonly,
    ACTIONS(6547), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3690), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185685] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LBRACK,
    ACTIONS(6487), 1,
      sym_number,
    ACTIONS(4416), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5132), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5346), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(5453), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(6625), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185747] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185815] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185885] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4446), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185941] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [185997] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6627), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186065] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6577), 1,
      anon_sym_STAR,
    ACTIONS(6629), 1,
      anon_sym_async,
    ACTIONS(6631), 1,
      sym_number,
    ACTIONS(6633), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186125] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6539), 1,
      anon_sym_STAR,
    ACTIONS(6635), 1,
      sym_number,
    ACTIONS(6637), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4155), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186183] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6639), 1,
      anon_sym_async,
    ACTIONS(6641), 1,
      sym_number,
    ACTIONS(6643), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3692), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186243] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6467), 1,
      sym_number,
    ACTIONS(4557), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4116), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186301] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6645), 1,
      anon_sym_STAR,
    ACTIONS(6647), 1,
      sym_number,
    ACTIONS(6649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4219), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186359] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6645), 1,
      anon_sym_STAR,
    ACTIONS(6651), 1,
      anon_sym_async,
    ACTIONS(6653), 1,
      sym_number,
    ACTIONS(6655), 1,
      anon_sym_readonly,
    ACTIONS(6657), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3709), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186421] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6645), 1,
      anon_sym_STAR,
    ACTIONS(6651), 1,
      anon_sym_async,
    ACTIONS(6653), 1,
      sym_number,
    ACTIONS(6657), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3709), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186481] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4495), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186537] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6627), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186609] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6627), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186679] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6659), 1,
      sym_number,
    STATE(4156), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186732] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6627), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186795] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6617), 1,
      sym_number,
    STATE(4119), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186848] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6599), 1,
      sym_number,
    STATE(4112), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186901] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2295), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [186964] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6569), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187027] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6661), 1,
      sym_number,
    STATE(3843), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4513), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187080] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6603), 1,
      sym_number,
    STATE(4092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187133] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2287), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187196] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2293), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6667), 1,
      anon_sym_LPAREN,
    ACTIONS(6669), 1,
      anon_sym_DOT,
    STATE(3552), 1,
      sym_arguments,
    ACTIONS(6665), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6663), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187308] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6611), 1,
      sym_number,
    STATE(4145), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187361] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6555), 1,
      sym_number,
    STATE(4172), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187414] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2291), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187477] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187540] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2285), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187603] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6467), 1,
      sym_number,
    STATE(4116), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187656] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_COMMA,
    ACTIONS(4550), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187709] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6585), 1,
      sym_number,
    STATE(4222), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187762] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      sym_number,
    STATE(4155), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187815] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6647), 1,
      sym_number,
    STATE(4219), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187868] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187931] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6671), 1,
      sym_number,
    STATE(3832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4513), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [187984] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6673), 1,
      sym_number,
    STATE(4196), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188100] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6621), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188163] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6571), 1,
      sym_number,
    STATE(4226), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188216] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6579), 1,
      sym_number,
    STATE(4224), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188269] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6675), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188329] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6671), 1,
      sym_number,
    ACTIONS(6678), 1,
      anon_sym_abstract,
    STATE(3832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4513), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188383] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6501), 1,
      anon_sym_abstract,
    ACTIONS(6661), 1,
      sym_number,
    STATE(3843), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4513), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188437] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(4576), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6682), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6680), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188527] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2222), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6688), 1,
      anon_sym_async,
    ACTIONS(6690), 1,
      sym_number,
    ACTIONS(6692), 1,
      anon_sym_static,
    ACTIONS(6694), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_accessibility_modifier,
    ACTIONS(6686), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(6696), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6698), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4086), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(5130), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(6684), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188597] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(4557), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188645] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6675), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188709] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6675), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188771] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188824] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6621), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188877] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6700), 1,
      sym_this,
    STATE(4330), 1,
      sym_pattern,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(2896), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1573), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188932] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6671), 1,
      sym_number,
    ACTIONS(6702), 1,
      anon_sym_readonly,
    STATE(3832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [188985] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6704), 1,
      sym_number,
    STATE(3873), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4513), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189036] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6661), 1,
      sym_number,
    ACTIONS(6706), 1,
      anon_sym_readonly,
    STATE(3843), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189089] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(2817), 1,
      sym_this,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    STATE(4305), 1,
      sym_pattern,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(2896), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1573), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189144] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2287), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189197] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(2817), 1,
      sym_this,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6708), 1,
      anon_sym_class,
    ACTIONS(6710), 1,
      anon_sym_readonly,
    STATE(3605), 1,
      sym_accessibility_modifier,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
    STATE(4305), 1,
      sym_pattern,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189264] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4471), 1,
      anon_sym_module,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(6712), 1,
      anon_sym_default,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4481), 1,
      sym_declaration,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [189343] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2295), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189396] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189449] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2244), 1,
      anon_sym_namespace,
    ACTIONS(2250), 1,
      anon_sym_type,
    ACTIONS(2252), 1,
      anon_sym_import,
    ACTIONS(2254), 1,
      anon_sym_var,
    ACTIONS(2256), 1,
      anon_sym_let,
    ACTIONS(2258), 1,
      anon_sym_const,
    ACTIONS(2269), 1,
      anon_sym_class,
    ACTIONS(2271), 1,
      anon_sym_async,
    ACTIONS(2273), 1,
      anon_sym_function,
    ACTIONS(2275), 1,
      anon_sym_declare,
    ACTIONS(2277), 1,
      anon_sym_abstract,
    ACTIONS(2279), 1,
      anon_sym_module,
    ACTIONS(2281), 1,
      anon_sym_interface,
    ACTIONS(2283), 1,
      anon_sym_enum,
    ACTIONS(6714), 1,
      anon_sym_default,
    STATE(1101), 1,
      sym_internal_module,
    STATE(1135), 1,
      sym_declaration,
    STATE(3633), 1,
      sym_decorator,
    STATE(4303), 1,
      aux_sym_export_statement_repeat1,
    STATE(1094), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [189528] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6675), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189583] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2293), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189636] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(4441), 1,
      anon_sym_namespace,
    ACTIONS(4449), 1,
      anon_sym_type,
    ACTIONS(4451), 1,
      anon_sym_import,
    ACTIONS(4453), 1,
      anon_sym_var,
    ACTIONS(4455), 1,
      anon_sym_let,
    ACTIONS(4457), 1,
      anon_sym_const,
    ACTIONS(4461), 1,
      anon_sym_class,
    ACTIONS(4463), 1,
      anon_sym_async,
    ACTIONS(4465), 1,
      anon_sym_function,
    ACTIONS(4467), 1,
      anon_sym_declare,
    ACTIONS(4469), 1,
      anon_sym_abstract,
    ACTIONS(4473), 1,
      anon_sym_interface,
    ACTIONS(4475), 1,
      anon_sym_enum,
    ACTIONS(6716), 1,
      anon_sym_module,
    ACTIONS(6718), 1,
      anon_sym_global,
    STATE(3633), 1,
      sym_decorator,
    STATE(4270), 1,
      sym_internal_module,
    STATE(4323), 1,
      aux_sym_export_statement_repeat1,
    STATE(4518), 1,
      sym_declaration,
    STATE(4275), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [189715] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6569), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189768] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6720), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189825] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2244), 1,
      anon_sym_namespace,
    ACTIONS(2250), 1,
      anon_sym_type,
    ACTIONS(2252), 1,
      anon_sym_import,
    ACTIONS(2254), 1,
      anon_sym_var,
    ACTIONS(2256), 1,
      anon_sym_let,
    ACTIONS(2258), 1,
      anon_sym_const,
    ACTIONS(2269), 1,
      anon_sym_class,
    ACTIONS(2271), 1,
      anon_sym_async,
    ACTIONS(2273), 1,
      anon_sym_function,
    ACTIONS(2275), 1,
      anon_sym_declare,
    ACTIONS(2277), 1,
      anon_sym_abstract,
    ACTIONS(2281), 1,
      anon_sym_interface,
    ACTIONS(2283), 1,
      anon_sym_enum,
    ACTIONS(2567), 1,
      anon_sym_module,
    ACTIONS(2569), 1,
      anon_sym_global,
    STATE(1101), 1,
      sym_internal_module,
    STATE(1145), 1,
      sym_declaration,
    STATE(3633), 1,
      sym_decorator,
    STATE(4303), 1,
      aux_sym_export_statement_repeat1,
    STATE(1094), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [189904] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6720), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [189965] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6607), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190018] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6720), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190077] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2285), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190130] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2291), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190183] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      sym_this,
    STATE(4483), 1,
      sym_pattern,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(2896), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1573), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190238] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6627), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6726), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6724), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190331] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6720), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4821), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4819), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190423] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(2817), 1,
      sym_this,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6710), 1,
      anon_sym_readonly,
    STATE(3605), 1,
      sym_accessibility_modifier,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
    STATE(4305), 1,
      sym_pattern,
    ACTIONS(2785), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4957), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4955), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6665), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6663), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4845), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4843), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190607] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6675), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190652] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2195), 1,
      anon_sym_COMMA,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6728), 1,
      anon_sym_RBRACK,
    STATE(4567), 1,
      sym_pattern,
    STATE(4861), 1,
      sym_assignment_pattern,
    STATE(4929), 1,
      aux_sym_array_pattern_repeat1,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190709] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2195), 1,
      anon_sym_COMMA,
    ACTIONS(2199), 1,
      anon_sym_RBRACK,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    STATE(4707), 1,
      sym_pattern,
    STATE(4734), 1,
      aux_sym_array_pattern_repeat1,
    STATE(4761), 1,
      sym_assignment_pattern,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6730), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190804] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6734), 1,
      anon_sym_STAR,
    ACTIONS(6736), 1,
      sym_number,
    ACTIONS(6738), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4218), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1947), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6742), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6740), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6746), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6744), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [190970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6748), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6752), 1,
      sym__automatic_semicolon,
    ACTIONS(1945), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1947), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6756), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6754), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2839), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2837), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191128] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    STATE(4886), 1,
      sym_pattern,
    STATE(4967), 1,
      sym_assignment_pattern,
    ACTIONS(6758), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6760), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191218] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6734), 1,
      anon_sym_STAR,
    ACTIONS(6736), 1,
      sym_number,
    ACTIONS(6764), 1,
      anon_sym_async,
    ACTIONS(6738), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4218), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6768), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6766), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191310] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6770), 1,
      anon_sym_STAR,
    ACTIONS(6772), 1,
      sym_number,
    ACTIONS(6774), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4102), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191362] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6770), 1,
      anon_sym_STAR,
    ACTIONS(6772), 1,
      sym_number,
    ACTIONS(6776), 1,
      anon_sym_async,
    ACTIONS(6778), 1,
      anon_sym_readonly,
    ACTIONS(6774), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4102), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6780), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191456] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6770), 1,
      anon_sym_STAR,
    ACTIONS(6772), 1,
      sym_number,
    ACTIONS(6776), 1,
      anon_sym_async,
    ACTIONS(6774), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4102), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6784), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6788), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191586] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6772), 1,
      sym_number,
    ACTIONS(6792), 1,
      anon_sym_EQ_GT,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4102), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1921), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1923), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6794), 1,
      sym__automatic_semicolon,
    ACTIONS(1841), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1843), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6798), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6796), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6804), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6802), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6800), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6808), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6806), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191830] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_STAR,
    ACTIONS(6812), 1,
      sym_number,
    ACTIONS(6814), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4104), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191882] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6736), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4218), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191929] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6647), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4219), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [191976] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6816), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4221), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192023] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6818), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4130), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192070] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6585), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4222), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192117] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6820), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4220), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192164] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6555), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4172), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192211] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6579), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4224), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192258] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6772), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4102), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192305] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6617), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4119), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192352] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6603), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192399] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6812), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4104), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192446] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6571), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4226), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192493] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6822), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4184), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192540] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6611), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4145), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192587] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6599), 1,
      sym_number,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(4112), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2839), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2896), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2837), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192672] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      sym_this,
    ACTIONS(6824), 1,
      anon_sym_readonly,
    STATE(4483), 1,
      sym_pattern,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192722] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(2817), 1,
      sym_this,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(6710), 1,
      anon_sym_readonly,
    STATE(4305), 1,
      sym_pattern,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192772] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6826), 1,
      anon_sym_RBRACE,
    ACTIONS(6828), 1,
      sym_number,
    STATE(4974), 1,
      sym_enum_assignment,
    STATE(4612), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(6830), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192856] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6828), 1,
      sym_number,
    ACTIONS(6832), 1,
      anon_sym_RBRACE,
    STATE(4974), 1,
      sym_enum_assignment,
    STATE(4612), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192904] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6539), 1,
      anon_sym_STAR,
    ACTIONS(6541), 1,
      anon_sym_async,
    ACTIONS(6543), 1,
      sym_number,
    ACTIONS(6834), 1,
      anon_sym_static,
    ACTIONS(6836), 1,
      anon_sym_readonly,
    ACTIONS(6838), 1,
      anon_sym_abstract,
    ACTIONS(6547), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3690), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [192960] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6844), 1,
      anon_sym_AT,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
    ACTIONS(6842), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6840), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193002] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6828), 1,
      sym_number,
    ACTIONS(6847), 1,
      anon_sym_RBRACE,
    STATE(4974), 1,
      sym_enum_assignment,
    STATE(4612), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193050] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6849), 1,
      anon_sym_RBRACE,
    ACTIONS(6851), 1,
      sym_number,
    STATE(4873), 1,
      sym_enum_assignment,
    STATE(4300), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193098] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6828), 1,
      sym_number,
    ACTIONS(6853), 1,
      anon_sym_RBRACE,
    STATE(4974), 1,
      sym_enum_assignment,
    STATE(4612), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193146] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6855), 1,
      anon_sym_RBRACE,
    ACTIONS(6857), 1,
      sym_number,
    STATE(4720), 1,
      sym_enum_assignment,
    STATE(4419), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193194] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6220), 1,
      anon_sym_STAR,
    ACTIONS(6226), 1,
      anon_sym_async,
    ACTIONS(6228), 1,
      sym_number,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    ACTIONS(6859), 1,
      anon_sym_static,
    ACTIONS(6230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3702), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193247] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6706), 1,
      anon_sym_readonly,
    ACTIONS(6861), 1,
      anon_sym_STAR,
    ACTIONS(6863), 1,
      sym_number,
    ACTIONS(6865), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3685), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193296] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2807), 1,
      sym_identifier,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    STATE(5140), 1,
      sym_pattern,
    STATE(3978), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1573), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193341] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6661), 1,
      sym_number,
    ACTIONS(6867), 1,
      anon_sym_static,
    ACTIONS(6869), 1,
      anon_sym_readonly,
    ACTIONS(6871), 1,
      anon_sym_abstract,
    STATE(3843), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193390] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(2771), 1,
      anon_sym_async,
    ACTIONS(2773), 1,
      anon_sym_readonly,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6553), 1,
      anon_sym_STAR,
    ACTIONS(6873), 1,
      anon_sym_static,
    ACTIONS(2775), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193443] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6875), 1,
      anon_sym_STAR,
    ACTIONS(6877), 1,
      sym_number,
    ACTIONS(6879), 1,
      anon_sym_readonly,
    ACTIONS(6881), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3683), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193492] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6465), 1,
      anon_sym_STAR,
    ACTIONS(6471), 1,
      anon_sym_async,
    ACTIONS(6473), 1,
      sym_number,
    ACTIONS(6477), 1,
      anon_sym_readonly,
    ACTIONS(6883), 1,
      anon_sym_static,
    ACTIONS(6475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3696), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193545] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6828), 1,
      sym_number,
    STATE(4974), 1,
      sym_enum_assignment,
    STATE(4612), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193590] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6816), 1,
      sym_number,
    STATE(4221), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193632] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      sym_number,
    STATE(4155), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193674] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(2745), 1,
      sym_number,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    STATE(4097), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193716] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6671), 1,
      sym_number,
    STATE(3832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193758] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6585), 1,
      sym_number,
    STATE(4222), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193800] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6555), 1,
      sym_number,
    STATE(4172), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193842] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6671), 1,
      sym_number,
    ACTIONS(6702), 1,
      anon_sym_readonly,
    STATE(3832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193886] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6818), 1,
      sym_number,
    STATE(4130), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193928] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6661), 1,
      sym_number,
    ACTIONS(6706), 1,
      anon_sym_readonly,
    STATE(3843), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [193972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6887), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AT,
    ACTIONS(6885), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194006] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6661), 1,
      sym_number,
    STATE(3843), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6647), 1,
      sym_number,
    STATE(4219), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194090] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6736), 1,
      sym_number,
    STATE(4218), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194132] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6579), 1,
      sym_number,
    STATE(4224), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194174] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6617), 1,
      sym_number,
    STATE(4119), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194216] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6822), 1,
      sym_number,
    STATE(4184), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194258] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6467), 1,
      sym_number,
    STATE(4116), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194300] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(6232), 1,
      anon_sym_LBRACK,
    ACTIONS(6704), 1,
      sym_number,
    STATE(3873), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4513), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194342] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6603), 1,
      sym_number,
    STATE(4092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194384] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6599), 1,
      sym_number,
    STATE(4112), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194426] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6571), 1,
      sym_number,
    STATE(4226), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6812), 1,
      sym_number,
    STATE(4104), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194510] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6673), 1,
      sym_number,
    STATE(4196), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194552] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      sym_number,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194594] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6611), 1,
      sym_number,
    STATE(4145), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194636] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6820), 1,
      sym_number,
    STATE(4220), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194678] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6659), 1,
      sym_number,
    STATE(4156), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194720] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(6236), 1,
      anon_sym_LBRACK,
    ACTIONS(6772), 1,
      sym_number,
    STATE(4102), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2769), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6889), 1,
      sym_identifier,
    STATE(5556), 1,
      sym_mapped_type_clause,
    ACTIONS(6891), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_declare,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [194792] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4634), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(4636), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [194822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 1,
      anon_sym_PIPE,
    ACTIONS(1895), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [194846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_DOT,
    ACTIONS(4873), 1,
      anon_sym_EQ,
    ACTIONS(4875), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_implements,
      anon_sym_extends,
  [194872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_PIPE,
    ACTIONS(1961), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [194896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4646), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [194926] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_LT,
    STATE(3681), 1,
      sym_type_arguments,
    ACTIONS(4620), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [194953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6897), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [194974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4640), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_LT,
    STATE(3681), 1,
      sym_type_arguments,
    ACTIONS(4642), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [195001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6899), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6905), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6909), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6913), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6915), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6919), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6925), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6927), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6929), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6935), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [195400] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6941), 1,
      anon_sym_BANG,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    ACTIONS(6945), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4366), 1,
      sym_type_annotation,
    STATE(4370), 1,
      sym__call_signature,
    STATE(4770), 1,
      sym__initializer,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 1,
      anon_sym_EQ,
    ACTIONS(4760), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_implements,
      anon_sym_extends,
  [195464] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_LT,
    ACTIONS(6949), 1,
      anon_sym_DOT,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(3642), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [195492] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    ACTIONS(6953), 1,
      anon_sym_BANG,
    ACTIONS(6955), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4487), 1,
      sym_type_annotation,
    STATE(4849), 1,
      sym__initializer,
    STATE(4877), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6951), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 1,
      anon_sym_EQ,
    ACTIONS(4750), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_implements,
      anon_sym_extends,
  [195556] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6941), 1,
      anon_sym_BANG,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    ACTIONS(6957), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4366), 1,
      sym_type_annotation,
    STATE(4770), 1,
      sym__initializer,
    STATE(4810), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195598] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_LT,
    ACTIONS(6949), 1,
      anon_sym_DOT,
    ACTIONS(6959), 1,
      anon_sym_is,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(3642), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [195628] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    ACTIONS(6963), 1,
      anon_sym_BANG,
    ACTIONS(6965), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4451), 1,
      sym_type_annotation,
    STATE(4513), 1,
      sym__call_signature,
    STATE(4870), 1,
      sym__initializer,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6961), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195670] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    ACTIONS(6969), 1,
      anon_sym_BANG,
    ACTIONS(6971), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4453), 1,
      sym_type_annotation,
    STATE(4457), 1,
      sym__call_signature,
    STATE(4796), 1,
      sym__initializer,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6967), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195712] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4634), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_LT,
    ACTIONS(6949), 1,
      anon_sym_DOT,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(4636), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [195740] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    ACTIONS(6953), 1,
      anon_sym_BANG,
    ACTIONS(6973), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4478), 1,
      sym__call_signature,
    STATE(4487), 1,
      sym_type_annotation,
    STATE(4849), 1,
      sym__initializer,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6951), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4640), 1,
      anon_sym_EQ,
    ACTIONS(4642), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [195803] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(6979), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4265), 1,
      sym__call_signature,
    STATE(4331), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6975), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [195838] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(6983), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4500), 1,
      sym__call_signature,
    STATE(4501), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6981), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [195873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4720), 1,
      anon_sym_EQ,
    ACTIONS(4722), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [195894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 1,
      anon_sym_EQ,
    ACTIONS(5027), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [195915] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(6987), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4341), 1,
      sym__call_signature,
    STATE(4384), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6985), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [195950] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(6989), 1,
      anon_sym_EQ,
    ACTIONS(6994), 1,
      anon_sym_COLON,
    ACTIONS(6996), 1,
      anon_sym_extends,
    STATE(3684), 1,
      sym_type_arguments,
    STATE(4561), 1,
      sym_constraint,
    STATE(4959), 1,
      sym_default_type,
    ACTIONS(6991), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(3642), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [195987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_DOT,
    ACTIONS(4873), 1,
      anon_sym_PIPE,
    ACTIONS(4875), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [196010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 1,
      anon_sym_EQ,
    ACTIONS(4620), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4724), 1,
      anon_sym_EQ,
    ACTIONS(4726), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4973), 1,
      anon_sym_EQ,
    ACTIONS(4975), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196073] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(6999), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3964), 1,
      sym__call_signature,
    STATE(4384), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6985), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [196108] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7001), 1,
      anon_sym_COLON,
    ACTIONS(7003), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4032), 1,
      sym__call_signature,
    STATE(4501), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6981), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [196143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_EQ,
    ACTIONS(5013), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_EQ,
    ACTIONS(2203), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196185] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7007), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3985), 1,
      sym__call_signature,
    STATE(4387), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7005), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [196220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 1,
      anon_sym_EQ,
    ACTIONS(4983), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4728), 1,
      anon_sym_EQ,
    ACTIONS(7009), 1,
      anon_sym_LBRACK,
    ACTIONS(4736), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4730), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [196266] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7011), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4387), 1,
      sym_type_annotation,
    STATE(4392), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7005), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [196301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4738), 1,
      anon_sym_EQ,
    ACTIONS(4740), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4899), 1,
      anon_sym_EQ,
    ACTIONS(4901), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196343] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_COLON,
    ACTIONS(4406), 1,
      anon_sym_EQ,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7016), 1,
      anon_sym_QMARK,
    STATE(3684), 1,
      sym_type_arguments,
    STATE(5192), 1,
      sym_type_annotation,
    ACTIONS(7013), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3642), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_EQ,
    ACTIONS(4865), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_EQ,
    ACTIONS(4869), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 1,
      anon_sym_EQ,
    ACTIONS(4746), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    ACTIONS(4991), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_LT,
    STATE(3755), 1,
      sym_type_arguments,
    ACTIONS(4620), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [196487] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7019), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3992), 1,
      sym__call_signature,
    STATE(4331), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6975), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [196522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 1,
      anon_sym_EQ,
    ACTIONS(4890), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4884), 1,
      anon_sym_EQ,
    ACTIONS(4886), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 1,
      anon_sym_EQ,
    ACTIONS(5009), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 1,
      anon_sym_EQ,
    ACTIONS(4971), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4640), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_LT,
    STATE(3755), 1,
      sym_type_arguments,
    ACTIONS(4642), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [196631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4754), 1,
      anon_sym_EQ,
    ACTIONS(4756), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196652] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6983), 1,
      anon_sym_QMARK,
    ACTIONS(7021), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4500), 1,
      sym__call_signature,
    STATE(4501), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(6981), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [196687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4734), 1,
      anon_sym_EQ,
    ACTIONS(7009), 1,
      anon_sym_LBRACK,
    ACTIONS(4736), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [196710] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4277), 1,
      sym__call_signature,
    STATE(4466), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7023), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [196742] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3998), 1,
      sym__call_signature,
    STATE(4413), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7025), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [196774] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4350), 1,
      sym_type_annotation,
    STATE(4784), 1,
      sym__initializer,
    STATE(4811), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7027), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196810] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4350), 1,
      sym_type_annotation,
    STATE(4378), 1,
      sym__call_signature,
    STATE(4784), 1,
      sym__initializer,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7027), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196846] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4375), 1,
      sym__call_signature,
    STATE(4494), 1,
      sym_type_annotation,
    STATE(4894), 1,
      sym__initializer,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196882] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3989), 1,
      sym__call_signature,
    STATE(4466), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7023), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [196914] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4494), 1,
      sym_type_annotation,
    STATE(4727), 1,
      sym__call_signature,
    STATE(4894), 1,
      sym__initializer,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196950] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [196978] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4510), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [197006] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4504), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [197034] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4428), 1,
      sym_type_annotation,
    STATE(4517), 1,
      sym__call_signature,
    STATE(4740), 1,
      sym__initializer,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197070] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4353), 1,
      sym__call_signature,
    STATE(4413), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7025), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [197102] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6947), 1,
      anon_sym_LT,
    ACTIONS(6949), 1,
      anon_sym_DOT,
    ACTIONS(7033), 1,
      anon_sym_is,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(3642), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197128] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_COLON,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7016), 1,
      anon_sym_QMARK,
    STATE(3684), 1,
      sym_type_arguments,
    STATE(5192), 1,
      sym_type_annotation,
    ACTIONS(3642), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197158] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4382), 1,
      sym_type_annotation,
    STATE(4398), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7035), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [197190] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4495), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [197218] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4492), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [197246] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4498), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [197274] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4256), 1,
      sym__call_signature,
    STATE(4409), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7037), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [197306] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7013), 1,
      anon_sym_RPAREN,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4406), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [197334] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3982), 1,
      sym__call_signature,
    STATE(4382), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7035), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [197366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_LT,
    ACTIONS(6949), 1,
      anon_sym_DOT,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(7013), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3642), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197394] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4446), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [197422] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7039), 1,
      anon_sym_LT,
    ACTIONS(7041), 1,
      anon_sym_DOT,
    ACTIONS(7043), 1,
      anon_sym_is,
    STATE(3933), 1,
      sym_type_arguments,
    ACTIONS(3642), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197448] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4501), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [197476] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4505), 1,
      sym_type_annotation,
    STATE(4510), 1,
      sym__call_signature,
    STATE(4909), 1,
      sym__initializer,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7045), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197512] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4489), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [197540] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3969), 1,
      sym__call_signature,
    STATE(4409), 1,
      sym_type_annotation,
    STATE(5151), 1,
      sym_type_parameters,
    ACTIONS(7037), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [197572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197591] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7047), 1,
      anon_sym_is,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197616] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7049), 1,
      anon_sym_is,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 1,
      anon_sym_PIPE,
    ACTIONS(6959), 1,
      anon_sym_is,
    ACTIONS(4620), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7039), 1,
      anon_sym_LT,
    ACTIONS(7041), 1,
      anon_sym_DOT,
    STATE(3933), 1,
      sym_type_arguments,
    ACTIONS(3642), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 1,
      anon_sym_PIPE,
    ACTIONS(3355), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197704] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(4292), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7051), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3642), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6334), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [197748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 1,
      anon_sym_PIPE,
    ACTIONS(5009), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197767] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7054), 1,
      anon_sym_is,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [197809] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7056), 1,
      anon_sym_is,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7058), 1,
      anon_sym_is,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 7,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2751), 1,
      anon_sym_PIPE,
    ACTIONS(2749), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 1,
      anon_sym_PIPE,
    ACTIONS(3365), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2755), 1,
      anon_sym_PIPE,
    ACTIONS(2753), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_PIPE,
    ACTIONS(4991), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197935] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7039), 1,
      anon_sym_LT,
    ACTIONS(7041), 1,
      anon_sym_DOT,
    STATE(3933), 1,
      sym_type_arguments,
    ACTIONS(4636), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [197958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 1,
      anon_sym_PIPE,
    ACTIONS(4983), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4973), 1,
      anon_sym_PIPE,
    ACTIONS(4975), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [197996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 1,
      anon_sym_PIPE,
    ACTIONS(4971), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_PIPE,
    ACTIONS(2757), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_PIPE,
    ACTIONS(3361), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 1,
      anon_sym_PIPE,
    ACTIONS(5027), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_PIPE,
    ACTIONS(2203), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_PIPE,
    ACTIONS(5013), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4899), 1,
      anon_sym_PIPE,
    ACTIONS(4901), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 1,
      anon_sym_PIPE,
    ACTIONS(4890), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4734), 1,
      anon_sym_PIPE,
    ACTIONS(7060), 1,
      anon_sym_LBRACK,
    ACTIONS(4736), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4884), 1,
      anon_sym_PIPE,
    ACTIONS(4886), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198207] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_COMMA,
    ACTIONS(4550), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [198232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_PIPE,
    ACTIONS(4869), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2765), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4720), 1,
      anon_sym_PIPE,
    ACTIONS(4722), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4724), 1,
      anon_sym_PIPE,
    ACTIONS(4726), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4734), 1,
      anon_sym_PIPE,
    ACTIONS(7060), 1,
      anon_sym_LBRACK,
    ACTIONS(4736), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(4730), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [198331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4738), 1,
      anon_sym_PIPE,
    ACTIONS(4740), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 1,
      anon_sym_PIPE,
    ACTIONS(4746), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4754), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4640), 1,
      anon_sym_PIPE,
    ACTIONS(4642), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 1,
      anon_sym_PIPE,
    ACTIONS(2761), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_PIPE,
    ACTIONS(4865), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_AMP,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(7066), 1,
      anon_sym_extends,
    ACTIONS(4991), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [198486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5769), 1,
      anon_sym_PIPE,
    ACTIONS(7062), 1,
      anon_sym_AMP,
    ACTIONS(5771), 8,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    STATE(4195), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(7068), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [198526] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_AMP,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(7066), 1,
      anon_sym_extends,
    ACTIONS(4886), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [198548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_AMP,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 8,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [198568] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7072), 1,
      sym_identifier,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    STATE(3327), 1,
      sym_class_body,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5088), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [198602] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7080), 1,
      sym_identifier,
    STATE(3312), 1,
      sym_class_body,
    STATE(4073), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5207), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [198636] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7082), 1,
      sym_identifier,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2305), 1,
      sym_class_body,
    STATE(4046), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5170), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [198670] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7086), 1,
      sym_identifier,
    STATE(2369), 1,
      sym_class_body,
    STATE(4062), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5074), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [198704] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(4483), 1,
      anon_sym_LBRACE,
    ACTIONS(7088), 1,
      sym_identifier,
    ACTIONS(7090), 1,
      anon_sym_STAR,
    STATE(5058), 1,
      sym_import_clause,
    STATE(5057), 2,
      sym_string,
      sym_import_require_clause,
    STATE(5414), 2,
      sym_namespace_import,
      sym_named_imports,
  [198734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_DOT,
    ACTIONS(4875), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [198752] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    ACTIONS(7094), 1,
      anon_sym_BANG,
    STATE(4358), 1,
      sym_type_annotation,
    STATE(4775), 1,
      sym__initializer,
    ACTIONS(7096), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7092), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7039), 1,
      anon_sym_LT,
    STATE(3925), 1,
      sym_type_arguments,
    ACTIONS(4620), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [198800] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4292), 1,
      anon_sym_COLON,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [198824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7039), 1,
      anon_sym_LT,
    STATE(3925), 1,
      sym_type_arguments,
    ACTIONS(4642), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [198844] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7098), 1,
      sym_identifier,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2173), 1,
      sym_class_body,
    STATE(4070), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5100), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [198878] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7102), 1,
      sym_identifier,
    STATE(2369), 1,
      sym_class_body,
    STATE(4062), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5074), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [198912] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7104), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_class_body,
    STATE(4046), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5170), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [198946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    STATE(4110), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(7106), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [198966] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6947), 1,
      anon_sym_LT,
    ACTIONS(6949), 1,
      anon_sym_DOT,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3794), 1,
      sym_type_arguments,
    ACTIONS(3642), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [198990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5508), 1,
      anon_sym_PIPE,
    ACTIONS(7062), 1,
      anon_sym_AMP,
    ACTIONS(5510), 8,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [199010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_AMP,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(7066), 1,
      anon_sym_extends,
    ACTIONS(5767), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [199032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_AMP,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(7066), 1,
      anon_sym_extends,
    ACTIONS(5570), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [199054] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7110), 1,
      sym_identifier,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    STATE(2879), 1,
      sym_class_body,
    STATE(4017), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5062), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199088] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7114), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_class_body,
    STATE(4046), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5170), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199122] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    ACTIONS(7116), 1,
      sym_identifier,
    STATE(2728), 1,
      sym_class_body,
    STATE(3962), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5018), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(4576), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [199176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(4557), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [199196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7118), 1,
      anon_sym_is,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [199220] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7120), 1,
      sym_identifier,
    STATE(2201), 1,
      sym_class_body,
    STATE(4061), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5204), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199254] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7076), 1,
      anon_sym_implements,
    ACTIONS(7078), 1,
      anon_sym_extends,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7122), 1,
      sym_identifier,
    STATE(2369), 1,
      sym_class_body,
    STATE(4062), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5074), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199288] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6607), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [199313] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(3170), 1,
      sym_class_body,
    STATE(4047), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5173), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199344] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4451), 1,
      sym_type_annotation,
    STATE(4870), 1,
      sym__initializer,
    ACTIONS(6963), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6961), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199369] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2291), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4747), 1,
      aux_sym_object_repeat1,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [199394] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7128), 1,
      anon_sym_is,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 5,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [199417] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [199442] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2285), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [199467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4724), 1,
      anon_sym_PIPE,
    ACTIONS(7130), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4726), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [199486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(7133), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2765), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [199505] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2287), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4799), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [199530] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6569), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [199555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6139), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [199570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6094), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7133), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2765), 5,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [199589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4366), 1,
      sym_type_annotation,
    STATE(4770), 1,
      sym__initializer,
    ACTIONS(6941), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199614] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7136), 1,
      anon_sym_LBRACE,
    STATE(152), 1,
      sym_class_body,
    STATE(3996), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4944), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7130), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4726), 5,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [199664] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2986), 1,
      sym_class_body,
    STATE(4084), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5123), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199695] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2295), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [199720] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4064), 1,
      sym_type_parameters,
    STATE(4499), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5094), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199751] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2139), 1,
      sym_class_body,
    STATE(4060), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5086), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199782] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(1059), 1,
      sym_class_body,
    STATE(4080), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5099), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199813] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2764), 1,
      sym_class_body,
    STATE(3971), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5043), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [199859] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2669), 1,
      sym_class_body,
    STATE(3956), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5056), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199890] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    STATE(1123), 1,
      sym_class_body,
    STATE(4090), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5006), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199921] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4019), 1,
      sym_type_parameters,
    STATE(4404), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5024), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [199952] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4487), 1,
      sym_type_annotation,
    STATE(4849), 1,
      sym__initializer,
    ACTIONS(6953), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6951), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_AMP,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(7066), 1,
      anon_sym_extends,
    ACTIONS(7142), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [199998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7033), 1,
      anon_sym_is,
    ACTIONS(4620), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200015] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(3041), 1,
      sym_class_body,
    STATE(3970), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4958), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [200046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [200061] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(3955), 1,
      sym_type_parameters,
    STATE(4299), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4939), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [200092] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [200117] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2099), 1,
      sym_class_body,
    STATE(4028), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4932), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [200148] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6621), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [200173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 1,
      anon_sym_RPAREN,
    ACTIONS(4620), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(7146), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [200192] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 1,
      anon_sym_RPAREN,
    ACTIONS(4726), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(6056), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [200211] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2442), 1,
      sym_class_body,
    STATE(4089), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5156), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [200242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7133), 1,
      anon_sym_RPAREN,
    ACTIONS(2765), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(6094), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [200261] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7151), 1,
      anon_sym_is,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7153), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [200299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4358), 1,
      sym_type_annotation,
    STATE(4775), 1,
      sym__initializer,
    ACTIONS(7096), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7092), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [200324] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2271), 1,
      sym_class_body,
    STATE(3975), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5078), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [200355] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4498), 1,
      sym_type_annotation,
    STATE(4867), 1,
      sym__initializer,
    ACTIONS(7157), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7155), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [200380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7159), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [200395] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(3974), 1,
      sym_type_parameters,
    STATE(4456), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4962), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [200426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7163), 1,
      anon_sym_RPAREN,
    ACTIONS(4620), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(7161), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [200445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 1,
      anon_sym_RPAREN,
    ACTIONS(2203), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(2896), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [200464] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(3309), 1,
      sym_class_body,
    STATE(4072), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5209), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [200495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7169), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [200510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6094), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [200525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7171), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [200540] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(1057), 1,
      sym_class_body,
    STATE(4003), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5105), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [200571] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6627), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4772), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [200596] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    STATE(1128), 1,
      sym_class_body,
    STATE(4021), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5152), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [200627] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7136), 1,
      anon_sym_LBRACE,
    STATE(151), 1,
      sym_class_body,
    STATE(4015), 1,
      sym_type_parameters,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5141), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [200658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(6895), 1,
      anon_sym_DOT,
    ACTIONS(7173), 1,
      anon_sym_is,
    STATE(3684), 1,
      sym_type_arguments,
    ACTIONS(3642), 5,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200681] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(2293), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4831), 1,
      aux_sym_object_repeat1,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [200706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_is,
    ACTIONS(4620), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_PIPE,
    ACTIONS(7166), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2203), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [200742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3365), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_PIPE,
    ACTIONS(7179), 1,
      anon_sym_extends,
    ACTIONS(4991), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [200790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5009), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4983), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4975), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4971), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2749), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2765), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [200892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4722), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_AMP,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(7066), 1,
      anon_sym_extends,
    ACTIONS(7181), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [200940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2757), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [200968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7183), 1,
      anon_sym_COLON,
    STATE(4624), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(7106), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [200986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7185), 1,
      anon_sym_LBRACK,
    ACTIONS(4736), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(5771), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [201060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4890), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7047), 1,
      anon_sym_is,
    ACTIONS(4620), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4886), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201104] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_PIPE,
    ACTIONS(7179), 1,
      anon_sym_extends,
    ACTIONS(4886), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [201124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4869), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4865), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7183), 1,
      anon_sym_COLON,
    STATE(4676), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(7068), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [201198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_AMP,
    ACTIONS(5771), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [201214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4991), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201228] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7189), 1,
      sym_identifier,
    ACTIONS(7191), 1,
      anon_sym_LBRACE,
    ACTIONS(7193), 1,
      anon_sym_LBRACK,
    ACTIONS(7195), 1,
      anon_sym_enum,
    STATE(4586), 1,
      sym_variable_declarator,
    STATE(3967), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [201252] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    ACTIONS(7094), 1,
      anon_sym_BANG,
    STATE(4358), 1,
      sym_type_annotation,
    STATE(4775), 1,
      sym__initializer,
    ACTIONS(7092), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [201276] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    ACTIONS(7199), 1,
      anon_sym_DOT,
    STATE(4289), 1,
      sym_statement_block,
    ACTIONS(1857), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [201296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4760), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201310] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_PIPE,
    ACTIONS(7179), 1,
      anon_sym_extends,
    ACTIONS(5570), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [201330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4756), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 1,
      anon_sym_is,
    ACTIONS(4620), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_PIPE,
    ACTIONS(7179), 1,
      anon_sym_extends,
    ACTIONS(5767), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [201408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_AMP,
    ACTIONS(7201), 1,
      anon_sym_PIPE,
    ACTIONS(7203), 1,
      anon_sym_extends,
    ACTIONS(5570), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [201428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4750), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4746), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_AMP,
    ACTIONS(5510), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [201472] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_AMP,
    ACTIONS(7201), 1,
      anon_sym_PIPE,
    ACTIONS(7203), 1,
      anon_sym_extends,
    ACTIONS(5767), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [201492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(5510), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [201508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7058), 1,
      anon_sym_is,
    ACTIONS(4620), 7,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 1,
      anon_sym_is,
    ACTIONS(4620), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7054), 1,
      anon_sym_is,
    ACTIONS(4620), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201556] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7189), 1,
      sym_identifier,
    ACTIONS(7191), 1,
      anon_sym_LBRACE,
    ACTIONS(7193), 1,
      anon_sym_LBRACK,
    ACTIONS(7205), 1,
      anon_sym_enum,
    STATE(4593), 1,
      sym_variable_declarator,
    STATE(3967), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [201580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4740), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7185), 1,
      anon_sym_LBRACK,
    ACTIONS(4736), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4730), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [201612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_AMP,
    ACTIONS(7201), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 6,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [201630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_AMP,
    ACTIONS(7201), 1,
      anon_sym_PIPE,
    ACTIONS(7203), 1,
      anon_sym_extends,
    ACTIONS(4991), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [201650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2753), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_AMP,
    ACTIONS(7201), 1,
      anon_sym_PIPE,
    ACTIONS(7203), 1,
      anon_sym_extends,
    ACTIONS(4886), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [201698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5027), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_AMP,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(7066), 1,
      anon_sym_extends,
    ACTIONS(7207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [201732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 1,
      anon_sym_EQ,
    ACTIONS(7166), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2203), 5,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [201750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(5771), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [201765] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7211), 1,
      sym_identifier,
    ACTIONS(7213), 1,
      anon_sym_STAR,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5183), 1,
      sym__call_signature,
  [201790] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7217), 1,
      sym_identifier,
    ACTIONS(7219), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(4996), 1,
      sym__call_signature,
  [201815] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4462), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4981), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [201840] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2833), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5051), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [201865] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_LBRACE,
    ACTIONS(7193), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 1,
      sym_identifier,
    STATE(4843), 1,
      sym_variable_declarator,
    STATE(3967), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [201886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7223), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [201899] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7225), 1,
      anon_sym_COLON,
    ACTIONS(7227), 1,
      anon_sym_QMARK,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5090), 1,
      sym__call_signature,
  [201924] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_LBRACE,
    ACTIONS(7193), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 1,
      sym_identifier,
    STATE(4695), 1,
      sym_variable_declarator,
    STATE(3967), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [201945] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6989), 1,
      anon_sym_EQ,
    STATE(4561), 1,
      sym_constraint,
    STATE(4959), 1,
      sym_default_type,
    ACTIONS(6994), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(7229), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [201966] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2788), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5053), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [201991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(4991), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [202010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5102), 1,
      sym_statement_block,
    ACTIONS(7237), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_AMP,
    ACTIONS(7241), 1,
      anon_sym_PIPE,
    ACTIONS(7243), 1,
      anon_sym_extends,
    ACTIONS(4886), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
  [202046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_AMP,
    ACTIONS(5771), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_extends,
  [202061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4358), 1,
      sym_type_annotation,
    STATE(4775), 1,
      sym__initializer,
    ACTIONS(7092), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [202082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7245), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [202095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5082), 1,
      sym_statement_block,
    ACTIONS(7247), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202112] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2925), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4961), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [202137] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2818), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5041), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [202162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym_is,
    ACTIONS(7249), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(4289), 1,
      sym_statement_block,
    ACTIONS(1857), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202194] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4475), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4987), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [202219] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2396), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4988), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [202244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(5771), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [202259] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7251), 1,
      sym_identifier,
    ACTIONS(7253), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5111), 1,
      sym__call_signature,
  [202284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4406), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [202297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_AMP,
    ACTIONS(7241), 1,
      anon_sym_PIPE,
    ACTIONS(7243), 1,
      anon_sym_extends,
    ACTIONS(4991), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
  [202316] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7255), 1,
      sym_identifier,
    ACTIONS(7257), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5183), 1,
      sym__call_signature,
  [202341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(7259), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
  [202358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(4998), 1,
      sym_statement_block,
    ACTIONS(7261), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(5570), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [202394] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_LBRACE,
    ACTIONS(7193), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 1,
      sym_identifier,
    STATE(4586), 1,
      sym_variable_declarator,
    STATE(3967), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [202415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(4991), 1,
      sym_statement_block,
    ACTIONS(7263), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4292), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [202445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_AMP,
    ACTIONS(7241), 1,
      anon_sym_PIPE,
    ACTIONS(7243), 1,
      anon_sym_extends,
    ACTIONS(5570), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
  [202464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7159), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [202477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(4966), 1,
      sym_statement_block,
    ACTIONS(7265), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7267), 1,
      anon_sym_EQ,
    ACTIONS(7271), 1,
      anon_sym_COLON,
    ACTIONS(7273), 1,
      anon_sym_QMARK,
    STATE(4574), 1,
      sym_type_annotation,
    STATE(4976), 1,
      sym__initializer,
    ACTIONS(7269), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [202517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_AMP,
    ACTIONS(7241), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_extends,
  [202534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(4964), 1,
      sym_statement_block,
    ACTIONS(7275), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(7259), 1,
      anon_sym_PIPE,
    ACTIONS(7277), 1,
      anon_sym_extends,
    ACTIONS(4991), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [202570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 5,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_extends,
  [202587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6334), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [202600] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7136), 1,
      anon_sym_LBRACE,
    STATE(160), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5163), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [202625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(4391), 1,
      sym_type_annotation,
    ACTIONS(7279), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5092), 1,
      sym_statement_block,
    ACTIONS(7281), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5047), 1,
      sym_statement_block,
    ACTIONS(7283), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5138), 1,
      sym_statement_block,
    ACTIONS(7285), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5134), 1,
      sym_statement_block,
    ACTIONS(7287), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5063), 1,
      sym_statement_block,
    ACTIONS(7289), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [202727] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(1049), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5001), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [202752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(7259), 1,
      anon_sym_PIPE,
    ACTIONS(7277), 1,
      anon_sym_extends,
    ACTIONS(4886), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [202771] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7291), 1,
      sym_identifier,
    ACTIONS(7293), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5161), 1,
      sym__call_signature,
  [202796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(5510), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_extends,
  [202811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_PIPE,
    ACTIONS(7299), 1,
      anon_sym_extends,
    ACTIONS(5767), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [202830] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4428), 1,
      sym_type_annotation,
    STATE(4740), 1,
      sym__initializer,
    ACTIONS(7031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [202851] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_LBRACE,
    ACTIONS(7193), 1,
      anon_sym_LBRACK,
    ACTIONS(7301), 1,
      sym_identifier,
    STATE(4586), 1,
      sym_variable_declarator,
    STATE(3871), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [202872] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7303), 1,
      sym_identifier,
    ACTIONS(7305), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(4996), 1,
      sym__call_signature,
  [202897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_LBRACE,
    ACTIONS(7193), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_variable_declarator,
    STATE(3967), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [202918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_LBRACE,
    ACTIONS(7193), 1,
      anon_sym_LBRACK,
    ACTIONS(7301), 1,
      sym_identifier,
    STATE(4695), 1,
      sym_variable_declarator,
    STATE(3871), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [202939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_PIPE,
    ACTIONS(7299), 1,
      anon_sym_extends,
    ACTIONS(5570), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [202958] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_LBRACE,
    ACTIONS(7193), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 1,
      sym_identifier,
    STATE(4593), 1,
      sym_variable_declarator,
    STATE(3967), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [202979] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7136), 1,
      anon_sym_LBRACE,
    STATE(163), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5008), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_AMP,
    ACTIONS(5510), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_extends,
  [203019] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2726), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5070), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_AMP,
    ACTIONS(7241), 1,
      anon_sym_PIPE,
    ACTIONS(7243), 1,
      anon_sym_extends,
    ACTIONS(5767), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
  [203063] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4438), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4960), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 1,
      anon_sym_COLON,
    ACTIONS(4726), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [203103] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    STATE(1062), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5010), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6094), 1,
      anon_sym_COLON,
    ACTIONS(2765), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [203143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4505), 1,
      sym_type_annotation,
    STATE(4909), 1,
      sym__initializer,
    ACTIONS(7045), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [203164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_PIPE,
    ACTIONS(7179), 1,
      anon_sym_extends,
    ACTIONS(7142), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [203183] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_AMP,
    ACTIONS(7309), 1,
      anon_sym_PIPE,
    ACTIONS(7311), 1,
      anon_sym_extends,
    ACTIONS(4886), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
  [203202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_AMP,
    ACTIONS(5771), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [203217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7213), 1,
      anon_sym_STAR,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7313), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5183), 1,
      sym__call_signature,
  [203242] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2180), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4985), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_AMP,
    ACTIONS(7309), 1,
      anon_sym_PIPE,
    ACTIONS(7311), 1,
      anon_sym_extends,
    ACTIONS(4991), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
  [203286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(5767), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [203305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_AMP,
    ACTIONS(7309), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
  [203322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5148), 1,
      sym_statement_block,
    ACTIONS(7315), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [203339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7153), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [203352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4350), 1,
      sym_type_annotation,
    STATE(4784), 1,
      sym__initializer,
    ACTIONS(7027), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [203373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [203386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 5,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_extends,
  [203403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [203416] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4494), 1,
      sym_type_annotation,
    STATE(4894), 1,
      sym__initializer,
    ACTIONS(7029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [203437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6094), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [203450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_AMP,
    ACTIONS(7309), 1,
      anon_sym_PIPE,
    ACTIONS(7311), 1,
      anon_sym_extends,
    ACTIONS(5767), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
  [203469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_AMP,
    ACTIONS(5510), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [203484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [203497] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(4296), 1,
      sym_type_annotation,
    STATE(4882), 1,
      sym__initializer,
    ACTIONS(7319), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [203518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_PIPE,
    ACTIONS(7299), 1,
      anon_sym_extends,
    ACTIONS(4991), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [203537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [203550] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2367), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4993), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203575] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(3135), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5202), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(4886), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [203619] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7219), 1,
      anon_sym_STAR,
    ACTIONS(7321), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(4996), 1,
      sym__call_signature,
  [203644] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7323), 1,
      sym_identifier,
    ACTIONS(7325), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5168), 1,
      sym__call_signature,
  [203669] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7327), 1,
      sym_identifier,
    ACTIONS(7329), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(4996), 1,
      sym__call_signature,
  [203694] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7331), 1,
      sym_identifier,
    ACTIONS(7333), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5067), 1,
      sym__call_signature,
  [203719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(5510), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [203734] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7335), 1,
      sym_identifier,
    ACTIONS(7337), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5206), 1,
      sym__call_signature,
  [203759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(7259), 1,
      anon_sym_PIPE,
    ACTIONS(7277), 1,
      anon_sym_extends,
    ACTIONS(5767), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [203778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [203791] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(7339), 1,
      sym_identifier,
    ACTIONS(7341), 1,
      anon_sym_DOT,
    STATE(1040), 1,
      sym_nested_identifier,
    STATE(1058), 1,
      sym_string,
    STATE(1143), 1,
      sym__module,
  [203816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(5510), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [203831] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(7343), 1,
      anon_sym_LT,
    ACTIONS(7345), 1,
      anon_sym_extends,
    STATE(1137), 1,
      sym_object_type,
    STATE(4342), 1,
      sym_type_parameters,
    STATE(4797), 1,
      sym_extends_clause,
  [203856] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2101), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4936), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203881] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2172), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5121), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203906] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2304), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5139), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203931] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7219), 1,
      anon_sym_STAR,
    ACTIONS(7347), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(4996), 1,
      sym__call_signature,
  [203956] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4431), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4943), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [203981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7169), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [203994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(5771), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_extends,
  [204009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_PIPE,
    ACTIONS(7299), 1,
      anon_sym_extends,
    ACTIONS(4886), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [204028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(7259), 1,
      anon_sym_PIPE,
    ACTIONS(7277), 1,
      anon_sym_extends,
    ACTIONS(5570), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [204047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(3311), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5158), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [204072] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2051), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4948), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [204097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7171), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [204110] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(3183), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5176), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [204135] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(3186), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5177), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [204160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(4347), 1,
      sym_type_annotation,
    ACTIONS(7349), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [204177] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_DOT,
    STATE(3924), 1,
      sym_nested_identifier,
    STATE(3973), 1,
      sym_string,
    STATE(4495), 1,
      sym__module,
  [204202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 1,
      anon_sym_is,
    ACTIONS(4620), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [204217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(7343), 1,
      anon_sym_LT,
    ACTIONS(7345), 1,
      anon_sym_extends,
    STATE(4417), 1,
      sym_object_type,
    STATE(4422), 1,
      sym_type_parameters,
    STATE(4712), 1,
      sym_extends_clause,
  [204242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_AMP,
    ACTIONS(7201), 1,
      anon_sym_PIPE,
    ACTIONS(7203), 1,
      anon_sym_extends,
    ACTIONS(7142), 4,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [204261] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7355), 1,
      sym_identifier,
    ACTIONS(7357), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5117), 1,
      sym__call_signature,
  [204286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(1047), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5107), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [204311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_AMP,
    ACTIONS(7309), 1,
      anon_sym_PIPE,
    ACTIONS(7311), 1,
      anon_sym_extends,
    ACTIONS(5570), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
  [204330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6139), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [204343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 1,
      anon_sym_is,
    ACTIONS(4620), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [204358] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2972), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5038), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [204383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7359), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [204396] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7227), 1,
      anon_sym_QMARK,
    ACTIONS(7361), 1,
      anon_sym_COLON,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5090), 1,
      sym__call_signature,
  [204421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6675), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [204438] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7213), 1,
      anon_sym_STAR,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7363), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5183), 1,
      sym__call_signature,
  [204463] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    STATE(2276), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(5081), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [204488] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(7126), 1,
      anon_sym_extends,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    STATE(1107), 1,
      sym_class_body,
    STATE(4863), 1,
      sym_extends_clause,
    STATE(4971), 1,
      sym_class_heritage,
    STATE(5284), 1,
      sym_implements_clause,
  [204513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7365), 1,
      sym_identifier,
    ACTIONS(7367), 1,
      anon_sym_STAR,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5183), 1,
      sym__call_signature,
  [204538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7369), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4513), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [204560] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7371), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(4997), 1,
      sym__call_signature,
  [204582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4128), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7375), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7373), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [204598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [204614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4596), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7381), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [204630] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7383), 1,
      anon_sym_QMARK,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5110), 1,
      sym__call_signature,
  [204652] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7385), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5157), 1,
      sym__call_signature,
  [204674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_typeof,
    ACTIONS(7387), 1,
      sym_identifier,
    STATE(3660), 1,
      sym_nested_type_identifier,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(3691), 2,
      sym_generic_type,
      sym_type_query,
  [204694] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_typeof,
    ACTIONS(7389), 1,
      sym_identifier,
    STATE(3723), 1,
      sym_nested_type_identifier,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(3796), 2,
      sym_generic_type,
      sym_type_query,
  [204714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [204726] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7391), 1,
      anon_sym_QMARK,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5101), 1,
      sym__call_signature,
  [204748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7393), 1,
      anon_sym_default,
    ACTIONS(7395), 1,
      anon_sym_RBRACE,
    ACTIONS(7397), 1,
      anon_sym_case,
    STATE(4252), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [204766] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7399), 1,
      anon_sym_QMARK,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4963), 1,
      sym__call_signature,
    STATE(4992), 1,
      sym_type_parameters,
  [204788] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7401), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5116), 1,
      sym__call_signature,
  [204810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [204824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4586), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7403), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [204840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7405), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [204852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(7407), 1,
      sym_identifier,
    STATE(5052), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [204870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7409), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [204882] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(7413), 1,
      anon_sym_LBRACK,
    STATE(2152), 1,
      sym_arguments,
    STATE(5103), 1,
      sym_type_arguments,
  [204904] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4390), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [204926] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(7417), 1,
      sym_identifier,
    ACTIONS(7419), 1,
      anon_sym_LBRACK,
    STATE(3285), 1,
      sym_arguments,
    STATE(5193), 1,
      sym_type_arguments,
  [204948] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(7421), 1,
      sym_identifier,
    STATE(5463), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [204966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7425), 1,
      anon_sym_BQUOTE,
    ACTIONS(7427), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7423), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4187), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [204984] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7429), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4341), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [205006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7427), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7433), 1,
      anon_sym_BQUOTE,
    ACTIONS(7431), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4146), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [205024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4225), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4622), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7435), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205040] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7437), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4491), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [205062] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3917), 1,
      anon_sym_typeof,
    ACTIONS(7439), 1,
      sym_identifier,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(2069), 2,
      sym_generic_type,
      sym_type_query,
  [205082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4588), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7441), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7427), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7443), 1,
      anon_sym_BQUOTE,
    ACTIONS(7423), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4187), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [205116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4107), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4588), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7441), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4125), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7447), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7445), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4622), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7435), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4157), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4655), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7449), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
    ACTIONS(5570), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [205198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4655), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7449), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_extends,
  [205230] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7457), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4326), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [205252] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5686), 1,
      anon_sym_LBRACE,
    ACTIONS(5714), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7459), 1,
      anon_sym_LT,
    STATE(4690), 1,
      aux_sym_extends_clause_repeat1,
    STATE(4793), 1,
      sym_type_arguments,
  [205274] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(7461), 1,
      sym_identifier,
    ACTIONS(7463), 1,
      anon_sym_LBRACK,
    STATE(2392), 1,
      sym_arguments,
    STATE(5068), 1,
      sym_type_arguments,
  [205296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4592), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7465), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205312] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7467), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5054), 1,
      sym__call_signature,
  [205334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4096), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4592), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7465), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7469), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7471), 1,
      anon_sym_QMARK_COLON,
    STATE(4360), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [205368] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7473), 1,
      anon_sym_COMMA,
    ACTIONS(7475), 1,
      anon_sym_GT,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4779), 1,
      aux_sym_implements_clause_repeat1,
  [205390] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1985), 1,
      anon_sym_typeof,
    ACTIONS(7387), 1,
      sym_identifier,
    STATE(3660), 1,
      sym_nested_type_identifier,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(3691), 2,
      sym_generic_type,
      sym_type_query,
  [205410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7173), 1,
      anon_sym_is,
    ACTIONS(4620), 5,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [205424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7469), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7471), 1,
      anon_sym_QMARK_COLON,
    STATE(4365), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [205442] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(7479), 1,
      anon_sym_COMMA,
    ACTIONS(7481), 1,
      anon_sym_GT,
    STATE(4765), 1,
      aux_sym_implements_clause_repeat1,
  [205464] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_typeof,
    ACTIONS(7387), 1,
      sym_identifier,
    STATE(3660), 1,
      sym_nested_type_identifier,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(3691), 2,
      sym_generic_type,
      sym_type_query,
  [205484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4121), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7485), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7483), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7487), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5066), 1,
      sym__call_signature,
  [205522] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7489), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4265), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [205544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7427), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7491), 1,
      anon_sym_BQUOTE,
    ACTIONS(7423), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4187), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [205562] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_AMP,
    ACTIONS(7241), 1,
      anon_sym_PIPE,
    ACTIONS(7243), 1,
      anon_sym_extends,
    ACTIONS(7493), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [205580] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(4886), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
  [205598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(5771), 5,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_extends,
  [205612] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7495), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(4997), 1,
      sym__call_signature,
  [205634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4245), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4632), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7497), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
    ACTIONS(4991), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [205668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4632), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7497), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7469), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7471), 1,
      anon_sym_QMARK_COLON,
    STATE(4479), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [205702] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7499), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4478), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [205724] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7501), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4810), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [205746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4651), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7503), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205762] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4130), 1,
      anon_sym_typeof,
    ACTIONS(7387), 1,
      sym_identifier,
    STATE(3660), 1,
      sym_nested_type_identifier,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(3691), 2,
      sym_generic_type,
      sym_type_query,
  [205782] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(7505), 1,
      anon_sym_COMMA,
    ACTIONS(7507), 1,
      anon_sym_GT,
    STATE(4910), 1,
      aux_sym_implements_clause_repeat1,
  [205804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4215), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4624), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7509), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [205820] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3865), 1,
      anon_sym_typeof,
    ACTIONS(7439), 1,
      sym_identifier,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(2069), 2,
      sym_generic_type,
      sym_type_query,
  [205840] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3713), 1,
      anon_sym_typeof,
    ACTIONS(7511), 1,
      sym_identifier,
    STATE(2256), 1,
      sym_nested_type_identifier,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(2356), 2,
      sym_generic_type,
      sym_type_query,
  [205860] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 1,
      anon_sym_typeof,
    ACTIONS(7513), 1,
      sym_identifier,
    STATE(3813), 1,
      sym_nested_type_identifier,
    STATE(5413), 1,
      sym_nested_identifier,
    STATE(3927), 2,
      sym_generic_type,
      sym_type_query,
  [205880] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(7515), 1,
      anon_sym_COMMA,
    ACTIONS(7517), 1,
      anon_sym_GT,
    STATE(4818), 1,
      aux_sym_implements_clause_repeat1,
  [205902] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4008), 1,
      anon_sym_typeof,
    ACTIONS(7511), 1,
      sym_identifier,
    STATE(2256), 1,
      sym_nested_type_identifier,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(2356), 2,
      sym_generic_type,
      sym_type_query,
  [205922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4344), 1,
      anon_sym_typeof,
    ACTIONS(7389), 1,
      sym_identifier,
    STATE(3723), 1,
      sym_nested_type_identifier,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(3796), 2,
      sym_generic_type,
      sym_type_query,
  [205942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 1,
      anon_sym_COMMA,
    ACTIONS(6893), 1,
      anon_sym_LT,
    STATE(3681), 1,
      sym_type_arguments,
    STATE(4641), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5714), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [205962] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(7519), 1,
      anon_sym_COMMA,
    ACTIONS(7521), 1,
      anon_sym_GT,
    STATE(4741), 1,
      aux_sym_implements_clause_repeat1,
  [205984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(5510), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [205998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7427), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7525), 1,
      anon_sym_BQUOTE,
    ACTIONS(7523), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4122), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [206016] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(7527), 1,
      anon_sym_COMMA,
    ACTIONS(7529), 1,
      anon_sym_GT,
    STATE(4837), 1,
      aux_sym_implements_clause_repeat1,
  [206038] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7531), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4370), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [206060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4153), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7535), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7533), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [206076] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
    ACTIONS(5767), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [206094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4209), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7539), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7537), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [206110] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3817), 1,
      anon_sym_typeof,
    ACTIONS(7439), 1,
      sym_identifier,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(2069), 2,
      sym_generic_type,
      sym_type_query,
  [206130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 1,
      anon_sym_typeof,
    ACTIONS(7387), 1,
      sym_identifier,
    STATE(3660), 1,
      sym_nested_type_identifier,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(3691), 2,
      sym_generic_type,
      sym_type_query,
  [206150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(4991), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
  [206168] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(7541), 1,
      anon_sym_export,
    ACTIONS(7543), 1,
      anon_sym_class,
    ACTIONS(7545), 1,
      anon_sym_abstract,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
  [206190] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_COMMA,
    ACTIONS(7549), 1,
      anon_sym_GT,
    STATE(4890), 1,
      aux_sym_implements_clause_repeat1,
  [206212] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_typeof,
    ACTIONS(7387), 1,
      sym_identifier,
    STATE(3660), 1,
      sym_nested_type_identifier,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(3691), 2,
      sym_generic_type,
      sym_type_query,
  [206232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7427), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7553), 1,
      anon_sym_BQUOTE,
    ACTIONS(7551), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4194), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [206250] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(7339), 1,
      sym_identifier,
    STATE(1040), 1,
      sym_nested_identifier,
    STATE(1058), 1,
      sym_string,
    STATE(1067), 1,
      sym__module,
  [206272] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7555), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4286), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [206294] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      sym_identifier,
    ACTIONS(7559), 1,
      anon_sym_COMMA,
    ACTIONS(7561), 1,
      anon_sym_RBRACE,
    STATE(4794), 1,
      sym__import_export_specifier,
    ACTIONS(7563), 2,
      anon_sym_type,
      anon_sym_typeof,
  [206314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1793), 1,
      anon_sym_typeof,
    ACTIONS(7387), 1,
      sym_identifier,
    STATE(3660), 1,
      sym_nested_type_identifier,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(3691), 2,
      sym_generic_type,
      sym_type_query,
  [206334] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7568), 1,
      anon_sym_BQUOTE,
    ACTIONS(7570), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7565), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4187), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [206352] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(7351), 1,
      sym_identifier,
    STATE(3924), 1,
      sym_nested_identifier,
    STATE(3973), 1,
      sym_string,
    STATE(4495), 1,
      sym__module,
  [206374] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    ACTIONS(7351), 1,
      sym_identifier,
    STATE(3924), 1,
      sym_nested_identifier,
    STATE(3973), 1,
      sym_string,
    STATE(4295), 1,
      sym__module,
  [206396] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3785), 1,
      anon_sym_typeof,
    ACTIONS(7387), 1,
      sym_identifier,
    STATE(3660), 1,
      sym_nested_type_identifier,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(3691), 2,
      sym_generic_type,
      sym_type_query,
  [206416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7427), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7575), 1,
      anon_sym_BQUOTE,
    ACTIONS(7573), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4115), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [206434] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(7577), 1,
      anon_sym_COMMA,
    ACTIONS(7579), 1,
      anon_sym_GT,
    STATE(4874), 1,
      aux_sym_implements_clause_repeat1,
  [206456] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7581), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5157), 1,
      sym__call_signature,
  [206478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7427), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7583), 1,
      anon_sym_BQUOTE,
    ACTIONS(7423), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4187), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [206496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7585), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [206508] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4725), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [206530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7592), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7589), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [206546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7393), 1,
      anon_sym_default,
    ACTIONS(7397), 1,
      anon_sym_case,
    ACTIONS(7594), 1,
      anon_sym_RBRACE,
    STATE(4103), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [206564] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
    ACTIONS(4886), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [206582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7596), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(4997), 1,
      sym__call_signature,
  [206604] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7598), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5164), 1,
      sym__call_signature,
  [206626] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_typeof,
    ACTIONS(7387), 1,
      sym_identifier,
    STATE(3660), 1,
      sym_nested_type_identifier,
    STATE(5311), 1,
      sym_nested_identifier,
    STATE(3691), 2,
      sym_generic_type,
      sym_type_query,
  [206646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_AMP,
    ACTIONS(7309), 1,
      anon_sym_PIPE,
    ACTIONS(7311), 1,
      anon_sym_extends,
    ACTIONS(7142), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [206664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7469), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7471), 1,
      anon_sym_QMARK_COLON,
    STATE(4284), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [206682] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7469), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7471), 1,
      anon_sym_QMARK_COLON,
    STATE(4280), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [206700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 1,
      anon_sym_is,
    ACTIONS(4620), 5,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [206714] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(7541), 1,
      anon_sym_export,
    ACTIONS(7545), 1,
      anon_sym_abstract,
    ACTIONS(7600), 1,
      anon_sym_class,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
  [206736] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3975), 1,
      anon_sym_typeof,
    ACTIONS(7511), 1,
      sym_identifier,
    STATE(2256), 1,
      sym_nested_type_identifier,
    STATE(5361), 1,
      sym_nested_identifier,
    STATE(2356), 2,
      sym_generic_type,
      sym_type_query,
  [206756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4624), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7509), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [206772] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7602), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5181), 1,
      sym__call_signature,
  [206794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(5771), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [206808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7151), 1,
      anon_sym_is,
    ACTIONS(4620), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [206822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 1,
      anon_sym_typeof,
    ACTIONS(7389), 1,
      sym_identifier,
    STATE(3723), 1,
      sym_nested_type_identifier,
    STATE(5331), 1,
      sym_nested_identifier,
    STATE(3796), 2,
      sym_generic_type,
      sym_type_query,
  [206842] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7604), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5157), 1,
      sym__call_signature,
  [206864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4653), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [206880] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(7259), 1,
      anon_sym_PIPE,
    ACTIONS(7277), 1,
      anon_sym_extends,
    ACTIONS(7608), 1,
      anon_sym_LBRACE,
    ACTIONS(7610), 1,
      anon_sym_COMMA,
    STATE(4785), 1,
      aux_sym_implements_clause_repeat1,
  [206902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    ACTIONS(6893), 1,
      anon_sym_LT,
    ACTIONS(7612), 1,
      sym_identifier,
    ACTIONS(7614), 1,
      anon_sym_LBRACK,
    STATE(2665), 1,
      sym_arguments,
    STATE(5060), 1,
      sym_type_arguments,
  [206924] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7616), 1,
      anon_sym_QMARK,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5036), 1,
      sym__call_signature,
  [206946] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7618), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4392), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [206968] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7620), 1,
      anon_sym_QMARK,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5015), 1,
      sym__call_signature,
  [206990] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7622), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4001), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [207012] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7624), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3999), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [207034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7469), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7471), 1,
      anon_sym_QMARK_COLON,
    STATE(4394), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [207052] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7626), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3992), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [207074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4590), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7628), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [207090] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3985), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [207112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7632), 1,
      anon_sym_EQ,
    ACTIONS(4406), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [207126] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7267), 1,
      anon_sym_EQ,
    ACTIONS(7271), 1,
      anon_sym_COLON,
    STATE(4589), 1,
      sym_type_annotation,
    STATE(5198), 1,
      sym__initializer,
    ACTIONS(7635), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [207146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7469), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7471), 1,
      anon_sym_QMARK_COLON,
    STATE(4332), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [207164] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3833), 1,
      anon_sym_typeof,
    ACTIONS(7637), 1,
      sym_identifier,
    STATE(2540), 1,
      sym_nested_type_identifier,
    STATE(5570), 1,
      sym_nested_identifier,
    STATE(2755), 2,
      sym_generic_type,
      sym_type_query,
  [207184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2809), 1,
      anon_sym_LBRACE,
    ACTIONS(6523), 1,
      anon_sym_LBRACK,
    ACTIONS(7639), 1,
      sym_identifier,
    STATE(3986), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [207202] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    ACTIONS(7339), 1,
      sym_identifier,
    STATE(1040), 1,
      sym_nested_identifier,
    STATE(1058), 1,
      sym_string,
    STATE(1143), 1,
      sym__module,
  [207224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4255), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7643), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7641), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [207240] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 1,
      anon_sym_typeof,
    ACTIONS(7439), 1,
      sym_identifier,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(2069), 2,
      sym_generic_type,
      sym_type_query,
  [207260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4582), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7645), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [207276] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(5570), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
  [207294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(5767), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
  [207312] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7469), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7471), 1,
      anon_sym_QMARK_COLON,
    STATE(4328), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [207330] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    ACTIONS(7647), 1,
      anon_sym_QMARK,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3964), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [207352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(5510), 5,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_extends,
  [207366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    ACTIONS(7469), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7471), 1,
      anon_sym_QMARK_COLON,
    STATE(4339), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [207384] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_PIPE,
    ACTIONS(7299), 1,
      anon_sym_extends,
    ACTIONS(7651), 1,
      anon_sym_QMARK,
    ACTIONS(7649), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [207404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4235), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4616), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7653), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [207420] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_typeof,
    ACTIONS(7439), 1,
      sym_identifier,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(2069), 2,
      sym_generic_type,
      sym_type_query,
  [207440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4604), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7655), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [207456] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3751), 1,
      anon_sym_typeof,
    ACTIONS(7439), 1,
      sym_identifier,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(2069), 2,
      sym_generic_type,
      sym_type_query,
  [207476] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3885), 1,
      anon_sym_typeof,
    ACTIONS(7657), 1,
      sym_identifier,
    STATE(2913), 1,
      sym_nested_type_identifier,
    STATE(5530), 1,
      sym_nested_identifier,
    STATE(3161), 2,
      sym_generic_type,
      sym_type_query,
  [207496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7249), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4133), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7661), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7659), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [207524] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7663), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5033), 1,
      sym__call_signature,
  [207546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3851), 1,
      anon_sym_typeof,
    ACTIONS(7439), 1,
      sym_identifier,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(5266), 1,
      sym_nested_identifier,
    STATE(2069), 2,
      sym_generic_type,
      sym_type_query,
  [207566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7665), 1,
      anon_sym_default,
    ACTIONS(7668), 1,
      anon_sym_RBRACE,
    ACTIONS(7670), 1,
      anon_sym_case,
    STATE(4252), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [207584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      sym_identifier,
    ACTIONS(7673), 1,
      anon_sym_COMMA,
    ACTIONS(7675), 1,
      anon_sym_RBRACE,
    STATE(4758), 1,
      sym__import_export_specifier,
    ACTIONS(7563), 2,
      anon_sym_type,
      anon_sym_typeof,
  [207604] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3675), 1,
      anon_sym_typeof,
    ACTIONS(7637), 1,
      sym_identifier,
    STATE(2540), 1,
      sym_nested_type_identifier,
    STATE(5570), 1,
      sym_nested_identifier,
    STATE(2755), 2,
      sym_generic_type,
      sym_type_query,
  [207624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4197), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4616), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7653), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [207640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7247), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(7677), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [207668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4261), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [207687] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4750), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [207706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
    ACTIONS(7681), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(4291), 1,
      sym_statement_block,
    ACTIONS(7683), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [207738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7685), 1,
      sym__automatic_semicolon,
    ACTIONS(1927), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      anon_sym_AMP,
    ACTIONS(5771), 4,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_extends,
  [207764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      anon_sym_AMP,
    ACTIONS(7689), 1,
      anon_sym_PIPE,
    ACTIONS(7691), 1,
      anon_sym_extends,
    ACTIONS(4886), 2,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
  [207781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7275), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2274), 1,
      sym_statement_block,
    ACTIONS(7693), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [207807] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4935), 1,
      sym__call_signature,
    STATE(4992), 1,
      sym_type_parameters,
  [207826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7695), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3281), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3061), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7699), 1,
      anon_sym_EQ_GT,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [207885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4934), 1,
      sym__call_signature,
    STATE(4992), 1,
      sym_type_parameters,
  [207904] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4353), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [207923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3567), 1,
      sym_statement_block,
    ACTIONS(7289), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [207949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7265), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7289), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [207971] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4458), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [207990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4956), 1,
      sym__call_signature,
    STATE(4992), 1,
      sym_type_parameters,
  [208020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3025), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7708), 1,
      anon_sym_EQ_GT,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [208068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3577), 1,
      sym_statement_block,
    ACTIONS(7287), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [208083] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4276), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [208102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3562), 1,
      sym_statement_block,
    ACTIONS(7285), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [208117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4984), 1,
      sym__call_signature,
    STATE(4992), 1,
      sym_type_parameters,
  [208147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7711), 1,
      sym__automatic_semicolon,
    ACTIONS(2024), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(5767), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [208177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(5510), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [208190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7719), 1,
      anon_sym_EQ_GT,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [208205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4914), 1,
      sym__initializer,
    ACTIONS(7722), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [208231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7724), 1,
      sym__automatic_semicolon,
    ACTIONS(2001), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3982), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [208263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1965), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208274] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7267), 1,
      anon_sym_EQ,
    ACTIONS(7726), 1,
      anon_sym_COMMA,
    ACTIONS(7728), 1,
      anon_sym_RBRACE,
    STATE(4897), 1,
      aux_sym_enum_body_repeat1,
    STATE(5009), 1,
      sym__initializer,
  [208293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7730), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [208304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3273), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208315] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(7545), 1,
      anon_sym_abstract,
    ACTIONS(7732), 1,
      anon_sym_class,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
  [208334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3217), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [208356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_is,
    ACTIONS(7249), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [208369] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3989), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [208388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
    ACTIONS(7734), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(3998), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [208424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7736), 1,
      sym__automatic_semicolon,
    ACTIONS(1911), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208437] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      sym_identifier,
    ACTIONS(7738), 1,
      anon_sym_RBRACE,
    STATE(5077), 1,
      sym__import_export_specifier,
    ACTIONS(7563), 2,
      anon_sym_type,
      anon_sym_typeof,
  [208454] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4000), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [208473] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4002), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [208492] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5049), 1,
      sym__call_signature,
  [208511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(5570), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
  [208528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7068), 1,
      anon_sym_LBRACE,
    ACTIONS(7746), 1,
      anon_sym_COLON,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [208543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [208554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7748), 1,
      anon_sym_EQ_GT,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [208569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4434), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [208588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      anon_sym_AMP,
    ACTIONS(7689), 1,
      anon_sym_PIPE,
    ACTIONS(7691), 1,
      anon_sym_extends,
    ACTIONS(4991), 2,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
  [208605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5154), 1,
      sym__call_signature,
  [208624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(5570), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [208641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(7751), 1,
      anon_sym_class,
    ACTIONS(7753), 1,
      anon_sym_abstract,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
  [208660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_LBRACE,
    STATE(144), 1,
      sym_statement_block,
    ACTIONS(7755), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [208675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(5767), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
  [208692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7287), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(5510), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_extends,
  [208716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4989), 1,
      sym__call_signature,
    STATE(4992), 1,
      sym_type_parameters,
  [208746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7759), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [208757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7761), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
    ACTIONS(7765), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208796] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [208815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
    ACTIONS(7767), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208832] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5136), 1,
      sym__call_signature,
  [208851] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4398), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [208870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4727), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [208889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7769), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208900] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4952), 1,
      sym__call_signature,
    STATE(4992), 1,
      sym_type_parameters,
  [208919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7237), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [208930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    ACTIONS(7345), 1,
      anon_sym_extends,
    STATE(1130), 1,
      sym_object_type,
    STATE(4711), 1,
      sym_extends_clause,
  [208949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2950), 1,
      sym_statement_block,
    ACTIONS(7771), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [208964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7773), 1,
      anon_sym_EQ_GT,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [208979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4954), 1,
      sym__call_signature,
    STATE(4992), 1,
      sym_type_parameters,
  [208998] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(4994), 1,
      sym__call_signature,
  [209017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7279), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7245), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [209039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4278), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [209058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4731), 1,
      sym__initializer,
    ACTIONS(7776), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [209073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7778), 1,
      anon_sym_EQ_GT,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [209088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7781), 1,
      anon_sym_EQ_GT,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [209103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7281), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4424), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [209133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(1053), 1,
      sym_statement_block,
    ACTIONS(7771), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [209148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5003), 1,
      sym__call_signature,
  [209167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7784), 1,
      anon_sym_EQ_GT,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [209182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4842), 1,
      sym__initializer,
    ACTIONS(7787), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [209197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5211), 1,
      sym__call_signature,
  [209216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7789), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7791), 1,
      anon_sym_EQ_GT,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [209242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_DOT,
    ACTIONS(4873), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [209257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7794), 1,
      anon_sym_EQ_GT,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [209272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      anon_sym_AMP,
    ACTIONS(7689), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 3,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_extends,
  [209287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7797), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4834), 1,
      sym__initializer,
    ACTIONS(7799), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [209313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      sym_identifier,
    ACTIONS(7801), 1,
      anon_sym_RBRACE,
    STATE(5124), 1,
      sym__import_export_specifier,
    ACTIONS(7563), 2,
      anon_sym_type,
      anon_sym_typeof,
  [209330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(7259), 1,
      anon_sym_PIPE,
    ACTIONS(7277), 1,
      anon_sym_extends,
    ACTIONS(7803), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [209358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3579), 1,
      sym_statement_block,
    ACTIONS(7263), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [209373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3257), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2274), 1,
      sym_statement_block,
    ACTIONS(7755), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [209399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3233), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209410] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4435), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [209429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3580), 1,
      sym_statement_block,
    ACTIONS(7265), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [209444] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_COLON,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(7805), 1,
      anon_sym_RBRACE,
    STATE(4824), 1,
      aux_sym_object_pattern_repeat1,
  [209463] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4375), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [209482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3565), 1,
      sym_statement_block,
    ACTIONS(7261), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [209497] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5175), 1,
      sym__call_signature,
  [209516] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5174), 1,
      sym__call_signature,
  [209535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7359), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [209546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7807), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3229), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7809), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209579] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5171), 1,
      sym__call_signature,
  [209598] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5166), 1,
      sym__call_signature,
  [209617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7811), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209628] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4368), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [209647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7592), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7283), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7813), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7263), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4277), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [209710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7815), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
    ACTIONS(7817), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [209738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(4262), 1,
      sym_statement_block,
    ACTIONS(7693), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [209753] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5147), 1,
      sym__call_signature,
  [209772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7261), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209794] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4372), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [209813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      sym_identifier,
    ACTIONS(7819), 1,
      anon_sym_RBRACE,
    STATE(5124), 1,
      sym__import_export_specifier,
    ACTIONS(7563), 2,
      anon_sym_type,
      anon_sym_typeof,
  [209830] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4266), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [209849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7821), 1,
      anon_sym_EQ_GT,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [209864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3225), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7824), 1,
      anon_sym_EQ_GT,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [209901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209912] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4355), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [209931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7827), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3205), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5106), 1,
      sym__call_signature,
  [209972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(1048), 1,
      sym_statement_block,
    ACTIONS(7755), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [209987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7829), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [209998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7831), 1,
      anon_sym_EQ_GT,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [210013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4930), 1,
      sym__call_signature,
    STATE(4992), 1,
      sym_type_parameters,
  [210032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3285), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3269), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210065] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7267), 1,
      anon_sym_EQ,
    ACTIONS(7834), 1,
      anon_sym_COMMA,
    ACTIONS(7836), 1,
      anon_sym_RBRACE,
    STATE(4864), 1,
      aux_sym_enum_body_repeat1,
    STATE(5009), 1,
      sym__initializer,
  [210084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3017), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210106] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(7345), 1,
      anon_sym_extends,
    STATE(4373), 1,
      sym_object_type,
    STATE(4847), 1,
      sym_extends_clause,
  [210125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7142), 2,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
  [210142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2976), 1,
      sym_statement_block,
    ACTIONS(7755), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [210157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      anon_sym_AMP,
    ACTIONS(7689), 1,
      anon_sym_PIPE,
    ACTIONS(7691), 1,
      anon_sym_extends,
    ACTIONS(5767), 2,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
  [210174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      anon_sym_AMP,
    ACTIONS(5510), 4,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_extends,
  [210187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4517), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [210206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4833), 1,
      sym__initializer,
    ACTIONS(7838), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [210221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    ACTIONS(7459), 1,
      anon_sym_LT,
    STATE(4793), 1,
      sym_type_arguments,
    ACTIONS(5902), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [210238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7106), 1,
      anon_sym_LBRACE,
    ACTIONS(7746), 1,
      anon_sym_COLON,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [210253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2044), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3073), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_LBRACE,
    STATE(158), 1,
      sym_statement_block,
    ACTIONS(7771), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [210301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2420), 1,
      sym_statement_block,
    ACTIONS(7771), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [210316] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5011), 1,
      sym__call_signature,
  [210335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3093), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3101), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 3,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
  [210383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(4991), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [210400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
    ACTIONS(7840), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [210417] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4412), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [210436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(5771), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [210449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(4886), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [210466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7842), 1,
      anon_sym_EQ_GT,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [210481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5080), 1,
      sym__call_signature,
  [210500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      anon_sym_AMP,
    ACTIONS(7689), 1,
      anon_sym_PIPE,
    ACTIONS(7691), 1,
      anon_sym_extends,
    ACTIONS(5570), 2,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
  [210517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7845), 1,
      anon_sym_EQ_GT,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [210543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4790), 1,
      sym__initializer,
    ACTIONS(7848), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [210558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3181), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4924), 1,
      sym__initializer,
    ACTIONS(7850), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [210584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5079), 1,
      sym__call_signature,
  [210603] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_COLON,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(7852), 1,
      anon_sym_RBRACE,
    STATE(4771), 1,
      aux_sym_object_pattern_repeat1,
  [210622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3209), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3569), 1,
      sym_statement_block,
    ACTIONS(7315), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [210648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2420), 1,
      sym_statement_block,
    ACTIONS(7683), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [210663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      sym_identifier,
    ACTIONS(7854), 1,
      anon_sym_RBRACE,
    STATE(5077), 1,
      sym__import_export_specifier,
    ACTIONS(7563), 2,
      anon_sym_type,
      anon_sym_typeof,
  [210680] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 3,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_extends,
  [210695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2068), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210728] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4396), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [210747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7856), 1,
      anon_sym_EQ_GT,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [210762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7859), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3293), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3173), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(4991), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
  [210812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3149), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7861), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [210856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7068), 1,
      anon_sym_EQ_GT,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [210871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210893] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4378), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [210912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3566), 1,
      sym_statement_block,
    ACTIONS(7237), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [210927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7863), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210938] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5031), 1,
      sym__call_signature,
  [210957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [210968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7223), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [210979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7865), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [210990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(5771), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_extends,
  [211003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7867), 1,
      anon_sym_EQ_GT,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [211029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4792), 1,
      sym__initializer,
    ACTIONS(7870), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [211044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7872), 1,
      anon_sym_EQ_GT,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [211070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3586), 1,
      sym_statement_block,
    ACTIONS(7283), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [211096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(4886), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
  [211113] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5084), 1,
      sym__call_signature,
  [211132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4807), 1,
      sym__initializer,
    ACTIONS(7875), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [211147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3133), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4891), 1,
      sym__initializer,
    ACTIONS(7877), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [211195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7879), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7881), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [211239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7106), 1,
      anon_sym_EQ_GT,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [211254] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5083), 1,
      sym__call_signature,
  [211273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_EQ,
    STATE(4812), 1,
      sym__initializer,
    ACTIONS(7883), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [211288] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5045), 1,
      sym__call_signature,
  [211307] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5046), 1,
      sym__call_signature,
  [211326] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3801), 1,
      sym_formal_parameters,
    STATE(4288), 1,
      sym__call_signature,
    STATE(5151), 1,
      sym_type_parameters,
  [211345] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(7259), 1,
      anon_sym_PIPE,
    ACTIONS(7277), 1,
      anon_sym_extends,
    ACTIONS(7142), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [211362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3574), 1,
      sym_statement_block,
    ACTIONS(7247), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [211377] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4965), 1,
      sym__call_signature,
    STATE(4992), 1,
      sym_type_parameters,
  [211396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_COLON,
    STATE(5192), 1,
      sym_type_annotation,
    ACTIONS(4406), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [211411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3572), 1,
      sym_statement_block,
    ACTIONS(7275), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [211426] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_formal_parameters,
    STATE(4324), 1,
      sym__call_signature,
    STATE(5044), 1,
      sym_type_parameters,
  [211445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    STATE(3681), 1,
      sym_type_arguments,
    ACTIONS(5902), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [211460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_AMP,
    ACTIONS(7259), 1,
      anon_sym_PIPE,
    ACTIONS(7277), 1,
      anon_sym_extends,
    ACTIONS(7885), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [211477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    STATE(3584), 1,
      sym_statement_block,
    ACTIONS(7281), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [211492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3297), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7887), 1,
      anon_sym_EQ_GT,
    STATE(5089), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [211518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_AMP,
    ACTIONS(7455), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(7803), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [211535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COLON,
    ACTIONS(7890), 1,
      anon_sym_EQ_GT,
    STATE(5213), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [211550] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym_formal_parameters,
    STATE(4992), 1,
      sym_type_parameters,
    STATE(5055), 1,
      sym__call_signature,
  [211569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [211591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [211601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4292), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [211611] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5187), 1,
      sym_type_parameters,
    STATE(5219), 1,
      sym_formal_parameters,
  [211627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4942), 1,
      sym_type_parameters,
    STATE(5335), 1,
      sym_formal_parameters,
  [211643] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7895), 1,
      anon_sym_RPAREN,
  [211659] = 4,
    ACTIONS(7897), 1,
      anon_sym_SQUOTE,
    ACTIONS(7901), 1,
      sym_comment,
    STATE(4617), 1,
      aux_sym_string_repeat2,
    ACTIONS(7899), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [211673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(7903), 1,
      anon_sym_export,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
  [211689] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(7905), 1,
      anon_sym_DQUOTE,
    STATE(4611), 1,
      aux_sym_string_repeat1,
    ACTIONS(7907), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [211703] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(7909), 1,
      anon_sym_SQUOTE,
    STATE(4617), 1,
      aux_sym_string_repeat2,
    ACTIONS(7899), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [211717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(7911), 1,
      anon_sym_QMARK,
  [211733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5019), 1,
      sym_type_parameters,
    STATE(5507), 1,
      sym_formal_parameters,
  [211749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(7913), 1,
      anon_sym_RBRACK,
  [211765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7915), 1,
      anon_sym_RPAREN,
  [211781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(7917), 1,
      anon_sym_QMARK,
  [211797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(7919), 1,
      anon_sym_RBRACK,
  [211813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(7921), 1,
      anon_sym_QMARK,
  [211829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(7923), 1,
      anon_sym_QMARK,
  [211845] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(7909), 1,
      anon_sym_DQUOTE,
    STATE(4616), 1,
      aux_sym_string_repeat1,
    ACTIONS(7925), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [211859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4933), 1,
      sym_type_parameters,
    STATE(5281), 1,
      sym_formal_parameters,
  [211875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4947), 1,
      sym_type_parameters,
    STATE(5460), 1,
      sym_formal_parameters,
  [211891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5178), 1,
      sym_type_parameters,
    STATE(5364), 1,
      sym_formal_parameters,
  [211907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(7927), 1,
      anon_sym_RBRACK,
  [211923] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5196), 1,
      sym_type_parameters,
    STATE(5433), 1,
      sym_formal_parameters,
  [211939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(7929), 1,
      anon_sym_QMARK,
  [211955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7931), 1,
      anon_sym_COLON,
  [211971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(7933), 1,
      anon_sym_class,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
  [211987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(7935), 1,
      anon_sym_RBRACK,
  [212003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(7937), 1,
      anon_sym_QMARK,
  [212019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    STATE(2389), 2,
      sym_template_string,
      sym_arguments,
  [212033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(7939), 1,
      anon_sym_RBRACK,
  [212049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7249), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [212059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(7941), 1,
      anon_sym_QMARK,
  [212075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(7943), 1,
      anon_sym_class,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
  [212091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(4074), 1,
      sym_formal_parameters,
    STATE(5208), 1,
      sym_type_parameters,
  [212107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4957), 1,
      sym_type_parameters,
    STATE(5544), 1,
      sym_formal_parameters,
  [212123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7945), 1,
      anon_sym_COLON,
  [212139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6989), 1,
      anon_sym_EQ,
    STATE(5185), 1,
      sym_default_type,
    ACTIONS(7947), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [212153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(7949), 1,
      anon_sym_QMARK,
  [212169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7951), 1,
      anon_sym_COMMA,
    STATE(4563), 1,
      aux_sym_array_repeat1,
    ACTIONS(5959), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [212183] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(7954), 1,
      anon_sym_SQUOTE,
    STATE(4702), 1,
      aux_sym_string_repeat2,
    ACTIONS(7956), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [212197] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7958), 1,
      anon_sym_COLON,
  [212213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(7960), 1,
      anon_sym_RBRACK,
  [212229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_COMMA,
    ACTIONS(7962), 1,
      anon_sym_EQ,
    ACTIONS(7964), 1,
      anon_sym_RBRACK,
    STATE(4778), 1,
      aux_sym_array_pattern_repeat1,
  [212245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5212), 1,
      sym_type_parameters,
    STATE(5269), 1,
      sym_formal_parameters,
  [212261] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7966), 1,
      anon_sym_COLON,
  [212277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7968), 1,
      anon_sym_COMMA,
    STATE(4570), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5902), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [212291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4968), 1,
      sym_type_parameters,
    STATE(5572), 1,
      sym_formal_parameters,
  [212307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(7971), 1,
      anon_sym_QMARK,
  [212323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7973), 1,
      anon_sym_COLON,
  [212339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7267), 1,
      anon_sym_EQ,
    STATE(5200), 1,
      sym__initializer,
    ACTIONS(7975), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [212353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5069), 1,
      sym_type_parameters,
    STATE(5525), 1,
      sym_formal_parameters,
  [212369] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(7977), 1,
      anon_sym_DQUOTE,
    STATE(4616), 1,
      aux_sym_string_repeat1,
    ACTIONS(7925), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [212383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7979), 1,
      anon_sym_COLON,
  [212399] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(7977), 1,
      anon_sym_SQUOTE,
    STATE(4617), 1,
      aux_sym_string_repeat2,
    ACTIONS(7899), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [212413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7981), 1,
      anon_sym_COLON,
  [212429] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(7954), 1,
      anon_sym_DQUOTE,
    STATE(4674), 1,
      aux_sym_string_repeat1,
    ACTIONS(7983), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [212443] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(7985), 1,
      anon_sym_SQUOTE,
    STATE(4533), 1,
      aux_sym_string_repeat2,
    ACTIONS(7987), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [212457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7989), 1,
      anon_sym_RPAREN,
  [212473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7991), 1,
      anon_sym_COLON,
  [212489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7993), 1,
      anon_sym_COLON,
  [212505] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(7995), 1,
      anon_sym_COLON,
  [212521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    STATE(4618), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7999), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [212535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8001), 1,
      anon_sym_QMARK,
  [212551] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(7905), 1,
      anon_sym_SQUOTE,
    STATE(4604), 1,
      aux_sym_string_repeat2,
    ACTIONS(8003), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [212565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7267), 1,
      anon_sym_EQ,
    STATE(5040), 1,
      sym__initializer,
    ACTIONS(8005), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [212579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_BQUOTE,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    STATE(2153), 2,
      sym_template_string,
      sym_arguments,
  [212593] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8007), 1,
      anon_sym_QMARK,
  [212609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8009), 1,
      anon_sym_QMARK,
  [212625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    STATE(4631), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8011), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [212639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8013), 1,
      anon_sym_COLON,
  [212655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8015), 1,
      anon_sym_QMARK,
  [212671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(8017), 1,
      anon_sym_RBRACK,
  [212687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 1,
      anon_sym_COMMA,
    STATE(4641), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5714), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [212701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8019), 1,
      anon_sym_COLON,
  [212717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    ACTIONS(8021), 1,
      anon_sym_COMMA,
    STATE(4599), 1,
      aux_sym_extends_clause_repeat1,
  [212733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(8024), 1,
      anon_sym_RBRACK,
  [212749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8026), 1,
      anon_sym_COMMA,
    STATE(4601), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8029), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [212763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8031), 1,
      anon_sym_QMARK,
  [212779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5153), 1,
      sym_type_parameters,
    STATE(5340), 1,
      sym_formal_parameters,
  [212795] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_SQUOTE,
    STATE(4617), 1,
      aux_sym_string_repeat2,
    ACTIONS(7899), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [212809] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8035), 1,
      anon_sym_COLON,
  [212825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8037), 1,
      anon_sym_QMARK,
  [212841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8039), 1,
      anon_sym_COLON,
  [212857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8041), 1,
      anon_sym_QMARK,
  [212873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5017), 1,
      sym_type_parameters,
    STATE(5230), 1,
      sym_formal_parameters,
  [212889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(8043), 1,
      anon_sym_class,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
  [212905] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_DQUOTE,
    STATE(4616), 1,
      aux_sym_string_repeat1,
    ACTIONS(7925), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [212919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7267), 1,
      anon_sym_EQ,
    STATE(5009), 1,
      sym__initializer,
    ACTIONS(8045), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [212933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8047), 1,
      anon_sym_COLON,
  [212949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    STATE(4629), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8049), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [212963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5000), 1,
      sym_type_parameters,
    STATE(5522), 1,
      sym_formal_parameters,
  [212979] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8051), 1,
      anon_sym_DQUOTE,
    STATE(4616), 1,
      aux_sym_string_repeat1,
    ACTIONS(8053), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [212993] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8056), 1,
      anon_sym_SQUOTE,
    STATE(4617), 1,
      aux_sym_string_repeat2,
    ACTIONS(8058), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [213007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    STATE(4601), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8061), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [213021] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5114), 1,
      sym_type_parameters,
    STATE(5326), 1,
      sym_formal_parameters,
  [213037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    STATE(4601), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8063), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [213051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8065), 1,
      anon_sym_COLON,
  [213067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8067), 1,
      anon_sym_RPAREN,
  [213083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8069), 1,
      anon_sym_COLON,
  [213099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7409), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [213109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7405), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [213119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5091), 1,
      sym_type_parameters,
    STATE(5575), 1,
      sym_formal_parameters,
  [213135] = 4,
    ACTIONS(7897), 1,
      anon_sym_DQUOTE,
    ACTIONS(7901), 1,
      sym_comment,
    STATE(4616), 1,
      aux_sym_string_repeat1,
    ACTIONS(7925), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [213149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
  [213165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    STATE(4601), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8073), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [213179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_BQUOTE,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    STATE(2666), 2,
      sym_template_string,
      sym_arguments,
  [213193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    STATE(4601), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8075), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [213207] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8077), 1,
      anon_sym_SQUOTE,
    STATE(4617), 1,
      aux_sym_string_repeat2,
    ACTIONS(7899), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [213221] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(7985), 1,
      anon_sym_DQUOTE,
    STATE(4542), 1,
      aux_sym_string_repeat1,
    ACTIONS(8079), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [213235] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8081), 1,
      anon_sym_DQUOTE,
    STATE(4700), 1,
      aux_sym_string_repeat1,
    ACTIONS(8083), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [213249] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8085), 1,
      anon_sym_SQUOTE,
    STATE(4686), 1,
      aux_sym_string_repeat2,
    ACTIONS(8087), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [213263] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8089), 1,
      anon_sym_QMARK,
  [213279] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8081), 1,
      anon_sym_SQUOTE,
    STATE(4705), 1,
      aux_sym_string_repeat2,
    ACTIONS(8091), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [213293] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8093), 1,
      anon_sym_COLON,
  [213309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(8095), 1,
      anon_sym_RBRACK,
  [213325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 1,
      anon_sym_COMMA,
    STATE(4570), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(8097), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [213339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 1,
      anon_sym_COMMA,
    STATE(4570), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(8099), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [213353] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8077), 1,
      anon_sym_DQUOTE,
    STATE(4616), 1,
      aux_sym_string_repeat1,
    ACTIONS(7925), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [213367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5159), 1,
      sym_type_parameters,
    STATE(5245), 1,
      sym_formal_parameters,
  [213383] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8101), 1,
      anon_sym_DQUOTE,
    STATE(4627), 1,
      aux_sym_string_repeat1,
    ACTIONS(8103), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [213397] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8105), 1,
      anon_sym_DQUOTE,
    STATE(4576), 1,
      aux_sym_string_repeat1,
    ACTIONS(8107), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [213411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5109), 1,
      sym_type_parameters,
    STATE(5536), 1,
      sym_formal_parameters,
  [213427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8109), 1,
      anon_sym_COLON,
  [213443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8111), 1,
      anon_sym_QMARK,
  [213459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8113), 1,
      anon_sym_RPAREN,
  [213475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8115), 1,
      anon_sym_COLON,
  [213491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(8117), 1,
      anon_sym_RBRACK,
  [213507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8119), 1,
      anon_sym_COLON,
  [213523] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8121), 1,
      anon_sym_RPAREN,
  [213539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      sym_identifier,
    STATE(5124), 1,
      sym__import_export_specifier,
    ACTIONS(7563), 2,
      anon_sym_type,
      anon_sym_typeof,
  [213553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8123), 1,
      anon_sym_COLON,
  [213569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8125), 1,
      anon_sym_COLON,
  [213585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4483), 1,
      anon_sym_LBRACE,
    ACTIONS(7090), 1,
      anon_sym_STAR,
    STATE(5249), 2,
      sym_namespace_import,
      sym_named_imports,
  [213599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5032), 1,
      sym_type_parameters,
    STATE(5466), 1,
      sym_formal_parameters,
  [213615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5128), 1,
      sym_type_parameters,
    STATE(5430), 1,
      sym_formal_parameters,
  [213631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5059), 1,
      sym_type_parameters,
    STATE(5417), 1,
      sym_formal_parameters,
  [213647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8127), 1,
      anon_sym_QMARK,
  [213663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5029), 1,
      sym_type_parameters,
    STATE(5471), 1,
      sym_formal_parameters,
  [213679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6792), 1,
      anon_sym_EQ_GT,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [213691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8129), 1,
      anon_sym_QMARK,
  [213707] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8131), 1,
      anon_sym_QMARK,
  [213723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5122), 1,
      sym_type_parameters,
    STATE(5401), 1,
      sym_formal_parameters,
  [213739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8133), 1,
      anon_sym_COLON,
  [213755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8135), 1,
      anon_sym_COLON,
  [213771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8137), 1,
      anon_sym_EQ_GT,
    ACTIONS(4459), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [213783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(8139), 1,
      anon_sym_class,
    STATE(3611), 1,
      aux_sym_export_statement_repeat1,
    STATE(3633), 1,
      sym_decorator,
  [213799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4938), 1,
      sym_type_parameters,
    STATE(5554), 1,
      sym_formal_parameters,
  [213815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8141), 1,
      anon_sym_RPAREN,
  [213831] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(8143), 1,
      anon_sym_RBRACK,
  [213847] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8145), 1,
      anon_sym_DQUOTE,
    STATE(4616), 1,
      aux_sym_string_repeat1,
    ACTIONS(7925), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [213861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_from,
    STATE(5191), 1,
      sym__from_clause,
    ACTIONS(8149), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [213875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7585), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [213885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
    ACTIONS(8151), 1,
      anon_sym_COLON,
  [213901] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8153), 1,
      anon_sym_DQUOTE,
    STATE(4642), 1,
      aux_sym_string_repeat1,
    ACTIONS(8155), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [213915] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8153), 1,
      anon_sym_SQUOTE,
    STATE(4632), 1,
      aux_sym_string_repeat2,
    ACTIONS(8157), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [213929] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8159), 1,
      anon_sym_QMARK,
  [213945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_COLON,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    ACTIONS(8161), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [213959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_BQUOTE,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    STATE(3293), 2,
      sym_template_string,
      sym_arguments,
  [213973] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8085), 1,
      anon_sym_DQUOTE,
    STATE(4687), 1,
      aux_sym_string_repeat1,
    ACTIONS(8163), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [213987] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8101), 1,
      anon_sym_SQUOTE,
    STATE(4530), 1,
      aux_sym_string_repeat2,
    ACTIONS(8165), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [214001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5430), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [214011] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8167), 1,
      anon_sym_SQUOTE,
    STATE(4617), 1,
      aux_sym_string_repeat2,
    ACTIONS(7899), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [214025] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8167), 1,
      anon_sym_DQUOTE,
    STATE(4616), 1,
      aux_sym_string_repeat1,
    ACTIONS(7925), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [214039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_from,
    STATE(5190), 1,
      sym__from_clause,
    ACTIONS(8169), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [214053] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(8097), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8171), 1,
      anon_sym_LBRACE,
    STATE(4599), 1,
      aux_sym_extends_clause_repeat1,
  [214069] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(8099), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8173), 1,
      anon_sym_LBRACE,
    STATE(4599), 1,
      aux_sym_extends_clause_repeat1,
  [214085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5686), 1,
      anon_sym_LBRACE,
    ACTIONS(5714), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4690), 1,
      aux_sym_extends_clause_repeat1,
  [214101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8175), 1,
      anon_sym_QMARK,
  [214117] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8105), 1,
      anon_sym_SQUOTE,
    STATE(4578), 1,
      aux_sym_string_repeat2,
    ACTIONS(8177), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [214131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      sym_identifier,
    STATE(5077), 1,
      sym__import_export_specifier,
    ACTIONS(7563), 2,
      anon_sym_type,
      anon_sym_typeof,
  [214145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_COMMA,
    STATE(4620), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8179), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [214159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5149), 1,
      sym_type_parameters,
    STATE(5354), 1,
      sym_formal_parameters,
  [214175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4949), 1,
      sym_type_parameters,
    STATE(5583), 1,
      sym_formal_parameters,
  [214191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8181), 1,
      anon_sym_QMARK,
  [214207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(8183), 1,
      anon_sym_RBRACK,
  [214223] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8185), 1,
      anon_sym_DQUOTE,
    STATE(4616), 1,
      aux_sym_string_repeat1,
    ACTIONS(7925), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [214237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(8187), 1,
      anon_sym_RBRACK,
  [214253] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8145), 1,
      anon_sym_SQUOTE,
    STATE(4617), 1,
      aux_sym_string_repeat2,
    ACTIONS(7899), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [214267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_AMP,
    ACTIONS(7715), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
    ACTIONS(8189), 1,
      anon_sym_RBRACK,
  [214283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 1,
      anon_sym_EQ_GT,
    ACTIONS(7687), 1,
      anon_sym_AMP,
    ACTIONS(7689), 1,
      anon_sym_PIPE,
    ACTIONS(7691), 1,
      anon_sym_extends,
  [214299] = 4,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8185), 1,
      anon_sym_SQUOTE,
    STATE(4617), 1,
      aux_sym_string_repeat2,
    ACTIONS(7899), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [214313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      anon_sym_AMP,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
    ACTIONS(8191), 1,
      anon_sym_QMARK,
  [214329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_COMMA,
    ACTIONS(7962), 1,
      anon_sym_EQ,
    ACTIONS(8193), 1,
      anon_sym_RBRACK,
    STATE(4893), 1,
      aux_sym_array_pattern_repeat1,
  [214345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(8195), 1,
      anon_sym_RBRACE,
    STATE(4733), 1,
      aux_sym_object_pattern_repeat1,
  [214358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8197), 1,
      anon_sym_EQ,
    ACTIONS(4371), 2,
      anon_sym_in,
      anon_sym_of,
  [214369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(8195), 1,
      anon_sym_RBRACE,
    STATE(4821), 1,
      aux_sym_object_pattern_repeat1,
  [214382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    STATE(1095), 1,
      sym_object_type,
  [214395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    STATE(4383), 1,
      sym_object_type,
  [214408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7819), 1,
      anon_sym_RBRACE,
    ACTIONS(8199), 1,
      anon_sym_COMMA,
    STATE(4774), 1,
      aux_sym_export_clause_repeat1,
  [214421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [214434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(8201), 1,
      anon_sym_RBRACE,
    STATE(4733), 1,
      aux_sym_object_pattern_repeat1,
  [214447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8203), 1,
      anon_sym_as,
    ACTIONS(8205), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [214458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8207), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [214467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8211), 1,
      anon_sym_RBRACK,
    STATE(4813), 1,
      aux_sym_tuple_type_repeat1,
  [214480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5957), 1,
      anon_sym_RPAREN,
    STATE(4878), 1,
      aux_sym_array_repeat1,
  [214493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7834), 1,
      anon_sym_COMMA,
    ACTIONS(7836), 1,
      anon_sym_RBRACE,
    STATE(4864), 1,
      aux_sym_enum_body_repeat1,
  [214506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8215), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [214519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5957), 1,
      anon_sym_RPAREN,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [214532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8217), 1,
      anon_sym_EQ,
    ACTIONS(4292), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [214543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(8219), 1,
      anon_sym_RPAREN,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [214556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8221), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [214565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8223), 1,
      anon_sym_LBRACE,
    ACTIONS(7861), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [214576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [214585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4248), 1,
      sym_type_predicate,
    ACTIONS(8227), 2,
      sym_identifier,
      sym_this,
  [214596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8229), 1,
      anon_sym_COMMA,
    ACTIONS(8232), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [214609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5900), 1,
      anon_sym_RBRACK,
    STATE(4832), 1,
      aux_sym_array_repeat1,
  [214622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8234), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [214631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5142), 1,
      sym_type_predicate,
    ACTIONS(8236), 2,
      sym_identifier,
      sym_this,
  [214642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8241), 1,
      anon_sym_RBRACE,
    STATE(4733), 1,
      aux_sym_object_pattern_repeat1,
  [214655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_COMMA,
    ACTIONS(8193), 1,
      anon_sym_RBRACK,
    STATE(4898), 1,
      aux_sym_array_pattern_repeat1,
  [214668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5898), 1,
      anon_sym_RBRACK,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [214681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5900), 1,
      anon_sym_RBRACK,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [214694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      anon_sym_extends,
  [214707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5898), 1,
      anon_sym_RBRACK,
    STATE(4887), 1,
      aux_sym_array_repeat1,
  [214720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7199), 1,
      anon_sym_DOT,
    ACTIONS(8243), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [214731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8245), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [214740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4226), 1,
      anon_sym_GT,
    ACTIONS(8247), 1,
      anon_sym_COMMA,
    STATE(4915), 1,
      aux_sym_implements_clause_repeat1,
  [214753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8249), 1,
      anon_sym_RBRACK,
    STATE(4718), 1,
      aux_sym_tuple_type_repeat1,
  [214766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_LBRACE,
    ACTIONS(7730), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [214777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5932), 1,
      anon_sym_RBRACK,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [214790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5932), 1,
      anon_sym_RBRACK,
    STATE(4920), 1,
      aux_sym_array_repeat1,
  [214803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8253), 1,
      anon_sym_RBRACK,
    STATE(4748), 1,
      aux_sym_tuple_type_repeat1,
  [214816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8255), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [214829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8257), 1,
      anon_sym_RBRACK,
    STATE(4813), 1,
      aux_sym_tuple_type_repeat1,
  [214842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8259), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [214855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8261), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [214864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7203), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [214877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8263), 1,
      anon_sym_COMMA,
    ACTIONS(8265), 1,
      anon_sym_GT,
    STATE(4885), 1,
      aux_sym_type_parameters_repeat1,
  [214890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_LBRACE,
    ACTIONS(5902), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [214901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8267), 1,
      anon_sym_COMMA,
    ACTIONS(8269), 1,
      anon_sym_RPAREN,
    STATE(4755), 1,
      aux_sym_formal_parameters_repeat1,
  [214914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym_RPAREN,
    ACTIONS(8271), 1,
      anon_sym_COMMA,
    STATE(4857), 1,
      aux_sym_formal_parameters_repeat1,
  [214927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8265), 1,
      anon_sym_GT,
    ACTIONS(8273), 1,
      sym_identifier,
    STATE(5172), 1,
      sym_type_parameter,
  [214940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [214953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8275), 1,
      anon_sym_COMMA,
    ACTIONS(8277), 1,
      anon_sym_RBRACE,
    STATE(4816), 1,
      aux_sym_named_imports_repeat1,
  [214966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8279), 1,
      anon_sym_EQ,
    ACTIONS(8281), 1,
      anon_sym_COMMA,
    ACTIONS(8283), 1,
      anon_sym_from,
  [214979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8285), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [214992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_COMMA,
    ACTIONS(8193), 1,
      anon_sym_RBRACK,
    STATE(4893), 1,
      aux_sym_array_pattern_repeat1,
  [215005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8287), 1,
      anon_sym_LPAREN,
    ACTIONS(8289), 1,
      anon_sym_await,
    STATE(52), 1,
      sym__for_header,
  [215018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8291), 1,
      sym_identifier,
    ACTIONS(8293), 1,
      anon_sym_require,
    STATE(4823), 1,
      sym_nested_identifier,
  [215031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [215044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4177), 1,
      anon_sym_GT,
    ACTIONS(8295), 1,
      anon_sym_COMMA,
    STATE(4915), 1,
      aux_sym_implements_clause_repeat1,
  [215057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8297), 1,
      sym_identifier,
    ACTIONS(8299), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [215068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8301), 1,
      anon_sym_as,
    ACTIONS(8303), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [215079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8305), 1,
      sym_identifier,
    ACTIONS(8307), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [215090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8309), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [215099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8311), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(8313), 1,
      anon_sym_RBRACE,
    STATE(4733), 1,
      aux_sym_object_pattern_repeat1,
  [215121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8315), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [215134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8317), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [215143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8319), 1,
      anon_sym_COMMA,
    ACTIONS(8322), 1,
      anon_sym_RBRACE,
    STATE(4774), 1,
      aux_sym_export_clause_repeat1,
  [215156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8326), 1,
      anon_sym_RBRACK,
    STATE(4902), 1,
      aux_sym_tuple_type_repeat1,
  [215178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [215191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_COMMA,
    ACTIONS(8328), 1,
      anon_sym_RBRACK,
    STATE(4898), 1,
      aux_sym_array_pattern_repeat1,
  [215204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4322), 1,
      anon_sym_GT,
    ACTIONS(8330), 1,
      anon_sym_COMMA,
    STATE(4915), 1,
      aux_sym_implements_clause_repeat1,
  [215217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 1,
      anon_sym_LBRACE,
    ACTIONS(3355), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [215228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(8332), 1,
      anon_sym_RBRACK,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [215241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8273), 1,
      sym_identifier,
    ACTIONS(8334), 1,
      anon_sym_GT,
    STATE(5172), 1,
      sym_type_parameter,
  [215254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_SQUOTE,
    STATE(5547), 1,
      sym_string,
  [215267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8336), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7610), 1,
      anon_sym_COMMA,
    ACTIONS(8338), 1,
      anon_sym_LBRACE,
    STATE(4906), 1,
      aux_sym_implements_clause_repeat1,
  [215289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5908), 1,
      anon_sym_RPAREN,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [215302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5908), 1,
      anon_sym_RPAREN,
    STATE(4724), 1,
      aux_sym_array_repeat1,
  [215315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 1,
      anon_sym_RPAREN,
    ACTIONS(8340), 1,
      anon_sym_COMMA,
    STATE(4857), 1,
      aux_sym_formal_parameters_repeat1,
  [215328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8285), 1,
      anon_sym_RBRACE,
    STATE(4749), 1,
      aux_sym_object_repeat1,
  [215341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8342), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8344), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [215363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8346), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 1,
      anon_sym_LBRACE,
    ACTIONS(4760), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [215383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8348), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_RBRACE,
    STATE(4713), 1,
      aux_sym_export_clause_repeat1,
  [215396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [215409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8352), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(605), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1791), 1,
      anon_sym_LBRACE,
    STATE(1129), 1,
      sym_object_type,
  [215431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7066), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [215444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8354), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [215457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7243), 1,
      anon_sym_extends,
  [215470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5142), 1,
      sym_type_predicate,
    ACTIONS(8356), 2,
      sym_identifier,
      sym_this,
  [215481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8358), 1,
      anon_sym_RBRACK,
    STATE(4813), 1,
      aux_sym_tuple_type_repeat1,
  [215494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8360), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [215503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8362), 1,
      anon_sym_LBRACE,
    ACTIONS(7881), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [215514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8364), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [215527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 1,
      anon_sym_LBRACE,
    ACTIONS(4750), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [215538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8366), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8368), 1,
      anon_sym_RBRACK,
    STATE(4840), 1,
      aux_sym_tuple_type_repeat1,
  [215560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8370), 1,
      anon_sym_RBRACK,
    STATE(4876), 1,
      aux_sym_tuple_type_repeat1,
  [215573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8372), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8374), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8378), 1,
      anon_sym_COMMA,
    ACTIONS(8381), 1,
      anon_sym_RBRACK,
    STATE(4813), 1,
      aux_sym_tuple_type_repeat1,
  [215613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8344), 1,
      anon_sym_RBRACE,
    STATE(4805), 1,
      aux_sym_object_repeat1,
  [215626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [215639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7854), 1,
      anon_sym_RBRACE,
    ACTIONS(8383), 1,
      anon_sym_COMMA,
    STATE(4860), 1,
      aux_sym_named_imports_repeat1,
  [215652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8387), 1,
      anon_sym_GT,
    STATE(4868), 1,
      aux_sym_type_parameters_repeat1,
  [215665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4300), 1,
      anon_sym_GT,
    ACTIONS(8389), 1,
      anon_sym_COMMA,
    STATE(4915), 1,
      aux_sym_implements_clause_repeat1,
  [215678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8391), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [215691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8393), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [215704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(8395), 1,
      anon_sym_RBRACE,
    STATE(4733), 1,
      aux_sym_object_pattern_repeat1,
  [215717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [215730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7199), 1,
      anon_sym_DOT,
    ACTIONS(8397), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [215741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(8399), 1,
      anon_sym_RBRACE,
    STATE(4733), 1,
      aux_sym_object_pattern_repeat1,
  [215754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5964), 1,
      anon_sym_RPAREN,
    STATE(4928), 1,
      aux_sym_array_repeat1,
  [215767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8401), 1,
      anon_sym_EQ,
    ACTIONS(4406), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [215778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5964), 1,
      anon_sym_RPAREN,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [215791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_COMMA,
    ACTIONS(8406), 1,
      anon_sym_RPAREN,
    STATE(4872), 1,
      aux_sym_formal_parameters_repeat1,
  [215804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6210), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [215817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(8408), 1,
      anon_sym_EQ,
    STATE(5527), 1,
      sym_type_parameters,
  [215830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8410), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [215843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(8412), 1,
      anon_sym_RBRACK,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [215856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8414), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8416), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8418), 1,
      anon_sym_LPAREN,
    ACTIONS(8420), 1,
      anon_sym_await,
    STATE(42), 1,
      sym__for_header,
  [215887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8045), 1,
      anon_sym_RBRACE,
    ACTIONS(8422), 1,
      anon_sym_COMMA,
    STATE(4836), 1,
      aux_sym_enum_body_repeat1,
  [215900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_GT,
    ACTIONS(8425), 1,
      anon_sym_COMMA,
    STATE(4915), 1,
      aux_sym_implements_clause_repeat1,
  [215913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6507), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [215926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8427), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8429), 1,
      anon_sym_RBRACK,
    STATE(4813), 1,
      aux_sym_tuple_type_repeat1,
  [215948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6145), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [215961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8431), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [215979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      anon_sym_SQUOTE,
    STATE(5093), 1,
      sym_string,
  [215992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6359), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [216005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7223), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [216014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    STATE(4439), 1,
      sym_object_type,
  [216027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [216040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8433), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(8435), 1,
      anon_sym_RPAREN,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [216062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [216075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 1,
      anon_sym_extends,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
  [216088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [216097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8437), 1,
      anon_sym_EQ,
    ACTIONS(4371), 2,
      anon_sym_in,
      anon_sym_of,
  [216108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7235), 1,
      anon_sym_extends,
  [216121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7245), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [216130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8439), 1,
      anon_sym_COMMA,
    ACTIONS(8442), 1,
      anon_sym_RPAREN,
    STATE(4857), 1,
      aux_sym_formal_parameters_repeat1,
  [216143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8444), 1,
      anon_sym_COMMA,
    ACTIONS(8446), 1,
      anon_sym_RPAREN,
    STATE(4788), 1,
      aux_sym_formal_parameters_repeat1,
  [216156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6804), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8448), 1,
      anon_sym_COMMA,
    ACTIONS(8451), 1,
      anon_sym_RBRACE,
    STATE(4860), 1,
      aux_sym_named_imports_repeat1,
  [216178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_COMMA,
    ACTIONS(7964), 1,
      anon_sym_RBRACK,
    STATE(4778), 1,
      aux_sym_array_pattern_repeat1,
  [216191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 1,
      anon_sym_LBRACE,
    ACTIONS(3365), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [216202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_implements,
    ACTIONS(8453), 1,
      anon_sym_LBRACE,
    STATE(5542), 1,
      sym_implements_clause,
  [216215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6853), 1,
      anon_sym_RBRACE,
    ACTIONS(8455), 1,
      anon_sym_COMMA,
    STATE(4836), 1,
      aux_sym_enum_body_repeat1,
  [216228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5896), 1,
      anon_sym_RBRACK,
    STATE(4781), 1,
      aux_sym_array_repeat1,
  [216241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8457), 1,
      anon_sym_RBRACK,
    STATE(4922), 1,
      aux_sym_tuple_type_repeat1,
  [216254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8459), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8461), 1,
      anon_sym_COMMA,
    ACTIONS(8463), 1,
      anon_sym_GT,
    STATE(4885), 1,
      aux_sym_type_parameters_repeat1,
  [216276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LBRACE,
    ACTIONS(3361), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [216287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8465), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7359), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [216305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 1,
      anon_sym_RPAREN,
    ACTIONS(8467), 1,
      anon_sym_COMMA,
    STATE(4857), 1,
      aux_sym_formal_parameters_repeat1,
  [216318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7726), 1,
      anon_sym_COMMA,
    ACTIONS(7728), 1,
      anon_sym_RBRACE,
    STATE(4897), 1,
      aux_sym_enum_body_repeat1,
  [216331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_GT,
    ACTIONS(8469), 1,
      anon_sym_COMMA,
    STATE(4915), 1,
      aux_sym_implements_clause_repeat1,
  [216344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4555), 1,
      sym_type_predicate,
    ACTIONS(8471), 2,
      sym_identifier,
      sym_this,
  [216355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8473), 1,
      anon_sym_RBRACK,
    STATE(4813), 1,
      aux_sym_tuple_type_repeat1,
  [216368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8475), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(8477), 1,
      anon_sym_RPAREN,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [216390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7299), 1,
      anon_sym_extends,
  [216403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    ACTIONS(8479), 1,
      anon_sym_LPAREN,
    STATE(1060), 1,
      sym_statement_block,
  [216416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8273), 1,
      sym_identifier,
    ACTIONS(8463), 1,
      anon_sym_GT,
    STATE(5172), 1,
      sym_type_parameter,
  [216429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8481), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5959), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [216447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5843), 1,
      anon_sym_RPAREN,
    STATE(4926), 1,
      aux_sym_array_repeat1,
  [216460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(8486), 1,
      anon_sym_GT,
    STATE(4885), 1,
      aux_sym_type_parameters_repeat1,
  [216473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7962), 1,
      anon_sym_EQ,
    ACTIONS(8488), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [216484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(8490), 1,
      anon_sym_RBRACK,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [216497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7277), 1,
      anon_sym_extends,
  [216510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8273), 1,
      sym_identifier,
    ACTIONS(8492), 1,
      anon_sym_GT,
    STATE(5172), 1,
      sym_type_parameter,
  [216523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_GT,
    ACTIONS(8494), 1,
      anon_sym_COMMA,
    STATE(4915), 1,
      aux_sym_implements_clause_repeat1,
  [216536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8496), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_while,
    ACTIONS(8498), 1,
      anon_sym_else,
    STATE(1080), 1,
      sym_else_clause,
  [216558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_COMMA,
    ACTIONS(8500), 1,
      anon_sym_RBRACK,
    STATE(4898), 1,
      aux_sym_array_pattern_repeat1,
  [216571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8502), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5843), 1,
      anon_sym_RPAREN,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [216593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5924), 1,
      anon_sym_RPAREN,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [216606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6826), 1,
      anon_sym_RBRACE,
    ACTIONS(8504), 1,
      anon_sym_COMMA,
    STATE(4836), 1,
      aux_sym_enum_body_repeat1,
  [216619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8488), 1,
      anon_sym_RBRACK,
    ACTIONS(8506), 1,
      anon_sym_COMMA,
    STATE(4898), 1,
      aux_sym_array_pattern_repeat1,
  [216632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7691), 1,
      anon_sym_extends,
  [216645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5924), 1,
      anon_sym_RPAREN,
    STATE(4850), 1,
      aux_sym_array_repeat1,
  [216658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7311), 1,
      anon_sym_extends,
  [216671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8509), 1,
      anon_sym_RBRACK,
    STATE(4813), 1,
      aux_sym_tuple_type_repeat1,
  [216684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8511), 1,
      sym_identifier,
    STATE(3499), 1,
      sym_decorator_member_expression,
    STATE(3557), 1,
      sym_decorator_call_expression,
  [216697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_extends,
  [216710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8281), 1,
      anon_sym_COMMA,
    ACTIONS(8283), 1,
      anon_sym_from,
    ACTIONS(8513), 1,
      anon_sym_EQ,
  [216723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7803), 1,
      anon_sym_LBRACE,
    ACTIONS(8515), 1,
      anon_sym_COMMA,
    STATE(4906), 1,
      aux_sym_implements_clause_repeat1,
  [216736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7717), 1,
      anon_sym_extends,
  [216749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_AMP,
    ACTIONS(7233), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
  [216762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8518), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 1,
      anon_sym_GT,
    ACTIONS(8520), 1,
      anon_sym_COMMA,
    STATE(4915), 1,
      aux_sym_implements_clause_repeat1,
  [216784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(5896), 1,
      anon_sym_RBRACK,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [216797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [216806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8522), 1,
      anon_sym_RBRACK,
    STATE(4802), 1,
      aux_sym_tuple_type_repeat1,
  [216819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8524), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7803), 1,
      anon_sym_GT,
    ACTIONS(8526), 1,
      anon_sym_COMMA,
    STATE(4915), 1,
      aux_sym_implements_clause_repeat1,
  [216841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_LT,
    ACTIONS(8529), 1,
      anon_sym_EQ,
    STATE(5381), 1,
      sym_type_parameters,
  [216854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(8531), 1,
      anon_sym_RBRACE,
    STATE(4733), 1,
      aux_sym_object_pattern_repeat1,
  [216867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8533), 1,
      anon_sym_RBRACE,
    STATE(4729), 1,
      aux_sym_object_repeat1,
  [216880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8391), 1,
      anon_sym_RBRACE,
    STATE(4820), 1,
      aux_sym_object_repeat1,
  [216893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(8535), 1,
      anon_sym_RBRACK,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [216906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    ACTIONS(8533), 1,
      anon_sym_RBRACE,
    STATE(4721), 1,
      aux_sym_object_repeat1,
  [216919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_COMMA,
    ACTIONS(8537), 1,
      anon_sym_RBRACK,
    STATE(4813), 1,
      aux_sym_tuple_type_repeat1,
  [216932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(8531), 1,
      anon_sym_RBRACE,
    STATE(4715), 1,
      aux_sym_object_pattern_repeat1,
  [216945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8539), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [216954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8541), 1,
      anon_sym_COMMA,
    ACTIONS(8543), 1,
      anon_sym_GT,
    STATE(4752), 1,
      aux_sym_type_parameters_repeat1,
  [216967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(8545), 1,
      anon_sym_RPAREN,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [216980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8217), 1,
      anon_sym_EQ,
    ACTIONS(4406), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [216991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_COMMA,
    ACTIONS(8547), 1,
      anon_sym_RPAREN,
    STATE(4563), 1,
      aux_sym_array_repeat1,
  [217004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_COMMA,
    ACTIONS(7964), 1,
      anon_sym_RBRACK,
    STATE(4898), 1,
      aux_sym_array_pattern_repeat1,
  [217017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(4998), 1,
      sym_statement_block,
  [217027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(1142), 1,
      sym_statement_block,
  [217037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2081), 1,
      sym_class_body,
  [217047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5279), 1,
      sym_formal_parameters,
  [217057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    STATE(2082), 1,
      sym_statement_block,
  [217067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    STATE(2084), 1,
      sym_statement_block,
  [217077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2085), 1,
      sym_class_body,
  [217087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5549), 1,
      sym_formal_parameters,
  [217097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5545), 1,
      sym_formal_parameters,
  [217107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4461), 1,
      sym_class_body,
  [217117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_LT,
    STATE(3681), 1,
      sym_type_arguments,
  [217127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5336), 1,
      sym_formal_parameters,
  [217137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5337), 1,
      sym_formal_parameters,
  [217147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4405), 1,
      sym_class_body,
  [217157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7136), 1,
      anon_sym_LBRACE,
    STATE(135), 1,
      sym_class_body,
  [217167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5457), 1,
      sym_formal_parameters,
  [217177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_COLON,
    STATE(5192), 1,
      sym_type_annotation,
  [217187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5452), 1,
      sym_formal_parameters,
  [217197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2094), 1,
      sym_class_body,
  [217207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5251), 1,
      sym_formal_parameters,
  [217217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4285), 1,
      sym_formal_parameters,
  [217227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7047), 1,
      anon_sym_is,
    ACTIONS(7249), 1,
      anon_sym_LBRACE,
  [217237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(4297), 1,
      sym_statement_block,
  [217247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8549), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [217255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(4310), 1,
      sym_statement_block,
  [217265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5397), 1,
      sym_formal_parameters,
  [217275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2923), 1,
      sym_statement_block,
  [217285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5403), 1,
      sym_formal_parameters,
  [217295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2926), 1,
      sym_class_body,
  [217305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7947), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [217313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4470), 1,
      sym_class_body,
  [217323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2922), 1,
      sym_class_body,
  [217333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4472), 1,
      sym_class_body,
  [217343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5047), 1,
      sym_statement_block,
  [217353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [217361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5092), 1,
      sym_statement_block,
  [217371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [217379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8488), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [217387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5573), 1,
      sym_formal_parameters,
  [217397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4450), 1,
      sym_formal_parameters,
  [217407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(1086), 1,
      sym_statement_block,
  [217417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    STATE(1088), 1,
      sym_class_body,
  [217427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8551), 1,
      anon_sym_LPAREN,
    STATE(5201), 1,
      sym_parenthesized_expression,
  [217437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5571), 1,
      sym_formal_parameters,
  [217447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8045), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [217455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8553), 1,
      anon_sym_LT,
    STATE(3202), 1,
      sym_type_arguments,
  [217465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8555), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [217473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8557), 1,
      anon_sym_LT,
    STATE(2757), 1,
      sym_type_arguments,
  [217483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8559), 1,
      anon_sym_LPAREN,
    STATE(51), 1,
      sym_parenthesized_expression,
  [217493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8559), 1,
      anon_sym_LPAREN,
    STATE(5075), 1,
      sym_parenthesized_expression,
  [217503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(1056), 1,
      sym_statement_block,
  [217513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4476), 1,
      sym_class_body,
  [217523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8559), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym_parenthesized_expression,
  [217533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8561), 1,
      anon_sym_in,
    ACTIONS(8563), 1,
      anon_sym_COLON,
  [217543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    STATE(2073), 1,
      sym_statement_block,
  [217553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2072), 1,
      sym_class_body,
  [217563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(1007), 1,
      sym_statement_block,
  [217573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4524), 1,
      sym_class_body,
  [217583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2319), 1,
      sym_class_body,
  [217593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2327), 1,
      sym_statement_block,
  [217603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8565), 1,
      sym_identifier,
    STATE(4739), 1,
      sym_nested_identifier,
  [217613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [217621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4430), 1,
      sym_formal_parameters,
  [217631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2407), 1,
      sym_class_body,
  [217641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(4966), 1,
      sym_statement_block,
  [217651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8567), 1,
      sym_identifier,
    ACTIONS(8569), 1,
      anon_sym_STAR,
  [217661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_statement_block,
  [217671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2313), 1,
      sym_statement_block,
  [217681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6742), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [217689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8559), 1,
      anon_sym_LPAREN,
    STATE(47), 1,
      sym_parenthesized_expression,
  [217699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5529), 1,
      sym_formal_parameters,
  [217709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(1055), 1,
      sym_class_body,
  [217719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5349), 1,
      sym_formal_parameters,
  [217729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(1054), 1,
      sym_statement_block,
  [217739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8571), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [217747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8573), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [217755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    STATE(1108), 1,
      sym_class_body,
  [217765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5526), 1,
      sym_formal_parameters,
  [217775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7136), 1,
      anon_sym_LBRACE,
    STATE(159), 1,
      sym_class_body,
  [217785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8575), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [217793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    STATE(1112), 1,
      sym_class_body,
  [217803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_LBRACE,
    STATE(141), 1,
      sym_statement_block,
  [217813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8577), 1,
      sym_identifier,
    ACTIONS(8579), 1,
      anon_sym_STAR,
  [217823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4294), 1,
      sym_formal_parameters,
  [217833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8581), 1,
      anon_sym_LBRACE,
    STATE(1075), 1,
      sym_enum_body,
  [217843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5134), 1,
      sym_statement_block,
  [217853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7039), 1,
      anon_sym_LT,
    STATE(3925), 1,
      sym_type_arguments,
  [217863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5585), 1,
      sym_formal_parameters,
  [217873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    STATE(2780), 1,
      sym_class_body,
  [217883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5509), 1,
      sym_formal_parameters,
  [217893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5508), 1,
      sym_formal_parameters,
  [217903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8583), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [217911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8273), 1,
      sym_identifier,
    STATE(5172), 1,
      sym_type_parameter,
  [217921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5829), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [217929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4437), 1,
      sym_class_body,
  [217939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4503), 1,
      sym_formal_parameters,
  [217949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8381), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [217957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8273), 1,
      sym_identifier,
    STATE(4925), 1,
      sym_type_parameter,
  [217967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_from,
    STATE(5191), 1,
      sym__from_clause,
  [217977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5473), 1,
      sym_formal_parameters,
  [217987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5472), 1,
      sym_formal_parameters,
  [217997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2946), 1,
      sym_statement_block,
  [218007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5468), 1,
      sym_formal_parameters,
  [218017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    STATE(2097), 1,
      sym_statement_block,
  [218027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5467), 1,
      sym_formal_parameters,
  [218037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5345), 1,
      sym_formal_parameters,
  [218047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(4964), 1,
      sym_statement_block,
  [218057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5430), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2964), 1,
      sym_class_body,
  [218075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8585), 1,
      sym_identifier,
    ACTIONS(8587), 1,
      anon_sym_STAR,
  [218085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8589), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [218093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_class_body,
  [218103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8591), 1,
      anon_sym_LPAREN,
    STATE(50), 1,
      sym__for_header,
  [218113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    STATE(2819), 1,
      sym_class_body,
  [218123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    STATE(3905), 1,
      sym_formal_parameters,
  [218133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(2835), 1,
      sym_statement_block,
  [218143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(2836), 1,
      sym_statement_block,
  [218153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6808), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_COLON,
    STATE(4839), 1,
      sym_type_annotation,
  [218171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5138), 1,
      sym_statement_block,
  [218181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4403), 1,
      sym_formal_parameters,
  [218191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    STATE(2837), 1,
      sym_class_body,
  [218201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 2,
      anon_sym_in,
      anon_sym_of,
  [218209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    STATE(2838), 1,
      sym_class_body,
  [218219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(2842), 1,
      sym_statement_block,
  [218229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(2845), 1,
      sym_statement_block,
  [218239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    STATE(2832), 1,
      sym_class_body,
  [218249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8593), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_from,
    STATE(5186), 1,
      sym__from_clause,
  [218267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5412), 1,
      sym_formal_parameters,
  [218277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 1,
      anon_sym_LPAREN,
    STATE(2753), 1,
      sym_arguments,
  [218287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5416), 1,
      sym_formal_parameters,
  [218297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    STATE(2728), 1,
      sym_class_body,
  [218307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_from,
    STATE(5057), 1,
      sym__from_clause,
  [218325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8595), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(2720), 1,
      sym_statement_block,
  [218343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(2713), 1,
      sym_statement_block,
  [218353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    STATE(2311), 1,
      sym_arguments,
  [218363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5491), 1,
      sym_formal_parameters,
  [218373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LBRACE,
    STATE(2702), 1,
      sym_class_body,
  [218383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5513), 1,
      sym_formal_parameters,
  [218393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4465), 1,
      sym_formal_parameters,
  [218403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8597), 1,
      anon_sym_LT,
    STATE(2070), 1,
      sym_type_arguments,
  [218413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2310), 1,
      sym_class_body,
  [218423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8599), 1,
      anon_sym_LBRACE,
    STATE(1071), 1,
      sym_switch_body,
  [218433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8591), 1,
      anon_sym_LPAREN,
    STATE(40), 1,
      sym__for_header,
  [218443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8601), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2397), 1,
      sym_class_body,
  [218461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2403), 1,
      sym_statement_block,
  [218471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2420), 1,
      sym_statement_block,
  [218481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2427), 1,
      sym_class_body,
  [218491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6768), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(2806), 1,
      sym_statement_block,
  [218509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    STATE(2100), 1,
      sym_statement_block,
  [218519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7405), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [218527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2102), 1,
      sym_class_body,
  [218537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5315), 1,
      sym_formal_parameters,
  [218547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    STATE(3312), 1,
      sym_class_body,
  [218557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7409), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [218565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5148), 1,
      sym_statement_block,
  [218575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5577), 1,
      sym_formal_parameters,
  [218585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6798), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8603), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(4282), 1,
      sym_class_body,
  [218611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8605), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5576), 1,
      sym_formal_parameters,
  [218629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8607), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8609), 1,
      sym_identifier,
    STATE(4823), 1,
      sym_nested_identifier,
  [218647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(1046), 1,
      sym_class_body,
  [218657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2105), 1,
      sym_class_body,
  [218667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(4991), 1,
      sym_statement_block,
  [218677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6746), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym_arguments,
  [218695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4318), 1,
      sym_formal_parameters,
  [218705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(1051), 1,
      sym_class_body,
  [218715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(1052), 1,
      sym_statement_block,
  [218725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym_LBRACE,
    STATE(1043), 1,
      sym_class_body,
  [218735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_from,
    STATE(5190), 1,
      sym__from_clause,
  [218745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5540), 1,
      sym_formal_parameters,
  [218755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5102), 1,
      sym_statement_block,
  [218765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    STATE(3310), 1,
      sym_statement_block,
  [218775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8613), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5539), 1,
      sym_formal_parameters,
  [218793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5223), 1,
      sym_formal_parameters,
  [218803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8615), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    STATE(2120), 1,
      sym_statement_block,
  [218821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    STATE(2125), 1,
      sym_statement_block,
  [218831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5939), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [218855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2130), 1,
      sym_class_body,
  [218865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5447), 1,
      sym_formal_parameters,
  [218875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2941), 1,
      sym_class_body,
  [218885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8617), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5404), 1,
      sym_formal_parameters,
  [218903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8619), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4519), 1,
      sym_formal_parameters,
  [218921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5448), 1,
      sym_formal_parameters,
  [218931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5440), 1,
      sym_formal_parameters,
  [218941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8232), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4486), 1,
      sym_formal_parameters,
  [218959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8241), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7612), 1,
      sym_identifier,
    ACTIONS(7614), 1,
      anon_sym_LBRACK,
  [218977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [218985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      sym_identifier,
    ACTIONS(7419), 1,
      anon_sym_LBRACK,
  [218995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5063), 1,
      sym_statement_block,
  [219005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6947), 1,
      anon_sym_LT,
    STATE(3755), 1,
      sym_type_arguments,
  [219015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [219023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2453), 1,
      sym_class_body,
  [219033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8621), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [219041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7136), 1,
      anon_sym_LBRACE,
    STATE(149), 1,
      sym_class_body,
  [219051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7249), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [219059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7173), 1,
      anon_sym_is,
    ACTIONS(7249), 1,
      anon_sym_EQ_GT,
  [219069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8623), 1,
      anon_sym_LT,
    STATE(2357), 1,
      sym_type_arguments,
  [219079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8273), 1,
      sym_identifier,
    STATE(4817), 1,
      sym_type_parameter,
  [219089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8559), 1,
      anon_sym_LPAREN,
    STATE(48), 1,
      sym_parenthesized_expression,
  [219099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LBRACE,
    STATE(5082), 1,
      sym_statement_block,
  [219109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6756), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [219117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5356), 1,
      sym_formal_parameters,
  [219127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5355), 1,
      sym_formal_parameters,
  [219137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3817), 1,
      sym_formal_parameters,
  [219147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    STATE(1092), 1,
      sym_class_body,
  [219157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5407), 1,
      sym_formal_parameters,
  [219167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_LBRACE,
    STATE(155), 1,
      sym_statement_block,
  [219177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8625), 1,
      sym_identifier,
    ACTIONS(8627), 1,
      anon_sym_STAR,
  [219187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2300), 1,
      sym_class_body,
  [219197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2438), 1,
      sym_statement_block,
  [219207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    STATE(3233), 1,
      sym_class_body,
  [219217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5226), 1,
      sym_formal_parameters,
  [219227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8629), 1,
      anon_sym_LBRACE,
    STATE(4283), 1,
      sym_enum_body,
  [219237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    STATE(3228), 1,
      sym_statement_block,
  [219247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5242), 1,
      sym_formal_parameters,
  [219257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7136), 1,
      anon_sym_LBRACE,
    STATE(161), 1,
      sym_class_body,
  [219267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    STATE(3163), 1,
      sym_statement_block,
  [219277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8559), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
  [219287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2274), 1,
      sym_statement_block,
  [219297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5579), 1,
      sym_formal_parameters,
  [219307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(2725), 1,
      sym_statement_block,
  [219317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8559), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_parenthesized_expression,
  [219327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_LBRACE,
    STATE(2369), 1,
      sym_class_body,
  [219337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    STATE(3133), 1,
      sym_statement_block,
  [219347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8486), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [219355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    STATE(3136), 1,
      sym_class_body,
  [219365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    STATE(3141), 1,
      sym_statement_block,
  [219375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    STATE(3145), 1,
      sym_statement_block,
  [219385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    STATE(3152), 1,
      sym_class_body,
  [219395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    STATE(3153), 1,
      sym_class_body,
  [219405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5347), 1,
      sym_formal_parameters,
  [219415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5357), 1,
      sym_formal_parameters,
  [219425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5432), 1,
      sym_formal_parameters,
  [219435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    STATE(3222), 1,
      sym_statement_block,
  [219445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5280), 1,
      sym_formal_parameters,
  [219455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(2358), 1,
      sym_statement_block,
  [219465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [219473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8631), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [219481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8633), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [219489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5222), 1,
      sym_formal_parameters,
  [219499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5220), 1,
      sym_formal_parameters,
  [219509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8635), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [219517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4364), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [219525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [219533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8637), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [219541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5520), 1,
      anon_sym_LPAREN,
    STATE(3188), 1,
      sym_arguments,
  [219551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [219559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(7413), 1,
      anon_sym_LBRACK,
  [219569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5431), 1,
      sym_formal_parameters,
  [219579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8629), 1,
      anon_sym_LBRACE,
    STATE(4418), 1,
      sym_enum_body,
  [219589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8639), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [219597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(4416), 1,
      sym_statement_block,
  [219607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8641), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [219615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8643), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [219623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    STATE(3122), 1,
      sym_class_body,
  [219633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_COLON,
    STATE(5021), 1,
      sym_type_annotation,
  [219643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    STATE(2173), 1,
      sym_class_body,
  [219653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4351), 1,
      sym_formal_parameters,
  [219663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    STATE(2171), 1,
      sym_statement_block,
  [219673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    STATE(3187), 1,
      sym_class_body,
  [219683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LPAREN,
    STATE(3997), 1,
      sym_formal_parameters,
  [219693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      anon_sym_LBRACE,
    STATE(3220), 1,
      sym_class_body,
  [219703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5268), 1,
      sym_formal_parameters,
  [219713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    STATE(3132), 1,
      sym_statement_block,
  [219723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(5262), 1,
      sym_formal_parameters,
  [219733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7585), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [219741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    STATE(4344), 1,
      sym_formal_parameters,
  [219751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7461), 1,
      sym_identifier,
    ACTIONS(7463), 1,
      anon_sym_LBRACK,
  [219761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8581), 1,
      anon_sym_LBRACE,
    STATE(1136), 1,
      sym_enum_body,
  [219771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_EQ_GT,
  [219778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8647), 1,
      sym_identifier,
  [219785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8649), 1,
      anon_sym_EQ_GT,
  [219792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8651), 1,
      anon_sym_EQ_GT,
  [219799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8653), 1,
      anon_sym_EQ_GT,
  [219806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8655), 1,
      anon_sym_EQ_GT,
  [219813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8657), 1,
      anon_sym_EQ_GT,
  [219820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8659), 1,
      anon_sym_class,
  [219827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8661), 1,
      anon_sym_EQ_GT,
  [219834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8663), 1,
      anon_sym_EQ_GT,
  [219841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8665), 1,
      anon_sym_LBRACK,
  [219848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8667), 1,
      sym_number,
  [219855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8669), 1,
      anon_sym_EQ_GT,
  [219862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8671), 1,
      anon_sym_EQ_GT,
  [219869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8673), 1,
      sym_identifier,
  [219876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8675), 1,
      anon_sym_EQ_GT,
  [219883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8677), 1,
      anon_sym_EQ,
  [219890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8679), 1,
      anon_sym_EQ_GT,
  [219897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_EQ_GT,
  [219904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8683), 1,
      anon_sym_EQ_GT,
  [219911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7461), 1,
      sym_identifier,
  [219918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8685), 1,
      sym_identifier,
  [219925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8687), 1,
      anon_sym_target,
  [219932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8689), 1,
      anon_sym_RBRACK,
  [219939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8691), 1,
      anon_sym_SLASH2,
  [219946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8693), 1,
      anon_sym_EQ_GT,
  [219953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8695), 1,
      sym_identifier,
  [219960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8697), 1,
      anon_sym_EQ_GT,
  [219967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8699), 1,
      anon_sym_EQ_GT,
  [219974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7411), 1,
      sym_identifier,
  [219981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8701), 1,
      sym_identifier,
  [219988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 1,
      anon_sym_RBRACK,
  [219995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8703), 1,
      anon_sym_from,
  [220002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8705), 1,
      sym_identifier,
  [220009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_EQ_GT,
  [220016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8709), 1,
      anon_sym_LPAREN,
  [220023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8711), 1,
      sym_number,
  [220030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8713), 1,
      sym_identifier,
  [220037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8715), 1,
      anon_sym_target,
  [220044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8717), 1,
      anon_sym_require,
  [220051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8719), 1,
      anon_sym_from,
  [220058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6051), 1,
      anon_sym_RBRACK,
  [220065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8721), 1,
      anon_sym_EQ,
  [220072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8723), 1,
      anon_sym_EQ_GT,
  [220079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8725), 1,
      anon_sym_EQ_GT,
  [220086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8727), 1,
      anon_sym_EQ_GT,
  [220093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8729), 1,
      anon_sym_EQ_GT,
  [220100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8731), 1,
      anon_sym_EQ_GT,
  [220107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8733), 1,
      anon_sym_EQ_GT,
  [220114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4638), 1,
      anon_sym_DOT,
  [220121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8735), 1,
      anon_sym_from,
  [220128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8737), 1,
      anon_sym_EQ_GT,
  [220135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8739), 1,
      anon_sym_EQ_GT,
  [220142] = 2,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8741), 1,
      sym_regex_pattern,
  [220149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8743), 1,
      anon_sym_from,
  [220156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8745), 1,
      anon_sym_EQ_GT,
  [220163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8137), 1,
      anon_sym_EQ_GT,
  [220170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8747), 1,
      anon_sym_EQ_GT,
  [220177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8749), 1,
      anon_sym_EQ_GT,
  [220184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6792), 1,
      anon_sym_EQ_GT,
  [220191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_EQ_GT,
  [220198] = 2,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8753), 1,
      sym_regex_pattern,
  [220205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8755), 1,
      anon_sym_EQ_GT,
  [220212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8757), 1,
      anon_sym_EQ_GT,
  [220219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8759), 1,
      anon_sym_EQ_GT,
  [220226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5790), 1,
      anon_sym_RPAREN,
  [220233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8761), 1,
      anon_sym_EQ_GT,
  [220240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8453), 1,
      anon_sym_LBRACE,
  [220247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8763), 1,
      anon_sym_EQ_GT,
  [220254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8765), 1,
      anon_sym_EQ,
  [220261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8767), 1,
      anon_sym_EQ,
  [220268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8769), 1,
      sym_identifier,
  [220275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8771), 1,
      anon_sym_EQ_GT,
  [220282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8773), 1,
      anon_sym_EQ_GT,
  [220289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      anon_sym_SLASH2,
  [220296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8777), 1,
      anon_sym_EQ_GT,
  [220303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8779), 1,
      sym_identifier,
  [220310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8350), 1,
      anon_sym_RBRACE,
  [220317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8781), 1,
      anon_sym_EQ_GT,
  [220324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8783), 1,
      anon_sym_EQ_GT,
  [220331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8785), 1,
      sym_identifier,
  [220338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8787), 1,
      anon_sym_EQ,
  [220345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8789), 1,
      anon_sym_EQ_GT,
  [220352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8791), 1,
      anon_sym_EQ_GT,
  [220359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8793), 1,
      anon_sym_EQ_GT,
  [220366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8795), 1,
      anon_sym_EQ_GT,
  [220373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_EQ_GT,
  [220380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8799), 1,
      anon_sym_EQ_GT,
  [220387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8801), 1,
      anon_sym_EQ_GT,
  [220394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8803), 1,
      anon_sym_EQ_GT,
  [220401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8805), 1,
      anon_sym_EQ_GT,
  [220408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8807), 1,
      anon_sym_EQ,
  [220415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_EQ,
  [220422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8811), 1,
      anon_sym_RPAREN,
  [220429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6895), 1,
      anon_sym_DOT,
  [220436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8813), 1,
      sym_identifier,
  [220443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8815), 1,
      sym_identifier,
  [220450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8817), 1,
      anon_sym_COLON,
  [220457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8819), 1,
      anon_sym_EQ_GT,
  [220464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_RPAREN,
  [220471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8821), 1,
      sym_number,
  [220478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8823), 1,
      sym_identifier,
  [220485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8197), 1,
      anon_sym_EQ,
  [220492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8825), 1,
      anon_sym_EQ_GT,
  [220499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
  [220506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8829), 1,
      anon_sym_EQ_GT,
  [220513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8831), 1,
      anon_sym_EQ,
  [220520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8833), 1,
      anon_sym_SLASH2,
  [220527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8835), 1,
      anon_sym_EQ_GT,
  [220534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8837), 1,
      anon_sym_EQ_GT,
  [220541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8839), 1,
      anon_sym_EQ_GT,
  [220548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8841), 1,
      sym_identifier,
  [220555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8843), 1,
      anon_sym_EQ_GT,
  [220562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8845), 1,
      anon_sym_EQ_GT,
  [220569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 1,
      anon_sym_DOT,
  [220576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8847), 1,
      anon_sym_EQ_GT,
  [220583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8849), 1,
      anon_sym_target,
  [220590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6135), 1,
      anon_sym_RBRACK,
  [220597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8851), 1,
      anon_sym_EQ_GT,
  [220604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8853), 1,
      anon_sym_EQ_GT,
  [220611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8855), 1,
      anon_sym_EQ_GT,
  [220618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7612), 1,
      sym_identifier,
  [220625] = 2,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8857), 1,
      sym_regex_pattern,
  [220632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8859), 1,
      anon_sym_EQ_GT,
  [220639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8861), 1,
      sym_identifier,
  [220646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8863), 1,
      sym_identifier,
  [220653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8865), 1,
      sym_identifier,
  [220660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8867), 1,
      anon_sym_EQ,
  [220667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8869), 1,
      anon_sym_EQ_GT,
  [220674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8871), 1,
      anon_sym_EQ,
  [220681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8873), 1,
      anon_sym_EQ_GT,
  [220688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8875), 1,
      anon_sym_RPAREN,
  [220695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8877), 1,
      anon_sym_EQ_GT,
  [220702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8879), 1,
      anon_sym_DOT,
  [220709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8881), 1,
      sym_identifier,
  [220716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8883), 1,
      anon_sym_EQ_GT,
  [220723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8885), 1,
      anon_sym_EQ_GT,
  [220730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8887), 1,
      anon_sym_EQ_GT,
  [220737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8889), 1,
      anon_sym_EQ_GT,
  [220744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8891), 1,
      anon_sym_EQ_GT,
  [220751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8893), 1,
      anon_sym_EQ_GT,
  [220758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8895), 1,
      anon_sym_EQ,
  [220765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8897), 1,
      anon_sym_EQ,
  [220772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8899), 1,
      sym_identifier,
  [220779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5133), 1,
      anon_sym_DOT,
  [220786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      sym_identifier,
  [220793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8901), 1,
      anon_sym_target,
  [220800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8903), 1,
      anon_sym_EQ_GT,
  [220807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6047), 1,
      anon_sym_RBRACK,
  [220814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8905), 1,
      sym_identifier,
  [220821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8907), 1,
      anon_sym_while,
  [220828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8909), 1,
      anon_sym_EQ_GT,
  [220835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8911), 1,
      anon_sym_EQ_GT,
  [220842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8913), 1,
      anon_sym_EQ,
  [220849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8915), 1,
      anon_sym_EQ_GT,
  [220856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8917), 1,
      sym_identifier,
  [220863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8919), 1,
      sym_identifier,
  [220870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8921), 1,
      sym_identifier,
  [220877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8923), 1,
      anon_sym_COLON,
  [220884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8925), 1,
      anon_sym_EQ_GT,
  [220891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8927), 1,
      anon_sym_SLASH2,
  [220898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_RPAREN,
  [220905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8929), 1,
      anon_sym_EQ_GT,
  [220912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8931), 1,
      sym_identifier,
  [220919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8933), 1,
      anon_sym_EQ,
  [220926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8935), 1,
      sym_number,
  [220933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8937), 1,
      anon_sym_RPAREN,
  [220940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8939), 1,
      anon_sym_EQ_GT,
  [220947] = 2,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8941), 1,
      sym_regex_pattern,
  [220954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8943), 1,
      anon_sym_from,
  [220961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8945), 1,
      anon_sym_EQ,
  [220968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8947), 1,
      anon_sym_EQ_GT,
  [220975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8949), 1,
      anon_sym_EQ_GT,
  [220982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8951), 1,
      anon_sym_EQ_GT,
  [220989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8953), 1,
      anon_sym_EQ_GT,
  [220996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8955), 1,
      anon_sym_EQ_GT,
  [221003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8957), 1,
      anon_sym_EQ,
  [221010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8959), 1,
      sym_identifier,
  [221017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8961), 1,
      anon_sym_EQ_GT,
  [221024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      anon_sym_EQ_GT,
  [221031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8965), 1,
      anon_sym_EQ_GT,
  [221038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8967), 1,
      sym_identifier,
  [221045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8969), 1,
      sym_identifier,
  [221052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8971), 1,
      anon_sym_function,
  [221059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8973), 1,
      anon_sym_EQ_GT,
  [221066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8975), 1,
      anon_sym_EQ_GT,
  [221073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8977), 1,
      anon_sym_EQ_GT,
  [221080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8979), 1,
      anon_sym_EQ_GT,
  [221087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8981), 1,
      anon_sym_SLASH2,
  [221094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8983), 1,
      sym_identifier,
  [221101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8985), 1,
      anon_sym_EQ_GT,
  [221108] = 2,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(8987), 1,
      sym_regex_pattern,
  [221115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8989), 1,
      sym_identifier,
  [221122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_RPAREN,
  [221129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8991), 1,
      sym_identifier,
  [221136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8993), 1,
      anon_sym_EQ_GT,
  [221143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym_DOT,
  [221150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8283), 1,
      anon_sym_from,
  [221157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8995), 1,
      anon_sym_EQ_GT,
  [221164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8997), 1,
      anon_sym_EQ_GT,
  [221171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8999), 1,
      anon_sym_EQ_GT,
  [221178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9001), 1,
      anon_sym_EQ_GT,
  [221185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9003), 1,
      anon_sym_EQ_GT,
  [221192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9005), 1,
      anon_sym_EQ_GT,
  [221199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9007), 1,
      anon_sym_EQ_GT,
  [221206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9009), 1,
      sym_identifier,
  [221213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9011), 1,
      anon_sym_EQ,
  [221220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_RBRACK,
  [221227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9013), 1,
      anon_sym_EQ_GT,
  [221234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9015), 1,
      anon_sym_as,
  [221241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 1,
      anon_sym_COLON,
  [221248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9017), 1,
      anon_sym_RBRACE,
  [221255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9019), 1,
      anon_sym_from,
  [221262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9021), 1,
      anon_sym_EQ_GT,
  [221269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9023), 1,
      anon_sym_EQ_GT,
  [221276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9025), 1,
      anon_sym_EQ_GT,
  [221283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9027), 1,
      anon_sym_EQ_GT,
  [221290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9029), 1,
      sym_number,
  [221297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9031), 1,
      anon_sym_EQ_GT,
  [221304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9033), 1,
      anon_sym_EQ_GT,
  [221311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9035), 1,
      anon_sym_EQ_GT,
  [221318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9037), 1,
      anon_sym_EQ_GT,
  [221325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9039), 1,
      anon_sym_EQ,
  [221332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9041), 1,
      anon_sym_EQ_GT,
  [221339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9043), 1,
      anon_sym_EQ_GT,
  [221346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6174), 1,
      anon_sym_RPAREN,
  [221353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 1,
      anon_sym_RPAREN,
  [221360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9045), 1,
      anon_sym_EQ,
  [221367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6154), 1,
      anon_sym_RPAREN,
  [221374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9047), 1,
      anon_sym_SLASH2,
  [221381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9049), 1,
      anon_sym_EQ_GT,
  [221388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9051), 1,
      anon_sym_EQ_GT,
  [221395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6149), 1,
      anon_sym_RBRACK,
  [221402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9053), 1,
      sym_identifier,
  [221409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9055), 1,
      sym_identifier,
  [221416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9057), 1,
      anon_sym_EQ_GT,
  [221423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9059), 1,
      anon_sym_COLON,
  [221430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9061), 1,
      sym_identifier,
  [221437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9063), 1,
      sym_identifier,
  [221444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9065), 1,
      anon_sym_EQ_GT,
  [221451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9067), 1,
      anon_sym_EQ_GT,
  [221458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9069), 1,
      sym_identifier,
  [221465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9071), 1,
      sym_identifier,
  [221472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9073), 1,
      anon_sym_EQ_GT,
  [221479] = 2,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(9075), 1,
      sym_regex_pattern,
  [221486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_RBRACK,
  [221493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9077), 1,
      anon_sym_RPAREN,
  [221500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9079), 1,
      anon_sym_EQ_GT,
  [221507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9081), 1,
      anon_sym_EQ_GT,
  [221514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9083), 1,
      anon_sym_EQ_GT,
  [221521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9085), 1,
      anon_sym_EQ_GT,
  [221528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9087), 1,
      anon_sym_EQ_GT,
  [221535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9089), 1,
      anon_sym_EQ_GT,
  [221542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9091), 1,
      anon_sym_EQ_GT,
  [221549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9093), 1,
      anon_sym_EQ_GT,
  [221556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9095), 1,
      anon_sym_EQ_GT,
  [221563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9097), 1,
      anon_sym_EQ_GT,
  [221570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9099), 1,
      anon_sym_EQ_GT,
  [221577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9101), 1,
      anon_sym_EQ_GT,
  [221584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9103), 1,
      anon_sym_EQ_GT,
  [221591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9105), 1,
      anon_sym_COLON,
  [221598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9107), 1,
      anon_sym_function,
  [221605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9109), 1,
      anon_sym_EQ_GT,
  [221612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9111), 1,
      anon_sym_EQ_GT,
  [221619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9113), 1,
      sym_identifier,
  [221626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9115), 1,
      sym_identifier,
  [221633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9117), 1,
      anon_sym_RBRACK,
  [221640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8217), 1,
      anon_sym_EQ,
  [221647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9119), 1,
      sym_identifier,
  [221654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9121), 1,
      sym_identifier,
  [221661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9123), 1,
      anon_sym_EQ_GT,
  [221668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9125), 1,
      anon_sym_EQ_GT,
  [221675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9127), 1,
      anon_sym_EQ,
  [221682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9129), 1,
      anon_sym_namespace,
  [221689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9131), 1,
      anon_sym_EQ_GT,
  [221696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9133), 1,
      sym_identifier,
  [221703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9135), 1,
      anon_sym_EQ_GT,
  [221710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5752), 1,
      anon_sym_RPAREN,
  [221717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9137), 1,
      anon_sym_SLASH2,
  [221724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_RBRACE,
  [221731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9139), 1,
      anon_sym_EQ_GT,
  [221738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9141), 1,
      anon_sym_EQ_GT,
  [221745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8437), 1,
      anon_sym_EQ,
  [221752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9143), 1,
      anon_sym_EQ_GT,
  [221759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9145), 1,
      sym_number,
  [221766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9147), 1,
      anon_sym_EQ_GT,
  [221773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9149), 1,
      sym_identifier,
  [221780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9151), 1,
      anon_sym_EQ_GT,
  [221787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9153), 1,
      anon_sym_SLASH2,
  [221794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9155), 1,
      anon_sym_EQ_GT,
  [221801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9157), 1,
      anon_sym_EQ_GT,
  [221808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9159), 1,
      anon_sym_EQ_GT,
  [221815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9161), 1,
      anon_sym_EQ_GT,
  [221822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9163), 1,
      anon_sym_EQ_GT,
  [221829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9165), 1,
      anon_sym_EQ_GT,
  [221836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9167), 1,
      anon_sym_EQ_GT,
  [221843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9169), 1,
      anon_sym_EQ_GT,
  [221850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9171), 1,
      anon_sym_EQ_GT,
  [221857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9173), 1,
      sym_identifier,
  [221864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9175), 1,
      anon_sym_RPAREN,
  [221871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9177), 1,
      ts_builtin_sym_end,
  [221878] = 2,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(9179), 1,
      sym_regex_pattern,
  [221885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      sym_identifier,
  [221892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9183), 1,
      anon_sym_EQ_GT,
  [221899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9185), 1,
      sym_identifier,
  [221906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9187), 1,
      anon_sym_EQ_GT,
  [221913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9189), 1,
      anon_sym_class,
  [221920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9191), 1,
      sym_identifier,
  [221927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9193), 1,
      anon_sym_EQ_GT,
  [221934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9195), 1,
      anon_sym_EQ_GT,
  [221941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9197), 1,
      anon_sym_EQ,
  [221948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9199), 1,
      anon_sym_EQ,
  [221955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9201), 1,
      anon_sym_EQ_GT,
  [221962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      anon_sym_DOT,
  [221969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9203), 1,
      anon_sym_class,
  [221976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9205), 1,
      anon_sym_EQ_GT,
  [221983] = 2,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(9207), 1,
      sym_regex_pattern,
  [221990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9209), 1,
      anon_sym_EQ_GT,
  [221997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9211), 1,
      anon_sym_EQ_GT,
  [222004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9213), 1,
      anon_sym_EQ_GT,
  [222011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9215), 1,
      anon_sym_EQ_GT,
  [222018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9217), 1,
      anon_sym_EQ_GT,
  [222025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9219), 1,
      anon_sym_EQ_GT,
  [222032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9221), 1,
      anon_sym_EQ_GT,
  [222039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9223), 1,
      anon_sym_namespace,
  [222046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9225), 1,
      anon_sym_LBRACE,
  [222053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9227), 1,
      anon_sym_EQ,
  [222060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9229), 1,
      anon_sym_EQ_GT,
  [222067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9231), 1,
      anon_sym_EQ_GT,
  [222074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9233), 1,
      anon_sym_from,
  [222081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9235), 1,
      anon_sym_RPAREN,
  [222088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6098), 1,
      anon_sym_RPAREN,
  [222095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9237), 1,
      anon_sym_EQ_GT,
  [222102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_RPAREN,
  [222109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym_EQ_GT,
  [222116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9241), 1,
      anon_sym_COLON,
  [222123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9243), 1,
      sym_identifier,
  [222130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9245), 1,
      anon_sym_EQ_GT,
  [222137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9247), 1,
      anon_sym_class,
  [222144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9249), 1,
      anon_sym_RBRACK,
  [222151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9251), 1,
      sym_number,
  [222158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9253), 1,
      anon_sym_EQ_GT,
  [222165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9255), 1,
      sym_identifier,
  [222172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9257), 1,
      anon_sym_EQ_GT,
  [222179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9259), 1,
      anon_sym_RPAREN,
  [222186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9261), 1,
      anon_sym_EQ_GT,
  [222193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9263), 1,
      anon_sym_SLASH2,
  [222200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9265), 1,
      anon_sym_EQ_GT,
  [222207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9267), 1,
      sym_identifier,
  [222214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9269), 1,
      anon_sym_EQ_GT,
  [222221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9271), 1,
      anon_sym_RPAREN,
  [222228] = 2,
    ACTIONS(7901), 1,
      sym_comment,
    ACTIONS(9273), 1,
      sym_regex_pattern,
  [222235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9275), 1,
      sym_identifier,
  [222242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 1,
      anon_sym_DOT,
  [222249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9277), 1,
      anon_sym_EQ_GT,
  [222256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9279), 1,
      anon_sym_EQ_GT,
  [222263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9281), 1,
      anon_sym_EQ_GT,
  [222270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9283), 1,
      anon_sym_EQ_GT,
  [222277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9285), 1,
      anon_sym_EQ_GT,
  [222284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9287), 1,
      anon_sym_EQ_GT,
  [222291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9289), 1,
      anon_sym_EQ_GT,
  [222298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 1,
      anon_sym_RBRACK,
  [222305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_EQ_GT,
  [222312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9293), 1,
      sym_identifier,
  [222319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 1,
      anon_sym_RPAREN,
  [222326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9295), 1,
      anon_sym_readonly,
  [222333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9297), 1,
      anon_sym_EQ_GT,
  [222340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9299), 1,
      sym_identifier,
  [222347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9301), 1,
      anon_sym_EQ_GT,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1181)] = 0,
  [SMALL_STATE(1182)] = 89,
  [SMALL_STATE(1183)] = 178,
  [SMALL_STATE(1184)] = 267,
  [SMALL_STATE(1185)] = 356,
  [SMALL_STATE(1186)] = 489,
  [SMALL_STATE(1187)] = 578,
  [SMALL_STATE(1188)] = 667,
  [SMALL_STATE(1189)] = 755,
  [SMALL_STATE(1190)] = 843,
  [SMALL_STATE(1191)] = 913,
  [SMALL_STATE(1192)] = 1001,
  [SMALL_STATE(1193)] = 1089,
  [SMALL_STATE(1194)] = 1177,
  [SMALL_STATE(1195)] = 1265,
  [SMALL_STATE(1196)] = 1335,
  [SMALL_STATE(1197)] = 1423,
  [SMALL_STATE(1198)] = 1511,
  [SMALL_STATE(1199)] = 1599,
  [SMALL_STATE(1200)] = 1687,
  [SMALL_STATE(1201)] = 1775,
  [SMALL_STATE(1202)] = 1865,
  [SMALL_STATE(1203)] = 1955,
  [SMALL_STATE(1204)] = 2045,
  [SMALL_STATE(1205)] = 2133,
  [SMALL_STATE(1206)] = 2221,
  [SMALL_STATE(1207)] = 2311,
  [SMALL_STATE(1208)] = 2403,
  [SMALL_STATE(1209)] = 2491,
  [SMALL_STATE(1210)] = 2561,
  [SMALL_STATE(1211)] = 2630,
  [SMALL_STATE(1212)] = 2767,
  [SMALL_STATE(1213)] = 2854,
  [SMALL_STATE(1214)] = 2991,
  [SMALL_STATE(1215)] = 3060,
  [SMALL_STATE(1216)] = 3197,
  [SMALL_STATE(1217)] = 3266,
  [SMALL_STATE(1218)] = 3335,
  [SMALL_STATE(1219)] = 3422,
  [SMALL_STATE(1220)] = 3559,
  [SMALL_STATE(1221)] = 3696,
  [SMALL_STATE(1222)] = 3783,
  [SMALL_STATE(1223)] = 3920,
  [SMALL_STATE(1224)] = 4007,
  [SMALL_STATE(1225)] = 4144,
  [SMALL_STATE(1226)] = 4231,
  [SMALL_STATE(1227)] = 4368,
  [SMALL_STATE(1228)] = 4455,
  [SMALL_STATE(1229)] = 4592,
  [SMALL_STATE(1230)] = 4661,
  [SMALL_STATE(1231)] = 4798,
  [SMALL_STATE(1232)] = 4935,
  [SMALL_STATE(1233)] = 5022,
  [SMALL_STATE(1234)] = 5159,
  [SMALL_STATE(1235)] = 5296,
  [SMALL_STATE(1236)] = 5433,
  [SMALL_STATE(1237)] = 5570,
  [SMALL_STATE(1238)] = 5657,
  [SMALL_STATE(1239)] = 5744,
  [SMALL_STATE(1240)] = 5813,
  [SMALL_STATE(1241)] = 5950,
  [SMALL_STATE(1242)] = 6041,
  [SMALL_STATE(1243)] = 6134,
  [SMALL_STATE(1244)] = 6271,
  [SMALL_STATE(1245)] = 6408,
  [SMALL_STATE(1246)] = 6545,
  [SMALL_STATE(1247)] = 6682,
  [SMALL_STATE(1248)] = 6769,
  [SMALL_STATE(1249)] = 6855,
  [SMALL_STATE(1250)] = 6941,
  [SMALL_STATE(1251)] = 7029,
  [SMALL_STATE(1252)] = 7117,
  [SMALL_STATE(1253)] = 7205,
  [SMALL_STATE(1254)] = 7291,
  [SMALL_STATE(1255)] = 7379,
  [SMALL_STATE(1256)] = 7467,
  [SMALL_STATE(1257)] = 7555,
  [SMALL_STATE(1258)] = 7681,
  [SMALL_STATE(1259)] = 7761,
  [SMALL_STATE(1260)] = 7841,
  [SMALL_STATE(1261)] = 7921,
  [SMALL_STATE(1262)] = 8007,
  [SMALL_STATE(1263)] = 8087,
  [SMALL_STATE(1264)] = 8177,
  [SMALL_STATE(1265)] = 8265,
  [SMALL_STATE(1266)] = 8353,
  [SMALL_STATE(1267)] = 8439,
  [SMALL_STATE(1268)] = 8527,
  [SMALL_STATE(1269)] = 8613,
  [SMALL_STATE(1270)] = 8699,
  [SMALL_STATE(1271)] = 8787,
  [SMALL_STATE(1272)] = 8871,
  [SMALL_STATE(1273)] = 8955,
  [SMALL_STATE(1274)] = 9027,
  [SMALL_STATE(1275)] = 9115,
  [SMALL_STATE(1276)] = 9195,
  [SMALL_STATE(1277)] = 9280,
  [SMALL_STATE(1278)] = 9359,
  [SMALL_STATE(1279)] = 9484,
  [SMALL_STATE(1280)] = 9569,
  [SMALL_STATE(1281)] = 9642,
  [SMALL_STATE(1282)] = 9767,
  [SMALL_STATE(1283)] = 9844,
  [SMALL_STATE(1284)] = 9929,
  [SMALL_STATE(1285)] = 10002,
  [SMALL_STATE(1286)] = 10087,
  [SMALL_STATE(1287)] = 10172,
  [SMALL_STATE(1288)] = 10239,
  [SMALL_STATE(1289)] = 10312,
  [SMALL_STATE(1290)] = 10437,
  [SMALL_STATE(1291)] = 10510,
  [SMALL_STATE(1292)] = 10583,
  [SMALL_STATE(1293)] = 10650,
  [SMALL_STATE(1294)] = 10735,
  [SMALL_STATE(1295)] = 10820,
  [SMALL_STATE(1296)] = 10903,
  [SMALL_STATE(1297)] = 10988,
  [SMALL_STATE(1298)] = 11073,
  [SMALL_STATE(1299)] = 11158,
  [SMALL_STATE(1300)] = 11235,
  [SMALL_STATE(1301)] = 11320,
  [SMALL_STATE(1302)] = 11393,
  [SMALL_STATE(1303)] = 11460,
  [SMALL_STATE(1304)] = 11545,
  [SMALL_STATE(1305)] = 11624,
  [SMALL_STATE(1306)] = 11691,
  [SMALL_STATE(1307)] = 11776,
  [SMALL_STATE(1308)] = 11843,
  [SMALL_STATE(1309)] = 11928,
  [SMALL_STATE(1310)] = 12015,
  [SMALL_STATE(1311)] = 12094,
  [SMALL_STATE(1312)] = 12179,
  [SMALL_STATE(1313)] = 12264,
  [SMALL_STATE(1314)] = 12331,
  [SMALL_STATE(1315)] = 12404,
  [SMALL_STATE(1316)] = 12483,
  [SMALL_STATE(1317)] = 12568,
  [SMALL_STATE(1318)] = 12653,
  [SMALL_STATE(1319)] = 12726,
  [SMALL_STATE(1320)] = 12805,
  [SMALL_STATE(1321)] = 12894,
  [SMALL_STATE(1322)] = 12979,
  [SMALL_STATE(1323)] = 13064,
  [SMALL_STATE(1324)] = 13149,
  [SMALL_STATE(1325)] = 13227,
  [SMALL_STATE(1326)] = 13299,
  [SMALL_STATE(1327)] = 13391,
  [SMALL_STATE(1328)] = 13517,
  [SMALL_STATE(1329)] = 13643,
  [SMALL_STATE(1330)] = 13715,
  [SMALL_STATE(1331)] = 13839,
  [SMALL_STATE(1332)] = 13965,
  [SMALL_STATE(1333)] = 14035,
  [SMALL_STATE(1334)] = 14107,
  [SMALL_STATE(1335)] = 14185,
  [SMALL_STATE(1336)] = 14311,
  [SMALL_STATE(1337)] = 14437,
  [SMALL_STATE(1338)] = 14507,
  [SMALL_STATE(1339)] = 14633,
  [SMALL_STATE(1340)] = 14711,
  [SMALL_STATE(1341)] = 14783,
  [SMALL_STATE(1342)] = 14909,
  [SMALL_STATE(1343)] = 14987,
  [SMALL_STATE(1344)] = 15067,
  [SMALL_STATE(1345)] = 15193,
  [SMALL_STATE(1346)] = 15319,
  [SMALL_STATE(1347)] = 15391,
  [SMALL_STATE(1348)] = 15517,
  [SMALL_STATE(1349)] = 15643,
  [SMALL_STATE(1350)] = 15713,
  [SMALL_STATE(1351)] = 15839,
  [SMALL_STATE(1352)] = 15915,
  [SMALL_STATE(1353)] = 16041,
  [SMALL_STATE(1354)] = 16167,
  [SMALL_STATE(1355)] = 16245,
  [SMALL_STATE(1356)] = 16317,
  [SMALL_STATE(1357)] = 16389,
  [SMALL_STATE(1358)] = 16473,
  [SMALL_STATE(1359)] = 16551,
  [SMALL_STATE(1360)] = 16677,
  [SMALL_STATE(1361)] = 16803,
  [SMALL_STATE(1362)] = 16887,
  [SMALL_STATE(1363)] = 16965,
  [SMALL_STATE(1364)] = 17091,
  [SMALL_STATE(1365)] = 17156,
  [SMALL_STATE(1366)] = 17227,
  [SMALL_STATE(1367)] = 17350,
  [SMALL_STATE(1368)] = 17419,
  [SMALL_STATE(1369)] = 17494,
  [SMALL_STATE(1370)] = 17565,
  [SMALL_STATE(1371)] = 17634,
  [SMALL_STATE(1372)] = 17757,
  [SMALL_STATE(1373)] = 17880,
  [SMALL_STATE(1374)] = 18003,
  [SMALL_STATE(1375)] = 18126,
  [SMALL_STATE(1376)] = 18197,
  [SMALL_STATE(1377)] = 18274,
  [SMALL_STATE(1378)] = 18397,
  [SMALL_STATE(1379)] = 18520,
  [SMALL_STATE(1380)] = 18595,
  [SMALL_STATE(1381)] = 18718,
  [SMALL_STATE(1382)] = 18841,
  [SMALL_STATE(1383)] = 18906,
  [SMALL_STATE(1384)] = 19029,
  [SMALL_STATE(1385)] = 19152,
  [SMALL_STATE(1386)] = 19229,
  [SMALL_STATE(1387)] = 19352,
  [SMALL_STATE(1388)] = 19475,
  [SMALL_STATE(1389)] = 19598,
  [SMALL_STATE(1390)] = 19721,
  [SMALL_STATE(1391)] = 19844,
  [SMALL_STATE(1392)] = 19967,
  [SMALL_STATE(1393)] = 20044,
  [SMALL_STATE(1394)] = 20167,
  [SMALL_STATE(1395)] = 20290,
  [SMALL_STATE(1396)] = 20371,
  [SMALL_STATE(1397)] = 20494,
  [SMALL_STATE(1398)] = 20617,
  [SMALL_STATE(1399)] = 20740,
  [SMALL_STATE(1400)] = 20863,
  [SMALL_STATE(1401)] = 20946,
  [SMALL_STATE(1402)] = 21023,
  [SMALL_STATE(1403)] = 21146,
  [SMALL_STATE(1404)] = 21269,
  [SMALL_STATE(1405)] = 21392,
  [SMALL_STATE(1406)] = 21461,
  [SMALL_STATE(1407)] = 21584,
  [SMALL_STATE(1408)] = 21707,
  [SMALL_STATE(1409)] = 21790,
  [SMALL_STATE(1410)] = 21913,
  [SMALL_STATE(1411)] = 22036,
  [SMALL_STATE(1412)] = 22117,
  [SMALL_STATE(1413)] = 22194,
  [SMALL_STATE(1414)] = 22317,
  [SMALL_STATE(1415)] = 22440,
  [SMALL_STATE(1416)] = 22505,
  [SMALL_STATE(1417)] = 22628,
  [SMALL_STATE(1418)] = 22751,
  [SMALL_STATE(1419)] = 22874,
  [SMALL_STATE(1420)] = 22997,
  [SMALL_STATE(1421)] = 23074,
  [SMALL_STATE(1422)] = 23155,
  [SMALL_STATE(1423)] = 23232,
  [SMALL_STATE(1424)] = 23355,
  [SMALL_STATE(1425)] = 23426,
  [SMALL_STATE(1426)] = 23549,
  [SMALL_STATE(1427)] = 23672,
  [SMALL_STATE(1428)] = 23755,
  [SMALL_STATE(1429)] = 23832,
  [SMALL_STATE(1430)] = 23955,
  [SMALL_STATE(1431)] = 24032,
  [SMALL_STATE(1432)] = 24109,
  [SMALL_STATE(1433)] = 24232,
  [SMALL_STATE(1434)] = 24301,
  [SMALL_STATE(1435)] = 24424,
  [SMALL_STATE(1436)] = 24547,
  [SMALL_STATE(1437)] = 24670,
  [SMALL_STATE(1438)] = 24793,
  [SMALL_STATE(1439)] = 24916,
  [SMALL_STATE(1440)] = 24987,
  [SMALL_STATE(1441)] = 25110,
  [SMALL_STATE(1442)] = 25233,
  [SMALL_STATE(1443)] = 25356,
  [SMALL_STATE(1444)] = 25479,
  [SMALL_STATE(1445)] = 25556,
  [SMALL_STATE(1446)] = 25679,
  [SMALL_STATE(1447)] = 25802,
  [SMALL_STATE(1448)] = 25925,
  [SMALL_STATE(1449)] = 26048,
  [SMALL_STATE(1450)] = 26131,
  [SMALL_STATE(1451)] = 26254,
  [SMALL_STATE(1452)] = 26377,
  [SMALL_STATE(1453)] = 26448,
  [SMALL_STATE(1454)] = 26513,
  [SMALL_STATE(1455)] = 26596,
  [SMALL_STATE(1456)] = 26719,
  [SMALL_STATE(1457)] = 26842,
  [SMALL_STATE(1458)] = 26971,
  [SMALL_STATE(1459)] = 27048,
  [SMALL_STATE(1460)] = 27135,
  [SMALL_STATE(1461)] = 27258,
  [SMALL_STATE(1462)] = 27381,
  [SMALL_STATE(1463)] = 27450,
  [SMALL_STATE(1464)] = 27573,
  [SMALL_STATE(1465)] = 27696,
  [SMALL_STATE(1466)] = 27819,
  [SMALL_STATE(1467)] = 27942,
  [SMALL_STATE(1468)] = 28013,
  [SMALL_STATE(1469)] = 28136,
  [SMALL_STATE(1470)] = 28259,
  [SMALL_STATE(1471)] = 28344,
  [SMALL_STATE(1472)] = 28467,
  [SMALL_STATE(1473)] = 28590,
  [SMALL_STATE(1474)] = 28713,
  [SMALL_STATE(1475)] = 28836,
  [SMALL_STATE(1476)] = 28959,
  [SMALL_STATE(1477)] = 29088,
  [SMALL_STATE(1478)] = 29153,
  [SMALL_STATE(1479)] = 29276,
  [SMALL_STATE(1480)] = 29399,
  [SMALL_STATE(1481)] = 29528,
  [SMALL_STATE(1482)] = 29599,
  [SMALL_STATE(1483)] = 29722,
  [SMALL_STATE(1484)] = 29799,
  [SMALL_STATE(1485)] = 29876,
  [SMALL_STATE(1486)] = 29947,
  [SMALL_STATE(1487)] = 30018,
  [SMALL_STATE(1488)] = 30147,
  [SMALL_STATE(1489)] = 30270,
  [SMALL_STATE(1490)] = 30359,
  [SMALL_STATE(1491)] = 30436,
  [SMALL_STATE(1492)] = 30559,
  [SMALL_STATE(1493)] = 30624,
  [SMALL_STATE(1494)] = 30747,
  [SMALL_STATE(1495)] = 30870,
  [SMALL_STATE(1496)] = 30990,
  [SMALL_STATE(1497)] = 31110,
  [SMALL_STATE(1498)] = 31230,
  [SMALL_STATE(1499)] = 31350,
  [SMALL_STATE(1500)] = 31470,
  [SMALL_STATE(1501)] = 31590,
  [SMALL_STATE(1502)] = 31660,
  [SMALL_STATE(1503)] = 31780,
  [SMALL_STATE(1504)] = 31900,
  [SMALL_STATE(1505)] = 32020,
  [SMALL_STATE(1506)] = 32140,
  [SMALL_STATE(1507)] = 32260,
  [SMALL_STATE(1508)] = 32380,
  [SMALL_STATE(1509)] = 32500,
  [SMALL_STATE(1510)] = 32620,
  [SMALL_STATE(1511)] = 32740,
  [SMALL_STATE(1512)] = 32860,
  [SMALL_STATE(1513)] = 32980,
  [SMALL_STATE(1514)] = 33100,
  [SMALL_STATE(1515)] = 33220,
  [SMALL_STATE(1516)] = 33340,
  [SMALL_STATE(1517)] = 33416,
  [SMALL_STATE(1518)] = 33536,
  [SMALL_STATE(1519)] = 33656,
  [SMALL_STATE(1520)] = 33776,
  [SMALL_STATE(1521)] = 33896,
  [SMALL_STATE(1522)] = 34016,
  [SMALL_STATE(1523)] = 34136,
  [SMALL_STATE(1524)] = 34256,
  [SMALL_STATE(1525)] = 34376,
  [SMALL_STATE(1526)] = 34446,
  [SMALL_STATE(1527)] = 34516,
  [SMALL_STATE(1528)] = 34636,
  [SMALL_STATE(1529)] = 34756,
  [SMALL_STATE(1530)] = 34876,
  [SMALL_STATE(1531)] = 34996,
  [SMALL_STATE(1532)] = 35116,
  [SMALL_STATE(1533)] = 35236,
  [SMALL_STATE(1534)] = 35306,
  [SMALL_STATE(1535)] = 35426,
  [SMALL_STATE(1536)] = 35546,
  [SMALL_STATE(1537)] = 35616,
  [SMALL_STATE(1538)] = 35736,
  [SMALL_STATE(1539)] = 35856,
  [SMALL_STATE(1540)] = 35924,
  [SMALL_STATE(1541)] = 36044,
  [SMALL_STATE(1542)] = 36164,
  [SMALL_STATE(1543)] = 36284,
  [SMALL_STATE(1544)] = 36352,
  [SMALL_STATE(1545)] = 36472,
  [SMALL_STATE(1546)] = 36592,
  [SMALL_STATE(1547)] = 36712,
  [SMALL_STATE(1548)] = 36784,
  [SMALL_STATE(1549)] = 36904,
  [SMALL_STATE(1550)] = 37024,
  [SMALL_STATE(1551)] = 37144,
  [SMALL_STATE(1552)] = 37264,
  [SMALL_STATE(1553)] = 37384,
  [SMALL_STATE(1554)] = 37504,
  [SMALL_STATE(1555)] = 37624,
  [SMALL_STATE(1556)] = 37744,
  [SMALL_STATE(1557)] = 37864,
  [SMALL_STATE(1558)] = 37984,
  [SMALL_STATE(1559)] = 38104,
  [SMALL_STATE(1560)] = 38224,
  [SMALL_STATE(1561)] = 38294,
  [SMALL_STATE(1562)] = 38414,
  [SMALL_STATE(1563)] = 38534,
  [SMALL_STATE(1564)] = 38654,
  [SMALL_STATE(1565)] = 38774,
  [SMALL_STATE(1566)] = 38894,
  [SMALL_STATE(1567)] = 39014,
  [SMALL_STATE(1568)] = 39134,
  [SMALL_STATE(1569)] = 39254,
  [SMALL_STATE(1570)] = 39374,
  [SMALL_STATE(1571)] = 39494,
  [SMALL_STATE(1572)] = 39570,
  [SMALL_STATE(1573)] = 39642,
  [SMALL_STATE(1574)] = 39762,
  [SMALL_STATE(1575)] = 39882,
  [SMALL_STATE(1576)] = 40002,
  [SMALL_STATE(1577)] = 40122,
  [SMALL_STATE(1578)] = 40242,
  [SMALL_STATE(1579)] = 40314,
  [SMALL_STATE(1580)] = 40434,
  [SMALL_STATE(1581)] = 40554,
  [SMALL_STATE(1582)] = 40674,
  [SMALL_STATE(1583)] = 40794,
  [SMALL_STATE(1584)] = 40914,
  [SMALL_STATE(1585)] = 41034,
  [SMALL_STATE(1586)] = 41154,
  [SMALL_STATE(1587)] = 41274,
  [SMALL_STATE(1588)] = 41394,
  [SMALL_STATE(1589)] = 41514,
  [SMALL_STATE(1590)] = 41634,
  [SMALL_STATE(1591)] = 41704,
  [SMALL_STATE(1592)] = 41824,
  [SMALL_STATE(1593)] = 41944,
  [SMALL_STATE(1594)] = 42064,
  [SMALL_STATE(1595)] = 42134,
  [SMALL_STATE(1596)] = 42254,
  [SMALL_STATE(1597)] = 42374,
  [SMALL_STATE(1598)] = 42494,
  [SMALL_STATE(1599)] = 42614,
  [SMALL_STATE(1600)] = 42734,
  [SMALL_STATE(1601)] = 42854,
  [SMALL_STATE(1602)] = 42974,
  [SMALL_STATE(1603)] = 43094,
  [SMALL_STATE(1604)] = 43214,
  [SMALL_STATE(1605)] = 43288,
  [SMALL_STATE(1606)] = 43408,
  [SMALL_STATE(1607)] = 43528,
  [SMALL_STATE(1608)] = 43648,
  [SMALL_STATE(1609)] = 43768,
  [SMALL_STATE(1610)] = 43888,
  [SMALL_STATE(1611)] = 43964,
  [SMALL_STATE(1612)] = 44084,
  [SMALL_STATE(1613)] = 44204,
  [SMALL_STATE(1614)] = 44324,
  [SMALL_STATE(1615)] = 44444,
  [SMALL_STATE(1616)] = 44518,
  [SMALL_STATE(1617)] = 44638,
  [SMALL_STATE(1618)] = 44758,
  [SMALL_STATE(1619)] = 44878,
  [SMALL_STATE(1620)] = 44998,
  [SMALL_STATE(1621)] = 45118,
  [SMALL_STATE(1622)] = 45238,
  [SMALL_STATE(1623)] = 45358,
  [SMALL_STATE(1624)] = 45478,
  [SMALL_STATE(1625)] = 45552,
  [SMALL_STATE(1626)] = 45672,
  [SMALL_STATE(1627)] = 45792,
  [SMALL_STATE(1628)] = 45912,
  [SMALL_STATE(1629)] = 46032,
  [SMALL_STATE(1630)] = 46152,
  [SMALL_STATE(1631)] = 46272,
  [SMALL_STATE(1632)] = 46392,
  [SMALL_STATE(1633)] = 46512,
  [SMALL_STATE(1634)] = 46632,
  [SMALL_STATE(1635)] = 46752,
  [SMALL_STATE(1636)] = 46872,
  [SMALL_STATE(1637)] = 46992,
  [SMALL_STATE(1638)] = 47112,
  [SMALL_STATE(1639)] = 47232,
  [SMALL_STATE(1640)] = 47352,
  [SMALL_STATE(1641)] = 47472,
  [SMALL_STATE(1642)] = 47592,
  [SMALL_STATE(1643)] = 47712,
  [SMALL_STATE(1644)] = 47832,
  [SMALL_STATE(1645)] = 47952,
  [SMALL_STATE(1646)] = 48072,
  [SMALL_STATE(1647)] = 48192,
  [SMALL_STATE(1648)] = 48312,
  [SMALL_STATE(1649)] = 48384,
  [SMALL_STATE(1650)] = 48456,
  [SMALL_STATE(1651)] = 48576,
  [SMALL_STATE(1652)] = 48652,
  [SMALL_STATE(1653)] = 48772,
  [SMALL_STATE(1654)] = 48842,
  [SMALL_STATE(1655)] = 48912,
  [SMALL_STATE(1656)] = 49032,
  [SMALL_STATE(1657)] = 49152,
  [SMALL_STATE(1658)] = 49272,
  [SMALL_STATE(1659)] = 49392,
  [SMALL_STATE(1660)] = 49512,
  [SMALL_STATE(1661)] = 49632,
  [SMALL_STATE(1662)] = 49752,
  [SMALL_STATE(1663)] = 49872,
  [SMALL_STATE(1664)] = 49992,
  [SMALL_STATE(1665)] = 50112,
  [SMALL_STATE(1666)] = 50232,
  [SMALL_STATE(1667)] = 50352,
  [SMALL_STATE(1668)] = 50472,
  [SMALL_STATE(1669)] = 50592,
  [SMALL_STATE(1670)] = 50672,
  [SMALL_STATE(1671)] = 50792,
  [SMALL_STATE(1672)] = 50912,
  [SMALL_STATE(1673)] = 51032,
  [SMALL_STATE(1674)] = 51152,
  [SMALL_STATE(1675)] = 51272,
  [SMALL_STATE(1676)] = 51392,
  [SMALL_STATE(1677)] = 51512,
  [SMALL_STATE(1678)] = 51632,
  [SMALL_STATE(1679)] = 51752,
  [SMALL_STATE(1680)] = 51872,
  [SMALL_STATE(1681)] = 51948,
  [SMALL_STATE(1682)] = 52068,
  [SMALL_STATE(1683)] = 52188,
  [SMALL_STATE(1684)] = 52308,
  [SMALL_STATE(1685)] = 52428,
  [SMALL_STATE(1686)] = 52548,
  [SMALL_STATE(1687)] = 52668,
  [SMALL_STATE(1688)] = 52788,
  [SMALL_STATE(1689)] = 52864,
  [SMALL_STATE(1690)] = 52984,
  [SMALL_STATE(1691)] = 53104,
  [SMALL_STATE(1692)] = 53224,
  [SMALL_STATE(1693)] = 53344,
  [SMALL_STATE(1694)] = 53464,
  [SMALL_STATE(1695)] = 53584,
  [SMALL_STATE(1696)] = 53704,
  [SMALL_STATE(1697)] = 53824,
  [SMALL_STATE(1698)] = 53944,
  [SMALL_STATE(1699)] = 54064,
  [SMALL_STATE(1700)] = 54184,
  [SMALL_STATE(1701)] = 54304,
  [SMALL_STATE(1702)] = 54424,
  [SMALL_STATE(1703)] = 54544,
  [SMALL_STATE(1704)] = 54614,
  [SMALL_STATE(1705)] = 54734,
  [SMALL_STATE(1706)] = 54854,
  [SMALL_STATE(1707)] = 54974,
  [SMALL_STATE(1708)] = 55094,
  [SMALL_STATE(1709)] = 55214,
  [SMALL_STATE(1710)] = 55334,
  [SMALL_STATE(1711)] = 55404,
  [SMALL_STATE(1712)] = 55524,
  [SMALL_STATE(1713)] = 55644,
  [SMALL_STATE(1714)] = 55714,
  [SMALL_STATE(1715)] = 55834,
  [SMALL_STATE(1716)] = 55954,
  [SMALL_STATE(1717)] = 56074,
  [SMALL_STATE(1718)] = 56194,
  [SMALL_STATE(1719)] = 56314,
  [SMALL_STATE(1720)] = 56434,
  [SMALL_STATE(1721)] = 56554,
  [SMALL_STATE(1722)] = 56674,
  [SMALL_STATE(1723)] = 56794,
  [SMALL_STATE(1724)] = 56914,
  [SMALL_STATE(1725)] = 57034,
  [SMALL_STATE(1726)] = 57154,
  [SMALL_STATE(1727)] = 57274,
  [SMALL_STATE(1728)] = 57394,
  [SMALL_STATE(1729)] = 57514,
  [SMALL_STATE(1730)] = 57634,
  [SMALL_STATE(1731)] = 57754,
  [SMALL_STATE(1732)] = 57874,
  [SMALL_STATE(1733)] = 57994,
  [SMALL_STATE(1734)] = 58114,
  [SMALL_STATE(1735)] = 58234,
  [SMALL_STATE(1736)] = 58354,
  [SMALL_STATE(1737)] = 58474,
  [SMALL_STATE(1738)] = 58594,
  [SMALL_STATE(1739)] = 58714,
  [SMALL_STATE(1740)] = 58834,
  [SMALL_STATE(1741)] = 58954,
  [SMALL_STATE(1742)] = 59074,
  [SMALL_STATE(1743)] = 59156,
  [SMALL_STATE(1744)] = 59276,
  [SMALL_STATE(1745)] = 59346,
  [SMALL_STATE(1746)] = 59466,
  [SMALL_STATE(1747)] = 59586,
  [SMALL_STATE(1748)] = 59706,
  [SMALL_STATE(1749)] = 59826,
  [SMALL_STATE(1750)] = 59946,
  [SMALL_STATE(1751)] = 60066,
  [SMALL_STATE(1752)] = 60186,
  [SMALL_STATE(1753)] = 60306,
  [SMALL_STATE(1754)] = 60376,
  [SMALL_STATE(1755)] = 60496,
  [SMALL_STATE(1756)] = 60616,
  [SMALL_STATE(1757)] = 60736,
  [SMALL_STATE(1758)] = 60856,
  [SMALL_STATE(1759)] = 60976,
  [SMALL_STATE(1760)] = 61096,
  [SMALL_STATE(1761)] = 61216,
  [SMALL_STATE(1762)] = 61336,
  [SMALL_STATE(1763)] = 61456,
  [SMALL_STATE(1764)] = 61576,
  [SMALL_STATE(1765)] = 61696,
  [SMALL_STATE(1766)] = 61816,
  [SMALL_STATE(1767)] = 61936,
  [SMALL_STATE(1768)] = 62056,
  [SMALL_STATE(1769)] = 62176,
  [SMALL_STATE(1770)] = 62296,
  [SMALL_STATE(1771)] = 62416,
  [SMALL_STATE(1772)] = 62536,
  [SMALL_STATE(1773)] = 62656,
  [SMALL_STATE(1774)] = 62776,
  [SMALL_STATE(1775)] = 62896,
  [SMALL_STATE(1776)] = 63016,
  [SMALL_STATE(1777)] = 63136,
  [SMALL_STATE(1778)] = 63256,
  [SMALL_STATE(1779)] = 63376,
  [SMALL_STATE(1780)] = 63496,
  [SMALL_STATE(1781)] = 63576,
  [SMALL_STATE(1782)] = 63696,
  [SMALL_STATE(1783)] = 63816,
  [SMALL_STATE(1784)] = 63936,
  [SMALL_STATE(1785)] = 64056,
  [SMALL_STATE(1786)] = 64176,
  [SMALL_STATE(1787)] = 64296,
  [SMALL_STATE(1788)] = 64416,
  [SMALL_STATE(1789)] = 64536,
  [SMALL_STATE(1790)] = 64618,
  [SMALL_STATE(1791)] = 64694,
  [SMALL_STATE(1792)] = 64814,
  [SMALL_STATE(1793)] = 64884,
  [SMALL_STATE(1794)] = 65004,
  [SMALL_STATE(1795)] = 65124,
  [SMALL_STATE(1796)] = 65194,
  [SMALL_STATE(1797)] = 65314,
  [SMALL_STATE(1798)] = 65384,
  [SMALL_STATE(1799)] = 65504,
  [SMALL_STATE(1800)] = 65624,
  [SMALL_STATE(1801)] = 65744,
  [SMALL_STATE(1802)] = 65864,
  [SMALL_STATE(1803)] = 65984,
  [SMALL_STATE(1804)] = 66104,
  [SMALL_STATE(1805)] = 66224,
  [SMALL_STATE(1806)] = 66300,
  [SMALL_STATE(1807)] = 66420,
  [SMALL_STATE(1808)] = 66492,
  [SMALL_STATE(1809)] = 66612,
  [SMALL_STATE(1810)] = 66682,
  [SMALL_STATE(1811)] = 66802,
  [SMALL_STATE(1812)] = 66922,
  [SMALL_STATE(1813)] = 67042,
  [SMALL_STATE(1814)] = 67112,
  [SMALL_STATE(1815)] = 67232,
  [SMALL_STATE(1816)] = 67352,
  [SMALL_STATE(1817)] = 67472,
  [SMALL_STATE(1818)] = 67592,
  [SMALL_STATE(1819)] = 67712,
  [SMALL_STATE(1820)] = 67832,
  [SMALL_STATE(1821)] = 67952,
  [SMALL_STATE(1822)] = 68072,
  [SMALL_STATE(1823)] = 68192,
  [SMALL_STATE(1824)] = 68312,
  [SMALL_STATE(1825)] = 68432,
  [SMALL_STATE(1826)] = 68514,
  [SMALL_STATE(1827)] = 68634,
  [SMALL_STATE(1828)] = 68754,
  [SMALL_STATE(1829)] = 68874,
  [SMALL_STATE(1830)] = 68994,
  [SMALL_STATE(1831)] = 69114,
  [SMALL_STATE(1832)] = 69234,
  [SMALL_STATE(1833)] = 69354,
  [SMALL_STATE(1834)] = 69474,
  [SMALL_STATE(1835)] = 69544,
  [SMALL_STATE(1836)] = 69664,
  [SMALL_STATE(1837)] = 69738,
  [SMALL_STATE(1838)] = 69858,
  [SMALL_STATE(1839)] = 69978,
  [SMALL_STATE(1840)] = 70098,
  [SMALL_STATE(1841)] = 70218,
  [SMALL_STATE(1842)] = 70338,
  [SMALL_STATE(1843)] = 70458,
  [SMALL_STATE(1844)] = 70528,
  [SMALL_STATE(1845)] = 70648,
  [SMALL_STATE(1846)] = 70768,
  [SMALL_STATE(1847)] = 70888,
  [SMALL_STATE(1848)] = 71008,
  [SMALL_STATE(1849)] = 71084,
  [SMALL_STATE(1850)] = 71204,
  [SMALL_STATE(1851)] = 71324,
  [SMALL_STATE(1852)] = 71444,
  [SMALL_STATE(1853)] = 71520,
  [SMALL_STATE(1854)] = 71590,
  [SMALL_STATE(1855)] = 71710,
  [SMALL_STATE(1856)] = 71830,
  [SMALL_STATE(1857)] = 71900,
  [SMALL_STATE(1858)] = 72020,
  [SMALL_STATE(1859)] = 72140,
  [SMALL_STATE(1860)] = 72260,
  [SMALL_STATE(1861)] = 72380,
  [SMALL_STATE(1862)] = 72500,
  [SMALL_STATE(1863)] = 72620,
  [SMALL_STATE(1864)] = 72740,
  [SMALL_STATE(1865)] = 72860,
  [SMALL_STATE(1866)] = 72980,
  [SMALL_STATE(1867)] = 73100,
  [SMALL_STATE(1868)] = 73220,
  [SMALL_STATE(1869)] = 73302,
  [SMALL_STATE(1870)] = 73422,
  [SMALL_STATE(1871)] = 73542,
  [SMALL_STATE(1872)] = 73620,
  [SMALL_STATE(1873)] = 73740,
  [SMALL_STATE(1874)] = 73860,
  [SMALL_STATE(1875)] = 73980,
  [SMALL_STATE(1876)] = 74100,
  [SMALL_STATE(1877)] = 74220,
  [SMALL_STATE(1878)] = 74340,
  [SMALL_STATE(1879)] = 74460,
  [SMALL_STATE(1880)] = 74580,
  [SMALL_STATE(1881)] = 74700,
  [SMALL_STATE(1882)] = 74820,
  [SMALL_STATE(1883)] = 74940,
  [SMALL_STATE(1884)] = 75060,
  [SMALL_STATE(1885)] = 75180,
  [SMALL_STATE(1886)] = 75300,
  [SMALL_STATE(1887)] = 75420,
  [SMALL_STATE(1888)] = 75540,
  [SMALL_STATE(1889)] = 75660,
  [SMALL_STATE(1890)] = 75780,
  [SMALL_STATE(1891)] = 75856,
  [SMALL_STATE(1892)] = 75976,
  [SMALL_STATE(1893)] = 76050,
  [SMALL_STATE(1894)] = 76170,
  [SMALL_STATE(1895)] = 76290,
  [SMALL_STATE(1896)] = 76363,
  [SMALL_STATE(1897)] = 76438,
  [SMALL_STATE(1898)] = 76513,
  [SMALL_STATE(1899)] = 76588,
  [SMALL_STATE(1900)] = 76663,
  [SMALL_STATE(1901)] = 76730,
  [SMALL_STATE(1902)] = 76799,
  [SMALL_STATE(1903)] = 76866,
  [SMALL_STATE(1904)] = 76935,
  [SMALL_STATE(1905)] = 77008,
  [SMALL_STATE(1906)] = 77077,
  [SMALL_STATE(1907)] = 77146,
  [SMALL_STATE(1908)] = 77221,
  [SMALL_STATE(1909)] = 77296,
  [SMALL_STATE(1910)] = 77363,
  [SMALL_STATE(1911)] = 77432,
  [SMALL_STATE(1912)] = 77495,
  [SMALL_STATE(1913)] = 77568,
  [SMALL_STATE(1914)] = 77635,
  [SMALL_STATE(1915)] = 77704,
  [SMALL_STATE(1916)] = 77779,
  [SMALL_STATE(1917)] = 77848,
  [SMALL_STATE(1918)] = 77915,
  [SMALL_STATE(1919)] = 77984,
  [SMALL_STATE(1920)] = 78053,
  [SMALL_STATE(1921)] = 78116,
  [SMALL_STATE(1922)] = 78191,
  [SMALL_STATE(1923)] = 78258,
  [SMALL_STATE(1924)] = 78321,
  [SMALL_STATE(1925)] = 78398,
  [SMALL_STATE(1926)] = 78467,
  [SMALL_STATE(1927)] = 78534,
  [SMALL_STATE(1928)] = 78605,
  [SMALL_STATE(1929)] = 78674,
  [SMALL_STATE(1930)] = 78753,
  [SMALL_STATE(1931)] = 78828,
  [SMALL_STATE(1932)] = 78897,
  [SMALL_STATE(1933)] = 78978,
  [SMALL_STATE(1934)] = 79047,
  [SMALL_STATE(1935)] = 79110,
  [SMALL_STATE(1936)] = 79179,
  [SMALL_STATE(1937)] = 79256,
  [SMALL_STATE(1938)] = 79325,
  [SMALL_STATE(1939)] = 79392,
  [SMALL_STATE(1940)] = 79455,
  [SMALL_STATE(1941)] = 79524,
  [SMALL_STATE(1942)] = 79593,
  [SMALL_STATE(1943)] = 79656,
  [SMALL_STATE(1944)] = 79725,
  [SMALL_STATE(1945)] = 79800,
  [SMALL_STATE(1946)] = 79866,
  [SMALL_STATE(1947)] = 79934,
  [SMALL_STATE(1948)] = 80000,
  [SMALL_STATE(1949)] = 80118,
  [SMALL_STATE(1950)] = 80188,
  [SMALL_STATE(1951)] = 80256,
  [SMALL_STATE(1952)] = 80324,
  [SMALL_STATE(1953)] = 80398,
  [SMALL_STATE(1954)] = 80466,
  [SMALL_STATE(1955)] = 80538,
  [SMALL_STATE(1956)] = 80610,
  [SMALL_STATE(1957)] = 80680,
  [SMALL_STATE(1958)] = 80748,
  [SMALL_STATE(1959)] = 80820,
  [SMALL_STATE(1960)] = 80892,
  [SMALL_STATE(1961)] = 80960,
  [SMALL_STATE(1962)] = 81034,
  [SMALL_STATE(1963)] = 81100,
  [SMALL_STATE(1964)] = 81168,
  [SMALL_STATE(1965)] = 81236,
  [SMALL_STATE(1966)] = 81304,
  [SMALL_STATE(1967)] = 81372,
  [SMALL_STATE(1968)] = 81442,
  [SMALL_STATE(1969)] = 81516,
  [SMALL_STATE(1970)] = 81584,
  [SMALL_STATE(1971)] = 81654,
  [SMALL_STATE(1972)] = 81724,
  [SMALL_STATE(1973)] = 81790,
  [SMALL_STATE(1974)] = 81856,
  [SMALL_STATE(1975)] = 81926,
  [SMALL_STATE(1976)] = 81994,
  [SMALL_STATE(1977)] = 82112,
  [SMALL_STATE(1978)] = 82182,
  [SMALL_STATE(1979)] = 82254,
  [SMALL_STATE(1980)] = 82324,
  [SMALL_STATE(1981)] = 82392,
  [SMALL_STATE(1982)] = 82459,
  [SMALL_STATE(1983)] = 82526,
  [SMALL_STATE(1984)] = 82593,
  [SMALL_STATE(1985)] = 82660,
  [SMALL_STATE(1986)] = 82727,
  [SMALL_STATE(1987)] = 82794,
  [SMALL_STATE(1988)] = 82861,
  [SMALL_STATE(1989)] = 82928,
  [SMALL_STATE(1990)] = 82999,
  [SMALL_STATE(1991)] = 83070,
  [SMALL_STATE(1992)] = 83137,
  [SMALL_STATE(1993)] = 83204,
  [SMALL_STATE(1994)] = 83272,
  [SMALL_STATE(1995)] = 83387,
  [SMALL_STATE(1996)] = 83462,
  [SMALL_STATE(1997)] = 83577,
  [SMALL_STATE(1998)] = 83692,
  [SMALL_STATE(1999)] = 83807,
  [SMALL_STATE(2000)] = 83922,
  [SMALL_STATE(2001)] = 84037,
  [SMALL_STATE(2002)] = 84152,
  [SMALL_STATE(2003)] = 84267,
  [SMALL_STATE(2004)] = 84382,
  [SMALL_STATE(2005)] = 84488,
  [SMALL_STATE(2006)] = 84594,
  [SMALL_STATE(2007)] = 84700,
  [SMALL_STATE(2008)] = 84806,
  [SMALL_STATE(2009)] = 84918,
  [SMALL_STATE(2010)] = 85024,
  [SMALL_STATE(2011)] = 85130,
  [SMALL_STATE(2012)] = 85236,
  [SMALL_STATE(2013)] = 85343,
  [SMALL_STATE(2014)] = 85412,
  [SMALL_STATE(2015)] = 85517,
  [SMALL_STATE(2016)] = 85624,
  [SMALL_STATE(2017)] = 85726,
  [SMALL_STATE(2018)] = 85828,
  [SMALL_STATE(2019)] = 85882,
  [SMALL_STATE(2020)] = 85984,
  [SMALL_STATE(2021)] = 86086,
  [SMALL_STATE(2022)] = 86188,
  [SMALL_STATE(2023)] = 86290,
  [SMALL_STATE(2024)] = 86344,
  [SMALL_STATE(2025)] = 86446,
  [SMALL_STATE(2026)] = 86548,
  [SMALL_STATE(2027)] = 86650,
  [SMALL_STATE(2028)] = 86706,
  [SMALL_STATE(2029)] = 86808,
  [SMALL_STATE(2030)] = 86910,
  [SMALL_STATE(2031)] = 87012,
  [SMALL_STATE(2032)] = 87114,
  [SMALL_STATE(2033)] = 87172,
  [SMALL_STATE(2034)] = 87232,
  [SMALL_STATE(2035)] = 87290,
  [SMALL_STATE(2036)] = 87392,
  [SMALL_STATE(2037)] = 87450,
  [SMALL_STATE(2038)] = 87552,
  [SMALL_STATE(2039)] = 87654,
  [SMALL_STATE(2040)] = 87712,
  [SMALL_STATE(2041)] = 87772,
  [SMALL_STATE(2042)] = 87874,
  [SMALL_STATE(2043)] = 87976,
  [SMALL_STATE(2044)] = 88036,
  [SMALL_STATE(2045)] = 88094,
  [SMALL_STATE(2046)] = 88152,
  [SMALL_STATE(2047)] = 88212,
  [SMALL_STATE(2048)] = 88314,
  [SMALL_STATE(2049)] = 88370,
  [SMALL_STATE(2050)] = 88472,
  [SMALL_STATE(2051)] = 88574,
  [SMALL_STATE(2052)] = 88627,
  [SMALL_STATE(2053)] = 88680,
  [SMALL_STATE(2054)] = 88757,
  [SMALL_STATE(2055)] = 88828,
  [SMALL_STATE(2056)] = 88921,
  [SMALL_STATE(2057)] = 89020,
  [SMALL_STATE(2058)] = 89119,
  [SMALL_STATE(2059)] = 89172,
  [SMALL_STATE(2060)] = 89271,
  [SMALL_STATE(2061)] = 89324,
  [SMALL_STATE(2062)] = 89377,
  [SMALL_STATE(2063)] = 89436,
  [SMALL_STATE(2064)] = 89489,
  [SMALL_STATE(2065)] = 89588,
  [SMALL_STATE(2066)] = 89641,
  [SMALL_STATE(2067)] = 89694,
  [SMALL_STATE(2068)] = 89793,
  [SMALL_STATE(2069)] = 89846,
  [SMALL_STATE(2070)] = 89899,
  [SMALL_STATE(2071)] = 89952,
  [SMALL_STATE(2072)] = 90051,
  [SMALL_STATE(2073)] = 90104,
  [SMALL_STATE(2074)] = 90157,
  [SMALL_STATE(2075)] = 90220,
  [SMALL_STATE(2076)] = 90319,
  [SMALL_STATE(2077)] = 90418,
  [SMALL_STATE(2078)] = 90517,
  [SMALL_STATE(2079)] = 90590,
  [SMALL_STATE(2080)] = 90673,
  [SMALL_STATE(2081)] = 90772,
  [SMALL_STATE(2082)] = 90825,
  [SMALL_STATE(2083)] = 90878,
  [SMALL_STATE(2084)] = 90931,
  [SMALL_STATE(2085)] = 90984,
  [SMALL_STATE(2086)] = 91037,
  [SMALL_STATE(2087)] = 91116,
  [SMALL_STATE(2088)] = 91201,
  [SMALL_STATE(2089)] = 91290,
  [SMALL_STATE(2090)] = 91367,
  [SMALL_STATE(2091)] = 91438,
  [SMALL_STATE(2092)] = 91531,
  [SMALL_STATE(2093)] = 91630,
  [SMALL_STATE(2094)] = 91683,
  [SMALL_STATE(2095)] = 91736,
  [SMALL_STATE(2096)] = 91835,
  [SMALL_STATE(2097)] = 91888,
  [SMALL_STATE(2098)] = 91941,
  [SMALL_STATE(2099)] = 91994,
  [SMALL_STATE(2100)] = 92047,
  [SMALL_STATE(2101)] = 92100,
  [SMALL_STATE(2102)] = 92153,
  [SMALL_STATE(2103)] = 92206,
  [SMALL_STATE(2104)] = 92261,
  [SMALL_STATE(2105)] = 92314,
  [SMALL_STATE(2106)] = 92367,
  [SMALL_STATE(2107)] = 92420,
  [SMALL_STATE(2108)] = 92509,
  [SMALL_STATE(2109)] = 92566,
  [SMALL_STATE(2110)] = 92619,
  [SMALL_STATE(2111)] = 92704,
  [SMALL_STATE(2112)] = 92803,
  [SMALL_STATE(2113)] = 92882,
  [SMALL_STATE(2114)] = 92935,
  [SMALL_STATE(2115)] = 92988,
  [SMALL_STATE(2116)] = 93071,
  [SMALL_STATE(2117)] = 93124,
  [SMALL_STATE(2118)] = 93177,
  [SMALL_STATE(2119)] = 93276,
  [SMALL_STATE(2120)] = 93329,
  [SMALL_STATE(2121)] = 93382,
  [SMALL_STATE(2122)] = 93435,
  [SMALL_STATE(2123)] = 93508,
  [SMALL_STATE(2124)] = 93561,
  [SMALL_STATE(2125)] = 93614,
  [SMALL_STATE(2126)] = 93667,
  [SMALL_STATE(2127)] = 93720,
  [SMALL_STATE(2128)] = 93773,
  [SMALL_STATE(2129)] = 93826,
  [SMALL_STATE(2130)] = 93881,
  [SMALL_STATE(2131)] = 93934,
  [SMALL_STATE(2132)] = 93987,
  [SMALL_STATE(2133)] = 94040,
  [SMALL_STATE(2134)] = 94093,
  [SMALL_STATE(2135)] = 94164,
  [SMALL_STATE(2136)] = 94217,
  [SMALL_STATE(2137)] = 94270,
  [SMALL_STATE(2138)] = 94323,
  [SMALL_STATE(2139)] = 94422,
  [SMALL_STATE(2140)] = 94475,
  [SMALL_STATE(2141)] = 94574,
  [SMALL_STATE(2142)] = 94627,
  [SMALL_STATE(2143)] = 94686,
  [SMALL_STATE(2144)] = 94745,
  [SMALL_STATE(2145)] = 94798,
  [SMALL_STATE(2146)] = 94851,
  [SMALL_STATE(2147)] = 94908,
  [SMALL_STATE(2148)] = 95007,
  [SMALL_STATE(2149)] = 95106,
  [SMALL_STATE(2150)] = 95163,
  [SMALL_STATE(2151)] = 95226,
  [SMALL_STATE(2152)] = 95279,
  [SMALL_STATE(2153)] = 95332,
  [SMALL_STATE(2154)] = 95385,
  [SMALL_STATE(2155)] = 95438,
  [SMALL_STATE(2156)] = 95493,
  [SMALL_STATE(2157)] = 95592,
  [SMALL_STATE(2158)] = 95645,
  [SMALL_STATE(2159)] = 95708,
  [SMALL_STATE(2160)] = 95761,
  [SMALL_STATE(2161)] = 95814,
  [SMALL_STATE(2162)] = 95867,
  [SMALL_STATE(2163)] = 95920,
  [SMALL_STATE(2164)] = 95973,
  [SMALL_STATE(2165)] = 96026,
  [SMALL_STATE(2166)] = 96079,
  [SMALL_STATE(2167)] = 96178,
  [SMALL_STATE(2168)] = 96231,
  [SMALL_STATE(2169)] = 96284,
  [SMALL_STATE(2170)] = 96337,
  [SMALL_STATE(2171)] = 96390,
  [SMALL_STATE(2172)] = 96443,
  [SMALL_STATE(2173)] = 96496,
  [SMALL_STATE(2174)] = 96549,
  [SMALL_STATE(2175)] = 96602,
  [SMALL_STATE(2176)] = 96661,
  [SMALL_STATE(2177)] = 96716,
  [SMALL_STATE(2178)] = 96815,
  [SMALL_STATE(2179)] = 96914,
  [SMALL_STATE(2180)] = 96969,
  [SMALL_STATE(2181)] = 97022,
  [SMALL_STATE(2182)] = 97075,
  [SMALL_STATE(2183)] = 97128,
  [SMALL_STATE(2184)] = 97181,
  [SMALL_STATE(2185)] = 97252,
  [SMALL_STATE(2186)] = 97305,
  [SMALL_STATE(2187)] = 97358,
  [SMALL_STATE(2188)] = 97411,
  [SMALL_STATE(2189)] = 97464,
  [SMALL_STATE(2190)] = 97517,
  [SMALL_STATE(2191)] = 97572,
  [SMALL_STATE(2192)] = 97625,
  [SMALL_STATE(2193)] = 97678,
  [SMALL_STATE(2194)] = 97733,
  [SMALL_STATE(2195)] = 97786,
  [SMALL_STATE(2196)] = 97841,
  [SMALL_STATE(2197)] = 97894,
  [SMALL_STATE(2198)] = 97947,
  [SMALL_STATE(2199)] = 98000,
  [SMALL_STATE(2200)] = 98053,
  [SMALL_STATE(2201)] = 98106,
  [SMALL_STATE(2202)] = 98159,
  [SMALL_STATE(2203)] = 98212,
  [SMALL_STATE(2204)] = 98265,
  [SMALL_STATE(2205)] = 98324,
  [SMALL_STATE(2206)] = 98377,
  [SMALL_STATE(2207)] = 98430,
  [SMALL_STATE(2208)] = 98499,
  [SMALL_STATE(2209)] = 98598,
  [SMALL_STATE(2210)] = 98697,
  [SMALL_STATE(2211)] = 98768,
  [SMALL_STATE(2212)] = 98839,
  [SMALL_STATE(2213)] = 98906,
  [SMALL_STATE(2214)] = 98959,
  [SMALL_STATE(2215)] = 99028,
  [SMALL_STATE(2216)] = 99127,
  [SMALL_STATE(2217)] = 99226,
  [SMALL_STATE(2218)] = 99282,
  [SMALL_STATE(2219)] = 99380,
  [SMALL_STATE(2220)] = 99478,
  [SMALL_STATE(2221)] = 99576,
  [SMALL_STATE(2222)] = 99674,
  [SMALL_STATE(2223)] = 99756,
  [SMALL_STATE(2224)] = 99854,
  [SMALL_STATE(2225)] = 99926,
  [SMALL_STATE(2226)] = 100024,
  [SMALL_STATE(2227)] = 100080,
  [SMALL_STATE(2228)] = 100178,
  [SMALL_STATE(2229)] = 100270,
  [SMALL_STATE(2230)] = 100368,
  [SMALL_STATE(2231)] = 100444,
  [SMALL_STATE(2232)] = 100542,
  [SMALL_STATE(2233)] = 100640,
  [SMALL_STATE(2234)] = 100738,
  [SMALL_STATE(2235)] = 100836,
  [SMALL_STATE(2236)] = 100934,
  [SMALL_STATE(2237)] = 101032,
  [SMALL_STATE(2238)] = 101130,
  [SMALL_STATE(2239)] = 101200,
  [SMALL_STATE(2240)] = 101270,
  [SMALL_STATE(2241)] = 101340,
  [SMALL_STATE(2242)] = 101438,
  [SMALL_STATE(2243)] = 101536,
  [SMALL_STATE(2244)] = 101596,
  [SMALL_STATE(2245)] = 101694,
  [SMALL_STATE(2246)] = 101762,
  [SMALL_STATE(2247)] = 101824,
  [SMALL_STATE(2248)] = 101880,
  [SMALL_STATE(2249)] = 101978,
  [SMALL_STATE(2250)] = 102066,
  [SMALL_STATE(2251)] = 102150,
  [SMALL_STATE(2252)] = 102228,
  [SMALL_STATE(2253)] = 102326,
  [SMALL_STATE(2254)] = 102386,
  [SMALL_STATE(2255)] = 102444,
  [SMALL_STATE(2256)] = 102502,
  [SMALL_STATE(2257)] = 102558,
  [SMALL_STATE(2258)] = 102614,
  [SMALL_STATE(2259)] = 102712,
  [SMALL_STATE(2260)] = 102768,
  [SMALL_STATE(2261)] = 102822,
  [SMALL_STATE(2262)] = 102882,
  [SMALL_STATE(2263)] = 102942,
  [SMALL_STATE(2264)] = 102993,
  [SMALL_STATE(2265)] = 103044,
  [SMALL_STATE(2266)] = 103141,
  [SMALL_STATE(2267)] = 103194,
  [SMALL_STATE(2268)] = 103255,
  [SMALL_STATE(2269)] = 103352,
  [SMALL_STATE(2270)] = 103421,
  [SMALL_STATE(2271)] = 103490,
  [SMALL_STATE(2272)] = 103541,
  [SMALL_STATE(2273)] = 103592,
  [SMALL_STATE(2274)] = 103683,
  [SMALL_STATE(2275)] = 103734,
  [SMALL_STATE(2276)] = 103785,
  [SMALL_STATE(2277)] = 103836,
  [SMALL_STATE(2278)] = 103893,
  [SMALL_STATE(2279)] = 103944,
  [SMALL_STATE(2280)] = 103997,
  [SMALL_STATE(2281)] = 104094,
  [SMALL_STATE(2282)] = 104191,
  [SMALL_STATE(2283)] = 104262,
  [SMALL_STATE(2284)] = 104359,
  [SMALL_STATE(2285)] = 104440,
  [SMALL_STATE(2286)] = 104531,
  [SMALL_STATE(2287)] = 104628,
  [SMALL_STATE(2288)] = 104705,
  [SMALL_STATE(2289)] = 104788,
  [SMALL_STATE(2290)] = 104875,
  [SMALL_STATE(2291)] = 104950,
  [SMALL_STATE(2292)] = 105041,
  [SMALL_STATE(2293)] = 105138,
  [SMALL_STATE(2294)] = 105235,
  [SMALL_STATE(2295)] = 105288,
  [SMALL_STATE(2296)] = 105339,
  [SMALL_STATE(2297)] = 105408,
  [SMALL_STATE(2298)] = 105475,
  [SMALL_STATE(2299)] = 105526,
  [SMALL_STATE(2300)] = 105617,
  [SMALL_STATE(2301)] = 105668,
  [SMALL_STATE(2302)] = 105759,
  [SMALL_STATE(2303)] = 105850,
  [SMALL_STATE(2304)] = 105909,
  [SMALL_STATE(2305)] = 105960,
  [SMALL_STATE(2306)] = 106011,
  [SMALL_STATE(2307)] = 106108,
  [SMALL_STATE(2308)] = 106205,
  [SMALL_STATE(2309)] = 106302,
  [SMALL_STATE(2310)] = 106353,
  [SMALL_STATE(2311)] = 106404,
  [SMALL_STATE(2312)] = 106455,
  [SMALL_STATE(2313)] = 106510,
  [SMALL_STATE(2314)] = 106561,
  [SMALL_STATE(2315)] = 106652,
  [SMALL_STATE(2316)] = 106709,
  [SMALL_STATE(2317)] = 106806,
  [SMALL_STATE(2318)] = 106903,
  [SMALL_STATE(2319)] = 106954,
  [SMALL_STATE(2320)] = 107005,
  [SMALL_STATE(2321)] = 107056,
  [SMALL_STATE(2322)] = 107117,
  [SMALL_STATE(2323)] = 107214,
  [SMALL_STATE(2324)] = 107265,
  [SMALL_STATE(2325)] = 107322,
  [SMALL_STATE(2326)] = 107379,
  [SMALL_STATE(2327)] = 107430,
  [SMALL_STATE(2328)] = 107481,
  [SMALL_STATE(2329)] = 107572,
  [SMALL_STATE(2330)] = 107669,
  [SMALL_STATE(2331)] = 107724,
  [SMALL_STATE(2332)] = 107775,
  [SMALL_STATE(2333)] = 107826,
  [SMALL_STATE(2334)] = 107885,
  [SMALL_STATE(2335)] = 107936,
  [SMALL_STATE(2336)] = 107995,
  [SMALL_STATE(2337)] = 108050,
  [SMALL_STATE(2338)] = 108107,
  [SMALL_STATE(2339)] = 108158,
  [SMALL_STATE(2340)] = 108209,
  [SMALL_STATE(2341)] = 108260,
  [SMALL_STATE(2342)] = 108357,
  [SMALL_STATE(2343)] = 108454,
  [SMALL_STATE(2344)] = 108551,
  [SMALL_STATE(2345)] = 108602,
  [SMALL_STATE(2346)] = 108653,
  [SMALL_STATE(2347)] = 108704,
  [SMALL_STATE(2348)] = 108755,
  [SMALL_STATE(2349)] = 108806,
  [SMALL_STATE(2350)] = 108857,
  [SMALL_STATE(2351)] = 108908,
  [SMALL_STATE(2352)] = 108959,
  [SMALL_STATE(2353)] = 109010,
  [SMALL_STATE(2354)] = 109061,
  [SMALL_STATE(2355)] = 109112,
  [SMALL_STATE(2356)] = 109163,
  [SMALL_STATE(2357)] = 109214,
  [SMALL_STATE(2358)] = 109265,
  [SMALL_STATE(2359)] = 109316,
  [SMALL_STATE(2360)] = 109369,
  [SMALL_STATE(2361)] = 109420,
  [SMALL_STATE(2362)] = 109511,
  [SMALL_STATE(2363)] = 109572,
  [SMALL_STATE(2364)] = 109623,
  [SMALL_STATE(2365)] = 109674,
  [SMALL_STATE(2366)] = 109735,
  [SMALL_STATE(2367)] = 109786,
  [SMALL_STATE(2368)] = 109837,
  [SMALL_STATE(2369)] = 109888,
  [SMALL_STATE(2370)] = 109939,
  [SMALL_STATE(2371)] = 110030,
  [SMALL_STATE(2372)] = 110081,
  [SMALL_STATE(2373)] = 110132,
  [SMALL_STATE(2374)] = 110223,
  [SMALL_STATE(2375)] = 110274,
  [SMALL_STATE(2376)] = 110325,
  [SMALL_STATE(2377)] = 110386,
  [SMALL_STATE(2378)] = 110485,
  [SMALL_STATE(2379)] = 110584,
  [SMALL_STATE(2380)] = 110683,
  [SMALL_STATE(2381)] = 110736,
  [SMALL_STATE(2382)] = 110787,
  [SMALL_STATE(2383)] = 110884,
  [SMALL_STATE(2384)] = 110975,
  [SMALL_STATE(2385)] = 111036,
  [SMALL_STATE(2386)] = 111135,
  [SMALL_STATE(2387)] = 111234,
  [SMALL_STATE(2388)] = 111305,
  [SMALL_STATE(2389)] = 111396,
  [SMALL_STATE(2390)] = 111447,
  [SMALL_STATE(2391)] = 111498,
  [SMALL_STATE(2392)] = 111595,
  [SMALL_STATE(2393)] = 111646,
  [SMALL_STATE(2394)] = 111697,
  [SMALL_STATE(2395)] = 111748,
  [SMALL_STATE(2396)] = 111845,
  [SMALL_STATE(2397)] = 111896,
  [SMALL_STATE(2398)] = 111947,
  [SMALL_STATE(2399)] = 112028,
  [SMALL_STATE(2400)] = 112105,
  [SMALL_STATE(2401)] = 112188,
  [SMALL_STATE(2402)] = 112239,
  [SMALL_STATE(2403)] = 112326,
  [SMALL_STATE(2404)] = 112377,
  [SMALL_STATE(2405)] = 112428,
  [SMALL_STATE(2406)] = 112499,
  [SMALL_STATE(2407)] = 112574,
  [SMALL_STATE(2408)] = 112625,
  [SMALL_STATE(2409)] = 112676,
  [SMALL_STATE(2410)] = 112745,
  [SMALL_STATE(2411)] = 112836,
  [SMALL_STATE(2412)] = 112887,
  [SMALL_STATE(2413)] = 112986,
  [SMALL_STATE(2414)] = 113039,
  [SMALL_STATE(2415)] = 113106,
  [SMALL_STATE(2416)] = 113205,
  [SMALL_STATE(2417)] = 113304,
  [SMALL_STATE(2418)] = 113403,
  [SMALL_STATE(2419)] = 113500,
  [SMALL_STATE(2420)] = 113569,
  [SMALL_STATE(2421)] = 113620,
  [SMALL_STATE(2422)] = 113689,
  [SMALL_STATE(2423)] = 113770,
  [SMALL_STATE(2424)] = 113821,
  [SMALL_STATE(2425)] = 113888,
  [SMALL_STATE(2426)] = 113953,
  [SMALL_STATE(2427)] = 114010,
  [SMALL_STATE(2428)] = 114061,
  [SMALL_STATE(2429)] = 114112,
  [SMALL_STATE(2430)] = 114163,
  [SMALL_STATE(2431)] = 114220,
  [SMALL_STATE(2432)] = 114319,
  [SMALL_STATE(2433)] = 114370,
  [SMALL_STATE(2434)] = 114421,
  [SMALL_STATE(2435)] = 114498,
  [SMALL_STATE(2436)] = 114581,
  [SMALL_STATE(2437)] = 114668,
  [SMALL_STATE(2438)] = 114743,
  [SMALL_STATE(2439)] = 114794,
  [SMALL_STATE(2440)] = 114863,
  [SMALL_STATE(2441)] = 114914,
  [SMALL_STATE(2442)] = 114969,
  [SMALL_STATE(2443)] = 115020,
  [SMALL_STATE(2444)] = 115071,
  [SMALL_STATE(2445)] = 115170,
  [SMALL_STATE(2446)] = 115267,
  [SMALL_STATE(2447)] = 115366,
  [SMALL_STATE(2448)] = 115463,
  [SMALL_STATE(2449)] = 115532,
  [SMALL_STATE(2450)] = 115631,
  [SMALL_STATE(2451)] = 115684,
  [SMALL_STATE(2452)] = 115781,
  [SMALL_STATE(2453)] = 115880,
  [SMALL_STATE(2454)] = 115931,
  [SMALL_STATE(2455)] = 116028,
  [SMALL_STATE(2456)] = 116079,
  [SMALL_STATE(2457)] = 116148,
  [SMALL_STATE(2458)] = 116246,
  [SMALL_STATE(2459)] = 116344,
  [SMALL_STATE(2460)] = 116442,
  [SMALL_STATE(2461)] = 116512,
  [SMALL_STATE(2462)] = 116608,
  [SMALL_STATE(2463)] = 116688,
  [SMALL_STATE(2464)] = 116740,
  [SMALL_STATE(2465)] = 116816,
  [SMALL_STATE(2466)] = 116898,
  [SMALL_STATE(2467)] = 116984,
  [SMALL_STATE(2468)] = 117058,
  [SMALL_STATE(2469)] = 117156,
  [SMALL_STATE(2470)] = 117246,
  [SMALL_STATE(2471)] = 117344,
  [SMALL_STATE(2472)] = 117442,
  [SMALL_STATE(2473)] = 117496,
  [SMALL_STATE(2474)] = 117592,
  [SMALL_STATE(2475)] = 117646,
  [SMALL_STATE(2476)] = 117702,
  [SMALL_STATE(2477)] = 117798,
  [SMALL_STATE(2478)] = 117896,
  [SMALL_STATE(2479)] = 117994,
  [SMALL_STATE(2480)] = 118092,
  [SMALL_STATE(2481)] = 118144,
  [SMALL_STATE(2482)] = 118242,
  [SMALL_STATE(2483)] = 118344,
  [SMALL_STATE(2484)] = 118442,
  [SMALL_STATE(2485)] = 118496,
  [SMALL_STATE(2486)] = 118594,
  [SMALL_STATE(2487)] = 118650,
  [SMALL_STATE(2488)] = 118704,
  [SMALL_STATE(2489)] = 118760,
  [SMALL_STATE(2490)] = 118828,
  [SMALL_STATE(2491)] = 118928,
  [SMALL_STATE(2492)] = 119024,
  [SMALL_STATE(2493)] = 119092,
  [SMALL_STATE(2494)] = 119160,
  [SMALL_STATE(2495)] = 119256,
  [SMALL_STATE(2496)] = 119352,
  [SMALL_STATE(2497)] = 119408,
  [SMALL_STATE(2498)] = 119504,
  [SMALL_STATE(2499)] = 119570,
  [SMALL_STATE(2500)] = 119670,
  [SMALL_STATE(2501)] = 119766,
  [SMALL_STATE(2502)] = 119866,
  [SMALL_STATE(2503)] = 119962,
  [SMALL_STATE(2504)] = 120058,
  [SMALL_STATE(2505)] = 120154,
  [SMALL_STATE(2506)] = 120250,
  [SMALL_STATE(2507)] = 120346,
  [SMALL_STATE(2508)] = 120442,
  [SMALL_STATE(2509)] = 120538,
  [SMALL_STATE(2510)] = 120634,
  [SMALL_STATE(2511)] = 120730,
  [SMALL_STATE(2512)] = 120788,
  [SMALL_STATE(2513)] = 120884,
  [SMALL_STATE(2514)] = 120944,
  [SMALL_STATE(2515)] = 121046,
  [SMALL_STATE(2516)] = 121142,
  [SMALL_STATE(2517)] = 121232,
  [SMALL_STATE(2518)] = 121300,
  [SMALL_STATE(2519)] = 121374,
  [SMALL_STATE(2520)] = 121470,
  [SMALL_STATE(2521)] = 121556,
  [SMALL_STATE(2522)] = 121652,
  [SMALL_STATE(2523)] = 121754,
  [SMALL_STATE(2524)] = 121850,
  [SMALL_STATE(2525)] = 121920,
  [SMALL_STATE(2526)] = 121978,
  [SMALL_STATE(2527)] = 122058,
  [SMALL_STATE(2528)] = 122134,
  [SMALL_STATE(2529)] = 122230,
  [SMALL_STATE(2530)] = 122312,
  [SMALL_STATE(2531)] = 122394,
  [SMALL_STATE(2532)] = 122480,
  [SMALL_STATE(2533)] = 122554,
  [SMALL_STATE(2534)] = 122622,
  [SMALL_STATE(2535)] = 122712,
  [SMALL_STATE(2536)] = 122808,
  [SMALL_STATE(2537)] = 122910,
  [SMALL_STATE(2538)] = 123006,
  [SMALL_STATE(2539)] = 123104,
  [SMALL_STATE(2540)] = 123164,
  [SMALL_STATE(2541)] = 123218,
  [SMALL_STATE(2542)] = 123274,
  [SMALL_STATE(2543)] = 123350,
  [SMALL_STATE(2544)] = 123448,
  [SMALL_STATE(2545)] = 123528,
  [SMALL_STATE(2546)] = 123584,
  [SMALL_STATE(2547)] = 123684,
  [SMALL_STATE(2548)] = 123740,
  [SMALL_STATE(2549)] = 123808,
  [SMALL_STATE(2550)] = 123876,
  [SMALL_STATE(2551)] = 123942,
  [SMALL_STATE(2552)] = 124044,
  [SMALL_STATE(2553)] = 124104,
  [SMALL_STATE(2554)] = 124164,
  [SMALL_STATE(2555)] = 124232,
  [SMALL_STATE(2556)] = 124286,
  [SMALL_STATE(2557)] = 124354,
  [SMALL_STATE(2558)] = 124410,
  [SMALL_STATE(2559)] = 124466,
  [SMALL_STATE(2560)] = 124520,
  [SMALL_STATE(2561)] = 124616,
  [SMALL_STATE(2562)] = 124668,
  [SMALL_STATE(2563)] = 124764,
  [SMALL_STATE(2564)] = 124832,
  [SMALL_STATE(2565)] = 124928,
  [SMALL_STATE(2566)] = 124994,
  [SMALL_STATE(2567)] = 125090,
  [SMALL_STATE(2568)] = 125150,
  [SMALL_STATE(2569)] = 125216,
  [SMALL_STATE(2570)] = 125272,
  [SMALL_STATE(2571)] = 125370,
  [SMALL_STATE(2572)] = 125472,
  [SMALL_STATE(2573)] = 125524,
  [SMALL_STATE(2574)] = 125576,
  [SMALL_STATE(2575)] = 125628,
  [SMALL_STATE(2576)] = 125724,
  [SMALL_STATE(2577)] = 125776,
  [SMALL_STATE(2578)] = 125872,
  [SMALL_STATE(2579)] = 125970,
  [SMALL_STATE(2580)] = 126026,
  [SMALL_STATE(2581)] = 126116,
  [SMALL_STATE(2582)] = 126176,
  [SMALL_STATE(2583)] = 126232,
  [SMALL_STATE(2584)] = 126300,
  [SMALL_STATE(2585)] = 126398,
  [SMALL_STATE(2586)] = 126464,
  [SMALL_STATE(2587)] = 126532,
  [SMALL_STATE(2588)] = 126602,
  [SMALL_STATE(2589)] = 126700,
  [SMALL_STATE(2590)] = 126774,
  [SMALL_STATE(2591)] = 126860,
  [SMALL_STATE(2592)] = 126958,
  [SMALL_STATE(2593)] = 127040,
  [SMALL_STATE(2594)] = 127116,
  [SMALL_STATE(2595)] = 127196,
  [SMALL_STATE(2596)] = 127266,
  [SMALL_STATE(2597)] = 127346,
  [SMALL_STATE(2598)] = 127402,
  [SMALL_STATE(2599)] = 127472,
  [SMALL_STATE(2600)] = 127568,
  [SMALL_STATE(2601)] = 127664,
  [SMALL_STATE(2602)] = 127760,
  [SMALL_STATE(2603)] = 127820,
  [SMALL_STATE(2604)] = 127896,
  [SMALL_STATE(2605)] = 127948,
  [SMALL_STATE(2606)] = 128030,
  [SMALL_STATE(2607)] = 128116,
  [SMALL_STATE(2608)] = 128172,
  [SMALL_STATE(2609)] = 128246,
  [SMALL_STATE(2610)] = 128314,
  [SMALL_STATE(2611)] = 128416,
  [SMALL_STATE(2612)] = 128506,
  [SMALL_STATE(2613)] = 128604,
  [SMALL_STATE(2614)] = 128660,
  [SMALL_STATE(2615)] = 128758,
  [SMALL_STATE(2616)] = 128856,
  [SMALL_STATE(2617)] = 128952,
  [SMALL_STATE(2618)] = 129048,
  [SMALL_STATE(2619)] = 129100,
  [SMALL_STATE(2620)] = 129198,
  [SMALL_STATE(2621)] = 129296,
  [SMALL_STATE(2622)] = 129394,
  [SMALL_STATE(2623)] = 129462,
  [SMALL_STATE(2624)] = 129530,
  [SMALL_STATE(2625)] = 129626,
  [SMALL_STATE(2626)] = 129722,
  [SMALL_STATE(2627)] = 129818,
  [SMALL_STATE(2628)] = 129914,
  [SMALL_STATE(2629)] = 130012,
  [SMALL_STATE(2630)] = 130070,
  [SMALL_STATE(2631)] = 130128,
  [SMALL_STATE(2632)] = 130184,
  [SMALL_STATE(2633)] = 130240,
  [SMALL_STATE(2634)] = 130321,
  [SMALL_STATE(2635)] = 130416,
  [SMALL_STATE(2636)] = 130473,
  [SMALL_STATE(2637)] = 130568,
  [SMALL_STATE(2638)] = 130663,
  [SMALL_STATE(2639)] = 130752,
  [SMALL_STATE(2640)] = 130807,
  [SMALL_STATE(2641)] = 130904,
  [SMALL_STATE(2642)] = 130971,
  [SMALL_STATE(2643)] = 131044,
  [SMALL_STATE(2644)] = 131111,
  [SMALL_STATE(2645)] = 131166,
  [SMALL_STATE(2646)] = 131251,
  [SMALL_STATE(2647)] = 131332,
  [SMALL_STATE(2648)] = 131407,
  [SMALL_STATE(2649)] = 131458,
  [SMALL_STATE(2650)] = 131537,
  [SMALL_STATE(2651)] = 131636,
  [SMALL_STATE(2652)] = 131705,
  [SMALL_STATE(2653)] = 131788,
  [SMALL_STATE(2654)] = 131837,
  [SMALL_STATE(2655)] = 131886,
  [SMALL_STATE(2656)] = 131981,
  [SMALL_STATE(2657)] = 132076,
  [SMALL_STATE(2658)] = 132131,
  [SMALL_STATE(2659)] = 132188,
  [SMALL_STATE(2660)] = 132237,
  [SMALL_STATE(2661)] = 132286,
  [SMALL_STATE(2662)] = 132383,
  [SMALL_STATE(2663)] = 132480,
  [SMALL_STATE(2664)] = 132529,
  [SMALL_STATE(2665)] = 132578,
  [SMALL_STATE(2666)] = 132627,
  [SMALL_STATE(2667)] = 132676,
  [SMALL_STATE(2668)] = 132725,
  [SMALL_STATE(2669)] = 132774,
  [SMALL_STATE(2670)] = 132823,
  [SMALL_STATE(2671)] = 132872,
  [SMALL_STATE(2672)] = 132921,
  [SMALL_STATE(2673)] = 132972,
  [SMALL_STATE(2674)] = 133061,
  [SMALL_STATE(2675)] = 133112,
  [SMALL_STATE(2676)] = 133179,
  [SMALL_STATE(2677)] = 133252,
  [SMALL_STATE(2678)] = 133337,
  [SMALL_STATE(2679)] = 133386,
  [SMALL_STATE(2680)] = 133467,
  [SMALL_STATE(2681)] = 133542,
  [SMALL_STATE(2682)] = 133621,
  [SMALL_STATE(2683)] = 133670,
  [SMALL_STATE(2684)] = 133719,
  [SMALL_STATE(2685)] = 133788,
  [SMALL_STATE(2686)] = 133847,
  [SMALL_STATE(2687)] = 133942,
  [SMALL_STATE(2688)] = 134031,
  [SMALL_STATE(2689)] = 134128,
  [SMALL_STATE(2690)] = 134223,
  [SMALL_STATE(2691)] = 134318,
  [SMALL_STATE(2692)] = 134413,
  [SMALL_STATE(2693)] = 134508,
  [SMALL_STATE(2694)] = 134557,
  [SMALL_STATE(2695)] = 134652,
  [SMALL_STATE(2696)] = 134711,
  [SMALL_STATE(2697)] = 134808,
  [SMALL_STATE(2698)] = 134857,
  [SMALL_STATE(2699)] = 134910,
  [SMALL_STATE(2700)] = 134961,
  [SMALL_STATE(2701)] = 135010,
  [SMALL_STATE(2702)] = 135063,
  [SMALL_STATE(2703)] = 135112,
  [SMALL_STATE(2704)] = 135161,
  [SMALL_STATE(2705)] = 135216,
  [SMALL_STATE(2706)] = 135265,
  [SMALL_STATE(2707)] = 135360,
  [SMALL_STATE(2708)] = 135455,
  [SMALL_STATE(2709)] = 135550,
  [SMALL_STATE(2710)] = 135599,
  [SMALL_STATE(2711)] = 135698,
  [SMALL_STATE(2712)] = 135755,
  [SMALL_STATE(2713)] = 135852,
  [SMALL_STATE(2714)] = 135901,
  [SMALL_STATE(2715)] = 135956,
  [SMALL_STATE(2716)] = 136005,
  [SMALL_STATE(2717)] = 136102,
  [SMALL_STATE(2718)] = 136151,
  [SMALL_STATE(2719)] = 136250,
  [SMALL_STATE(2720)] = 136347,
  [SMALL_STATE(2721)] = 136396,
  [SMALL_STATE(2722)] = 136495,
  [SMALL_STATE(2723)] = 136554,
  [SMALL_STATE(2724)] = 136611,
  [SMALL_STATE(2725)] = 136660,
  [SMALL_STATE(2726)] = 136709,
  [SMALL_STATE(2727)] = 136758,
  [SMALL_STATE(2728)] = 136813,
  [SMALL_STATE(2729)] = 136862,
  [SMALL_STATE(2730)] = 136911,
  [SMALL_STATE(2731)] = 136960,
  [SMALL_STATE(2732)] = 137009,
  [SMALL_STATE(2733)] = 137058,
  [SMALL_STATE(2734)] = 137113,
  [SMALL_STATE(2735)] = 137168,
  [SMALL_STATE(2736)] = 137263,
  [SMALL_STATE(2737)] = 137312,
  [SMALL_STATE(2738)] = 137361,
  [SMALL_STATE(2739)] = 137412,
  [SMALL_STATE(2740)] = 137507,
  [SMALL_STATE(2741)] = 137604,
  [SMALL_STATE(2742)] = 137699,
  [SMALL_STATE(2743)] = 137794,
  [SMALL_STATE(2744)] = 137889,
  [SMALL_STATE(2745)] = 137986,
  [SMALL_STATE(2746)] = 138037,
  [SMALL_STATE(2747)] = 138086,
  [SMALL_STATE(2748)] = 138181,
  [SMALL_STATE(2749)] = 138280,
  [SMALL_STATE(2750)] = 138375,
  [SMALL_STATE(2751)] = 138470,
  [SMALL_STATE(2752)] = 138519,
  [SMALL_STATE(2753)] = 138576,
  [SMALL_STATE(2754)] = 138625,
  [SMALL_STATE(2755)] = 138678,
  [SMALL_STATE(2756)] = 138727,
  [SMALL_STATE(2757)] = 138800,
  [SMALL_STATE(2758)] = 138849,
  [SMALL_STATE(2759)] = 138898,
  [SMALL_STATE(2760)] = 138947,
  [SMALL_STATE(2761)] = 139012,
  [SMALL_STATE(2762)] = 139075,
  [SMALL_STATE(2763)] = 139174,
  [SMALL_STATE(2764)] = 139271,
  [SMALL_STATE(2765)] = 139320,
  [SMALL_STATE(2766)] = 139417,
  [SMALL_STATE(2767)] = 139482,
  [SMALL_STATE(2768)] = 139567,
  [SMALL_STATE(2769)] = 139616,
  [SMALL_STATE(2770)] = 139711,
  [SMALL_STATE(2771)] = 139806,
  [SMALL_STATE(2772)] = 139887,
  [SMALL_STATE(2773)] = 139954,
  [SMALL_STATE(2774)] = 140029,
  [SMALL_STATE(2775)] = 140082,
  [SMALL_STATE(2776)] = 140149,
  [SMALL_STATE(2777)] = 140200,
  [SMALL_STATE(2778)] = 140299,
  [SMALL_STATE(2779)] = 140396,
  [SMALL_STATE(2780)] = 140475,
  [SMALL_STATE(2781)] = 140524,
  [SMALL_STATE(2782)] = 140577,
  [SMALL_STATE(2783)] = 140632,
  [SMALL_STATE(2784)] = 140687,
  [SMALL_STATE(2785)] = 140738,
  [SMALL_STATE(2786)] = 140805,
  [SMALL_STATE(2787)] = 140860,
  [SMALL_STATE(2788)] = 140909,
  [SMALL_STATE(2789)] = 140958,
  [SMALL_STATE(2790)] = 141007,
  [SMALL_STATE(2791)] = 141104,
  [SMALL_STATE(2792)] = 141201,
  [SMALL_STATE(2793)] = 141250,
  [SMALL_STATE(2794)] = 141317,
  [SMALL_STATE(2795)] = 141374,
  [SMALL_STATE(2796)] = 141423,
  [SMALL_STATE(2797)] = 141520,
  [SMALL_STATE(2798)] = 141569,
  [SMALL_STATE(2799)] = 141618,
  [SMALL_STATE(2800)] = 141685,
  [SMALL_STATE(2801)] = 141752,
  [SMALL_STATE(2802)] = 141817,
  [SMALL_STATE(2803)] = 141866,
  [SMALL_STATE(2804)] = 141921,
  [SMALL_STATE(2805)] = 141990,
  [SMALL_STATE(2806)] = 142039,
  [SMALL_STATE(2807)] = 142088,
  [SMALL_STATE(2808)] = 142137,
  [SMALL_STATE(2809)] = 142232,
  [SMALL_STATE(2810)] = 142331,
  [SMALL_STATE(2811)] = 142380,
  [SMALL_STATE(2812)] = 142477,
  [SMALL_STATE(2813)] = 142526,
  [SMALL_STATE(2814)] = 142621,
  [SMALL_STATE(2815)] = 142688,
  [SMALL_STATE(2816)] = 142783,
  [SMALL_STATE(2817)] = 142850,
  [SMALL_STATE(2818)] = 142945,
  [SMALL_STATE(2819)] = 142994,
  [SMALL_STATE(2820)] = 143043,
  [SMALL_STATE(2821)] = 143138,
  [SMALL_STATE(2822)] = 143233,
  [SMALL_STATE(2823)] = 143284,
  [SMALL_STATE(2824)] = 143333,
  [SMALL_STATE(2825)] = 143428,
  [SMALL_STATE(2826)] = 143523,
  [SMALL_STATE(2827)] = 143572,
  [SMALL_STATE(2828)] = 143637,
  [SMALL_STATE(2829)] = 143686,
  [SMALL_STATE(2830)] = 143785,
  [SMALL_STATE(2831)] = 143834,
  [SMALL_STATE(2832)] = 143883,
  [SMALL_STATE(2833)] = 143932,
  [SMALL_STATE(2834)] = 143981,
  [SMALL_STATE(2835)] = 144036,
  [SMALL_STATE(2836)] = 144085,
  [SMALL_STATE(2837)] = 144134,
  [SMALL_STATE(2838)] = 144183,
  [SMALL_STATE(2839)] = 144232,
  [SMALL_STATE(2840)] = 144281,
  [SMALL_STATE(2841)] = 144378,
  [SMALL_STATE(2842)] = 144473,
  [SMALL_STATE(2843)] = 144522,
  [SMALL_STATE(2844)] = 144575,
  [SMALL_STATE(2845)] = 144670,
  [SMALL_STATE(2846)] = 144719,
  [SMALL_STATE(2847)] = 144768,
  [SMALL_STATE(2848)] = 144827,
  [SMALL_STATE(2849)] = 144876,
  [SMALL_STATE(2850)] = 144925,
  [SMALL_STATE(2851)] = 144974,
  [SMALL_STATE(2852)] = 145023,
  [SMALL_STATE(2853)] = 145112,
  [SMALL_STATE(2854)] = 145161,
  [SMALL_STATE(2855)] = 145210,
  [SMALL_STATE(2856)] = 145277,
  [SMALL_STATE(2857)] = 145350,
  [SMALL_STATE(2858)] = 145435,
  [SMALL_STATE(2859)] = 145530,
  [SMALL_STATE(2860)] = 145605,
  [SMALL_STATE(2861)] = 145654,
  [SMALL_STATE(2862)] = 145749,
  [SMALL_STATE(2863)] = 145828,
  [SMALL_STATE(2864)] = 145923,
  [SMALL_STATE(2865)] = 145992,
  [SMALL_STATE(2866)] = 146041,
  [SMALL_STATE(2867)] = 146136,
  [SMALL_STATE(2868)] = 146231,
  [SMALL_STATE(2869)] = 146280,
  [SMALL_STATE(2870)] = 146329,
  [SMALL_STATE(2871)] = 146378,
  [SMALL_STATE(2872)] = 146473,
  [SMALL_STATE(2873)] = 146522,
  [SMALL_STATE(2874)] = 146571,
  [SMALL_STATE(2875)] = 146666,
  [SMALL_STATE(2876)] = 146761,
  [SMALL_STATE(2877)] = 146820,
  [SMALL_STATE(2878)] = 146915,
  [SMALL_STATE(2879)] = 147014,
  [SMALL_STATE(2880)] = 147063,
  [SMALL_STATE(2881)] = 147157,
  [SMALL_STATE(2882)] = 147223,
  [SMALL_STATE(2883)] = 147289,
  [SMALL_STATE(2884)] = 147383,
  [SMALL_STATE(2885)] = 147479,
  [SMALL_STATE(2886)] = 147573,
  [SMALL_STATE(2887)] = 147667,
  [SMALL_STATE(2888)] = 147761,
  [SMALL_STATE(2889)] = 147819,
  [SMALL_STATE(2890)] = 147913,
  [SMALL_STATE(2891)] = 148007,
  [SMALL_STATE(2892)] = 148057,
  [SMALL_STATE(2893)] = 148151,
  [SMALL_STATE(2894)] = 148205,
  [SMALL_STATE(2895)] = 148299,
  [SMALL_STATE(2896)] = 148393,
  [SMALL_STATE(2897)] = 148487,
  [SMALL_STATE(2898)] = 148581,
  [SMALL_STATE(2899)] = 148669,
  [SMALL_STATE(2900)] = 148735,
  [SMALL_STATE(2901)] = 148807,
  [SMALL_STATE(2902)] = 148891,
  [SMALL_STATE(2903)] = 148971,
  [SMALL_STATE(2904)] = 149025,
  [SMALL_STATE(2905)] = 149121,
  [SMALL_STATE(2906)] = 149195,
  [SMALL_STATE(2907)] = 149289,
  [SMALL_STATE(2908)] = 149345,
  [SMALL_STATE(2909)] = 149441,
  [SMALL_STATE(2910)] = 149497,
  [SMALL_STATE(2911)] = 149593,
  [SMALL_STATE(2912)] = 149671,
  [SMALL_STATE(2913)] = 149765,
  [SMALL_STATE(2914)] = 149817,
  [SMALL_STATE(2915)] = 149867,
  [SMALL_STATE(2916)] = 149935,
  [SMALL_STATE(2917)] = 150031,
  [SMALL_STATE(2918)] = 150125,
  [SMALL_STATE(2919)] = 150219,
  [SMALL_STATE(2920)] = 150273,
  [SMALL_STATE(2921)] = 150369,
  [SMALL_STATE(2922)] = 150463,
  [SMALL_STATE(2923)] = 150515,
  [SMALL_STATE(2924)] = 150567,
  [SMALL_STATE(2925)] = 150617,
  [SMALL_STATE(2926)] = 150669,
  [SMALL_STATE(2927)] = 150721,
  [SMALL_STATE(2928)] = 150771,
  [SMALL_STATE(2929)] = 150865,
  [SMALL_STATE(2930)] = 150919,
  [SMALL_STATE(2931)] = 150969,
  [SMALL_STATE(2932)] = 151029,
  [SMALL_STATE(2933)] = 151123,
  [SMALL_STATE(2934)] = 151173,
  [SMALL_STATE(2935)] = 151233,
  [SMALL_STATE(2936)] = 151327,
  [SMALL_STATE(2937)] = 151423,
  [SMALL_STATE(2938)] = 151517,
  [SMALL_STATE(2939)] = 151611,
  [SMALL_STATE(2940)] = 151669,
  [SMALL_STATE(2941)] = 151733,
  [SMALL_STATE(2942)] = 151785,
  [SMALL_STATE(2943)] = 151839,
  [SMALL_STATE(2944)] = 151905,
  [SMALL_STATE(2945)] = 151971,
  [SMALL_STATE(2946)] = 152025,
  [SMALL_STATE(2947)] = 152077,
  [SMALL_STATE(2948)] = 152127,
  [SMALL_STATE(2949)] = 152193,
  [SMALL_STATE(2950)] = 152249,
  [SMALL_STATE(2951)] = 152301,
  [SMALL_STATE(2952)] = 152353,
  [SMALL_STATE(2953)] = 152447,
  [SMALL_STATE(2954)] = 152541,
  [SMALL_STATE(2955)] = 152605,
  [SMALL_STATE(2956)] = 152659,
  [SMALL_STATE(2957)] = 152713,
  [SMALL_STATE(2958)] = 152809,
  [SMALL_STATE(2959)] = 152863,
  [SMALL_STATE(2960)] = 152913,
  [SMALL_STATE(2961)] = 152963,
  [SMALL_STATE(2962)] = 153013,
  [SMALL_STATE(2963)] = 153071,
  [SMALL_STATE(2964)] = 153121,
  [SMALL_STATE(2965)] = 153173,
  [SMALL_STATE(2966)] = 153223,
  [SMALL_STATE(2967)] = 153285,
  [SMALL_STATE(2968)] = 153347,
  [SMALL_STATE(2969)] = 153403,
  [SMALL_STATE(2970)] = 153455,
  [SMALL_STATE(2971)] = 153549,
  [SMALL_STATE(2972)] = 153643,
  [SMALL_STATE(2973)] = 153695,
  [SMALL_STATE(2974)] = 153789,
  [SMALL_STATE(2975)] = 153845,
  [SMALL_STATE(2976)] = 153939,
  [SMALL_STATE(2977)] = 153991,
  [SMALL_STATE(2978)] = 154085,
  [SMALL_STATE(2979)] = 154151,
  [SMALL_STATE(2980)] = 154245,
  [SMALL_STATE(2981)] = 154339,
  [SMALL_STATE(2982)] = 154389,
  [SMALL_STATE(2983)] = 154483,
  [SMALL_STATE(2984)] = 154533,
  [SMALL_STATE(2985)] = 154583,
  [SMALL_STATE(2986)] = 154639,
  [SMALL_STATE(2987)] = 154691,
  [SMALL_STATE(2988)] = 154753,
  [SMALL_STATE(2989)] = 154809,
  [SMALL_STATE(2990)] = 154905,
  [SMALL_STATE(2991)] = 154999,
  [SMALL_STATE(2992)] = 155093,
  [SMALL_STATE(2993)] = 155147,
  [SMALL_STATE(2994)] = 155201,
  [SMALL_STATE(2995)] = 155255,
  [SMALL_STATE(2996)] = 155309,
  [SMALL_STATE(2997)] = 155359,
  [SMALL_STATE(2998)] = 155409,
  [SMALL_STATE(2999)] = 155503,
  [SMALL_STATE(3000)] = 155597,
  [SMALL_STATE(3001)] = 155647,
  [SMALL_STATE(3002)] = 155743,
  [SMALL_STATE(3003)] = 155795,
  [SMALL_STATE(3004)] = 155889,
  [SMALL_STATE(3005)] = 155983,
  [SMALL_STATE(3006)] = 156037,
  [SMALL_STATE(3007)] = 156131,
  [SMALL_STATE(3008)] = 156199,
  [SMALL_STATE(3009)] = 156293,
  [SMALL_STATE(3010)] = 156381,
  [SMALL_STATE(3011)] = 156459,
  [SMALL_STATE(3012)] = 156525,
  [SMALL_STATE(3013)] = 156597,
  [SMALL_STATE(3014)] = 156671,
  [SMALL_STATE(3015)] = 156751,
  [SMALL_STATE(3016)] = 156835,
  [SMALL_STATE(3017)] = 156889,
  [SMALL_STATE(3018)] = 156939,
  [SMALL_STATE(3019)] = 157023,
  [SMALL_STATE(3020)] = 157103,
  [SMALL_STATE(3021)] = 157177,
  [SMALL_STATE(3022)] = 157249,
  [SMALL_STATE(3023)] = 157345,
  [SMALL_STATE(3024)] = 157399,
  [SMALL_STATE(3025)] = 157477,
  [SMALL_STATE(3026)] = 157565,
  [SMALL_STATE(3027)] = 157633,
  [SMALL_STATE(3028)] = 157727,
  [SMALL_STATE(3029)] = 157781,
  [SMALL_STATE(3030)] = 157875,
  [SMALL_STATE(3031)] = 157969,
  [SMALL_STATE(3032)] = 158021,
  [SMALL_STATE(3033)] = 158079,
  [SMALL_STATE(3034)] = 158175,
  [SMALL_STATE(3035)] = 158225,
  [SMALL_STATE(3036)] = 158279,
  [SMALL_STATE(3037)] = 158373,
  [SMALL_STATE(3038)] = 158423,
  [SMALL_STATE(3039)] = 158517,
  [SMALL_STATE(3040)] = 158569,
  [SMALL_STATE(3041)] = 158623,
  [SMALL_STATE(3042)] = 158675,
  [SMALL_STATE(3043)] = 158731,
  [SMALL_STATE(3044)] = 158827,
  [SMALL_STATE(3045)] = 158881,
  [SMALL_STATE(3046)] = 158945,
  [SMALL_STATE(3047)] = 159039,
  [SMALL_STATE(3048)] = 159133,
  [SMALL_STATE(3049)] = 159199,
  [SMALL_STATE(3050)] = 159265,
  [SMALL_STATE(3051)] = 159361,
  [SMALL_STATE(3052)] = 159415,
  [SMALL_STATE(3053)] = 159469,
  [SMALL_STATE(3054)] = 159525,
  [SMALL_STATE(3055)] = 159581,
  [SMALL_STATE(3056)] = 159677,
  [SMALL_STATE(3057)] = 159727,
  [SMALL_STATE(3058)] = 159820,
  [SMALL_STATE(3059)] = 159873,
  [SMALL_STATE(3060)] = 159928,
  [SMALL_STATE(3061)] = 159981,
  [SMALL_STATE(3062)] = 160034,
  [SMALL_STATE(3063)] = 160127,
  [SMALL_STATE(3064)] = 160176,
  [SMALL_STATE(3065)] = 160249,
  [SMALL_STATE(3066)] = 160324,
  [SMALL_STATE(3067)] = 160395,
  [SMALL_STATE(3068)] = 160488,
  [SMALL_STATE(3069)] = 160575,
  [SMALL_STATE(3070)] = 160640,
  [SMALL_STATE(3071)] = 160711,
  [SMALL_STATE(3072)] = 160794,
  [SMALL_STATE(3073)] = 160847,
  [SMALL_STATE(3074)] = 160900,
  [SMALL_STATE(3075)] = 160979,
  [SMALL_STATE(3076)] = 161032,
  [SMALL_STATE(3077)] = 161105,
  [SMALL_STATE(3078)] = 161152,
  [SMALL_STATE(3079)] = 161245,
  [SMALL_STATE(3080)] = 161298,
  [SMALL_STATE(3081)] = 161375,
  [SMALL_STATE(3082)] = 161442,
  [SMALL_STATE(3083)] = 161535,
  [SMALL_STATE(3084)] = 161588,
  [SMALL_STATE(3085)] = 161637,
  [SMALL_STATE(3086)] = 161730,
  [SMALL_STATE(3087)] = 161823,
  [SMALL_STATE(3088)] = 161880,
  [SMALL_STATE(3089)] = 161965,
  [SMALL_STATE(3090)] = 162038,
  [SMALL_STATE(3091)] = 162113,
  [SMALL_STATE(3092)] = 162184,
  [SMALL_STATE(3093)] = 162231,
  [SMALL_STATE(3094)] = 162302,
  [SMALL_STATE(3095)] = 162377,
  [SMALL_STATE(3096)] = 162462,
  [SMALL_STATE(3097)] = 162519,
  [SMALL_STATE(3098)] = 162576,
  [SMALL_STATE(3099)] = 162629,
  [SMALL_STATE(3100)] = 162714,
  [SMALL_STATE(3101)] = 162765,
  [SMALL_STATE(3102)] = 162816,
  [SMALL_STATE(3103)] = 162869,
  [SMALL_STATE(3104)] = 162922,
  [SMALL_STATE(3105)] = 162971,
  [SMALL_STATE(3106)] = 163024,
  [SMALL_STATE(3107)] = 163117,
  [SMALL_STATE(3108)] = 163166,
  [SMALL_STATE(3109)] = 163213,
  [SMALL_STATE(3110)] = 163266,
  [SMALL_STATE(3111)] = 163339,
  [SMALL_STATE(3112)] = 163414,
  [SMALL_STATE(3113)] = 163485,
  [SMALL_STATE(3114)] = 163550,
  [SMALL_STATE(3115)] = 163643,
  [SMALL_STATE(3116)] = 163708,
  [SMALL_STATE(3117)] = 163801,
  [SMALL_STATE(3118)] = 163894,
  [SMALL_STATE(3119)] = 163987,
  [SMALL_STATE(3120)] = 164050,
  [SMALL_STATE(3121)] = 164135,
  [SMALL_STATE(3122)] = 164220,
  [SMALL_STATE(3123)] = 164267,
  [SMALL_STATE(3124)] = 164320,
  [SMALL_STATE(3125)] = 164373,
  [SMALL_STATE(3126)] = 164422,
  [SMALL_STATE(3127)] = 164475,
  [SMALL_STATE(3128)] = 164528,
  [SMALL_STATE(3129)] = 164581,
  [SMALL_STATE(3130)] = 164632,
  [SMALL_STATE(3131)] = 164679,
  [SMALL_STATE(3132)] = 164772,
  [SMALL_STATE(3133)] = 164819,
  [SMALL_STATE(3134)] = 164866,
  [SMALL_STATE(3135)] = 164913,
  [SMALL_STATE(3136)] = 164960,
  [SMALL_STATE(3137)] = 165007,
  [SMALL_STATE(3138)] = 165080,
  [SMALL_STATE(3139)] = 165173,
  [SMALL_STATE(3140)] = 165248,
  [SMALL_STATE(3141)] = 165319,
  [SMALL_STATE(3142)] = 165366,
  [SMALL_STATE(3143)] = 165413,
  [SMALL_STATE(3144)] = 165460,
  [SMALL_STATE(3145)] = 165507,
  [SMALL_STATE(3146)] = 165554,
  [SMALL_STATE(3147)] = 165639,
  [SMALL_STATE(3148)] = 165688,
  [SMALL_STATE(3149)] = 165735,
  [SMALL_STATE(3150)] = 165782,
  [SMALL_STATE(3151)] = 165875,
  [SMALL_STATE(3152)] = 165928,
  [SMALL_STATE(3153)] = 165975,
  [SMALL_STATE(3154)] = 166022,
  [SMALL_STATE(3155)] = 166069,
  [SMALL_STATE(3156)] = 166116,
  [SMALL_STATE(3157)] = 166169,
  [SMALL_STATE(3158)] = 166216,
  [SMALL_STATE(3159)] = 166265,
  [SMALL_STATE(3160)] = 166312,
  [SMALL_STATE(3161)] = 166359,
  [SMALL_STATE(3162)] = 166406,
  [SMALL_STATE(3163)] = 166453,
  [SMALL_STATE(3164)] = 166500,
  [SMALL_STATE(3165)] = 166547,
  [SMALL_STATE(3166)] = 166594,
  [SMALL_STATE(3167)] = 166641,
  [SMALL_STATE(3168)] = 166688,
  [SMALL_STATE(3169)] = 166735,
  [SMALL_STATE(3170)] = 166782,
  [SMALL_STATE(3171)] = 166829,
  [SMALL_STATE(3172)] = 166922,
  [SMALL_STATE(3173)] = 166969,
  [SMALL_STATE(3174)] = 167016,
  [SMALL_STATE(3175)] = 167109,
  [SMALL_STATE(3176)] = 167156,
  [SMALL_STATE(3177)] = 167203,
  [SMALL_STATE(3178)] = 167276,
  [SMALL_STATE(3179)] = 167323,
  [SMALL_STATE(3180)] = 167370,
  [SMALL_STATE(3181)] = 167417,
  [SMALL_STATE(3182)] = 167464,
  [SMALL_STATE(3183)] = 167511,
  [SMALL_STATE(3184)] = 167558,
  [SMALL_STATE(3185)] = 167643,
  [SMALL_STATE(3186)] = 167690,
  [SMALL_STATE(3187)] = 167737,
  [SMALL_STATE(3188)] = 167784,
  [SMALL_STATE(3189)] = 167831,
  [SMALL_STATE(3190)] = 167878,
  [SMALL_STATE(3191)] = 167925,
  [SMALL_STATE(3192)] = 167978,
  [SMALL_STATE(3193)] = 168027,
  [SMALL_STATE(3194)] = 168112,
  [SMALL_STATE(3195)] = 168205,
  [SMALL_STATE(3196)] = 168258,
  [SMALL_STATE(3197)] = 168311,
  [SMALL_STATE(3198)] = 168362,
  [SMALL_STATE(3199)] = 168415,
  [SMALL_STATE(3200)] = 168464,
  [SMALL_STATE(3201)] = 168511,
  [SMALL_STATE(3202)] = 168564,
  [SMALL_STATE(3203)] = 168611,
  [SMALL_STATE(3204)] = 168658,
  [SMALL_STATE(3205)] = 168705,
  [SMALL_STATE(3206)] = 168752,
  [SMALL_STATE(3207)] = 168803,
  [SMALL_STATE(3208)] = 168888,
  [SMALL_STATE(3209)] = 168937,
  [SMALL_STATE(3210)] = 168990,
  [SMALL_STATE(3211)] = 169037,
  [SMALL_STATE(3212)] = 169130,
  [SMALL_STATE(3213)] = 169223,
  [SMALL_STATE(3214)] = 169276,
  [SMALL_STATE(3215)] = 169327,
  [SMALL_STATE(3216)] = 169420,
  [SMALL_STATE(3217)] = 169467,
  [SMALL_STATE(3218)] = 169516,
  [SMALL_STATE(3219)] = 169565,
  [SMALL_STATE(3220)] = 169614,
  [SMALL_STATE(3221)] = 169661,
  [SMALL_STATE(3222)] = 169718,
  [SMALL_STATE(3223)] = 169765,
  [SMALL_STATE(3224)] = 169812,
  [SMALL_STATE(3225)] = 169859,
  [SMALL_STATE(3226)] = 169932,
  [SMALL_STATE(3227)] = 170007,
  [SMALL_STATE(3228)] = 170078,
  [SMALL_STATE(3229)] = 170125,
  [SMALL_STATE(3230)] = 170178,
  [SMALL_STATE(3231)] = 170235,
  [SMALL_STATE(3232)] = 170282,
  [SMALL_STATE(3233)] = 170335,
  [SMALL_STATE(3234)] = 170382,
  [SMALL_STATE(3235)] = 170439,
  [SMALL_STATE(3236)] = 170510,
  [SMALL_STATE(3237)] = 170563,
  [SMALL_STATE(3238)] = 170610,
  [SMALL_STATE(3239)] = 170659,
  [SMALL_STATE(3240)] = 170734,
  [SMALL_STATE(3241)] = 170807,
  [SMALL_STATE(3242)] = 170900,
  [SMALL_STATE(3243)] = 170953,
  [SMALL_STATE(3244)] = 171010,
  [SMALL_STATE(3245)] = 171103,
  [SMALL_STATE(3246)] = 171196,
  [SMALL_STATE(3247)] = 171289,
  [SMALL_STATE(3248)] = 171382,
  [SMALL_STATE(3249)] = 171449,
  [SMALL_STATE(3250)] = 171526,
  [SMALL_STATE(3251)] = 171599,
  [SMALL_STATE(3252)] = 171652,
  [SMALL_STATE(3253)] = 171731,
  [SMALL_STATE(3254)] = 171784,
  [SMALL_STATE(3255)] = 171867,
  [SMALL_STATE(3256)] = 171920,
  [SMALL_STATE(3257)] = 171991,
  [SMALL_STATE(3258)] = 172056,
  [SMALL_STATE(3259)] = 172141,
  [SMALL_STATE(3260)] = 172228,
  [SMALL_STATE(3261)] = 172321,
  [SMALL_STATE(3262)] = 172370,
  [SMALL_STATE(3263)] = 172423,
  [SMALL_STATE(3264)] = 172476,
  [SMALL_STATE(3265)] = 172527,
  [SMALL_STATE(3266)] = 172574,
  [SMALL_STATE(3267)] = 172667,
  [SMALL_STATE(3268)] = 172718,
  [SMALL_STATE(3269)] = 172811,
  [SMALL_STATE(3270)] = 172904,
  [SMALL_STATE(3271)] = 172997,
  [SMALL_STATE(3272)] = 173090,
  [SMALL_STATE(3273)] = 173183,
  [SMALL_STATE(3274)] = 173276,
  [SMALL_STATE(3275)] = 173369,
  [SMALL_STATE(3276)] = 173462,
  [SMALL_STATE(3277)] = 173555,
  [SMALL_STATE(3278)] = 173648,
  [SMALL_STATE(3279)] = 173695,
  [SMALL_STATE(3280)] = 173788,
  [SMALL_STATE(3281)] = 173835,
  [SMALL_STATE(3282)] = 173882,
  [SMALL_STATE(3283)] = 173975,
  [SMALL_STATE(3284)] = 174022,
  [SMALL_STATE(3285)] = 174069,
  [SMALL_STATE(3286)] = 174116,
  [SMALL_STATE(3287)] = 174169,
  [SMALL_STATE(3288)] = 174218,
  [SMALL_STATE(3289)] = 174311,
  [SMALL_STATE(3290)] = 174396,
  [SMALL_STATE(3291)] = 174489,
  [SMALL_STATE(3292)] = 174582,
  [SMALL_STATE(3293)] = 174675,
  [SMALL_STATE(3294)] = 174722,
  [SMALL_STATE(3295)] = 174793,
  [SMALL_STATE(3296)] = 174868,
  [SMALL_STATE(3297)] = 174941,
  [SMALL_STATE(3298)] = 174994,
  [SMALL_STATE(3299)] = 175047,
  [SMALL_STATE(3300)] = 175100,
  [SMALL_STATE(3301)] = 175153,
  [SMALL_STATE(3302)] = 175200,
  [SMALL_STATE(3303)] = 175247,
  [SMALL_STATE(3304)] = 175294,
  [SMALL_STATE(3305)] = 175387,
  [SMALL_STATE(3306)] = 175434,
  [SMALL_STATE(3307)] = 175481,
  [SMALL_STATE(3308)] = 175528,
  [SMALL_STATE(3309)] = 175613,
  [SMALL_STATE(3310)] = 175660,
  [SMALL_STATE(3311)] = 175707,
  [SMALL_STATE(3312)] = 175754,
  [SMALL_STATE(3313)] = 175801,
  [SMALL_STATE(3314)] = 175850,
  [SMALL_STATE(3315)] = 175905,
  [SMALL_STATE(3316)] = 175952,
  [SMALL_STATE(3317)] = 176017,
  [SMALL_STATE(3318)] = 176082,
  [SMALL_STATE(3319)] = 176167,
  [SMALL_STATE(3320)] = 176260,
  [SMALL_STATE(3321)] = 176307,
  [SMALL_STATE(3322)] = 176354,
  [SMALL_STATE(3323)] = 176401,
  [SMALL_STATE(3324)] = 176448,
  [SMALL_STATE(3325)] = 176495,
  [SMALL_STATE(3326)] = 176588,
  [SMALL_STATE(3327)] = 176651,
  [SMALL_STATE(3328)] = 176698,
  [SMALL_STATE(3329)] = 176783,
  [SMALL_STATE(3330)] = 176876,
  [SMALL_STATE(3331)] = 176923,
  [SMALL_STATE(3332)] = 176996,
  [SMALL_STATE(3333)] = 177071,
  [SMALL_STATE(3334)] = 177156,
  [SMALL_STATE(3335)] = 177227,
  [SMALL_STATE(3336)] = 177293,
  [SMALL_STATE(3337)] = 177359,
  [SMALL_STATE(3338)] = 177411,
  [SMALL_STATE(3339)] = 177463,
  [SMALL_STATE(3340)] = 177529,
  [SMALL_STATE(3341)] = 177581,
  [SMALL_STATE(3342)] = 177633,
  [SMALL_STATE(3343)] = 177699,
  [SMALL_STATE(3344)] = 177789,
  [SMALL_STATE(3345)] = 177841,
  [SMALL_STATE(3346)] = 177907,
  [SMALL_STATE(3347)] = 177959,
  [SMALL_STATE(3348)] = 178027,
  [SMALL_STATE(3349)] = 178097,
  [SMALL_STATE(3350)] = 178169,
  [SMALL_STATE(3351)] = 178235,
  [SMALL_STATE(3352)] = 178285,
  [SMALL_STATE(3353)] = 178375,
  [SMALL_STATE(3354)] = 178441,
  [SMALL_STATE(3355)] = 178491,
  [SMALL_STATE(3356)] = 178541,
  [SMALL_STATE(3357)] = 178589,
  [SMALL_STATE(3358)] = 178637,
  [SMALL_STATE(3359)] = 178689,
  [SMALL_STATE(3360)] = 178779,
  [SMALL_STATE(3361)] = 178827,
  [SMALL_STATE(3362)] = 178893,
  [SMALL_STATE(3363)] = 178983,
  [SMALL_STATE(3364)] = 179035,
  [SMALL_STATE(3365)] = 179087,
  [SMALL_STATE(3366)] = 179135,
  [SMALL_STATE(3367)] = 179187,
  [SMALL_STATE(3368)] = 179239,
  [SMALL_STATE(3369)] = 179295,
  [SMALL_STATE(3370)] = 179343,
  [SMALL_STATE(3371)] = 179395,
  [SMALL_STATE(3372)] = 179445,
  [SMALL_STATE(3373)] = 179497,
  [SMALL_STATE(3374)] = 179549,
  [SMALL_STATE(3375)] = 179615,
  [SMALL_STATE(3376)] = 179667,
  [SMALL_STATE(3377)] = 179719,
  [SMALL_STATE(3378)] = 179767,
  [SMALL_STATE(3379)] = 179819,
  [SMALL_STATE(3380)] = 179866,
  [SMALL_STATE(3381)] = 179917,
  [SMALL_STATE(3382)] = 179984,
  [SMALL_STATE(3383)] = 180035,
  [SMALL_STATE(3384)] = 180098,
  [SMALL_STATE(3385)] = 180149,
  [SMALL_STATE(3386)] = 180198,
  [SMALL_STATE(3387)] = 180249,
  [SMALL_STATE(3388)] = 180316,
  [SMALL_STATE(3389)] = 180367,
  [SMALL_STATE(3390)] = 180418,
  [SMALL_STATE(3391)] = 180465,
  [SMALL_STATE(3392)] = 180530,
  [SMALL_STATE(3393)] = 180581,
  [SMALL_STATE(3394)] = 180648,
  [SMALL_STATE(3395)] = 180711,
  [SMALL_STATE(3396)] = 180776,
  [SMALL_STATE(3397)] = 180827,
  [SMALL_STATE(3398)] = 180900,
  [SMALL_STATE(3399)] = 180973,
  [SMALL_STATE(3400)] = 181046,
  [SMALL_STATE(3401)] = 181119,
  [SMALL_STATE(3402)] = 181192,
  [SMALL_STATE(3403)] = 181265,
  [SMALL_STATE(3404)] = 181330,
  [SMALL_STATE(3405)] = 181397,
  [SMALL_STATE(3406)] = 181460,
  [SMALL_STATE(3407)] = 181523,
  [SMALL_STATE(3408)] = 181596,
  [SMALL_STATE(3409)] = 181647,
  [SMALL_STATE(3410)] = 181720,
  [SMALL_STATE(3411)] = 181783,
  [SMALL_STATE(3412)] = 181834,
  [SMALL_STATE(3413)] = 181881,
  [SMALL_STATE(3414)] = 181954,
  [SMALL_STATE(3415)] = 182005,
  [SMALL_STATE(3416)] = 182054,
  [SMALL_STATE(3417)] = 182105,
  [SMALL_STATE(3418)] = 182156,
  [SMALL_STATE(3419)] = 182203,
  [SMALL_STATE(3420)] = 182275,
  [SMALL_STATE(3421)] = 182347,
  [SMALL_STATE(3422)] = 182403,
  [SMALL_STATE(3423)] = 182459,
  [SMALL_STATE(3424)] = 182527,
  [SMALL_STATE(3425)] = 182597,
  [SMALL_STATE(3426)] = 182653,
  [SMALL_STATE(3427)] = 182713,
  [SMALL_STATE(3428)] = 182773,
  [SMALL_STATE(3429)] = 182831,
  [SMALL_STATE(3430)] = 182889,
  [SMALL_STATE(3431)] = 182949,
  [SMALL_STATE(3432)] = 183011,
  [SMALL_STATE(3433)] = 183057,
  [SMALL_STATE(3434)] = 183115,
  [SMALL_STATE(3435)] = 183177,
  [SMALL_STATE(3436)] = 183247,
  [SMALL_STATE(3437)] = 183319,
  [SMALL_STATE(3438)] = 183387,
  [SMALL_STATE(3439)] = 183443,
  [SMALL_STATE(3440)] = 183501,
  [SMALL_STATE(3441)] = 183563,
  [SMALL_STATE(3442)] = 183631,
  [SMALL_STATE(3443)] = 183703,
  [SMALL_STATE(3444)] = 183761,
  [SMALL_STATE(3445)] = 183831,
  [SMALL_STATE(3446)] = 183899,
  [SMALL_STATE(3447)] = 183957,
  [SMALL_STATE(3448)] = 184029,
  [SMALL_STATE(3449)] = 184099,
  [SMALL_STATE(3450)] = 184167,
  [SMALL_STATE(3451)] = 184239,
  [SMALL_STATE(3452)] = 184307,
  [SMALL_STATE(3453)] = 184377,
  [SMALL_STATE(3454)] = 184447,
  [SMALL_STATE(3455)] = 184517,
  [SMALL_STATE(3456)] = 184589,
  [SMALL_STATE(3457)] = 184659,
  [SMALL_STATE(3458)] = 184719,
  [SMALL_STATE(3459)] = 184791,
  [SMALL_STATE(3460)] = 184849,
  [SMALL_STATE(3461)] = 184907,
  [SMALL_STATE(3462)] = 184975,
  [SMALL_STATE(3463)] = 185033,
  [SMALL_STATE(3464)] = 185089,
  [SMALL_STATE(3465)] = 185157,
  [SMALL_STATE(3466)] = 185229,
  [SMALL_STATE(3467)] = 185287,
  [SMALL_STATE(3468)] = 185357,
  [SMALL_STATE(3469)] = 185427,
  [SMALL_STATE(3470)] = 185483,
  [SMALL_STATE(3471)] = 185555,
  [SMALL_STATE(3472)] = 185623,
  [SMALL_STATE(3473)] = 185685,
  [SMALL_STATE(3474)] = 185747,
  [SMALL_STATE(3475)] = 185815,
  [SMALL_STATE(3476)] = 185885,
  [SMALL_STATE(3477)] = 185941,
  [SMALL_STATE(3478)] = 185997,
  [SMALL_STATE(3479)] = 186065,
  [SMALL_STATE(3480)] = 186125,
  [SMALL_STATE(3481)] = 186183,
  [SMALL_STATE(3482)] = 186243,
  [SMALL_STATE(3483)] = 186301,
  [SMALL_STATE(3484)] = 186359,
  [SMALL_STATE(3485)] = 186421,
  [SMALL_STATE(3486)] = 186481,
  [SMALL_STATE(3487)] = 186537,
  [SMALL_STATE(3488)] = 186609,
  [SMALL_STATE(3489)] = 186679,
  [SMALL_STATE(3490)] = 186732,
  [SMALL_STATE(3491)] = 186795,
  [SMALL_STATE(3492)] = 186848,
  [SMALL_STATE(3493)] = 186901,
  [SMALL_STATE(3494)] = 186964,
  [SMALL_STATE(3495)] = 187027,
  [SMALL_STATE(3496)] = 187080,
  [SMALL_STATE(3497)] = 187133,
  [SMALL_STATE(3498)] = 187196,
  [SMALL_STATE(3499)] = 187259,
  [SMALL_STATE(3500)] = 187308,
  [SMALL_STATE(3501)] = 187361,
  [SMALL_STATE(3502)] = 187414,
  [SMALL_STATE(3503)] = 187477,
  [SMALL_STATE(3504)] = 187540,
  [SMALL_STATE(3505)] = 187603,
  [SMALL_STATE(3506)] = 187656,
  [SMALL_STATE(3507)] = 187709,
  [SMALL_STATE(3508)] = 187762,
  [SMALL_STATE(3509)] = 187815,
  [SMALL_STATE(3510)] = 187868,
  [SMALL_STATE(3511)] = 187931,
  [SMALL_STATE(3512)] = 187984,
  [SMALL_STATE(3513)] = 188047,
  [SMALL_STATE(3514)] = 188100,
  [SMALL_STATE(3515)] = 188163,
  [SMALL_STATE(3516)] = 188216,
  [SMALL_STATE(3517)] = 188269,
  [SMALL_STATE(3518)] = 188329,
  [SMALL_STATE(3519)] = 188383,
  [SMALL_STATE(3520)] = 188437,
  [SMALL_STATE(3521)] = 188485,
  [SMALL_STATE(3522)] = 188527,
  [SMALL_STATE(3523)] = 188597,
  [SMALL_STATE(3524)] = 188645,
  [SMALL_STATE(3525)] = 188709,
  [SMALL_STATE(3526)] = 188771,
  [SMALL_STATE(3527)] = 188824,
  [SMALL_STATE(3528)] = 188877,
  [SMALL_STATE(3529)] = 188932,
  [SMALL_STATE(3530)] = 188985,
  [SMALL_STATE(3531)] = 189036,
  [SMALL_STATE(3532)] = 189089,
  [SMALL_STATE(3533)] = 189144,
  [SMALL_STATE(3534)] = 189197,
  [SMALL_STATE(3535)] = 189264,
  [SMALL_STATE(3536)] = 189343,
  [SMALL_STATE(3537)] = 189396,
  [SMALL_STATE(3538)] = 189449,
  [SMALL_STATE(3539)] = 189528,
  [SMALL_STATE(3540)] = 189583,
  [SMALL_STATE(3541)] = 189636,
  [SMALL_STATE(3542)] = 189715,
  [SMALL_STATE(3543)] = 189768,
  [SMALL_STATE(3544)] = 189825,
  [SMALL_STATE(3545)] = 189904,
  [SMALL_STATE(3546)] = 189965,
  [SMALL_STATE(3547)] = 190018,
  [SMALL_STATE(3548)] = 190077,
  [SMALL_STATE(3549)] = 190130,
  [SMALL_STATE(3550)] = 190183,
  [SMALL_STATE(3551)] = 190238,
  [SMALL_STATE(3552)] = 190291,
  [SMALL_STATE(3553)] = 190331,
  [SMALL_STATE(3554)] = 190383,
  [SMALL_STATE(3555)] = 190423,
  [SMALL_STATE(3556)] = 190487,
  [SMALL_STATE(3557)] = 190527,
  [SMALL_STATE(3558)] = 190567,
  [SMALL_STATE(3559)] = 190607,
  [SMALL_STATE(3560)] = 190652,
  [SMALL_STATE(3561)] = 190709,
  [SMALL_STATE(3562)] = 190766,
  [SMALL_STATE(3563)] = 190804,
  [SMALL_STATE(3564)] = 190856,
  [SMALL_STATE(3565)] = 190894,
  [SMALL_STATE(3566)] = 190932,
  [SMALL_STATE(3567)] = 190970,
  [SMALL_STATE(3568)] = 191008,
  [SMALL_STATE(3569)] = 191048,
  [SMALL_STATE(3570)] = 191086,
  [SMALL_STATE(3571)] = 191128,
  [SMALL_STATE(3572)] = 191180,
  [SMALL_STATE(3573)] = 191218,
  [SMALL_STATE(3574)] = 191272,
  [SMALL_STATE(3575)] = 191310,
  [SMALL_STATE(3576)] = 191362,
  [SMALL_STATE(3577)] = 191418,
  [SMALL_STATE(3578)] = 191456,
  [SMALL_STATE(3579)] = 191510,
  [SMALL_STATE(3580)] = 191548,
  [SMALL_STATE(3581)] = 191586,
  [SMALL_STATE(3582)] = 191636,
  [SMALL_STATE(3583)] = 191674,
  [SMALL_STATE(3584)] = 191714,
  [SMALL_STATE(3585)] = 191752,
  [SMALL_STATE(3586)] = 191792,
  [SMALL_STATE(3587)] = 191830,
  [SMALL_STATE(3588)] = 191882,
  [SMALL_STATE(3589)] = 191929,
  [SMALL_STATE(3590)] = 191976,
  [SMALL_STATE(3591)] = 192023,
  [SMALL_STATE(3592)] = 192070,
  [SMALL_STATE(3593)] = 192117,
  [SMALL_STATE(3594)] = 192164,
  [SMALL_STATE(3595)] = 192211,
  [SMALL_STATE(3596)] = 192258,
  [SMALL_STATE(3597)] = 192305,
  [SMALL_STATE(3598)] = 192352,
  [SMALL_STATE(3599)] = 192399,
  [SMALL_STATE(3600)] = 192446,
  [SMALL_STATE(3601)] = 192493,
  [SMALL_STATE(3602)] = 192540,
  [SMALL_STATE(3603)] = 192587,
  [SMALL_STATE(3604)] = 192634,
  [SMALL_STATE(3605)] = 192672,
  [SMALL_STATE(3606)] = 192722,
  [SMALL_STATE(3607)] = 192772,
  [SMALL_STATE(3608)] = 192820,
  [SMALL_STATE(3609)] = 192856,
  [SMALL_STATE(3610)] = 192904,
  [SMALL_STATE(3611)] = 192960,
  [SMALL_STATE(3612)] = 193002,
  [SMALL_STATE(3613)] = 193050,
  [SMALL_STATE(3614)] = 193098,
  [SMALL_STATE(3615)] = 193146,
  [SMALL_STATE(3616)] = 193194,
  [SMALL_STATE(3617)] = 193247,
  [SMALL_STATE(3618)] = 193296,
  [SMALL_STATE(3619)] = 193341,
  [SMALL_STATE(3620)] = 193390,
  [SMALL_STATE(3621)] = 193443,
  [SMALL_STATE(3622)] = 193492,
  [SMALL_STATE(3623)] = 193545,
  [SMALL_STATE(3624)] = 193590,
  [SMALL_STATE(3625)] = 193632,
  [SMALL_STATE(3626)] = 193674,
  [SMALL_STATE(3627)] = 193716,
  [SMALL_STATE(3628)] = 193758,
  [SMALL_STATE(3629)] = 193800,
  [SMALL_STATE(3630)] = 193842,
  [SMALL_STATE(3631)] = 193886,
  [SMALL_STATE(3632)] = 193928,
  [SMALL_STATE(3633)] = 193972,
  [SMALL_STATE(3634)] = 194006,
  [SMALL_STATE(3635)] = 194048,
  [SMALL_STATE(3636)] = 194090,
  [SMALL_STATE(3637)] = 194132,
  [SMALL_STATE(3638)] = 194174,
  [SMALL_STATE(3639)] = 194216,
  [SMALL_STATE(3640)] = 194258,
  [SMALL_STATE(3641)] = 194300,
  [SMALL_STATE(3642)] = 194342,
  [SMALL_STATE(3643)] = 194384,
  [SMALL_STATE(3644)] = 194426,
  [SMALL_STATE(3645)] = 194468,
  [SMALL_STATE(3646)] = 194510,
  [SMALL_STATE(3647)] = 194552,
  [SMALL_STATE(3648)] = 194594,
  [SMALL_STATE(3649)] = 194636,
  [SMALL_STATE(3650)] = 194678,
  [SMALL_STATE(3651)] = 194720,
  [SMALL_STATE(3652)] = 194762,
  [SMALL_STATE(3653)] = 194792,
  [SMALL_STATE(3654)] = 194822,
  [SMALL_STATE(3655)] = 194846,
  [SMALL_STATE(3656)] = 194872,
  [SMALL_STATE(3657)] = 194896,
  [SMALL_STATE(3658)] = 194926,
  [SMALL_STATE(3659)] = 194953,
  [SMALL_STATE(3660)] = 194974,
  [SMALL_STATE(3661)] = 195001,
  [SMALL_STATE(3662)] = 195022,
  [SMALL_STATE(3663)] = 195043,
  [SMALL_STATE(3664)] = 195064,
  [SMALL_STATE(3665)] = 195085,
  [SMALL_STATE(3666)] = 195106,
  [SMALL_STATE(3667)] = 195127,
  [SMALL_STATE(3668)] = 195148,
  [SMALL_STATE(3669)] = 195169,
  [SMALL_STATE(3670)] = 195190,
  [SMALL_STATE(3671)] = 195211,
  [SMALL_STATE(3672)] = 195232,
  [SMALL_STATE(3673)] = 195253,
  [SMALL_STATE(3674)] = 195274,
  [SMALL_STATE(3675)] = 195295,
  [SMALL_STATE(3676)] = 195316,
  [SMALL_STATE(3677)] = 195337,
  [SMALL_STATE(3678)] = 195358,
  [SMALL_STATE(3679)] = 195379,
  [SMALL_STATE(3680)] = 195400,
  [SMALL_STATE(3681)] = 195442,
  [SMALL_STATE(3682)] = 195464,
  [SMALL_STATE(3683)] = 195492,
  [SMALL_STATE(3684)] = 195534,
  [SMALL_STATE(3685)] = 195556,
  [SMALL_STATE(3686)] = 195598,
  [SMALL_STATE(3687)] = 195628,
  [SMALL_STATE(3688)] = 195670,
  [SMALL_STATE(3689)] = 195712,
  [SMALL_STATE(3690)] = 195740,
  [SMALL_STATE(3691)] = 195782,
  [SMALL_STATE(3692)] = 195803,
  [SMALL_STATE(3693)] = 195838,
  [SMALL_STATE(3694)] = 195873,
  [SMALL_STATE(3695)] = 195894,
  [SMALL_STATE(3696)] = 195915,
  [SMALL_STATE(3697)] = 195950,
  [SMALL_STATE(3698)] = 195987,
  [SMALL_STATE(3699)] = 196010,
  [SMALL_STATE(3700)] = 196031,
  [SMALL_STATE(3701)] = 196052,
  [SMALL_STATE(3702)] = 196073,
  [SMALL_STATE(3703)] = 196108,
  [SMALL_STATE(3704)] = 196143,
  [SMALL_STATE(3705)] = 196164,
  [SMALL_STATE(3706)] = 196185,
  [SMALL_STATE(3707)] = 196220,
  [SMALL_STATE(3708)] = 196241,
  [SMALL_STATE(3709)] = 196266,
  [SMALL_STATE(3710)] = 196301,
  [SMALL_STATE(3711)] = 196322,
  [SMALL_STATE(3712)] = 196343,
  [SMALL_STATE(3713)] = 196378,
  [SMALL_STATE(3714)] = 196399,
  [SMALL_STATE(3715)] = 196420,
  [SMALL_STATE(3716)] = 196441,
  [SMALL_STATE(3717)] = 196462,
  [SMALL_STATE(3718)] = 196487,
  [SMALL_STATE(3719)] = 196522,
  [SMALL_STATE(3720)] = 196543,
  [SMALL_STATE(3721)] = 196564,
  [SMALL_STATE(3722)] = 196585,
  [SMALL_STATE(3723)] = 196606,
  [SMALL_STATE(3724)] = 196631,
  [SMALL_STATE(3725)] = 196652,
  [SMALL_STATE(3726)] = 196687,
  [SMALL_STATE(3727)] = 196710,
  [SMALL_STATE(3728)] = 196742,
  [SMALL_STATE(3729)] = 196774,
  [SMALL_STATE(3730)] = 196810,
  [SMALL_STATE(3731)] = 196846,
  [SMALL_STATE(3732)] = 196882,
  [SMALL_STATE(3733)] = 196914,
  [SMALL_STATE(3734)] = 196950,
  [SMALL_STATE(3735)] = 196978,
  [SMALL_STATE(3736)] = 197006,
  [SMALL_STATE(3737)] = 197034,
  [SMALL_STATE(3738)] = 197070,
  [SMALL_STATE(3739)] = 197102,
  [SMALL_STATE(3740)] = 197128,
  [SMALL_STATE(3741)] = 197158,
  [SMALL_STATE(3742)] = 197190,
  [SMALL_STATE(3743)] = 197218,
  [SMALL_STATE(3744)] = 197246,
  [SMALL_STATE(3745)] = 197274,
  [SMALL_STATE(3746)] = 197306,
  [SMALL_STATE(3747)] = 197334,
  [SMALL_STATE(3748)] = 197366,
  [SMALL_STATE(3749)] = 197394,
  [SMALL_STATE(3750)] = 197422,
  [SMALL_STATE(3751)] = 197448,
  [SMALL_STATE(3752)] = 197476,
  [SMALL_STATE(3753)] = 197512,
  [SMALL_STATE(3754)] = 197540,
  [SMALL_STATE(3755)] = 197572,
  [SMALL_STATE(3756)] = 197591,
  [SMALL_STATE(3757)] = 197616,
  [SMALL_STATE(3758)] = 197641,
  [SMALL_STATE(3759)] = 197662,
  [SMALL_STATE(3760)] = 197685,
  [SMALL_STATE(3761)] = 197704,
  [SMALL_STATE(3762)] = 197731,
  [SMALL_STATE(3763)] = 197748,
  [SMALL_STATE(3764)] = 197767,
  [SMALL_STATE(3765)] = 197792,
  [SMALL_STATE(3766)] = 197809,
  [SMALL_STATE(3767)] = 197834,
  [SMALL_STATE(3768)] = 197859,
  [SMALL_STATE(3769)] = 197878,
  [SMALL_STATE(3770)] = 197897,
  [SMALL_STATE(3771)] = 197916,
  [SMALL_STATE(3772)] = 197935,
  [SMALL_STATE(3773)] = 197958,
  [SMALL_STATE(3774)] = 197977,
  [SMALL_STATE(3775)] = 197996,
  [SMALL_STATE(3776)] = 198015,
  [SMALL_STATE(3777)] = 198034,
  [SMALL_STATE(3778)] = 198053,
  [SMALL_STATE(3779)] = 198072,
  [SMALL_STATE(3780)] = 198091,
  [SMALL_STATE(3781)] = 198110,
  [SMALL_STATE(3782)] = 198129,
  [SMALL_STATE(3783)] = 198148,
  [SMALL_STATE(3784)] = 198167,
  [SMALL_STATE(3785)] = 198188,
  [SMALL_STATE(3786)] = 198207,
  [SMALL_STATE(3787)] = 198232,
  [SMALL_STATE(3788)] = 198251,
  [SMALL_STATE(3789)] = 198270,
  [SMALL_STATE(3790)] = 198289,
  [SMALL_STATE(3791)] = 198308,
  [SMALL_STATE(3792)] = 198331,
  [SMALL_STATE(3793)] = 198350,
  [SMALL_STATE(3794)] = 198369,
  [SMALL_STATE(3795)] = 198388,
  [SMALL_STATE(3796)] = 198407,
  [SMALL_STATE(3797)] = 198426,
  [SMALL_STATE(3798)] = 198445,
  [SMALL_STATE(3799)] = 198464,
  [SMALL_STATE(3800)] = 198486,
  [SMALL_STATE(3801)] = 198506,
  [SMALL_STATE(3802)] = 198526,
  [SMALL_STATE(3803)] = 198548,
  [SMALL_STATE(3804)] = 198568,
  [SMALL_STATE(3805)] = 198602,
  [SMALL_STATE(3806)] = 198636,
  [SMALL_STATE(3807)] = 198670,
  [SMALL_STATE(3808)] = 198704,
  [SMALL_STATE(3809)] = 198734,
  [SMALL_STATE(3810)] = 198752,
  [SMALL_STATE(3811)] = 198780,
  [SMALL_STATE(3812)] = 198800,
  [SMALL_STATE(3813)] = 198824,
  [SMALL_STATE(3814)] = 198844,
  [SMALL_STATE(3815)] = 198878,
  [SMALL_STATE(3816)] = 198912,
  [SMALL_STATE(3817)] = 198946,
  [SMALL_STATE(3818)] = 198966,
  [SMALL_STATE(3819)] = 198990,
  [SMALL_STATE(3820)] = 199010,
  [SMALL_STATE(3821)] = 199032,
  [SMALL_STATE(3822)] = 199054,
  [SMALL_STATE(3823)] = 199088,
  [SMALL_STATE(3824)] = 199122,
  [SMALL_STATE(3825)] = 199156,
  [SMALL_STATE(3826)] = 199176,
  [SMALL_STATE(3827)] = 199196,
  [SMALL_STATE(3828)] = 199220,
  [SMALL_STATE(3829)] = 199254,
  [SMALL_STATE(3830)] = 199288,
  [SMALL_STATE(3831)] = 199313,
  [SMALL_STATE(3832)] = 199344,
  [SMALL_STATE(3833)] = 199369,
  [SMALL_STATE(3834)] = 199394,
  [SMALL_STATE(3835)] = 199417,
  [SMALL_STATE(3836)] = 199442,
  [SMALL_STATE(3837)] = 199467,
  [SMALL_STATE(3838)] = 199486,
  [SMALL_STATE(3839)] = 199505,
  [SMALL_STATE(3840)] = 199530,
  [SMALL_STATE(3841)] = 199555,
  [SMALL_STATE(3842)] = 199570,
  [SMALL_STATE(3843)] = 199589,
  [SMALL_STATE(3844)] = 199614,
  [SMALL_STATE(3845)] = 199645,
  [SMALL_STATE(3846)] = 199664,
  [SMALL_STATE(3847)] = 199695,
  [SMALL_STATE(3848)] = 199720,
  [SMALL_STATE(3849)] = 199751,
  [SMALL_STATE(3850)] = 199782,
  [SMALL_STATE(3851)] = 199813,
  [SMALL_STATE(3852)] = 199844,
  [SMALL_STATE(3853)] = 199859,
  [SMALL_STATE(3854)] = 199890,
  [SMALL_STATE(3855)] = 199921,
  [SMALL_STATE(3856)] = 199952,
  [SMALL_STATE(3857)] = 199977,
  [SMALL_STATE(3858)] = 199998,
  [SMALL_STATE(3859)] = 200015,
  [SMALL_STATE(3860)] = 200046,
  [SMALL_STATE(3861)] = 200061,
  [SMALL_STATE(3862)] = 200092,
  [SMALL_STATE(3863)] = 200117,
  [SMALL_STATE(3864)] = 200148,
  [SMALL_STATE(3865)] = 200173,
  [SMALL_STATE(3866)] = 200192,
  [SMALL_STATE(3867)] = 200211,
  [SMALL_STATE(3868)] = 200242,
  [SMALL_STATE(3869)] = 200261,
  [SMALL_STATE(3870)] = 200284,
  [SMALL_STATE(3871)] = 200299,
  [SMALL_STATE(3872)] = 200324,
  [SMALL_STATE(3873)] = 200355,
  [SMALL_STATE(3874)] = 200380,
  [SMALL_STATE(3875)] = 200395,
  [SMALL_STATE(3876)] = 200426,
  [SMALL_STATE(3877)] = 200445,
  [SMALL_STATE(3878)] = 200464,
  [SMALL_STATE(3879)] = 200495,
  [SMALL_STATE(3880)] = 200510,
  [SMALL_STATE(3881)] = 200525,
  [SMALL_STATE(3882)] = 200540,
  [SMALL_STATE(3883)] = 200571,
  [SMALL_STATE(3884)] = 200596,
  [SMALL_STATE(3885)] = 200627,
  [SMALL_STATE(3886)] = 200658,
  [SMALL_STATE(3887)] = 200681,
  [SMALL_STATE(3888)] = 200706,
  [SMALL_STATE(3889)] = 200723,
  [SMALL_STATE(3890)] = 200742,
  [SMALL_STATE(3891)] = 200756,
  [SMALL_STATE(3892)] = 200770,
  [SMALL_STATE(3893)] = 200790,
  [SMALL_STATE(3894)] = 200804,
  [SMALL_STATE(3895)] = 200818,
  [SMALL_STATE(3896)] = 200832,
  [SMALL_STATE(3897)] = 200846,
  [SMALL_STATE(3898)] = 200860,
  [SMALL_STATE(3899)] = 200874,
  [SMALL_STATE(3900)] = 200892,
  [SMALL_STATE(3901)] = 200906,
  [SMALL_STATE(3902)] = 200920,
  [SMALL_STATE(3903)] = 200940,
  [SMALL_STATE(3904)] = 200954,
  [SMALL_STATE(3905)] = 200968,
  [SMALL_STATE(3906)] = 200986,
  [SMALL_STATE(3907)] = 201002,
  [SMALL_STATE(3908)] = 201016,
  [SMALL_STATE(3909)] = 201030,
  [SMALL_STATE(3910)] = 201044,
  [SMALL_STATE(3911)] = 201060,
  [SMALL_STATE(3912)] = 201074,
  [SMALL_STATE(3913)] = 201090,
  [SMALL_STATE(3914)] = 201104,
  [SMALL_STATE(3915)] = 201124,
  [SMALL_STATE(3916)] = 201138,
  [SMALL_STATE(3917)] = 201152,
  [SMALL_STATE(3918)] = 201166,
  [SMALL_STATE(3919)] = 201180,
  [SMALL_STATE(3920)] = 201198,
  [SMALL_STATE(3921)] = 201214,
  [SMALL_STATE(3922)] = 201228,
  [SMALL_STATE(3923)] = 201252,
  [SMALL_STATE(3924)] = 201276,
  [SMALL_STATE(3925)] = 201296,
  [SMALL_STATE(3926)] = 201310,
  [SMALL_STATE(3927)] = 201330,
  [SMALL_STATE(3928)] = 201344,
  [SMALL_STATE(3929)] = 201358,
  [SMALL_STATE(3930)] = 201372,
  [SMALL_STATE(3931)] = 201388,
  [SMALL_STATE(3932)] = 201408,
  [SMALL_STATE(3933)] = 201428,
  [SMALL_STATE(3934)] = 201442,
  [SMALL_STATE(3935)] = 201456,
  [SMALL_STATE(3936)] = 201472,
  [SMALL_STATE(3937)] = 201492,
  [SMALL_STATE(3938)] = 201508,
  [SMALL_STATE(3939)] = 201524,
  [SMALL_STATE(3940)] = 201540,
  [SMALL_STATE(3941)] = 201556,
  [SMALL_STATE(3942)] = 201580,
  [SMALL_STATE(3943)] = 201594,
  [SMALL_STATE(3944)] = 201612,
  [SMALL_STATE(3945)] = 201630,
  [SMALL_STATE(3946)] = 201650,
  [SMALL_STATE(3947)] = 201664,
  [SMALL_STATE(3948)] = 201678,
  [SMALL_STATE(3949)] = 201698,
  [SMALL_STATE(3950)] = 201712,
  [SMALL_STATE(3951)] = 201732,
  [SMALL_STATE(3952)] = 201750,
  [SMALL_STATE(3953)] = 201765,
  [SMALL_STATE(3954)] = 201790,
  [SMALL_STATE(3955)] = 201815,
  [SMALL_STATE(3956)] = 201840,
  [SMALL_STATE(3957)] = 201865,
  [SMALL_STATE(3958)] = 201886,
  [SMALL_STATE(3959)] = 201899,
  [SMALL_STATE(3960)] = 201924,
  [SMALL_STATE(3961)] = 201945,
  [SMALL_STATE(3962)] = 201966,
  [SMALL_STATE(3963)] = 201991,
  [SMALL_STATE(3964)] = 202010,
  [SMALL_STATE(3965)] = 202027,
  [SMALL_STATE(3966)] = 202046,
  [SMALL_STATE(3967)] = 202061,
  [SMALL_STATE(3968)] = 202082,
  [SMALL_STATE(3969)] = 202095,
  [SMALL_STATE(3970)] = 202112,
  [SMALL_STATE(3971)] = 202137,
  [SMALL_STATE(3972)] = 202162,
  [SMALL_STATE(3973)] = 202177,
  [SMALL_STATE(3974)] = 202194,
  [SMALL_STATE(3975)] = 202219,
  [SMALL_STATE(3976)] = 202244,
  [SMALL_STATE(3977)] = 202259,
  [SMALL_STATE(3978)] = 202284,
  [SMALL_STATE(3979)] = 202297,
  [SMALL_STATE(3980)] = 202316,
  [SMALL_STATE(3981)] = 202341,
  [SMALL_STATE(3982)] = 202358,
  [SMALL_STATE(3983)] = 202375,
  [SMALL_STATE(3984)] = 202394,
  [SMALL_STATE(3985)] = 202415,
  [SMALL_STATE(3986)] = 202432,
  [SMALL_STATE(3987)] = 202445,
  [SMALL_STATE(3988)] = 202464,
  [SMALL_STATE(3989)] = 202477,
  [SMALL_STATE(3990)] = 202494,
  [SMALL_STATE(3991)] = 202517,
  [SMALL_STATE(3992)] = 202534,
  [SMALL_STATE(3993)] = 202551,
  [SMALL_STATE(3994)] = 202570,
  [SMALL_STATE(3995)] = 202587,
  [SMALL_STATE(3996)] = 202600,
  [SMALL_STATE(3997)] = 202625,
  [SMALL_STATE(3998)] = 202642,
  [SMALL_STATE(3999)] = 202659,
  [SMALL_STATE(4000)] = 202676,
  [SMALL_STATE(4001)] = 202693,
  [SMALL_STATE(4002)] = 202710,
  [SMALL_STATE(4003)] = 202727,
  [SMALL_STATE(4004)] = 202752,
  [SMALL_STATE(4005)] = 202771,
  [SMALL_STATE(4006)] = 202796,
  [SMALL_STATE(4007)] = 202811,
  [SMALL_STATE(4008)] = 202830,
  [SMALL_STATE(4009)] = 202851,
  [SMALL_STATE(4010)] = 202872,
  [SMALL_STATE(4011)] = 202897,
  [SMALL_STATE(4012)] = 202918,
  [SMALL_STATE(4013)] = 202939,
  [SMALL_STATE(4014)] = 202958,
  [SMALL_STATE(4015)] = 202979,
  [SMALL_STATE(4016)] = 203004,
  [SMALL_STATE(4017)] = 203019,
  [SMALL_STATE(4018)] = 203044,
  [SMALL_STATE(4019)] = 203063,
  [SMALL_STATE(4020)] = 203088,
  [SMALL_STATE(4021)] = 203103,
  [SMALL_STATE(4022)] = 203128,
  [SMALL_STATE(4023)] = 203143,
  [SMALL_STATE(4024)] = 203164,
  [SMALL_STATE(4025)] = 203183,
  [SMALL_STATE(4026)] = 203202,
  [SMALL_STATE(4027)] = 203217,
  [SMALL_STATE(4028)] = 203242,
  [SMALL_STATE(4029)] = 203267,
  [SMALL_STATE(4030)] = 203286,
  [SMALL_STATE(4031)] = 203305,
  [SMALL_STATE(4032)] = 203322,
  [SMALL_STATE(4033)] = 203339,
  [SMALL_STATE(4034)] = 203352,
  [SMALL_STATE(4035)] = 203373,
  [SMALL_STATE(4036)] = 203386,
  [SMALL_STATE(4037)] = 203403,
  [SMALL_STATE(4038)] = 203416,
  [SMALL_STATE(4039)] = 203437,
  [SMALL_STATE(4040)] = 203450,
  [SMALL_STATE(4041)] = 203469,
  [SMALL_STATE(4042)] = 203484,
  [SMALL_STATE(4043)] = 203497,
  [SMALL_STATE(4044)] = 203518,
  [SMALL_STATE(4045)] = 203537,
  [SMALL_STATE(4046)] = 203550,
  [SMALL_STATE(4047)] = 203575,
  [SMALL_STATE(4048)] = 203600,
  [SMALL_STATE(4049)] = 203619,
  [SMALL_STATE(4050)] = 203644,
  [SMALL_STATE(4051)] = 203669,
  [SMALL_STATE(4052)] = 203694,
  [SMALL_STATE(4053)] = 203719,
  [SMALL_STATE(4054)] = 203734,
  [SMALL_STATE(4055)] = 203759,
  [SMALL_STATE(4056)] = 203778,
  [SMALL_STATE(4057)] = 203791,
  [SMALL_STATE(4058)] = 203816,
  [SMALL_STATE(4059)] = 203831,
  [SMALL_STATE(4060)] = 203856,
  [SMALL_STATE(4061)] = 203881,
  [SMALL_STATE(4062)] = 203906,
  [SMALL_STATE(4063)] = 203931,
  [SMALL_STATE(4064)] = 203956,
  [SMALL_STATE(4065)] = 203981,
  [SMALL_STATE(4066)] = 203994,
  [SMALL_STATE(4067)] = 204009,
  [SMALL_STATE(4068)] = 204028,
  [SMALL_STATE(4069)] = 204047,
  [SMALL_STATE(4070)] = 204072,
  [SMALL_STATE(4071)] = 204097,
  [SMALL_STATE(4072)] = 204110,
  [SMALL_STATE(4073)] = 204135,
  [SMALL_STATE(4074)] = 204160,
  [SMALL_STATE(4075)] = 204177,
  [SMALL_STATE(4076)] = 204202,
  [SMALL_STATE(4077)] = 204217,
  [SMALL_STATE(4078)] = 204242,
  [SMALL_STATE(4079)] = 204261,
  [SMALL_STATE(4080)] = 204286,
  [SMALL_STATE(4081)] = 204311,
  [SMALL_STATE(4082)] = 204330,
  [SMALL_STATE(4083)] = 204343,
  [SMALL_STATE(4084)] = 204358,
  [SMALL_STATE(4085)] = 204383,
  [SMALL_STATE(4086)] = 204396,
  [SMALL_STATE(4087)] = 204421,
  [SMALL_STATE(4088)] = 204438,
  [SMALL_STATE(4089)] = 204463,
  [SMALL_STATE(4090)] = 204488,
  [SMALL_STATE(4091)] = 204513,
  [SMALL_STATE(4092)] = 204538,
  [SMALL_STATE(4093)] = 204560,
  [SMALL_STATE(4094)] = 204582,
  [SMALL_STATE(4095)] = 204598,
  [SMALL_STATE(4096)] = 204614,
  [SMALL_STATE(4097)] = 204630,
  [SMALL_STATE(4098)] = 204652,
  [SMALL_STATE(4099)] = 204674,
  [SMALL_STATE(4100)] = 204694,
  [SMALL_STATE(4101)] = 204714,
  [SMALL_STATE(4102)] = 204726,
  [SMALL_STATE(4103)] = 204748,
  [SMALL_STATE(4104)] = 204766,
  [SMALL_STATE(4105)] = 204788,
  [SMALL_STATE(4106)] = 204810,
  [SMALL_STATE(4107)] = 204824,
  [SMALL_STATE(4108)] = 204840,
  [SMALL_STATE(4109)] = 204852,
  [SMALL_STATE(4110)] = 204870,
  [SMALL_STATE(4111)] = 204882,
  [SMALL_STATE(4112)] = 204904,
  [SMALL_STATE(4113)] = 204926,
  [SMALL_STATE(4114)] = 204948,
  [SMALL_STATE(4115)] = 204966,
  [SMALL_STATE(4116)] = 204984,
  [SMALL_STATE(4117)] = 205006,
  [SMALL_STATE(4118)] = 205024,
  [SMALL_STATE(4119)] = 205040,
  [SMALL_STATE(4120)] = 205062,
  [SMALL_STATE(4121)] = 205082,
  [SMALL_STATE(4122)] = 205098,
  [SMALL_STATE(4123)] = 205116,
  [SMALL_STATE(4124)] = 205132,
  [SMALL_STATE(4125)] = 205148,
  [SMALL_STATE(4126)] = 205164,
  [SMALL_STATE(4127)] = 205180,
  [SMALL_STATE(4128)] = 205198,
  [SMALL_STATE(4129)] = 205214,
  [SMALL_STATE(4130)] = 205230,
  [SMALL_STATE(4131)] = 205252,
  [SMALL_STATE(4132)] = 205274,
  [SMALL_STATE(4133)] = 205296,
  [SMALL_STATE(4134)] = 205312,
  [SMALL_STATE(4135)] = 205334,
  [SMALL_STATE(4136)] = 205350,
  [SMALL_STATE(4137)] = 205368,
  [SMALL_STATE(4138)] = 205390,
  [SMALL_STATE(4139)] = 205410,
  [SMALL_STATE(4140)] = 205424,
  [SMALL_STATE(4141)] = 205442,
  [SMALL_STATE(4142)] = 205464,
  [SMALL_STATE(4143)] = 205484,
  [SMALL_STATE(4144)] = 205500,
  [SMALL_STATE(4145)] = 205522,
  [SMALL_STATE(4146)] = 205544,
  [SMALL_STATE(4147)] = 205562,
  [SMALL_STATE(4148)] = 205580,
  [SMALL_STATE(4149)] = 205598,
  [SMALL_STATE(4150)] = 205612,
  [SMALL_STATE(4151)] = 205634,
  [SMALL_STATE(4152)] = 205650,
  [SMALL_STATE(4153)] = 205668,
  [SMALL_STATE(4154)] = 205684,
  [SMALL_STATE(4155)] = 205702,
  [SMALL_STATE(4156)] = 205724,
  [SMALL_STATE(4157)] = 205746,
  [SMALL_STATE(4158)] = 205762,
  [SMALL_STATE(4159)] = 205782,
  [SMALL_STATE(4160)] = 205804,
  [SMALL_STATE(4161)] = 205820,
  [SMALL_STATE(4162)] = 205840,
  [SMALL_STATE(4163)] = 205860,
  [SMALL_STATE(4164)] = 205880,
  [SMALL_STATE(4165)] = 205902,
  [SMALL_STATE(4166)] = 205922,
  [SMALL_STATE(4167)] = 205942,
  [SMALL_STATE(4168)] = 205962,
  [SMALL_STATE(4169)] = 205984,
  [SMALL_STATE(4170)] = 205998,
  [SMALL_STATE(4171)] = 206016,
  [SMALL_STATE(4172)] = 206038,
  [SMALL_STATE(4173)] = 206060,
  [SMALL_STATE(4174)] = 206076,
  [SMALL_STATE(4175)] = 206094,
  [SMALL_STATE(4176)] = 206110,
  [SMALL_STATE(4177)] = 206130,
  [SMALL_STATE(4178)] = 206150,
  [SMALL_STATE(4179)] = 206168,
  [SMALL_STATE(4180)] = 206190,
  [SMALL_STATE(4181)] = 206212,
  [SMALL_STATE(4182)] = 206232,
  [SMALL_STATE(4183)] = 206250,
  [SMALL_STATE(4184)] = 206272,
  [SMALL_STATE(4185)] = 206294,
  [SMALL_STATE(4186)] = 206314,
  [SMALL_STATE(4187)] = 206334,
  [SMALL_STATE(4188)] = 206352,
  [SMALL_STATE(4189)] = 206374,
  [SMALL_STATE(4190)] = 206396,
  [SMALL_STATE(4191)] = 206416,
  [SMALL_STATE(4192)] = 206434,
  [SMALL_STATE(4193)] = 206456,
  [SMALL_STATE(4194)] = 206478,
  [SMALL_STATE(4195)] = 206496,
  [SMALL_STATE(4196)] = 206508,
  [SMALL_STATE(4197)] = 206530,
  [SMALL_STATE(4198)] = 206546,
  [SMALL_STATE(4199)] = 206564,
  [SMALL_STATE(4200)] = 206582,
  [SMALL_STATE(4201)] = 206604,
  [SMALL_STATE(4202)] = 206626,
  [SMALL_STATE(4203)] = 206646,
  [SMALL_STATE(4204)] = 206664,
  [SMALL_STATE(4205)] = 206682,
  [SMALL_STATE(4206)] = 206700,
  [SMALL_STATE(4207)] = 206714,
  [SMALL_STATE(4208)] = 206736,
  [SMALL_STATE(4209)] = 206756,
  [SMALL_STATE(4210)] = 206772,
  [SMALL_STATE(4211)] = 206794,
  [SMALL_STATE(4212)] = 206808,
  [SMALL_STATE(4213)] = 206822,
  [SMALL_STATE(4214)] = 206842,
  [SMALL_STATE(4215)] = 206864,
  [SMALL_STATE(4216)] = 206880,
  [SMALL_STATE(4217)] = 206902,
  [SMALL_STATE(4218)] = 206924,
  [SMALL_STATE(4219)] = 206946,
  [SMALL_STATE(4220)] = 206968,
  [SMALL_STATE(4221)] = 206990,
  [SMALL_STATE(4222)] = 207012,
  [SMALL_STATE(4223)] = 207034,
  [SMALL_STATE(4224)] = 207052,
  [SMALL_STATE(4225)] = 207074,
  [SMALL_STATE(4226)] = 207090,
  [SMALL_STATE(4227)] = 207112,
  [SMALL_STATE(4228)] = 207126,
  [SMALL_STATE(4229)] = 207146,
  [SMALL_STATE(4230)] = 207164,
  [SMALL_STATE(4231)] = 207184,
  [SMALL_STATE(4232)] = 207202,
  [SMALL_STATE(4233)] = 207224,
  [SMALL_STATE(4234)] = 207240,
  [SMALL_STATE(4235)] = 207260,
  [SMALL_STATE(4236)] = 207276,
  [SMALL_STATE(4237)] = 207294,
  [SMALL_STATE(4238)] = 207312,
  [SMALL_STATE(4239)] = 207330,
  [SMALL_STATE(4240)] = 207352,
  [SMALL_STATE(4241)] = 207366,
  [SMALL_STATE(4242)] = 207384,
  [SMALL_STATE(4243)] = 207404,
  [SMALL_STATE(4244)] = 207420,
  [SMALL_STATE(4245)] = 207440,
  [SMALL_STATE(4246)] = 207456,
  [SMALL_STATE(4247)] = 207476,
  [SMALL_STATE(4248)] = 207496,
  [SMALL_STATE(4249)] = 207508,
  [SMALL_STATE(4250)] = 207524,
  [SMALL_STATE(4251)] = 207546,
  [SMALL_STATE(4252)] = 207566,
  [SMALL_STATE(4253)] = 207584,
  [SMALL_STATE(4254)] = 207604,
  [SMALL_STATE(4255)] = 207624,
  [SMALL_STATE(4256)] = 207640,
  [SMALL_STATE(4257)] = 207651,
  [SMALL_STATE(4258)] = 207668,
  [SMALL_STATE(4259)] = 207687,
  [SMALL_STATE(4260)] = 207706,
  [SMALL_STATE(4261)] = 207723,
  [SMALL_STATE(4262)] = 207738,
  [SMALL_STATE(4263)] = 207751,
  [SMALL_STATE(4264)] = 207764,
  [SMALL_STATE(4265)] = 207781,
  [SMALL_STATE(4266)] = 207792,
  [SMALL_STATE(4267)] = 207807,
  [SMALL_STATE(4268)] = 207826,
  [SMALL_STATE(4269)] = 207837,
  [SMALL_STATE(4270)] = 207848,
  [SMALL_STATE(4271)] = 207859,
  [SMALL_STATE(4272)] = 207870,
  [SMALL_STATE(4273)] = 207885,
  [SMALL_STATE(4274)] = 207904,
  [SMALL_STATE(4275)] = 207923,
  [SMALL_STATE(4276)] = 207934,
  [SMALL_STATE(4277)] = 207949,
  [SMALL_STATE(4278)] = 207960,
  [SMALL_STATE(4279)] = 207971,
  [SMALL_STATE(4280)] = 207990,
  [SMALL_STATE(4281)] = 208001,
  [SMALL_STATE(4282)] = 208020,
  [SMALL_STATE(4283)] = 208031,
  [SMALL_STATE(4284)] = 208042,
  [SMALL_STATE(4285)] = 208053,
  [SMALL_STATE(4286)] = 208068,
  [SMALL_STATE(4287)] = 208083,
  [SMALL_STATE(4288)] = 208102,
  [SMALL_STATE(4289)] = 208117,
  [SMALL_STATE(4290)] = 208128,
  [SMALL_STATE(4291)] = 208147,
  [SMALL_STATE(4292)] = 208160,
  [SMALL_STATE(4293)] = 208177,
  [SMALL_STATE(4294)] = 208190,
  [SMALL_STATE(4295)] = 208205,
  [SMALL_STATE(4296)] = 208216,
  [SMALL_STATE(4297)] = 208231,
  [SMALL_STATE(4298)] = 208244,
  [SMALL_STATE(4299)] = 208263,
  [SMALL_STATE(4300)] = 208274,
  [SMALL_STATE(4301)] = 208293,
  [SMALL_STATE(4302)] = 208304,
  [SMALL_STATE(4303)] = 208315,
  [SMALL_STATE(4304)] = 208334,
  [SMALL_STATE(4305)] = 208345,
  [SMALL_STATE(4306)] = 208356,
  [SMALL_STATE(4307)] = 208369,
  [SMALL_STATE(4308)] = 208388,
  [SMALL_STATE(4309)] = 208405,
  [SMALL_STATE(4310)] = 208424,
  [SMALL_STATE(4311)] = 208437,
  [SMALL_STATE(4312)] = 208454,
  [SMALL_STATE(4313)] = 208473,
  [SMALL_STATE(4314)] = 208492,
  [SMALL_STATE(4315)] = 208511,
  [SMALL_STATE(4316)] = 208528,
  [SMALL_STATE(4317)] = 208543,
  [SMALL_STATE(4318)] = 208554,
  [SMALL_STATE(4319)] = 208569,
  [SMALL_STATE(4320)] = 208588,
  [SMALL_STATE(4321)] = 208605,
  [SMALL_STATE(4322)] = 208624,
  [SMALL_STATE(4323)] = 208641,
  [SMALL_STATE(4324)] = 208660,
  [SMALL_STATE(4325)] = 208675,
  [SMALL_STATE(4326)] = 208692,
  [SMALL_STATE(4327)] = 208703,
  [SMALL_STATE(4328)] = 208716,
  [SMALL_STATE(4329)] = 208727,
  [SMALL_STATE(4330)] = 208746,
  [SMALL_STATE(4331)] = 208757,
  [SMALL_STATE(4332)] = 208768,
  [SMALL_STATE(4333)] = 208779,
  [SMALL_STATE(4334)] = 208796,
  [SMALL_STATE(4335)] = 208815,
  [SMALL_STATE(4336)] = 208832,
  [SMALL_STATE(4337)] = 208851,
  [SMALL_STATE(4338)] = 208870,
  [SMALL_STATE(4339)] = 208889,
  [SMALL_STATE(4340)] = 208900,
  [SMALL_STATE(4341)] = 208919,
  [SMALL_STATE(4342)] = 208930,
  [SMALL_STATE(4343)] = 208949,
  [SMALL_STATE(4344)] = 208964,
  [SMALL_STATE(4345)] = 208979,
  [SMALL_STATE(4346)] = 208998,
  [SMALL_STATE(4347)] = 209017,
  [SMALL_STATE(4348)] = 209028,
  [SMALL_STATE(4349)] = 209039,
  [SMALL_STATE(4350)] = 209058,
  [SMALL_STATE(4351)] = 209073,
  [SMALL_STATE(4352)] = 209088,
  [SMALL_STATE(4353)] = 209103,
  [SMALL_STATE(4354)] = 209114,
  [SMALL_STATE(4355)] = 209133,
  [SMALL_STATE(4356)] = 209148,
  [SMALL_STATE(4357)] = 209167,
  [SMALL_STATE(4358)] = 209182,
  [SMALL_STATE(4359)] = 209197,
  [SMALL_STATE(4360)] = 209216,
  [SMALL_STATE(4361)] = 209227,
  [SMALL_STATE(4362)] = 209242,
  [SMALL_STATE(4363)] = 209257,
  [SMALL_STATE(4364)] = 209272,
  [SMALL_STATE(4365)] = 209287,
  [SMALL_STATE(4366)] = 209298,
  [SMALL_STATE(4367)] = 209313,
  [SMALL_STATE(4368)] = 209330,
  [SMALL_STATE(4369)] = 209341,
  [SMALL_STATE(4370)] = 209358,
  [SMALL_STATE(4371)] = 209373,
  [SMALL_STATE(4372)] = 209384,
  [SMALL_STATE(4373)] = 209399,
  [SMALL_STATE(4374)] = 209410,
  [SMALL_STATE(4375)] = 209429,
  [SMALL_STATE(4376)] = 209444,
  [SMALL_STATE(4377)] = 209463,
  [SMALL_STATE(4378)] = 209482,
  [SMALL_STATE(4379)] = 209497,
  [SMALL_STATE(4380)] = 209516,
  [SMALL_STATE(4381)] = 209535,
  [SMALL_STATE(4382)] = 209546,
  [SMALL_STATE(4383)] = 209557,
  [SMALL_STATE(4384)] = 209568,
  [SMALL_STATE(4385)] = 209579,
  [SMALL_STATE(4386)] = 209598,
  [SMALL_STATE(4387)] = 209617,
  [SMALL_STATE(4388)] = 209628,
  [SMALL_STATE(4389)] = 209647,
  [SMALL_STATE(4390)] = 209658,
  [SMALL_STATE(4391)] = 209669,
  [SMALL_STATE(4392)] = 209680,
  [SMALL_STATE(4393)] = 209691,
  [SMALL_STATE(4394)] = 209710,
  [SMALL_STATE(4395)] = 209721,
  [SMALL_STATE(4396)] = 209738,
  [SMALL_STATE(4397)] = 209753,
  [SMALL_STATE(4398)] = 209772,
  [SMALL_STATE(4399)] = 209783,
  [SMALL_STATE(4400)] = 209794,
  [SMALL_STATE(4401)] = 209813,
  [SMALL_STATE(4402)] = 209830,
  [SMALL_STATE(4403)] = 209849,
  [SMALL_STATE(4404)] = 209864,
  [SMALL_STATE(4405)] = 209875,
  [SMALL_STATE(4406)] = 209886,
  [SMALL_STATE(4407)] = 209901,
  [SMALL_STATE(4408)] = 209912,
  [SMALL_STATE(4409)] = 209931,
  [SMALL_STATE(4410)] = 209942,
  [SMALL_STATE(4411)] = 209953,
  [SMALL_STATE(4412)] = 209972,
  [SMALL_STATE(4413)] = 209987,
  [SMALL_STATE(4414)] = 209998,
  [SMALL_STATE(4415)] = 210013,
  [SMALL_STATE(4416)] = 210032,
  [SMALL_STATE(4417)] = 210043,
  [SMALL_STATE(4418)] = 210054,
  [SMALL_STATE(4419)] = 210065,
  [SMALL_STATE(4420)] = 210084,
  [SMALL_STATE(4421)] = 210095,
  [SMALL_STATE(4422)] = 210106,
  [SMALL_STATE(4423)] = 210125,
  [SMALL_STATE(4424)] = 210142,
  [SMALL_STATE(4425)] = 210157,
  [SMALL_STATE(4426)] = 210174,
  [SMALL_STATE(4427)] = 210187,
  [SMALL_STATE(4428)] = 210206,
  [SMALL_STATE(4429)] = 210221,
  [SMALL_STATE(4430)] = 210238,
  [SMALL_STATE(4431)] = 210253,
  [SMALL_STATE(4432)] = 210264,
  [SMALL_STATE(4433)] = 210275,
  [SMALL_STATE(4434)] = 210286,
  [SMALL_STATE(4435)] = 210301,
  [SMALL_STATE(4436)] = 210316,
  [SMALL_STATE(4437)] = 210335,
  [SMALL_STATE(4438)] = 210346,
  [SMALL_STATE(4439)] = 210357,
  [SMALL_STATE(4440)] = 210368,
  [SMALL_STATE(4441)] = 210383,
  [SMALL_STATE(4442)] = 210400,
  [SMALL_STATE(4443)] = 210417,
  [SMALL_STATE(4444)] = 210436,
  [SMALL_STATE(4445)] = 210449,
  [SMALL_STATE(4446)] = 210466,
  [SMALL_STATE(4447)] = 210481,
  [SMALL_STATE(4448)] = 210500,
  [SMALL_STATE(4449)] = 210517,
  [SMALL_STATE(4450)] = 210528,
  [SMALL_STATE(4451)] = 210543,
  [SMALL_STATE(4452)] = 210558,
  [SMALL_STATE(4453)] = 210569,
  [SMALL_STATE(4454)] = 210584,
  [SMALL_STATE(4455)] = 210603,
  [SMALL_STATE(4456)] = 210622,
  [SMALL_STATE(4457)] = 210633,
  [SMALL_STATE(4458)] = 210648,
  [SMALL_STATE(4459)] = 210663,
  [SMALL_STATE(4460)] = 210680,
  [SMALL_STATE(4461)] = 210695,
  [SMALL_STATE(4462)] = 210706,
  [SMALL_STATE(4463)] = 210717,
  [SMALL_STATE(4464)] = 210728,
  [SMALL_STATE(4465)] = 210747,
  [SMALL_STATE(4466)] = 210762,
  [SMALL_STATE(4467)] = 210773,
  [SMALL_STATE(4468)] = 210784,
  [SMALL_STATE(4469)] = 210795,
  [SMALL_STATE(4470)] = 210812,
  [SMALL_STATE(4471)] = 210823,
  [SMALL_STATE(4472)] = 210834,
  [SMALL_STATE(4473)] = 210845,
  [SMALL_STATE(4474)] = 210856,
  [SMALL_STATE(4475)] = 210871,
  [SMALL_STATE(4476)] = 210882,
  [SMALL_STATE(4477)] = 210893,
  [SMALL_STATE(4478)] = 210912,
  [SMALL_STATE(4479)] = 210927,
  [SMALL_STATE(4480)] = 210938,
  [SMALL_STATE(4481)] = 210957,
  [SMALL_STATE(4482)] = 210968,
  [SMALL_STATE(4483)] = 210979,
  [SMALL_STATE(4484)] = 210990,
  [SMALL_STATE(4485)] = 211003,
  [SMALL_STATE(4486)] = 211014,
  [SMALL_STATE(4487)] = 211029,
  [SMALL_STATE(4488)] = 211044,
  [SMALL_STATE(4489)] = 211055,
  [SMALL_STATE(4490)] = 211070,
  [SMALL_STATE(4491)] = 211081,
  [SMALL_STATE(4492)] = 211096,
  [SMALL_STATE(4493)] = 211113,
  [SMALL_STATE(4494)] = 211132,
  [SMALL_STATE(4495)] = 211147,
  [SMALL_STATE(4496)] = 211158,
  [SMALL_STATE(4497)] = 211169,
  [SMALL_STATE(4498)] = 211180,
  [SMALL_STATE(4499)] = 211195,
  [SMALL_STATE(4500)] = 211206,
  [SMALL_STATE(4501)] = 211217,
  [SMALL_STATE(4502)] = 211228,
  [SMALL_STATE(4503)] = 211239,
  [SMALL_STATE(4504)] = 211254,
  [SMALL_STATE(4505)] = 211273,
  [SMALL_STATE(4506)] = 211288,
  [SMALL_STATE(4507)] = 211307,
  [SMALL_STATE(4508)] = 211326,
  [SMALL_STATE(4509)] = 211345,
  [SMALL_STATE(4510)] = 211362,
  [SMALL_STATE(4511)] = 211377,
  [SMALL_STATE(4512)] = 211396,
  [SMALL_STATE(4513)] = 211411,
  [SMALL_STATE(4514)] = 211426,
  [SMALL_STATE(4515)] = 211445,
  [SMALL_STATE(4516)] = 211460,
  [SMALL_STATE(4517)] = 211477,
  [SMALL_STATE(4518)] = 211492,
  [SMALL_STATE(4519)] = 211503,
  [SMALL_STATE(4520)] = 211518,
  [SMALL_STATE(4521)] = 211535,
  [SMALL_STATE(4522)] = 211550,
  [SMALL_STATE(4523)] = 211569,
  [SMALL_STATE(4524)] = 211580,
  [SMALL_STATE(4525)] = 211591,
  [SMALL_STATE(4526)] = 211601,
  [SMALL_STATE(4527)] = 211611,
  [SMALL_STATE(4528)] = 211627,
  [SMALL_STATE(4529)] = 211643,
  [SMALL_STATE(4530)] = 211659,
  [SMALL_STATE(4531)] = 211673,
  [SMALL_STATE(4532)] = 211689,
  [SMALL_STATE(4533)] = 211703,
  [SMALL_STATE(4534)] = 211717,
  [SMALL_STATE(4535)] = 211733,
  [SMALL_STATE(4536)] = 211749,
  [SMALL_STATE(4537)] = 211765,
  [SMALL_STATE(4538)] = 211781,
  [SMALL_STATE(4539)] = 211797,
  [SMALL_STATE(4540)] = 211813,
  [SMALL_STATE(4541)] = 211829,
  [SMALL_STATE(4542)] = 211845,
  [SMALL_STATE(4543)] = 211859,
  [SMALL_STATE(4544)] = 211875,
  [SMALL_STATE(4545)] = 211891,
  [SMALL_STATE(4546)] = 211907,
  [SMALL_STATE(4547)] = 211923,
  [SMALL_STATE(4548)] = 211939,
  [SMALL_STATE(4549)] = 211955,
  [SMALL_STATE(4550)] = 211971,
  [SMALL_STATE(4551)] = 211987,
  [SMALL_STATE(4552)] = 212003,
  [SMALL_STATE(4553)] = 212019,
  [SMALL_STATE(4554)] = 212033,
  [SMALL_STATE(4555)] = 212049,
  [SMALL_STATE(4556)] = 212059,
  [SMALL_STATE(4557)] = 212075,
  [SMALL_STATE(4558)] = 212091,
  [SMALL_STATE(4559)] = 212107,
  [SMALL_STATE(4560)] = 212123,
  [SMALL_STATE(4561)] = 212139,
  [SMALL_STATE(4562)] = 212153,
  [SMALL_STATE(4563)] = 212169,
  [SMALL_STATE(4564)] = 212183,
  [SMALL_STATE(4565)] = 212197,
  [SMALL_STATE(4566)] = 212213,
  [SMALL_STATE(4567)] = 212229,
  [SMALL_STATE(4568)] = 212245,
  [SMALL_STATE(4569)] = 212261,
  [SMALL_STATE(4570)] = 212277,
  [SMALL_STATE(4571)] = 212291,
  [SMALL_STATE(4572)] = 212307,
  [SMALL_STATE(4573)] = 212323,
  [SMALL_STATE(4574)] = 212339,
  [SMALL_STATE(4575)] = 212353,
  [SMALL_STATE(4576)] = 212369,
  [SMALL_STATE(4577)] = 212383,
  [SMALL_STATE(4578)] = 212399,
  [SMALL_STATE(4579)] = 212413,
  [SMALL_STATE(4580)] = 212429,
  [SMALL_STATE(4581)] = 212443,
  [SMALL_STATE(4582)] = 212457,
  [SMALL_STATE(4583)] = 212473,
  [SMALL_STATE(4584)] = 212489,
  [SMALL_STATE(4585)] = 212505,
  [SMALL_STATE(4586)] = 212521,
  [SMALL_STATE(4587)] = 212535,
  [SMALL_STATE(4588)] = 212551,
  [SMALL_STATE(4589)] = 212565,
  [SMALL_STATE(4590)] = 212579,
  [SMALL_STATE(4591)] = 212593,
  [SMALL_STATE(4592)] = 212609,
  [SMALL_STATE(4593)] = 212625,
  [SMALL_STATE(4594)] = 212639,
  [SMALL_STATE(4595)] = 212655,
  [SMALL_STATE(4596)] = 212671,
  [SMALL_STATE(4597)] = 212687,
  [SMALL_STATE(4598)] = 212701,
  [SMALL_STATE(4599)] = 212717,
  [SMALL_STATE(4600)] = 212733,
  [SMALL_STATE(4601)] = 212749,
  [SMALL_STATE(4602)] = 212763,
  [SMALL_STATE(4603)] = 212779,
  [SMALL_STATE(4604)] = 212795,
  [SMALL_STATE(4605)] = 212809,
  [SMALL_STATE(4606)] = 212825,
  [SMALL_STATE(4607)] = 212841,
  [SMALL_STATE(4608)] = 212857,
  [SMALL_STATE(4609)] = 212873,
  [SMALL_STATE(4610)] = 212889,
  [SMALL_STATE(4611)] = 212905,
  [SMALL_STATE(4612)] = 212919,
  [SMALL_STATE(4613)] = 212933,
  [SMALL_STATE(4614)] = 212949,
  [SMALL_STATE(4615)] = 212963,
  [SMALL_STATE(4616)] = 212979,
  [SMALL_STATE(4617)] = 212993,
  [SMALL_STATE(4618)] = 213007,
  [SMALL_STATE(4619)] = 213021,
  [SMALL_STATE(4620)] = 213037,
  [SMALL_STATE(4621)] = 213051,
  [SMALL_STATE(4622)] = 213067,
  [SMALL_STATE(4623)] = 213083,
  [SMALL_STATE(4624)] = 213099,
  [SMALL_STATE(4625)] = 213109,
  [SMALL_STATE(4626)] = 213119,
  [SMALL_STATE(4627)] = 213135,
  [SMALL_STATE(4628)] = 213149,
  [SMALL_STATE(4629)] = 213165,
  [SMALL_STATE(4630)] = 213179,
  [SMALL_STATE(4631)] = 213193,
  [SMALL_STATE(4632)] = 213207,
  [SMALL_STATE(4633)] = 213221,
  [SMALL_STATE(4634)] = 213235,
  [SMALL_STATE(4635)] = 213249,
  [SMALL_STATE(4636)] = 213263,
  [SMALL_STATE(4637)] = 213279,
  [SMALL_STATE(4638)] = 213293,
  [SMALL_STATE(4639)] = 213309,
  [SMALL_STATE(4640)] = 213325,
  [SMALL_STATE(4641)] = 213339,
  [SMALL_STATE(4642)] = 213353,
  [SMALL_STATE(4643)] = 213367,
  [SMALL_STATE(4644)] = 213383,
  [SMALL_STATE(4645)] = 213397,
  [SMALL_STATE(4646)] = 213411,
  [SMALL_STATE(4647)] = 213427,
  [SMALL_STATE(4648)] = 213443,
  [SMALL_STATE(4649)] = 213459,
  [SMALL_STATE(4650)] = 213475,
  [SMALL_STATE(4651)] = 213491,
  [SMALL_STATE(4652)] = 213507,
  [SMALL_STATE(4653)] = 213523,
  [SMALL_STATE(4654)] = 213539,
  [SMALL_STATE(4655)] = 213553,
  [SMALL_STATE(4656)] = 213569,
  [SMALL_STATE(4657)] = 213585,
  [SMALL_STATE(4658)] = 213599,
  [SMALL_STATE(4659)] = 213615,
  [SMALL_STATE(4660)] = 213631,
  [SMALL_STATE(4661)] = 213647,
  [SMALL_STATE(4662)] = 213663,
  [SMALL_STATE(4663)] = 213679,
  [SMALL_STATE(4664)] = 213691,
  [SMALL_STATE(4665)] = 213707,
  [SMALL_STATE(4666)] = 213723,
  [SMALL_STATE(4667)] = 213739,
  [SMALL_STATE(4668)] = 213755,
  [SMALL_STATE(4669)] = 213771,
  [SMALL_STATE(4670)] = 213783,
  [SMALL_STATE(4671)] = 213799,
  [SMALL_STATE(4672)] = 213815,
  [SMALL_STATE(4673)] = 213831,
  [SMALL_STATE(4674)] = 213847,
  [SMALL_STATE(4675)] = 213861,
  [SMALL_STATE(4676)] = 213875,
  [SMALL_STATE(4677)] = 213885,
  [SMALL_STATE(4678)] = 213901,
  [SMALL_STATE(4679)] = 213915,
  [SMALL_STATE(4680)] = 213929,
  [SMALL_STATE(4681)] = 213945,
  [SMALL_STATE(4682)] = 213959,
  [SMALL_STATE(4683)] = 213973,
  [SMALL_STATE(4684)] = 213987,
  [SMALL_STATE(4685)] = 214001,
  [SMALL_STATE(4686)] = 214011,
  [SMALL_STATE(4687)] = 214025,
  [SMALL_STATE(4688)] = 214039,
  [SMALL_STATE(4689)] = 214053,
  [SMALL_STATE(4690)] = 214069,
  [SMALL_STATE(4691)] = 214085,
  [SMALL_STATE(4692)] = 214101,
  [SMALL_STATE(4693)] = 214117,
  [SMALL_STATE(4694)] = 214131,
  [SMALL_STATE(4695)] = 214145,
  [SMALL_STATE(4696)] = 214159,
  [SMALL_STATE(4697)] = 214175,
  [SMALL_STATE(4698)] = 214191,
  [SMALL_STATE(4699)] = 214207,
  [SMALL_STATE(4700)] = 214223,
  [SMALL_STATE(4701)] = 214237,
  [SMALL_STATE(4702)] = 214253,
  [SMALL_STATE(4703)] = 214267,
  [SMALL_STATE(4704)] = 214283,
  [SMALL_STATE(4705)] = 214299,
  [SMALL_STATE(4706)] = 214313,
  [SMALL_STATE(4707)] = 214329,
  [SMALL_STATE(4708)] = 214345,
  [SMALL_STATE(4709)] = 214358,
  [SMALL_STATE(4710)] = 214369,
  [SMALL_STATE(4711)] = 214382,
  [SMALL_STATE(4712)] = 214395,
  [SMALL_STATE(4713)] = 214408,
  [SMALL_STATE(4714)] = 214421,
  [SMALL_STATE(4715)] = 214434,
  [SMALL_STATE(4716)] = 214447,
  [SMALL_STATE(4717)] = 214458,
  [SMALL_STATE(4718)] = 214467,
  [SMALL_STATE(4719)] = 214480,
  [SMALL_STATE(4720)] = 214493,
  [SMALL_STATE(4721)] = 214506,
  [SMALL_STATE(4722)] = 214519,
  [SMALL_STATE(4723)] = 214532,
  [SMALL_STATE(4724)] = 214543,
  [SMALL_STATE(4725)] = 214556,
  [SMALL_STATE(4726)] = 214565,
  [SMALL_STATE(4727)] = 214576,
  [SMALL_STATE(4728)] = 214585,
  [SMALL_STATE(4729)] = 214596,
  [SMALL_STATE(4730)] = 214609,
  [SMALL_STATE(4731)] = 214622,
  [SMALL_STATE(4732)] = 214631,
  [SMALL_STATE(4733)] = 214642,
  [SMALL_STATE(4734)] = 214655,
  [SMALL_STATE(4735)] = 214668,
  [SMALL_STATE(4736)] = 214681,
  [SMALL_STATE(4737)] = 214694,
  [SMALL_STATE(4738)] = 214707,
  [SMALL_STATE(4739)] = 214720,
  [SMALL_STATE(4740)] = 214731,
  [SMALL_STATE(4741)] = 214740,
  [SMALL_STATE(4742)] = 214753,
  [SMALL_STATE(4743)] = 214766,
  [SMALL_STATE(4744)] = 214777,
  [SMALL_STATE(4745)] = 214790,
  [SMALL_STATE(4746)] = 214803,
  [SMALL_STATE(4747)] = 214816,
  [SMALL_STATE(4748)] = 214829,
  [SMALL_STATE(4749)] = 214842,
  [SMALL_STATE(4750)] = 214855,
  [SMALL_STATE(4751)] = 214864,
  [SMALL_STATE(4752)] = 214877,
  [SMALL_STATE(4753)] = 214890,
  [SMALL_STATE(4754)] = 214901,
  [SMALL_STATE(4755)] = 214914,
  [SMALL_STATE(4756)] = 214927,
  [SMALL_STATE(4757)] = 214940,
  [SMALL_STATE(4758)] = 214953,
  [SMALL_STATE(4759)] = 214966,
  [SMALL_STATE(4760)] = 214979,
  [SMALL_STATE(4761)] = 214992,
  [SMALL_STATE(4762)] = 215005,
  [SMALL_STATE(4763)] = 215018,
  [SMALL_STATE(4764)] = 215031,
  [SMALL_STATE(4765)] = 215044,
  [SMALL_STATE(4766)] = 215057,
  [SMALL_STATE(4767)] = 215068,
  [SMALL_STATE(4768)] = 215079,
  [SMALL_STATE(4769)] = 215090,
  [SMALL_STATE(4770)] = 215099,
  [SMALL_STATE(4771)] = 215108,
  [SMALL_STATE(4772)] = 215121,
  [SMALL_STATE(4773)] = 215134,
  [SMALL_STATE(4774)] = 215143,
  [SMALL_STATE(4775)] = 215156,
  [SMALL_STATE(4776)] = 215165,
  [SMALL_STATE(4777)] = 215178,
  [SMALL_STATE(4778)] = 215191,
  [SMALL_STATE(4779)] = 215204,
  [SMALL_STATE(4780)] = 215217,
  [SMALL_STATE(4781)] = 215228,
  [SMALL_STATE(4782)] = 215241,
  [SMALL_STATE(4783)] = 215254,
  [SMALL_STATE(4784)] = 215267,
  [SMALL_STATE(4785)] = 215276,
  [SMALL_STATE(4786)] = 215289,
  [SMALL_STATE(4787)] = 215302,
  [SMALL_STATE(4788)] = 215315,
  [SMALL_STATE(4789)] = 215328,
  [SMALL_STATE(4790)] = 215341,
  [SMALL_STATE(4791)] = 215350,
  [SMALL_STATE(4792)] = 215363,
  [SMALL_STATE(4793)] = 215372,
  [SMALL_STATE(4794)] = 215383,
  [SMALL_STATE(4795)] = 215396,
  [SMALL_STATE(4796)] = 215409,
  [SMALL_STATE(4797)] = 215418,
  [SMALL_STATE(4798)] = 215431,
  [SMALL_STATE(4799)] = 215444,
  [SMALL_STATE(4800)] = 215457,
  [SMALL_STATE(4801)] = 215470,
  [SMALL_STATE(4802)] = 215481,
  [SMALL_STATE(4803)] = 215494,
  [SMALL_STATE(4804)] = 215503,
  [SMALL_STATE(4805)] = 215514,
  [SMALL_STATE(4806)] = 215527,
  [SMALL_STATE(4807)] = 215538,
  [SMALL_STATE(4808)] = 215547,
  [SMALL_STATE(4809)] = 215560,
  [SMALL_STATE(4810)] = 215573,
  [SMALL_STATE(4811)] = 215582,
  [SMALL_STATE(4812)] = 215591,
  [SMALL_STATE(4813)] = 215600,
  [SMALL_STATE(4814)] = 215613,
  [SMALL_STATE(4815)] = 215626,
  [SMALL_STATE(4816)] = 215639,
  [SMALL_STATE(4817)] = 215652,
  [SMALL_STATE(4818)] = 215665,
  [SMALL_STATE(4819)] = 215678,
  [SMALL_STATE(4820)] = 215691,
  [SMALL_STATE(4821)] = 215704,
  [SMALL_STATE(4822)] = 215717,
  [SMALL_STATE(4823)] = 215730,
  [SMALL_STATE(4824)] = 215741,
  [SMALL_STATE(4825)] = 215754,
  [SMALL_STATE(4826)] = 215767,
  [SMALL_STATE(4827)] = 215778,
  [SMALL_STATE(4828)] = 215791,
  [SMALL_STATE(4829)] = 215804,
  [SMALL_STATE(4830)] = 215817,
  [SMALL_STATE(4831)] = 215830,
  [SMALL_STATE(4832)] = 215843,
  [SMALL_STATE(4833)] = 215856,
  [SMALL_STATE(4834)] = 215865,
  [SMALL_STATE(4835)] = 215874,
  [SMALL_STATE(4836)] = 215887,
  [SMALL_STATE(4837)] = 215900,
  [SMALL_STATE(4838)] = 215913,
  [SMALL_STATE(4839)] = 215926,
  [SMALL_STATE(4840)] = 215935,
  [SMALL_STATE(4841)] = 215948,
  [SMALL_STATE(4842)] = 215961,
  [SMALL_STATE(4843)] = 215970,
  [SMALL_STATE(4844)] = 215979,
  [SMALL_STATE(4845)] = 215992,
  [SMALL_STATE(4846)] = 216005,
  [SMALL_STATE(4847)] = 216014,
  [SMALL_STATE(4848)] = 216027,
  [SMALL_STATE(4849)] = 216040,
  [SMALL_STATE(4850)] = 216049,
  [SMALL_STATE(4851)] = 216062,
  [SMALL_STATE(4852)] = 216075,
  [SMALL_STATE(4853)] = 216088,
  [SMALL_STATE(4854)] = 216097,
  [SMALL_STATE(4855)] = 216108,
  [SMALL_STATE(4856)] = 216121,
  [SMALL_STATE(4857)] = 216130,
  [SMALL_STATE(4858)] = 216143,
  [SMALL_STATE(4859)] = 216156,
  [SMALL_STATE(4860)] = 216165,
  [SMALL_STATE(4861)] = 216178,
  [SMALL_STATE(4862)] = 216191,
  [SMALL_STATE(4863)] = 216202,
  [SMALL_STATE(4864)] = 216215,
  [SMALL_STATE(4865)] = 216228,
  [SMALL_STATE(4866)] = 216241,
  [SMALL_STATE(4867)] = 216254,
  [SMALL_STATE(4868)] = 216263,
  [SMALL_STATE(4869)] = 216276,
  [SMALL_STATE(4870)] = 216287,
  [SMALL_STATE(4871)] = 216296,
  [SMALL_STATE(4872)] = 216305,
  [SMALL_STATE(4873)] = 216318,
  [SMALL_STATE(4874)] = 216331,
  [SMALL_STATE(4875)] = 216344,
  [SMALL_STATE(4876)] = 216355,
  [SMALL_STATE(4877)] = 216368,
  [SMALL_STATE(4878)] = 216377,
  [SMALL_STATE(4879)] = 216390,
  [SMALL_STATE(4880)] = 216403,
  [SMALL_STATE(4881)] = 216416,
  [SMALL_STATE(4882)] = 216429,
  [SMALL_STATE(4883)] = 216438,
  [SMALL_STATE(4884)] = 216447,
  [SMALL_STATE(4885)] = 216460,
  [SMALL_STATE(4886)] = 216473,
  [SMALL_STATE(4887)] = 216484,
  [SMALL_STATE(4888)] = 216497,
  [SMALL_STATE(4889)] = 216510,
  [SMALL_STATE(4890)] = 216523,
  [SMALL_STATE(4891)] = 216536,
  [SMALL_STATE(4892)] = 216545,
  [SMALL_STATE(4893)] = 216558,
  [SMALL_STATE(4894)] = 216571,
  [SMALL_STATE(4895)] = 216580,
  [SMALL_STATE(4896)] = 216593,
  [SMALL_STATE(4897)] = 216606,
  [SMALL_STATE(4898)] = 216619,
  [SMALL_STATE(4899)] = 216632,
  [SMALL_STATE(4900)] = 216645,
  [SMALL_STATE(4901)] = 216658,
  [SMALL_STATE(4902)] = 216671,
  [SMALL_STATE(4903)] = 216684,
  [SMALL_STATE(4904)] = 216697,
  [SMALL_STATE(4905)] = 216710,
  [SMALL_STATE(4906)] = 216723,
  [SMALL_STATE(4907)] = 216736,
  [SMALL_STATE(4908)] = 216749,
  [SMALL_STATE(4909)] = 216762,
  [SMALL_STATE(4910)] = 216771,
  [SMALL_STATE(4911)] = 216784,
  [SMALL_STATE(4912)] = 216797,
  [SMALL_STATE(4913)] = 216806,
  [SMALL_STATE(4914)] = 216819,
  [SMALL_STATE(4915)] = 216828,
  [SMALL_STATE(4916)] = 216841,
  [SMALL_STATE(4917)] = 216854,
  [SMALL_STATE(4918)] = 216867,
  [SMALL_STATE(4919)] = 216880,
  [SMALL_STATE(4920)] = 216893,
  [SMALL_STATE(4921)] = 216906,
  [SMALL_STATE(4922)] = 216919,
  [SMALL_STATE(4923)] = 216932,
  [SMALL_STATE(4924)] = 216945,
  [SMALL_STATE(4925)] = 216954,
  [SMALL_STATE(4926)] = 216967,
  [SMALL_STATE(4927)] = 216980,
  [SMALL_STATE(4928)] = 216991,
  [SMALL_STATE(4929)] = 217004,
  [SMALL_STATE(4930)] = 217017,
  [SMALL_STATE(4931)] = 217027,
  [SMALL_STATE(4932)] = 217037,
  [SMALL_STATE(4933)] = 217047,
  [SMALL_STATE(4934)] = 217057,
  [SMALL_STATE(4935)] = 217067,
  [SMALL_STATE(4936)] = 217077,
  [SMALL_STATE(4937)] = 217087,
  [SMALL_STATE(4938)] = 217097,
  [SMALL_STATE(4939)] = 217107,
  [SMALL_STATE(4940)] = 217117,
  [SMALL_STATE(4941)] = 217127,
  [SMALL_STATE(4942)] = 217137,
  [SMALL_STATE(4943)] = 217147,
  [SMALL_STATE(4944)] = 217157,
  [SMALL_STATE(4945)] = 217167,
  [SMALL_STATE(4946)] = 217177,
  [SMALL_STATE(4947)] = 217187,
  [SMALL_STATE(4948)] = 217197,
  [SMALL_STATE(4949)] = 217207,
  [SMALL_STATE(4950)] = 217217,
  [SMALL_STATE(4951)] = 217227,
  [SMALL_STATE(4952)] = 217237,
  [SMALL_STATE(4953)] = 217247,
  [SMALL_STATE(4954)] = 217255,
  [SMALL_STATE(4955)] = 217265,
  [SMALL_STATE(4956)] = 217275,
  [SMALL_STATE(4957)] = 217285,
  [SMALL_STATE(4958)] = 217295,
  [SMALL_STATE(4959)] = 217305,
  [SMALL_STATE(4960)] = 217313,
  [SMALL_STATE(4961)] = 217323,
  [SMALL_STATE(4962)] = 217333,
  [SMALL_STATE(4963)] = 217343,
  [SMALL_STATE(4964)] = 217353,
  [SMALL_STATE(4965)] = 217361,
  [SMALL_STATE(4966)] = 217371,
  [SMALL_STATE(4967)] = 217379,
  [SMALL_STATE(4968)] = 217387,
  [SMALL_STATE(4969)] = 217397,
  [SMALL_STATE(4970)] = 217407,
  [SMALL_STATE(4971)] = 217417,
  [SMALL_STATE(4972)] = 217427,
  [SMALL_STATE(4973)] = 217437,
  [SMALL_STATE(4974)] = 217447,
  [SMALL_STATE(4975)] = 217455,
  [SMALL_STATE(4976)] = 217465,
  [SMALL_STATE(4977)] = 217473,
  [SMALL_STATE(4978)] = 217483,
  [SMALL_STATE(4979)] = 217493,
  [SMALL_STATE(4980)] = 217503,
  [SMALL_STATE(4981)] = 217513,
  [SMALL_STATE(4982)] = 217523,
  [SMALL_STATE(4983)] = 217533,
  [SMALL_STATE(4984)] = 217543,
  [SMALL_STATE(4985)] = 217553,
  [SMALL_STATE(4986)] = 217563,
  [SMALL_STATE(4987)] = 217573,
  [SMALL_STATE(4988)] = 217583,
  [SMALL_STATE(4989)] = 217593,
  [SMALL_STATE(4990)] = 217603,
  [SMALL_STATE(4991)] = 217613,
  [SMALL_STATE(4992)] = 217621,
  [SMALL_STATE(4993)] = 217631,
  [SMALL_STATE(4994)] = 217641,
  [SMALL_STATE(4995)] = 217651,
  [SMALL_STATE(4996)] = 217661,
  [SMALL_STATE(4997)] = 217671,
  [SMALL_STATE(4998)] = 217681,
  [SMALL_STATE(4999)] = 217689,
  [SMALL_STATE(5000)] = 217699,
  [SMALL_STATE(5001)] = 217709,
  [SMALL_STATE(5002)] = 217719,
  [SMALL_STATE(5003)] = 217729,
  [SMALL_STATE(5004)] = 217739,
  [SMALL_STATE(5005)] = 217747,
  [SMALL_STATE(5006)] = 217755,
  [SMALL_STATE(5007)] = 217765,
  [SMALL_STATE(5008)] = 217775,
  [SMALL_STATE(5009)] = 217785,
  [SMALL_STATE(5010)] = 217793,
  [SMALL_STATE(5011)] = 217803,
  [SMALL_STATE(5012)] = 217813,
  [SMALL_STATE(5013)] = 217823,
  [SMALL_STATE(5014)] = 217833,
  [SMALL_STATE(5015)] = 217843,
  [SMALL_STATE(5016)] = 217853,
  [SMALL_STATE(5017)] = 217863,
  [SMALL_STATE(5018)] = 217873,
  [SMALL_STATE(5019)] = 217883,
  [SMALL_STATE(5020)] = 217893,
  [SMALL_STATE(5021)] = 217903,
  [SMALL_STATE(5022)] = 217911,
  [SMALL_STATE(5023)] = 217921,
  [SMALL_STATE(5024)] = 217929,
  [SMALL_STATE(5025)] = 217939,
  [SMALL_STATE(5026)] = 217949,
  [SMALL_STATE(5027)] = 217957,
  [SMALL_STATE(5028)] = 217967,
  [SMALL_STATE(5029)] = 217977,
  [SMALL_STATE(5030)] = 217987,
  [SMALL_STATE(5031)] = 217997,
  [SMALL_STATE(5032)] = 218007,
  [SMALL_STATE(5033)] = 218017,
  [SMALL_STATE(5034)] = 218027,
  [SMALL_STATE(5035)] = 218037,
  [SMALL_STATE(5036)] = 218047,
  [SMALL_STATE(5037)] = 218057,
  [SMALL_STATE(5038)] = 218065,
  [SMALL_STATE(5039)] = 218075,
  [SMALL_STATE(5040)] = 218085,
  [SMALL_STATE(5041)] = 218093,
  [SMALL_STATE(5042)] = 218103,
  [SMALL_STATE(5043)] = 218113,
  [SMALL_STATE(5044)] = 218123,
  [SMALL_STATE(5045)] = 218133,
  [SMALL_STATE(5046)] = 218143,
  [SMALL_STATE(5047)] = 218153,
  [SMALL_STATE(5048)] = 218161,
  [SMALL_STATE(5049)] = 218171,
  [SMALL_STATE(5050)] = 218181,
  [SMALL_STATE(5051)] = 218191,
  [SMALL_STATE(5052)] = 218201,
  [SMALL_STATE(5053)] = 218209,
  [SMALL_STATE(5054)] = 218219,
  [SMALL_STATE(5055)] = 218229,
  [SMALL_STATE(5056)] = 218239,
  [SMALL_STATE(5057)] = 218249,
  [SMALL_STATE(5058)] = 218257,
  [SMALL_STATE(5059)] = 218267,
  [SMALL_STATE(5060)] = 218277,
  [SMALL_STATE(5061)] = 218287,
  [SMALL_STATE(5062)] = 218297,
  [SMALL_STATE(5063)] = 218307,
  [SMALL_STATE(5064)] = 218315,
  [SMALL_STATE(5065)] = 218325,
  [SMALL_STATE(5066)] = 218333,
  [SMALL_STATE(5067)] = 218343,
  [SMALL_STATE(5068)] = 218353,
  [SMALL_STATE(5069)] = 218363,
  [SMALL_STATE(5070)] = 218373,
  [SMALL_STATE(5071)] = 218383,
  [SMALL_STATE(5072)] = 218393,
  [SMALL_STATE(5073)] = 218403,
  [SMALL_STATE(5074)] = 218413,
  [SMALL_STATE(5075)] = 218423,
  [SMALL_STATE(5076)] = 218433,
  [SMALL_STATE(5077)] = 218443,
  [SMALL_STATE(5078)] = 218451,
  [SMALL_STATE(5079)] = 218461,
  [SMALL_STATE(5080)] = 218471,
  [SMALL_STATE(5081)] = 218481,
  [SMALL_STATE(5082)] = 218491,
  [SMALL_STATE(5083)] = 218499,
  [SMALL_STATE(5084)] = 218509,
  [SMALL_STATE(5085)] = 218519,
  [SMALL_STATE(5086)] = 218527,
  [SMALL_STATE(5087)] = 218537,
  [SMALL_STATE(5088)] = 218547,
  [SMALL_STATE(5089)] = 218557,
  [SMALL_STATE(5090)] = 218565,
  [SMALL_STATE(5091)] = 218575,
  [SMALL_STATE(5092)] = 218585,
  [SMALL_STATE(5093)] = 218593,
  [SMALL_STATE(5094)] = 218601,
  [SMALL_STATE(5095)] = 218611,
  [SMALL_STATE(5096)] = 218619,
  [SMALL_STATE(5097)] = 218629,
  [SMALL_STATE(5098)] = 218637,
  [SMALL_STATE(5099)] = 218647,
  [SMALL_STATE(5100)] = 218657,
  [SMALL_STATE(5101)] = 218667,
  [SMALL_STATE(5102)] = 218677,
  [SMALL_STATE(5103)] = 218685,
  [SMALL_STATE(5104)] = 218695,
  [SMALL_STATE(5105)] = 218705,
  [SMALL_STATE(5106)] = 218715,
  [SMALL_STATE(5107)] = 218725,
  [SMALL_STATE(5108)] = 218735,
  [SMALL_STATE(5109)] = 218745,
  [SMALL_STATE(5110)] = 218755,
  [SMALL_STATE(5111)] = 218765,
  [SMALL_STATE(5112)] = 218775,
  [SMALL_STATE(5113)] = 218783,
  [SMALL_STATE(5114)] = 218793,
  [SMALL_STATE(5115)] = 218803,
  [SMALL_STATE(5116)] = 218811,
  [SMALL_STATE(5117)] = 218821,
  [SMALL_STATE(5118)] = 218831,
  [SMALL_STATE(5119)] = 218839,
  [SMALL_STATE(5120)] = 218847,
  [SMALL_STATE(5121)] = 218855,
  [SMALL_STATE(5122)] = 218865,
  [SMALL_STATE(5123)] = 218875,
  [SMALL_STATE(5124)] = 218885,
  [SMALL_STATE(5125)] = 218893,
  [SMALL_STATE(5126)] = 218903,
  [SMALL_STATE(5127)] = 218911,
  [SMALL_STATE(5128)] = 218921,
  [SMALL_STATE(5129)] = 218931,
  [SMALL_STATE(5130)] = 218941,
  [SMALL_STATE(5131)] = 218949,
  [SMALL_STATE(5132)] = 218959,
  [SMALL_STATE(5133)] = 218967,
  [SMALL_STATE(5134)] = 218977,
  [SMALL_STATE(5135)] = 218985,
  [SMALL_STATE(5136)] = 218995,
  [SMALL_STATE(5137)] = 219005,
  [SMALL_STATE(5138)] = 219015,
  [SMALL_STATE(5139)] = 219023,
  [SMALL_STATE(5140)] = 219033,
  [SMALL_STATE(5141)] = 219041,
  [SMALL_STATE(5142)] = 219051,
  [SMALL_STATE(5143)] = 219059,
  [SMALL_STATE(5144)] = 219069,
  [SMALL_STATE(5145)] = 219079,
  [SMALL_STATE(5146)] = 219089,
  [SMALL_STATE(5147)] = 219099,
  [SMALL_STATE(5148)] = 219109,
  [SMALL_STATE(5149)] = 219117,
  [SMALL_STATE(5150)] = 219127,
  [SMALL_STATE(5151)] = 219137,
  [SMALL_STATE(5152)] = 219147,
  [SMALL_STATE(5153)] = 219157,
  [SMALL_STATE(5154)] = 219167,
  [SMALL_STATE(5155)] = 219177,
  [SMALL_STATE(5156)] = 219187,
  [SMALL_STATE(5157)] = 219197,
  [SMALL_STATE(5158)] = 219207,
  [SMALL_STATE(5159)] = 219217,
  [SMALL_STATE(5160)] = 219227,
  [SMALL_STATE(5161)] = 219237,
  [SMALL_STATE(5162)] = 219247,
  [SMALL_STATE(5163)] = 219257,
  [SMALL_STATE(5164)] = 219267,
  [SMALL_STATE(5165)] = 219277,
  [SMALL_STATE(5166)] = 219287,
  [SMALL_STATE(5167)] = 219297,
  [SMALL_STATE(5168)] = 219307,
  [SMALL_STATE(5169)] = 219317,
  [SMALL_STATE(5170)] = 219327,
  [SMALL_STATE(5171)] = 219337,
  [SMALL_STATE(5172)] = 219347,
  [SMALL_STATE(5173)] = 219355,
  [SMALL_STATE(5174)] = 219365,
  [SMALL_STATE(5175)] = 219375,
  [SMALL_STATE(5176)] = 219385,
  [SMALL_STATE(5177)] = 219395,
  [SMALL_STATE(5178)] = 219405,
  [SMALL_STATE(5179)] = 219415,
  [SMALL_STATE(5180)] = 219425,
  [SMALL_STATE(5181)] = 219435,
  [SMALL_STATE(5182)] = 219445,
  [SMALL_STATE(5183)] = 219455,
  [SMALL_STATE(5184)] = 219465,
  [SMALL_STATE(5185)] = 219473,
  [SMALL_STATE(5186)] = 219481,
  [SMALL_STATE(5187)] = 219489,
  [SMALL_STATE(5188)] = 219499,
  [SMALL_STATE(5189)] = 219509,
  [SMALL_STATE(5190)] = 219517,
  [SMALL_STATE(5191)] = 219525,
  [SMALL_STATE(5192)] = 219533,
  [SMALL_STATE(5193)] = 219541,
  [SMALL_STATE(5194)] = 219551,
  [SMALL_STATE(5195)] = 219559,
  [SMALL_STATE(5196)] = 219569,
  [SMALL_STATE(5197)] = 219579,
  [SMALL_STATE(5198)] = 219589,
  [SMALL_STATE(5199)] = 219597,
  [SMALL_STATE(5200)] = 219607,
  [SMALL_STATE(5201)] = 219615,
  [SMALL_STATE(5202)] = 219623,
  [SMALL_STATE(5203)] = 219633,
  [SMALL_STATE(5204)] = 219643,
  [SMALL_STATE(5205)] = 219653,
  [SMALL_STATE(5206)] = 219663,
  [SMALL_STATE(5207)] = 219673,
  [SMALL_STATE(5208)] = 219683,
  [SMALL_STATE(5209)] = 219693,
  [SMALL_STATE(5210)] = 219703,
  [SMALL_STATE(5211)] = 219713,
  [SMALL_STATE(5212)] = 219723,
  [SMALL_STATE(5213)] = 219733,
  [SMALL_STATE(5214)] = 219741,
  [SMALL_STATE(5215)] = 219751,
  [SMALL_STATE(5216)] = 219761,
  [SMALL_STATE(5217)] = 219771,
  [SMALL_STATE(5218)] = 219778,
  [SMALL_STATE(5219)] = 219785,
  [SMALL_STATE(5220)] = 219792,
  [SMALL_STATE(5221)] = 219799,
  [SMALL_STATE(5222)] = 219806,
  [SMALL_STATE(5223)] = 219813,
  [SMALL_STATE(5224)] = 219820,
  [SMALL_STATE(5225)] = 219827,
  [SMALL_STATE(5226)] = 219834,
  [SMALL_STATE(5227)] = 219841,
  [SMALL_STATE(5228)] = 219848,
  [SMALL_STATE(5229)] = 219855,
  [SMALL_STATE(5230)] = 219862,
  [SMALL_STATE(5231)] = 219869,
  [SMALL_STATE(5232)] = 219876,
  [SMALL_STATE(5233)] = 219883,
  [SMALL_STATE(5234)] = 219890,
  [SMALL_STATE(5235)] = 219897,
  [SMALL_STATE(5236)] = 219904,
  [SMALL_STATE(5237)] = 219911,
  [SMALL_STATE(5238)] = 219918,
  [SMALL_STATE(5239)] = 219925,
  [SMALL_STATE(5240)] = 219932,
  [SMALL_STATE(5241)] = 219939,
  [SMALL_STATE(5242)] = 219946,
  [SMALL_STATE(5243)] = 219953,
  [SMALL_STATE(5244)] = 219960,
  [SMALL_STATE(5245)] = 219967,
  [SMALL_STATE(5246)] = 219974,
  [SMALL_STATE(5247)] = 219981,
  [SMALL_STATE(5248)] = 219988,
  [SMALL_STATE(5249)] = 219995,
  [SMALL_STATE(5250)] = 220002,
  [SMALL_STATE(5251)] = 220009,
  [SMALL_STATE(5252)] = 220016,
  [SMALL_STATE(5253)] = 220023,
  [SMALL_STATE(5254)] = 220030,
  [SMALL_STATE(5255)] = 220037,
  [SMALL_STATE(5256)] = 220044,
  [SMALL_STATE(5257)] = 220051,
  [SMALL_STATE(5258)] = 220058,
  [SMALL_STATE(5259)] = 220065,
  [SMALL_STATE(5260)] = 220072,
  [SMALL_STATE(5261)] = 220079,
  [SMALL_STATE(5262)] = 220086,
  [SMALL_STATE(5263)] = 220093,
  [SMALL_STATE(5264)] = 220100,
  [SMALL_STATE(5265)] = 220107,
  [SMALL_STATE(5266)] = 220114,
  [SMALL_STATE(5267)] = 220121,
  [SMALL_STATE(5268)] = 220128,
  [SMALL_STATE(5269)] = 220135,
  [SMALL_STATE(5270)] = 220142,
  [SMALL_STATE(5271)] = 220149,
  [SMALL_STATE(5272)] = 220156,
  [SMALL_STATE(5273)] = 220163,
  [SMALL_STATE(5274)] = 220170,
  [SMALL_STATE(5275)] = 220177,
  [SMALL_STATE(5276)] = 220184,
  [SMALL_STATE(5277)] = 220191,
  [SMALL_STATE(5278)] = 220198,
  [SMALL_STATE(5279)] = 220205,
  [SMALL_STATE(5280)] = 220212,
  [SMALL_STATE(5281)] = 220219,
  [SMALL_STATE(5282)] = 220226,
  [SMALL_STATE(5283)] = 220233,
  [SMALL_STATE(5284)] = 220240,
  [SMALL_STATE(5285)] = 220247,
  [SMALL_STATE(5286)] = 220254,
  [SMALL_STATE(5287)] = 220261,
  [SMALL_STATE(5288)] = 220268,
  [SMALL_STATE(5289)] = 220275,
  [SMALL_STATE(5290)] = 220282,
  [SMALL_STATE(5291)] = 220289,
  [SMALL_STATE(5292)] = 220296,
  [SMALL_STATE(5293)] = 220303,
  [SMALL_STATE(5294)] = 220310,
  [SMALL_STATE(5295)] = 220317,
  [SMALL_STATE(5296)] = 220324,
  [SMALL_STATE(5297)] = 220331,
  [SMALL_STATE(5298)] = 220338,
  [SMALL_STATE(5299)] = 220345,
  [SMALL_STATE(5300)] = 220352,
  [SMALL_STATE(5301)] = 220359,
  [SMALL_STATE(5302)] = 220366,
  [SMALL_STATE(5303)] = 220373,
  [SMALL_STATE(5304)] = 220380,
  [SMALL_STATE(5305)] = 220387,
  [SMALL_STATE(5306)] = 220394,
  [SMALL_STATE(5307)] = 220401,
  [SMALL_STATE(5308)] = 220408,
  [SMALL_STATE(5309)] = 220415,
  [SMALL_STATE(5310)] = 220422,
  [SMALL_STATE(5311)] = 220429,
  [SMALL_STATE(5312)] = 220436,
  [SMALL_STATE(5313)] = 220443,
  [SMALL_STATE(5314)] = 220450,
  [SMALL_STATE(5315)] = 220457,
  [SMALL_STATE(5316)] = 220464,
  [SMALL_STATE(5317)] = 220471,
  [SMALL_STATE(5318)] = 220478,
  [SMALL_STATE(5319)] = 220485,
  [SMALL_STATE(5320)] = 220492,
  [SMALL_STATE(5321)] = 220499,
  [SMALL_STATE(5322)] = 220506,
  [SMALL_STATE(5323)] = 220513,
  [SMALL_STATE(5324)] = 220520,
  [SMALL_STATE(5325)] = 220527,
  [SMALL_STATE(5326)] = 220534,
  [SMALL_STATE(5327)] = 220541,
  [SMALL_STATE(5328)] = 220548,
  [SMALL_STATE(5329)] = 220555,
  [SMALL_STATE(5330)] = 220562,
  [SMALL_STATE(5331)] = 220569,
  [SMALL_STATE(5332)] = 220576,
  [SMALL_STATE(5333)] = 220583,
  [SMALL_STATE(5334)] = 220590,
  [SMALL_STATE(5335)] = 220597,
  [SMALL_STATE(5336)] = 220604,
  [SMALL_STATE(5337)] = 220611,
  [SMALL_STATE(5338)] = 220618,
  [SMALL_STATE(5339)] = 220625,
  [SMALL_STATE(5340)] = 220632,
  [SMALL_STATE(5341)] = 220639,
  [SMALL_STATE(5342)] = 220646,
  [SMALL_STATE(5343)] = 220653,
  [SMALL_STATE(5344)] = 220660,
  [SMALL_STATE(5345)] = 220667,
  [SMALL_STATE(5346)] = 220674,
  [SMALL_STATE(5347)] = 220681,
  [SMALL_STATE(5348)] = 220688,
  [SMALL_STATE(5349)] = 220695,
  [SMALL_STATE(5350)] = 220702,
  [SMALL_STATE(5351)] = 220709,
  [SMALL_STATE(5352)] = 220716,
  [SMALL_STATE(5353)] = 220723,
  [SMALL_STATE(5354)] = 220730,
  [SMALL_STATE(5355)] = 220737,
  [SMALL_STATE(5356)] = 220744,
  [SMALL_STATE(5357)] = 220751,
  [SMALL_STATE(5358)] = 220758,
  [SMALL_STATE(5359)] = 220765,
  [SMALL_STATE(5360)] = 220772,
  [SMALL_STATE(5361)] = 220779,
  [SMALL_STATE(5362)] = 220786,
  [SMALL_STATE(5363)] = 220793,
  [SMALL_STATE(5364)] = 220800,
  [SMALL_STATE(5365)] = 220807,
  [SMALL_STATE(5366)] = 220814,
  [SMALL_STATE(5367)] = 220821,
  [SMALL_STATE(5368)] = 220828,
  [SMALL_STATE(5369)] = 220835,
  [SMALL_STATE(5370)] = 220842,
  [SMALL_STATE(5371)] = 220849,
  [SMALL_STATE(5372)] = 220856,
  [SMALL_STATE(5373)] = 220863,
  [SMALL_STATE(5374)] = 220870,
  [SMALL_STATE(5375)] = 220877,
  [SMALL_STATE(5376)] = 220884,
  [SMALL_STATE(5377)] = 220891,
  [SMALL_STATE(5378)] = 220898,
  [SMALL_STATE(5379)] = 220905,
  [SMALL_STATE(5380)] = 220912,
  [SMALL_STATE(5381)] = 220919,
  [SMALL_STATE(5382)] = 220926,
  [SMALL_STATE(5383)] = 220933,
  [SMALL_STATE(5384)] = 220940,
  [SMALL_STATE(5385)] = 220947,
  [SMALL_STATE(5386)] = 220954,
  [SMALL_STATE(5387)] = 220961,
  [SMALL_STATE(5388)] = 220968,
  [SMALL_STATE(5389)] = 220975,
  [SMALL_STATE(5390)] = 220982,
  [SMALL_STATE(5391)] = 220989,
  [SMALL_STATE(5392)] = 220996,
  [SMALL_STATE(5393)] = 221003,
  [SMALL_STATE(5394)] = 221010,
  [SMALL_STATE(5395)] = 221017,
  [SMALL_STATE(5396)] = 221024,
  [SMALL_STATE(5397)] = 221031,
  [SMALL_STATE(5398)] = 221038,
  [SMALL_STATE(5399)] = 221045,
  [SMALL_STATE(5400)] = 221052,
  [SMALL_STATE(5401)] = 221059,
  [SMALL_STATE(5402)] = 221066,
  [SMALL_STATE(5403)] = 221073,
  [SMALL_STATE(5404)] = 221080,
  [SMALL_STATE(5405)] = 221087,
  [SMALL_STATE(5406)] = 221094,
  [SMALL_STATE(5407)] = 221101,
  [SMALL_STATE(5408)] = 221108,
  [SMALL_STATE(5409)] = 221115,
  [SMALL_STATE(5410)] = 221122,
  [SMALL_STATE(5411)] = 221129,
  [SMALL_STATE(5412)] = 221136,
  [SMALL_STATE(5413)] = 221143,
  [SMALL_STATE(5414)] = 221150,
  [SMALL_STATE(5415)] = 221157,
  [SMALL_STATE(5416)] = 221164,
  [SMALL_STATE(5417)] = 221171,
  [SMALL_STATE(5418)] = 221178,
  [SMALL_STATE(5419)] = 221185,
  [SMALL_STATE(5420)] = 221192,
  [SMALL_STATE(5421)] = 221199,
  [SMALL_STATE(5422)] = 221206,
  [SMALL_STATE(5423)] = 221213,
  [SMALL_STATE(5424)] = 221220,
  [SMALL_STATE(5425)] = 221227,
  [SMALL_STATE(5426)] = 221234,
  [SMALL_STATE(5427)] = 221241,
  [SMALL_STATE(5428)] = 221248,
  [SMALL_STATE(5429)] = 221255,
  [SMALL_STATE(5430)] = 221262,
  [SMALL_STATE(5431)] = 221269,
  [SMALL_STATE(5432)] = 221276,
  [SMALL_STATE(5433)] = 221283,
  [SMALL_STATE(5434)] = 221290,
  [SMALL_STATE(5435)] = 221297,
  [SMALL_STATE(5436)] = 221304,
  [SMALL_STATE(5437)] = 221311,
  [SMALL_STATE(5438)] = 221318,
  [SMALL_STATE(5439)] = 221325,
  [SMALL_STATE(5440)] = 221332,
  [SMALL_STATE(5441)] = 221339,
  [SMALL_STATE(5442)] = 221346,
  [SMALL_STATE(5443)] = 221353,
  [SMALL_STATE(5444)] = 221360,
  [SMALL_STATE(5445)] = 221367,
  [SMALL_STATE(5446)] = 221374,
  [SMALL_STATE(5447)] = 221381,
  [SMALL_STATE(5448)] = 221388,
  [SMALL_STATE(5449)] = 221395,
  [SMALL_STATE(5450)] = 221402,
  [SMALL_STATE(5451)] = 221409,
  [SMALL_STATE(5452)] = 221416,
  [SMALL_STATE(5453)] = 221423,
  [SMALL_STATE(5454)] = 221430,
  [SMALL_STATE(5455)] = 221437,
  [SMALL_STATE(5456)] = 221444,
  [SMALL_STATE(5457)] = 221451,
  [SMALL_STATE(5458)] = 221458,
  [SMALL_STATE(5459)] = 221465,
  [SMALL_STATE(5460)] = 221472,
  [SMALL_STATE(5461)] = 221479,
  [SMALL_STATE(5462)] = 221486,
  [SMALL_STATE(5463)] = 221493,
  [SMALL_STATE(5464)] = 221500,
  [SMALL_STATE(5465)] = 221507,
  [SMALL_STATE(5466)] = 221514,
  [SMALL_STATE(5467)] = 221521,
  [SMALL_STATE(5468)] = 221528,
  [SMALL_STATE(5469)] = 221535,
  [SMALL_STATE(5470)] = 221542,
  [SMALL_STATE(5471)] = 221549,
  [SMALL_STATE(5472)] = 221556,
  [SMALL_STATE(5473)] = 221563,
  [SMALL_STATE(5474)] = 221570,
  [SMALL_STATE(5475)] = 221577,
  [SMALL_STATE(5476)] = 221584,
  [SMALL_STATE(5477)] = 221591,
  [SMALL_STATE(5478)] = 221598,
  [SMALL_STATE(5479)] = 221605,
  [SMALL_STATE(5480)] = 221612,
  [SMALL_STATE(5481)] = 221619,
  [SMALL_STATE(5482)] = 221626,
  [SMALL_STATE(5483)] = 221633,
  [SMALL_STATE(5484)] = 221640,
  [SMALL_STATE(5485)] = 221647,
  [SMALL_STATE(5486)] = 221654,
  [SMALL_STATE(5487)] = 221661,
  [SMALL_STATE(5488)] = 221668,
  [SMALL_STATE(5489)] = 221675,
  [SMALL_STATE(5490)] = 221682,
  [SMALL_STATE(5491)] = 221689,
  [SMALL_STATE(5492)] = 221696,
  [SMALL_STATE(5493)] = 221703,
  [SMALL_STATE(5494)] = 221710,
  [SMALL_STATE(5495)] = 221717,
  [SMALL_STATE(5496)] = 221724,
  [SMALL_STATE(5497)] = 221731,
  [SMALL_STATE(5498)] = 221738,
  [SMALL_STATE(5499)] = 221745,
  [SMALL_STATE(5500)] = 221752,
  [SMALL_STATE(5501)] = 221759,
  [SMALL_STATE(5502)] = 221766,
  [SMALL_STATE(5503)] = 221773,
  [SMALL_STATE(5504)] = 221780,
  [SMALL_STATE(5505)] = 221787,
  [SMALL_STATE(5506)] = 221794,
  [SMALL_STATE(5507)] = 221801,
  [SMALL_STATE(5508)] = 221808,
  [SMALL_STATE(5509)] = 221815,
  [SMALL_STATE(5510)] = 221822,
  [SMALL_STATE(5511)] = 221829,
  [SMALL_STATE(5512)] = 221836,
  [SMALL_STATE(5513)] = 221843,
  [SMALL_STATE(5514)] = 221850,
  [SMALL_STATE(5515)] = 221857,
  [SMALL_STATE(5516)] = 221864,
  [SMALL_STATE(5517)] = 221871,
  [SMALL_STATE(5518)] = 221878,
  [SMALL_STATE(5519)] = 221885,
  [SMALL_STATE(5520)] = 221892,
  [SMALL_STATE(5521)] = 221899,
  [SMALL_STATE(5522)] = 221906,
  [SMALL_STATE(5523)] = 221913,
  [SMALL_STATE(5524)] = 221920,
  [SMALL_STATE(5525)] = 221927,
  [SMALL_STATE(5526)] = 221934,
  [SMALL_STATE(5527)] = 221941,
  [SMALL_STATE(5528)] = 221948,
  [SMALL_STATE(5529)] = 221955,
  [SMALL_STATE(5530)] = 221962,
  [SMALL_STATE(5531)] = 221969,
  [SMALL_STATE(5532)] = 221976,
  [SMALL_STATE(5533)] = 221983,
  [SMALL_STATE(5534)] = 221990,
  [SMALL_STATE(5535)] = 221997,
  [SMALL_STATE(5536)] = 222004,
  [SMALL_STATE(5537)] = 222011,
  [SMALL_STATE(5538)] = 222018,
  [SMALL_STATE(5539)] = 222025,
  [SMALL_STATE(5540)] = 222032,
  [SMALL_STATE(5541)] = 222039,
  [SMALL_STATE(5542)] = 222046,
  [SMALL_STATE(5543)] = 222053,
  [SMALL_STATE(5544)] = 222060,
  [SMALL_STATE(5545)] = 222067,
  [SMALL_STATE(5546)] = 222074,
  [SMALL_STATE(5547)] = 222081,
  [SMALL_STATE(5548)] = 222088,
  [SMALL_STATE(5549)] = 222095,
  [SMALL_STATE(5550)] = 222102,
  [SMALL_STATE(5551)] = 222109,
  [SMALL_STATE(5552)] = 222116,
  [SMALL_STATE(5553)] = 222123,
  [SMALL_STATE(5554)] = 222130,
  [SMALL_STATE(5555)] = 222137,
  [SMALL_STATE(5556)] = 222144,
  [SMALL_STATE(5557)] = 222151,
  [SMALL_STATE(5558)] = 222158,
  [SMALL_STATE(5559)] = 222165,
  [SMALL_STATE(5560)] = 222172,
  [SMALL_STATE(5561)] = 222179,
  [SMALL_STATE(5562)] = 222186,
  [SMALL_STATE(5563)] = 222193,
  [SMALL_STATE(5564)] = 222200,
  [SMALL_STATE(5565)] = 222207,
  [SMALL_STATE(5566)] = 222214,
  [SMALL_STATE(5567)] = 222221,
  [SMALL_STATE(5568)] = 222228,
  [SMALL_STATE(5569)] = 222235,
  [SMALL_STATE(5570)] = 222242,
  [SMALL_STATE(5571)] = 222249,
  [SMALL_STATE(5572)] = 222256,
  [SMALL_STATE(5573)] = 222263,
  [SMALL_STATE(5574)] = 222270,
  [SMALL_STATE(5575)] = 222277,
  [SMALL_STATE(5576)] = 222284,
  [SMALL_STATE(5577)] = 222291,
  [SMALL_STATE(5578)] = 222298,
  [SMALL_STATE(5579)] = 222305,
  [SMALL_STATE(5580)] = 222312,
  [SMALL_STATE(5581)] = 222319,
  [SMALL_STATE(5582)] = 222326,
  [SMALL_STATE(5583)] = 222333,
  [SMALL_STATE(5584)] = 222340,
  [SMALL_STATE(5585)] = 222347,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3960),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3922),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4978),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4979),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4762),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4982),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4986),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4999),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4768),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5005),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5533),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3816),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4091),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5523),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5521),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5519),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1578),
  [304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(371),
  [307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1201),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1368),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(859),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1995),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3960),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3984),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3922),
  [333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(491),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4978),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4979),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4762),
  [345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(167),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(493),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4982),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(43),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4986),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4999),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4766),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4768),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5005),
  [372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(248),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(415),
  [378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1044),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(105),
  [384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(182),
  [387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1371),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5533),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3816),
  [396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(980),
  [399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4091),
  [402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(393),
  [405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(491),
  [408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(574),
  [411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4633),
  [414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4581),
  [417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4117),
  [420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2275),
  [423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2275),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4903),
  [429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(908),
  [432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1572),
  [435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5523),
  [438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1202),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5521),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5519),
  [447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 62),
  [449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 62),
  [451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 62),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 62),
  [455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5146),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4835),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5165),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5169),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3823),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3980),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5270),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3828),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4054),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3341),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5313),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3298),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4142),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2803),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5380),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4100),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4186),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2569),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2579),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3072),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3073),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5518),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5408),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3806),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4027),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2955),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2956),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2860),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5568),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3822),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4050),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2714),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3376),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4202),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [1231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5278),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2701),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5461),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3804),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3977),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3264),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3278),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3079),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3123),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [1493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [1511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5339),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3251),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3263),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3746),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4037),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [1577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(674),
  [1580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [1584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5145),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4609),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5228),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3705),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3865),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3704),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3877),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3657),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [1791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4697),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3699),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [1843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [1847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2),
  [1849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [1851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5238),
  [1869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 73),
  [1875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 73),
  [1877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 73),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 73),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4643),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 129),
  [1913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 129),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 129),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 129),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 81),
  [1929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 81),
  [1931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 81),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 81),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 111),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 111),
  [1955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 111),
  [1957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 111),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [1961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 86),
  [1967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 86),
  [1969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 86),
  [1971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 86),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [1975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 38),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 38),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 38),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 38),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4545),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 21),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 21),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 104),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 104),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 104),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 104),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [2013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(381),
  [2016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [2018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [2020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [2022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [2024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 104),
  [2026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 104),
  [2028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 104),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 104),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 131),
  [2036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 131),
  [2038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 131),
  [2040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 131),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 74),
  [2046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 74),
  [2048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 74),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 74),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 101),
  [2056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 101),
  [2058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 101),
  [2060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 101),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [2064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [2066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [2068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 112),
  [2070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 112),
  [2072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 112),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 112),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3682),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3778),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4658),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5382),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3779),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3782),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3780),
  [2116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [2118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [2130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(312),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4009),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [2201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [2203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [2205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [2209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [2215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5028),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5490),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [2260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(35),
  [2266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5478),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [2309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [2311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [2321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [2325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [2329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [2331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [2333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [2335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [2341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [2345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [2347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [2351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [2353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [2355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [2363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [2367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [2383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [2387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [2401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [2403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4109),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [2415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [2427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [2431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [2439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [2441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [2445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [2449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [2459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [2463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [2465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [2469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [2471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [2473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [2475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [2477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [2479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [2481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [2483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [2485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [2487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [2497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [2499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [2515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [2523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [2525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [2533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [2545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [2547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [2551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [2555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5255),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5239),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5333),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3953),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [2629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4088),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5363),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [2643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [2653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [2657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [2661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [2669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [2671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [2677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [2679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [2681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [2685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [2687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [2691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [2699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [2705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [2715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [2717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [2723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4669),
  [2727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4663),
  [2729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3651),
  [2732] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3409),
  [2736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(697),
  [2739] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(5145),
  [2743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4051),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [2747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3581),
  [2749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [2751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [2753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [2755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [2757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [2759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [2761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [2763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [2765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [2767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4101),
  [2771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [2773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3578),
  [2775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3596),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [2781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3876),
  [2783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [2785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [2787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3712),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [2797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3951),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3978),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [2811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3561),
  [2814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4305),
  [2819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5264),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5263),
  [2823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3409),
  [2826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(5145),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4049),
  [2831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5475),
  [2833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5479),
  [2835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4079),
  [2837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5391),
  [2843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5392),
  [2845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4052),
  [2847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5221),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5225),
  [2851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5511),
  [2853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5510),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5235),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5234),
  [2859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5273),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5276),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5436),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5437),
  [2867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4005),
  [2869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5469),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5476),
  [2873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5388),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5330),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4010),
  [2879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(301),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5303),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5302),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5275),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5277),
  [2892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5512),
  [2894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5500),
  [2896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [2898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5369),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [2904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 10),
  [2906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 10),
  [2908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4880),
  [2910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4970),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5301),
  [2914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5300),
  [2916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(863),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5535),
  [2923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5537),
  [2925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4063),
  [2927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5564),
  [2929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5562),
  [2931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5419),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5420),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 31),
  [2945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 31),
  [2947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5292),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5295),
  [2951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5327),
  [2953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5325),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5250),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 137),
  [2969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 137),
  [2971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 10),
  [2973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 10),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 26),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 26),
  [2979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 106),
  [2983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 106),
  [2985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 136),
  [2987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 136),
  [2989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 33),
  [2991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 33),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 32),
  [2995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 32),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 30),
  [2999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 30),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 28),
  [3003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 28),
  [3005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [3007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [3009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 27),
  [3011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 27),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3),
  [3015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4),
  [3023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4),
  [3025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 65),
  [3027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 65),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [3031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [3033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [3035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [3039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [3041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 73),
  [3043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 73),
  [3045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 66),
  [3047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 66),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 74),
  [3051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 74),
  [3053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [3055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 67),
  [3059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 67),
  [3061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 10),
  [3071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 10),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 103),
  [3075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 103),
  [3077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 148),
  [3079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 148),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 131),
  [3083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 131),
  [3085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 81),
  [3087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 81),
  [3089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 69),
  [3091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 69),
  [3093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 105),
  [3095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 105),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [3099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [3101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 101),
  [3103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 101),
  [3105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, .production_id = 147),
  [3107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, .production_id = 147),
  [3109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [3111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [3113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 129),
  [3115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 129),
  [3117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [3119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [3121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [3123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 34),
  [3127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 34),
  [3129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 56),
  [3131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 56),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 55),
  [3135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 55),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 34),
  [3139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 34),
  [3141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 95),
  [3143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 95),
  [3145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 133),
  [3147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 133),
  [3149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 132),
  [3151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 132),
  [3153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 112),
  [3155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 112),
  [3157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 111),
  [3159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 111),
  [3161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [3163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [3165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 130),
  [3167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 130),
  [3169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 104),
  [3171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 104),
  [3173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 104),
  [3175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 104),
  [3177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [3179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [3181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 110),
  [3183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 110),
  [3185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 101),
  [3187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 101),
  [3189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 86),
  [3191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 86),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 38),
  [3195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 38),
  [3197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [3199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [3201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 19),
  [3203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 19),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 80),
  [3207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 80),
  [3209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 114),
  [3211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 114),
  [3213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [3215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [3217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [3219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [3221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 93),
  [3223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 93),
  [3225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 83),
  [3227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 83),
  [3229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 73),
  [3231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 73),
  [3233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 74),
  [3235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 74),
  [3237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [3239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5382),
  [3245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3889),
  [3249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [3251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [3253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [3255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [3257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [3259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [3261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 53),
  [3263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 53),
  [3265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 46),
  [3267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 46),
  [3269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 38),
  [3271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 38),
  [3273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 92),
  [3275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 92),
  [3277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 120),
  [3279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 120),
  [3281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [3283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [3285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [3287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [3289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [3291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [3293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 117),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 117),
  [3297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [3299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [3301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 118),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 118),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 119),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 119),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 135),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 135),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [3317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4),
  [3319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [3331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [3333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3740),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2488),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [3353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [3355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [3357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3040),
  [3359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [3361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [3363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [3365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [3369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [3383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [3385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4558),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5582),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [3391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3065),
  [3393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3339),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3486),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [3401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3743),
  [3403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [3407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [3409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3332),
  [3411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [3413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [3415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3463),
  [3417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 48),
  [3419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 48),
  [3421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3749),
  [3423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3235),
  [3429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3239),
  [3431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [3433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3342),
  [3435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3476),
  [3437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 108),
  [3439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 108),
  [3441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3751),
  [3443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [3447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [3449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [3451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [3453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3350),
  [3455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [3465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3753),
  [3467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [3471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [3473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3139),
  [3475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3137),
  [3477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3374),
  [3479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3422),
  [3481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 84),
  [3483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 84),
  [3485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3744),
  [3487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [3491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3294),
  [3493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3295),
  [3495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3296),
  [3497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [3501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3736),
  [3503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [3507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3112),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [3511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [3513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [3515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [3517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3734),
  [3519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [3523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [3525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3090),
  [3527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [3529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [3531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3477),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [3537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [3539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [3545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [3551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [3553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3094),
  [3555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [3557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [3559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [3569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4916),
  [3571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [3573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [3575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [3579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1776),
  [3582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(5580),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [3589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1874),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1650),
  [3597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [3599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1498),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [3604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 11),
  [3607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 11),
  [3610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3761),
  [3616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [3618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3812),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [3632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [3642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 11),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [3648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1583),
  [3651] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 11),
  [3655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(5318),
  [3658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [3660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(626),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [3665] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 11), SHIFT(5203),
  [3669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [3673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [3675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [3681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4544),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [3691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [3695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [3697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [3699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [3701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5455),
  [3703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4254),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [3707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [3711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [3713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [3719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [3729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [3731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [3733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [3735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [3737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [3739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5247),
  [3741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4162),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [3745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [3749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [3751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [3757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4559),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [3767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [3771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [3773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [3775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [3777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5321),
  [3779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4246),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [3783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3886),
  [3785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [3787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4696),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [3797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4732),
  [3801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4190),
  [3803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [3805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4660),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [3813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [3815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4234),
  [3817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4535),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [3827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [3829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4176),
  [3831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [3833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4527),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [3843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [3845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4230),
  [3847] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [3853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4543),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [3861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [3863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4251),
  [3865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4666),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [3875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [3877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4161),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2893),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [3883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [3891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4571),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5557),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3144),
  [3907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5559),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4247),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4662),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [3927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [3929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4120),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3750),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [3935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [3937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [3943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4615),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3890),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3888),
  [3963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3918),
  [3965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [3967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4875),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5503),
  [3971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4163),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [3977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4671),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [3985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [3987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4528),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [3999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [4001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4244),
  [4003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1537),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4568),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [4020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4165),
  [4022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3756),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3912),
  [4026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4801),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3686),
  [4030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3758),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4728),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [4036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3697),
  [4040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3869),
  [4042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [4052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4212),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [4056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4099),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [4060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3377),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3034),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3818),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4619),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2525),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3757),
  [4110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [4112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [4116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [4118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [4120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2968),
  [4122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3834),
  [4130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [4132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4646),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [4140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4206),
  [4142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [4144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4158),
  [4146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3825),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [4150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1), REDUCE(aux_sym_object_pattern_repeat1, 1),
  [4153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [4155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [4157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [4159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [4161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [4171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [4181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [4183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [4185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [4187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3766),
  [4193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4575),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3930),
  [4205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [4207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4181),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [4215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1527),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [4220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3056),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [4230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3827),
  [4232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4083),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3767),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3938),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [4240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 36),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3764),
  [4248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [4250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4659),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3940),
  [4260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [4262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4177),
  [4264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3786),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [4274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3347),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [4278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3349),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3348),
  [4282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3410),
  [4284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3506),
  [4286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2),
  [4288] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 11), REDUCE(sym_rest_pattern, 2),
  [4292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [4302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [4304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [4306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2, .production_id = 36),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [4310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1570),
  [4313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(5524),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3365),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [4330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [4336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [4339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [4342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3739),
  [4344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [4346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4547),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [4354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3858),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [4358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4166),
  [4360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3759),
  [4362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3909),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [4368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(295),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [4375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 36),
  [4377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 36),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [4385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [4393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(372),
  [4396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [4398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [4400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(480),
  [4403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(906),
  [4406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [4408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3826),
  [4414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [4416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1),
  [4418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3404),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [4424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3482),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3523),
  [4428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_rest_pattern, 2),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [4439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5541),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [4443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2652),
  [4446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2103),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [4459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [4477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4905),
  [4479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5426),
  [4481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [4485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [4487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3808),
  [4489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2960),
  [4492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2413),
  [4495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2217),
  [4498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3229),
  [4501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2984),
  [4504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3218),
  [4507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2574),
  [4510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3083),
  [4513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3765),
  [4515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [4523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [4527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3431),
  [4529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [4531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3505),
  [4533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [4547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3473),
  [4550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3841),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [4557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 23),
  [4560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 12),
  [4562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 12),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [4576] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 22), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 23),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [4612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 43),
  [4614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 43),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [4618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [4620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [4634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2, .production_id = 36),
  [4636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2, .production_id = 36),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [4640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [4642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [4646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 11),
  [4648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 11), SHIFT(5218),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [4657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 88),
  [4659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 88),
  [4661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 72),
  [4663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 72),
  [4665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [4667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 47),
  [4669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [4675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(86),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [4688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [4690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [4708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 51),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [4716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 44),
  [4718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 76),
  [4720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [4722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [4724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [4726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [4728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [4730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [4734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [4736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [4738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [4740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [4742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 78),
  [4744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 8),
  [4746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 8),
  [4748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 11),
  [4750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 11),
  [4752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 79),
  [4754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 36),
  [4756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 36),
  [4758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2),
  [4760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2),
  [4762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 109),
  [4764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [4766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [4768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [4774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 18),
  [4776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [4778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5195),
  [4784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [4806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [4808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 44),
  [4810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(90),
  [4813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 45),
  [4815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 113),
  [4817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 113),
  [4819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [4821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [4823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 102),
  [4825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 102),
  [4827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 22),
  [4829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, .production_id = 23),
  [4831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 22),
  [4833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 87),
  [4835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 87),
  [4837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 85),
  [4839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 85),
  [4841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 20),
  [4843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [4845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [4847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 82),
  [4849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 82),
  [4851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 77),
  [4853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 77),
  [4855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 79),
  [4857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 78),
  [4859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 77),
  [4861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 77),
  [4863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [4865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [4867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [4869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [4871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 76),
  [4873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 71),
  [4875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 71),
  [4877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 71),
  [4880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 75),
  [4882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 75),
  [4884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3),
  [4886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3),
  [4888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [4890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [4892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [4894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [4896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(86),
  [4899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [4901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [4903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [4905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [4907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [4909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [4911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [4913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [4916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [4919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [4922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [4925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [4927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [4929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 22),
  [4931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 22),
  [4933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [4936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [4939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1),
  [4942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1),
  [4945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 51),
  [4947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 50),
  [4949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 50),
  [4951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 49),
  [4953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 49),
  [4955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [4957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [4959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [4961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [4963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 45),
  [4965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [4967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [4969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [4971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [4973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4),
  [4975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4),
  [4977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 42),
  [4979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 42),
  [4981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [4983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [4985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [4987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [4989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4),
  [4991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4),
  [4993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 41),
  [4995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 41),
  [4997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 40),
  [4999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 40),
  [5001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 39),
  [5003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 39),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [5007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5),
  [5009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5),
  [5011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [5013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [5015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [5017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [5019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 37),
  [5021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 37),
  [5023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [5025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [5027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [5031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [5033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [5035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 20),
  [5037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 14),
  [5039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 14),
  [5041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 13),
  [5043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 13),
  [5045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [5047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [5049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 10),
  [5051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 10),
  [5053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [5055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [5057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(90),
  [5060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [5062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [5064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(90),
  [5067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [5071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(86),
  [5074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 22), REDUCE(sym_object_pattern, 3, .production_id = 23),
  [5077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [5081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [5085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [5089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [5091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [5097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [5105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [5107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [5109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [5119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(95),
  [5122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(95),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [5127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(95),
  [5130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 11), SHIFT(5341),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [5135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [5138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [5141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [5145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [5147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [5149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [5151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [5153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [5161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [5163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [5165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [5173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(78),
  [5176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(87),
  [5179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3835),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [5185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3420),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3475),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3503),
  [5195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [5199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [5203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [5205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [5207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [5209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [5217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [5219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [5221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [5229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3833),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [5233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [5235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [5237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [5239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3502),
  [5241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [5243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(78),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [5250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3450),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3452),
  [5256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3504),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3839),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [5266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [5268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3444),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3497),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3533),
  [5274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3830),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [5280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3465),
  [5282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3467),
  [5284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3510),
  [5286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [5288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [5290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 11), SHIFT(5459),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [5295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [5299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [5301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3436),
  [5303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3435),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3494),
  [5307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3542),
  [5309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3862),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [5313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [5315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3458),
  [5317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3456),
  [5319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3512),
  [5321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [5323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [5327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3478),
  [5329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3487),
  [5331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [5333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3490),
  [5335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3551),
  [5337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3847),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [5341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [5343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3455),
  [5345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [5347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3493),
  [5349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [5351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [5353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [5355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 18),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [5359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [5361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [5363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [5371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [5373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [5375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [5383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 3),
  [5385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3864),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [5389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [5391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3470),
  [5393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3468),
  [5395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [5397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [5399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 44),
  [5401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(94),
  [5404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3887),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [5408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [5410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3447),
  [5412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [5414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [5416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3540),
  [5418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(78),
  [5421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(94),
  [5424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [5426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [5430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 44),
  [5432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(94),
  [5435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(87),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [5440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 44),
  [5442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(87),
  [5445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 109),
  [5447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [5451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [5453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [5455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [5457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [5465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [5467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [5469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [5477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(83),
  [5480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [5482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [5484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [5486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [5488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [5500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [5508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [5510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [5512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [5514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [5518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [5522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [5526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [5528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [5534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [5542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [5544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [5546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [5556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 156),
  [5558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 156),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [5562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [5564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [5568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [5574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [5588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(84),
  [5591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 44), REDUCE(sym_assignment_expression, 3, .production_id = 44),
  [5594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 44),
  [5596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(92),
  [5599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [5603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [5605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [5607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [5609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [5617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [5619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [5621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [5623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [5625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [5627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [5629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(92),
  [5632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 58), REDUCE(sym_assignment_expression, 3, .production_id = 44),
  [5635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 58),
  [5637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 58), REDUCE(sym_assignment_expression, 3, .production_id = 18),
  [5640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [5644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [5646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [5658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [5662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [5674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(84),
  [5677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [5679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(81),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [5684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [5686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2),
  [5688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [5702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [5704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [5706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [5714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5459),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [5720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [5722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [5724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [5726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [5734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [5738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [5746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(81),
  [5749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(83),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [5754] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [5758] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [5762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(83),
  [5765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2),
  [5767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2),
  [5769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [5771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [5773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(96),
  [5776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(81),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [5781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(84),
  [5784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(92),
  [5787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(96),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [5792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(96),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [5797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [5801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [5815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [5817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [5819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [5831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(82),
  [5834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(88),
  [5837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [5839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [5845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4087),
  [5847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3517),
  [5849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [5851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [5853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [5855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [5859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [5863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(100),
  [5866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [5868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [5870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [5872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [5880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [5882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [5884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [5892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [5902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [5904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [5906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 62),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [5912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 11), SHIFT(5553),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [5919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(100),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [5926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(93),
  [5929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(93),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [5934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(100),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [5943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(88),
  [5946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(88),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [5951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(82),
  [5954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(82),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [5959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [5961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(93),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [5966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [5970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [5972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [5974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [5976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [5986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [5996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(79),
  [5999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(79),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [6004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [6006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 59),
  [6008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [6010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [6012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [6014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [6016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [6024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [6026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [6028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [6036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(97),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [6043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 44),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [6053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [6056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [6060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [6064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [6066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [6068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [6076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [6078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [6080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [6088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [6090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [6094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [6102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(85),
  [6105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(85),
  [6108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(79),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [6113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 22), REDUCE(sym_object_pattern, 3, .production_id = 23),
  [6116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [6119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [6123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1),
  [6125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1),
  [6128] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [6132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [6139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, .production_id = 23),
  [6141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [6143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [6151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(85),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [6158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [6166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(97),
  [6169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(97),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [6178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [6182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [6184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [6186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [6194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [6198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [6208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [6214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [6216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [6226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [6230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [6234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [6240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3600),
  [6242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(99),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [6251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3480),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [6255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3395),
  [6257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [6259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3406),
  [6261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3621),
  [6263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [6271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [6274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [6276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [6279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(99),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [6286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(99),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [6297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [6301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [6303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [6307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [6309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [6311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [6319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [6321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [6323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [6331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [6334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [6336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [6345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [6347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [6351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [6353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [6355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [6357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [6367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [6369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [6373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 47), SHIFT(80),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [6390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3765),
  [6393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3625),
  [6396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [6398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(456),
  [6401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3480),
  [6404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(5582),
  [6407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4683),
  [6410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4635),
  [6413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3688),
  [6416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4903),
  [6419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3395),
  [6422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3472),
  [6425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3406),
  [6428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3621),
  [6431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3508),
  [6434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3432),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [6439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(80),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [6444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(80),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [6453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [6455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [6459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [6461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [6467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3589),
  [6471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3483),
  [6473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [6475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [6477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3485),
  [6479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [6481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4376),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5453),
  [6489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [6491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [6497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [6499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [6501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3496),
  [6505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [6509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4455),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [6515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [6517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [6519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3632),
  [6521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [6525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3990),
  [6527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3532),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [6531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [6541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3428),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [6545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3634),
  [6547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3501),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [6553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [6557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3598),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [6561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [6565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3516),
  [6567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3479),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [6571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [6573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [6575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3457),
  [6577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [6579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [6581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3592),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [6587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3590),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [6591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [6595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3491),
  [6597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [6601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3591),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [6605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3597),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [6613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3603),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [6619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3601),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [6623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3427),
  [6625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4681),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [6629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [6633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [6637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3594),
  [6639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [6643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3492),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [6649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3602),
  [6651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [6655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [6657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3500),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [6663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [6665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [6669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5492),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [6675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 22), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 23),
  [6678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3641),
  [6680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 48),
  [6682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 48),
  [6684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4106),
  [6686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [6688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [6692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [6694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3547),
  [6696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [6698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3570),
  [6700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4330),
  [6702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [6706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [6708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3814),
  [6710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [6720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 22),
  [6722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4483),
  [6724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 14),
  [6726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 14),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [6730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 162),
  [6732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 162),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [6738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3599),
  [6740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 116),
  [6742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 116),
  [6744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 81),
  [6746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 81),
  [6748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 171),
  [6750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 171),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [6754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 60),
  [6756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 60),
  [6758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1),
  [6760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 129),
  [6762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 129),
  [6764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3587),
  [6766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 91),
  [6768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 91),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [6774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3588),
  [6776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [6778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3573),
  [6780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 163),
  [6782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 163),
  [6784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 104),
  [6786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 104),
  [6788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 134),
  [6790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 134),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [6796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 149),
  [6798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 149),
  [6800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [6802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [6806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 150),
  [6808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 150),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [6814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3593),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [6824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3528),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [6830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [6834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [6836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [6838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3617),
  [6840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 17),
  [6842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 17),
  [6844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 17), SHIFT_REPEAT(4903),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [6859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3434),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [6863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [6865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [6867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3529),
  [6869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3518),
  [6871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3630),
  [6873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3576),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [6879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [6881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3489),
  [6883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [6885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [6887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [6889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4983),
  [6891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5552),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5580),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [6939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 96),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5318),
  [6951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 57),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4034),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [6961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 124),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [6967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [6975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 124),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [6981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [6985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 57),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [6991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 11), REDUCE(sym_type_parameter, 1, .production_id = 11),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [6996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 11), SHIFT(1500),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [7005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 96),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [7013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 11),
  [7016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 11), SHIFT(5203),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [7023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 96),
  [7025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 124),
  [7027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 57),
  [7029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 96),
  [7031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 124),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [7035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 57),
  [7037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [7045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [7051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 11), REDUCE(sym_rest_pattern, 2),
  [7054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [7064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [7068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [7072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3878),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [7076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [7078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [7080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3831),
  [7082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [7086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [7092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5048),
  [7096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [7098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3863),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [7102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3872),
  [7104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3844),
  [7106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [7110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3853),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [7114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3846),
  [7116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3851),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [7120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3849),
  [7122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3885),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [7130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [7133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [7142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [7144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3),
  [7146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2),
  [7148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1), REDUCE(sym__parameter_name, 2),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [7153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4),
  [7155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 146),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [7159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3),
  [7161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1),
  [7163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [7166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [7169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4),
  [7171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, .production_id = 23),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [7181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [7189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [7195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5394),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [7201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [7205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5584),
  [7207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [7211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [7215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [7223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [7229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 11),
  [7231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [7237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 80),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [7245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [7247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 98),
  [7249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [7261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 121),
  [7263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 103),
  [7265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 138),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [7269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, .production_id = 9),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [7275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 139),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [7279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3),
  [7281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 153),
  [7283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 154),
  [7285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 164),
  [7287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 166),
  [7289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 173),
  [7291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [7295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [7299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [7303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [7305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [7311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [7315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 70),
  [7317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [7319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 146),
  [7321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [7323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [7347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [7349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2),
  [7351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5409),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [7359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [7373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [7387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3653),
  [7389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3689),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [7397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [7399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [7403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [7405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [7407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [7409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 52),
  [7411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [7415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [7419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [7435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [7439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [7443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [7449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [7451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [7453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [7459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [7461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [7465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [7479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [7481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [7483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [7487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [7489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [7491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [7493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [7495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [7505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [7511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [7513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3772),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [7535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [7555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [7557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4767),
  [7559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [7561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [7563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5297),
  [7565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(4187),
  [7568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [7570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(416),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [7585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 15),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [7589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(2241),
  [7592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [7608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [7632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(626),
  [7635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, .production_id = 9),
  [7637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2541),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [7649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [7657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [7665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(5375),
  [7668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [7670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(302),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [7677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [7695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 35),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [7699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(1524),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [7704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 152),
  [7706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 172),
  [7708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16), SHIFT(1549),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [7719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16), SHIFT(1425),
  [7722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 169),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [7730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5328),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5546),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [7742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [7748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16), SHIFT(1450),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [7757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6),
  [7759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 9),
  [7761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 141),
  [7763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 151),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [7767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [7769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 152),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [7773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16), SHIFT(1885),
  [7776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 123),
  [7778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16), SHIFT(1410),
  [7781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(1891),
  [7784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(1741),
  [7787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 25),
  [7789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7),
  [7791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(1455),
  [7794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(1394),
  [7797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 165),
  [7799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 122),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [7803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [7807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 123),
  [7809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 97),
  [7811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 122),
  [7813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4),
  [7815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [7821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16), SHIFT(1441),
  [7824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(1700),
  [7827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 63),
  [7829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 155),
  [7831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(1414),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [7836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [7838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 155),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [7842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(1468),
  [7845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16), SHIFT(1728),
  [7848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 141),
  [7850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 25),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [7856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16), SHIFT(1601),
  [7859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 140),
  [7861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [7863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5),
  [7865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3),
  [7867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16), SHIFT(1724),
  [7870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 97),
  [7872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(1474),
  [7875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 140),
  [7877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 161),
  [7879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 25),
  [7881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [7883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 63),
  [7885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2),
  [7887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 16), SHIFT(1447),
  [7890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(1731),
  [7893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [7897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [7901] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [7905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2872),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [7909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [7913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [7929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [7933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [7935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [7937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [7939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [7941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [7943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [7947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 11),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [7951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(197),
  [7954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3900),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [7968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(239),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [7975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 9),
  [7977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4674),
  [7985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [8005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 9),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [8021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(265),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [8026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(3957),
  [8029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [8033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [8045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [8051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [8053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(4616),
  [8056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [8058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(4617),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [8077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [8081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [8085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3656),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4705),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [8097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 36),
  [8099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3),
  [8101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [8105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [8145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3907),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [8153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3189),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [8161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 23),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [8167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3654),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [8171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3, .production_id = 36),
  [8173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [8185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [8187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 11),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [8205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 2, .production_id = 57),
  [8207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [8221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 139),
  [8223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [8225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 138),
  [8227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3972),
  [8229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(3522),
  [8232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [8234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 145),
  [8236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5143),
  [8238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2), SHIFT_REPEAT(3473),
  [8241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [8245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 157),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [8251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [8261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 153),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4782),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [8279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [8283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [8291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4823),
  [8293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5252),
  [8295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [8299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [8303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [8309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 90),
  [8311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 125),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [8317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 90),
  [8319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(4654),
  [8322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [8324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 24),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [8336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 126),
  [8338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [8342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 158),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [8346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 127),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [8352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 24),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [8356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4951),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [8360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [8362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [8366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 159),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [8372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 103),
  [8374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 121),
  [8376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 128),
  [8378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(1185),
  [8381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [8389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [8401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(906),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [8414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 167),
  [8416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 144),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [8422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(3623),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [8427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 63),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [8431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 64),
  [8433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 99),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [8439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(3454),
  [8442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [8448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(4694),
  [8451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [8453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [8455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [8459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 160),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [8465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 142),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [8471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4306),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [8475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 80),
  [8477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [8481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 168),
  [8483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(5022),
  [8486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [8488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [8496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 170),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [8502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 143),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [8506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2), SHIFT_REPEAT(3571),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [8515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1762),
  [8518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 100),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [8524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 174),
  [8526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1530),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [8537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [8539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 64),
  [8541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [8545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [8549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [8555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 29),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [8559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [8561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [8563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [8567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [8571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 4, .production_id = 115),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [8575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 107),
  [8577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [8579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [8581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [8583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [8589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 94),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [8599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [8601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 61),
  [8603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 54),
  [8605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [8607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [8611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [8613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [8617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 90),
  [8619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 89),
  [8621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, .production_id = 59),
  [8623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5372),
  [8629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [8631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 11),
  [8633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [8635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [8637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2),
  [8639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 68),
  [8641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 68),
  [8643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [8645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [8647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [8649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [8651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [8653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [8655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [8657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [8661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [8663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [8665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [8669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [8673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [8677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [8691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [8701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [8703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [8719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 61),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [8735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [8741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5241),
  [8743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [8749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [8753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5324),
  [8755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [8761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [8763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [8771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [8773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [8775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3000),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [8789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [8795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [8833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [8857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5505),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [8861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [8863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [8865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [8867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [8869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [8871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [8873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [8875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [8879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [8881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [8883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [8885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [8891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [8895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [8899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [8903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [8905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [8907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [8909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [8921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [8923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [8925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [8927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [8931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [8933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [8935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [8939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [8941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5377),
  [8943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 61),
  [8945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [8947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [8949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [8951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [8953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [8955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [8957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [8959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5014),
  [8961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [8963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [8965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [8967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [8969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [8971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [8973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [8975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [8981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2947),
  [8983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [8987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5563),
  [8989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [8991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [8993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [8997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [8999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [9001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [9003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [9005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [9019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [9023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [9041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [9045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [9047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2965),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [9051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [9053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [9063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [9065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [9067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [9071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [9075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5446),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [9079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [9081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [9085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [9087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [9089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [9093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [9095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [9097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [9099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [9101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [9103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [9105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [9107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [9109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [9111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [9113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [9115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [9117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [9119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [9121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [9123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [9125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [9127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [9129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [9131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [9133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [9135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [9137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [9139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [9141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [9143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [9145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [9147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [9149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [9151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [9153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3084),
  [9155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [9159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [9163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [9165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [9167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [9171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [9173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [9175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [9177] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [9179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5405),
  [9181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [9183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [9185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [9189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [9193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [9197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [9199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4990),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [9205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [9207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5291),
  [9209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [9213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [9215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [9217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [9219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [9221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [9223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [9225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [9227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [9233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 61),
  [9235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [9237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [9241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [9247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [9249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [9251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [9253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [9255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [9257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [9259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [9261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [9263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [9265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [9267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [9269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [9271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [9273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5495),
  [9275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [9277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [9279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [9281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [9283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [9285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [9287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [9289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [9291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [9293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [9295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [9297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [9299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [9301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
